/**********************/
/*    BuftoDBC.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "BuftoDBC.h"
#include "winsdjtsdoc.h"
#include "statusbox.h"
#include "winsdjtsview.h"
#include "dbeframe.h"
#include "dbeview.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBuftoDBC _CAO

CBuftoDBC::CBuftoDBC(CWnd* pParent /*=NULL*/)
	: CDialog(CBuftoDBC::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBuftoDBC)
	m_iMode = -1;
	m_strDbcInfo = _T("");
	//}}AFX_DATA_INIT
	m_pDoc=NULL;
	m_pFile=NULL;
	m_Multi=0;
}

void CBuftoDBC::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBuftoDBC)
	DDX_Radio(pDX, IDC_ModeNew, m_iMode);
	DDX_Text(pDX, IDC_DBCINFO, m_strDbcInfo);
	DDV_MaxChars(pDX, m_strDbcInfo, 512);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBuftoDBC, CDialog)
	//{{AFX_MSG_MAP(CBuftoDBC)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuftoDBC bZ[W nh

BOOL CBuftoDBC::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// DoModal()̑Om_pDocݒ肳ĂO
	ASSERT(m_pDoc);
	
	// l̐ݒ)
	char StringBuffer[128];
	char DbcInfo[1024];
	CDSP *cdsp=m_pDoc->m_Dbc.GetMdsp();
	sprintf(DbcInfo,"\    %s\r\n",cdsp->title);
	sprintf(StringBuffer,"    %s\r\n",cdsp->author);
	strcat(DbcInfo,StringBuffer);
	sprintf(StringBuffer,"Փx  %s\r\n",cdsp->level);
	strcat(DbcInfo,StringBuffer);
	sprintf(StringBuffer,"qg  %s\r\n",cdsp->hint);
	strcat(DbcInfo,StringBuffer);
	sprintf(StringBuffer,"l萔  %s\r\n",cdsp->movenum);
	strcat(DbcInfo,StringBuffer);
	sprintf(StringBuffer,"o}  %s\r\n",cdsp->hash_s);
	strcat(DbcInfo,StringBuffer);
	sprintf(StringBuffer,"o^  %s\r\n",cdsp->datetime);
	strcat(DbcInfo,StringBuffer);
	sprintf(StringBuffer,"lԍ  %s\r\n",cdsp->c_recno);
	strcat(DbcInfo,StringBuffer);

	m_strDbcInfo.Format("%s",DbcInfo); // l

	// o^[h̃ftHglc_recno̗LŌ߂
	if (strlen(cdsp->c_recno))
		m_iMode=1; // ㏑o^
	else
		m_iMode=0; // VKo^

	UpdateData(FALSE); // f[^̔f()

	// DBRNOɏlL
	Dbrno.dbrno=atol(cdsp->c_recno);
	CKBase *pKBase=m_pDoc->GetKBase();
	Dbrno.tesu=pKBase->level();
	// ǖʂ̎w(B_PLAY)Xg擾Bm_Multiɂ͑ԂۂԂB
	m_Multi=pKBase->GetBplayList(&m_Blist);
	
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////////
/// o^Xbh
static UINT BuftoDBCWorkerThread(CStatusBox *pBox,CEvent *pEvent,LPARAM lParam)
{
	CBuftoDBC *pBuftoDBC=(CBuftoDBC *)lParam;
	CDBC Dbc; // lca

	Dbc.SetQuitObject((HANDLE)(*pEvent));			// fCxg

	CSDJArchive arIn(pBuftoDBC->m_pFile,CArchive::load);
	pBuftoDBC->Dbrno.dbrno=Dbc.InCsa2DB(arIn,pBox); // DBo^ & lԍԂ
	arIn.Close();

	// cao^s瑦I(do^̉\ԍ)
	if (pBuftoDBC->Dbrno.dbrno < 0)
		return 0;

	// DBo^AwԂׂ̈̈ȉ̌㏈B

	// wPCLt@CXVB
	Dbc.set_mdsp();
	CDSP *cdsp=Dbc.GetMdsp();
	// wԂLꍇPCLt@CVKo
	// AÃt@C̋lԍ,hash_s͓ĂɂĂ͂ȂB
	pBuftoDBC->m_pDoc->PclUpdate(pBuftoDBC->m_Multi,FALSE,cdsp->hash_s);

	return 0;
}

////////
/// l̓o^
void CBuftoDBC::OnOK() 
{
	BOOL bOK=TRUE;
	CDSP *cdsp=m_pDoc->m_Dbc.GetMdsp();
	C_REC *c_rec=m_pDoc->m_Dbc.GetMrec();
	char crecno[sizeof cdsp->c_recno];
	crecno[0]='\0';

	// ݒl̎擾
	UpdateData(TRUE);

	// o^[h̃`FbN
	if (m_iMode==0) { // VKo^
		if (strlen(cdsp->c_recno)!=0) {
			strcpy(crecno,cdsp->c_recno); // c_recnoL
			c_rec->row.c_recno[0]='\0';   // hLg̋lԍꎞIɏ
		}
	}
	else { // ㏑o^
		if (strlen(cdsp->c_recno)==0) {
			AfxMessageBox("㏑o^ɂ͋lԍ̎w肪KvłB");
			bOK=FALSE;
		}
	}

	// o^
	if (bOK) {
		// lt@CCSAo͂B
		m_pFile=new CWinMemFile;
		CSDJArchive arOut(m_pFile, CArchive::store);
		m_pDoc->Serialize(arOut,TRUE);		// l({菇)CSAt@Co
		arOut.Close();
		m_pFile->Seek(0L,CFile::begin);		// t@C̓o

		// c_recnőLɖ߂
		if (strlen(crecno)!=0) {			// L
			strncpy(c_rec->row.c_recno,crecno,strlen(crecno));
		}	

		CStatusBox StatusBox(&BuftoDBCWorkerThread,(LPARAM)this);
		StatusBox.DoModal();				// o^
		delete m_pFile;

		// o^ɐ
		if (Dbrno.dbrno >=0) {
			// DbrnȍɁAlcalǂݏoB
			// 鎖ɂAVKo^ĂlԍZbgB
			CWinSDJTSView *pView=(CWinSDJTSView *)m_pDoc->GetSDJView();	

			// ߃{bNXJĂ	
			pView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);
			
			CWaitCursor wcur; // v
			m_pDoc->ReadDbcInfo(Dbrno,&m_Blist);	// lDBǂݍ
	
			m_pDoc->SetModifiedFlag(FALSE);

			if (pView->GetGuideFrame()!=NULL)		// ǖʕ\JĂ
				pView->GetGuideFrame()->Invalidate();
			if (pView->GetSubFrame()!=NULL)			// TuEBhEJĂ
				pView->GetSubFrame()->Invalidate();
			pView->Invalidate();					// \XV

			// JĂe
			if (pView->GetKifFrame()!=NULL) {
				pView->GetKifFrame()->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
			}

			// ՑJĂeXV(ۂ͒Ց̓I[v
			// 邱Ƃ͂ȂBj[ŃC^[bNĂ)
			if (theApp.m_bDbeUsing) {
				CDbeFrame *pDbeFrame=pView->GetDbeFrame();
				if (pDbeFrame) { // ̃r[ՑJĂ
					CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
					pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
				}
			}

			// ēxPCLt@Co͂BꂪŁB
			// [J[Xbhŏo͂̂͋lԍhash_sȂ̂ŁB
			m_pDoc->PclUpdate(m_Multi);
		} 
		// o^ɎsAꉞADbrno̒lɖ߂ĂB
		else {
			CDSP *cdsp=m_pDoc->m_Dbc.GetMdsp();
			Dbrno.dbrno=atol(cdsp->c_recno);
		}

		CDialog::OnOK(); // OKI
	}
}
