/*=========================================================================
                                   
                       B `vO
                                   
                           1993.11 by Ra
                           1996.7  version 3.0 by Ra
                                   
============================================================================*/
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include "bform.h"
#include <sbase.h>
extern "C" {
#include <shgdb.h>
}

/////////////  CBform ///////////////
IMPLEMENT_SERIAL(CBform,CObject,0)

CBform::CBform(void)
{
    Init(0);    // zu
}
CBform::CBform(CBform *bp)
{
	bform=*bp;
}
CBform::~CBform(void)
{
}

//////////////
// Serialization
void CBform::Serialize(CArchive &ar)
{
	CObject::Serialize(ar);
	
    if (ar.IsStoring()) {
		// ۑ
		ar.Write(&bform,sizeof (B_FORM));
    } else {
		// Ǎ
		UINT nr=ar.Read(&bform, sizeof(B_FORM));
		ASSERT(nr==sizeof(B_FORM));
    }
}

//////////////
// Ֆʂ̏
//
//   mode  0: 1:E 2: 3:
//         4:p 5:񖇗 6:l 7:Z 8:S
////////////////////////////////////////////////////////
void CBform::Init(int mode)
{
    int i;
    unsigned int ukm[40];					// B`WJz

    for (i=0;i<40;i++) ukm[i]=(127 << 1);	// (Sċ)

    if (mode < 8 ) {						// zuȊOȂ
        ukm[0]=(51 << 1) + 1;				// 
        ukm[1]=(59 << 1);					// 
        if (mode != 3 && mode < 5) 
            ukm[2]=(82 << 1) + 1;			// 
        ukm[3]=(28 << 1);					// 
        if (mode != 4 && mode < 5)
            ukm[4]=(22 << 1) + 1;			// p
        ukm[5]=(88 << 1);					// p
        for (i=0;i<4;i++) {					// `
            if (i < 2 ||					// ̋͏ɒu
                (i==2 && mode < 7) ||		// jn4(mode=6)܂Œu
                (i==3 && mode < 6)){		// Ԃ2(mode=5)܂łŁA
                if (i<3 || i==3 && mode!=2)	// (mode=1)łȂ
                    ukm[6+i*4+0]=((40-10*i+1) << 1) + 1;  // 
                if (i<3 || i==3 && mode!=1)	// E(mode=2)łȂ
                    ukm[6+i*4+1]=((60+10*i+1) << 1) + 1;  // 
            }
            ukm[6+i*4+2]=((40-10*i+9) << 1);	// 
            ukm[6+i*4+3]=((60+10*i+9) << 1);	// 
        }
        for (i=0;i<9;i++) {
            ukm[22+2*i]  =(((i+1)*10+3) << 1) + 1; // ̕
            ukm[22+2*i+1]=(((i+1)*10+7) << 1);     // ̕
        }
    }

    ImportFrom(ukm);           // ukmB_FORM𐶐(\[g&facenumvZ)
}

//////////////////
// Ֆʂ𔽓]
//////////////////////
void  CBform::ReverseBform()
{
    B_ReverseForm(&bform);
}

/////////////////
// wi߂(ukm)B
///////////////////
void CBform::ForwardUkm(unsigned int *ukm, B_PLAY bplay)
{
	B_ForwardUkm(ukm, bplay);
}

/////////////////
// wi߂B
///////////////////
void CBform::Forward(B_PLAY bplay)
{
	B_Forward(&bform, bplay);
}

//////////////////
// ukm -> BFORM ϊ
/////////////////////
void CBform::ImportFrom(unsigned int *ukm)
{
	B_ImportFrom(ukm, &bform);
}

////////////////////
// BFORM -> ukm ϊ
///////////////////
void CBform::ExportTo(unsigned int *ukm)
{
	B_ExportTo(&bform, ukm);
}

///////////////////
// WJz̔]
//////////////////
void CBform::ReverseUkm(unsigned int *ukm)
{
	B_ReverseUkm(ukm);
}

///////////////////
// w𔽓]B
////////////////////
B_PLAY  CBform::ReverseBplay(B_PLAY bplay)
{
	CBform bformr;
    bformr.bform=bform;         // ʂ
    bformr.ReverseBform();      // ]Ֆ

    return B_ReversePlay(&bform, bplay, &bformr.bform);
}


////////////////
//  w̎擾
//    SBASEmpos󂯎AB_PLAYɕϊ
///////////////////
B_PLAY CBform::GetBplay(int from,int to,int prm,int side,int code)
{
	// SBASEƂ͋̒`Ⴄ
	if (from==2)
		from=127;
	if (to==2)
		to=127;
    return B_GetBplay(&bform,from,to,prm,side,code);
}

////
/// SBASEp̎w̏擾B
// {擪id,}
static struct {
    int sid;
    int num;
} B_kt[8]={{0,2},{2,2},{4,2},{6,4},{10,4},{14,4},{18,4},{22,18}};
void CBform::GetMoveInfo(B_PLAY bplay, int *km,
						 int *from, int *to, int *prom, int *side)
{
	unsigned int Ukm[40];

	ExportTo(Ukm);						// wi߂ŐǖʂukmWJ
	int id0=bplay & 0x3f;
	int from_b=(Ukm[id0] >> 1) & 0x7f;
	if (from_b==127) *from=2;			// ̒lႤ
	else			 *from=from_b;		// ͓̑

	*to=(bplay >> 6) & 0x7f;
	*side=(bplay >> 14) & 1;
	*prom=((bplay >> 13) & 1)			// ̎wŐ̂ or
		| ((Ukm[id0]>>8) & 1);			// ɐȂ̂B(͑̕ȂƎvB97.5)
	for (int i=0;i<8;i++) {
		if (B_kt[i].sid <= id0 && id0 < B_kt[i].sid+B_kt[i].num) {
			*km=i;
			break;
		}
	}
}

///////////////////////////////
//  B`̏ՏɓWJ
void CBform::ToShogiBan(SHOGIBAN *pSBan)
{
	unsigned int ukm[40];
	int i,j,km,pos,kx,ky;

	memset(pSBan,-1,sizeof(SHOGIBAN));	// -1NA
	for (i=0;i<8;i++) {
		for (j=0;j<2;j++) {
			pSBan->Dai[j][i]=0;			//  0NA
		}
	}

	ExportTo(ukm);						// Ukm WJ

	for (i=0;i<40;i++) {
		// ܂͋̈ʒu(pos)A(km)߂
		pos=(ukm[i]>>1) & 0x7f;
		for (j=0;j<8;j++) {
			if (B_kt[j].sid <= i && i< B_kt[j].sid+B_kt[j].num) {
				km=j;
				break;
			}
		}

		// Տ̋Ȃ
		if (pos >= 11 && pos <= 99) {
			kx=pos/10; ky=pos%10;
			pSBan->Ban[kx][ky].km=km;				// 
			pSBan->Ban[kx][ky].sg=ukm[i] & 1;		// 
			pSBan->Ban[kx][ky].nr=(ukm[i]>>8) & 1;	// \
		}
		// 
		else if (pos==0) {
			pSBan->Dai[0][km]++;	//  +1
		}
		// 
		else if (pos==1) {
			pSBan->Dai[1][km]++;	//  +1
		}

	}
}

////////////
// ݂̔ՖʂCSA`ŏo͂B
//   (CDBB::out_bform_csa)
/* CSA `̋̎ */
void CBform::GetCsaForm(CString *csa,char *title)
{
    int x,y,sg,km,nr;
	int i,n;
	SHOGIBAN SBan;
	char StringBuffer[256];

	struct { char *n1;		/*  */
			char *n2;       /*  */
	} kmname[8] = { 
		{"OU",""},			/*  */
		{"HI","RY"},		/*  */
		{"KA","UM"},		/* p */
		{"KI",""},			/*  */
		{"GI","NG"},		/*  */
		{"KE","NK"},		/* j */
		{"KY","NY"},		/*  */
		{"FU","TO"}			/*  */
	};

	// os
	csa->Format("'-------- %s -------\r\n",
		(title)? title:"CSA FORMAT");

	// ՓWJ
	ToShogiBan(&SBan);
	
    /* ꊇ\ */
    for (y=1;y<=9;y++) {
        sprintf(StringBuffer,"P%d",y);
		*csa+=(LPCTSTR)StringBuffer;
        for (x=9;x>=1;x--) {
            sg=SBan.Ban[x][y].sg;
            km=SBan.Ban[x][y].km;
            nr=SBan.Ban[x][y].nr;
            if (km!=-1) {		/*  */
                if (sg !=0) {	/* ̋ */
                    sprintf(StringBuffer,"-%s",(nr)? kmname[km].n2:kmname[km].n1);
					*csa+=(LPCTSTR)StringBuffer;
				}
                else {			/* ̋ */
                    sprintf(StringBuffer,"+%s",(nr)? kmname[km].n2:kmname[km].n1);
					*csa+=(LPCTSTR)StringBuffer;
				}
            }
            else {
			    *csa+=" * ";	/* Ȃ */
			}

        }
		*csa+="\r\n";           /* s̏o͏I */
    }
    /* ̏o */
	for (i=0;i<8;i++) {
		if (SBan.Dai[0][i]!=0) {
			*csa+="P+";
            for (n=0;n < SBan.Dai[0][i];n++) {	/* ނsŏo */
				sprintf(StringBuffer,"00%s",kmname[i].n1);
				*csa+=(LPCTSTR)StringBuffer;
			}
			*csa+="\r\n";						/* s̏o͏I */
		}
	}
    /* ̏o */
	for (i=0;i<8;i++) {
		if (SBan.Dai[1][i]!=0) {
			*csa+="P-";
            for (n=0;n < SBan.Dai[1][i];n++) {	/* ނsŏo */
                sprintf(StringBuffer,"00%s",kmname[i].n1);
				*csa+=(LPCTSTR)StringBuffer;
			}
            *csa+="\r\n";
		}
	}
}


///////
// fobO[`
//   ՖʂTRACEo͂B
void CBform::TraceOut()
{
	CString strForm;

	GetCsaForm(&strForm);
	TRACE(strForm);
}

/////////
///  nbVlԂ
long CBform::Hash()
{
	return B_Hash(&bform);
}