/////////////////////////////////
// DBA.cpp : implementation file
//                      1996.09 by Ra
//
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include "dba.h"

#include <mbstring.h>

/* ʊO֐錾 */
extern "C" {
void *memalloc(unsigned int);
void memfree(void *);
}

////////////////////////////////////////
// f[^x[XfBNg̎擾
///
IMPLEMENT_SERIAL(CDBA, CObject, 0 /* Schema number */ )

char *GetShgdbName(void)
{
	static char dname[512];

	char *pSHGDB=getenv("SHGDB");
	ASSERT(pSHGDB);
	strcpy(dname,pSHGDB);

	int len = strlen(dname);
	if (dname[len-1]!='\\' && dname[len-1]!='/')
		strcat(dname,"\\");

	// ؂q\ɂB
	//   Ȃ CFileDialogm_ofn\̂lpszFileName̋؂q'/'
	//   A_CAOJȂB(97.3)
	len=strlen(dname);
	for (int i=0;i<len;i++) {
		if (dname[i]=='/')
			dname[i]='\\';
	}

	return dname;
}

////
// XWpQoCg܂ޕʏ̕ɕϊB
// pQoCg͔pɂȂB
void String98Convert(char *cp)
{
	if (cp==NULL)
		return;
	//
	// Pcp^[OɁA98pO𔼊pɕϊB
	int len=strlen(cp);
	unsigned char *rcp=(unsigned char*)memalloc(len+1);
	if (rcp==NULL)
		return;				// sȂ߂B

	strcpy((char *)rcp,cp);	// 悸{rcpɃRs[B
	int kanji=0;			// R[h̕
	BOOL kj98=FALSE;		// 98p(2oCg)ۂ
	int i,cnt;
	for (cnt=i=0;i<len;i++) {
		// ̕
		switch (kanji) {
		case 0:
		case 2:
			if (_ismbblead(rcp[i]))		// PoCg
				kanji=1;
			else						// ʏ̕
				kanji=0;
			break;
		case 1:
			if (_ismbbtrail(rcp[i]))	// QoCg
				kanji=2;
			break;
		default:
			ASSERT(0);
			break;
		}

		// ϊ
		if (kj98) { // XWpQoCĝQoCgڂ̎̕
			kj98=FALSE;
			// pɕϊB
			if (rcp[i]>=0x3f && rcp[i]<=0x7e) {			// Ep啶
				cp[cnt]=rcp[i]-0x3f+0x20;
				cnt++;
			}
			else if (rcp[i]>=0x80 && rcp[i]<=0x9e) {	// p
				cp[cnt]=rcp[i]-0x80+0x60;
				cnt++;
			} else if (rcp[i]>=0x9f && rcp[i]<=0xdd) {	// Ji
				cp[cnt]=rcp[i]-0x9f+0xa1;
				cnt++;
			} else {									// ͂ȂƎv
				cp[cnt]=rcp[i];
				cnt++;
			}
		}
		else {
			if (kanji==1 &&		// 1oCg
				rcp[i]==0x85) { // 98̔pQoCg̎n܂
				kj98=TRUE;		// pɕϊ̂ŃRs[͂Ȃ
			}
			else {
				cp[cnt]=rcp[i];	// ȊO̕Ȃ炻̂܂܃Rs[
				cnt++;
			}
		}
	}
	cp[cnt]='\0';
	memfree(rcp);
}

CDBA::CDBA()
{
	m_Ascm=NULL;
}
CDBA::CDBA(char *dname)
{
	m_Ascm=NULL;
    Open(dname);
}
CDBA::~CDBA()
{
	if (m_Ascm!=NULL)
		SdbClose(m_Ascm);
}

// f[^x[X̃N[Y
void CDBA::Close()
{
	if (m_Ascm!=NULL) {
		SdbClose(m_Ascm);
		m_Ascm=NULL;
	}
}

// f[^x[X̍쐬
BOOL CDBA::CreateA() 
{
	char *dname = GetShgdbName(); // cafBNg̎擾

	return CreateA(dname);
}
// cãZbg
static void SetShgdbA(char *dbname)
{
	int len=strlen(dbname);
	if (len > 0) {
		if (dbname[len-1]!='\\' && dbname[len-1]!='/')
			strcat(dbname,"\\");
	}
	strcat(dbname,"SHGDB_A");
}
////////////////////
// f[^x[X̍쐬
//    dname ̓fBNg
BOOL CDBA::CreateA(char *dname) 
{
	char dbname[512];
	strcpy(dbname,dname);
	SetShgdbA(dbname); // cãZbg

	if (m_Ascm!=NULL) Close();
	if ((m_Ascm=SdbCreate(dbname))!=NULL) {
		SdbClose(m_Ascm);
	    m_Ascm=NULL;
		return TRUE;
	}
	else {
		char strMes[256];
		sprintf(strMes,"f[^x[X %s ̍쐬Ɏs܂B",dbname);
		AfxMessageBox(strMes);
		return FALSE;
	}
}
// f[^x[X̃I[v
BOOL CDBA::Open()
{
	char *dname = GetShgdbName(); // cafBNg̎擾

	return Open(dname);
}
///////////////////////
// f[^x[X̃I[v
//     dname ͏cafBNg
BOOL CDBA::Open(char *dname)
{
	char dbname[512];
	strcpy(dbname,dname);
	SetShgdbA(dbname); // cãZbg

	if (m_Ascm!=NULL) Close();
	if ((m_Ascm=SdbOpen(dbname))!=NULL)
		return TRUE;
	else {
		char strMes[256];
		sprintf(strMes,"f[^x[X %s ̃I[vɎs܂B",dbname);
		AfxMessageBox(strMes);
		return FALSE;
	}
}

///////////////////////////
// ՖDBB`Ō
//
// 
//    CBform *pBform : Ֆʃf[^ B `
// ߂l
//    o^Ă@@@:HSnbVl (>=0)
//    o^ĂȂ΁@@:~(nbVl)(<0)                           
long CDBA::Find(CBform *pBform)
{
	return DBA_Find(m_Ascm, &pBform->bform);
}

/////////////////////////////
// ՖDBHSnbVlŌB
//
//@
//    long  hash_s  : HSnbVl
//@߂l
//@@o^Ă@@@: E$OK(0)
//@@o^ĂȂ΁@@: E$NOTFOUND(10)ق
int  CDBA::HSfind(long hash_s)
{
	return DBA_HSfind(m_Ascm, hash_s);
}

///////////////////////
// ՖDBB`œǂݏo
//
// 
//    CBform *pBform : Ֆʃf[^ B `
// o
//@  R[h(a_rec)
// ߂l
//@@ǂݏoɐ@:HSnbVl (>=0)
//@@s@@@@@@:~(nbVl)(<0)
long CDBA::Read(CBform *pBform)
{
	return DBA_Read(m_Ascm, &pBform->bform, &a_rec);
}

////////////////////////
// ՖDBHSnbVlœǂݏo
//
// 
//    long hash_s   : HSnbVl                                             
// o
//  @R[h(a_rec)
// ߂l
//@@ǂݏoȂ@@@: E$OK(0)
//@@s            : E$NOTFOUND(10)ق
int  CDBA::HSread(long hash_s)
{
	return DBA_HSread(m_Ascm, hash_s, &a_rec);
}

/////////////////
// ՖDBւ̓o^
//
// 
//    CBform *pBform         : o^Ֆʃf[^ B `
//    unsigned long refcount : QƐ
// ߂l
//@@o^ɐ@@@ : HSnbVl (>=0)
//@@o^Ɏs@@   : ~(nbVl)(<0)                           
long CDBA::Write(CBform *pBform, unsigned long refcount)
{
	return DBA_Write(m_Ascm, &pBform->bform, refcount);
}

///////////////
// ՖDB̍XV
//
//@
//  @R[h(a_rec)
//@߂l
//@@XVɐ@@@: E$OK(0)
//@@XVɎs@@  : ȊO
int  CDBA::Update()
{
	return DBA_Update(m_Ascm, &a_rec);
}

////////////////////////////
// ՖDB̃R[h폜B
//
// 
//    SCM_t *scm    : ՖDB̕\XL[}\(I[vς݂ł邱)
// ߂l
// @폜Ȃ@: E$OK(0)
// @s    : E$NOTFOUND(10)
int  CDBA::Delete(long hash_s)
{
	return DBA_Delete(m_Ascm, hash_s);
}

