//////////////////////
// 
// CDBB class
//                      1996.09 by Ra
//						1997.09 modified by Ra
#ifndef __DBB__
#define __DBB__

#include "bform.h"
extern "C" {
#include <shgdb.h>
}

#include <afxtempl.h>
#include "dbm.h"
#include "sdjarchive.h"
#include "arydupchk.h"

/* DB_BR[h\pobt@ */
typedef struct Bdsp {
    char splayer[sizeof ((B_REC *)0)->row.player + 1]; /* ΋ǎ */
    char gplayer[sizeof ((B_REC *)0)->row.player + 1]; /* ΋ǎ */
    char playdate[9];           /* ΋Ǔ yy/mm/dd */
    char sdan[sizeof ((B_REC *)0)->row.sdan + 1 ]; /* i */
    char gdan[sizeof ((B_REC *)0)->row.gdan + 1 ]; /* i */
    char teai[sizeof ((B_REC *)0)->row.teai + 1 ]; /* 荇 */
    char htime[9];              /*  hh:mm:ss */
    char timecount[5];          /* xxb or ؕ */
    char result[sizeof ((B_REC *)0)->row.result + 1]; /*  */
    char tesu[sizeof ((B_REC *)0)->row.tesu + 1]; /* 萔 */
    char srhtime[9];            /* c hh:mm:ss */
    char grhtime[9];            /* c hh:mm:ss */
    char senkei[sizeof ((B_REC *)0)->row.senkei + 1]; /* ^ */
    char kisen[sizeof ((B_REC *)0)->row.kisen + 1]; /*  */
    char place[sizeof ((B_REC *)0)->row.place + 1]; /* ΋Ǐꏊ */
    char datetime[18];          /* o^ yy/mm/dd hh:mm:ss */
    char b_recno[sizeof ((B_REC *)0)->row.b_recno + 1]; /* ΋ǔԍ */
} BDSP;

// w胊Xg̑傫B̒llƂĐ{ŊgB
#define m_aryBplay_MaxBuff  1000

class CDBB : public CDBM
{
	DECLARE_SERIAL(CDBB)
protected:
	BDSP *mdsp,m_mdsp;  // ΋ǂcaR[h\obt@
	B_REC m_rec;		    // ΋ǂcaR[hobt@
    CAryDupchk m_aryDupitm;     // dʊi[obt@
	int m_idxDupitm;                  // @CfbNX
	unsigned int ukm1[40];  // dpobt@

    long m_nDbrno;            // d`FbNȓ΋ǔԍ(-1LȂ)
	CBform m_EndBform1;  //  d`FbNpr̍ŏIǖ
    B_PLAY *m_aryBplay1;   // @w胊XgiLobt@j
    int m_idxBplay1;            // @ 萔
    int m_nBplay1Max;           //  obt@݂̌̃TCYij
    B_PLAY *m_aryBplay2;   // r̎w胊XgivZp̃obt@j
    int m_idxBplay2;            //  @ 萔
    int m_nBplay2Max;           //  obt@݂̌̃TCYij

private:
	void common_init();
protected:
 	virtual void mrec_init();
	virtual int get_mrec_side();
	virtual char *get_mdsp_strrecno(){return mdsp->b_recno;}
	virtual long get_mrec_hash_s();

public:
	virtual long get_mrec_recno();
	virtual void set_disp_mrec(char *dikpbuf,int w1=-1,int w2=-1);
	// CSA`DBB֓o^(nǕ)
	virtual int InCsa2DB(CSDJArchive &ar,CWnd *pWnd=NULL,BOOL bIgnoreRecno=FALSE );
	virtual int OutMrec2CsaHeader1(CSDJArchive &ar,int za=0); // CSAt@Cwb_[̏o
	virtual int OutMrec2CsaHeader2(CSDJArchive &ar);		   // CSARgL[[h̏o
	virtual int OutMrec2CsaHeader4(CSDJArchive &ar);          // CSA΋ǎ҂̏o
	virtual int OutDB2Csa(CSDJArchive &ar,int za=0);  // CSA`o(1Ǖ)
	CDBB();
	CDBB(char *dname);
	~CDBB();
	virtual BOOL CreateDB(char *dname);
	virtual BOOL CreateDB(void);
	virtual BOOL Open(char *dname);
	virtual BOOL Open();
public:
	virtual char *GetDbName();					      // DBB̎擾
	virtual long Write(CBform *pBform,int side);      // ΋DBւ̃R[ho^
	virtual int Delete(long recno);					  // ΋DB̃R[h폜
	virtual int DeleteByDbrno(long recno);            // ΋ǒ߁EEo̍폜
	virtual int ReadByDbrno(long dbrno);              // ΋ǔԍ(Dbrno)ɂǂݏo
	virtual int Update(CBform *pBform, int side);     // ΋DB̃R[hXV('03.08.02)

	// oca(order by L/)
	int DupchkFirst(char *strSql,KYINFO *kyinfo, int iDupMatch);
	int DupchkNext();
	void DupchkExit(); // ̒f

	// ʂ̎擾
	BDSP *GetMdsp(void){return mdsp;}
	B_REC*GetMrec(void){return &m_rec;}
	virtual void set_mdsp(void);		   // \obt@̃Zbg
	void set_mdsp(B_REC *bp, BDSP *pBdsp); // BDSP̃Zbg

protected:
	int cmd_Insert_dupchk(CAryDupchk *paryDupchk); // d⏕(DUPCHK̓Ǎ)
    int cmp_dupchk(DUPCHK *pDupchk1, DUPCHK *pDupchk2, int iDupMatch); // d

	// CSAo
	virtual void out_bplay_comment_csa(CSDJArchive &ar, long recno, int tesu); // ,ߏo

	// ΋ǂca
	virtual void set_dbrno(DBRNO *pdbrno,int tesu); // DBRNÕZbg
	virtual int ky_matches(B_FORM *bp,CDBD *pDBD,KYINFO *kyp,int *tesu);

	// CSAs̓Ǎ
	virtual int set_player(char *sente,char *gote); // ΋ǎҖ̃Zbg
	virtual int item_check(int ino,char *cp); // L[ڒl̃`FbN

	virtual int drec_play_set(char *line,int side,long brecno); // D_REC̃R[h`FbNƊDBւ̓o^
	virtual int sasite_comment(int sasite); // w蒍߂̓o^(sasite=萔)

	virtual int delete_DF(B_REC *bp); // bpŎw肳ꂽ΋ǂ̊A߂
	// ΋ǔԍrecnoɊւ钍DB Fscm̃R[hSďB Fscm,DscmQƂB
	virtual void dbf_remove(long recno);
};
#endif // __DBB__
