/////////////////////////////////
// winmemfile.cpp : implementation file
//                      1997.04 by Ra
//

#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include "winmemfile.h"

extern "C" {
void *memalloc(unsigned int);
void memfree(void *);
}
/////////
// RXgN^
//   obt@̃TCYƑTCY^B(ftHg8192,1024)
CWinMemFile::CWinMemFile(UINT nInitBufSize, UINT nGrowSize)
{
	m_lpMem=NULL;
	m_Size=0;
	ASSERT(nInitBufSize); // obt@TCY > 0 łȂƑʖځB
	BYTE *lpMem=Alloc(nInitBufSize); // 擾
	ASSERT(lpMem); // 擾s
	// 擾CMemFile֌ѕtB
	Attach(lpMem,nInitBufSize,nGrowSize);
}
CWinMemFile::~CWinMemFile()
{
	if (m_lpMem) {
		BYTE *lpMem=Detach(); // ؂藣B
		if (lpMem)
			Free(lpMem);
	}
}
void CWinMemFile::Attach(BYTE *lpMem,UINT nBytes,UINT nGrowBytes)
{
	// łAttachĂDetach & FreeB
	if (m_lpMem) {
		BYTE *lpOld=Detach();
		if (lpOld)
			Free(lpOld);
	}
	m_lpMem=lpMem;
	m_Size=nBytes;
	CMemFile::Attach(lpMem,nBytes,nGrowBytes);
}
BYTE *CWinMemFile::Detach()
{
	m_lpMem=NULL;
	m_Size=0;
	return CMemFile::Detach();
}

BYTE *CWinMemFile::Alloc(DWORD nBytes)
{
	return (BYTE *)memalloc((unsigned int)nBytes);
}
void CWinMemFile::Free(BYTE *lpMem)
{
	memfree((void *)lpMem);
}
BYTE *CWinMemFile::Realloc(BYTE *lpMem, DWORD nBytes)
{
	ASSERT(m_lpMem==lpMem);
	m_lpMem=Alloc(nBytes);
	memcpy(m_lpMem,lpMem,m_Size);
	m_Size=nBytes;
	Free(lpMem);
	return m_lpMem;
}
