//////////////////////
// 
// CDBM class   oۃNX
//                      1997.09 by Ra
#ifndef __DBM__
#define __DBM__

#include "bform.h"
extern "C" {
#include <shgdb.h>
}

#include "dba.h"
#include "dbd.h"
#include "dbf.h"
#include "sdjarchive.h"


// 
typedef struct Kyinfo {
    int match;			/* 0: 1:ǖʈv 2:Տv */
    int rev;			/* 0:]Ȃ  1:]L */
    int stesu;			/* Jn萔 0~999 */
    int tesu;			/* 萔     1~999 */
	/* ΋ǖ */
	unsigned int uiUkm[40];
	int teban;
} KYINFO;

// DBB
typedef struct tagDbrno {
	long	dbrno;
	short	tesu;
} DBRNO;

/* m_rec CSARgso^L[[h */
typedef struct tagMtab {
    char *mcp;                  /* L[[h */
    char *mrp;                  /* R[hʒu */
    int  msz;                   /* ڒ */
} MTAB;

#define SET_MTAB(i,MCP,MRP,MSZ) (Mtab[i].mcp=MCP,Mtab[i].mrp=MRP,Mtab[i].msz=MSZ)

class CDBM : public CDBA
{
	DECLARE_SERIAL(CDBM)
public:
	int m_rc; // Serialize 
protected:
    SCM_t *m_Mscm;		// ocãXL[}
	char *m_dbname;		// oca
	DBRNO m_Dbrno;		// ǂݏoocȁ(΋ǔԍ,萔)
	char *m_pComment;   // oRg
	char *rec_buffer;   // oR[hobt@
	MTAB *Mtab;		    // CSA RgsL[[h

	CDBD	DBD;			 // DBD ca
	CDBF    DBF;             // DBF ߂ca


	// CSAo^
 	CBform  Bform;
	char *comment;			 /* ߕ */
	int   rcsiz;             /* ߕ̈}[W(܂\0) */
	int flag[4];             /* ,,Ֆ,Ԑݒ芮/ */
	int pl;                  /* zuꊇ\Cԍ(l0) */
	int m_MrecCount;	     // o̓ǂݏoJEgLl
	int m_MrecCount2;		 //  JEgl

	////////////////
	// oca
protected:
	/*  */
	char *sql_text;          /* where߈ȉSQLB*/
	char *select_from;       /* select from  i[̈*/

	HANDLE h_quit;       // fIuWFNg
	int order_by;            // order_by̗L
	long rn;                 // 
    SQL_t *sql;              // zBorder by w肪ȂɎgp
    RDB_t *rdb;              // RDB \́B  
    long hash_s,hash_s1;     // ՖDB HS nbVl

private:
	SQLRESP *resp;           // t@CQƍ\
	FILE *rfp;               // t@C
	unsigned int rukm1[40];  // ǖʓWJobt@()
	int side1;               //    
	int ban1[100];           //    Ֆʏ
	unsigned int rukm2[40];  //                     (t)
	int side2;
	int ban2[100];           //    Ֆʏ


private:
	void common_init();
protected:
	virtual void mrec_init();
	virtual int get_mrec_side();
	virtual char *get_mdsp_strrecno();
	virtual long get_mrec_hash_s();
	void SetDateTime(char *datetime);
	void adjust_width(char *cp,int width);
	void fill_zenblk(CString &str,int sz);
	
public:
	virtual long get_mrec_recno();
	MTAB *GetMtab(){return Mtab;} // L[[hAm_rec̍ڏ擾
	virtual void set_disp_mrec(char *dikpbuf,int w1=-1,int w2=-1);
	void ReplaceComment(char *pComment);
	char *GetComment(){return m_pComment;};   // oRg̎擾
	virtual int InCsa2MrecInit(CSDJArchive &ar); // CSA`̌oǍݏ
	virtual BOOL InCsa2MrecIsEnd(); // CSA`̌oǍ݊`FbN
	virtual void InCsa2MrecEnd();   // CSA`̌oǍݏI
	virtual int InCsa2Mrec(CSDJArchive &ar,BOOL bCheck=TRUE); //CSA`(ar)猩oǍށB
	// CSA`DBB֓o^(nǕ)
	virtual int InCsa2DB(CSDJArchive &ar,CWnd *pWnd=NULL,BOOL bIgnoreRecno=FALSE );
	virtual int OutMrec2CsaHeader1(CSDJArchive &ar,int za=0); // CSAt@Cwb_[̏o
	virtual int OutMrec2CsaHeader2(CSDJArchive &ar);   // CSARgL[[h̏o
	int OutMrec2CsaHeader2(CSDJArchive &ar,int count); // CSARgL[[h̏o
	int OutMrec2CsaHeader3(CSDJArchive &ar);           // CSAo߂̏o
	virtual int OutMrec2CsaHeader4(CSDJArchive &ar);   // CSA΋ǎ҂̏o
	int OutMrec2Csa(CSDJArchive &ar,int za=0); // CSA`(ar)֑΋ǌoo͂B
	virtual int OutDB2Csa(CSDJArchive &ar,int za=0);  // CSA`o(1Ǖ)
	int OutDB2Csa(CSDJArchive &ar,int za,int recid);  // CSA`o(1Ǖ)
	B_FORM *GetFirstBform(void); // ǖʂ̎擾
	void DBDClose(void);
	BOOL DBDOpen(char *dname);
	BOOL DBDOpen(void);
	void DBFClose(void);
	BOOL DBFOpen(char *dname);
	BOOL DBFOpen(void);
	B_PLAY PrevBplay(void);
	B_PLAY NextBplay(void);
	B_PLAY FindBplay(long recno, int num);
	CDBM();
	CDBM(char *dname);
	~CDBM();
    virtual void Serialize(CArchive& ar);
	virtual BOOL CreateDB(char *dname); // dummy
	virtual BOOL CreateDB(void);		// dummy
	virtual BOOL Open(char *dname);		// dummy
	virtual BOOL Open(void);			// dummy
	void Close(void);

	SCM_t *GetScm(){return m_Mscm;}                  // SCM_t ̎擾
	virtual char *GetDbName();					     // DB̎擾(dummy)
	virtual long Write(CBform *pBform,int side=0);   // oDBւ̃R[ho^(dummy)
	virtual int Delete(long recno);				     // oDB̃R[h폜(dummy)
	virtual int DeleteByDbrno(long recno);           // ߁EEo̍폜
	int DeleteByDbrno(long recno,int recid);		 // ߁EEo̍폜
	virtual int ReadByDbrno(long dbrno);             // R[hԍ(Dbrno)ɂǂݏo
	int ReadByDbrno(long dbrno,int recid);           // R[hԍ(Dbrno)ɂǂݏo
	void SetQuitObject(HANDLE h){h_quit=h;}          // fIuWFNg̐ݒ

	// oca(order by L/)
	int FindFirst(char *strSql,KYINFO *kyinfo);
	int FindNext(KYINFO *kyinfo);
	void FindExit(KYINFO *kyinfo); // ̒f
	// ʂ̎擾
	DBRNO GetDbrno(void){return m_Dbrno;}
	virtual void set_mdsp(void);		// \obt@̃Zbg(dummy)

protected:
	// 
	int sql_cond(char *strSql,int *order_by); // ̃Zbg
	int mk_select_from(int order_by);		  // SQL̐

	// oca
	virtual void set_dbrno(DBRNO *pdbrno,int tesu); // DBRNÕZbg

	// CSAo
	// ,ߏo
	virtual void out_bplay_comment_csa(CSDJArchive &ar, long recno, int tesu);
	void out_bplay_comment_csa(CSDJArchive &ar, long recno, int tesu,int recid);

private:
	// 
	int cmd_ls_orderby_1st(void);
	int cmd_ls_orderby_2nd(void);
	void cmd_ls_orderby_exit(void);
	int cmd_ls_1st(KYINFO *kyinfo);
	int cmd_ls_2nd(KYINFO *kyinfo);
	void cmd_ls_exit(KYINFO *kyinfo);
	int cmd_ls_judge(KYINFO *kyinfo);
	int ky_shogo(KYINFO *kyp,unsigned int *nUkm,int side);

	// CSAo
	void out_bform_csa(CSDJArchive &ar, CBform *bp); // zȕo(csa)
	void out_bplay_csa(CSDJArchive &ar, CBform *pBform, B_PLAY bplay); // w̏o
	char *out_T_csa(CSDJArchive &ar,char *text); // Ԃ̏o
protected:
	int realloc_comment(char *cp,int crlf=1); // Rg̈(comment)ɃRgcpZbg
	
protected:
	// 
	virtual int ky_matches(B_FORM *bp,CDBD *pDBD,KYINFO *kyp,int *tesu);
	int ky_matches(B_FORM *bp,CDBD *pDBD,KYINFO *kyp,int *tesu,int recid);

	// CSAs̓Ǎ
	virtual int set_player(char *sente,char *gote); // ΋ǎҖ̃Zbg
	virtual int item_check(int ino,char *cp); // L[ڒl̃`FbN
	char *line; // ͍s
	// ȉ̂R[`̓hLgCSA`̓ǂݍݑׂpublicƂB
public:
	char *get_line(CSDJArchive &ar); /* s */
	virtual int mrec_comment_set(char *line); // õRg
	virtual int brec_player(char *line);        // m_rec ΋ǎ҂̐ݒ
protected:
	int loc_PI(char *line); // PI zuZbg
	int loc_Psingle(char *line); //ʒPƕ\̏ꍇ(P+99KY,P-00FUȂ)
	int loc_Pall(char *line); // zuꊇ\
	virtual int drec_comment_set(char *line); // DB̃Rg
	int drec_T_set(char *line); // DB̏ԏ@RgƂēo^
	// D_REC̃R[h`FbNƊDBւ̓o^
	virtual int drec_play_set(char *line,int side,long brecno);
	int drec_play_set(char *line,int side,long brecno,int recid);
	virtual int sasite_comment(int sasite); // w蒍߂̓o^(sasite=萔)

	// ΋ǔԍrecnoɊւ钍DB Fscm̃R[hSďB Fscm,DscmQƂB
	virtual void dbf_remove(long recno);
};
#endif // __DBM__
