/************************/
/*    DlgCsaToJS.cpp    */
/************************/
// 2001.11.18  UpdateCsaFile() ǉ@by Ra
//   obt@ҏWĒՓo^łȂsCB

#include "stdafx.h"
#include "winsdj.h"
#include "DlgCsaToJS.h"
#include "statusbox.h"
#include <dbe.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;
/* ʊO֐錾 */
extern "C" {
void *memalloc(unsigned int);
void memfree(void *);
}

/////////////////////////////////////////////////////////////////////////////
// CDlgCsaToJS _CAO

CDlgCsaToJS::CDlgCsaToJS(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCsaToJS::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCsaToJS)
	m_strFile = _T("");
	m_Attr = 100;
	m_Eval = 100;
	m_Tsn = 40;
	m_bComment = FALSE;
	m_bDetail = TRUE;
	//}}AFX_DATA_INIT
}

void CDlgCsaToJS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCsaToJS)
	DDX_Control(pDX, IDC_CSA_WINDOW, m_edContents);
	DDX_Text(pDX, IDC_CSA_FILENAME, m_strFile);
	DDV_MaxChars(pDX, m_strFile, 128);
	DDX_Text(pDX, IDC_EDIT_ATTR, m_Attr);
	DDV_MinMaxInt(pDX, m_Attr, 0, 16383);
	DDX_Text(pDX, IDC_EDIT_EVAL, m_Eval);
	DDV_MinMaxInt(pDX, m_Eval, 0, 256);
	DDX_Text(pDX, IDC_EDIT_TSN, m_Tsn);
	DDV_MinMaxInt(pDX, m_Tsn, 1, 999);
	DDX_Check(pDX, IDC_COMMENT, m_bComment);
	DDX_Check(pDX, IDC_DISPDETAIL, m_bDetail);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgCsaToJS, CDialog)
	//{{AFX_MSG_MAP(CDlgCsaToJS)
	ON_BN_CLICKED(IDC_FILE_SELECT, OnFileSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCsaToJS bZ[W nh

/////
// 
BOOL CDlgCsaToJS::OnInitDialog() 
{
	// It@C̋L(vt@C)ΓǂݏoB
	GetCsaFname(m_strFile,FALSE);

	CDialog::OnInitDialog();
	
	// t@C̎w肪΂m_edContents֓ǂݏo
	SetEditContents(FALSE); // ͌x\ȂB
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

///////////////
// CSAt@CeGfBbg{bNXɕ\B
//  bMessageTRUE(ftHg)ȂxbZ[WL
void CDlgCsaToJS::SetEditContents(BOOL bMessage)
{
	CWaitCursor waitcr; // v

	if (m_strFile.IsEmpty())
		return ;

	FILE *fp;

	// String buffer  Ɨp
	char buffer[8192]; // CSAt@CsǍ݃obt@(CSA MAXs)
	char *buf,*buf1;
	int bufsize,buflen,len;
	
	bufsize=sizeof buffer; // String Buffer̃TCY8KPʂɂ
	if ((buf=(char *)memalloc(bufsize))==NULL) {
		AfxMessageBox("No memory!!");
		return;
	}
	// String Buffeȑ
	buf[0]='\0';
	buflen=0; // Buffer Length = 0

	fp=fopen(m_strFile,"rt");
	if (fp!=NULL) {
		m_edContents.SetReadOnly(FALSE); // obt@ҏW\ƂB
		// eLXgt@C"rt"ŃI[vfgets()œǂނƂɂB
		// eLXgt@C"\n"̍s"\r\n"̍sL蓾B
		// fgets()͂ǂ̃P[Xł"\n"ƂēǂݏoB
		for (int nLine=0;fgets(buffer,sizeof buffer -3,fp)!=NULL; nLine++) { // 
			// String Buffer Max 3000s܂
			// (5000ɂSetWindowTextĂȂ)
			if (nLine == 3000) {
				if (bMessage)
					AfxMessageBox(
  "̃t@C͑傫̂ŕҏW͏o܂B\nAÂ܂ܓo^邱Ƃ͉\łB");
				m_edContents.SetReadOnly(TRUE); // obt@[hI[ɂB
				break;
			}
			char *cp=strchr(buffer,'\n'); // fgetsœǂނ"\n"tēǂ܂
			if (cp!=NULL)
				strcpy(cp,"\r\n"); // WindowText͉sR[hKv

			// String Buffer̃TCY`FbN
			// ǂ񂾍sǉłȂ΃obt@gB
			len=strlen(buffer);
			if (buflen+len+1 > bufsize) {
				// obt@̊g
				bufsize+=sizeof buffer; // gTCY
				if ((buf1=(char *)memalloc(bufsize))==NULL) {
					AfxMessageBox("No memory!!");
					break;
				}
				strcpy(buf1,buf); // obt@̓eVobt@փRs[B
				memfree(buf);     // obt@͊JB
				buf=buf1; // obt@̊g
			}
			strcat(buf,buffer); // String Buffer֍sǍ݃obt@̓eǉB
			buflen+=len; // Buffer Length
		}
		fclose(fp);
	}
	m_edContents.SetWindowText(buf);
	m_edContents.SetModify(FALSE); // CtOZbg

	if (buf)
		memfree(buf);
}

/////
//  t@C̑I
void CDlgCsaToJS::OnFileSelect() 
{
	if (!UpdateData(TRUE))
		return;

	CString strFile=m_strFile;
	if (strFile.IsEmpty())
		// CSAt@C(fBNĝ)
		strFile.Format("%s*.csa",GetShgdbName()); 

 	CFileDialog dlgToJS(TRUE,	// Ǎ݃_CAO
			"csa",				// ftHggq
			strFile,		    // ftHgCSAt@C
			(DWORD)(OFN_HIDEREADONLY | OFN_FILEMUSTEXIST), // t@C̑
			"CSAt@C (*.csa)|*.csa| PCLt@C (*.pcl)|*.pcl||");
	BOOL bResult = dlgToJS.DoModal();

	if (bResult == IDOK) { // I
		m_strFile = dlgToJS.GetPathName();
		UpdateData(FALSE);

		// t@C̎w肪΂m_edContents֓ǂݏo
		SetEditContents();
	}
}

////////////////////////
// CSA o^ [J[Xbh
//   CSAt@CI[vāAeՂca֓o^B
static UINT ToDbeWorkerThread(CStatusBox *pBox,CEvent *pStopEvent,
								LPARAM lParam /* =0L */ )
{
	CDlgCsaToJS *pDlgCsaToJS=(CDlgCsaToJS *)lParam;
	CString *pstrFile=&pDlgCsaToJS->m_strFile;
	CString strFile=*pstrFile;
	int Eval=pDlgCsaToJS->m_Eval;
	int Attr=pDlgCsaToJS->m_Attr;
	int Tsn =pDlgCsaToJS->m_Tsn;
	BOOL bComment=pDlgCsaToJS->m_bComment;
	BOOL bDetail=pDlgCsaToJS->m_bDetail;
	long sum;
	BOOL bQuit=FALSE;

	CDBE Dbe;
	if (!Dbe.Open()) { // DB I[vs
		return 1;
	}
	
	Dbe.SetQuitObject((HANDLE)(*pStopEvent)); // fCxg̐ݒ
	Dbe.DetailDispEnable(bDetail);    // ڍו\̗L
	Dbe.CommentWriteEnable(bComment); // ߓo^̗L

	if (strFile.IsEmpty()) {
		// CSAt@Ci[t@CI[vG[
		CString str;
		str.Format("CSAt@C͂ĂB");
		AfxMessageBox(str);
		bQuit=TRUE;
	}

	if (!bQuit) {
		CFile f;
		// t@C̃I[v
		if (f.Open(strFile,CFile::modeReadWrite)) { 
			CSDJArchive ar(&f,CArchive::load);
			Dbe.SetMessageWindow(pBox);
			// CSAt@C̓e΋ǂca֓o^B
			int rc=Dbe.InCsa2DBE(ar,Eval,Attr,Tsn,&sum);
			ar.Close();
			f.Close();
		}
		else { // CSAt@CI[vG[
			CString str;
			str.Format("t@C(%s)I[vł܂B",strFile);
			AfxMessageBox(str);
			bQuit=TRUE;
		}
	}

	Dbe.Close();
	return (UINT)(!bQuit);
}

/////
// t@C̓o^
void CDlgCsaToJS::OnOK() 
{
	int iWriteOK=IDYES;

	if (!UpdateData(TRUE))
		return;

	// obt@ҏWĂ邩ׂ
	if (m_edContents.GetModify()) {
		iWriteOK=AfxMessageBox(
			"obt@ύXĂ܂B̓eœo^܂H",
			MB_YESNO);
		if (iWriteOK==IDYES) {
			if (!UpdateCsaFile()) // obt@̓eCSAt@C֍XV
				iWriteOK=IDNO;    // XVs
		}
	}
	if (iWriteOK != IDYES)
		return ;

	// Փo^
	CStatusBox StatusBox(&ToDbeWorkerThread,(LPARAM)this); // t@C̓o^
	StatusBox.DoModal();

	CDialog::OnOK();
}

// obt@̓et@C֍XV
BOOL CDlgCsaToJS::UpdateCsaFile()
{
	CFile f;
	if (!f.Open(m_strFile,
		CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyWrite)) {
		char StringBuffer[512];
		if (m_strFile!="")
			sprintf(StringBuffer,"t@C(%s)̃I[vG[łB",m_strFile);
		else
			sprintf(StringBuffer,"t@Cw肵ĂB");

		AfxMessageBox(StringBuffer);
		return FALSE;
	}
	char buffer[PCLLINE_MAX]; // CSAt@CsǍ݃obt@
	// ɂƁAGetLineCount()'\n'̐+1Ԃ̗lB
	// ]čŏIs'\n'ƂƂȂƂŒӂKvB(Ldl)
	int nLine=m_edContents.GetLineCount();
	int i,len;
	for (i=0;i<nLine;i++) {
		// ɂƁAGetLine()\r\nOčsԂB
		len=m_edContents.GetLine(i,buffer,sizeof buffer);
		strcpy(&buffer[len],"\r\n"); // ގ͉sď
		if (i < nLine-1 || len > 0) // ŏIs'\n'Ȃ len>0̔
			f.Write(buffer,len+2); // notepadłJ悤 "\n\r"ŏ
	}
	f.Close();
	m_edContents.SetModify(FALSE); // eLXg͖C(=FILE)ƂB

	return TRUE;
}
