/********************/
/*    DlgDir.cpp    */
/********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgDir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

/////////////////////////////////////////////////////////////////////////////
// CDlgDir _CAO

CDlgDir::CDlgDir(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDir::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgDir)
	//}}AFX_DATA_INIT
}

void CDlgDir::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDir)
	DDX_Control(pDX, IDC_DIRSTATIC, m_PathName);
	DDX_Control(pDX, IDC_DRIVECOMBO, m_DriveCombo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgDir, CDialog)
	//{{AFX_MSG_MAP(CDlgDir)
	ON_LBN_DBLCLK(IDC_DIRLIST, OnDblclkDirlist)
	ON_CBN_SELCHANGE(IDC_DRIVECOMBO, OnSelchangeDrivecombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgDir bZ[W nh

BOOL CDlgDir::OnInitDialog() 
{
	
	CDialog::OnInitDialog();

	// fBNgl̋L
	GetCurrentDirectory(sizeof m_DefaultDir,m_DefaultDir);

	// fBNgXg̎擾
	strcpy(PathString,"*.*");
	DlgDirList(PathString,IDC_DIRLIST,IDC_DIRSTATIC,
		DDL_DIRECTORY|DDL_EXCLUSIVE);

	// hCuXg̎擾
	strcpy(DriveString,"*.*");
	DlgDirListComboBox(DriveString,IDC_DRIVECOMBO,0,
		DDL_DRIVES|DDL_EXCLUSIVE);

	// hCuR{{bNXɃJghCu\B
	CString strDrv=m_DefaultDir;
	strDrv.Format("[-%c-]",(int)m_DefaultDir[0]);
	int idx=m_DriveCombo.SelectString(-1,strDrv); // R{{bNX̑I
	m_DriveCombo.SetTopIndex(idx); // R{{bNX̑I\

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

///////
// fBNgI(_uNbN)
void CDlgDir::OnDblclkDirlist() 
{
	DlgDirSelect(PathString,IDC_DIRLIST); // IfBNgl̎擾
	SetCurrentDirectory(PathString);      // Change Directory

	// fBNgXg̎擾
	strcpy(PathString,"*.*");
	DlgDirList(PathString,IDC_DIRLIST,IDC_DIRSTATIC,
		DDL_DIRECTORY|DDL_EXCLUSIVE);
}

////////
// hCuI
void CDlgDir::OnSelchangeDrivecombo() 
{
	// hCuXg̑I
	DlgDirSelectComboBox(DriveString,IDC_DRIVECOMBO); // IhCul̎擾

	CWaitCursor WaitCursor; // v
	// ChangeDirectory
	SetCurrentDirectory(DriveString);

	////
	// fBNgŃXg{bNXƃR{{bNXĕ\B

	// fBNgXg̎擾
	strcpy(PathString,"*.*");
	DlgDirList(PathString,IDC_DIRLIST,IDC_DIRSTATIC,
		DDL_DIRECTORY|DDL_EXCLUSIVE);

	// hCuXg̎擾
	strcpy(DriveString,"*.*");
	DlgDirListComboBox(DriveString,IDC_DRIVECOMBO,0,
		DDL_DRIVES|DDL_EXCLUSIVE);

	// hCuR{{bNXɃJghCu\B
	char CurDir[512];
	GetCurrentDirectory(sizeof CurDir,CurDir);
	CString strDrv;
	strDrv.Format("[-%c-]",(int)CurDir[0]);
	int idx=m_DriveCombo.SelectString(-1,strDrv); // R{{bNX̑I
	m_DriveCombo.SetTopIndex(idx); // R{{bNX̑I\
}

///////
// fBNgII
void CDlgDir::OnOK() 
{
	// Xg{bNXɑIꂽfBNg΁A
	// ܂߂đI邽߂ɁAxChangeDirectoryB
	BOOL bSelected=DlgDirSelect(PathString,IDC_DIRLIST); // IfBNgl̎擾
	if (bSelected) {
		SetCurrentDirectory(PathString);      // Change Directory

		// fBNgXg̎擾
		strcpy(PathString,"*.*");
		DlgDirList(PathString,IDC_DIRLIST,IDC_DIRSTATIC,
			DDL_DIRECTORY|DDL_EXCLUSIVE);
	}

	// IꂽfBNg
	m_PathName.GetWindowText(strSelPathName);

	SetCurrentDirectory(m_DefaultDir); // fBNg֖߂ďI
	CDialog::OnOK();
}

//////
// LZI
void CDlgDir::OnCancel() 
{
	SetCurrentDirectory(m_DefaultDir); // fBNg֖߂ďI
	CDialog::OnCancel();
}
