/*************************/
/*    DlgEcellBox.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include <dbe.h>
#include "dbeframe.h"
#include "ecell.h"
#include "dbedoc.h"
#include "kbase.h"
#include "DlgEcellBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/// O[o
extern CWinSDJApp theApp;
extern HANDLE g_hDblock;
/////////////////////////////////////////////////////////////////////////////
// CDlgEcellBox _CAO

CDlgEcellBox::CDlgEcellBox(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgEcellBox::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgEcellBox)
	m_strMove = _T("");
	m_Attr = 0;
	m_Eval1 = 0;
	m_Eval2 = 0;
	//}}AFX_DATA_INIT
	m_bInitOK=FALSE;
}

void CDlgEcellBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgEcellBox)
	DDX_Text(pDX, IDC_STRMOVE, m_strMove);
	DDV_MaxChars(pDX, m_strMove, 256);
	DDX_Text(pDX, IDC_ATTR, m_Attr);
	DDV_MinMaxInt(pDX, m_Attr, 0, 16383);
	DDX_Text(pDX, IDC_EVAL1, m_Eval1);
	DDX_Text(pDX, IDC_EVAL2, m_Eval2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgEcellBox, CDialog)
	//{{AFX_MSG_MAP(CDlgEcellBox)
	ON_WM_DESTROY()
	ON_COMMAND(ID_ECELLBOX_INITDATA,OnEcellBoxInitData)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgEcellBox bZ[W nh

/////
// ՎlݒI
void CDlgEcellBox::OnOK() 
{
	if (!UpdateData(TRUE)) // f[^̎o
		return;
	if (!m_bInitOK)
		return;  // ܂ȂB

	if (m_Attr != eclCld->attr) {
		// Վ葮l̍XV
		// f[^x[XP񂾂bNĎsreturnB
		if (WaitForSingleObject(g_hDblock,0)!=WAIT_OBJECT_0) {
			AfxMessageBox("f[^x[X͎gpł");
			return;
		}
		pFrame->SetCloseLock(TRUE);
		
		CDBE Dbe;
		int rc;
		if (Dbe.Open()) {
			//  Ղca̍XV
			// WinSDJ5.1 by KY. 00/2/20 o[ɕύX
			rc=Dbe.UpdateBplay(&m_Bform,m_side,
				eclCld->bplay,(short)m_Attr);
			Dbe.Close();
		}
		ReleaseMutex(g_hDblock); // DB unlock
		pFrame->SetCloseLock(FALSE);
		
		if (rc==E$OK)  {
			eclCld->attr=m_Attr;
		} else {
			CString mes;
			mes.Format("Վ̍XVɎs܂(%d)",rc);
			AfxMessageBox(mes);
		}
	}

	DestroyWindow();
}

/////
// ՎlLZI
void CDlgEcellBox::OnCancel() 
{
	DestroyWindow();
}

////
// IuWFNg̔j
void CDlgEcellBox::PostNcDestroy() 
{
	delete this;
}

////
// e̋L
void CDlgEcellBox::OnDestroy() 
{
	CDialog::OnDestroy();
	
	CWnd *pWnd=GetParent(); // CDbeFrameɂȂĂ
	// CDbeViewŃR}hB
	pWnd->SendMessage(WM_COMMAND,ID_DLG_ECELLBOX_SETNULL);
}

////
// 
void CDlgEcellBox::InitData()
{
	m_bInitOK=FALSE;

	m_strMove.Empty();
	m_Eval1=0;
	m_Eval2=0;
	m_Attr=0;

	if (theApp.m_bSelectBoxBUsing)
		return; // EI_CAOgp

	HTREEITEM hRoot=pTreeCtrl->GetRootItem();
	if (hRoot==NULL)
		return; // Վ肪Ȃ

	HTREEITEM hNow =pTreeCtrl->GetSelectedItem();
	if (hNow==NULL) // I
		return;

	POSITION pos=(POSITION)pTreeCtrl->GetItemData(hNow);
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	eclCld=pEcellList->GetAt(pos);
	if (eclCld->bplay==(B_PLAY)(-1))
		return; // ǖʂI

	// RootI𒆂̏ꍇ
	if (hNow==hRoot) {
		CKBase *pKBase=pDoc->GetKBase();
		pKBase->backmove2();
		// WinSDJ5.1 by KY.00/02/20
		//ŐǖʂoɌďo
		m_Bform=*pKBase->btype(); // ŐǖʂKBase狁߂B
		m_side = pKBase->turn();
		pKBase->ahead2();
		if (WaitForSingleObject(g_hDblock,0)!=WAIT_OBJECT_0) // Db lock
			return;
		pFrame->SetCloseLock(TRUE);

		CDBE Dbe;
		int rc=E$NG; // WinSDJ5.1 modifyed by KY. E$NG,FindBplay()
		B_PLAY bplay;short eval,attr;
		if (Dbe.Open()) {
			rc=Dbe.FindBplay(&m_Bform,m_side,&eval,&bplay,&attr);// DBǂ
			Dbe.Close();
		}
		ReleaseMutex(g_hDblock); // DB unlock
		pFrame->SetCloseLock(FALSE);
		if (rc==E$OK)
			m_Eval1=eval;
		else
			return;
	} else {
		HTREEITEM hParent=pTreeCtrl->GetParentItem(hNow); // Őǖ(e)
		ASSERT(hParent);
		pos=(POSITION)pTreeCtrl->GetItemData(hParent);
		eclPnt=pEcellList->GetAt(pos);
		m_Eval1		=eclPnt->eval;

		// WinSDJ5.1 by KY. 00/2/20 ȉ̂QsǉB
		m_Bform		=eclPnt->Bform;
		m_side		=eclPnt->side;
	}	

	m_strMove	=eclCld->strMove;
	m_Eval2		=eclCld->eval;
	m_Attr		=eclCld->attr;

	m_bInitOK=TRUE;
}

BOOL CDlgEcellBox::OnInitDialog() 
{
	InitData(); // f[^̏
	CDialog::OnInitDialog();
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

///////
// \XV
void CDlgEcellBox::OnEcellBoxInitData()
{
	InitData();
	UpdateData(FALSE);
}
