/**********************/
/*    DlgInCsa.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgInCsa.h"
#include "StatusBox.h"
#include <dbb.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;
/* ʊO֐錾 */
extern "C" {
void *memalloc(unsigned int);
void memfree(void *);
}

/////////////////////////////////////////////////////////////////////////////
// CDlgInCsa _CAO
void CDlgInCsa::CommonInit()
{
	//{{AFX_DATA_INIT(CDlgInCsa)
	m_strCsaFile = _T("");
	m_iMode = -1;
	//}}AFX_DATA_INIT
}


CDlgInCsa::CDlgInCsa(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgInCsa::IDD, pParent)
{
	CommonInit();
}
CDlgInCsa::CDlgInCsa(int idd,CWnd* pParent /*=NULL*/)
    : CDialog(idd,pParent)
{
	CommonInit();
}


void CDlgInCsa::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgInCsa)
	DDX_Control(pDX, IDC_CSA_WINDOW, m_edCsaContents);
	DDX_Text(pDX, IDC_CSA_FILENAME, m_strCsaFile);
	DDV_MaxChars(pDX, m_strCsaFile, 128);
	DDX_Radio(pDX, IDC_ModeNew, m_iMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgInCsa, CDialog)
	//{{AFX_MSG_MAP(CDlgInCsa)
	ON_BN_CLICKED(IDOK, OnTouroku)
	ON_BN_CLICKED(IDC_FILE_SELECT, OnFileSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDlgInCsa bZ[W nh

/////
//  CSAt@C̑I
void CDlgInCsa::OnFileSelect() 
{
	CString CsaFile=m_strCsaFile;
	if (CsaFile.IsEmpty())
		// CSAt@C(fBNĝ)
		CsaFile.Format("%s*.csa",GetShgdbName()); 

	CFileDialog dlgInCsa(TRUE,	// Ǎ݃_CAO
			"csa",				// ftHggq
			CsaFile,		    // ftHgCSAt@C
			(DWORD)(OFN_HIDEREADONLY | OFN_FILEMUSTEXIST), // t@C̑
			"CSAt@C (*.csa)|*.csa||");
	BOOL bResult = dlgInCsa.DoModal();

	if (bResult == IDOK) { // I
		m_strCsaFile = dlgInCsa.GetPathName();
		UpdateData(FALSE);

		// t@C̎w肪΂m_edContents֓ǂݏo
		SetEditCsaContents();

		// Iꂽt@Cvt@CփZ[uB
		// OnInitDialogŎQƂB
		WriteCsaFname(m_strCsaFile);
	}
}

////
/// _CAȌ
BOOL CDlgInCsa::OnInitDialog() 
{
	CWaitCursor waitcr; // v
	m_iMode=0; // ɐVKo^(ftHg)
	
	// It@C̋L(vt@C)ΓǂݏoB
	GetCsaFname(m_strCsaFile,FALSE);

	CDialog::OnInitDialog();

	// t@C̎w肪΂m_edContents֓ǂݏo
	SetEditCsaContents(FALSE); // ͌x\ȂB


	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

///////////////
// CSAt@CeGfBbg{bNXɕ\B
//  bMessageTRUE(ftHg)ȂxbZ[WL
void CDlgInCsa::SetEditCsaContents(BOOL bMessage)
{
	if (m_strCsaFile.IsEmpty())
		return ;

	FILE *fp;

	// String buffer  Ɨp
	char buffer[CSALINE_MAX]; // CSAt@CsǍ݃obt@(CSA MAXs)
	char *buf,*buf1;
	int bufsize,buflen,len;
	
	bufsize=sizeof buffer; // String Buffer̃TCY8KPʂɂ
	if ((buf=(char *)memalloc(bufsize))==NULL) {
		AfxMessageBox("No memory!!");
		return;
	}
	// String Buffeȑ
	buf[0]='\0';
	buflen=0; // Buffer Length = 0

	fp=fopen(m_strCsaFile,"rt");
	if (fp!=NULL) {
		m_edCsaContents.SetReadOnly(FALSE); // obt@ҏW\ƂB
		// eLXgt@C"rt"ŃI[vfgets()œǂނƂɂB
		// eLXgt@C"\n"̍s"\r\n"̍sL蓾B
		// fgets()͂ǂ̃P[Xł"\n"ƂēǂݏoB
		for (int nLine=0;fgets(buffer,sizeof buffer -3,fp)!=NULL; nLine++) { // 
			// String Buffer Max 3000s܂
			// (5000ɂSetWindowTextĂȂ)
			if (nLine == 3000) {
				if (bMessage)
					AfxMessageBox(
 "CSAt@C͑傫̂ŕҏW͏o܂B\nAÂ܂ܓo^邱Ƃ͉\łB");
				m_edCsaContents.SetReadOnly(TRUE); // obt@[hI[ɂB
				break;
			}
			char *cp=strchr(buffer,'\n'); // fgetsœǂނ"\n"tēǂ܂
			if (cp!=NULL)
				strcpy(cp,"\r\n"); // WindowText͉sR[hKv

			// String Buffer̃TCY`FbN
			// ǂ񂾍sǉłȂ΃obt@gB
			len=strlen(buffer);
			if (buflen+len+1 > bufsize) {
				// obt@̊g
				bufsize+=sizeof buffer; // gTCY
				if ((buf1=(char *)memalloc(bufsize))==NULL) {
					AfxMessageBox("No memory!!");
					break;
				}
				strcpy(buf1,buf); // obt@̓eVobt@փRs[B
				memfree(buf);     // obt@͊JB
				buf=buf1; // obt@̊g
			}
			strcat(buf,buffer); // String Buffer֍sǍ݃obt@̓eǉB
			buflen+=len; // Buffer Length
		}
		fclose(fp);
	}
	m_edCsaContents.SetWindowText(buf);
	m_edCsaContents.SetModify(FALSE); // CtOZbg

	if (buf)
		memfree(buf);
}

////////////////////////
// CSA o^ [J[Xbh
//   vt@C(KF_SECTION,KF_CSAFILE_NAME)Ɋi[ĂCSAt@
//   CǂݏoCSAt@CI[vāAe΋ǂca
//   o^BVKEXVo^̎wCSAt@C̑΋ǔԍw̗L
//   ōsB
static UINT Csa2DBBWorkerThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam )
{
	CDBB Dbb;
	BOOL bQuit=FALSE;
	CDlgInCsa *pDlg=(CDlgInCsa*)lParam;
	BOOL bIgnoreRecno=!(pDlg->m_iMode); // ɐVKo^(TRUE)ۂ

	// fCxg̐ݒ
	Dbb.SetQuitObject((HANDLE)(*pStopEvent));
	
	CString strCsaFile; // CSAt@C
	GetCsaFname(strCsaFile,FALSE); // CSAt@C̓ǂݏo
	if (strCsaFile.IsEmpty()) {
		// CSAt@Ci[t@CI[vG[
		CString str;
		str.Format("CSAt@C͂ĂB");
		AfxMessageBox(str);
		bQuit=TRUE;
	}

	if (!bQuit) {
		CFile fCsa;
		// CSAt@C̃I[v
		if (fCsa.Open(strCsaFile,CFile::modeReadWrite)) { 
			CSDJArchive ar(&fCsa,CArchive::load);
			Dbb.InCsa2DB(ar,pBox,bIgnoreRecno); // CSAt@C̓e΋ǂca֓o^B
			ar.Close();
			fCsa.Close();
		}
		else { // CSAt@CI[vG[
			CString str;
			str.Format("CSAt@C(%s)I[vł܂B",strCsaFile);
			AfxMessageBox(str);
			bQuit=TRUE;
		}
	}
	return (UINT)(!bQuit);
}
// obt@̓et@C֍XV
BOOL CDlgInCsa::UpdateCsaFile()
{
	CFile f;
	if (!f.Open(m_strCsaFile,
		CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyWrite)) {
		char StringBuffer[512];
		if (m_strCsaFile!="")
			sprintf(StringBuffer,"CSAt@C(%s)̃I[vG[łB",m_strCsaFile);
		else
			sprintf(StringBuffer,"CSAt@Cw肵ĂB");

		AfxMessageBox(StringBuffer);
		return FALSE;
	}
	char buffer[CSALINE_MAX]; // CSAt@CsǍ݃obt@
	// ɂƁAGetLineCount()'\n'̐+1Ԃ̗lB
	// ]čŏIs'\n'ƂƂȂƂŒӂKvB(Ldl)
	int nLine=m_edCsaContents.GetLineCount();
	int i,len;
	for (i=0;i<nLine;i++) {
		// ɂƁAGetLine()\r\nOčsԂB
		len=m_edCsaContents.GetLine(i,buffer,sizeof buffer);
		strcpy(&buffer[len],"\r\n"); // ގ͉sď
		if (i < nLine-1 || len > 0) // ŏIs'\n'Ȃ len>0̔
			f.Write(buffer,len+2); // notepadłJ悤 "\n\r"ŏ
	}
	f.Close();
	m_edCsaContents.SetModify(FALSE); // eLXg͖C(=FILE)ƂB

	return TRUE;
}
/////
// CSAt@C̓o^
void CDlgInCsa::OnTouroku() 
{
	int iWriteOK=IDYES;

	// obt@ҏWĂ邩ׂ
	if (m_edCsaContents.GetModify()) {
		iWriteOK=AfxMessageBox(
			"obt@ύXĂ܂B̓eœo^܂H",MB_YESNO);
		if (iWriteOK==IDYES) {
			if (!UpdateCsaFile()) // obt@̓eCSAt@C֍XV
				iWriteOK=IDNO;    // XVs
		}
	}
	if (iWriteOK != IDYES)
		return ;

	UpdateData(TRUE); // f[^̎擾

	// ΋DBo^
	CStatusBox StatusBox(&Csa2DBBWorkerThread,(LPARAM)this); // CSAt@C̓o^
	StatusBox.DoModal();

	CDialog::OnOK(); // OKI
}
