/************************/
/*    DlgKifToJS.cpp    */
/************************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgKifToJS.h"
#include "statusbox.h"
#include <dbe.h>
#include <winmemfile.h>
#include "KBase.h"
#include "LBase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgKifToJS _CAO

CDlgKifToJS::CDlgKifToJS(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgKifToJS::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgKifToJS)
	m_bComment = FALSE;
	m_bDetail = TRUE;
	m_Attr = 100;
	m_Eval = 100;
	m_Tsn = 40;
	//}}AFX_DATA_INIT
	m_pKBase=NULL;
}

void CDlgKifToJS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgKifToJS)
	DDX_Check(pDX, IDC_COMMENT, m_bComment);
	DDX_Check(pDX, IDC_DISPDETAIL, m_bDetail);
	DDX_Text(pDX, IDC_EDIT_ATTR, m_Attr);
	DDV_MinMaxInt(pDX, m_Attr, 0, 16383);
	DDX_Text(pDX, IDC_EDIT_EVAL, m_Eval);
	DDV_MinMaxInt(pDX, m_Eval, 0, 256);
	DDX_Text(pDX, IDC_EDIT_TSN, m_Tsn);
	DDV_MinMaxInt(pDX, m_Tsn, 1, 300);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgKifToJS, CDialog)
	//{{AFX_MSG_MAP(CDlgKifToJS)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgKifToJS bZ[W nh

////////////////////////
// CSA o^ [J[Xbh
//   DlgKifToJSm_pKBase̓eՂca֓o^B
static UINT WorkerThread(CStatusBox *pBox,CEvent *pStopEvent,
								LPARAM lParam /* =0L */ )
{
	CDlgKifToJS *pDlgKifToJS=(CDlgKifToJS *)lParam;
	long sum;
	int Eval=pDlgKifToJS->m_Eval;
	int Attr=pDlgKifToJS->m_Attr;
	int Tsn =pDlgKifToJS->m_Tsn;
	BOOL bComment=pDlgKifToJS->m_bComment;
	BOOL bDetail=pDlgKifToJS->m_bDetail;
	CKBase *pKBase=pDlgKifToJS->GetKBase();

	// ݂̋ǖʈȉ̊Rs[B
	CLBase LBase;
	pKBase->CopySBase(&LBase,FALSE,FALSE); // ǖʈȉ̑ԂRs[

	CWinMemFile mf; // t@C
	// Rs[obt@̊t@CփVACY
	CSDJArchive storeAr(&mf,CArchive::store);
	LBase.Serialize(storeAr);
	storeAr.Close();

	mf.Seek(0L,CFile::begin); // 擪Seek

	CDBE Dbe;
	if (!Dbe.Open()) { // DB I[vs
		return 1;
	}
	
	Dbe.SetQuitObject((HANDLE)(*pStopEvent)); // fCxg̐ݒ
	Dbe.DetailDispEnable(bDetail);    // ڍו\̗L
	Dbe.CommentWriteEnable(bComment); // ߓo^̗L

	Dbe.SetMessageWindow(pBox);

	// ǂݏoA[JCo
	CSDJArchive loadAr(&mf,CArchive::load);
	// CSAt@C̓e΋ǂca֓o^B
	int rc=Dbe.InCsa2DBE(loadAr,Eval,Attr,Tsn,&sum);
	loadAr.Close();

	Dbe.Close();

	return 0;
}

void CDlgKifToJS::OnOK() 
{
	if (!UpdateData(TRUE))
		return;
	
	// Փo^
	CStatusBox StatusBox(&WorkerThread,(LPARAM)this); // t@C̓o^
	StatusBox.DoModal();

	CDialog::OnOK();
}

BOOL CDlgKifToJS::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	ASSERT(m_pKBase);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
