/************************/
/*    DlgMateDbc.cpp    */
/************************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgMateDbc.h"
#include "mateframe.h"
#include "mateview.h"
#include "winsdjtsdoc.h"
#include "winsdjtsview.h"
#include "kbase.h"
#include <sthought.h>
#include <winmemfile.h>
#include <dbc.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/// O[o
extern HANDLE g_hDblock;
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgMateDbc _CAO

CDlgMateDbc::CDlgMateDbc(CWnd* pParent /*=NULL*/)
	: CDlgDelDbc(CDlgMateDbc::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMateDbc)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	m_pParentWnd=NULL;
	m_bThinking=FALSE;
	m_bThinkEnd=FALSE;
	m_bMateFrameClosing=FALSE;
	m_pos=NULL;
	theApp.m_bMateDbcUsing=TRUE; // lcavlJn
}

void CDlgMateDbc::DoDataExchange(CDataExchange* pDX)
{
	CDlgDelDbc::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMateDbc)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgMateDbc, CDlgDelDbc)
	//{{AFX_MSG_MAP(CDlgMateDbc)
	ON_BN_CLICKED(IDOK, OnThought)
	ON_WM_CLOSE()
	ON_COMMAND(ID_ON_CLOSE_MATE_FRAME, OnCloseMateFrame)
	ON_COMMAND(ID_MATE_FINISHED, OnMateFinished)
	ON_BN_CLICKED(IDC_SELECTALL, OnSelectAll)
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// Create
BOOL CDlgMateDbc::Create(UINT nIDTemplate,CWnd* pParent)
{
	m_pParentWnd=pParent;

	return CDialog::Create(nIDTemplate,pParent);
}

/////////////////////////////////////////////////////////////////////////////
// CDlgMateDbc bZ[W nh

// VXej[R}h(ő\ResoreɕύX)
void CDlgMateDbc::OnSysCommand(UINT nID, LPARAM lParam)
{
	nID &= 0xfff0; // }XN
    if (nID==SC_MAXIMIZE) { // ő\
		ShowWindow(SW_RESTORE); // ɖ߂
	}
	else {
		CDlgDelDbc::OnSysCommand(nID,lParam);
	}
}

void CDlgMateDbc::OnThought() 
{
	if (m_bThinking)
		return;
	UpdateData(TRUE); // ϐ̍XV

	// I𐔂̃`FbN
	if (m_iSelItemNum <=0) 
		return ; // IĂȂB

	// vl̔O
	int MBret=IDNO;
	CWinSDJTSView *pView=(CWinSDJTSView*)(m_pParentWnd);
	ASSERT(pView->IsKindOf(RUNTIME_CLASS(CWinSDJTSView)));
	CKBase *pKBase = pView->GetDocument()->GetKBase();
	CString strbuf;
	strbuf.Format("%d%s%s",
		m_iSelItemNum,
		" ̋lvlAf[^x[XXV܂B\r\n",
		(pKBase->root()->cldnum())?
			"obt@̎w͑SĔj܂B\r\n낵łH":
			"낵łH");
	MBret=AfxMessageBox(strbuf,MB_YESNO);
	if (MBret!=IDYES)
		return;

	pView->PrepareMenuMate(); // j[sO

	int ret=AutoThink(); // lvl̋N
	if (ret==FALSE) { // ͂Ȃ....B
		AfxMessageBox("lvlɎs܂B");
		NotifyParent(); // Iʒm
		DestroyWindow();
	}
}

void CDlgMateDbc::PostNcDestroy() 
{
	theApp.m_bMateDbcUsing=FALSE; // lcavl I
	delete this;
}

// LZI
void CDlgMateDbc::OnCancel() 
{
	NotifyParent(); // Iʒm
	DestroyWindow();
}


void CDlgMateDbc::OnClose() 
{
	NotifyParent(); // Iʒm
	CDlgDelDbc::OnClose();
}

// Iʒm
void CDlgMateDbc::NotifyParent()
{
	if (!m_pParentWnd)
		return;
	CWinSDJTSView *pTSView=(CWinSDJTSView*)m_pParentWnd;
	CSSdjDocTemplate *pMateTemplate=pTSView->GetMateTemplate();
	POSITION pos=pMateTemplate->GetFirstDocPosition();
	if (pos) {
		m_bMateFrameClosing=TRUE;
		pMateTemplate->CloseAllDocuments(TRUE);
		m_bMateFrameClosing=FALSE;
	}
	if (m_pParentWnd) {
		m_pParentWnd->SendMessage(WM_COMMAND,ID_DLG_MATE_DBC_SETNULL);
		m_pParentWnd=NULL;
	}
}

// vl󋵕\̃N[Yʒm
// ł͓ɂȂɂ邱Ƃ͂ȂB
void CDlgMateDbc::OnCloseMateFrame()
{
	return;
}

// lvlI
// ̋lvlIƌĂ΂B
void CDlgMateDbc::OnMateFinished()
{
	if (m_bMateFrameClosing) {
		// Iʒm(WM_CLOSE)ŒfI͑I
		// AutoThink()֍sƎ̎vln߂Ă܂B
		m_bThinkEnd=TRUE;
		return;
	}

	CWinSDJTSView *pView=(CWinSDJTSView*)(m_pParentWnd);
	ASSERT(pView->IsKindOf(RUNTIME_CLASS(CWinSDJTSView)));
	CWinSDJTSDoc *pDoc=pView->GetDocument(); // hLg
	CKBase *pKBase=pDoc->GetKBase();

	if (pKBase->root()->cldnum()) {
		WaitForSingleObject(g_hDblock,INFINITE); // Db lock

		// cãZbg
		CString strShgdb=getenv("SHGDB"); // ݂̏ca
		if (strShgdb!=m_strShgdb) {
			CString shgdb;
			shgdb.Format("SHGDB=%s",m_strShgdb); // ȑȌcaZbg
			_putenv(shgdb);
		}

		// 炪lca̍XV
		// CKBasẽobt@͂caǂݍ܂ꂽ̂Ȃ̂ŏ㏑o^O
		// 悸l({菇)t@CCSAo͂B
		CWinMemFile *pMemFile=new CWinMemFile;
		CSDJArchive arOut(pMemFile, CArchive::store); // A[JCo
		pDoc->Serialize(arOut,TRUE); // {菇̏o
		arOut.Close();
		pMemFile->Seek(0L,CFile::begin); // t@C̓oB
		CSDJArchive arIn(pMemFile, CArchive::load);
		CDBC Dbc; // lca
		// caXV(o߂MateFrame\,㏑[hAg[^͕\ȂB)
		CSSdjDocTemplate *pMateTemplate=pView->GetMateTemplate();
		POSITION pos=pMateTemplate->GetFirstDocPosition();ASSERT(pos);
		CDocument *pMateDoc=pMateTemplate->GetNextDoc(pos);
		POSITION pos2=pMateDoc->GetFirstViewPosition(); ASSERT(pos2);
		CMateView *pMateView=(CMateView*)pMateDoc->GetNextView(pos2);
		int recno=Dbc.InCsa2DB(arIn,pMateView,FALSE,FALSE);
		arIn.Close();
		delete pMemFile;

		// XVɐBPCLt@CXV
		if (recno >=0) {
			// xȂAPCLt@C̓hLg玩B
			// (㏑L蓾Ȃ̂)
			BOOL bMulti=pKBase->IsMulti();
			pDoc->PclUpdate(bMulti,FALSE);
		}

		// cãZbg
		if (strShgdb!=m_strShgdb) {
			CString shgdb;
			shgdb.Format("SHGDB=%s",strShgdb); // ݂̏caɖ߂
			_putenv(shgdb);
		}

		ReleaseMutex(g_hDblock); // Db unlock
	}

	// s͍폜B
	m_MultiSelList.DeleteString(0);

	BOOL ret=AutoThink(); // vl

	if (ret==FALSE) {
		// vlI̋L
		m_bThinkEnd=TRUE;
	}
}

// lvl̎s
// f[^x[XǂݏoĎvl
// ߂l  TRUE:vlN  FALSE:ΏۊȂ̂ŎvlI
BOOL CDlgMateDbc::AutoThink()
{
	if (m_bThinking==FALSE) {
		// ̏
		m_bThinking=TRUE;

		m_lstDbrno.RemoveAll();

		// DBRNÕXg(CSelectBoxBɂ)
		CList <DBRNO,DBRNO&> *pDbrFindList=GetSelectBoxC()->GetDbrFindList();
		int n=m_MultiSelList.GetCount(); // Xg̐
		for (int i=0;i<n;i++) {
			POSITION pos=pDbrFindList->FindIndex(i); // Indexpos߂
			if (pos==NULL)
				break;
			if (m_MultiSelList.GetSel(i)) { // IĂ
				DBRNO Dbrno=pDbrFindList->GetAt(pos); // posDBRNO߂
				m_lstDbrno.AddTail(Dbrno.dbrno);	  // vlΏDBCR[hԍ
			}
			else {
				m_MultiSelList.DeleteString(i);
				pDbrFindList->RemoveAt(pos);
				i--; // +1邩炱ňĂB
				n--; // 폜S-1;
			}
		}
		m_pos=m_lstDbrno.GetHeadPosition(); // m_posHeadɁB

		// lvl󋵕\
		// r[MateTemplate --> MateDoc --> MateView ̏ɎJB
		CWinSDJTSView *pTSView=(CWinSDJTSView*)m_pParentWnd;
		CSSdjDocTemplate *pMateTemplate=pTSView->GetMateTemplate();
		POSITION pos=pMateTemplate->GetFirstDocPosition();
		if (pos==NULL) {
			CDocument *pMateDoc=pMateTemplate->OpenDocumentFile(NULL);
			POSITION pos2=pMateDoc->GetFirstViewPosition(); ASSERT(pos2);
			CMateView *pMateView=(CMateView*)pMateDoc->GetNextView(pos2);
			pMateView->SetNotifyWnd(this); // ɏIʒmႤB
		}
	}

	// \̍XV
	int cnt=m_MultiSelList.GetCount();
	if (cnt) {
		m_MultiSelList.SetSel(0,TRUE); // I
		if (cnt>1)
			m_MultiSelList.SelItemRange(FALSE,1,cnt-1); // 
	}
	UpdateDisplay();

	BOOL ret=FALSE;
	if (m_pos) {
		CWinSDJTSView *pView=(CWinSDJTSView*)(m_pParentWnd);
		ASSERT(pView->IsKindOf(RUNTIME_CLASS(CWinSDJTSView)));
		CWinSDJTSDoc *pDoc=pView->GetDocument(); // hLg
		CKBase *pKBase=pDoc->GetKBase();
		DBRNO Dbrno;
		Dbrno.dbrno =m_lstDbrno.GetNext(m_pos); // lR[hԍ
		Dbrno.tesu  =0; // ǖ

		WaitForSingleObject(g_hDblock,INFINITE); // Db lock
		// ϐZbĝlockB
		// cãZbg
		CString strShgdb=getenv("SHGDB"); // ݂̏ca
		if (strShgdb!=m_strShgdb) {
			CString shgdb;
			shgdb.Format("SHGDB=%s",m_strShgdb); // ȑȌcaZbg
			_putenv(shgdb);
		}
		pDoc->ReadDbcInfo(Dbrno); // lcaǂݍ
		// cãZbg
		if (strShgdb!=m_strShgdb) {
			CString shgdb;
			shgdb.Format("SHGDB=%s",strShgdb); // ݂̏caɖ߂
			_putenv(shgdb);
		}
		ReleaseMutex(g_hDblock); // Db unlock

		if (pDoc->m_Dbc.get_mrec_recno()!=Dbrno.dbrno) {
			CString strMes;
			strMes.Format("l(R[hԍ=%06ld)ǂ߂܂",Dbrno.dbrno);
			AfxMessageBox(strMes);
			return FALSE; // Not found.
		}

		pKBase->recstart(); // lߎ菇

		if (pView->GetGuideFrame()!=NULL) // ǖʕ\JĂ
			pView->GetGuideFrame()->Invalidate();
		if (pView->GetSubFrame()!=NULL) // TuEBhEJĂ
			pView->GetSubFrame()->Invalidate();
		pView->Invalidate(); // \XV
		// ͕̑̑Ă邱Ƃۏ؂ĂB

		// r[MateTemplate --> MateDoc --> MateView ̏ɎJB
		CSSdjDocTemplate *pMateTemplate=pView->GetMateTemplate();
		POSITION pos=pMateTemplate->GetFirstDocPosition();
		if (pos) {
			CDocument *pMateDoc=pMateTemplate->GetNextDoc(pos);
			POSITION pos2=pMateDoc->GetFirstViewPosition(); ASSERT(pos2);
			CMateView *pMateView=(CMateView*)pMateDoc->GetNextView(pos2);
			// vlXbh̋N
			pMateView->BeginThread(&MateThread,(LPARAM)pKBase);
			ret=TRUE;
		}
	}
	return ret;
}

// SI
void CDlgMateDbc::OnSelectAll() 
{
	if (m_bThinking)
		return;
	CDlgDelDbc::OnSelectAll();
}

BOOL CDlgMateDbc::OnInitDialog() 
{
	CDlgDelDbc::OnInitDialog();
	
	m_strShgdb=getenv("SHGDB"); // ca̋L
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
