/***********************/
/*    DlgMidasi.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgMidasi.h"
#include "winsdjdoc.h"
#include "kbase.h"
#include "sdjview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgMidasi _CAO

CDlgMidasi::CDlgMidasi(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgMidasi::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMidasi)
	m_Brecno = _T("");
	m_Result = _T("");
	m_Senkei = _T("");
	m_Teai = _T("");
	m_Comment = _T("");
	m_Datetime = _T("");
	m_Gdan = _T("");
	m_Gplayer = _T("");
	m_Kisen = _T("");
	m_Place = _T("");
	m_Sdan = _T("");
	m_Splayer = _T("");
	m_Tesu = _T("");
	//}}AFX_DATA_INIT
	m_pDoc=NULL;
	m_pComment=NULL;
	m_pDbb=NULL;
	memset(&m_Brec,0,sizeof(B_REC));
	memset(&m_Bdsp,0,sizeof(BDSP));
	m_pEdit=NULL;
}

void CDlgMidasi::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMidasi)
	DDX_Control(pDX, IDC_CMB_SENKEI, m_cmbSenkei);
	DDX_Control(pDX, IDC_HTIME, m_Htime);
	DDX_Control(pDX, IDC_SRTIME, m_Srtime);
	DDX_Control(pDX, IDC_GRTIME, m_Grtime);
	DDX_Control(pDX, IDC_PLAYDATE, m_Playdate);
	DDX_Control(pDX, IDC_TIMECOUNT, m_Timecount);
	DDX_Text(pDX, IDC_BRECNO, m_Brecno);
	DDV_MaxChars(pDX, m_Brecno, 6);
	DDX_CBString(pDX, IDC_CMB_RESULT, m_Result);
	DDV_MaxChars(pDX, m_Result, 6);
	DDX_CBString(pDX, IDC_CMB_SENKEI, m_Senkei);
	DDV_MaxChars(pDX, m_Senkei, 40);
	DDX_CBString(pDX, IDC_CMB_TEAI, m_Teai);
	DDV_MaxChars(pDX, m_Teai, 6);
	DDX_Text(pDX, IDC_COMMENT, m_Comment);
	DDV_MaxChars(pDX, m_Comment, 4096);
	DDX_Text(pDX, IDC_DATETIME, m_Datetime);
	DDV_MaxChars(pDX, m_Datetime, 20);
	DDX_Text(pDX, IDC_GDAN, m_Gdan);
	DDV_MaxChars(pDX, m_Gdan, 10);
	DDX_Text(pDX, IDC_GPLAYER, m_Gplayer);
	DDV_MaxChars(pDX, m_Gplayer, 14);
	DDX_Text(pDX, IDC_KISEN, m_Kisen);
	DDV_MaxChars(pDX, m_Kisen, 40);
	DDX_Text(pDX, IDC_PLACE, m_Place);
	DDV_MaxChars(pDX, m_Place, 40);
	DDX_Text(pDX, IDC_SDAN, m_Sdan);
	DDV_MaxChars(pDX, m_Sdan, 10);
	DDX_Text(pDX, IDC_SPLAYER, m_Splayer);
	DDV_MaxChars(pDX, m_Splayer, 14);
	DDX_Text(pDX, IDC_TESU, m_Tesu);
	DDV_MaxChars(pDX, m_Tesu, 4);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgMidasi, CDialog)
	//{{AFX_MSG_MAP(CDlgMidasi)
	ON_EN_SETFOCUS(IDC_TIMECOUNT, OnSetfocusTimecount)
	ON_EN_KILLFOCUS(IDC_TIMECOUNT, OnKillfocusTimecount)
	ON_EN_SETFOCUS(IDC_PLAYDATE, OnSetfocusPlaydate)
	ON_EN_KILLFOCUS(IDC_PLAYDATE, OnKillfocusPlaydate)
	ON_EN_SETFOCUS(IDC_SRTIME, OnSetfocusSrtime)
	ON_EN_KILLFOCUS(IDC_SRTIME, OnKillfocusSrtime)
	ON_EN_SETFOCUS(IDC_GRTIME, OnSetfocusGrtime)
	ON_EN_KILLFOCUS(IDC_GRTIME, OnKillfocusGrtime)
	ON_EN_SETFOCUS(IDC_HTIME, OnSetfocusHtime)
	ON_EN_KILLFOCUS(IDC_HTIME, OnKillfocusHtime)
	ON_COMMAND(ID_RBUTTON_UP,OnCmdRButtonUp)
	ON_COMMAND(ID_DELETE_CMB_ITEM, OnDeleteCmbItem)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgMidasi bZ[W nh

// hLg̐ݒ
void CDlgMidasi::SetDoc(CWinSDJDoc *pDoc)
{
	m_pDoc=pDoc;
	m_pDbb=&pDoc->m_Dbb;
}

BOOL CDlgMidasi::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// ɂȑO m_pDocݒ肳ĂȂ΂ȂȂB
	ASSERT(m_pDoc);

	// ftHg^̊o
	int n=m_cmbSenkei.GetCount();
	for (int i=0;i<n;i++) {
		CString str;
		m_cmbSenkei.GetLBText(i,str);
		m_lstDefSenkei.AddHead(str);
	}

	// [U`^f[^̃R{{bNXf
	POSITION pos=theApp.m_lstSenkei.GetHeadPosition();
	while (pos) {
		CString &str=theApp.m_lstSenkei.GetNext(pos);
		m_cmbSenkei.AddString(str);
	}

	UpdateDisplayInfo(); // hLgʃf[^

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//////////
// obt@ʃf[^փZbg
void CDlgMidasi::UpdateDisplayInfo()
{
	m_pDoc->SetMrecTesu();  // 萔̌vZhLg΋ǏXV

	m_pComment=m_pDbb->GetComment();     // ΋ǒ
	// ΋ǒ
	if (m_pComment!=NULL)
		m_Comment.Format("%s",m_pComment);

	B_REC *pBrec=m_pDbb->GetMrec();      // ΋ǂcaR[h
	memcpy(&m_Brec,pBrec,sizeof(B_REC));
	m_pDbb->set_mdsp(&m_Brec,&m_Bdsp);   // ΋ǂca\obt@̃Zbg

	// ΋ǔԍ
	m_Brecno.Format("%s",m_Bdsp.b_recno);
	// o^
	m_Datetime.Format("%s",m_Bdsp.datetime);
	// i
	m_Gdan.Format("%s",m_Bdsp.gdan);
	// ΋ǎ
	m_Gplayer.Format("%s",m_Bdsp.gplayer);
	// c
	m_Grtime.SetWindowText(m_Bdsp.grhtime);
	// 
	m_Htime.SetWindowText(m_Bdsp.htime);
	// 햼
	m_Kisen.Format("%s",m_Bdsp.kisen);
	// ΋Ǐꏊ
	m_Place.Format("%s",m_Bdsp.place);
	// ΋Ǔ
	m_Playdate.SetWindowText(m_Bdsp.playdate);
	// 
	m_Result.Format("%s",m_Bdsp.result);
	// i
	m_Sdan.Format("%s",m_Bdsp.sdan);
	// ΋ǎ
	m_Splayer.Format("%s",m_Bdsp.splayer);
	// c
	m_Srtime.SetWindowText(m_Bdsp.srhtime);
	// ^
	m_Senkei.Format("%s",m_Bdsp.senkei);
	// 荇
	m_Teai.Format("%s",m_Bdsp.teai);
	// 萔
	m_Tesu.Format("%s",m_Bdsp.tesu);
	// b
	m_Timecount.SetWindowText(m_Bdsp.timecount);

	// obt@lʂ֔f
	UpdateData(FALSE);
}

////////////////////
// ʏobt@փZbgB
void CDlgMidasi::UpdateBufferInfo()
{
	int len,i;

	// ΋ǒ
	const char *cp;
	len=m_Comment.GetLength();
	cp=m_Comment;
	for (i=0;i<len;i++) {
		if (cp[i]!='\r' && cp[i]!='\n') // sR[hȊO邩
			break;
	}
	// LȕΒߕƂĐݒ肷B
	if (len > 0 && i < len)
		m_pDbb->ReplaceComment((char *)cp); // ΋ǒ߂̐ݒ
	else
		m_pDbb->ReplaceComment(NULL);       // ΋ǒ߂̐ݒ
	m_pComment=m_pDbb->GetComment();


	// CEditȊỎʃo[ϐobt@(m_Brec)փf[^ZbgB
	// (CEdit͓̏sxsxobt@ɐݒ肳Ă)

	// ΋ǔԍAo^A萔̓[hI[ݒ肵ȂB

	// ΋ǎ
	char work[2][20];
	len=m_Splayer.GetLength();
	if (len>0)	sprintf(work[0],"%s",m_Splayer);
	else		sprintf(work[0],"%s","΋ǎҕs");
	len=m_Gplayer.GetLength();
	if (len>0)	sprintf(work[1],"%s",m_Gplayer);
	else		sprintf(work[1],"%s","΋ǎҕs");
	memset(m_Brec.row.player,0,sizeof m_Brec.row.player);
	sprintf(m_Brec.row.player,"%s-%s",work[0],work[1]);

	// i
	memset(m_Brec.row.sdan,0,sizeof m_Brec.row.sdan);
	if ((len=m_Sdan.GetLength())>0)
		memcpy(m_Brec.row.sdan,m_Sdan,len);
	// i
	memset(m_Brec.row.gdan,0,sizeof m_Brec.row.gdan);
	if ((len=m_Gdan.GetLength())>0)
		memcpy(m_Brec.row.gdan,m_Gdan,len);
	// 햼
	memset(m_Brec.row.kisen,0,sizeof m_Brec.row.kisen);
	if ((len=m_Kisen.GetLength())>0)
		memcpy(m_Brec.row.kisen,m_Kisen,len);
	// ΋Ǐꏊ
	memset(m_Brec.row.place,0,sizeof m_Brec.row.place);
	if ((len=m_Place.GetLength())>0)
		memcpy(m_Brec.row.place,m_Place,len);
	// 
	memset(m_Brec.row.result,0,sizeof m_Brec.row.result);
	if ((len=m_Result.GetLength())>0)
		memcpy(m_Brec.row.result,m_Result,len);
	// ^
	memset(m_Brec.row.senkei,0,sizeof m_Brec.row.senkei);
	if ((len=m_Senkei.GetLength())>0)
		memcpy(m_Brec.row.senkei,m_Senkei,len);
	// 荇
	memset(m_Brec.row.teai,0,sizeof m_Brec.row.teai);
	if ((len=m_Teai.GetLength())>0)
		memcpy(m_Brec.row.teai,m_Teai,len);

	// obt@(m_Brec)̓ehLgɃRs[B
	B_REC *pBrec=m_pDbb->GetMrec();
	memcpy(pBrec,&m_Brec,sizeof(B_REC));
	// hLg̕\obt@XVB
	m_pDbb->set_mdsp();

	// r[̏̕\XV
	CWnd *pWnd=m_pDoc->GetSDJView()->GetSubFrame();
	if (pWnd)
		pWnd->Invalidate();

	// _CAO̕\obt@XVB
	m_pDbb->set_mdsp(&m_Brec,&m_Bdsp);

	// XVobt@lʂ֔f
	UpdateDisplayInfo();
}

// bǕҏW (Jn)
void CDlgMidasi::OnSetfocusTimecount() 
{
	char work[20];
	strncpy(work,m_Brec.row.timecount,sizeof m_Brec.row.timecount);
	work[sizeof m_Brec.row.timecount]='\0';

	m_Timecount.SetWindowText(work);

	m_pEdit=&m_Timecount; // GfBbgL
}
// bǕҏW(I)
void CDlgMidasi::OnKillfocusTimecount() 
{
	// ڃ`FbNobt@Zbg
	ItemDigitCheck(&m_Timecount,m_Brec.row.timecount,sizeof m_Brec.row.timecount);

	// bǒl̂ݍĕ\B(cXVĂ邩ȂA
	// UpdateData(FALSE)͑ʖ)
	m_Timecount.SetWindowText(m_Bdsp.timecount);

	m_pEdit=NULL; // GfBbgLZbg
}

// ΋ǓҏW(Jn)
void CDlgMidasi::OnSetfocusPlaydate() 
{
	char work[20];
	strncpy(work,m_Brec.row.playdate,sizeof m_Brec.row.playdate);
	work[sizeof m_Brec.row.playdate]='\0';

	m_Playdate.SetWindowText(work);
	
	m_pEdit=&m_Playdate; // GfBbgL
}
// ΋ǓҏW(I)
void CDlgMidasi::OnKillfocusPlaydate() 
{
	// ڃ`FbNobt@Zbg
	ItemDigitCheck(&m_Playdate,m_Brec.row.playdate,sizeof m_Brec.row.playdate);

	// ΋Ǔ̂ݍĕ\B
	m_Playdate.SetWindowText(m_Bdsp.playdate);

	m_pEdit=NULL; // GfBbgLZbg
}

// cԕҏW(Jn)
void CDlgMidasi::OnSetfocusSrtime() 
{
	char work[20];
	strncpy(work,m_Brec.row.srhtime,sizeof m_Brec.row.srhtime);
	work[sizeof m_Brec.row.srhtime]='\0';

	m_Srtime.SetWindowText(work);

	m_pEdit=&m_Srtime; // GfBbgL
}
// cԕҏW(I)
void CDlgMidasi::OnKillfocusSrtime() 
{
	// ڃ`FbNobt@Zbg
	ItemDigitCheck(&m_Srtime,m_Brec.row.srhtime,sizeof m_Brec.row.srhtime);

	// cԂ̂ݍĕ\B
	m_Srtime.SetWindowText(m_Bdsp.srhtime);

	m_pEdit=NULL; // GfBbgLZbg
}

// cԕҏW(Jn)
void CDlgMidasi::OnSetfocusGrtime() 
{
	char work[20];
	strncpy(work,m_Brec.row.grhtime,sizeof m_Brec.row.grhtime);
	work[sizeof m_Brec.row.grhtime]='\0';

	m_Grtime.SetWindowText(work);

	m_pEdit=&m_Grtime; // GfBbgL
}
// cԕҏW(I)
void CDlgMidasi::OnKillfocusGrtime() 
{
	// ڃ`FbNobt@Zbg
	ItemDigitCheck(&m_Grtime,m_Brec.row.grhtime,sizeof m_Brec.row.grhtime);

	// cԂ̂ݍĕ\B
	m_Grtime.SetWindowText(m_Bdsp.grhtime);

	m_pEdit=NULL; // GfBbgLZbg
}
// ԕҏW(Jn)
void CDlgMidasi::OnSetfocusHtime() 
{
	char work[20];
	strncpy(work,m_Brec.row.htime,sizeof m_Brec.row.htime);
	work[sizeof m_Brec.row.htime]='\0';

	m_Htime.SetWindowText(work);

	m_pEdit=&m_Htime; // GfBbgL
}
// ԕҏW(I)
void CDlgMidasi::OnKillfocusHtime() 
{
	// ڃ`FbNobt@Zbg
	ItemDigitCheck(&m_Htime,m_Brec.row.htime,sizeof m_Brec.row.htime);

	// cԂ̂ݍĕ\B
	m_Htime.SetWindowText(m_Bdsp.htime);

	m_pEdit=NULL; // GfBbgLZbg
}

// ڃ`FbN֐
// pEdit̃eLXglenłׂĐȂpItemȉɂRs[B
// m_Brec,m_Bdsp̓eXVB
void CDlgMidasi::ItemDigitCheck(CEdit *pEdit, char *pItem, int itemlen)
{
	int i;
	CString str;
	pEdit->GetWindowText(str); // ݒl̎擾
	int len=str.GetLength();   // 

	// ׂĐȂnj
	const char *cp=str;
	for (i=0;i<len;i++) {
		if (!isdigit(cp[i])) // ǂ
			break;
	}
	if (len==0 || len == itemlen && i == itemlen) {
		// ʂ̍XV
		// B_RECXVset_bdspŕ\obt@XVB
		if (len==0)
			memset(pItem,0,itemlen);  //  0 Ȃ 0 NA
		else
			memcpy(pItem,cp,itemlen); // lXV
		m_pDbb->set_mdsp(&m_Brec, &m_Bdsp);
	}
}

/////
// ݒ
void CDlgMidasi::OnOK() 
{
	// GfBbg̃`FbN
	// ȉCEditŕҏWAnjt(orRETURN)ꂽ͂
	// 󂯕tׂҏWobt@m肵UpdateData()ĂԁB
	if (m_pEdit) {
		if (m_pEdit==&m_Grtime) {
			OnKillfocusGrtime();
		} else if (m_pEdit==&m_Htime) {
			OnKillfocusHtime();
		} else if (m_pEdit==&m_Playdate) {
			OnKillfocusPlaydate();
		} else if (m_pEdit==&m_Srtime) {
			OnKillfocusSrtime();
		} else if (m_pEdit==&m_Timecount) {
			OnKillfocusTimecount();
		}
	}
	if (!UpdateData(TRUE))
		return;

	// `FbNOKȂlhLg֔f
	UpdateBufferInfo();

	// [U^̃`FbNL
	if (m_lstDefSenkei.Find(m_Senkei)==NULL && 
		theApp.m_lstSenkei.Find(m_Senkei)==NULL) {
		theApp.m_lstSenkei.AddHead(m_Senkei);
	}

	CDialog::OnOK();
}

/////
// Etj[
void CDlgMidasi::OnCmdRButtonUp()
{
	CPoint point;
	::GetCursorPos(&point);

	int n=m_cmbSenkei.GetCurSel(); // ݑI(index)
	POSITION pos=NULL;
	CString str;
	if (n>=0) {
		m_cmbSenkei.GetLBText(n,str); // ݑI()
		pos=theApp.m_lstSenkei.Find(str); // [U`ڂ
	}

	// |bvAbvj[J
	CMenu Menu;
	Menu.LoadMenu(IDR_CMB_POPMENU);
	CMenu *pPopMenu=Menu.GetSubMenu(0);

	pPopMenu->EnableMenuItem(ID_DELETE_CMB_ITEM,
		(pos)? MF_ENABLED:(MF_GRAYED | MF_DISABLED));

	pPopMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		point.x,point.y, this);
}

/////
// [U`^ڂ̍폜
void CDlgMidasi::OnDeleteCmbItem() 
{
	int n=m_cmbSenkei.GetCurSel(); // ݑI(index)
	POSITION pos=NULL;
	CString str;
	if (n>=0) {
		m_cmbSenkei.GetLBText(n,str); // ݑI()
		pos=theApp.m_lstSenkei.Find(str); // [U`ڂ
	}
	// [U`ڂȂ폜B
	if (pos) {
		theApp.m_lstSenkei.RemoveAt(pos);
		m_cmbSenkei.DeleteString(n);
	}
}
