/***********************/
/*    DlgOutPcl.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgOutPcl.h"
#include "statusbox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#pragma comment(lib, "winmm.lib")
//#pragma comment(lib, "rsdb32.lib")
//#pragma comment(lib, "shgdb.lib")
//#pragma comment(lib, "CShgdb.lib")
//#pragma comment(lib, "sbase.lib")

/////////////////////////////////////////////////////////////////////////////
// CDlgOutPcl _CAO

CDlgOutPcl::CDlgOutPcl(CWnd* pParent /*=NULL*/)
	: CDlgOutCsa(CDlgOutPcl::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgOutPcl)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}

void CDlgOutPcl::DoDataExchange(CDataExchange* pDX)
{
	CDlgOutCsa::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOutPcl)
                //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgOutPcl, CDlgOutCsa)
	//{{AFX_MSG_MAP(CDlgOutPcl)
	ON_BN_CLICKED(IDC_FILE_SELECT, OnFileSelect)
	ON_BN_CLICKED(IDOK, OnOutPclFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOutPcl bZ[W nh

BOOL CDlgOutPcl::OnInitDialog() 
{
	CWaitCursor waitcr; // v

	m_SelectBoxC.ReadPrevInfo(); // O񌟍̓ǂݏo

	//// PCLt@C̎擾
	GetPclFname(m_strCsaFile);

	CDialog::OnInitDialog();
	
	CList <DBRNO,DBRNO&> *pDbrFindList=m_SelectBoxC.GetDbrFindList();
	CList <DBRNO, DBRNO&> DbrnoList; // DBCʍƃXg
	POSITION pos;
	DBRNO Dbrno;

	CDBC Dbc; // lDB
	char dispbuf[512];
	m_MultiSelList.ResetContent(); // SelectListɂB
	if (Dbc.Open()) { // lcãI[v
		Dbc.DBFOpen(); // ߂cãI[v
		pos=pDbrFindList->GetHeadPosition();
		while (pos) {
			Dbrno=pDbrFindList->GetNext(pos);
			//// DBRNOɊY΋ǃR[hǂށB
			int rc=Dbc.ReadByDbrno(Dbrno.dbrno);
			if (rc==E$OK) { // ɓǂ߂\B
				Dbc.set_disp_mrec(dispbuf); // \̐
				m_MultiSelList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DbrnoList.AddTail(Dbrno); // ƃXgɒǉ
			}
		}
		Dbc.DBFClose(); // ߂cãN[Y
		Dbc.Close();	// lcãN[Y
		//// Xg{bNX̃J[\ݒ
		if (m_MultiSelList.GetCount()) {
			m_MultiSelList.SetSel(0,TRUE);  // 擪ɐݒ
		}
	}
	//// DbrnoList̓epDbrFindList֔fB
	pDbrFindList->RemoveAll(); // XgɂB
	pos=DbrnoList.GetHeadPosition();
	while (pos) {
		//// DbrnoListpDbrFindListփRs[
		Dbrno=DbrnoList.GetNext(pos);
		pDbrFindList->AddTail(Dbrno); 
	}
	DbrnoList.RemoveAll(); // DbrnoList

	//// \̍XV
	m_iItemNum=m_MultiSelList.GetCount(); // 
	m_iSelItemNum=m_MultiSelList.GetSelCount(); // I
	UpdateData(FALSE); // \XV	UpdateData(FALSE);

	GotoDlgCtrl(&m_MultiSelList); // 

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////
// PCLt@C̑I
void CDlgOutPcl::OnFileSelect() 
{
	if (m_strCsaFile.IsEmpty())
		GetPclFname(m_strCsaFile); // PCLt@C̎擾

	CFileDialog dlgOutPcl(TRUE, // ǂݍ݃_CAO
		"pcl",					// ftHggq
		m_strCsaFile,			// ftHgPCLt@C
		(DWORD)(OFN_HIDEREADONLY), //  t@C̑
		"PCLt@C (*.pcl)|*.pcl||"); // tB^[
	BOOL bResult = dlgOutPcl.DoModal();

	if (bResult == IDOK) { // Iꂽ
		m_strCsaFile = dlgOutPcl.GetPathName(); // pX擾
		UpdateData(FALSE); // \XV

		WritePclFname(m_strCsaFile); // vt@C֋L
	}
}

////
// PCLt@Co̓[J[Xbh
static UINT OnOutPclFileThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgOutPcl *pDlg=(CDlgOutPcl *)lParam;
	CSelectBoxC *pSelectBoxC=pDlg->GetSelectBoxC();
	CList <DBRNO,DBRNO&> *pDbrFindList=pSelectBoxC->GetDbrFindList();
	char StringBuffer[512];
 
	// PCL t@C̃I[v
	CFile fpcl;
	if (!fpcl.Open(pDlg->m_strCsaFile,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyWrite))
		return FALSE; // I[vs
	CSDJArchive ar(&fpcl,CArchive::store);

	// lcãI[v
	CDBC Dbc;
	char dispbuf[512];
	DBRNO Dbrno;
	int Index=-1;
	BOOL bInitOutFlag = FALSE;
	int iCounter=0;

    BOOL Copen=FALSE;
    BOOL Dopen=FALSE;
    BOOL Fopen=FALSE;
	Copen=Dbc.Open();
	if (Copen) {
		Dopen=Dbc.DBDOpen();
		Fopen=Dbc.DBFOpen();
	}
	if (Copen && Dopen && Fopen) { // SăI[v
		POSITION pos=pDbrFindList->GetHeadPosition();
		while (pos) {
			Dbrno=pDbrFindList->GetNext(pos);
			Index++;
			if (pDlg->m_MultiSelList.GetSel(Index)) { // ̃ZIĂ
				// DBRNOɊY΋ǃR[hǂށB
				int rc=Dbc.ReadByDbrno(Dbrno.dbrno);
				if (rc==E$OK) { // ɓǂ߂
					if (bInitOutFlag) {
						CString crlf("/\r\n"); // ؂̏o
						ar.WriteString(crlf);
					}
					else
						bInitOutFlag=TRUE;

					rc=Dbc.OutDB2Csa(ar);// ̋lPCLo
					// \̐
					Dbc.set_disp_mrec(dispbuf);
					if (rc==0) {
						sprintf(StringBuffer,"%so͂܂B",dispbuf);
						iCounter++; // o̓JE^[+1
					}
					else
						sprintf(StringBuffer,
						"%s̏o͂Ɏs܂(rc=%d)B", dispbuf,rc);
					if (pBox)
						pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,
						(LPARAM)StringBuffer);
					else
						TRACE("%s\n",StringBuffer);
				}
			}
			// fI`FbN
			if (WaitForSingleObject(*pStopEvent, 0)==WAIT_OBJECT_0) {
				sprintf(StringBuffer,"PCLt@Co͂𒆒fI܂B");
				if (pBox)
					pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,
					(LPARAM)StringBuffer);
				else
					TRACE("%s\n",StringBuffer);
				break;
			}
		}
		char str1[80],str2[80];
		_strdate(str1); _strtime(str2);
		sprintf(StringBuffer,"%d o͂܂(%s %s)B",iCounter,str1,str2);
		if (pBox)
		    pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)StringBuffer);
	    else
			TRACE("%s\n",StringBuffer);
	}
	if (Fopen) Dbc.DBFClose();
	if (Dopen) Dbc.DBDClose();
	if (Copen) Dbc.Close();

	ar.Close();
	fpcl.Close();

	return TRUE;
}

////
// PCLt@Co
void CDlgOutPcl::OnOutPclFile() 
{
	UpdateData(TRUE); // ϐ̍XV

	// I𐔂̃`FbN
	if (m_iSelItemNum <=0) 
		return ; // IĂȂB

	// PCLt@C̃`FbN
	if (m_strCsaFile.IsEmpty()) {
		AfxMessageBox("PCL t@C(*.pcl)w肵ĂB");
		return ;
	}
	if (strcmp((LPCTSTR)m_strCsaFile+strlen(m_strCsaFile)-4,".pcl")!=0)
		TRACE("Pcl file does not terminiate with \".pcl\"\n");

	// PCL t@C̃I[v`FbN
	CFile fpcl;
	int MBret=IDYES;
	if (fpcl.Open(m_strCsaFile,CFile::modeReadWrite | CFile::shareDenyWrite)) {
		CString strbuf;
		strbuf.Format("PCLt@C(%s)ɏ㏑Ă낵łH",m_strCsaFile);
		MBret=AfxMessageBox(strbuf,MB_YESNO);
		fpcl.Close();
	}
	if (MBret!=IDYES)
		return;

	// j^\{bNX  ƊJn
	CStatusBox StatusBox(&OnOutPclFileThread,(LPARAM)this);
	StatusBox.DoModal();

	CDialog::OnOK(); // OKI
}
