/***********************/
/*    DlgSelSep.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgSelSep.h"
#include "sdjdoc.h"
#include "kbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSelSep _CAO

void CDlgSelSep::CommonInit()
{
	//{{AFX_DATA_INIT(CDlgSelSep)
	//}}AFX_DATA_INIT
	m_iSelNo=-1;
	m_pDoc=NULL;
}

CDlgSelSep::CDlgSelSep(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSelSep::IDD, pParent)
{
	CommonInit();
}
CDlgSelSep::CDlgSelSep(int idd,CWnd* pParent)
	: CDialog(idd, pParent)
{
	CommonInit();
}

void CDlgSelSep::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSelSep)
	DDX_Control(pDX, IDC_SELLIST, m_SelectList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgSelSep, CDialog)
	//{{AFX_MSG_MAP(CDlgSelSep)
	ON_BN_CLICKED(IDOK, OnSelect)
	ON_LBN_DBLCLK(IDC_SELLIST, OnDblclkSellist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSelSep bZ[W nh

BOOL CDlgSelSep::OnInitDialog() 
{
	CDialog::OnInitDialog();

	ASSERT(m_iSelNo!=-1);
	ASSERT(m_pDoc!=NULL);

	CKBase *pKBase=m_pDoc->GetKBase();
	PCELL *pcl=pKBase->lastmove(); // O̎w
	PCELL *parent=pcl->pnt();
	int n=parent->cldnum();  // O̎w̌Z̐

	ASSERT(m_iSelNo>=0 && m_iSelNo<n);

	CString sn,gn; // 㖼
	m_pDoc->GetSGName(pKBase,&sn,&gn);
	int side=!pKBase->turn(); // 1O̎
	CString sgname=(side==SIDE_A)? sn: gn;

	for (int i=0;i<n;i++) {
		char *cp=pKBase->mvstr(parent->cld(i));
		CString str;
		str.Format("%s%s",sgname,cp+4);
		m_SelectList.InsertString(-1,str);
	}

	m_SelectList.SetCurSel(m_iSelNo);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////
// I
void CDlgSelSep::OnSelect() 
{
	CKBase *pKBase=m_pDoc->GetKBase();
	PCELL *pcl=pKBase->lastmove(); // O̎w
	PCELL *parent=pcl->pnt();
	int n=parent->cldnum();  // O̎w̌Z̐

	// I`FbN
	int Sel=m_SelectList.GetCurSel();
	if (Sel==LB_ERR) // IȂΉȂB
		return;

	if (Sel<0 || Sel>=n)
		return;      // ͈͂BiȂ)

	m_iSelNo=Sel; // Ihc

	CDialog::OnOK();
}

////
// Xg_uNbNI
void CDlgSelSep::OnDblclkSellist() 
{
	OnSelect();
}
