/**************************/
/*    DlgSelectDir.cpp    */
/**************************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgSelectDir.h"
#include <stdlib.h>
#include <ctype.h>
#include <mbstring.h>
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

/* ʊO֐錾 */
extern "C" {
void *memalloc(unsigned int);
void memfree(void *);
}

/////////////////////////////////////////////////////////////////////////////
// CDlgSelectDir _CAO

CDlgSelectDir::CDlgSelectDir(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSelectDir::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSelectDir)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}

void CDlgSelectDir::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSelectDir)
	DDX_Control(pDX, IDC_COMBO_DRIVE, m_ComboDrive);
	DDX_Control(pDX, IDC_DIRNAME, m_DirName);
	DDX_Control(pDX, IDC_TREE_FOLDER, m_TreeFolder);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgSelectDir, CDialog)
	//{{AFX_MSG_MAP(CDlgSelectDir)
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_TREE_FOLDER, OnItemexpandingTreeFolder)
	ON_NOTIFY(TVN_DELETEITEM, IDC_TREE_FOLDER, OnDeleteitemTreeFolder)
	ON_CBN_SELCHANGE(IDC_COMBO_DRIVE, OnSelchangeComboDrive)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_FOLDER, OnSelchangedTreeFolder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSelectDir bZ[W nh

void CDlgSelectDir::OnOK() 
{
	SetCurrentDirectory(m_strSelectDir);     // IꂽfBNgցB
	
	CDialog::OnOK();
}
void CDlgSelectDir::OnCancel() 
{
	SetCurrentDirectory(m_DefaultDir); // l̃fBNg֖߂B
	
	CDialog::OnCancel();
}

BOOL CDlgSelectDir::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// fBNgl̋L
	GetCurrentDirectory(sizeof m_DefaultDir,m_DefaultDir);

	if (!m_strSelectDir.IsEmpty()) {
		_chdir(m_strSelectDir); // WJfBNg
	}

    // VXeɃC[WXg擾Ac[r[ɃZbgB
    HIMAGELIST  hImageList;
    SHFILEINFO    sfi;

    hImageList = (HIMAGELIST)SHGetFileInfo((LPCSTR)"C:\\",0,&sfi,sizeof(SHFILEINFO), 
		                             SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
    // Attach ImageList to TreeView
    if (hImageList)
        ::SendMessage(m_TreeFolder.m_hWnd, TVM_SETIMAGELIST, (WPARAM) TVSIL_NORMAL,
            (LPARAM)hImageList);


    HRESULT hr;
    LPSHELLFOLDER lpsfDesktop;	// fXNgbvSH
    LPSHELLFOLDER lpsfMycomp;	// }CRs[^SH
	LPMALLOC lpMalloc			= NULL; // VFIuWFNg
	LPITEMIDLIST lpiMycomp		= NULL; // }CRs[^PIDL
    LPENUMIDLIST lpe; // 񋓃IuWFNgID LIST
	LPITEMIDLIST lpi; // PIDL
	char szBuff[512]; // th
	HWND hwnd;
    ULONG ulFetched,ulAttrs;
	LPTVITEMDATA lptvid;
	int iIndex;
	CBXIS *lpcbxis;

	// fXNgbvtH_̎擾
	hr=SHGetDesktopFolder(&lpsfDesktop);
	if (!SUCCEEDED(hr)) goto exit;

	// VFIuWFNg̎擾
    hr=::SHGetMalloc(&lpMalloc);
    if (FAILED(hr)) goto exit;

	// }CRs[^PIDL擾
    hwnd=::GetParent(m_TreeFolder.m_hWnd);
	hr=SHGetSpecialFolderLocation(hwnd,CSIDL_DRIVES,&lpiMycomp); // PIDL
	if (!SUCCEEDED(hr)) goto exit;

	// }CRs[^̃VFtH_擾
	hr=lpsfDesktop->BindToObject(lpiMycomp,0,IID_IShellFolder,(LPVOID *)&lpsfMycomp);
	if (!SUCCEEDED(hr)) goto exit; 

	
	// }CRs[^tH_̗񋓃IuWFNg擾
	hr=lpsfMycomp->EnumObjects(hwnd, SHCONTF_FOLDERS | SHCONTF_NONFOLDERS, &lpe);
	if (!SUCCEEDED(hr))	goto exit;

	// }CRs[^̒񋓂ȂAhCutH_̂݃R{{bNX
	// (m_ComboDrive)֊i[B(i[f[^TVITEMDATA^)
	while (S_OK==lpe->Next(1, &lpi, &ulFetched)) {
		// IuWFNg̎ނ𔻒fB
		ulAttrs = SFGAO_HASSUBFOLDER | SFGAO_FOLDER | SFGAO_FILESYSANCESTOR;
		lpsfMycomp->GetAttributesOf (1,(const struct _ITEMIDLIST **)&lpi,&ulAttrs);
		// hCu̔fiIʁj
		if (ulAttrs == (SFGAO_HASSUBFOLDER | SFGAO_FOLDER | SFGAO_FILESYSANCESTOR)) {
			// x̎擾
			if (!GetName(lpsfMycomp,lpi,SHGDN_NORMAL,szBuff))
				goto exit;

			// TVITEMDATA\̂̍\z
			lptvid=(LPTVITEMDATA)lpMalloc->Alloc(sizeof(TVITEMDATA));
			if (lptvid==NULL)
				goto exit;
			lptvid->lpsfParent	= lpsfMycomp;			// SH̃Zbg
			lptvid->lpifq=ConcatPidls(lpiMycomp,lpi);	// tpXPIDL
			lptvid->lpi=CopyITEMID(lpMalloc,lpi);		// Copy PIDL
			lpsfMycomp->AddRef();

			// x,TVITEMDATA\̂R{RbNX֑}B
			if ((lpcbxis=(CBXIS*)memalloc(sizeof(CBXIS)))==NULL)
				goto exit;
			lpcbxis->idrv=toupper(szBuff[strlen(szBuff)-3])-'A'+1;
			lpcbxis->lptvid=lptvid;
			iIndex=m_ComboDrive.InsertString(-1,szBuff);
			m_ComboDrive.SetItemDataPtr(iIndex,lpcbxis);
		}
		lpMalloc->Free(lpi); // PIDL J
	}

	// R{{bNX̃Xg̒AJghCuIB
	iIndex=SelectCurrentDrive(); 

	// ̃JghCu[gɃc[WJB
	ExpandDrive(iIndex);

	// JgfBNg̓WJEI
	SelectCurrentDirectory();

exit:
	if (lpMalloc) {
		if (lpiMycomp)
			lpMalloc->Free(lpiMycomp);
		lpMalloc->Release();
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/****************************************************************************
*
*  FUNCTION: FillTreeView( LPSHELLFOLDER lpsf,
*                          LPITEMIDLIST  lpifq,
*                          HTREEITEM     hParent)
*
*  PURPOSE: Fills a branch of the TreeView control.  Given the
*           shell folder, enumerate the subitems of this folder,
*           and add the appropriate items to the tree.
*
*  PARAMETERS:
*    lpsf         - Pointer to shell folder that we want to enumerate items 
*    lpifq        - Fully qualified item id list to the item that we are enumerating
*                   items for.  In other words, this is the PIDL to the item
*                   identified by the lpsf parameter.
*    hParent      - Parent node
*
*  COMMENTS:
*    This function enumerates the items in the folder identifed by lpsf.
*    Note that since we are filling the left hand pane, we will only add
*    items that are folders and/or have sub-folders.  We *could* put all
*    items in here if we wanted, but that's not the intent.
*
****************************************************************************/
void CDlgSelectDir::FillTreeView(
   LPSHELLFOLDER lpsf, LPITEMIDLIST lpifq, HTREEITEM hParent)
{
    TV_ITEM         tvi;            // tree view item
    TV_INSERTSTRUCT tvins;          // tree view insert structure
    HTREEITEM       hPrev = NULL;   // previous item added
    LPSHELLFOLDER   lpsf2=NULL;
    LPENUMIDLIST    lpe=NULL;
    LPITEMIDLIST    lpi=NULL, lpiTemp=NULL, lpifqThisItem=NULL;
    LPTVITEMDATA    lptvid=NULL;
    LPMALLOC        lpMalloc=NULL;
    ULONG           ulFetched;
    UINT            uCount=0;
    HRESULT         hr;                        
    char            szBuff[256];
    HWND            hwnd=::GetParent(m_TreeFolder.m_hWnd);

    // VFIuWFNg̎擾
    hr=::SHGetMalloc(&lpMalloc);
    if (FAILED(hr))
		return;

    if (!SUCCEEDED(hr))
		return;

	// w肳ꂽtH_IEnumIDlistIuWFNg擾B
	hr=lpsf->EnumObjects(hwnd, SHCONTF_FOLDERS | SHCONTF_NONFOLDERS, &lpe);
	if (!SUCCEEDED(hr))
		goto Done;

	// tH_ƃtH_ȊÕIuWFNg񋓂B
	while (S_OK==lpe->Next(1, &lpi, &ulFetched)) {
		// JgACẽtpX쐬BSH*֐̓tpXPIDL
		// Ɏ邪AC^[tF[X֐͑΃pXPIDLɎB
		ULONG ulAttrs = SFGAO_HASSUBFOLDER | SFGAO_FOLDER;

		// IuWFNg̎ނ𔻒fB
		lpsf->GetAttributesOf (
			1, (const struct _ITEMIDLIST **)&lpi, &ulAttrs);

		if (ulAttrs & (SFGAO_HASSUBFOLDER | SFGAO_FOLDER)) {
			// tH_ł͂ȂIuWFNgc[ɒǉȂ߂ɂ͂if
			// KvłBTutH_AtH_ł͂ȂIuWFNg
			// B	
			if (ulAttrs & SFGAO_FOLDER) {
				tvi.mask= TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
				
				if (ulAttrs & SFGAO_HASSUBFOLDER) {
					// ̃ACe̓TutH_̂ŁAc[r[Rg[
					// ɃvXLB[U[̂̃ACeŏɃNbN
					// ́ÃTutH_ɈڂȂ΂ȂȂB
					tvi.cChildren=1;
					tvi.mask |= TVIF_CHILDREN;
				}
                        
				// ITEMDATA\ׂ̂̈̃擾B
				lptvid = (LPTVITEMDATA)lpMalloc->Alloc(sizeof(TVITEMDATA));
				if (!lptvid)
					goto Done;  // 擾G[
   
				// c[r[Rg[ɕ\邽߂̕ՂO
				// 擾B
				if (!GetName(lpsf, lpi, SHGDN_NORMAL, szBuff))
					goto Done; // O̎擾G[

				tvi.pszText    = szBuff;
				tvi.cchTextMax = MAX_PATH;
    
				lpifqThisItem=ConcatPidls(lpifq, lpi);
      
				// ITEMIDLIST̃Rs[쐬B
				lptvid->lpi=CopyITEMID(lpMalloc, lpi);
   
				GetNormalAndSelectedIcons(lpifqThisItem, &tvi);
				
				lptvid->lpsfParent=lpsf;    // etH_SFLB
				lpsf->AddRef();
				lptvid->lpifq	= ConcatPidls(lpifq, lpi);
   
				tvi.lParam = (LPARAM)lptvid;
   
				// c[r[֍\̂InsertAֈڂB
				// ̃ACe͏őꂽ̂łBŌInsertꂽACe
				// ̌InsertAꂪ[gGgł鎖B
				tvins.item         = tvi;
				tvins.hInsertAfter = TVI_FIRST;
				tvins.hParent      = hParent;
   
				// ACec[ɒǉB
				hPrev = m_TreeFolder.InsertItem(&tvins);
			}
			// ̃ACe̍ƃJB
			lpMalloc->Free(lpifqThisItem);  
			lpifqThisItem=0;
		}

		lpMalloc->Free(lpi);  // VF^PIDLJB
		lpi=NULL;
	} // end while

	m_TreeFolder.SortChildren(hParent); // ڂ̃\[g

Done:
    if (lpe)  
        lpe->Release();

	// ̂Qif́AgotoG[ɂȂꍇTRUEɂȂBłȂꍇ́A
	// whilȅIł̃JB
    if (lpi && lpMalloc)           
        lpMalloc->Free(lpi);
    if (lpifqThisItem && lpMalloc) 
        lpMalloc->Free(lpifqThisItem);  

    if (lpMalloc) 
        lpMalloc->Release();

}

/****************************************************************************
*
*    FUNCTION: GetName(LPSHELLFOLDER lpsf,LPITEMIDLIST  lpi,DWORD dwFlags,
*             LPSTR         lpFriendlyName)
*
*    PURPOSE:  Gets the friendly name for the folder(th[l[̎擾) 
*
****************************************************************************/
BOOL CDlgSelectDir::GetName(LPSHELLFOLDER lpsf, LPITEMIDLIST lpi,
							DWORD dwFlags, LPSTR lpFriendlyName)
{
   BOOL   bSuccess=TRUE;
   STRRET str;

   if (NOERROR==lpsf->GetDisplayNameOf(lpi,dwFlags, &str))
   {
      switch (str.uType)
      {
         case STRRET_WSTR:
            WideCharToMultiByte(
               CP_ACP,                 // code page
               0,                      // dwFlags
               str.pOleStr,            // lpWideCharStr
               -1,                     // cchWideCharStr
               lpFriendlyName,         // lpMultiByteStr
			   MAX_PATH,               // cchMultiByte(ďoŊm)
               NULL,                   // lpDefaultChar
               NULL);                  // lpUsedDefaultChar
             break;

         case STRRET_OFFSET:
             lstrcpy(lpFriendlyName, (LPSTR)lpi+str.uOffset);
             break;

         case STRRET_CSTR:             
             lstrcpy(lpFriendlyName, (LPSTR)str.cStr);
             break;

         default:
             bSuccess = FALSE;
             break;
	  }
   }
   else
      bSuccess = FALSE;

   return bSuccess;
}

/****************************************************************************
*
*    FUNCTION: ConcatPidls(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2)
*
*    PURPOSE:  Concatenates two PIDLs 
*
****************************************************************************/
LPITEMIDLIST CDlgSelectDir::ConcatPidls(LPCITEMIDLIST pidl1, LPCITEMIDLIST pidl2)
{
    LPITEMIDLIST pidlNew;
    UINT cb1;
    UINT cb2;

    if (pidl1)  //May be NULL
       cb1 = GetSize(pidl1) - sizeof(pidl1->mkid.cb);
    else
       cb1 = 0;

    cb2 = GetSize(pidl2);

    pidlNew = Create(cb1 + cb2);
    if (pidlNew)
    {
        if (pidl1)
           memcpy(pidlNew, pidl1, cb1);
        memcpy(((LPSTR)pidlNew) + cb1, pidl2, cb2);
    }
    return pidlNew;

}

/****************************************************************************
*
*    FUNCTION: Create(UINT cbSize)
*
*    PURPOSE:  Allocates a PIDL 
*
****************************************************************************/
LPITEMIDLIST CDlgSelectDir::Create(UINT cbSize)
{
    LPMALLOC lpMalloc;
    HRESULT  hr;
    LPITEMIDLIST pidl=NULL;

    hr=SHGetMalloc(&lpMalloc);

    if (FAILED(hr))
       return 0;

    pidl=(LPITEMIDLIST)lpMalloc->Alloc(cbSize);

    if (pidl)
        memset(pidl, 0, cbSize);      // zero-init for external task   alloc

    if (lpMalloc) lpMalloc->Release();

    return pidl;
}

/****************************************************************************
*
*    FUNCTION: GetSize(LPCITEMIDLIST pidl)
*
*    PURPOSE:  Gets the size of the PIDL 
*
****************************************************************************/
UINT CDlgSelectDir::GetSize(LPCITEMIDLIST pidl)
{
    UINT cbTotal = 0;
    if (pidl)
    {
        cbTotal += sizeof(pidl->mkid.cb);       // Null terminator
        while (pidl->mkid.cb)
        {
            cbTotal += pidl->mkid.cb;
            pidl = Next(pidl);
        }
    }

    return cbTotal;
}

/****************************************************************************
*
*    FUNCTION: GetFullyQualPidl(LPSHELLFOLDER lpsf, LPITEMIDLIST lpi)
*
*    PURPOSE:  Gets the Fully qualified Pidls for the folder 
*
****************************************************************************/
LPITEMIDLIST CDlgSelectDir::GetFullyQualPidl(LPSHELLFOLDER lpsf, LPITEMIDLIST lpi)
{
   char szBuff[MAX_PATH];
   OLECHAR szOleChar[MAX_PATH];
   LPSHELLFOLDER lpsfDeskTop;
   LPITEMIDLIST  lpifq;
   ULONG ulEaten, ulAttribs;
   HRESULT hr;

   if (!GetName(lpsf, lpi, SHGDN_FORPARSING, szBuff))
      return NULL;

   hr=SHGetDesktopFolder(&lpsfDeskTop);

   if (FAILED(hr))
      return NULL;

//   MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,szBuff,-1,(USHORT *)szOleChar,sizeof(szOleChar));	//5 Ԗڂ̈ 'USHORT *  'LPWSTR' ɕϊł܂B




   hr=lpsfDeskTop->ParseDisplayName(NULL,
                                    NULL,
                                    szOleChar,
                                    &ulEaten,
                                    &lpifq,
                                    &ulAttribs);

   lpsfDeskTop->Release();

   if (FAILED(hr))
      return NULL;

    //return lpifq;
	return NULL;	//G[ô
}

/****************************************************************************
*
*    FUNCTION: CopyITEMID(LPMALLOC lpMalloc, LPITEMIDLIST lpi)
*
*    PURPOSE:  Copies the ITEMID 
*
****************************************************************************/
LPITEMIDLIST CDlgSelectDir::CopyITEMID(LPMALLOC lpMalloc, LPITEMIDLIST lpi)
{
   LPITEMIDLIST lpiTemp;

   lpiTemp=(LPITEMIDLIST)lpMalloc->Alloc(lpi->mkid.cb+sizeof(lpi->mkid.cb));
   CopyMemory((PVOID)lpiTemp, (CONST VOID *)lpi, lpi->mkid.cb+sizeof(lpi->mkid.cb));

   return lpiTemp;
}

/****************************************************************************
*
*    FUNCTION: Next(LPCITEMIDLIST pidl)
*
*    PURPOSE:  Gets the next PIDL in the list 
*
****************************************************************************/
LPITEMIDLIST CDlgSelectDir::Next(LPCITEMIDLIST pidl)
{
   LPSTR lpMem=(LPSTR)pidl;

   lpMem+=pidl->mkid.cb;

   return (LPITEMIDLIST)lpMem;
}

/****************************************************************************
*
*    FUNCTION: GetNormalAndSelectedIcons(LPITEMIDLIST lpifq, LPTV_ITEM lptvitem)
*
*    PURPOSE:  Gets the index for the normal and selected icons for the current item.
*
*    PARAMETERS:
*    lpifq    - Fully qualified item id list for current item.
*    lptvitem - Pointer to treeview item we are about to add to the tree.
*
****************************************************************************/
void CDlgSelectDir::GetNormalAndSelectedIcons(LPITEMIDLIST lpifq, LPTV_ITEM lptvitem)
{
   // Don't check the return value here. 
   // If IGetIcon() fails, you're in big trouble.
   lptvitem->iImage = GetIcon (lpifq, 
      SHGFI_PIDL | SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
   
   lptvitem->iSelectedImage = GetIcon (lpifq, 
      SHGFI_PIDL | SHGFI_SYSICONINDEX | SHGFI_SMALLICON | SHGFI_OPENICON);
   
   return;
}

/****************************************************************************
*
*    FUNCTION: GetIcon(LPITEMIDLIST lpi, UINT uFlags)
*
*    PURPOSE:  Gets the index for the current icon.  Index is index into system
*              image list.
*
*  PARAMETERS:
*    lpi    - Fully qualified item id list for current item.
*    uFlags - Flags for SHGetFileInfo()
*
*  RETURN VALUE:
*    Icon index for current item.
****************************************************************************/
int CDlgSelectDir::GetIcon(LPITEMIDLIST lpi, UINT uFlags)
{
   SHFILEINFO    sfi;

   SHGetFileInfo((LPCSTR)lpi, 0, &sfi, sizeof(SHFILEINFO), uFlags);

   return sfi.iIcon;
}


void CDlgSelectDir::OnItemexpandingTreeFolder(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	LPTVITEMDATA lptvid;
	LPSHELLFOLDER lpsf;
	HRESULT hr;
	
	if ((pNMTreeView->itemNew.state & TVIS_EXPANDEDONCE))
		goto exit;
        
	lptvid=(LPTVITEMDATA)pNMTreeView->itemNew.lParam;
	if (lptvid) {
		hr=lptvid->lpsfParent->BindToObject(lptvid->lpi, 0,
			                                IID_IShellFolder,(LPVOID *)&lpsf);
		if (SUCCEEDED(hr)) {
			FillTreeView(lpsf,lptvid->lpifq, pNMTreeView->itemNew.hItem);
		}

	}
exit:
	*pResult = 0;
}

void CDlgSelectDir::OnDeleteitemTreeFolder(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	//Let's free the memory for the TreeView item data...
	LPMALLOC     lpMalloc;
	HRESULT hr=SHGetMalloc(&lpMalloc);
	if (FAILED(hr)) {
		*pResult = 0; return ;
	}
        
	LPTVITEMDATA lptvid=(LPTVITEMDATA)pNMTreeView->itemOld.lParam;
	lptvid->lpsfParent->Release();
	lpMalloc->Free(lptvid->lpi);  
	lpMalloc->Free(lptvid->lpifq);  
	lpMalloc->Free(lptvid);  
	lpMalloc->Release();
	
	*pResult = 0;
}

void CDlgSelectDir::OnSelchangeComboDrive() 
{
	CWaitCursor WaitCursor;  // v

	// ݑIĂ鍀ڃCfbNX
	int iIndex	= m_ComboDrive.GetCurSel();
	CString strLabel;
	m_ComboDrive.GetLBText(iIndex,strLabel);
	// hCu("C:" etc)
	int cDrive=toupper(strLabel[strLabel.GetLength()-3]);
	int iDrive=cDrive-'A'+1;
	int cdret=_chdrive(iDrive);  // Change Drive

	// R{{bNXJghCuɑIB
	iIndex=SelectCurrentDrive(); 

	if (cdret==0) { // chdriveɐ
		// JghCu[gɑIB
		ExpandDrive(iIndex);
		
		//JgfBNg̓WJEI
		SelectCurrentDirectory();
	}
}

// R{{bNXŃJghCuIB
int CDlgSelectDir::SelectCurrentDrive()
{
	int i;
	int iDrive=_getdrive();  // hCuԍ

	int n=m_ComboDrive.GetCount();
	for (i=0;i<n;i++) {
		CBXIS *lpcbxis=(CBXIS*)m_ComboDrive.GetItemDataPtr(i);
		if (lpcbxis->idrv==iDrive) // hCuԍ
			break;
	}
	ASSERT(i<n); 

	// ړI̍ڂGfBbgRg[ֈڂ
	CString strLabel;
	m_ComboDrive.GetLBText(i,strLabel);
 	m_ComboDrive.SelectString(-1,strLabel);

	return  i;
}

// R{{bNX̎w肳ꂽCfbNX(idx)̃hCu[g
// c[WJB
void CDlgSelectDir::ExpandDrive(int idx)
{
	CBXIS *lpcbxis=(CBXIS *)m_ComboDrive.GetItemDataPtr(idx);
	LPTVITEMDATA lptvid=lpcbxis->lptvid;

	// VFIuWFNg̎擾
	LPMALLOC lpMalloc;
    HRESULT hr=::SHGetMalloc(&lpMalloc);
    if (FAILED(hr)) return;

	LPTVITEMDATA lptvid2 = (LPTVITEMDATA)lpMalloc->Alloc(sizeof(TVITEMDATA));
	if (lptvid2==NULL) {
		lpMalloc->Release(); return ;
	}
	lptvid2->lpi		= CopyITEMID(lpMalloc,lptvid->lpi);
	lptvid2->lpifq		= ConcatPidls(NULL,lptvid->lpifq);
	lptvid2->lpsfParent = lptvid->lpsfParent;
	lptvid2->lpsfParent->AddRef();

	lpMalloc->Release();

	char szBuff[MAX_PATH]; // th
	if (!GetName(lptvid->lpsfParent,lptvid->lpi,SHGDN_NORMAL,szBuff))
		return;

	TV_ITEM tvi;
	tvi.pszText		= szBuff;
	tvi.cchTextMax	= MAX_PATH;
	tvi.mask= TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;

	// TutH_̗L`FbN
	ULONG ulAttrs = SFGAO_HASSUBFOLDER | SFGAO_FOLDER;
	lptvid2->lpsfParent->GetAttributesOf (
			1, (const struct _ITEMIDLIST **)&lptvid2->lpi, &ulAttrs);
	if (ulAttrs & SFGAO_HASSUBFOLDER) {
		tvi.cChildren=1;
		tvi.mask |= TVIF_CHILDREN;
	}

	GetNormalAndSelectedIcons(lptvid2->lpifq,&tvi); // C[WXgindex

	tvi.lParam = (LPARAM)lptvid2;

	TV_INSERTSTRUCT tvins;
	tvins.item			= tvi;
	tvins.hInsertAfter	= TVI_FIRST;
	tvins.hParent		= TVI_ROOT;

	// Initialize the tree view control to be empty.
	m_TreeFolder.DeleteAllItems();

	HTREEITEM hti = m_TreeFolder.InsertItem(&tvins);

	m_TreeFolder.Expand(hti,TVE_EXPAND); // }[g(Drive)WJ
}

// JgfBNg̃tH_IB
// JghCuWJĂƂOŁB
void CDlgSelectDir::SelectCurrentDirectory()
{
	char szDir[MAX_PATH];
	if (_getdcwd(_getdrive(),szDir,MAX_PATH)==NULL) // JgfBNg
		return;
	CString strDir = szDir;

	HTREEITEM hti=m_TreeFolder.GetRootItem(); // Root Item
	unsigned char *yen=(unsigned char*)"\\";
	unsigned char *cp=_mbstok((unsigned char*)szDir,yen); // Drive char
	while ((cp=_mbstok(NULL,yen))!=NULL) {
		hti=m_TreeFolder.GetChildItem(hti); // j֍~(ȂNULL)B
		ASSERT(hti);
		if (hti==NULL) return ; // L蓾Ȃ
		CString strFolder;
		strFolder.Format("%s",cp);
		strFolder.MakeUpper(); // tH_͑啶ɂB
		CString strLabel=m_TreeFolder.GetItemText(hti); // j̃x
		strLabel.MakeUpper(); // 啶
		while  (strLabel != strFolder) { 
			// YtH_܂ŌZT
			hti=m_TreeFolder.GetNextSiblingItem(hti); // jAOj..
			ASSERT(hti);
			if (hti==NULL) return; // L蓾Ȃ
			strLabel=m_TreeFolder.GetItemText(hti); // jOj̃x
			strLabel.MakeUpper(); // 啶
		}
		m_TreeFolder.Expand(hti,TVE_EXPAND); // YtH_WJ
	}
	m_TreeFolder.SelectItem(hti);		 // ŌɓWJtH_I
}

void CDlgSelectDir::OnSelchangedTreeFolder(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// ӁI ̃[`OnDeleteItemTreeFolder()Ă΂Oɂ
	// ďoB̎̓hCuύXłB
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	int iDrive = _getdrive(); // JghCuԍ(1(A),2(B),...)

	LPSHELLFOLDER lpsf;
	HRESULT hr=SHGetDesktopFolder(&lpsf); // fXNgbvtH_

	if (SUCCEEDED(hr)) {
		LPTVITEMDATA lptvid=(LPTVITEMDATA)pNMTreeView->itemNew.lParam;
		char szCurr[MAX_PATH],szBuff[MAX_PATH];
		if (GetName(lpsf,lptvid->lpifq,SHGDN_FORPARSING,szBuff)) {
			strcpy(szCurr,szBuff); // ʂBDlgDirListszBuff͔j󂳂B
			if (iDrive==toupper(szCurr[0])-'A'+1) {
				// hCu̎(Deleteł͂Ȃ)tH_\B
				// DlgDirList̒SetCurrentDirectory()Ă΂B
				m_strSelectDir=szBuff; // ŐṼfBNgL
				DlgDirList(szBuff,0,IDC_DIRNAME,DDL_DIRECTORY);
				// fBNg_chdirBĒuȂƃhCu
				// JgfBNg̊ǗB(oI)
				_chdir(szCurr);
			}
		}
		lpsf->Release();
	}
	
	*pResult = 0;
}
