/*************************/
/*    KifListView.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include "KifListView.h"
#include "sdjdoc.h"
#include "sdjview.h"
#include "kbase.h"
#include "kifframe.h"
#include "dbeframe.h"
#include "dbeview.h"
#include "ssdjdoctemplate.h"
#include "kiftreeview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CKifListView

IMPLEMENT_DYNCREATE(CKifListView, CListView)

CKifListView::CKifListView()
{
	m_bInitialUpdate=FALSE;
}

CKifListView::~CKifListView()
{
}

BEGIN_MESSAGE_MAP(CKifListView, CListView)
	//{{AFX_MSG_MAP(CKifListView)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemchanged)
	ON_WM_SIZE()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_COMMAND(ID_MENU_PLAYCMNT, OnMenuPlaycmnt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKifListView `

void CKifListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// CKifListView ff

#ifdef _DEBUG
void CKifListView::AssertValid() const
{
	CListView::AssertValid();
}

void CKifListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CKifListView bZ[W nh

void CKifListView::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();

	CListCtrl &lc=GetListCtrl(); // XgRg[̎擾

	// RP`(̓EBhEɐݒ)
	CRect rect;
	GetClientRect(&rect);
	int rc=lc.InsertColumn(0,"w",LVCFMT_LEFT,rect.Width());
	ASSERT(rc!=-1);

	// 
	KifInit();

	m_bInitialUpdate=TRUE;
}

BOOL CKifListView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// |[gr[(ot) | o͖t@\ | 펞I\ | PI
	cs.style |= 
		(LVS_REPORT | LVS_NOSORTHEADER | LVS_SHOWSELALWAYS | LVS_SINGLESEL);
	
	return CListView::PreCreateWindow(cs);
}

//
// w荀ڂ̃XgRg[ւ̑}
//   n: }ʒu(CfbNX)
//   pcl: }w
// pKBasePCLw̋ǖʂO
BOOL CKifListView::KifInsert(int n, PCELL * pcl,CKBase *pKBase,CListCtrl &lc)
{
	int i;

	// w\L  __1_VZ
	//             __2_Wl
	CString str;
	str.Format("%3d %s%s",pKBase->level(),
		(pcl->newside()==SIDE_A)? "": "", pKBase->mvstr(pcl)+4);

	// ڒǉ(擪)
	int rc=lc.InsertItem(n,str);
	ASSERT(rc!=-1);
	if (rc==-1)
		return FALSE;

	// ǉwIndexlParam֋L
	PCELL *ppnt=pcl->pnt();
	int m=ppnt->cldnum();
	for (i=0;i<m;i++) {
		if (ppnt->cld(i)==pcl)
				break;
	}
	ASSERT(i!=m);
	lc.SetItemData(n,i); // lParam̃Zbg

	return TRUE;
}

// ̏
void CKifListView::KifInit()
{
	int j,k;
	CListCtrl &lc=GetListCtrl(); // XgRg[̎擾
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg

	PCELL *pcl=pKBase->lastmove();	// O̎w
	PCELL *root=pKBase->root();		// ǖ

	lc.DeleteAllItems(); // S

	// 肩猻ǖʂ܂ł̍ڂ̑}
	while (root!=pcl) {
		// 擪ڂƂđ}
		if (!KifInsert(0,pcl,pKBase,lc))
			break;
		// Őǖʂ
		pKBase->backmove2();
		pcl=pKBase->lastmove();
	}
	
	lc.InsertItem(0,"  ǖ"); // ǖʍs(index 0)
	lc.SetItemData(0,0); // lParam̒l0ɂĂ

	// ǖʂǖʂɖ߂
	for (j=1;j < lc.GetItemCount();j++) {
		int n=lc.GetItemData(j);
		pKBase->ahead2(n); // LIndexŋǖʂOi
	}

	// ǖʈڍs̍ڂ̑}(Index j)
	for (k=j;pKBase->lastmove()->cldnum();k++) {
		pKBase->ahead2(); // {菇Oi
		pcl=pKBase->lastmove();
		// kԖڂ̍ڂƂđ}
		if (!KifInsert(k,pcl,pKBase,lc))
			break;
	}

	// ǖʂǖʂɖ߂
	while (k!=j) {
		pKBase->backmove2();
		k--;
	}

	// ǖʂ̎wI
	int level=pKBase->level();
	UINT mask = LVIS_SELECTED | LVIS_FOCUSED;
	lc.SetItemState(level,mask,mask);
	lc.EnsureVisible(level,FALSE);
}

// ̍XV
//   {菇ωĂ邩`FbNāAωĂΌXgXVB
//   w̏ƍ͈͂́AhLg̋ǖ(level)Ɗ̑I
//   CfbNX̎Ⴂ̎wƂAvȂwȍ~̃Xg
//   ڂ͑Sč폜čXVB
void CKifListView::KifUpdate()
{
	int i;
	CListCtrl &lc=GetListCtrl();	 // XgRg[̎擾
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg
	int level = pKBase->level();	 // ݂̊hLg̎w萔


	// ݂̊̑IڃCfbNXl߂
	int n=lc.GetItemCount();
	for (i=0;i<n;i++) {
		if (lc.GetItemState(i,LVIS_SELECTED) & LVIS_SELECTED)
			break;
	}
	ASSERT(i<=n);
	int icnt=i; // ݂̊̑IڃCfbNX

	// icnt̕␳
	// ʏicnt!=level̎ɖ{֐Ă΂邪AI̎̂icnt==level
	// Ă΂B(ʂ̂ݍXVĂȂ̂łŕ␳B)
	if (icnt==level) {
		// ! ݌vicnt==level͕Î݂̔AႦ΂Qڂ̋ǖ
		// Ń[Uރc[o[fQqbgAQڂ̃qbg̃bZ[
		// WPڂ̃qbg̏AID_KIFFRAME_UPDATESendMessageO
		// ƂƁA_Iɂ́AǖʌށAށAUpdate,UpdateƏ
		// ʂƂȂAPڂupdateicnt=0ƂȂA2ڂupdateicnt=0,level=0
		// Ɛ蓾BĂ̏ꍇz肵returnB
		// (return ȂĂnjAʁB)
		if (icnt > 0)
			icnt--;
		else
			return;
	}

	// 肩hLglevelƌ̑Iicnt̎Ⴂk
	int k = (level < icnt)? level:icnt;

	// klevel܂ł̌s̎菇擾B
	CArray <int,int> pid; 
	if (level-k) pid.SetSize(level-k);
	// KBasek̋ǖʂ
	while (pKBase->level() > k) {
		int m = pKBase->level()-1;
		pid[m-k]=pKBase->GetPid(m);
		pKBase->backmove2();
	}

	// ǖ(k)Ő[̋ǖʂ܂Ői߂AwrB
	for (i=0;pKBase->playnum();i++) {
		// wOi
		int rc;
		if (pKBase->level()<level)
			rc=pKBase->ahead2(pid[i]);
		else
			rc=pKBase->ahead2();
		ASSERT(rc);

		int lv=pKBase->level();

		// lvڂ̎w肪XgڂɂΔrB
		if (lc.GetItemCount()>lv) {
			// w肪Ԃ͐VȎwrB
			CString str1 = pKBase->mvstr(pKBase->lastmove()); // VZ
			CString str2 = lc.GetItemText(lv,0);              // __1_VZ
			int n1 = pKBase->GetPid(lv-1);   // w̃CfbNX
			int n2 = (int)lc.GetItemData(lv);
			// w̃CfbNXƖ̗̂̈vŎwrB
			if (n1!=n2 ||
				strcmp((LPCTSTR)str1+4,(LPCTSTR)str2+6)!=0) {
				// w肪HAlvȍ~̎w胊Xgڂׂč폜B
				while (lc.GetItemCount() > lv)
					lc.DeleteItem(lv);
				// ̎wlvԖڂ̃XgڂƂInsert
				if (!KifInsert(lv,pKBase->lastmove(),pKBase,lc))
					ASSERT(0);
				// ̎_lc.GetItemCount()==lv+1ƂȂĂBOi(lv+1)
				// ̃[v͉L(lc.GetItemCount()==lv)̃ubN
				// ʉ߂悤ɂȂB
			}
		}
		// lvڂ̎w肪XgڂɂȂBAVȎw肪ǉꂽꍇ
		else {
			ASSERT(lc.GetItemCount()==lv); // ǉꂽꍇAȂ锤B
			// ̎wlvԖڂ̃XgڂƂInsert
			if (!KifInsert(lv,pKBase->lastmove(),pKBase,lc))
				ASSERT(0);
		}
	}

	// ̎_ŋǖʂ͊̍Ő[[ɂB]āAXg
	// ̋ǖʈȍ~̎w荀ڂׂč폜B(]ȃXg)
	int lv=pKBase->level();
	while (lc.GetItemCount() > lv+1) // lc.GetItemCount()==lv+1ȂvԁB
		lc.DeleteItem(lv+1);

	// ǖʂl(level)֖߂
	while (pKBase->level()>level)
		pKBase->backmove2();

	// ݂̎wI\
	UINT mask = LVIS_SELECTED | LVIS_FOCUSED;
	lc.SetItemState(level,mask,mask);
	lc.EnsureVisible(level,FALSE);
}

///
// ڂύXꂽɒʒmB
void CKifListView::OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	*pResult = 0;

	// ڂVɑIꂽꍇ̏Ԃ̏
	if (!(pNMListView->uNewState & LVIS_SELECTED))
		return; // ڂVɑIꂽꍇłȂΏI

	CListCtrl &lc=GetListCtrl();	 // XgRg[̎擾
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg
	int level = pKBase->level();	 // ݂̊hLg̎w萔
	int iItem = pNMListView->iItem;  // ݂̊̑I

	if (level==iItem)
		return; // ǖʂ𓮂đIڂړꍇB

	CSDJView *pSDJView=pDoc->GetSDJView(); // Ղ̃r[
	if (pSDJView->IsAutoPlay())
		return; // ǖʂXVĂ鎞͉ȂB

	// er[ɒߑJĂ炱
	pSDJView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	// Qȏ㗣ꂽǖʂ͂PŐǖʂ܂ŃWvB
	if (abs(level-iItem)>1) {
		while (abs(level-iItem)>1) { 
			if (level > iItem) {
				pKBase->backmove2();  // ǖʌ
			}
			else {
				int n=lc.GetItemData(level+1);
				int rc=pKBase->ahead2(n);   // ǖʂ̑Oi
				ASSERT(rc!=0);
			}
			level=pKBase->level();
		}
		pSDJView->Invalidate(); // SʍXV
	}

	// ߂̂P̍XV͉ʂ𓮂
	while (level!=iItem) {
		if (level > iItem) {
			pKBase->backmove(); // ǖʂ̌(ʂ)
		}
		else {
			// KBase͍levelڂ̎w̏ԂA
			// ǖʂOiw͊(level+1)ڂ̎w
			int n=lc.GetItemData(level+1);
			int rc=pKBase->ahead(n);   // ǖʂ̑Oi(ʂ)
			ASSERT(rc!=0);

			if (theApp.m_bKSoundEnable)
				theApp.m_KSound.Play(); // 炷
		}
		// er[̏̕\XVB(JĂ)
		pSDJView->PostMessage(WM_COMMAND,ID_GUIDEFRAME_INVALIDATE);
		level=pKBase->level();
	}

	// c[r[̍XV
	CKifFrame *pKifFrame=(CKifFrame *)GetParentFrame();
	CKifTreeView *pKifTreeView=(CKifTreeView *)pKifFrame->m_wndSplitter.GetPane(0,1);
	pKifTreeView->KifUpdate();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==pSDJView) { // ̃r[ƓȂ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	// w蒍߂̎\(OiłނłΕ\)
	pSDJView->AutoCommentDisplay();

	SetFocus(); // tH[JX͂֒u
}

// EBhẼTCYύXꂽ
void CKifListView::OnSize(UINT nType, int cx, int cy) 
{
	CListView::OnSize(nType, cx, cy);

/* ̂ARςƁA傫Ɂuǖʁv̕\ʒuB
	if (m_bInitialUpdate) { // OnSizeInitailUpdatȇOɂĂ΂B
		CListCtrl &lc=GetListCtrl();	 // XgRg[̎擾
		int cw=lc.GetColumnWidth(0);
		if (cw!=cx) {
			lc.SetColumnWidth(0,cx); // EBhEɃRݒ肷B
		}
//		CKifFrame *pFrameWnd=(CKifFrame*)GetParentFrame();
//		pFrameWnd->m_wndSplitter.RecalcLayout(); // ̌ʂ͂ȂB
//		pFrameWnd->RecalcLayout();
	}*/
}

/////
// ENbN
void CKifListView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// ̎_ł͂łOnItemChanged()Ă΂ċǖʈړ͏IĂB
	*pResult = 0;

	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CSDJView *pSDJView=pDoc->GetSDJView(); // Ղ̃r[
	if (pSDJView->IsCommentBoxOpened())
		return;

	// |bvAbvj[J
	CPoint point;
	::GetCursorPos(&point);
	CMenu Menu;
	Menu.LoadMenu(IDR_KIF_POPMENU);
	CMenu *pPopMenu=Menu.GetSubMenu(0);

	BOOL bMenuEnable=pSDJView->UpdateMenuPlaycmnt();
	pPopMenu->EnableMenuItem(ID_MENU_PLAYCMNT,
		(bMenuEnable)? MF_ENABLED:(MF_GRAYED | MF_DISABLED));

	pPopMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		point.x,point.y, this);

}

////
// w蒍߃j[
void CKifListView::OnMenuPlaycmnt() 
{
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CSDJView *pSDJView=pDoc->GetSDJView(); // Ղ̃r[

	pSDJView->MenuPlaycmnt();
}
