/*************************/
/*    KifTreeView.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include "KifTreeView.h"
#include "sdjdoc.h"
#include "sdjview.h"
#include "kbase.h"
#include "kifframe.h"
#include "dbeframe.h"
#include "dbeview.h"
#include "ssdjdoctemplate.h"
#include "kiflistview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CKifTreeView

IMPLEMENT_DYNCREATE(CKifTreeView, CTreeView)

CKifTreeView::CKifTreeView()
{
	m_bDeleting=FALSE;
}

CKifTreeView::~CKifTreeView()
{
}

BEGIN_MESSAGE_MAP(CKifTreeView, CTreeView)
	//{{AFX_MSG_MAP(CKifTreeView)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemexpanding)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_COMMAND(ID_MENU_PLAYCMNT, OnMenuPlaycmnt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKifTreeView `

void CKifTreeView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// CKifTreeView ff

#ifdef _DEBUG
void CKifTreeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CKifTreeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CKifTreeView bZ[W nh


BOOL CKifTreeView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// ڂŌ | ROOTŌ | ڂ͖t(+/-) | ɑI\
	cs.style |=
		(TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS);
	
	return CTreeView::PreCreateWindow(cs);
}

void CKifTreeView::OnInitialUpdate() 
{
	CTreeView::OnInitialUpdate();
	
	// 
	KifInit();
}

// ̏
void CKifTreeView::KifInit()
{
	CTreeCtrl &tc=GetTreeCtrl();
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg

	// ǖʂ̋L
	int level=pKBase->level();
	CArray <int,int> pid;
	if (level) {
		pid.SetSize(level);
		for (int i=0;i<level;i++)
			pid[i]=pKBase->GetPid(i);
	}

	// DeleteSelectďo𖳌ɂ邽߂ɃtO䂷B
	m_bDeleting=TRUE;
	tc.DeleteAllItems(); // S
	m_bDeleting=FALSE;

	// ǖʂցB
	while (pKBase->lastmove()!=pKBase->root())
		pKBase->backmove2();

	HTREEITEM ht=tc.InsertItem("ǖ",TVI_ROOT);
	tc.SetItemData(ht,0);

	// ǖʂJ
	ExpandItem(ht,tc,pKBase);

	// ǖʂւǂ
	for(int i=0;pKBase->level() < level;i++) {
		pKBase->ahead2(pid[i]);
		ht=tc.GetChildItem(ht);
		ExpandItem(ht,tc,pKBase);
		for (int j=0;j<pid[i];j++) {
			ht=tc.GetNextSiblingItem(ht);
			ExpandItem(ht,tc,pKBase);
		}
	}
	// ݂̎wI\
	tc.SelectItem(ht);
	tc.EnsureVisible(ht);
}

// ̍XV
//   {IɁA{֐Ă΂̂͊ɉ ahead()/backmove()ŋǖ
//  łBw̃c[ύX̂PutSprite()ɂĎw
//  XV݂̂łBȊO̍XV(ႦΊ̓Ǎ)̏ꍇKifInit
//  ďoB
//  ]āARoot猻ǖʂ̂PO܂ł̎菇̓c[r[̒ɕKB
//  ȂPutSprite()͈肵XVłȂłB
//  ̂ɁA{֐łRoot猻ǖʂ̈O܂ł̍ڂc[̒TAŌ
//  ̈ȍ~̎wƍB
//  
void CKifTreeView::KifUpdate()
{
	CTreeCtrl &tc=GetTreeCtrl();
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg

	int level=pKBase->level();
	if (level==0) { // ǖʂȂIđI(XV͗L蓾Ȃ)
		HTREEITEM ht=tc.GetRootItem();
		tc.SelectItem(ht);
		tc.EnsureVisible(ht);
		return;
	}

	// ǖʂ̋L
	CArray <int,int> pid;
	if (level) {
		pid.SetSize(level);
		for (int i=0;i<level;i++)
			pid[i]=pKBase->GetPid(i);
	}

	// ǖʂ
	while (pKBase->lastmove()!=pKBase->root())
		pKBase->backmove2();
	HTREEITEM ht=tc.GetRootItem();
	if (!(tc.GetItemState(ht,TVIS_EXPANDEDONCE) & TVIS_EXPANDEDONCE))
		ExpandItem(ht,tc,pKBase);

	// level̈Őǖʂ܂htƋǖʂXV
	for (int i=0;i<level-1;i++) {
		ht=tc.GetChildItem(ht);
		for (int j=0;j<pid[i];j++) {
			ht=tc.GetNextSiblingItem(ht);
		}
		pKBase->ahead2(pid[i]);
		if (!(tc.GetItemState(ht,TVIS_EXPANDEDONCE) & TVIS_EXPANDEDONCE))
			ExpandItem(ht,tc,pKBase);
	}

	// level̈ŐǖʂĂwƍB
	int n1=pKBase->playnum(); // KBase̎w̐
	int n2=GetChildNum(ht);   // c[̎w̐
	BOOL bUpdate=FALSE;
	if (n1==n2) { // w萔Ȃw肻̂̂rB
		HTREEITEM ht1=tc.GetChildItem(ht);
		for (int i=0;i<n1;i++) {
			PCELL *pcl=pKBase->lastmove();
			CString str1=pKBase->mvstr(pcl->cld(i)); // VZ
			CString str2=tc.GetItemText(ht1);// __1_VZ
			if (strcmp((LPCTSTR)str1+4,(LPCTSTR)str2+6)) {
				bUpdate=TRUE; // w肪ႤB
				break;
			}
			ht1=tc.GetNextSiblingItem(ht1);
		}
	}else {
		bUpdate=TRUE; // w萔Ⴄ
	}
	// w̏ƍŕsvȂAc[̍ڂč\zB
	if (bUpdate) {
		// qS
		EraseItem(ht,tc,pKBase);
		// ēxexpand.
		ExpandItem(ht,tc,pKBase);
	}
	// ȏōŏIǖʂ̈vۏ؂ꂽ̂ōŏIǖʂֈړB
	ht=tc.GetChildItem(ht);
	for (int j=0;j<pid[level-1];j++) {
		ht=tc.GetNextSiblingItem(ht);
	}
	pKBase->ahead2(pid[level-1]);
	if (!(tc.GetItemState(ht,TVIS_EXPANDEDONCE) & TVIS_EXPANDEDONCE))
		ExpandItem(ht,tc,pKBase);

	// ŏIǖʈȍ~̎w͎萔̂݃`FbNB
	n1=pKBase->playnum();
	n2=GetChildNum(ht);
	if (n1!=n2) {
		// ŏIǖʂ̎萔ႤPutSprite()ł̒ǉ݂̎̂̔
		ASSERT(n1==0);
		// qS.
		EraseItem(ht,tc,pKBase);
	}
	// ŏIIɎw̍ڂIB
	tc.SelectItem(ht);
	tc.EnsureVisible(ht);
}

// ht̎qSāAԂĐݒ肷B
// KBase͍ht̎wwŐǖʂɂȂĂ邱ƂOB
void CKifTreeView::EraseItem(HTREEITEM ht,CTreeCtrl &tc,CKBase *pKBase)
{
	// Atc.ItemHasChildren(ht) while肷Ɩ[vɓB
	// MF/C̃oO...BItemHasChildren()cChildrenreturnĂ邾B
	// qSB
	HTREEITEM ht1=tc.GetChildItem(ht);
	while (ht1) {
		// 폜Selectďo𖳌ɂ邽߂ɃtO䂷B
		m_bDeleting=TRUE;
		tc.DeleteItem(ht1);
		m_bDeleting=FALSE;
		ht1=tc.GetChildItem(ht);
	}
	// ڂĐݒ肷BȂƕ\(cChildren)B
	TV_ITEM tvi;
	tvi.hItem	= ht;
	tvi.mask	= TVIF_CHILDREN | TVIF_STATE;
	tc.GetItem(&tvi);
	tvi.state   &= ~TVIS_EXPANDEDONCE;
	tvi.cChildren = (pKBase->playnum())? 1:0;
	tc.SetItem(&tvi);
}

// ht̎q̐Ԃ
int CKifTreeView::GetChildNum(HTREEITEM ht)
{
	CTreeCtrl &tc=GetTreeCtrl();

	int n=0; // (ht)̎q̐
	if (tc.ItemHasChildren(ht)) {
		HTREEITEM ht1=tc.GetChildItem(ht);
		while (ht1!=NULL) {
			n++;
			ht1=tc.GetNextSiblingItem(ht1);
		}
	}
	return n;
}

// ݂̋ǖʂ̎wAw肳ꂽht̎qƂēWJB
// {֐͍ڂWJđ}݂̂Ŏۂ̓WJ\͍ŝł͂ȂB
void CKifTreeView::ExpandItem(HTREEITEM ht, CTreeCtrl &tc, CKBase *pKBase)
{
	// ̍(ht)͊JƂƂԂɐݒ肷B
	tc.SetItemState(ht,TVIS_EXPANDEDONCE,TVIS_EXPANDEDONCE);

	int n=pKBase->playnum();
	for (int i=0;i<n;i++) {
		PCELL *pcl=pKBase->lastmove()->cld(i);
		CString str; // \x́u__1_VZv
		str.Format("%3d %s%s",pKBase->level()+1,
			(pcl->newside()==SIDE_A)? "": "", pKBase->mvstr(pcl)+4);

		TV_ITEM tvi;
		memset(&tvi,0,sizeof (TV_ITEM));
		tvi.mask		= TVIF_TEXT | TVIF_PARAM | TVIF_CHILDREN;
		tvi.pszText		= (LPSTR)(LPCTSTR)str;
		tvi.cchTextMax	= str.GetLength()+1;
		tvi.lParam		= i;
		tvi.cChildren	= (pcl->cldnum())? 1:0; // q+

		TV_INSERTSTRUCT tvins;
		tvins.item			= tvi;
		tvins.hParent		= ht;
		tvins.hInsertAfter	= TVI_LAST;

		tc.InsertItem(&tvins); // ڂ̑}
	}
}

void CKifTreeView::OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	CTreeCtrl &tc=GetTreeCtrl();
	HTREEITEM ht=pNMTreeView->itemNew.hItem;

	*pResult = 0;

	// xJꂽƂ̂鍀ڂȂ牽ȂB
	if (tc.GetItemState(ht,TVIS_EXPANDEDONCE) & TVIS_EXPANDEDONCE)
		return;

	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg

	JumpTo(ht);					// ht̋ǖʂֈړ
	ExpandItem(ht,tc,pKBase);   // ǖʂJ
	JumpBack();					// ̋ǖʂ֖߂
}

void CKifTreeView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg
	CTreeCtrl &tc=GetTreeCtrl();
	HTREEITEM ht=pNMTreeView->itemNew.hItem;
	
	*pResult = 0;

	if (m_bDeleting)
		return; // 폜ɂĂ΂B͉̎ȂB

	// ݂̑I\ƊhLg̃JgʒurB
	// vĂ΁AhLgύXđI\
	// ړꍇȂ̂ŉɏIB

	int ilv=0; // c[̐[i̎萔ڂƔrB)
	HTREEITEM hpt=ht;
	while (hpt!=tc.GetRootItem()) {
		hpt=tc.GetParentItem(hpt);
		ilv++;
	}
	int level=pKBase->level();
	// w̃xi萔jȂ
	if (level==ilv) {
		if (level==0)
			return; // ǖʂ͈Ȃ̂ŕ\L̏ƍ̕Kv͂ȂB
		// ǖʈӊOł͕̎w肪΂̕\L̈vm߂B
		PCELL *pcl=pKBase->lastmove();
		PCELL *ppnt=pcl->pnt();
		if (ppnt->cldnum()==0)
			return; // w肪ȂΎw̏ƍ̕Kv͂ȂB

		CString str1=pKBase->mvstr(pcl); // VZ
		CString str2=tc.GetItemText(ht); // __1_VZ
		if (strcmp((LPCTSTR)str1+4,(LPCTSTR)str2+6)==0) {
			return; // w͈vB
			// A͑ύXAI\XVꂽB
		}
	}

	// ́Ac[̑I\ύXꂽꍇ̏B
	// c[̑IĈʒuɊ̋ǖʂXVB

	CSDJView *pSDJView=pDoc->GetSDJView(); // Ղ̃r[
	if (pSDJView->IsAutoPlay())
		return; // ǖʂXVĂ鎞͉ȂB

	// er[ɒߑJĂ炱
	pSDJView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	// 悸ړI̋ǖʂֈړB
	JumpTo(ht);
	// WvXgAړŐǖʂ̋ʂ̑c
	// ɂǖ(clv)B
	POSITION pos1=m_lstFrom.GetHeadPosition();
	POSITION pos2=m_lstTo.GetHeadPosition();
	int clv=0;
	while (pos1!=NULL && pos2!=NULL) {
		int n1=m_lstFrom.GetNext(pos1);
		int n2=m_lstTo.GetNext(pos2);
		if (n1!=n2)
			break;
		clv++;
	}
	// Ō̂P̓ ̔
	int action=-1; // 0:backmove 1:ahead(n)
	int n=-1;
	int listview_action=-1; // 0:update, 1:init
	// {菇֖߂Aǖʈȍ~֐i߂ꍇ
	if (clv==ilv || clv==level) {
		ASSERT(ilv!=level);
		listview_action=0;
		if (clv==ilv) { // {菇߂ꍇ
			ASSERT(pos1);
			int n3=m_lstFrom.GetNext(pos1);
			pKBase->ahead2(n3);
			if (level-ilv>1) // Qȏ㗣ꂽǖʂȂ
				pSDJView->Invalidate(); // SʍXV
			action=0;
		}
		else { // ǖʂOiꍇ
			pKBase->backmove2();
			if (ilv-level>1) // Qȏ㗣ꂽǖʂȂ
				pSDJView->Invalidate(); // SʍXV
			action=1;
			n=m_lstTo.GetTail(); // Ō̎w
		}
	}
	// {菇܂͂ȍ~̋ǖʂƂ͕ʂ̎}w肵ꍇ
	else {
		listview_action=1;
		pKBase->backmove2();
		// Z̎wI񂾏ꍇ
		if (level==ilv && level-clv==1) {
			int n3=m_lstFrom.GetTail();
			pKBase->ahead3(n3); // ʂ̋ǖʂɖ߂
			pKBase->backmove(); // ʂ𓮂Ė߂B
		}
		else // ZӊO̎wI񂾏ꍇ
			pSDJView->Invalidate(); // SʍXV
		action=1;
		n=m_lstTo.GetTail();
	}
	// Ō̂P̍XVBʂAB
	switch (action) 
	{
	case 0:
		pKBase->backmove(); // ǖʌ
		break;
	case 1:
		pKBase->ahead(n);   // ǖʑOi
		if (theApp.m_bKSoundEnable)
			theApp.m_KSound.Play(); // 炷
		break;
	default:
		ASSERT(0);
	}

	// er[̏̕\XVB(JĂ)
	pSDJView->PostMessage(WM_COMMAND,ID_GUIDEFRAME_INVALIDATE);

	// Xgr[̍XV
	CKifFrame *pKifFrame=(CKifFrame *)GetParentFrame();
	CKifListView *pKifListView=(CKifListView *)pKifFrame->m_wndSplitter.GetPane(0,0);
	if (listview_action==0)
		pKifListView->KifUpdate();
	else
		pKifListView->KifInit();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==pSDJView) { // ̃r[ƓȂ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	JumpClear(); // ǖʃWvXg̍폜
	tc.EnsureVisible(ht); // I\ʒuɑXN[

	// w蒍߂̎\(OiłނłΕ\)
	pSDJView->AutoCommentDisplay();

	SetFocus(); // tH[JX͂֒u
}

// ݂̋ǖʂLāAǖʂht֔΂B
void CKifTreeView::JumpTo(HTREEITEM ht)
{
	int i;
	CTreeCtrl &tc=GetTreeCtrl();
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg

	m_lstTo.RemoveAll();
	m_lstFrom.RemoveAll();

	// KBaseǖʂֈړm_lstFromL
	while (pKBase->lastmove()!=pKBase->root()) {
		PCELL *pcl=pKBase->lastmove();
		PCELL *ppnt=pcl->pnt();
		for (i=0;i<ppnt->cldnum();i++) {
			if (ppnt->cld(i)==pcl)
				break;
		}
		ASSERT(i<ppnt->cldnum());
		m_lstFrom.AddHead(i);

		pKBase->backmove2();
	}
	// tc[g܂ŒHm_lstToB
	while (ht!=tc.GetRootItem()) {
		int n = (int)tc.GetItemData(ht);
		m_lstTo.AddHead(n);

		ht=tc.GetParentItem(ht);
	}
	// m_lstToHċǖʂ𓱂
	POSITION pos=m_lstTo.GetHeadPosition();
	while (pos) {
		int n = m_lstTo.GetNext(pos);
		pKBase->ahead2(n);
	}

}

// ݂̋ǖʂ𕜌B
// JumpTo(ht)ŋLǖ	֖߂B
void CKifTreeView::JumpBack()
{
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase(); // hLg

	// ǖʂ܂Ŗ߂
	while (pKBase->lastmove()!=pKBase->root())
		pKBase->backmove2();

	// m_lstFromHČ̋ǖʂցB
	POSITION pos = m_lstFrom.GetHeadPosition();
	while (pos) {
		int n = m_lstFrom.GetNext(pos);
		pKBase->ahead2(n);
	}

	m_lstTo.RemoveAll();
	m_lstFrom.RemoveAll();
}

void CKifTreeView::JumpClear()
{
	m_lstTo.RemoveAll();
	m_lstFrom.RemoveAll();
}

/////
// ENbN
void CKifTreeView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// }EXJ[\ʒu̎擾
	CPoint point;
	::GetCursorPos(&point);	   // XN[W
	CPoint clientpt=point;
	ScreenToClient(&clientpt); // NCAgW

	*pResult = 0;

	// qbgeXgŃACe𒲂ׂB
	CTreeCtrl &tc=GetTreeCtrl();
	UINT flag;
	HTREEITEM ht=tc.HitTest(clientpt,&flag);
	if (ht==NULL)
		return; // qbgꂽACeȂΏI

	// c[r[ł̓qbgꂽACe͑IĂȂB
	// (Pɋ\Ă邾) őIB
	// ŃXgr[̉ENbNƓɂȂB
	tc.SelectItem(ht); 

	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CSDJView *pSDJView=pDoc->GetSDJView(); // Ղ̃r[
	if (pSDJView->IsCommentBoxOpened())
		return;

	// |bvAbvj[J
	CMenu Menu;
	Menu.LoadMenu(IDR_KIF_POPMENU);
	CMenu *pPopMenu=Menu.GetSubMenu(0);

	BOOL bMenuEnable=pSDJView->UpdateMenuPlaycmnt();
	pPopMenu->EnableMenuItem(ID_MENU_PLAYCMNT,
		(bMenuEnable)? MF_ENABLED:(MF_GRAYED | MF_DISABLED));

	pPopMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		point.x,point.y, this);

}

////
// w蒍߃j[
void CKifTreeView::OnMenuPlaycmnt() 
{
	CSDJDoc *pDoc=(CSDJDoc *)GetDocument();
	CSDJView *pSDJView=pDoc->GetSDJView(); // Ղ̃r[

	pSDJView->MenuPlaycmnt();
}
