#ifndef __MBASE__
#define __MBASE__
// MBase.h : wb_[ t@C
//
#include <afxtempl.h>
#include <sbase.h>
#include "..\sdjarchive.h"


/////////////////////////////////////////////////////////////////////////////
// CMBase R}h ^[Qbg

class CMBase : public SBASE
{
	DECLARE_SERIAL(CMBase)

// Agr[g
public:

// Iy[V
public:
	virtual void CopyAspect(SBASE *psrc);
	BOOL IsMulti();
	int GetBplayList(CList <B_PLAY,B_PLAY&>* pBlist,
		CBform *bp=NULL,int*side=NULL); // {菇B_PLAYXg̎擾
	void LineSerialize(CSDJArchive& ar); // {菇݂̂Serialize
	void CopySBase(SBASE *pj,BOOL bAll=FALSE,BOOL bLine=TRUE);
	void PushAspect(BOOL bReturn=TRUE,CBform *bp=NULL,int *side=NULL,
		CList <int,int> *pList=NULL);	// ǖʂ̋L
	void PopAspect(CList <int,int> *pList=NULL);	// ǖʂ̕
	void JudgeRootPreCheck();   // wO̖{菇
	void JudgeRootPreCheck(PCELL *pcl);   // wO̖{菇
	void JudgeRootPreCheck(int n);   // wO̖{菇
	void JudgeRootPreCheck(B_PLAY bplay);   // wO̖{菇
	void JudgeRootAfterCheck(); // w̖{菇
	void FreePcell();
	virtual void recstart();
	int ahead(void);
	int ahead2(void);
	int ahead(int n);
	int ahead2(int n);
	int ahead3(int n);
	void JudgeRoot(); // {菇̔
	int GetPid(int level){return m_pid[level];} // {菇̎擾
	int GetJudgeLevel(){return m_judgelevel;}	// {菇萔ڂ̎擾
	void ResetJudgeLevel(){m_judgelevel=-1;}
	int GetPidSize(){return m_maxlevel;}		// {菇̎萔
	int move(B_PLAY bplay,BOOL bSep=FALSE);
	int move2(B_PLAY bplay,BOOL bSep=FALSE);
	int move(PCELL *pcl,BOOL bSep=FALSE);
	int move2(PCELL *pcl,BOOL bSep=FALSE);
	B_PLAY LastBplay(CBform *bp=NULL,int *pside=NULL);
	BOOL GetMvstr(B_PLAY bplay,CString &mvstr);   // w̕
	void GetAspect(CBform *pBform, int *side);    // ǖʂ̎擾
	void SetAspect(CBform *pBform, int  side);    // ǖʂ̐ݒ
	// RXgN^
	CMBase();
	~CMBase();

	// I[o[Ch
	virtual void Serialize(CArchive& ar);  
	virtual void Serialize(CSDJArchive& ar){Serialize((CArchive&)ar);}

private:
	void CopySBasePlay(SBASE *pj); // {菇̃Rs[ƃ[`
	void CopySBasePlayWhole(SBASE *pj); // 
	BOOL PclToPly(PCELL *pcl,SBASE *pj,PLAY *pply);     // 
	void CopyPclCmnt(PCELL *pcl,SBASE *pj,PCELL *pcl2); // 


// Cve[V
protected:
	void SearchPcell(); // wԂ̒T
	BOOL JudgeAspect();	// ǖʂ̔
	int m_judgelevel;   // {菇vZ萔
	CArray <int,int> m_pid;	// {菇
	CArray <int,int> m_pid2;	// Ɨp

	SHOGIBAN m_jban;	// ŏIǖ
	int m_maxlevel;		// 萔

	CList <int,int> m_Alist; // ǖʋLXg
	BOOL m_bAlistUsing;
};

/////////////////////////////////////////////////////////////////////////////

#endif // __MBASE__