/***********************/
/*    OsVersion.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "OsVersion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COsVersion

COsVersion::COsVersion()
{
	m_OsVersionInfo.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);

	GetVersionEx(&m_OsVersionInfo);						// OS̃o[W擾

	switch ( m_OsVersionInfo.dwPlatformId )
	{
	case VER_PLATFORM_WIN32s:
		m_OsVersionType = 0;							// Windows3.1 Win32s
		break;

	case VER_PLATFORM_WIN32_NT:
		if (m_OsVersionInfo.dwMajorVersion == 3 &&
			m_OsVersionInfo.dwMinorVersion == 51) {
			m_OsVersionType = 1;						// NT3.51
		}
		else if (m_OsVersionInfo.dwMajorVersion >= 4) {
			m_OsVersionType = 3;						// NT4.0 ȏ
		}
		break;

	case VER_PLATFORM_WIN32_WINDOWS:
		m_OsVersionType = 2;							// Windows95݊
		break;

	default:
		m_OsVersionType = -1;
		break;
	}
}

COsVersion::~COsVersion()
{
}
