/*************************/
/*    SDJCmntView.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include "SDJCmntView.h"
#include "sdjcmntdoc.h"
#include "kbase.h"
#include "sdjdoc.h"
#include "sdjview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSDJCmntView

IMPLEMENT_DYNCREATE(CSDJCmntView, CSDJEditView)

CSDJCmntView::CSDJCmntView()
{
	// ftHgLOGFONT m_lf̐ݒ
	CString strSection=EDITOR_SECTION;
	LOGFONT lf;
	::GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &lf);
	CString strFaceName;
	CString strGothic="lr SVbN";
	// tHg̎w肪LB
	BOOL bFontValid=theApp.GetProfileInt(strSection,CMNT_FONT_VALID,0);
	if (bFontValid) {
		lf.lfHeight =theApp.GetProfileInt(strSection,CMNT_FONT_HEIGHT,-90);
		lf.lfWidth  =theApp.GetProfileInt(strSection,CMNT_FONT_WIDTH,0);
		lf.lfWeight =theApp.GetProfileInt(strSection,CMNT_FONT_WEIGHT,400);
		strFaceName =theApp.GetProfileString(strSection,CMNT_FONT_FACE_NAME,strGothic);
		strcpy(lf.lfFaceName,strFaceName);  // 
	}
	else {
		lf.lfHeight	=-90; // tHg̐ݒ(9 points)
		lf.lfWidth	=0;   // tHg͎ݒ
		lf.lfWeight =400; // Wl
		strcpy(lf.lfFaceName,strGothic); // 
	}
	lf.lfOutPrecision	= OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	lf.lfQuality		= DEFAULT_QUALITY;
	lf.lfPitchAndFamily = DEFAULT_PITCH;

	CFont ft;
	if (bFontValid) {
		if (ft.CreateFontIndirect(&lf)) {
			ft.GetLogFont(&m_lf);
		}
		else
			m_lf=lf;
	}
	else {
		if (ft.CreatePointFontIndirect(&lf)) {
			ft.GetLogFont(&m_lf);
		}
		else
			m_lf=lf;
	}
}

CSDJCmntView::~CSDJCmntView()
{
}

BEGIN_MESSAGE_MAP(CSDJCmntView, CSDJEditView)
	//{{AFX_MSG_MAP(CSDJCmntView)
	ON_COMMAND(ID_COMMENT_OK, OnCommentOk)
	ON_COMMAND(ID_COMMENT_DELETE, OnCommentDelete)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDJCmntView `

void CSDJCmntView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// CSDJCmntView ff

#ifdef _DEBUG
void CSDJCmntView::AssertValid() const
{
	CSDJEditView::AssertValid();
}

void CSDJCmntView::Dump(CDumpContext& dc) const
{
	CSDJEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSDJCmntView bZ[W nh

////
// w蒍߂̐ݒ
void CSDJCmntView::OnCommentOk() 
{
	CSDJCmntDoc *pSDJCmntDoc=(CSDJCmntDoc *)GetDocument();
	CKBase *pKBase=pSDJCmntDoc->GetKBase();
	PCELL *pcl=pSDJCmntDoc->GetPcell();

	pKBase->delcmnt(pcl); // ݂̃Rg폜B

	CString strText;
	GetWindowText(strText);

	int len=strText.GetLength();
	if (len > 0) {
		char *buf=(char *)memalloc(len+1);
		if (buf==NULL) return;
		strcpy(buf,strText);
		char *cp=strtok(buf,"\r\n");
		while (cp) {
			len = strlen(cp);
			if (len > 0) { // s͂ĂB
				pKBase->addcmnt(pcl,cp);
			}
			cp=strtok(NULL,"\r\n");
		}
		memfree(buf);

		CSDJView *pView=pKBase->GetView();
		CSDJDoc *pDoc=pView->GetDocument();
		pDoc->SetModifiedFlag();   // ehLgύXL Ver.5.2 '03.7.15
	}

	pSDJCmntDoc->SetModifiedFlag(FALSE);
}

////
// ߕ̍폜
void CSDJCmntView::OnCommentDelete() 
{
	CSDJCmntDoc *pSDJCmntDoc=(CSDJCmntDoc *)GetDocument();
	CKBase *pKBase=pSDJCmntDoc->GetKBase();
	PCELL *pcl=pSDJCmntDoc->GetPcell();

	// Rgݒ肳Ă(Ver.5.2 '03.7.15)
	if (pKBase->getcmnt(pcl,0)!=NULL) { 
		pKBase->delcmnt(pcl); // ݂̃Rg폜B

		CSDJView *pView=pKBase->GetView();
		CSDJDoc *pDoc=pView->GetDocument();
		pDoc->SetModifiedFlag();   // ehLgύXL(Ver.5.2 '03.7.15)
	}

	// hLg𖳏ɏ
	pSDJCmntDoc->SetModifiedFlag(FALSE);
	SendMessage(WM_COMMAND,ID_FILE_NEW_ED);
}

void CSDJCmntView::OnDestroy() 
{
	CEditView::OnDestroy(); // CSDJEditView͌Ă΂Ȃ
	
	// tHginit@CL
	CString strSection=EDITOR_SECTION;

	theApp.WriteProfileInt(strSection,CMNT_FONT_HEIGHT,m_lf.lfHeight);
	theApp.WriteProfileInt(strSection,CMNT_FONT_WIDTH,m_lf.lfWidth);
	theApp.WriteProfileInt(strSection,CMNT_FONT_WEIGHT,m_lf.lfWeight);
	CString strFaceName=m_lf.lfFaceName;
	theApp.WriteProfileString(strSection,CMNT_FONT_FACE_NAME,strFaceName);
	theApp.WriteProfileInt(strSection,CMNT_FONT_VALID,1);
}
