/**************************/
/*    SDJEditFrame.cpp    */
/**************************/
#include "stdafx.h"
#include "winsdj.h"

#include "SDJEditFrame.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSDJEditFrame

IMPLEMENT_DYNCREATE(CSDJEditFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CSDJEditFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CSDJEditFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_APP_EXIT_ED, OnAppExitEd)
	ON_WM_MOVE()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CSDJEditFrame NX̍\z/

CSDJEditFrame::CSDJEditFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	
}

CSDJEditFrame::~CSDJEditFrame()
{
}

int CSDJEditFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_SDJEDTYPE))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.SetWindowText("W");
	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// init@C`FbN
	CString strSection=EDITOR_SECTION;
	BOOL bVisible;
	// Xe[^Xo[
	bVisible=theApp.GetProfileInt(strSection,VISIBLE_EDITOR_STATUS_BAR,1);
	if (!bVisible) {
		ShowControlBar(&m_wndStatusBar,FALSE,FALSE);
	}
	// c[o[
	bVisible=theApp.GetProfileInt(strSection,VISIBLE_EDITOR_TOOL_BAR,1);
	if (!bVisible) {
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
	}

	return 0;
}

BOOL CSDJEditFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// CMainFramer[TB
	CMainFrame *pMainFrame=(CMainFrame *)AfxGetMainWnd();
	ASSERT(pMainFrame->IsKindOf(RUNTIME_CLASS(CMainFrame)));

	// EBhE̕\ʒu
	CRect rect;
	if (theApp.m_rectEditPos.IsRectEmpty()) {
		// ȑŐLȂ΃CNCAg̈悩
		::GetClientRect(pMainFrame->m_hWndMDIClient,&rect); // MDIClient

		int mx=rect.Width()/2;  // S
		int my=rect.Height()/2;
		// Ց̑傫(360*600)
		rect.right	= mx+300;
		rect.left	= mx-300;
		rect.top	= my-180;
		rect.bottom = my+180;

		CPoint &tl=rect.TopLeft();
		CPoint &br=rect.BottomRight();
		::ClientToScreen(pMainFrame->m_hWndMDIClient,&tl);
		::ClientToScreen(pMainFrame->m_hWndMDIClient,&br);
	}
	else {
		// ȑŐL΂B
		rect=theApp.m_rectEditPos;
	}

	cs.hwndParent = pMainFrame->m_hWnd; // eEBhE(C)
	cs.x=rect.left;
	cs.y=rect.top;
	cs.cx=rect.Width();
	cs.cy=rect.Height();
	cs.style &=~WS_CHILD;			   // POPUPEBhE
	cs.style |= WS_POPUP;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSDJEditFrame NX̐ff

#ifdef _DEBUG
void CSDJEditFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CSDJEditFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSDJEditFrame bZ[W nh




////
// GfB^̏I
void CSDJEditFrame::OnAppExitEd() 
{
	SendMessage(WM_CLOSE);
}

////
// EBhE
void CSDJEditFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);
	
	// r[NULL̏HƃACRAőTCYԂ
	// EBhËʒuLB
	CView *pView=GetActiveView();
	if (pView && !IsIconic() && !IsZoomed()) {
		GetWindowRect(&theApp.m_rectEditPos);
	}
}

//////
// EBhẼTCYς
void CSDJEditFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);

	// r[NULL̏HƃACRAőTCYԂ
	// EBhËʒuLB
	CView *pView=GetActiveView();
	if (pView && !IsIconic() && !IsZoomed()) {
		GetWindowRect(&theApp.m_rectEditPos);
	}
}

void CSDJEditFrame::OnDestroy() 
{
	// init@Cւ̃Z[u
	CString strSection=EDITOR_SECTION;

	BOOL bVisible;
	// Xe[^Xo[̋L
	bVisible=(m_wndStatusBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	theApp.WriteProfileInt(strSection,VISIBLE_EDITOR_STATUS_BAR,bVisible);
	// c[o[̋L
	bVisible=(m_wndToolBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	theApp.WriteProfileInt(strSection,VISIBLE_EDITOR_TOOL_BAR,bVisible);

	CFrameWnd::OnDestroy();
}
