/**************************/
/*    SDJJCmntView.cpp    */
/**************************/
#include "stdafx.h"
#include "winsdj.h"
#include "SDJJCmntView.h"
#include "sdjjcmntdoc.h"
#include <dbe.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

extern HANDLE g_hDblock;
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSDJJCmntView

IMPLEMENT_DYNCREATE(CSDJJCmntView, CSDJEditView)

CSDJJCmntView::CSDJJCmntView()
{
	// ftHgLOGFONT m_lf̐ݒ
	CString strSection=EDITOR_SECTION;
	LOGFONT lf;
	::GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &lf);
	CString strFaceName;
	CString strGothic="lr SVbN";
	// tHg̎w肪LB
	BOOL bFontValid=theApp.GetProfileInt(strSection,JCMNT_FONT_VALID,0);
	if (bFontValid) {
		lf.lfHeight =theApp.GetProfileInt(strSection,JCMNT_FONT_HEIGHT,-90);
		lf.lfWidth  =theApp.GetProfileInt(strSection,JCMNT_FONT_WIDTH,0);
		lf.lfWeight =theApp.GetProfileInt(strSection,JCMNT_FONT_WEIGHT,400);
		strFaceName =theApp.GetProfileString(strSection,JCMNT_FONT_FACE_NAME,strGothic);
		strcpy(lf.lfFaceName,strFaceName);  // 
	}
	else {
		lf.lfHeight	=-90; // tHg̐ݒ(9 points)
		lf.lfWidth	=0;   // tHg͎ݒ
		lf.lfWeight =400; // Wl
		strcpy(lf.lfFaceName,strGothic); // 
	}
	lf.lfOutPrecision	= OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	lf.lfQuality		= DEFAULT_QUALITY;
	lf.lfPitchAndFamily = DEFAULT_PITCH;

	CFont ft;
	if (bFontValid) {
		if (ft.CreateFontIndirect(&lf)) {
			ft.GetLogFont(&m_lf);
		}
		else
			m_lf=lf;
	}
	else {
		if (ft.CreatePointFontIndirect(&lf)) {
			ft.GetLogFont(&m_lf);
		}
		else
			m_lf=lf;
	}
}

CSDJJCmntView::~CSDJJCmntView()
{
}

BEGIN_MESSAGE_MAP(CSDJJCmntView, CSDJEditView)
	//{{AFX_MSG_MAP(CSDJJCmntView)
	ON_COMMAND(ID_COMMENT_OK, OnCommentOk)
	ON_COMMAND(ID_COMMENT_DELETE, OnCommentDelete)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDJJCmntView `

void CSDJJCmntView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// CSDJJCmntView ff

#ifdef _DEBUG
void CSDJJCmntView::AssertValid() const
{
	CSDJEditView::AssertValid();
}

void CSDJJCmntView::Dump(CDumpContext& dc) const
{
	CSDJEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSDJJCmntView bZ[W nh

/////
// Վ蒍߂̐ݒ
void CSDJJCmntView::OnCommentOk() 
{
	// o^
	CSDJJCmntDoc *pDoc=(CSDJJCmntDoc*)GetDocument();
	int cid; CString ckey;
	pDoc->GetCidCkey(&cid,&ckey);

	// ߕ
	CString strText;
	GetWindowText(strText);

	// Ղcao^
	CDBE Dbe;
	if (!Dbe.Open())
		return;
	CWaitCursor wcur; // v

	WaitForSingleObject(g_hDblock,INFINITE); // Db lock
	CDBF *pDbf=Dbe.GetDBF();
	pDbf->Delete(cid,(char *)(LPCTSTR)ckey);  // 悸͂܂ł̒߂B
	if (strText.GetLength()) { // f[^
		pDbf->Write(cid,(char *)(LPCTSTR)ckey,(char *)(LPCTSTR)strText);
	}
	Dbe.Close();
	ReleaseMutex(g_hDblock); // Db unlock

	pDoc->SetModifiedFlag(FALSE);
}

////
// Վ蒍߂̍폜
void CSDJJCmntView::OnCommentDelete() 
{
	// o^
	CSDJJCmntDoc *pDoc=(CSDJJCmntDoc*)GetDocument();
	int cid; CString ckey;
	pDoc->GetCidCkey(&cid,&ckey);

	CDBE Dbe;
	if (!Dbe.Open())
		return;
	CWaitCursor wcur; // v
	WaitForSingleObject(g_hDblock,INFINITE); // Db lock
	CDBF *pDbf=Dbe.GetDBF();
	pDbf->Delete(cid,(char *)(LPCTSTR)ckey);  // 폜
	Dbe.Close();
	ReleaseMutex(g_hDblock); // Db unlock

	// hLg𖳏ɏ
	pDoc->SetModifiedFlag(FALSE);
	SendMessage(WM_COMMAND,ID_FILE_NEW_ED);
}

void CSDJJCmntView::OnDestroy() 
{
	CEditView::OnDestroy(); // CSDJEditView͌Ă΂Ȃ
	
	// tHginit@CL
	CString strSection=EDITOR_SECTION;

	theApp.WriteProfileInt(strSection,JCMNT_FONT_HEIGHT,m_lf.lfHeight);
	theApp.WriteProfileInt(strSection,JCMNT_FONT_WIDTH,m_lf.lfWidth);
	theApp.WriteProfileInt(strSection,JCMNT_FONT_WEIGHT,m_lf.lfWeight);
	CString strFaceName=m_lf.lfFaceName;
	theApp.WriteProfileString(strSection,JCMNT_FONT_FACE_NAME,strFaceName);
	theApp.WriteProfileInt(strSection,JCMNT_FONT_VALID,1);
}
