/***********************/
/*    SFrameWnd.cpp    */
/***********************/
#include "stdafx.h"
#include "WinSDJ.h"
#include "SFrameWnd.h"
#include "sdjview.h"
#include "childfrm.h"
#include "childvsize.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSFrameWnd

IMPLEMENT_DYNCREATE(CSFrameWnd, CFrameWnd)

CSFrameWnd::CSFrameWnd()
{
	m_pSdjParent=NULL;
	m_iParentType=-1;
}

CSFrameWnd::~CSFrameWnd()
{
}

BEGIN_MESSAGE_MAP(CSFrameWnd, CFrameWnd)
	//{{AFX_MSG_MAP(CSFrameWnd)
	ON_WM_CLOSE()
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSFrameWnd bZ[W nh

void CSFrameWnd::OnClose() 
{
	if (theApp.m_bSDocTemplateUsing) {
		// ۑ̏C`FbN͂Ȃ悤ɂB
		// (t@CǍ񂾎CLAǖʂύX
		//  CLAƂ̂őO҂̕ۑ`FbN͂Ȃ
		//  悤ɂ)
		CDocument *pDoc=GetActiveDocument();
		ASSERT(pDoc);
		pDoc->SetModifiedFlag(FALSE);
	}
	
	CFrameWnd::OnClose(); // DestroyWindowĂ΂Ȃ
}

BOOL CSFrameWnd::PreCreateWindow(CREATESTRUCT& cs) 
{
	// ǖʂ̃I[vʒu̓CNCAg̈̒Sŗ
	// 킹B
	CMDIFrameWnd *pMDIFrame=(CMDIFrameWnd *)AfxGetMainWnd();
	if (pMDIFrame) { // ړĨANeBu̓r[
		CRect rect;
		pMDIFrame->GetClientRect(&rect); // C̃NCAg̈
		CPoint tp; // ǖʃI[vʒu(̃XN[W)
		tp.x=rect.right/2-CHILD_VIEW_XSIZE/2; if (tp.x<0) tp.x=0;
		tp.y=rect.bottom/2-CHILD_VIEW_YSIZE/2;if (tp.y<0) tp.y=0;
		pMDIFrame->ClientToScreen(&tp); // Wϊ
		cs.x=tp.x;
		cs.y=tp.y;

		cs.hwndParent = pMDIFrame->m_hWnd; // eEBhE(C)
		cs.style &=~WS_CHILD;			   // POPUPEBhE
		cs.style |= WS_POPUP;
	}
	return CFrameWnd::PreCreateWindow(cs);
}

void CSFrameWnd::OnSysCommand(UINT nID, LPARAM lParam)
{
	nID &= 0xfff0; // }XN
    if (nID==SC_MAXIMIZE) { // ő\
		// TCY(łő)
		CSDJView *pView=(CSDJView *)GetActiveView();
		pView->AdjustChildFrame();
	}
	else {
		CFrameWnd::OnSysCommand(nID,lParam);
	}
}

BOOL CSFrameWnd::DestroyWindow() 
{
	if (theApp.m_bSDocTemplateUsing) {
		theApp.m_bSDocTemplateUsing = FALSE;
		// et[LĂ鎩̋LB
		GetSdjParent()->SendMessage(WM_COMMAND,ID_SETSFRAME_NULL);
	}
	
	return CFrameWnd::DestroyWindow();
}
