/************************/
/*    SelectBoxB.cpp    */
/************************/
#include "stdafx.h"
#include "WinSDJ.h"
#include "SelectBoxB.h"
#include <mbstring.h>
#include "winsdjview.h"
#include "winsdjdoc.h"
#include "sframewnd.h"
#include "ssdjdoctemplate.h"
#include <winmemfile.h>
#include "dbeframe.h"
#include "dbeview.h"
#include "childfrm.h"
#include "winsdjtsdoc.h"
#include "kifframe.h"
#include "statusbox.h"
#include "sbasedbb.h"

/* ʊO֐錾 */
extern "C" {
void *memalloc(unsigned int);
void memfree(void *);
}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;
extern HANDLE g_hDblock;

/////////////////////////////////////////////////////////////////////////////
// CSelectBoxB _CAO

IMPLEMENT_SERIAL(CSelectBoxB, CDialog,0)

// RXgN^
CSelectBoxB::CSelectBoxB()
{
	//{{AFX_DATA_INIT(CSelectBoxB)
	m_sStesu = 1;
	m_sTesu = 1;
	m_bReverse = TRUE;
	m_iMatch = 0;
	m_iItemNum = 0;
	//}}AFX_DATA_INIT
	memset(m_uiUkm,0,sizeof(m_uiUkm));
	m_teban=-1;
	char *shgdb=GetShgdbName(); // f[^x[X
	m_FindStop.SetQuitEvent(&m_QuitEvent); // fCxg̎w

	m_pSFrame=NULL; // ՐݒSDIt[EBhE

	m_iSelNo=0;

	m_iDupMatch=0;
}

void CSelectBoxB::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectBoxB)
	DDX_Control(pDX, IDC_SEARCHEDIT, m_edSqlText);
	DDX_Control(pDX, IDC_SELECTLIST, m_SelectList);
	DDX_Text(pDX, IDC_EDIT2, m_sStesu);
	DDV_MinMaxInt(pDX, m_sStesu, 1, 999);
	DDX_Text(pDX, IDC_EDIT3, m_sTesu);
	DDV_MinMaxInt(pDX, m_sTesu, 1, 999);
	DDX_Check(pDX, IDC_REVERSE, m_bReverse);
	DDX_Radio(pDX, IDC_NOASPECT, m_iMatch);
	DDX_Text(pDX, IDC_ITEMNUM, m_iItemNum);
	DDV_MinMaxInt(pDX, m_iItemNum, 0, 999999);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelectBoxB, CDialog)
	//{{AFX_MSG_MAP(CSelectBoxB)
	ON_BN_CLICKED(IDC_SELWRT, OnSelwrt)
	ON_BN_CLICKED(IDC_SELRED, OnSelred)
	ON_BN_CLICKED(IDC_BANSET1, OnBanset1)
	ON_BN_CLICKED(IDC_BANSET2, OnBanset2)
	ON_BN_CLICKED(IDC_SEARCH, OnSearch)
	ON_LBN_DBLCLK(IDC_SELECTLIST, OnDblclkSelectlist)
 	ON_COMMAND(ID_SETSFRAME_NULL,OnSetSFrameNull)
	ON_COMMAND(ID_SELBOX_UPDATENUM,OnUpdateNum)
	ON_COMMAND(ID_SHGDB_CHANGE,OnShgdbChange)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_DUPCHK, OnDupchk)
	ON_BN_CLICKED(IDC_CMPSBASE, OnCmpSBase)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////
//  \bh

///////
// KYINFOɐݒ肷
//
void CSelectBoxB::set_kyinfo(void)
{
	m_kyinfo.match=(int)m_iMatch;
	m_kyinfo.rev=(m_bReverse)? 1:0;
	m_kyinfo.stesu=(int)m_sStesu;
	m_kyinfo.tesu=(int)m_sTesu;
	//  uiUkm̐ݒ
	for (int i=0;i<40;i++)
		m_kyinfo.uiUkm[i]=m_uiUkm[i];
	//  teban̐ݒ
	m_kyinfo.teban=m_teban;
}

// VACY
void CSelectBoxB::Serialize(CArchive& ar) 
{
	if (ar.IsStoring())
	{	// R[h̕ۑ
		ar << (WORD)m_iMatch;
		ar << (WORD)m_bReverse;
		ar << (WORD)m_sStesu;
		ar << (WORD)m_sTesu;
		for (int i=0;i<40;i++) {
			ar << (WORD)m_uiUkm[i];
		}
		ar << (WORD)m_teban;
		m_DbrFindList.Serialize(ar);
		ar << m_strSqlText;
		ar << (WORD)m_iSelNo;
		ar << (WORD)m_iDupMatch;
	}
	else
	{	// R[h̓ǂݍ
		WORD w;
		ar >> w; m_iMatch=(int)w;
		ar >> w; m_bReverse=(BOOL)w;
		ar >> w; m_sStesu=(short)w;
		ar >> w; m_sTesu=(short)w;
		for (int i=0;i<40;i++) {
			ar >> w; m_uiUkm[i]=(unsigned int)w;
		}
		ar >> w; m_teban=(int)w;
		m_DbrFindList.RemoveAll();
		m_DbrFindList.Serialize(ar);
		ar >> m_strSqlText;
		// Version 5.0ɂĒǉ(1998.5.17)
		TRY {
			ar >> w; m_iSelNo=(int)w;
		}
		CATCH(CException, e) {
			TRACE("Âǂݍ݂܂\n");
			m_iSelNo=0;
		}
		END_CATCH

		// Version 5.1eɂĒǉ(2003.7)
		TRY {
			ar >> w; m_iDupMatch=(int)w;
		}
		CATCH(CException, e) {
			TRACE("Âǂݍ݂܂\n");
			m_iDupMatch=0;
		}
		END_CATCH
	}
}

// DBBʂ\Xg(m_SelectList)ɔf
void CSelectBoxB::set_SelectList(void)
{
	CDBB Dbb; // ΋ǂca
	char dispbuf[512];
	CList <DBRNO, DBRNO&> DbrnoList; // DBBʍƃXg
	POSITION pos;
	DBRNO Dbrno;
	CWaitCursor waitcr;  // v

	m_SelectList.ResetContent(); // SelectListɂB
	// INFINITEő҂B
	// 猏̌ʂǂݍł鎞DbLockModal()WM_CLOSE
	// 󂯂MFCASSERTĂ܂B(InitDialogłModalLoop͑ʖ)
	WaitForSingleObject(g_hDblock,INFINITE); // DB lock

	if (Dbb.Open()) { // ΋ǂcãI[v
		Dbb.DBFOpen(); // ߂caI[vB
		pos=m_DbrFindList.GetHeadPosition();
		while (pos) {
			Dbrno=m_DbrFindList.GetNext(pos);
			// DBRNOɊY΋ǃR[hǂށB
			int rc=Dbb.ReadByDbrno(Dbrno.dbrno);
			if (rc==E$OK) { // ɓǂ߂
				Dbb.set_disp_mrec(dispbuf,24,18); // \̐
				m_SelectList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DbrnoList.AddTail(Dbrno); // ƃXgɒǉ
			}
		}
		Dbb.DBFClose(); // ߂cãN[Y
		Dbb.Close(); // ΋ǂcãN[Y
		// Xg{bNX̃J[\ݒ
		int iSelNo=m_SelectList.GetCount();
		if (iSelNo) {
			if (m_iSelNo>=iSelNo)
				m_iSelNo=0;  // 擪ɐݒ
			m_SelectList.SetCurSel(m_iSelNo); 
		}
	}
	ReleaseMutex(g_hDblock); // DB unlock

	// DbrnoList̓em_DbrFindList֔fB
	m_DbrFindList.RemoveAll(); // XgɂB
	pos=DbrnoList.GetHeadPosition();
	while (pos) {
		// DbrnoListm_DbrFindListփRs[
		Dbrno=DbrnoList.GetNext(pos);
		m_DbrFindList.AddTail(Dbrno); 
	}
	DbrnoList.RemoveAll(); // DbrnoList
		
	UpdateItemNum();			// ڐ\XV
	GotoDlgCtrl(&m_SelectList); // 
}

/////
// O񌟍̓ǂݏo
//   ߂l:I[v
BOOL CSelectBoxB::ReadPrevInfo(void)
{
	CFile file;
	BOOL success=FALSE;

	char *shgdb=GetShgdbName(); // f[^x[X
	m_strFindFile.Format("%s%s",shgdb,SDJFIND_FILE);
	if (file.Open(m_strFindFile,CFile::modeRead)) {
		CSDJArchive ar(&file,CArchive::load);
		Serialize(ar);
		ar.Close();
		file.Close();
		success=TRUE;
	}
	return success;
}

/////
/// ڐ\̍XV
void CSelectBoxB::UpdateItemNum()
{
	m_iItemNum=m_SelectList.GetCount();
	UpdateData(FALSE);
}

///////
// O񌟍Ƃĕۑ
void CSelectBoxB::WritePrevInfo()
{
	char *shgdb=GetShgdbName(); // f[^x[X
	m_strFindFile.Format("%s%s",shgdb,SDJFIND_FILE);
	CFile file;
	// t@C̃I[v
	if (file.Open(m_strFindFile,CFile::modeReadWrite|CFile::modeCreate)) {
		CSDJArchive ar(&file,CArchive::store);
		Serialize(ar); // VA
		ar.Close();
		file.Close();
	}
}

//////
// ʃXg̒
// ʃXg̒ő΋ǂcaɓo^ĂȂ͍̂폜B
void CSelectBoxB::SlimListInfo()
{
	CDBB Dbb; // ΋ǂca
	CList <DBRNO, DBRNO&> DbrnoList; // DBBʍƃobt@
	POSITION pos;
	DBRNO Dbrno;

	if (Dbb.Open()) { // ΋ǂcãI[v
		Dbb.DBFOpen(); // ߂caI[vB
		pos=m_DbrFindList.GetHeadPosition();
		while (pos) {
			Dbrno=m_DbrFindList.GetNext(pos);
			// DBRNOɊY΋ǃR[hǂށB
			int rc=Dbb.ReadByDbrno(Dbrno.dbrno);
			if (rc==E$OK) { // ɓǂ߂炻̓eLB
				DbrnoList.AddTail(Dbrno);
			}
		}
		Dbb.DBFClose(); // ߂cãN[Y
		Dbb.Close(); // ΋ǂcãN[Y
	}

	// DbrnoList̓em_DbrFindList֔fB
	m_DbrFindList.RemoveAll(); // XgɂB
	pos=DbrnoList.GetHeadPosition();
	while (pos) {
		// DbrnoListm_DbrFindListփRs[
		Dbrno=DbrnoList.GetNext(pos);
		m_DbrFindList.AddTail(Dbrno); 
	}
	DbrnoList.RemoveAll(); // DbrnoList
}

///
// Rg[ɐݒ肷B
void CSelectBoxB::SetEdSqlText()
{
	// ̃ftHg
	if (m_strSqlText.IsEmpty()) {
		m_strSqlText.Format("%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n",
			"#",
			"#擪'#'̓Rg",
			"#΋ǎ matches \"H\" and ",
			"#΋ǎ matches \"J\" and ",
			"#^   matches \"q\" and ",
			"#order by ΋Ǔ");
	}
	m_edSqlText.SetWindowText(m_strSqlText); // EditBOXɒl𔽉f
}

/////////////////////////////////////////////////////////////////////////////
// CSelectBoxB bZ[W nh

BOOL CSelectBoxB::OnInitDialog() 
{
	ReadPrevInfo(); // O񌟍̓ǂݏo

	CDialog::OnInitDialog();

	theApp.m_bSelectBoxBUsing=TRUE; // caEI
	theApp.m_pSelectBoxB=this;


	// d̏(t̏ԂXV)
	UpdateDupMatch(FALSE);
	
	// ̐ݒ
	SetEdSqlText();

	// ʃXgm_DbrFindList̓e\Xg{bNXm_SelectList
	// ɔfB
	set_SelectList();

	CenterWindow(); // |bvAbvʒuCEBhE̒SɑB

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// ΋ǑI
void CSelectBoxB::OnOK() 
{
	int idx=m_SelectList.GetCurSel(); // ݑIĂ镶̃CfbNXl
	if (idx==LB_ERR)
		return ; // IꂽR[hȂΉɏI

	// Iꂽ΋ǂ̑΋ǔԍʃXg狁߂B
	DBRNO Dbrno;
	POSITION pos=m_DbrFindList.GetHeadPosition();
	for (int i=0;i<=idx;i++) Dbrno=m_DbrFindList.GetNext(pos);

	// ΋ǔԍ̑΋ǃR[hhLgɓǍ
	CWinSDJDoc *pDoc=GetSDJDocument();
	if (pDoc->SaveModified()) { // Modified`FbNۑ
		CWaitCursor wait; // v
		CWinSDJView *pView=(CWinSDJView *)pDoc->GetSDJView();

		// ߃{bNXJĂ
		pView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

		CWaitCursor wcur; // v
		// ŃhLgƃ}YĈŃ[_[v͎gȂ
		WaitForSingleObject(g_hDblock,INFINITE);  // Db lock
		pDoc->ReadDbbInfo(Dbrno); // ΋DBǂݍ
		ReleaseMutex(g_hDblock);  // Db unlock

		pDoc->SetModifiedFlag(FALSE);

		m_iSelNo=idx;    // ǂݏoꂽIԍ̍XV
		WritePrevInfo(); // Ƃ̋L

		if (pView->GetGuideFrame()!=NULL) // ǖʕ\JĂ
			pView->GetGuideFrame()->Invalidate();
		if (pView->GetSubFrame()!=NULL) // TuEBhEJĂ
			pView->GetSubFrame()->Invalidate();
		pView->Invalidate(); // \XV

		// ՑJĂeXV
		if (theApp.m_bDbeUsing) {
			CDbeFrame *pDbeFrame=pView->GetDbeFrame();
			if (pDbeFrame) { // ̃r[ՑJĂ
				CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
				pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
			}
		}

		// JĂe
		CKifFrame *pKifFrame=pView->GetKifFrame();
		if (pKifFrame!=NULL) {
			pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
		}
	}


	// [hX_CAO{bNX̏ꍇEndDialog()(CDialog::OnOK())
	// Ă΂ȂŒDestroyWindow()ĂԁB
	DestroyWindow();
}

// ۑ
void CSelectBoxB::OnSelwrt() 
{
	if (UpdateData(TRUE)) { // ̓f[^̎荞(]OK)
		UpdateDupMatch(TRUE); // d̎荞
		CFileDialog fileDialog(FALSE, // 
			"dj1",			// ftHg̊gq
			m_strFindFile,	// ftHg̃t@C
			// ǂݏopt@C͑ΏۊOA㏑mFL
			(DWORD)(OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT),
			" (*.dj1)|*.dj1||"); // tB^[

		BOOL bRet=fileDialog.DoModal(); // Dialog̎s
		if (bRet==IDOK) {				// IDOKȂA
			m_strFindFile=fileDialog.GetPathName(); // t@C̎擾
			CFile file;
			// t@C̃I[v
			if (file.Open(m_strFindFile,CFile::modeReadWrite|CFile::modeCreate)) {
				m_edSqlText.GetWindowText(m_strSqlText); // o
				CSDJArchive ar(&file,CArchive::store);
				Serialize(ar); // VA
				ar.Close();
				file.Close();
			}
		}
	}
}

// ǂݏo
void CSelectBoxB::OnSelred() 
{
	CFileDialog fileDialog(TRUE, // ǂݏo
		"dj1",			// ftHg̊gq
		m_strFindFile,	// ftHg̃t@C
		// ǂݏopt@C͑ΏۊOA㏑mFL
		(DWORD)(OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT),
		" (*.dj1)|*.dj1||"); // tB^[

	BOOL bRet=fileDialog.DoModal(); // Dialog̎s
	if (bRet==IDOK) {				// IDOKȂA
		m_strFindFile=fileDialog.GetPathName(); // t@C̎擾
		CFile file;
		// t@C̃I[v
		if (file.Open(m_strFindFile,CFile::modeRead)) {
			CSDJArchive ar(&file,CArchive::load);
			Serialize(ar); // VA
			ar.Close();
			file.Close();
			UpdateData(FALSE); // ǂݏolDialogɔf
			UpdateDupMatch(FALSE); // d̔f
			SetEdSqlText();  // EditBoxɂf
			set_SelectList(); // ǂݏoʂR[h̕\XgɔfB

			// ǂݏoO񌟍Ƃĕۑ
			WritePrevInfo();
		}
	}
}

// VK
void CSelectBoxB::OnBanset1() 
{
	if (UpdateData(TRUE)==0) // DDX`FbNG[
		return;

	if (m_iMatch==0) {
		AfxMessageBox("uǖʎwȂv̎͐VKǖʂ̓͂͂ł܂B");
		return;
	}

    // 炪ՐݒSDIt[EBhE̐

	// ɊJnς݂ȂȂɂȂB
	if (theApp.m_bSDocTemplateUsing) {
		AfxMessageBox("Ֆʂ̐ݒ͓ɂQʂ͂ł܂");
		return ;
	}
	theApp.m_bSDocTemplateUsing=TRUE;

	CSDJDoc *pDocument=GetSDJDocument(); 
	// Cǖʂ̃t@Co(t@C)
	CWinMemFile File;
	CSDJArchive arOut(&File,CArchive::store);
	// ̃_CAÕhLg̋ǖʂt@Co
	pDocument->WriteBaninfo(arOut);
	arOut.Close();

	// SDIhLgt[̍쐬
	CSDJDoc *pDoc=theApp.m_pSDocTemplate->OpenDocumentFile(NULL);
	File.Seek(0L,CFile::begin); // t@C擪Seek
	CSDJArchive arIn(&File,CArchive::load);
	pDoc->ReadBaninfo(arIn); // Ֆʂ̓Ǎ
	arIn.Close();
	pDoc->SetTitle("VK"); // SDĨ^Cg

	// SDĨt[EBhE̐et[EBhẼ_CAOEBhE
	// ɐݒ肷B
	// SDI t[EBhE
	CSFrameWnd *pSFrameWnd=(CSFrameWnd *)theApp.m_pSDocTemplate->GetFrameWnd();
	// ̃_CAOEBhESDĨt[EBhEɃNB
	pSFrameWnd->SetSdjParent(this);
	// hLg̃^CvZbg
	if (pDocument->IsKindOf(RUNTIME_CLASS(CWinSDJDoc)))
		pSFrameWnd->SetParentType(0); 
	else if (pDocument->IsKindOf(RUNTIME_CLASS(CWinSDJTSDoc)))
		pSFrameWnd->SetParentType(1);

	// SDIt[EBhẼ_CAOEBhE̎qEBhEƂċLB
	SetSFrame(pSFrameWnd);
}

// C
void CSelectBoxB::OnBanset2() 
{
	if (UpdateData(TRUE)==0) // DDX`FbNG[
		return;

	if (m_iMatch==0) {
		AfxMessageBox("uǖʎwȂv̎͋ǖʂ̏C͂͂ł܂B");
		return;
	}
    // 炪ՐݒSDIt[EBhE̐

	// ɊJnς݂ȂȂɂȂB
	if (theApp.m_bSDocTemplateUsing) {
		AfxMessageBox("Ֆʂ̐ݒ͓ɂQʂ͂ł܂");
		return ;
	}
	theApp.m_bSDocTemplateUsing=TRUE;

	// Cǖʂ̃t@Co
	CSDJDoc WorkDocument;			// Cǖʏo͍ƗphLg
	CKBase *pKBase=WorkDocument.GetKBase(); // ƗpKBase
	CBform Bform;				    // ƗpBform;
	Bform.ImportFrom(m_uiUkm);      // ݂̎wǖʏ(O񌟍.DJ1)B`ցB
	WorkDocument.DeleteContents();  // hLg͕zuŏĂ̂łZbgB
	pKBase->setbtype(&Bform);       // ̋ǖʂƗpKBaseɃZbg
	pKBase->setturn(m_teban);       // ݂̎wǖʏ̎ԂƗpKBaseցB

	// VKǖʂ̃t@Co(t@C)
	CWinMemFile File;
	CSDJArchive arOut(&File,CArchive::store);
	WorkDocument.WriteBaninfo(arOut); // ƗphLg̏t@Co
	arOut.Close();

	// SDIhLgt[̍쐬
	CSDJDoc *pDoc=theApp.m_pSDocTemplate->OpenDocumentFile(NULL);
	File.Seek(0L,CFile::begin); // t@C擪Seek
	CSDJArchive arIn(&File,CArchive::load);
	pDoc->ReadBaninfo(arIn); // Ֆʂ̓Ǎ
	arIn.Close();
	pDoc->SetTitle("C"); // SDĨ^Cg

	// SDĨt[EBhE̐et[EBhẼ_CAOEBhE
	// ɐݒ肷B
	// SDI t[EBhE
	CSFrameWnd *pSFrameWnd=(CSFrameWnd *)theApp.m_pSDocTemplate->GetFrameWnd();
	// ̃_CAOEBhESDĨt[EBhEɃNB
	pSFrameWnd->SetSdjParent(this);
	CSDJDoc *pDocument=GetSDJDocument();
	// hLg̃^CvZbg
	if (pDocument->IsKindOf(RUNTIME_CLASS(CWinSDJDoc)))
		pSFrameWnd->SetParentType(0); 
	else if (pDocument->IsKindOf(RUNTIME_CLASS(CWinSDJTSDoc)))
		pSFrameWnd->SetParentType(1);
	// SDIt[EBhẼ_CAOEBhE̎qEBhEƂċLB
	SetSFrame(pSFrameWnd);
}

/***********************
 *   f̂ (ƂƂ񂲂ƂȂ(^^;)

 OnSearch() ̃C
 -----------------------
  // Jn(D揇ʂ͂Pi)
  CWinThread *pFindThread=AfxBeginThread(DbbFindThread,this,
    THREAD_PRIORITY_BELOW_NORMAL);
  m_FindStop.DoModal(); // f_CAO{bNX
  WaitForSingleObject(m_EndThread,INFINITE); // Xbh̏ImF(QdNh~)
  <<<<<<  C͂Ŏ~܂B ̓XbhŎsB >>>>>>>


     CFindStop::m_pEvent <============= SelectBoxB()ŃZbg ((A)̏)()
                             CFindStop::SetQuitEvent(&m_QuitEvent)
  <<<<< Xbh̑O  >>>>>
     CDBB::h_quit <=============== Xbh̑OɂăZbg((B)̏)
 	                   pBoxB->m_QuitEvent.ResetEvent();
                       CDBB::SetQuitObject(pBoxB->m_QuitEvent)
  <<<<  f̖t  >>>>
	 CDBB::h_quit <===========CFindStop::OnButtonStop()ŒfCxgZbg--(A)
			           m_pEvent->SetEvent()  ~~~~~~~~~~~~~~~
	         ->CDBB::cmd_ls_judge()Quit -----(B)
			       if (WaitForSingleObject(h_quit,0)==WAIT_OBJECT_0) ....
				       (f)
	         ->CDBB::cmd_ls_1st/2nd()Quit
	         ->CDBB::FindFirst/Next()Quit
			        ~~~~~~~~~~~~~~~~~~~~~~~
     RSDB32::iQuitObject  <====== CFindStop::OnButtonStop()ŒfCxgZbg
                             SqlSetQuit(1)   ~~~~~~~~~~~~~~
	         ->SqlSeletFrom() Quit
			       if (iQuitObject) ...
				      (f)
			 ->CDBB::cmd_ls_orderby_1st/2nd()Quit
	         ->CDBB::FindFirst/Next()Quit
			        ~~~~~~~~~~~~~~~~~~~~~~~

  <<< Xbh CDBB::FindFirst/Next()QuitƏI >>>
  Xbh̏I
  ------------------
   pBoxB->m_FindStop.SendMessage(WM_CLOSE); // f_CAO{bNX̏
   pBoxB->m_EndThread.SetEvent(); // XbhICxg

  <<<<< 烁CĊJ >>>>
  WaitForSingleObject(m_EndThread,INFINITE); // Xbh̏ImF(QdNh~)
 */

// sXbh֐
static UINT DbbFindThread(LPVOID pParam)
{
	CSelectBoxB  *pBoxB=(CSelectBoxB *)pParam;
	CDBB Dbb;

	Dbb.SetQuitObject((HANDLE)pBoxB->m_QuitEvent); // fCxg̐ݒ

	int counter=0; // \XVJE^
	char dispbuf[512];
	char *strSql=(char *)(LPCTSTR)pBoxB->m_strSqlText;
	// ̓CDoModal()ő҂Ă̂WM_CLOSE̓ubNB
	// ă[_[vő҂B
	if (DbLockModal()) { // Db lock
		int found=Dbb.FindFirst(strSql,&pBoxB->m_kyinfo); // ŏ̃R[h{
		// R[hȂȂ邩ACxg(m_QuitEvent)܂Ń[vB
		while (found>=0) {
			if (found) {
				Dbb.set_disp_mrec(dispbuf,24,18); // \̐
				pBoxB->m_SelectList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DBRNO Dbrno=Dbb.GetDbrno(); // DBRNO̎擾
				pBoxB->m_DbrFindList.AddTail(Dbrno); // Xg֕ۑ
				// ڐ\XV (Xbh璼ڊ֐ĂԂƃfobO
				// [hASSERTƂȂ̂łނȂbZ[Wgp)
				if ((++counter % 10)==0) // 101\(͒x)B
					pBoxB->PostMessage(WM_COMMAND,ID_SELBOX_UPDATENUM);
			}
			found=Dbb.FindNext(&pBoxB->m_kyinfo); // ̃R[h{
		}
		Dbb.FindExit(&pBoxB->m_kyinfo); // I
		pBoxB->SetSelNo(0);             // IʒũZbg
		pBoxB->WritePrevInfo();			// ʂ"O񌟍"Ƃĕۑ
		ReleaseMutex(g_hDblock);		// Db unlock
	}
	pBoxB->PostMessage(WM_COMMAND,ID_SELBOX_UPDATENUM); // \

	pBoxB->m_FindStop.PostMessage(WM_CLOSE); // f_CAO{bNX̏
	return 0;
}

// s
void CSelectBoxB::OnSearch() 
{
	if (!UpdateData(TRUE))
		return ;

	UpdateDupMatch(TRUE);  // d̓Ǎ

	set_kyinfo(); // KYINFOɐݒ肷
	m_edSqlText.GetWindowText(m_strSqlText); // o

	m_SelectList.ResetContent(); // Xg{bNXɂB
	m_DbrFindList.RemoveAll();   // DBʂɂB
	UpdateItemNum();			// ڐ\XV

	// ɂ͏fBNgChange DirectoryB
	char szCurrDir[MAX_PATH];
	GetCurrentDirectory(sizeof szCurrDir,szCurrDir); // JgDir̎擾
	char *shgdb=GetShgdbName();
	if (SetCurrentDirectory(shgdb)==FALSE) {
		CString strMes;
		strMes.Format("f[^x[X(%s)Ił܂B",shgdb);
		AfxMessageBox(strMes);
		return;
	}
	
	CSDJView *pView=GetSDJDocument()->GetSDJView();
	CChildFrame *pChildFrame=(CChildFrame *)pView->GetParentFrame();
	ASSERT(pChildFrame->IsKindOf(RUNTIME_CLASS(CChildFrame)));
	pChildFrame->SetCloseLock(TRUE); // et[N[YbN
	m_QuitEvent.ResetEvent();   // fCxg̃Zbg
	// Jn(D揇ʂ͂Pi)
	CWinThread *pFindThread=AfxBeginThread(DbbFindThread,this,
		THREAD_PRIORITY_BELOW_NORMAL);
	m_FindStop.DoModal(); // f_CAO{bNX
	pChildFrame->SetCloseLock(FALSE); // et[̃bN

	// Xg{bNX̃J[\ݒ
	if (m_SelectList.GetCount()) {
		m_SelectList.SetCurSel(m_iSelNo); // 擪ɐݒ
	}
	GotoDlgCtrl(&m_SelectList); // 

	// fBNgɖ߂B
	SetCurrentDirectory(szCurrDir); 
}


// \Xg{bNX̕񂪃_uNbNꂽƂ
void CSelectBoxB::OnDblclkSelectlist() 
{
	OnOK();
}

BOOL CSelectBoxB::DestroyWindow() 
{
	// MFC hLg
    // CWnd IuWFNgɌѕtꂽ Windows ̃EBhEj܂B
	// DestroyWindow o֐̓EBhEANeBuɂ̓tH[JX
	// 菜߂ɓKȃbZ[W𑗂܂B̑ɁAEBhẼ
	// j[̔jAAvP[V L[̃tbVAo߂̃^C}
	// jANbv{[hL̏ACWnd 擪Ȃ΃Nbv{[h 
	// r[A `FC̔js܂B̊֐̓EBhE 
	// WM_DESTROY  WM_NCDESTROY bZ[W𑗂܂B̊֐ CWnd 
	// IuWFNgj邱Ƃ͂܂BEBhEeEBhÊƂA
	// qEBhE͐eEBhEjƂɎIɔj܂B
	// DestroyWindow o֐́A܂qEBhEjǍł̃EB
	// hEj܂B
    // DestroyWindow o֐ CDialog::Create ō쐬ꂽ[hX _C
	// AO {bNXj܂B
	return CDialog::DestroyWindow();
}

// SDIt[EBhE̋LNABՐݒSDIEBhE
// ̏IR}hɂČĂ΂B
void CSelectBoxB::OnSetSFrameNull()
{
	SetSFrame(NULL);
}

// IuWFNg̔j([hX_CAO{bNX̏ꍇ)
//
// q[vɎg蓖Ă悤ɐ݌vĂNXł́Ao֐
//  PostNcDestroy I[o[Ch "delete this" s킹܂B̃Xe
// [gg C++ IuWFNgɑΉtĂ C++ ׂĉ
// ܂B(eNjJm[g17 EBhEIuWFNg̔j)
void CSelectBoxB::PostNcDestroy() 
{
	delete this;
}

// [hX_CAO{bNX̏ꍇEndDialog()(CDialog::OnCancel())
// Ă΂ȂŒDestroyWindow()ĂԁB
void CSelectBoxB::OnCancel() 
{
	DestroyWindow();
}

// SDIt[EBhE̋ǖʐݒIbZ[W
void CSelectBoxB::BansetCommand(CMemLump *lpMemLump)
{
	// 󂯎t@CƂănhB
	CWinMemFile File;
	// GrowSize=0ɂƃt@CTCYm_SizeɂȂ
	File.Attach(lpMemLump->m_lpMem,lpMemLump->m_Size);
	delete lpMemLump;

   // ݂̌ǖʂt@C͂B
   CSDJDoc WorkDocument; // ǖʓǂݏoƗpɃhLgpӁB
   CSDJArchive arIn(&File,CArchive::load);
   WorkDocument.ReadBaninfo(arIn); // hLg̏B

   CKBase *pKBase=WorkDocument.GetKBase(); // KBase̎擾
   CBform *pBform=pKBase->btype(); // Bform̎擾
   pBform->ExportTo(m_uiUkm); // ΋ǖ
   m_teban=pKBase->turn();    // 
}

/////
// ڐ\XVbZ[W
void CSelectBoxB::OnUpdateNum()
{
	UpdateItemNum();
}

BOOL CSelectBoxB::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if (LOWORD(wParam)==ID_BANSET_COMMAND) {
		// BANSET_COMMAND
		CMemLump *lpMemLump=(CMemLump*)lParam;
		BansetCommand(lpMemLump); // BansetCommand
		return 1;
	}
	
	return CDialog::OnCommand(wParam, lParam);
}

/////////
/// f[^x[X̕ύXʒm
void CSelectBoxB::OnShgdbChange()
{
	// ϐ̍ď
	m_sStesu = 1;
	m_sTesu = 1;
	m_bReverse = TRUE;
	m_iMatch = 0;
	m_iItemNum = 0;
	memset(m_uiUkm,0,sizeof(m_uiUkm));
	m_teban=-1;
	m_strSqlText.Empty();
	m_DbrFindList.RemoveAll();

	ReadPrevInfo(); // O񌟍̓ǂݏo
	SetEdSqlText(); // ̐ݒ

	UpdateData(FALSE); // _CAO{bNX̕\XV
	UpdateDupMatch(FALSE);  // d̍XV

	// ʃXgm_DbrFindList̓e\Xg{bNXm_SelectList
	// ɔfB
	set_SelectList();
}

void CSelectBoxB::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// ՐݒSDIEBhEJĂ炱B
	if (GetSFrame()) {
		GetSFrame()->SendMessage(WM_CLOSE);
	}

	theApp.m_bSelectBoxBUsing=FALSE; // caEII
	theApp.m_pSelectBoxB=NULL;
}

// dXbh֐
static UINT DbbDupchkThread(LPVOID pParam)
{
	CSelectBoxB  *pBoxB=(CSelectBoxB *)pParam;
	CDBB Dbb;

	Dbb.SetQuitObject((HANDLE)pBoxB->m_QuitEvent); // fCxg̐ݒ

	int counter=0; // \XVJE^
	char dispbuf[512];
	char *strSql=(char *)(LPCTSTR)pBoxB->m_strSqlText;
	// ̓CDoModal()ő҂Ă̂WM_CLOSE̓ubNB
	// ă[_[vő҂B
	if (DbLockModal()) { // Db lock
		// ŏ̃R[h{
		int found=Dbb.DupchkFirst(strSql,&pBoxB->m_kyinfo, pBoxB->m_iDupMatch); 
		// R[hȂȂ邩ACxg(m_QuitEvent)܂Ń[vB
		while (found>=0) {
			if (found) {
				Dbb.set_disp_mrec(dispbuf,24,18); // \̐
				pBoxB->m_SelectList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DBRNO Dbrno=Dbb.GetDbrno(); // DBRNO̎擾
				pBoxB->m_DbrFindList.AddTail(Dbrno); // Xg֕ۑ
				// ڐ\XV (Xbh璼ڊ֐ĂԂƃfobO
				// [hASSERTƂȂ̂łނȂbZ[Wgp)
				if ((++counter % 10)==0) // 101\(͒x)B
					pBoxB->PostMessage(WM_COMMAND,ID_SELBOX_UPDATENUM);
			}
			found=Dbb.DupchkNext(); // ̃R[h{

			if (WaitForSingleObject((HANDLE)pBoxB->m_QuitEvent,0)==WAIT_OBJECT_0) {
				break; // fI
			}
		}
		Dbb.DupchkExit();                // I
		pBoxB->SetSelNo(0);          // IʒũZbg
		pBoxB->WritePrevInfo();		 // ʂ"O񌟍"Ƃĕۑ
		ReleaseMutex(g_hDblock);	// Db unlock
	}
	pBoxB->PostMessage(WM_COMMAND,ID_SELBOX_UPDATENUM); // \

	pBoxB->m_FindStop.PostMessage(WM_CLOSE); // f_CAO{bNX̏
	return 0;
}

////////////
// d ('03.06.14 added by Ra)
//    iSQLjŎw肳ꂽ΋ǊΏۂɁA
//    dAɕ\B
//    ǖʎw͖B ʂ̕ۑ͉\B
void CSelectBoxB::OnDupchk() 
{
	if (!UpdateData(TRUE))
		return ;

	UpdateDupMatch(TRUE); // d̓Ǎ

	set_kyinfo(); // KYINFOɐݒ肷
	m_edSqlText.GetWindowText(m_strSqlText); // o

    // ǖʎw肪Lx𔭂AɂB(Ōɖ߂)
	int i_match=m_kyinfo.match;
	if (i_match!=0) {
        AfxMessageBox("d́uǖʎwv͖ł");
		m_kyinfo.match=0;
	}

	m_SelectList.ResetContent(); // Xg{bNXɂB
	m_DbrFindList.RemoveAll();   // DBʂɂB
	UpdateItemNum();			// ڐ\XV

	// ɂ͏fBNgChange DirectoryB
	char szCurrDir[MAX_PATH];
	GetCurrentDirectory(sizeof szCurrDir,szCurrDir); // JgDir̎擾
	char *shgdb=GetShgdbName();
	if (SetCurrentDirectory(shgdb)==FALSE) {
		CString strMes;
		strMes.Format("f[^x[X(%s)Ił܂B",shgdb);
		AfxMessageBox(strMes);
		return;
	}
	
	CSDJView *pView=GetSDJDocument()->GetSDJView();
	CChildFrame *pChildFrame=(CChildFrame *)pView->GetParentFrame();
	ASSERT(pChildFrame->IsKindOf(RUNTIME_CLASS(CChildFrame)));
	pChildFrame->SetCloseLock(TRUE); // et[N[YbN
	m_QuitEvent.ResetEvent();   // fCxg̃Zbg
	// Jn(D揇ʂ͂Pi)
	CWinThread *pFindThread=AfxBeginThread(DbbDupchkThread,this,
		THREAD_PRIORITY_BELOW_NORMAL);
	m_FindStop.DoModal(); // f_CAO{bNX
	pChildFrame->SetCloseLock(FALSE); // et[̃bN

	// Xg{bNX̃J[\ݒ
	if (m_SelectList.GetCount()) {
		m_SelectList.SetCurSel(m_iSelNo); // 擪ɐݒ
	}
	GotoDlgCtrl(&m_SelectList); // 


	// ǖʎw肪L猳ɖ߂
	if (i_match!=0) {
		m_kyinfo.match=i_match;
	}
	
	
	// fBNgɖ߂B
	SetCurrentDirectory(szCurrDir); 
}

// m_iDupMatch<->RadiotDDX
//   hNXCSelectBoxCł͏dw(IDC_DUPRADIO1,2)Ȃ̂
//   NXCSelectBoxBłDDXgȂB]ĎŐ䂷B
//    bInputData 
//      TRUE :    IDC_DUPRADIO1,2̏Ԃm_iDupMatchɓǂݍ
//       FALSE:   m_iDupMatch̃f[^IDC_DUPRADIO1,2̏ԂɔfB

void CSelectBoxB::UpdateDupMatch(BOOL bInputData)
{
	if (GetDlgItem(IDC_DUPRADIO1)==NULL)
		return; // dw肪`ĂȂB
	
    if (bInputData) {
		if (GetCheckedRadioButton(IDC_DUPRADIO1, IDC_DUPRADIO2)==IDC_DUPRADIO2)
			m_iDupMatch=1;
		else 
			m_iDupMatch=0;
	}
	else {
		if (m_iDupMatch==0)
			CheckRadioButton(IDC_DUPRADIO1, IDC_DUPRADIO2, IDC_DUPRADIO1);
		else
			CheckRadioButton(IDC_DUPRADIO1, IDC_DUPRADIO2, IDC_DUPRADIO2);
	}
}


// bZ[W̕\
static void OutMessage(CStatusBox *pBox, const char *cp)
{
	// bZ[W̕\
	pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE, (LPARAM)(char *)cp);
}

///////
// wrXbh
static UINT CompareSBaseThread(CStatusBox *pBox, CEvent *pEvent, LPARAM lParam)
{
	int i;

	CSelectBoxB *pDlg=(CSelectBoxB *)lParam;

	int idx=pDlg->m_SelectList.GetCurSel(); // ݑIĂ镶̃CfbNXl
	if (idx==LB_ERR)
		return 0; // IꂽR[hȂΉɏI(ǂݏoŃ`FbNς)

	// Iꂽ΋ǂ̑΋ǔԍʃXg狁߂B
	DBRNO Dbrno;
	POSITION pos=pDlg->m_DbrFindList.GetHeadPosition();
	for (i=0;i<=idx;i++) Dbrno=pDlg->m_DbrFindList.GetNext(pos);

	// ΋ǔԍ̑΋ǃR[hǍ
	CSBaseDbb SBDbb1; Dbrno.tesu=0; // ǖʂœǂ
	// ŃhLgƃ}YĈŃ[_[v͎gȂ
	WaitForSingleObject(g_hDblock,INFINITE);  // Db lock
	SBDbb1.ReadDbb(Dbrno); // ΋DBǂݍ
	ReleaseMutex(g_hDblock);  // Db unlock

	// obt@Ǎ
	CSBaseDbb SBDbb2;
	CWinSDJDoc *pDoc=pDlg->GetSDJDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pKBase->CopySBase(&SBDbb2,TRUE,FALSE); // ׂăRs[
	while (SBDbb2.backmove2()>0); // ǖʂ

	// rB
	int rc=SBDbb2.CompareSBase(SBDbb1);
	CString strMes;
	if (rc==0) {
		strMes.Format("v܂B");
		OutMessage(pBox, strMes);
	}
	if (rc==-1) { // Ⴂ
		strMes.Format("Ⴂ܂BP̊Ƒ͔̊rł܂B");
		OutMessage(pBox, strMes);
	}
	if (rc==-2)  { // ǖʈႢ
		strMes.Format("ǖ(܁A)Ⴂ܂B");
		OutMessage(pBox, strMes);
	}
	if (rc==-3) { // w萔Ⴂ
		strMes.Format("w萔Ⴂ܂B");
		OutMessage(pBox, strMes);
	}
	// wႢ
	if (rc>0) {
		CString strMvstr1, strMvstr2;
		// svǖʂ܂Ői߂
		for (i=0;i<rc;i++) {
			SBDbb1.ahead2(); 
			SBDbb2.ahead2();
		}
		// w̓`I\L擾B
		PCELL *pcl1=SBDbb1.lastmove();
		strMvstr1.Format("%s",SBDbb1.mvstr(pcl1));
		PCELL *pcl2=SBDbb2.lastmove();
		strMvstr2.Format("%s",SBDbb2.mvstr(pcl2));

		// \
		strMes.Format("%dڂ̎w肪Ⴂ܂B",rc);
		OutMessage(pBox, strMes);
		strMes.Format("obt@=%s", strMvstr2);
		OutMessage(pBox, strMes);
		strMes.Format("I  =%s", strMvstr1);
		OutMessage(pBox, strMes);
	}
	return 0;
}
///////////
// wr 
//   Iꂽƌsobt@̊rA_
//    StatusBoxJĕ\B
//    wvŏďʂɊÂAd폜A
//    ŏIǖʂ̈vŏdĕ\ɂĂ̋@\
//    ŵǂႤ̂鎖z肷B
void CSelectBoxB::OnCmpSBase() 
{
	int idx=m_SelectList.GetCurSel(); // ݑIĂ镶̃CfbNXl
	if (idx==LB_ERR)
		return ; // IꂽR[hȂΉɏI

	CStatusBox StatusBox(&CompareSBaseThread, (LPARAM)this);
	StatusBox.DoModal(); // wr
}
