/***********************/
/*    SelectCsa.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "SelectCsa.h"
#include <dbb.h>
#include "sdjview.h"
#include "dbeview.h"
#include "dbeframe.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSelectCsa _CAO

void CSelectCsa::CommonInit()
{
	//{{AFX_DATA_INIT(CSelectCsa)
	m_CsaFile = _T("");
	m_iItemNum = 0;
	//}}AFX_DATA_INIT
	m_pDoc=NULL;
	m_StopButton.SetStopEvent(&m_KillThread);	// fCxg̐ݒ
}

CSelectCsa::CSelectCsa(CWnd* pParent			/*=NULL*/)
	: CDialog(CSelectCsa::IDD, pParent)
{
	CommonInit();
}
CSelectCsa::CSelectCsa(int idd,CWnd* pParent)
	: CDialog(idd, pParent)
{
	CommonInit();
}

void CSelectCsa::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectCsa)
	DDX_Control(pDX, IDC_SELECTLIST, m_SelectList);
	DDX_Text(pDX, IDC_EDIT_CSAFILE, m_CsaFile);
	DDV_MaxChars(pDX, m_CsaFile, 512);
	DDX_Text(pDX, IDC_ITEMNUM, m_iItemNum);
	DDV_MinMaxInt(pDX, m_iItemNum, 0, 999999);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelectCsa, CDialog)
	//{{AFX_MSG_MAP(CSelectCsa)
	ON_BN_CLICKED(IDOK, OnSelectList)
	ON_BN_CLICKED(IDC_CSAFILE, OnCsafile)
	ON_COMMAND(ID_CSALIST_UPDATENUM,OnUpdateNum)
	ON_LBN_DBLCLK(IDC_SELECTLIST, OnDblclkSelectlist)
	ON_BN_CLICKED(IDC_MAKE_LIST, OnMakeList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectCsa bZ[W nh

/////
/// ڐ\̍XV
void CSelectCsa::UpdateItemNum()
{
	m_iItemNum=m_SelectList.GetCount();
	UpdateData(FALSE);
}
/////
// ڐ\XVbZ[W
void CSelectCsa::OnUpdateNum()
{
	UpdateItemNum();
}

/////
// CSAt@C̎w
void CSelectCsa::OnCsafile() 
{
	CString CsaFile=m_CsaFile;

	if (CsaFile.IsEmpty())
		// CSAt@C(fBNĝ)
		CsaFile.Format("%s*.csa",GetShgdbName()); 

	CFileDialog dlgCsa(TRUE,							// ǂݍ݃_CAO
		"csa",											// ftHggq
		CsaFile,										// CSAt@C
		(DWORD)(OFN_HIDEREADONLY | OFN_FILEMUSTEXIST),	// t@C̑
		"CSAt@C (*.csa)|*.csa||");					// tB^[

	BOOL bResult = dlgCsa.DoModal();					// t@C_CAO

	if (bResult == IDOK) {								// Iꂽ
		m_CsaFile = dlgCsa.GetPathName();				// pX擾
		UpdateData(FALSE);								// \XV

		WriteCsaFname(m_CsaFile);						// vt@C֋L

		MakeList();										// \Xg̍XV
	}
}

// Xg\z[J[Xbh֐
static UINT MakeListThread(LPVOID pParam)
{
	int rc;
	CSelectCsa  *pSelectCsa=(CSelectCsa *)pParam;
	CEvent *pStopEvent=&pSelectCsa->m_KillThread;

	pStopEvent->ResetEvent();							// fCxg̃Zbg

	// CSAt@CI[v
	CFile fileCsa;
	if (!fileCsa.Open(pSelectCsa->m_CsaFile,CFile::modeReadWrite | CFile::shareDenyWrite)) {
		// t@CȂ΂̂܂܏IB
		pSelectCsa->m_StopButton.SendMessage(WM_CLOSE); // ft̏
		pSelectCsa->m_EndThread.SetEvent();				// ICxg
		return 1;
	}
	// A[JCo̍\z
	CSDJArchive inar(&fileCsa,CArchive::load);
	// ΋ǂcaǂݏođ΋ǃXgݒ肷B
	CDBB Dbb; // ΋ǂca
	char dispbuf[512];
	int counter=0; // \XVJE^

	// ΋ǋ؂q "/"̃t@CʒűLɂ
	// CArchive̓ubNP(4096)Ńt@CǂނCFile::GetPosition()ł͂
	// ʒu킩ȂB]āA"/"Seekʒu͂킩ȂB{łCArchive
	// ubNǂݏoƂ̂̈ʒu "/"̃JEglLĂAł
	// ʒu܂SeekĎc"/"JEgl狁߂ēǂݎ̂Ă@ƂB
	// CSAt@CǂޒOPosItem̒l͎̂悤ɂȂB
	// CSA File    |---rec0---|---rec1---|---rec2---|---rec3---|---rec4---|---rec5---|---
	//             |<--- CArchive buffer 0(4k)--><---buffer 1(4k)----><---buffer 2(4k)--
	// PosItem    0,0       4k,1        4k,2       8k,3       8k,4      12k,5      12k,6
	// PosItem1   0,0       4k,1        4k,2       8k,3       8k,4      12k,5      12k,6
	// PosItem2   0,0        0,0,        0,0       4k,2       4k,2       8k,4       8k,4
	// rec(n)̋LƂPosItem2̒lLB
	POSITEM PosItem,PosItem1,PosItem2;
	PosItem2.lPos=0; // l(OXl)
	PosItem2.iCount=0;
	PosItem1.lPos=0; // l(Ol)
	PosItem1.iCount=0;
	PosItem.lPos=(long)fileCsa.GetPosition();			// t@C|C^
	PosItem.iCount=counter;								// R[hԍ
	rc=Dbb.InCsa2Mrec(inar,FALSE);
	// R[hǂݏo(G[\Ȃ) nj̊ԌJԂ
	while (rc==0) {
		// \obt@̃Zbg
		Dbb.set_mdsp();
		Dbb.set_disp_mrec(dispbuf); // \̐
		pSelectCsa->m_SelectList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
		pSelectCsa->m_PosList.AddTail(PosItem2);		// R[hrec(n)̋LׂlPosItem2

		// \XV
		if ((++counter % 10)==0) // 101\(͒x)B
			pSelectCsa->PostMessage(WM_COMMAND,ID_CSALIST_UPDATENUM);
		
		// ΋ǋ؂q"/"܂œǂݔ΂(sP)
		CString EndofRec;
		BOOL loop=FALSE;
		while ( inar.ReadString(EndofRec)==TRUE ) {
			if ( EndofRec=="/" ) {
				loop=TRUE; break; // ΋ǋ؂qmB
			}
		}
		// loop==FALSEȂI Maybe EOF
		if (!loop)
			break;
		// fCxg̃`FbN
		if (WaitForSingleObject(*pStopEvent, 0)==WAIT_OBJECT_0)
			break; // fI

		// ̃R[h`FbN
		PosItem.lPos=(long)fileCsa.GetPosition();		// t@C|C^
		PosItem.iCount=counter;							// R[hԍ
		// OlƔră|C^i񂾂LVtg
		if (PosItem.lPos!=PosItem1.lPos)
			PosItem2=PosItem1;
		PosItem1=PosItem; // lOlƂċL(܂iCounter̍XV)
		rc=Dbb.InCsa2Mrec(inar,FALSE);
	}
	pSelectCsa->PostMessage(WM_COMMAND,ID_CSALIST_UPDATENUM); // \

	// N[Y
	inar.Close();
	fileCsa.Close();


	pSelectCsa->m_StopButton.SendMessage(WM_CLOSE);		// ft̏
	pSelectCsa->m_EndThread.SetEvent(); // ICxg

	return 0;
}

/////
// CSAt@Cǂݍő΋ǃXg\zB
void CSelectCsa::MakeList() 
{
	m_SelectList.ResetContent();						// Xg{bNXɂB
	m_PosList.RemoveAll();								// R[hCfbNXNA
	UpdateItemNum();									// ڐ\XV

	// Jn(D揇ʂ͂Pi)
	CWinThread *pFindThread=AfxBeginThread(MakeListThread,this,
		THREAD_PRIORITY_BELOW_NORMAL);
	m_StopButton.DoModal();								// f_CAO{bNX
	WaitForSingleObject(m_EndThread,INFINITE);			// Xbh̏ImF(QdNh~)

	// Xg{bNX̃J[\ݒ
	if (m_SelectList.GetCount()) {
		m_SelectList.SetCurSel(0);						// 擪ɐݒ
	}
	GotoDlgCtrl(&m_SelectList);							// 
	SetDefID(IDOK);										// ftHgtI(^[L[őI)
}

////
// I
void CSelectCsa::OnSelectList() 
{
	CWaitCursor WaitCursor;								// v

	// I`FbN
	int Sel=m_SelectList.GetCurSel();
	if (Sel==LB_ERR)									// IȂΉȂB
		return;
	// hLg̕ۑ`FbN
	if (!m_pDoc->SaveModified())
		return;
	// CSAt@CI[v
	CFile fileCsa;
	if (!fileCsa.Open(m_CsaFile,CFile::modeReadWrite | CFile::shareDenyWrite)) {
		// t@CȂ΂̂܂܏IB
		return;
	}

	// ΋ǃR[h̓B悸LPosItem2̃t@CʒuSeekB
	POSITION pos=m_PosList.FindIndex(Sel);
	POSITEM PosItem=m_PosList.GetAt(pos);
	if (PosItem.lPos != fileCsa.Seek(PosItem.lPos,CFile::begin)) {
		fileCsa.Close();
		return; // Seek Error;
	}
	// A[JCo̍\z
	CSDJArchive inar(&fileCsa,CArchive::load);
	// c̃R[hǂݎ̂Ă(PosItem2.iCounterƂ̍)
	CString EndofRec("/");
	CString Line;
	BOOL bReadOK=TRUE;
	int iCount=PosItem.iCount;
	while (iCount < Sel) {
		if (inar.ReadString(Line)) {
			if (Line == EndofRec) {
				iCount++;
			}
		} else {
			bReadOK=FALSE; break;
		}
	}
	// ܂łCSAt@C̓o

	// r[̎擾
	CSDJView *pView=m_pDoc->GetSDJView();
	// ߃{bNXJĂ
	if (pView)
		pView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	BOOL bUpdateDoc=FALSE;
	if (iCount==Sel && bReadOK==TRUE) {
		// hLgɃR[hǂݍ
		m_pDoc->DeleteContents();					// hLgZbg
		// R[hǍ(\obt@BDSPŃZbg)
		m_pDoc->Serialize(inar); 
		m_pDoc->SetModifiedFlag(FALSE);

		// hLg^CgCSAt@C{΋ǒǔ
		CString strFname=fileCsa.GetFileName();
		int n=strFname.GetLength();
		char *cp=strFname.GetBuffer(n+1);
		*(cp+n-4)='\0';								// .csa菜
		strFname.ReleaseBuffer();
		CString strTitle;
		strTitle.Format("%s%d",strFname,Sel);		// ^Cg
		m_pDoc->SetTitle(strTitle);
		m_pDoc->SetDiskPathName("");				// ܂ł̃fBXNpXZbg

		if (pView) { // ۂ pViewNULLł邱Ƃ͂ȂƎv
			m_pDoc->AdjustSpriteList();
			if (pView->GetGuideFrame()!=NULL)		// ǖʕ\JĂ
				pView->GetGuideFrame()->Invalidate();
			if (pView->GetSubFrame()!=NULL)			// TuEBhEJĂ
				pView->GetSubFrame()->Invalidate();
			pView->Invalidate();					// \XV
		}
		// ՑJĂeXV
		if (theApp.m_bDbeUsing) {
			CDbeFrame *pDbeFrame=pView->GetDbeFrame();
			if (pDbeFrame) {						// ̃r[ՑĂ
				CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
				pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
			}
		}
		// JĂe
		CKifFrame *pKifFrame=pView->GetKifFrame();
		if (pKifFrame!=NULL) {
			pKifFrame->SetWindowText(strTitle);		// ^Cg
			pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
		}
		bUpdateDoc=TRUE;
	}

	// N[Y
	inar.Close();
	fileCsa.Close(); 

	// ɓǂݍ񂾂_CAO
	if (bUpdateDoc)
		CDialog::OnOK();
}

////
// Xg_uNbNI
void CSelectCsa::OnDblclkSelectlist() 
{
	OnSelectList();
}

BOOL CSelectCsa::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetCsaFname(m_CsaFile); // CSAt@C
	UpdateData(FALSE);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////
// t@CǍXg\
void CSelectCsa::OnMakeList() 
{
	MakeList(); // \Xg̍XV
}
