/**********************/
/*    ShgdbDlg.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "ShgdbDlg.h"
#include "selectboxb.h"
#include "dbeframe.h"
#include "ssdjdoctemplate.h"
#include "dbeview.h"
#include "osversion.h"
#include "dlgdir.h"
#include "dlgselectdir.h"

#pragma warning(disable:4996)

extern CWinSDJApp theApp;
extern HANDLE g_hDblock;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShgdbDlg _CAO

CShgdbDlg::CShgdbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShgdbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShgdbDlg)
	m_strShgdb = _T("");
	//}}AFX_DATA_INIT
}

void CShgdbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShgdbDlg)
	DDX_Control(pDX, IDC_CMB_SHGDB, m_cmbShgdb);
	DDX_CBString(pDX, IDC_CMB_SHGDB, m_strShgdb);
	DDV_MaxChars(pDX, m_strShgdb, 512);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShgdbDlg, CDialog)
	//{{AFX_MSG_MAP(CShgdbDlg)
	ON_BN_CLICKED(IDC_SELDIR, OnSelDir)
	ON_COMMAND(ID_RBUTTON_UP,OnCmdRButtonUp)
	ON_COMMAND(ID_DELETE_CMB_ITEM,OnDeleteCmbItem)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShgdbDlg bZ[W nh

// fBNg̐ݒ
void CShgdbDlg::OnOK() 
{
	if (!UpdateData(TRUE))
		return;

	CString strShgdb=getenv("SHGDB");
	int n=m_cmbShgdb.GetCurSel(); // ݑI(index)
	if (n==CB_ERR) {
		if (m_strShgdb.GetLength()==0) {
			// ftHg̏cafBNg
			CString strMes;
			strMes.Format("%s","f[^x[X̐ݒ͕KKvłB\n");
			strMes+="ݒl\n";
			strMes+=strShgdb;
			strMes+="\nɐݒ肵܂B낵łH";

			int res=AfxMessageBox(strMes,MB_YESNO);
			if (res==IDNO)
				return;
		}
		else {
			strShgdb=m_strShgdb;
		}
	}
	else {
		m_cmbShgdb.GetLBText(n,strShgdb);
	}

	// f[^x[XbNł΁AύX\
	if (WaitForSingleObject(g_hDblock,0)!=WAIT_OBJECT_0)
		return ;

	CString shgdb;
	shgdb.Format("SHGDB=%s",strShgdb);
	_putenv(shgdb);

	if (theApp.m_bSelectBoxBUsing) { // EI{bNX
			ASSERT(theApp.m_pSelectBoxB);
		theApp.m_pSelectBoxB->PostMessage(WM_COMMAND,ID_SHGDB_CHANGE);
	}
	if (theApp.m_bDbeUsing) {  // Ց
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
		pDbeView->PostMessage(WM_COMMAND,ID_DBE_REINITROOT);
	}
	ReleaseMutex(g_hDblock); // f[^x[XAbN

	// SHGDB̋L
	POSITION pos=theApp.m_lstShgdb.Find(strShgdb);
	if (pos)
		theApp.m_lstShgdb.RemoveAt(pos); // Έx폜
	theApp.m_lstShgdb.AddHead(strShgdb); // 擪Insert
	// SHGDB̋L͍ŐVW܂łƂB
	if (theApp.m_lstShgdb.GetCount()>8)
		theApp.m_lstShgdb.RemoveTail();


	// strShgdbɈړB
	CWaitCursor waitcr; // v
	SetCurrentDirectory(strShgdb);
	
	CDialog::OnOK();
}

///////
// fBNgI
void CShgdbDlg::OnSelDir() 
{
	COsVersion OsVersion; // OS Version 
	CString strShgdb=getenv("SHGDB");
	int n=m_cmbShgdb.GetCurSel(); // ݑI(index)
	if (n>=0) {
		m_cmbShgdb.GetLBText(n,strShgdb);
	}
	if (OsVersion.m_OsVersionType >=2 ) { // Win95,NT4.0 ȏ
		CDlgSelectDir DlgSelectDir; // fBNgI_CAO
		DlgSelectDir.m_strSelectDir=strShgdb; // l
		
		if (DlgSelectDir.DoModal()==IDOK) {
			strShgdb=DlgSelectDir.m_strSelectDir;
			int found=m_cmbShgdb.FindStringExact(-1,strShgdb);
			if (found==CB_ERR)
				found=m_cmbShgdb.InsertString(0,strShgdb);
			m_cmbShgdb.SetCurSel(found);
		}
	} 
	else { // NT3.51
		CDlgDir DlgDir;

		if (DlgDir.DoModal()==IDOK) {
			strShgdb=DlgDir.strSelPathName;
			int found=m_cmbShgdb.FindStringExact(-1,strShgdb);
			if (found==CB_ERR)
				found=m_cmbShgdb.InsertString(0,strShgdb);
			m_cmbShgdb.SetCurSel(found);
		}
	}
}

BOOL CShgdbDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	POSITION pos=theApp.m_lstShgdb.GetHeadPosition();
	while (pos) {
		CString &str=theApp.m_lstShgdb.GetNext(pos);
		m_cmbShgdb.AddString(str);
	}
	
	CString strShgdb=getenv("SHGDB");
	int found=m_cmbShgdb.FindStringExact(-1,strShgdb);
	if (found==CB_ERR) {
		found=m_cmbShgdb.InsertString(0,strShgdb);
	}
	m_cmbShgdb.SetCurSel(found);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/////
// Etj[
void CShgdbDlg::OnCmdRButtonUp()
{
	CPoint point;
	::GetCursorPos(&point);

 	int n=m_cmbShgdb.GetCurSel(); // ݑI(index)
	POSITION pos=NULL;
	CString str;
	if (n>=0) {
		m_cmbShgdb.GetLBText(n,str); // ݑI()
		pos=theApp.m_lstShgdb.Find(str); // [U`ڂ
	}

	// |bvAbvj[J
	CMenu Menu;
	Menu.LoadMenu(IDR_CMB_POPMENU);
	CMenu *pPopMenu=Menu.GetSubMenu(0);

	pPopMenu->EnableMenuItem(ID_DELETE_CMB_ITEM,
		(pos)? MF_ENABLED:(MF_GRAYED | MF_DISABLED));

	pPopMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		point.x,point.y, this);
}

/////
// [U`^ڂ̍폜
void CShgdbDlg::OnDeleteCmbItem() 
{
	int n=m_cmbShgdb.GetCurSel(); // ݑI(index)
	POSITION pos=NULL;
	CString str;
	if (n>=0) {
		m_cmbShgdb.GetLBText(n,str); // ݑI()
		pos=theApp.m_lstShgdb.Find(str); // [U`ڂ
	}
	// [U`ڂȂ폜B
	if (pos) {
		theApp.m_lstShgdb.RemoveAt(pos);
		m_cmbShgdb.DeleteString(n);
	}
}
