// splstno.h : header file
//
// CSpriteListNotifyObj class
//
// This is a class derived from CSpriteNotifyObj which is used in 
// CSpriteList to handle notification calls from CSprite objects.
//

#ifndef __CSPRITELISTNOTIFYOBJ__
#define __CSPRITELISTNOTIFYOBJ__

#include "sprite.h"

class CSpriteList;
class CSDJView;

class CSpriteListNotifyObj : public CSpriteNotifyObj
{
public:
    CSpriteListNotifyObj();
    ~CSpriteListNotifyObj();
    void SetList(CSpriteList* pSpriteList)
        {m_pSpriteList = pSpriteList;}
    void SetView(CSDJView* pSDJView)
        {m_pSDJView = pSDJView;}
    void Change(CSprite *pSprite,
                CHANGETYPE change,
                CRect* pRect1 = NULL,
                CRect* pRect2 = NULL);
	void Reorder(CSprite *pSprite);

protected:
    CSpriteList* m_pSpriteList;
    CSDJView* m_pSDJView;
};
#endif // __CSPRITELISTNOTIFYOBJ__