/********************/
/*    WinSDJ.cpp    */
/********************/
#include "stdafx.h"
#include "winsdj.h"
#include "mainfrm.h"
#include "childfrm.h"
#include "winsdjview.h"
#include "winsdjsview.h"
#include "winsdjdoc.h"
#include "sframewnd.h"
#include "ssdjdoctemplate.h"
#include "winsdjsdoc.h"
#include "selectboxb.h"
#include "dbedoc.h"
#include "dbeview.h"
#include "dbeframe.h"
#include "titlewindow.h"
#include "winsdjtsdoc.h"
#include "winsdjtsview.h"
#include "sdjeditdoc.h"
#include "sdjeditframe.h"
#include "sdjeditview.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)
#pragma warning(disable:4005)

/////////////////////////////////////////////////////////////////////////////
// CWinSDJApp

BEGIN_MESSAGE_MAP(CWinSDJApp, CWinApp)
	//{{AFX_MSG_MAP(CWinSDJApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN_KF, OnFileOpenKF)
	ON_COMMAND(ID_FILE_OPEN_TS, OnFileOpenTS)
	ON_COMMAND(ID_FILE_NEW1, OnFileNew1)
	ON_COMMAND(ID_FILE_NEW2, OnFileNew2)
	ON_COMMAND(ID_FILE_OPEN2, OnFileOpen2)
	ON_COMMAND(ID_FILE_NEW_TS, OnFileNewTs)
	ON_COMMAND(ID_MENU_EDITOR, OnMenuEditor)
	//}}AFX_MSG_MAP
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	// ẄZbgAbv R}h
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSDJApp NX̍\z

// f[^x[XbNMutex
HANDLE g_hDblock;

/* ̃e[u(\A) */
char *Ktab[]={"","","","","p","n","","","","S",
                  "j","\","","","",""};
char *Ksu[]={"","","O","l","","Z","","","","\",
			 "\","\","\O","\l","\","\Z","\","\"};

CWinSDJApp::CWinSDJApp()
{
	int i;
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB

	// vOi[fBNg̎擾
	SetPgmDir();
	// Ppbg̍쐬`FbNtO
	m_bMapColorsToPalette = FALSE;
	// DIB̃[h
	m_bLoadDIB = FALSE;

	// hLgev[g
	m_pMDocTemplate=NULL;
	m_pMDocTemplate2=NULL;
	m_pSDocTemplate=NULL;
	m_pDbeDocTemplate=NULL;
	m_bSDocTemplateUsing=FALSE;
	m_bSelectBoxBUsing=FALSE;
	m_bDbeUsing=FALSE;
	m_bMateDbcUsing=FALSE;
	m_pSelectBoxB=NULL;
	m_pTitleWindow=NULL;
	m_bTitleExist=FALSE;
	m_rectEditPos.SetRectEmpty();

	// x֘A
	m_pDlgKspeed=NULL;
	// xe[uiPOiKj
	int tbla[]={3000,2000,1000,700,400,200,150,100, 50, 30};
	int tblb[]={3000,2000,1000,700,400,200,150,100, 50, 30};
	for (i=0;i<10;i++) {
		m_KspeedTableA[i]=tbla[i];
		m_KspeedTableB[i]=tblb[i];
	}

	// 98摜̗L
	//KomafontCheck98();

	// ^Cgt@C̗L
	CString tf;
	tf.Format("%stitle.wb",m_PgmDir);
	CFile f;
	if (f.Open(tf,CFile::modeRead)) {
		m_bTitleExist=TRUE;
		f.Close();
	}

	for (i=0;i<2;i++) {
		m_bKfontInit[i]=FALSE; // \̏tO
		m_bTfontInit[i]=FALSE;
	}
}

/////////////////////////////////////////////////////////////////////////////
// B CWinSDJApp IuWFNg

CWinSDJApp theApp;


////////
// O[o֐
//////
// CSAt@C̋L
void WriteCsaFname(CString &CsaFname)
{
	// t@Cvt@CɋLB
	theApp.WriteProfileString(KF_SECTION,KF_CSAFILE_NAME,CsaFname);
}
///////
// CSAt@C̎擾
void GetCsaFname(CString &CsaFname,BOOL bDefault)
{
	CString CsaFile;
	CsaFile=theApp.GetProfileString(KF_SECTION,KF_CSAFILE_NAME,NULL);

	if (!CsaFile.IsEmpty()) {
		CsaFname = CsaFile;
	} else if (bDefault) {
		CsaFname.Format("%s%s",GetShgdbName(),DEFAULT_CSAFILE);
	}
}
//////
// PCLt@C̋L
void WritePclFname(CString &PclFname)
{
	// t@Cvt@CɋLB
	theApp.WriteProfileString(KF_SECTION,KF_PCLFILE_NAME,PclFname);
}
///////
// PCLt@C̎擾
void GetPclFname(CString &PclFname,BOOL bDefault)
{
	CString PclFile;
	PclFile=theApp.GetProfileString(KF_SECTION,KF_PCLFILE_NAME,NULL);

	if (!PclFile.IsEmpty()) {
		PclFname = PclFile;
	} else if (bDefault) {
		PclFname.Format("%s%s",GetShgdbName(),DEFAULT_PCLFILE);
	}
}

///////////
/// f[^x[XbN҂ Modal Loop
BOOL DbLockModal()
{
	CWinThread *pThread=AfxGetThread();
	BOOL bGetLock=FALSE;
	MSG Msg;
	while ( bGetLock == FALSE ) {
		while ( ::PeekMessage( &Msg, NULL, 0, 0, PM_NOREMOVE ) ) {
			if ( !pThread->PumpMessage( ) ) {
				bGetLock = FALSE; 
				::PostQuitMessage(0);
				return FALSE;
			} 
		}
		
		// MFC ŃAChOs
// SelectBoxB/ČXbhASSERTIONN̂Ŏ~߂B
//		LONG lIdle = 0;
//		while ( AfxGetApp()->OnIdle(lIdle++ ) );

		// Lock̊l
		if (WaitForSingleObject(g_hDblock,0)==WAIT_OBJECT_0) {
			bGetLock=TRUE;
		}
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJApp NX̏

///////
// dN`FbN[`
static BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam)
{
	HWND *phWnd=(HWND *)lParam;
	char title[512];
	// EBhE^Cg ""ۂŃ`FbNB
	GetWindowText(hWnd,title,sizeof title);
	if (strncmp(title," by Iwanami Compiled -",10)==0 || strcmp(title,"")==0) {
		// dN̏ꍇ́APGMANeBuɂB
		SendMessage(hWnd,WM_COMMAND,ID_WAKEUP,0);

		*phWnd=hWnd;
		return FALSE;
	}
	else {
		// ̌ĂяovB
		*phWnd=NULL;
		return TRUE;
	}
}

// SĂn܂
BOOL CWinSDJApp::InitInstance()
{
	// dÑ`FbN

	HWND hWnd=NULL;
	// ׂĂ̐eEBhEɑ΂EnumWindowsProcŃ`FbNB
	EnumWindows(EnumWindowsProc,(LPARAM)&hWnd);
	// ɋNς̏ꍇ
	if (hWnd) {
		// R}hC
		CCommandLineInfo cmdInfo;
		ParseCommandLine(cmdInfo);
		// R}hC̏(File New or File Open)
		if (!cmdInfo.m_strFileName.IsEmpty()) {
			// CSAt@C̃`FbN
			int len=cmdInfo.m_strFileName.GetLength();
			char *buf=cmdInfo.m_strFileName.GetBuffer(len+1);
			// 啶ʂȂ
			if ((_mbsicmp((unsigned char *)&buf[len-4],(unsigned char *)".csa")==0) ||
				(_mbsicmp((unsigned char *)&buf[len-4],(unsigned char *)".pcl")==0)) { 
				// File Open
				// vt@C
				theApp.WriteProfileString(KF_SECTION,KF_WAKEUP_FILE,cmdInfo.m_strFileName);
				::SendMessage(hWnd,WM_COMMAND,ID_WAKEUP_OPEN,0);
			}
			cmdInfo.m_strFileName.ReleaseBuffer();
		}
		return FALSE;
	}

	// WIȏ
	m_hHandCursor=LoadCursor(IDC_HANDCUR);		// J[\
	m_hHandCursor2=LoadCursor(IDC_HANDCUR2);	// ͗pJ[\

    // ^Cg̕\
	time_t ltime1;
	time(&ltime1);								// ̎擾(ltime1)

	m_pTitleWindow=CreateTitleWindow();
	m_pTitleWindow->DispTitle();

	//ShowTitle();								// Ń^Cg\B

	g_hDblock=CreateMutex(NULL,FALSE,"SHGDB");	// f[^x[X Lock Mutex

#ifdef _AFXDLL
	Enable3dControls();							// L DLL ̒ MFC gpꍇɂ͂R[ĂB 
#else
	Enable3dControlsStatic();					// MFC ƐÓIɃNĂꍇɂ͂R[ĂB
#endif
	
	// Profile̐ݒ(q[vɎ)
	// NfBNgWinsdj.ini
#ifdef malloc
#undef malloc
#ifdef free
#undef free
	CString profile;
	profile.Format("%s\\%s",m_PgmDir,m_pszProfileName);
	free((void *)m_pszProfileName);
	char *cp=(char *)malloc(profile.GetLength()+1);
	strcpy(cp,profile);
	m_pszProfileName=(LPCTSTR)cp;
#endif
#endif

	LoadStdProfileSettings();  // W INI t@C̃IvV[ނ܂ (MRU ܂)
	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	// ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B

	// cafBNg̃`FbN&ݒ
	// ftHgSHGDBfBNgBϐSHGDB΂̗pB
	// ȂPGMDIR\..\database
	char *dname=getenv("SHGDB");
	CString defShgdb;

	if (dname)
		defShgdb.Format("%s",dname);
	else
		defShgdb.Format("%s..\\database",m_PgmDir);
	// vt@CĐݒ肪΂ŗDɍ̗pB
	CString ShgdbSection = SHGDB_SECTION;
	CString ShgdbDir=GetProfileString(ShgdbSection,SHGDB_DIR,defShgdb);

	// ϐSHGDBݒ肷B
	static char shgdb[256];
	sprintf(shgdb,"SHGDB=%s",ShgdbDir);
	int rc=_putenv(shgdb);
	if (rc!=0) {
		AfxMessageBox("ϐ SHGDB ݒł܂B");
		return FALSE;
	}

	// \
	m_bKifWindowEnable=GetProfileInt(SETTING_SECTION,KIF_WINDOW,0);		// ftHg0(FALSE)
	// 
	m_bKSoundEnable=GetProfileInt(SETTING_SECTION,K_SOUND,0);			// ftHg0(FALSE)

	//  hLgev[g̍쐬
	m_pMDocTemplate = new CMultiDocTemplate(
		IDR_WINSDJTYPE,
		RUNTIME_CLASS(CWinSDJDoc),
		RUNTIME_CLASS(CChildFrame), 
		RUNTIME_CLASS(CWinSDJView));
	AddDocTemplate(m_pMDocTemplate);	// hLg̓o^

	//  lhLgev[g̍쐬
	m_pMDocTemplate2 = new CMultiDocTemplate(
		IDR_SDJTSTYPE,
		RUNTIME_CLASS(CWinSDJTSDoc),
		RUNTIME_CLASS(CChildFrame), 
		RUNTIME_CLASS(CWinSDJTSView));
	AddDocTemplate(m_pMDocTemplate2);	// lhLg̓o^

	//  GfB^hLgev[g̍쐬
	m_pSDJEditTemplate = new CSSdjDocTemplate(
		IDR_SDJEDTYPE,
		RUNTIME_CLASS(CSDJEditDoc),
		RUNTIME_CLASS(CSDJEditFrame), 
		RUNTIME_CLASS(CSDJEditView));
	AddDocTemplate(m_pSDJEditTemplate); // GfB^hLg̓o^

	//  ՖʃhLgev[g̍쐬
	m_pSDocTemplate = new CSSdjDocTemplate(
		IDR_SUBSDJTYPE,
		RUNTIME_CLASS(CWinSDJSDoc),
		RUNTIME_CLASS(CSFrameWnd),
		RUNTIME_CLASS(CWinSDJSView));

	//  ՂcahLgev[g̍쐬
	m_pDbeDocTemplate = new CSSdjDocTemplate(
		IDR_DBEFRAME,
		RUNTIME_CLASS(CDbeDoc),
		RUNTIME_CLASS(CDbeFrame), 
		RUNTIME_CLASS(CDbeView));

	// C MDI t[ EBhE쐬
	CMainFrame* pMainFrame = new CMainFrame;

	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;

	m_pMainWnd = pMainFrame;

	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// R}hC̏(File New or File Open)
	if (cmdInfo.m_strFileName.IsEmpty()) {
		// File New
		m_pMDocTemplate->OpenDocumentFile(NULL);
	}
	else {
		// CSAt@C̃`FbN
		char buf[512];
		strcpy(buf,cmdInfo.m_strFileName);
		int len=strlen(buf);
		// 啶ʂȂ
		if (_mbsicmp((unsigned char *)&buf[len-4],(unsigned char *)".csa")==0) {
			m_pMDocTemplate->OpenDocumentFile(cmdInfo.m_strFileName);	// ΋Ǌ
		}
		else if	(_mbsicmp((unsigned char *)&buf[len-4],(unsigned char *)".pcl")==0) { 
			// File Open
			m_pMDocTemplate2->OpenDocumentFile(cmdInfo.m_strFileName);	// l
		} else {
			AfxMessageBox("CSA ܂ PCL t@Cł͂܂B");
			return FALSE;
		}
	}

	// (kmsound.wav)̏
	CString fn;
	fn.Format("%skmsound.wav",m_PgmDir);
	CFile kwf;

	if (kwf.Open(fn,CFile::modeRead)) {
		m_KSound.Load(&kwf);
		kwf.Close();
	}
	else {
		// t@CȂ΋̐ݒ͋IFALSEɂB
		m_bKSoundEnable=FALSE;
	}

	// XgL̓Ǎ
	// ^L
	int nSenkei=GetProfileInt(STRING_LIST_SECTION,SENKEI_STRING_NUM,0);
	if (nSenkei) {
		for (int i=0;i<nSenkei;i++) {
			CString strEntry;
			strEntry.Format("%s%d",SENKEI_STRING_ITEM,i);
			CString str=GetProfileString(STRING_LIST_SECTION,strEntry);
			if (!str.IsEmpty()) {
				m_lstSenkei.AddTail(str);
			}
		}
	}
	// SHGDB
	int nShgdb=GetProfileInt(STRING_LIST_SECTION,SHGDB_STRING_NUM,0);
	if (nShgdb) {
		for (int i=0;i<nShgdb;i++) {
			CString strEntry;
			strEntry.Format("%s%d",SHGDB_STRING_ITEM,i);
			CString str=GetProfileString(STRING_LIST_SECTION,strEntry);
			if (!str.IsEmpty()) {
				m_lstShgdb.AddTail(str);
			}
		}
	}

	// xl
	m_KspeedCurrentA=GetProfileInt(KSPEED_SECTION,VALUE_OF_SLIDER1,5);
	m_KspeedCurrentB=GetProfileInt(KSPEED_SECTION,VALUE_OF_SLIDER2,9);
	m_KspeedOffsetX =GetProfileInt(KSPEED_SECTION,WINDOW_OFFSET_X,-1000);
	m_KspeedOffsetY =GetProfileInt(KSPEED_SECTION,WINDOW_OFFSET_Y,-1000);

	// ^Cg
	time_t ltime2;

	do {
		time(&ltime2);
	} while (ltime2-ltime1 < TITLE_SHOW_SECOND);	// ^Cg\Ԓ@Sb
	EraseTitle();

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	// ő\`FbN
	BOOL bZoomed=GetProfileInt(MAINFRAME_SECTION,MAINFRAME_MAXIMUM,0);
	if (bZoomed) {
		m_nCmdShow=SW_SHOWMAXIMIZED;
	}
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	// SHGDBɈړB
	CWaitCursor waitcr; // v
	SetCurrentDirectory(ShgdbDir);

	// Nbv{[htH[}bg̓o^
	m_nWinSDJFormat=RegisterClipboardFormat(WINSDJ_FORMAT);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

  	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// bZ[W nh͂܂B
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CWinSDJApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJApp R}h

// vOi[fBNg̎擾
void CWinSDJApp::SetPgmDir(void)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	_splitpath(_pgmptr,drive,dir,fname,ext);

	sprintf(m_PgmDir,"%s%s",drive,dir);
}


// VXep[^̐ݒ
void CWinSDJApp::InitSysprm(int iColors)
{
	/* ̈ړp[^ */
	m_prm.dspcounter=10;
	m_prm.komaspeed=20;

	/* nF */
	m_prm.komaclr=100;				/* yF */
	m_prm.komared=255*15/15;		// 255
	m_prm.komagreen=255*13/15;		// 221
	m_prm.komablue=0;				// 0

	/* F */
	m_prm.komafcclr=101;			/* yF */
	m_prm.komafcred=255*15/15;		// 255
	m_prm.komafcgreen=255*14/15;	// 238
	m_prm.komafcblue=0;				// 0

	/* ÐF */
	m_prm.komafdclr=102;			/* ÒF */
	m_prm.komafdred=136;			// 255*8/15
	m_prm.komafdgreen=103;			// 255*6/15
	m_prm.komafdblue=0;				// 0

	/* 蕶F */
	m_prm.komaprclr=103;			/*  */
	m_prm.komaprred=255;			// 255*15/15
	m_prm.komaprgreen=0;			// 0
	m_prm.komaprblue=0;				// 0

	/* ՐF */
	m_prm.banclr=104;				/* ÉyF */
	m_prm.banred=221;				// 255*13/15
	m_prm.bangreen=187;				// 255*11/15
	m_prm.banblue=0;				// 0

	/* ՉF */
	m_prm.banfcclr=105;
	m_prm.banfcred=221;				// 255*13/15
	m_prm.banfcgreen=187;			// 255*11/15
	m_prm.banfcblue=0;				// 0

	/* ՉÐF */
	m_prm.banfdclr=106;
	m_prm.banfdred=221;				// 255*13/15
	m_prm.banfdgreen=187;			// 255*11/15
	m_prm.banfdblue=0;				// 0

	/* ՏڐF */
	m_prm.banframe=0;

	/* F */
	m_prm.daiclr=107;				/* ÐԐF */
	m_prm.daired=170;				// 255*10/15
	m_prm.daigreen=68;				// 255*4/15
	m_prm.daiblue=0;				// 0

	/* 䉏F */
	m_prm.daifcclr=108;				/* F */
	m_prm.daifcred=187;				// 255*11/15
	m_prm.daifcgreen=102;			// 255*6/15
	m_prm.daifcblue=85;				// 255*5/15

	/* 䉏ÐF */
	m_prm.daifdclr=109;				/* ÒF */
	m_prm.daifdred=136;				// 255*8/15
	m_prm.daifdgreen=51;			// 255*3/15
	m_prm.daifdblue=0;				// 0

	/* F */
	m_prm.sujiclr=0;
	
	/* F */
	m_prm.kboxclr=110;				/* ÐԐF */
	m_prm.kboxred=170;				// 255*10/15
	m_prm.kboxgreen=68;				// 255*4/15
	m_prm.kboxblue=0;				// 0

	/* F */
	m_prm.kboxfcclr=111;			/* F */
	m_prm.kboxfcred=187;			// 255*11/15
	m_prm.kboxfcgreen=102;			// 255*6/15
	m_prm.kboxfcblue=85;			// 255*5/15

	/* ÐF */
	m_prm.kboxfdclr=112;			/* ÒF */
	m_prm.kboxfdred=136;			// 255*8/15
	m_prm.kboxfdgreen=51;			// 255*3/15
	m_prm.kboxfdblue=0;				// 0
	
	/* wiF */
	m_prm.backclr=113;				/* ×ΉF */
	m_prm.backred=153;				// 255*9/15
	m_prm.backgreen=153;			// 255*9/15
	m_prm.backblue=68;				// 255*4/15

	m_prm.backframe=0;
	m_prm.backmjclr=255;
	
	/* EBhEgF */
	m_prm.winfrclr=114;				/* DF */
	m_prm.winfrred=204;				// 255*12/15
	m_prm.winfrgreen=204;			// 255*12/15
	m_prm.winfrblue=221;			// 255*13/15

	/* EBhEF */
	m_prm.winbkclr=115;				/* ÊDF */
	m_prm.winbkred=170;				// 255*10/15
	m_prm.winbkgreen=170;			// 255*10/15
	m_prm.winbkblue=170;			// 255*10/15

	/* EBhEgF */
	m_prm.winfcclr=116;				/*  */
	m_prm.winfcred=238;				// 255*14/15
	m_prm.winfcgreen=238;			// 255*14/15
	m_prm.winfcblue=255;			// 255*15/15

	/* EBhEgÐF */
	m_prm.winfdclr=117;				/* ÈÊDF */
	m_prm.winfdred=136;				// 255*8/15
	m_prm.winfdgreen=136;			// 255*8/15
	m_prm.winfdblue=153;			// 255*9/15

	/* EBhEF */
	m_prm.winmjclr=255;
}


////////////////////////
// Քwi̐ݒ
void CWinSDJApp::LoadBackDIB(int colormode)
{
	//CBitmap backdib;
	//backdib.LoadBitmap(IDR_MAINFRAME2);

	//m_BackDIB=backdib;
	char strFname[256];

	CFile f;

	sprintf_s(strFname,"%sback.dib",theApp.m_PgmDir);   // 256FDIB

	// witHgt@C̃I[v
	
	if (!f.Open(strFname,CFile::modeRead | CFile::shareDenyWrite)) {
		char buffer[256];
		sprintf(buffer,"witHg %s I[vł܂B",strFname);
		AfxMessageBox(buffer);
		exit(1);
	}

	//int sg;
	for (int sg=0;sg<2;sg++) {
		m_BackDIB[sg].Load(&f);
	}

		f.Close();		// witHgt@C̃N[Y
}

//////////////////////
// DIB̐ݒ
void CWinSDJApp::LoadKomaDIB(int colormode)
{
	char strFname[512];
	int sg,km,nr;

	//if (colormode!=16)
		sprintf(strFname,"%skmfont.dib",theApp.m_PgmDir);
	//else
		//sprintf(strFname,"%skmfont16.dib",theApp.m_PgmDir);
	CFile f;
	if (!f.Open(strFname,CFile::modeRead | CFile::shareDenyWrite)) {
		char buffer[256];
		sprintf(buffer,"摜 %s ̃I[vɎs܂B",strFname);
		AfxMessageBox(buffer);
		exit(1);
	}
	for (sg=0;sg<2;sg++) {
		for (km=0;km<8;km++) {
			for (nr=0;nr<2;nr++) {
				m_KomaDIB[sg][km][nr].Load(&f);
			}
		}
	}
	f.Close(); // 摜̃N[Y
}

////////////////////////
// DIB̐ݒ
void CWinSDJApp::LoadKBoxDIB(int colormode)
{
	char strFname[256];
	//if (colormode!=16) 
		sprintf(strFname,"%sKBox.dib",theApp.m_PgmDir);	  // 256FDIB
	//else
		//sprintf(strFname,"%sKBox16.dib",theApp.m_PgmDir); // 16FpDIB
	
	m_KBoxDIB.Load(strFname);
}


///////////////////
// \DIB̐ݒ
void CWinSDJApp::LoadFontDIB()
{
	CString strKfont[2];
	strKfont[0].Format("%ssg0.dib",theApp.m_PgmDir);	// 
	strKfont[1].Format("%ssg1.dib",theApp.m_PgmDir);	// 
	CString strTfont[2];
	strTfont[0].Format("%ssu0.dib",theApp.m_PgmDir);	// U
	strTfont[1].Format("%ssu1.dib",theApp.m_PgmDir);	// 

	for (int i=0;i<2;i++) {
		CFile f; CFileStatus fs;
		if (f.GetStatus(strKfont[i],fs)) {				// EDIB̑݊mF
			if (m_KfontDIB[i].Load((LPSTR)((LPCTSTR)strKfont[i])))
				m_bKfontInit[i]=TRUE;
		}
		if (f.GetStatus(strTfont[i],fs)) {				// UEDIB̑݊mF
			if (m_TfontDIB[i].Load((LPSTR)((LPCTSTR)strTfont[i])))
				m_bTfontInit[i]=TRUE;
		}
	}
}

// 98Komafontt@C̗L
//void CWinSDJApp::KomafontCheck98()
//{
	//char strFname[256];
	//sprintf(strFname,"%skomafnt.ft2",theApp.m_PgmDir);
	//FILE *fp=fopen(strFname,"rb");

	//if (fp!=NULL) {
		//m_bKomafontExist=TRUE;
		//fclose(fp);
	//}
	//else
		//m_bKomafontExist=FALSE;
//}

// VKhLgI[vB
// mfc\src\docmgr.cpp
void CWinSDJApp::OnFileNew1() 
{
	// }`hLgI[v
	m_pMDocTemplate->OpenDocumentFile(NULL);
}

// VKlhLgI[vB
void CWinSDJApp::OnFileNewTs() 
{
	// }`hLgI[v
	m_pMDocTemplate2->OpenDocumentFile(NULL);
}

//////
// SDI t[EBhÉut@C̐VK쐬v
void CWinSDJApp::OnFileNew2() 
{
	if (!m_bSDocTemplateUsing)
		return ;

	// VOhLgI[vB
	m_pSDocTemplate->OpenDocumentFile(NULL);
}

// VK΋ǊhLgI[vB
void CWinSDJApp::OnFileOpenKF() 
{
	// prompt the user (with all document templates)

	CString newName;
	if (!DoPromptFileName(newName, AFX_IDS_OPENFILE,
		OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TRUE, 
		(CDocTemplate *)m_pMDocTemplate))
		return; // open cancelled

	/* CWinAppOpenDocumentFile͈ȉ̍\ƂȂĂB
	   CWinApp::OpenDocumentFile(newName)
	    +---m_pDocManager->OpenDocumentFile(lpszFileName)
		     | bestTemplate=CDocTemplate::MatchDocType(lpszFileName,pOpenDocument)
			 | if (pOpenDocument) {
			 |      CFrameWnd::ActiveFrame()
			 |      return pOpenDocument; }
			 | else
			 |	    return bestTemplate->OpenDocumentFile(newName)

	 CDocTemplate::MatchDocType(..)̓łpDoc->GetPathName()ɂďƍ
	 sBhLg(pDoc)fBXNt@CƊ֘AȂƂGetPathName()
	 ͋ԂB
	*/
	CSDJDoc *pDoc=(CSDJDoc*)OpenDocumentFile(newName);

	// JĂ瓯^Cg
	CSDJView *pSDJView=pDoc->GetSDJView();
	if (pSDJView) {
		CKifFrame *pKifFrame=pSDJView->GetKifFrame();
		if (pKifFrame) {
			CString strTitle=pDoc->GetTitle();
			pKifFrame->SetWindowText(strTitle);
		}
	}

	//  ɃI[vĂhLgłAʂɃI[vꍇ
	//	́ARgɂĂ̕LɂB
	// m_pMDocTemplate->OpenDocumentFile(newName);
}
// VKlhLgI[vB
void CWinSDJApp::OnFileOpenTS() 
{
	// prompt the user (with all document templates)

	CString newName;
	if (!DoPromptFileName(newName, AFX_IDS_OPENFILE,
		OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TRUE, 
		(CDocTemplate *)m_pMDocTemplate2))
		return; // open cancelled

	/* CWinAppOpenDocumentFile͈ȉ̍\ƂȂĂB
	   CWinApp::OpenDocumentFile(newName)
	    +---m_pDocManager->OpenDocumentFile(lpszFileName)
		     | bestTemplate=CDocTemplate::MatchDocType(lpszFileName,pOpenDocument)
			 | if (pOpenDocument) {
			 |      CFrameWnd::ActiveFrame()
			 |      return pOpenDocument; }
			 | else
			 |	    return bestTemplate->OpenDocumentFile(newName)

	 CDocTemplate::MatchDocType(..)̓łpDoc->GetPathName()ɂďƍ
	 sBhLg(pDoc)fBXNt@CƊ֘AȂƂGetPathName()
	 ͋ԂB
	*/

	CSDJDoc *pDoc=(CSDJDoc*)OpenDocumentFile(newName);

	// JĂ瓯^Cg
	CSDJView *pSDJView=pDoc->GetSDJView();
	if (pSDJView) {
		CKifFrame *pKifFrame=pSDJView->GetKifFrame();
		if (pKifFrame) {
			CString strTitle=pDoc->GetTitle();
			pKifFrame->SetWindowText(strTitle);
		}
	}

	//  ɃI[vĂhLgłAʂɃI[vꍇ
	//	́ARgɂĂ̕LɂB
	// m_pMDocTemplate->OpenDocumentFile(newName);
}
//////
// SDI t[EBhÉut@CJv
void CWinSDJApp::OnFileOpen2() 
{
	if (!m_bSDocTemplateUsing)
		return ;

	BOOL bOpen=TRUE;
	// prompt the user (with all document templates)
	CString newName;
	if (!DoPromptFileName(newName, AFX_IDS_OPENFILE,
		OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TRUE, 
		(CDocTemplate *)m_pSDocTemplate))
		bOpen=FALSE; // open cancelled

	if (!m_bSDocTemplateUsing)
		return ; // _CAOJĂԂɏIꍇ

	if (bOpen) {
		// SDI(SDocTemplate)̎͂Ńt@C`FbNB
		CDocument *pOpenDocument = NULL;
		CDocTemplate::Confidence match;
		match = m_pSDocTemplate->MatchDocType(newName,pOpenDocument);
		if (match > CDocTemplate::yesAttemptForeign ) { // OK
			CWinSDJDoc *pDoc=(CWinSDJDoc *)m_pSDocTemplate->OpenDocumentFile(newName);
			if (pDoc)
				pDoc->SetModifiedFlag();
		}
		else { // NG
			AfxMessageBox(AFX_IDP_FAILED_TO_OPEN_DOC);
		}
	}
}

/**********
 *  t@C_CAOJ֐(DoPromptFileName(..))JXg}CYB
    [R]
  	  t@Cgq̑IŌ߂ꂽgqIȂ悤ɂȂ
	  ʂ̊gqvONƃCt[G[
	  Ȃ邽߁B

 MFCɂOnFileOpeñftHg̓
 (1) t@CJ̓
   CWinApp::OnFileOpen()
	  +--- m_pDocManager->OnFileOpen()
	        |  DoPromptFileName(newName,..)
			|  AfxGetApp()->OpenDocumentFile(newName)
 (2) t@Cގ(ID_FILE_SAVE,ID_FILE_SAVE_AS)
   CDocument::OnFileSave(),
              OnFileSaveAs()
				+--DoSave(lpszPathName,...)
				    | newName=lpszPathName
					+--- AfxGetApp()->DoPromptFileName(newName,..)
   CWinApp::DoPromptFileName(newName,...)
      +---m_pDocManager->DoPromptFileName(newName,...)

  ƂƂŁACDocManager::DoPromptFileName(..)ŏ̂
  JXg}CYCWinSDJAppɎB
 
 */
// \[Xmsdev\mfc\src\docmgr.cpp
void AppendFilterSuffix(CString& filter, OPENFILENAME& ofn,	CDocTemplate* pTemplate,
						CString* pstrDefaultExt); // vg錾(helper function)
BOOL CWinSDJApp::DoPromptFileName(CString &fileName, UINT nIDSTitle, DWORD lFlags,
								  BOOL bOpenFileDialog, CDocTemplate *pTemplate)
{
	CFileDialog dlgFile(bOpenFileDialog);

	CString title;
	VERIFY(title.LoadString(nIDSTitle));

	dlgFile.m_ofn.Flags |= lFlags;

	CString strFilter;
	CString strDefault;
	if (pTemplate != NULL)
	{
		ASSERT_VALID(pTemplate);
		AppendFilterSuffix(strFilter, dlgFile.m_ofn, pTemplate, &strDefault);
	}
	else
	{
		ASSERT(0); // łCDocTemplate͕Kw肷B
	    /* IWi͎w肪Ȃ΁Aev[gTR[hĂB
		// do for all doc template
		POSITION pos = m_templateList.GetHeadPosition();
		BOOL bFirst = TRUE;
		while (pos != NULL)
		{
			CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetNext(pos);
			AppendFilterSuffix(strFilter, dlgFile.m_ofn, pTemplate,
				bFirst ? &strDefault : NULL);
			bFirst = FALSE;
		}
		*/
	}

	/* ̓̕JbgBSẴt@C(*.*)āAJƃG[ɂȂB
	// append the "*.*" all files filter
	CString allFilter;
	VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
	strFilter += allFilter;
	strFilter += (TCHAR)'\0';   // next string please
#ifndef _MAC
	strFilter += _T("*.*");
#else
	strFilter += _T("****");
#endif
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;
	*/

	dlgFile.m_ofn.lpstrFilter = strFilter;
#ifndef _MAC
	dlgFile.m_ofn.lpstrTitle = title;
#else
	dlgFile.m_ofn.lpstrPrompt = title;
#endif
	dlgFile.m_ofn.lpstrFile = fileName.GetBuffer(_MAX_PATH);

	BOOL bResult = dlgFile.DoModal() == IDOK ? TRUE : FALSE;
	fileName.ReleaseBuffer();
	return bResult;
}
// docmgr.cpp肻̂܂܃Rs[
static void AppendFilterSuffix(CString& filter, OPENFILENAME& ofn,
	CDocTemplate* pTemplate, CString* pstrDefaultExt)
{
	ASSERT_VALID(pTemplate);
	ASSERT_KINDOF(CDocTemplate, pTemplate);

	CString strFilterExt, strFilterName;
	if (pTemplate->GetDocString(strFilterExt, CDocTemplate::filterExt) &&
	 !strFilterExt.IsEmpty() &&
	 pTemplate->GetDocString(strFilterName, CDocTemplate::filterName) &&
	 !strFilterName.IsEmpty())
	{
		// a file based document template - add to filter list
#ifndef _MAC
		ASSERT(strFilterExt[0] == '.');
#endif
		if (pstrDefaultExt != NULL)
		{
			// set the default extension
#ifndef _MAC
			*pstrDefaultExt = ((LPCTSTR)strFilterExt) + 1;  // skip the '.'
#else
			*pstrDefaultExt = strFilterExt;
#endif
			ofn.lpstrDefExt = (LPTSTR)(LPCTSTR)(*pstrDefaultExt);
			ofn.nFilterIndex = ofn.nMaxCustFilter + 1;  // 1 based number
		}

		// add to filter
		filter += strFilterName;
		ASSERT(!filter.IsEmpty());	// must have a file type name
		filter += (TCHAR)'\0';		// next string please
#ifndef _MAC
		filter += (TCHAR)'*';
#endif
		filter += strFilterExt;
		filter += (TCHAR)'\0';		// next string please
		ofn.nMaxCustFilter++;
	}
}

/*
 * OpenDocumentFileJXg}CYB
 * [R]
 *    t@CI[vɂĎw`ȊÕt@CI[v邱Ƃ
 *    Ȃ悤ɂ邽߁BftHgł͑gq̃t@CłCDocTemplate::
 *    OpenDocumentFile()Ăяo悤ɂȂĂAOnOpenDocument()ŕsA
 *    NZXƂȂBCWinSDJ::OnOpenDocument()Ń`FbN邱Ƃ\A
 *    ƈxhLg̃RXgN^ʂĂ̂ŃfXgN^
 *    Ă΂HڂɂȂASBASẼfXgN^̒ŃG[NB
 */
// afximpl.hRs[
// determine number of elements in an array (not bytes)
// misc helpers
#define _countof(array) (sizeof(array)/sizeof(array[0]))
BOOL AFXAPI AfxFullPath(LPTSTR lpszPathOut, LPCTSTR lpszFileIn);
BOOL AFXAPI AfxComparePath(LPCTSTR lpszPath1, LPCTSTR lpszPath2);
BOOL AFXAPI AfxResolveShortcut(CWnd* pWnd, LPCTSTR pszShortcutFile,
	LPTSTR pszPath, int cchPath);
// \[Xdocmgr.cppRs[
CDocument * CWinSDJApp::OpenDocumentFile(LPCTSTR lpszFileName)
{
	// find the highest confidence
// ̊֐CDocManagergȂ
//	POSITION pos = m_templateList.GetHeadPosition();
	POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
//	CDocTemplate::Confidence bestMatch = CDocTemplate::noAttempt;
//  gqv邩t@Ĉ̂v邩Ȃ悤ɂB
	CDocTemplate::Confidence bestMatch = CDocTemplate::yesAttemptForeign;
	CDocTemplate* pBestTemplate = NULL;
	CDocument* pOpenDocument = NULL;

	TCHAR szPath[_MAX_PATH];
	ASSERT(lstrlen(lpszFileName) < _countof(szPath));
#ifndef _MAC
	TCHAR szTemp[_MAX_PATH];
	if (lpszFileName[0] == '\"')
		++lpszFileName;
	lstrcpyn(szTemp, lpszFileName, _MAX_PATH);
	LPTSTR lpszLast = _tcsrchr(szTemp, '\"');
	if (lpszLast != NULL)
		*lpszLast = 0;
	AfxFullPath(szPath, szTemp);
	TCHAR szLinkName[_MAX_PATH];
	if (AfxResolveShortcut(AfxGetMainWnd(), szPath, szLinkName, _MAX_PATH))
		lstrcpy(szPath, szLinkName);

#else
	lstrcpyn(szPath, lpszFileName, _MAX_PATH);
	WIN32_FIND_DATA fileData;
	HANDLE hFind = FindFirstFile(lpszFileName, &fileData);
	if (hFind != INVALID_HANDLE_VALUE)
		VERIFY(FindClose(hFind));
	else
		fileData.dwFileType = 0;    // won't match any type
#endif

	while (pos != NULL)
	{
// ̊֐CDocManagergȂ
//		CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetNext(pos);
		CDocTemplate* pTemplate = m_pDocManager->GetNextDocTemplate(pos);
		ASSERT_KINDOF(CDocTemplate, pTemplate);

 		CDocTemplate::Confidence match;
		ASSERT(pOpenDocument == NULL);
#ifndef _MAC
		match = pTemplate->MatchDocType(szPath, pOpenDocument);
#else
		match = pTemplate->MatchDocType(szPath, fileData.dwFileType, pOpenDocument);
#endif
		if (match > bestMatch)
		{
			bestMatch = match;
			pBestTemplate = pTemplate;
		}
		if (match == CDocTemplate::yesAlreadyOpen)
			break;      // stop here
	}

	if (pOpenDocument != NULL)
	{
		POSITION pos = pOpenDocument->GetFirstViewPosition();
		if (pos != NULL)
		{
			CView* pView = pOpenDocument->GetNextView(pos); // get first one
			ASSERT_VALID(pView);
			CFrameWnd* pFrame = pView->GetParentFrame();
			if (pFrame != NULL)
				pFrame->ActivateFrame();
			else
				TRACE0("Error: Can not find a frame for document to activate.\n");
			CFrameWnd* pAppFrame;
			if (pFrame != (pAppFrame = (CFrameWnd*)AfxGetApp()->m_pMainWnd))
			{
				ASSERT_KINDOF(CFrameWnd, pAppFrame);
				pAppFrame->ActivateFrame();
			}
		}
		else
		{
			TRACE0("Error: Can not find a view for document to activate.\n");
		}
		return pOpenDocument;
	}

	if (pBestTemplate == NULL)
	{
		AfxMessageBox(AFX_IDP_FAILED_TO_OPEN_DOC);
		return NULL;
	}

	return pBestTemplate->OpenDocumentFile(szPath);
}

//////
// vOI
int CWinSDJApp::ExitInstance() 
{
	// AvP[VI
	// f[^x[X̋L
	char *dname=getenv("SHGDB");
	if (dname)
		WriteProfileString(SHGDB_SECTION,SHGDB_DIR,dname);
	// \
	WriteProfileInt(SETTING_SECTION,KIF_WINDOW,m_bKifWindowEnable);
	// 
	WriteProfileInt(SETTING_SECTION,K_SOUND,m_bKSoundEnable);
	// XgL
	// ^L
	int nSenkei=GetProfileInt(STRING_LIST_SECTION,SENKEI_STRING_NUM,0);	// ڐ
	int nlst=m_lstSenkei.GetCount(); // Vڐ
	WriteProfileInt(STRING_LIST_SECTION,SENKEI_STRING_NUM,nlst);		// ڐ̏
	// [U`^̏
	POSITION pos=m_lstSenkei.GetHeadPosition();
	int count=0;
	CString strEntry;
	while (pos) {
		CString &str=m_lstSenkei.GetNext(pos);
		strEntry.Format("%s%d",SENKEI_STRING_ITEM,count);
		WriteProfileString(STRING_LIST_SECTION,strEntry,str);
		count++;
	}
	// ꍇAcڂ̍폜
	while (count < nSenkei) {
		strEntry.Format("%s%d",SENKEI_STRING_ITEM,count);
		WriteProfileString(STRING_LIST_SECTION,strEntry,NULL);
		count++;
	}
	// ShgdbL
	int nShgdb=GetProfileInt(STRING_LIST_SECTION,SHGDB_STRING_NUM,0);	// ڐ
	nlst=m_lstShgdb.GetCount(); // Vڐ
	WriteProfileInt(STRING_LIST_SECTION,SHGDB_STRING_NUM,nlst);			// ڐ̏
	// [U`cȁ
	pos=m_lstShgdb.GetHeadPosition();
	count=0;
	while (pos) {
		CString &str=m_lstShgdb.GetNext(pos);
		strEntry.Format("%s%d",SHGDB_STRING_ITEM,count);
		WriteProfileString(STRING_LIST_SECTION,strEntry,str);
		count++;
	}
	// ꍇAcڂ̍폜
	while (count < nShgdb) {
		strEntry.Format("%s%d",SHGDB_STRING_ITEM,count);
		WriteProfileString(STRING_LIST_SECTION,strEntry,NULL);
		count++;
	}

	// x֘Al
	WriteProfileInt(KSPEED_SECTION,VALUE_OF_SLIDER1,m_KspeedCurrentA);
	WriteProfileInt(KSPEED_SECTION,VALUE_OF_SLIDER2,m_KspeedCurrentB);
	WriteProfileInt(KSPEED_SECTION,WINDOW_OFFSET_X ,m_KspeedOffsetX);
	WriteProfileInt(KSPEED_SECTION,WINDOW_OFFSET_Y ,m_KspeedOffsetY);
	
	CloseHandle(g_hDblock); // f[^x[XLock Mutex

	// AddDocTemplate()ȂhLgev[g̍폜
	delete m_pSDocTemplate;
	delete m_pDbeDocTemplate;

	return CWinApp::ExitInstance();
}

/////
// ^Cg̕\
void CWinSDJApp::ShowTitle()
{
	m_pTitleWindow=CreateTitleWindow();

	m_pTitleWindow->DispTitle();
}

////
// ^Cg̏
void CWinSDJApp::EraseTitle()
{
	if (!m_pTitleWindow)
		return;
	m_pTitleWindow->SendMessage(WM_CLOSE);
	m_pTitleWindow=NULL;
}

////////
// ^Cg쐬B
CTitleWindow *CWinSDJApp::CreateTitleWindow()
{
	int scWidth	=GetSystemMetrics(SM_CXSCREEN);
	int scHeight=GetSystemMetrics(SM_CYSCREEN);
	CPoint ctr(scWidth/2,scHeight/2);

	CTitleWindow *pTitleWindow=new CTitleWindow;
	CRect rc(ctr.x-224,ctr.y-89,ctr.x+224,ctr.y+89);	// ^Cg摜i440*170j傫߂ɂ

	BOOL result=pTitleWindow->Create(NULL,"", WS_POPUP|WS_VISIBLE|WS_DLGFRAME,rc);
	ASSERT(result);

	return pTitleWindow;
}

////
// GfB^̋N
void CWinSDJApp::OnMenuEditor() 
{
	m_pSDJEditTemplate->OpenDocumentFile(NULL);
}
