/**************************/
/*    WinSDJTSView.cpp    */
/**************************/
#include "stdafx.h"
#include "winsdj.h"
#include "winsdjtsview.h"
#include "dlgmidasic.h"
#include "winsdjtsdoc.h"
#include <winmemfile.h>
#include "winsdjsdoc.h"
#include "ssdjdoctemplate.h"
#include "sframewnd.h"
#include "SelectBoxC.h"
#include "dlgoutpcl.h"
#include "buftodbc.h"
#include "DlgDelDbc.h"
#include "DlgInPcl.h"
#include "printobject.h"
#include "childfrm.h"
#include "selectpcl.h"
#include "dlgselsep.h"
#include "dbeframe.h"
#include "dbeview.h"
#include "kifframe.h"
#include "dlgmatedbc.h"
#include <sthought.h>
#include "matedoc.h"
#include "mateframe.h"
#include "mateview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4244)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSView

IMPLEMENT_DYNCREATE(CWinSDJTSView, CSDJView)

CWinSDJTSView::CWinSDJTSView()
{
	m_pDlgMateDbc=NULL;
	m_pMateTemplate=NULL;
	m_pMateTemplate=new CSSdjDocTemplate(
		IDR_MATETYPE,   // EBhE^Cg̎w
		RUNTIME_CLASS(CMateDoc),
		RUNTIME_CLASS(CMateFrame),
		RUNTIME_CLASS(CMateView));
}

CWinSDJTSView::~CWinSDJTSView()
{
}


BEGIN_MESSAGE_MAP(CWinSDJTSView, CSDJView)
	//{{AFX_MSG_MAP(CWinSDJTSView)
	ON_UPDATE_COMMAND_UI(ID_MENU_SELECTBOX, OnUpdateMenuSelectbox)
	ON_COMMAND(ID_MENU_SELECTBOX, OnMenuSelectbox)
	ON_COMMAND(ID_MENU_BUFTODBB, OnMenuBuftoDBC)
	ON_UPDATE_COMMAND_UI(ID_MENU_BUFTODBB, OnUpdateMenuBuftoDbc)
	ON_COMMAND(ID_MENU_MIDASI_TS, OnMenuMidasiTs)
	ON_UPDATE_COMMAND_UI(ID_MENU_INITFORM_TS, OnUpdateMenuInitformTs)
	ON_COMMAND(ID_MENU_INITFORM_TS, OnMenuInitformTs)
	ON_COMMAND(ID_ZA_ROTATION, OnZaRotation)
	ON_UPDATE_COMMAND_UI(ID_MENU_OUTPCL, OnUpdateMenuOutPcl)
	ON_COMMAND(ID_MENU_OUTPCL, OnMenuOutPcl)
	ON_UPDATE_COMMAND_UI(ID_MENU_DELDBC, OnUpdateMenuDelDbc)
	ON_COMMAND(ID_MENU_DELDBC, OnMenuDelDbc)
	ON_UPDATE_COMMAND_UI(ID_MENU_INPCL, OnUpdateMenuInPcl)
	ON_COMMAND(ID_MENU_INPCL, OnMenuInPcl)
	ON_COMMAND(ID_MENU_CLIPOUT21, OnMenuClipout2)
	ON_COMMAND(ID_MENU_CLIPOUT31, OnMenuClipout3)
	ON_WM_DESTROY()
	ON_COMMAND(ID_SELECT_PCLFILE, OnSelectPclfile)
	ON_UPDATE_COMMAND_UI(ID_MENU_SEPARATE, OnUpdateMenuSeparate)
	ON_COMMAND(ID_MENU_SEPARATE, OnMenuSeparate)
	ON_UPDATE_COMMAND_UI(ID_MENU_SELSEPARATE, OnUpdateMenuSelseparate)
	ON_COMMAND(ID_MENU_SELSEPARATE, OnMenuSelseparate)
	ON_COMMAND(ID_MENU_MATE_BUFFER, OnMenuMateBuffer)
	ON_COMMAND(ID_MATE_FINISHED, OnMateFinished)
	ON_COMMAND(ID_ON_CLOSE_MATE_FRAME, OnCloseMateFrame)
	ON_UPDATE_COMMAND_UI(ID_ZA_ROTATION, OnUpdateZaRotation)
	ON_UPDATE_COMMAND_UI(ID_MENU_MIDASI_TS, OnUpdateMenuMidasiTs)
	ON_UPDATE_COMMAND_UI(ID_MENU_CLIPOUT21, OnUpdateMenuClipout2)
	ON_UPDATE_COMMAND_UI(ID_MENU_CLIPOUT31, OnUpdateMenuClipout3)
	ON_UPDATE_COMMAND_UI(ID_SELECT_PCLFILE, OnUpdateSelectPclfile)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_MENU_MATE_BUFFER, OnUpdateMenuMateBuffer)
	ON_COMMAND(ID_MENU_MATE_DBC, OnMenuMateDbc)
	ON_UPDATE_COMMAND_UI(ID_MENU_MATE_DBC, OnUpdateMenuMateDbc)
	ON_COMMAND(ID_DLG_MATE_DBC_SETNULL, OnDlgMateDbcSetnull)
	ON_COMMAND(ID_CHECK_MATE, OnCheckMate)
	ON_UPDATE_COMMAND_UI(ID_MENU_MATE_BREAK, OnUpdateMenuMateBreak)
	ON_COMMAND(ID_MENU_MATE_BREAK, OnMenuMateBreak)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSView `

void CWinSDJTSView::OnDraw(CDC* pDC)
{
	ResetZaFontDIB(1);	// \DIB̃Zbg
	CSDJView::OnDraw(pDC);
	DrawSide(pDC,1);	// lԕ\(\DIB̏)
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSView ff

#ifdef _DEBUG
void CWinSDJTSView::AssertValid() const
{
	CSDJView::AssertValid();
}

void CWinSDJTSView::Dump(CDumpContext& dc) const
{
	CSDJView::Dump(dc);
}

CWinSDJTSDoc* CWinSDJTSView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWinSDJTSDoc)));
	return (CWinSDJTSDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSView bZ[W nh

// lcaEI
void CWinSDJTSView::OnUpdateMenuSelectbox(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex()||theApp.m_bMateDbcUsing);
}
void CWinSDJTSView::OnMenuSelectbox() 
{
	if (m_bMenuLock)
		return;

	// lcaEI_CAO{bNX
	CWaitCursor waitcr;  // v
	CSelectBoxC *pSelectBoxC = new CSelectBoxC; // [hX_CAO{bNX
	pSelectBoxC->SetSDJDocument(GetDocument()); // Kꂪ
	pSelectBoxC->Create(IDD_SelectBoxC,this);
	pSelectBoxC->ShowWindow(SW_SHOWNORMAL);
}

//////
/// l̓o^
void CWinSDJTSView::OnUpdateMenuBuftoDbc(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex());
}
void CWinSDJTSView::OnMenuBuftoDBC() 
{
	if (m_bMenuLock)
		return;

	CWinSDJTSDoc *pDoc=GetDocument();

	CBuftoDBC BuftoDBC;   // l̓o^_CAO
	BuftoDBC.m_pDoc=pDoc; // lhLg̐ݒ

	BuftoDBC.DoModal();
}

/////
// lo̕ҏW
void CWinSDJTSView::OnUpdateMenuMidasiTs(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}
void CWinSDJTSView::OnMenuMidasiTs() 
{
	if (m_bMenuLock)
		return;

	CWinSDJTSDoc *pDoc=GetDocument();
	CDlgMidasiC DlgMidasiC;
	DlgMidasiC.SetDoc(pDoc);
	DlgMidasiC.DoModal();
}


void CWinSDJTSView::OnUpdateMenuInitformTs(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	// ɔՖʕҏWȂ烁j[Disable
	if (theApp.m_bSDocTemplateUsing)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
	
}
void CWinSDJTSView::OnMenuInitformTs() 
{
	if (m_bMenuLock)
		return;

	// ɊJnς݂ȂȂɂȂB
	if (theApp.m_bSDocTemplateUsing)
		return ;
	theApp.m_bSDocTemplateUsing=TRUE;

	// ǖʂ̃t@Co(t@C)
	CWinSDJTSDoc *pDocument=GetDocument();
	CWinMemFile File;
	CSDJArchive arOut(&File,CArchive::store);
	pDocument->WriteBaninfo(arOut);
	arOut.Close();

	// SDIhLgt[̍쐬
	CWinSDJSDoc *pDoc = (CWinSDJSDoc *)theApp.m_pSDocTemplate->OpenDocumentFile(NULL);

	File.Seek(0L,CFile::begin); // t@C擪Seek
	CSDJArchive arIn(&File,CArchive::load);
	pDoc->ReadBaninfo(arIn); // SDI hLgɏǖʂ[h
	arIn.Close();
	pDoc->SetTitle(pDocument->GetTitle()); // ^Cg

	// SDĨt[EBhE̐et[EBhẼr[ɐݒ肷B
	// SDI t[EBhE
	CSFrameWnd *pSFrameWnd=(CSFrameWnd *)theApp.m_pSDocTemplate->GetFrameWnd();
	// ̃r[SDĨt[EBhEɃNB
	pSFrameWnd->SetSdjParent(this);
	pSFrameWnd->SetParentType(1); // e͋lhLg

	// SDIt[EBhẼr[̎qEBhEƂċLB
	SetSFrame(pSFrameWnd);
}

// ϊ
void CWinSDJTSView::OnZaRotation() 
{
	if (m_bMenuLock)
		return;

	CSDJView::ZaRotation();
	Invalidate(); // ĕ\
}
void CWinSDJTSView::OnUpdateZaRotation(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}

/////
// lPCLt@Cւ̏o̓j[
void CWinSDJTSView::OnUpdateMenuOutPcl(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex());
}
void CWinSDJTSView::OnMenuOutPcl() 
{
	if (m_bMenuLock)
		return;

	CDlgOutPcl DlgOutPcl;
	DlgOutPcl.DoModal();
}

///
// l폜
void CWinSDJTSView::OnUpdateMenuDelDbc(CCmdUI* pCmdUI) 
{
 	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex());
}

void CWinSDJTSView::OnMenuDelDbc() 
{
	if (m_bMenuLock)
		return;

	CDlgDelDbc DlgDelDbc;
	DlgDelDbc.DoModal();
}

/////
// PCLt@Ĉcao^j[
void CWinSDJTSView::OnUpdateMenuInPcl(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex());
}
void CWinSDJTSView::OnMenuInPcl() 
{
	if (m_bMenuLock)
		return;

	CDlgInPcl DlgInPcl; // t@CIj[_CAO
	DlgInPcl.DoModal();
}

///////
// l̃Nbv{[ho
void CWinSDJTSView::OnUpdateMenuClipout2(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}
void CWinSDJTSView::OnMenuClipout2() 
{
	if (m_bMenuLock)
		return;

	CWinSDJTSDoc *pDoc=GetDocument();
	// ݂̋ǖʂ𕶎Ŏ擾B
	CString str;
	pDoc->OutputKifStd(str);
	// O[oAP[gĂփRs[B
	int len=str.GetLength();
	HANDLE hMem=GlobalAlloc(GMEM_MOVEABLE,len+1);
	if (hMem==NULL)
		return;
	char *cp=(char *)GlobalLock(hMem);
	strcpy(cp,str);
	GlobalUnlock(hMem);
	// O[oNbv{[h֏o͂B
	if (!OpenClipboard()) {
		GlobalFree(hMem);
		return ;						 // Nbv{[hI[vs
	}
	::EmptyClipboard();					 // Nbv{[h󂷂B
	::SetClipboardData(CF_OEMTEXT,hMem); // Nbv{[hɏo
	::CloseClipboard();					 // Nbv{[hB
	
}

/////////
// ΋ǂ̃Nbv{[ho(PCL`)
void CWinSDJTSView::OnUpdateMenuClipout3(CCmdUI* pCmdUI) 
{
 	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}
void CWinSDJTSView::OnMenuClipout3() 
{
	if (m_bMenuLock)
		return;

	CWinSDJTSDoc *pDoc=GetDocument();
	// ݂̋ǖʂ𕶎Ŏ擾B
	CString str;
	pDoc->OutputKifCsa(str);
	// O[oAP[gĂփRs[B
	int len=str.GetLength();
	HANDLE hMem=GlobalAlloc(GMEM_MOVEABLE,len+1);
	if (hMem==NULL)
		return;
	char *cp=(char *)GlobalLock(hMem);
	strcpy(cp,str);
	GlobalUnlock(hMem);
	// O[oNbv{[h֏o͂B
	if (!OpenClipboard()) {
		GlobalFree(hMem);
		return ;						 // Nbv{[hI[vs
	}
	::EmptyClipboard();					 // Nbv{[h󂷂B
	::SetClipboardData(CF_OEMTEXT,hMem); // Nbv{[hɏo
	::CloseClipboard();					 // Nbv{[hB
	
}

// ̃r[jƂɁA_CAOJĂ炱jB
void CWinSDJTSView::OnDestroy() 
{
	// EI{bNXgpȂ炱IB
	if (theApp.m_pSelectBoxB && theApp.m_bSelectBoxBUsing) {
		if ((CWinSDJTSDoc *)theApp.m_pSelectBoxB->GetSDJDocument()
			==GetDocument())
			theApp.m_pSelectBoxB->SendMessage(WM_CLOSE);
	}
	// lca}Ȃ炱I
	if (m_pDlgMateDbc) {
		m_pDlgMateDbc->SendMessage(WM_CLOSE);
	}
	// l}Ȃ炱IB
	POSITION pos=m_pMateTemplate->GetFirstDocPosition();
	if (pos) {
		m_pMateTemplate->CloseAllDocuments(TRUE);
	}
	delete m_pMateTemplate;

	CSDJView::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSView NẌ

BOOL CWinSDJTSView::OnPreparePrinting(CPrintInfo* pInfo) 
{
	CWinSDJTSDoc *pDoc=GetDocument();
	CPrintObject *pPObj = new CPrintObject;
	CString str;
	pDoc->OutputKifStd(str,100);		// W`(100)
	GetPrintString(str,pPObj->strKif);  // `(Qig)
	pPObj->kif=pPObj->strKif.GetBuffer(pPObj->strKif.GetLength()+1);
	// ǖʂ̎擾
	CKBase *pKBase=pDoc->GetKBase();
	pKBase->PushAspect(FALSE);     // ݂̋ǖʂۑďǖʂ
	pPObj->Bform=*pKBase->btype(); // ǖʂ擾
	pPObj->side=pKBase->turn();
	pKBase->PopAspect();		   // ǖʂ߂
	// ǖʂ͕肩
	CBform Bform; Bform.Init(0); // 
	if (Bform == pPObj->Bform)	pPObj->bPI=TRUE;
	else					    pPObj->bPI=FALSE;

	pInfo->m_lpUserData=(LPVOID)pPObj;
	return CSDJView::OnPreparePrinting(pInfo);
}

void CWinSDJTSView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	CPrintObject *pPObj=(CPrintObject *)pInfo->m_lpUserData;

	// s̃tHg̎擾
	// tHg̏
	pDC->SetMapMode(MM_LOMETRIC);

	CFont Font; // `̃tHg
	Font.CreatePointFont(100,"lr ",pDC); // `tHg10pt̍쐬()
	LOGFONT lfFont;
	Font.GetObject(sizeof(LOGFONT),&lfFont); // tHg̎擾
	// 
	// CreatePointFontŃ|Cgw肵ătHg쐬ƃvr[ƈ
	// ŃtHgTCYقȂBł
	//             12pt    10pt 
	//  vr[  25	    17   (_P)
	//          42      35   (_P)
	//  ̂ɁAł͒ڃTCYw肷B
	lfFont.lfHeight=42;	pPObj->nf12.CreateFontIndirect(&lfFont); // 12pt
	lfFont.lfHeight=35;	pPObj->nf.CreateFontIndirect(&lfFont);	 // 10pt
	lfFont.lfEscapement = 1800;
	pPObj->rf.CreateFontIndirect(&lfFont); // `tHg10pt(t)̍쐬
	
	// MAXy[W̌vZ
	int i,ix,dn;
	for (ix=0,i=0;ix < pPObj->strKif.GetLength();) {
		// OłpInfo->m_rectDraw͖BA4cŌvZB
		ix=PageCalc(++i,pDC,pInfo,&dn,2883); 
	}
	pInfo->SetMaxPage(i-1);
}

void CWinSDJTSView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	CPrintObject *pPObj=(CPrintObject*)pInfo->m_lpUserData;
	pPObj->strKif.ReleaseBuffer();
	delete pPObj;
}

void CWinSDJTSView::OnEndPrintPreview(CDC* pDC, CPrintInfo* pInfo, POINT point, CPreviewView* pView) 
{
	CChildFrame *pParent=(CChildFrame*)GetParentFrame();
	// ő\(vr[̂݋Ă)Ȃ猳ɂɖ߂B
	if (pParent->IsZoomed()) {
		pParent->MDIRestore();
	}
	
	// ACR\Ȃ猳ɂɖ߂BȂOnEndPrintPreview()ASSERT.
	// MFC̃oOB
	if (pParent->IsIconic()) {
		pParent->MDIRestore();
	}

	CSDJView::OnEndPrintPreview(pDC, pInfo, point, pView);
}

void CWinSDJTSView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CPrintObject *pPObj=(CPrintObject*)pInfo->m_lpUserData;

	PagePrint(pDC,pInfo);

	// tb^[(y[Wԍ)̈
	CString str;
	str.Format("- %d -",pInfo->m_nCurPage);
	LOGFONT lfFont; // tHg
	pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont); // tHg̎擾
	if (lfFont.lfHeight<0) lfFont.lfHeight=-lfFont.lfHeight;
	lfFont.lfWidth=0;
	CFont Font;
	Font.CreateFontIndirect(&lfFont);
	CFont *pOldFont=pDC->SelectObject(&Font); // tHgI
	int h=pInfo->m_rectDraw.Height(); 	// ʒu
	int w=pInfo->m_rectDraw.Width();
	pDC->TextOut(w/2-lfFont.lfHeight/2*2,h+50,str);
	pDC->SelectObject(pOldFont); // tHgɖ߂
}

void CWinSDJTSView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	if (pInfo==NULL) 
		CSDJView::OnPrepareDC(pDC, pInfo);
	else {
		int OldMode = pDC->SetMapMode(MM_LOMETRIC);
	}
}

//////
/// y[Ẅ
void CWinSDJTSView::PagePrint(CDC *pDC,CPrintInfo *pInfo)
{
	CPrintObject *pPObj=(CPrintObject *)pInfo->m_lpUserData;
	int dn;
	int ix=PageCalc(pInfo->m_nCurPage,pDC,pInfo,&dn);
	CString strKif=&pPObj->kif[ix]; // 舵(Ɨp)
	char *kif=strKif.GetBuffer(strKif.GetLength()+1); // ̓WJ
	int PageHeight=pInfo->m_rectDraw.Height(); // y[W(_P)
	if (PageHeight<0) PageHeight=-PageHeight;
	// 󎚊Jnʒu
	int y=-150;
	int x=150;
	// wo͒ۂ
	BOOL bDan=FALSE;
	// ^Cg\ۂ
	BOOL bTTL=FALSE;

	// õtHg
	LOGFONT lfFont;
	int fh;
	CFont *pOldFont=pDC->SelectObject(&pPObj->nf); // tHgI(10pt)
	pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont); // tHg
	fh=lfFont.lfHeight; // tHg̍
	char *cp=strtok(kif,"\r\n");
	while (cp) {
		CString str;
		if (strncmp(cp,"====================",20)==0) {
			// JnQd
			pDC->MoveTo(x,y); pDC->LineTo(x+1700,y); y-=5;
			pDC->MoveTo(x,y); pDC->LineTo(x+1700,y);
			y-=fh/2; // 󎚊Jnʒu
			bDan=FALSE;
			bTTL=TRUE;
		} else if (strncmp(cp,"oǖ: ------",16)==0) {
			pDC->SelectObject(&pPObj->nf); // tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			str="oǖ:";
			y-=fh; // s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*11,y-fh/2);
			pDC->LineTo(x+fh/2*11+700,y-fh/2);
			y-=fh;
			// Տ PSsǂݎ̂ĂB
			for (int i=0;i<14;i++)	strtok(NULL,"\r\n");
			PrintBan(pDC,pInfo,x,&y); // Ֆʂ̈
			bDan=FALSE;
		} else if (strncmp(cp,"l: ------",18)==0) {
			pDC->SelectObject(&pPObj->nf); // tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			str="l:";
			y-=fh; // s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*11,y-fh/2);
			pDC->LineTo(x+fh/2*11+700,y-fh/2);
			y-=fh; // s
			bDan=FALSE;
		} else if (strncmp(cp,"w: ------",14)==0) {
			dn=-1; // igJE^(w^Cĝ-1)
			pDC->SelectObject(&pPObj->nf); // tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			str="w:";
			y-=fh; // s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*9,y-fh/2);
			pDC->LineTo(x+fh/2*9+700,y-fh/2);
			y-=fh; // s
			bDan=TRUE;
		} else if (strncmp(cp,"w蒍: ------",16)==0) {
			pDC->SelectObject(&pPObj->nf); // tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			str="w蒍:";
			y-=fh; // s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*11,y-fh/2);
			pDC->LineTo(x+fh/2*11+700,y-fh/2);
			y-=fh; // s
			bDan=FALSE;
		} else {
			str=cp;
			if (bTTL) { // ^Cg(lԍ,o^)
				bTTL=FALSE;
				pDC->TextOut(x+800,y,str);
				y-=fh; // s
				pDC->SelectObject(&pPObj->nf12); // tHgI
				pPObj->nf12.GetObject(sizeof(LOGFONT),&lfFont);
				fh=lfFont.lfHeight; // tHg̍
			} else {
				pDC->TextOut(x,y,str);
				y-=fh; // s
			}
			if (bDan) { // wo͒(ig)
				dn++;
				if (dn==10) {
					y-=fh;
					dn=0;
				}
			}
		}
		cp=strtok(NULL,"\r\n");
		int ht=(y<0)? -y:y;
		if (ht > PageHeight-100)
			break;
	}
	pDC->SelectObject(pOldFont); // tHgɖ߂
	strKif.ReleaseBuffer();
}

///////
/// y[WvZ
///   iPagey[WƂ obt@Jnʒu(ix)߂lɕԂB
//    ̎̒igJE^ldnpɕԂB
//    I[o[y[Ww肵
//    ߂lɂ̓obt@̕(strKif.GetLength())ԂB
//    y[W(PageHeight)=0(ftHg)wȂŒpInfovZB
//    (ӁIĨASYPagePrint()Ƒ΂ɂȂĂB)
int CWinSDJTSView::PageCalc(int iPage,CDC *pDC,CPrintInfo *pInfo,int *dnp,int PageHeight)
{
	CPrintObject *pPObj=(CPrintObject *)pInfo->m_lpUserData;
	*dnp=0;
	int ix=0;
	int n_page=1;
	CString strKif=pPObj->strKif; // 舵(Ɨp)
	char *kif=strKif.GetBuffer(strKif.GetLength()+1); // ̓WJ
	if (PageHeight==0) {
		PageHeight=pInfo->m_rectDraw.Height(); // y[W(_P)
		if (PageHeight<0) PageHeight=-PageHeight;
	}

	// 󎚊Jnʒu
	int y=-150;
	// wo͒ۂ
	BOOL bDan=FALSE;
	// ^Cg\ۂ
	BOOL bTTL=FALSE;

	// õtHg
	LOGFONT lfFont;
	int fh;
	pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
	fh=lfFont.lfHeight; // tHg̍
	char *cp=strtok(kif,"\r\n");
	while (cp) {
		if (n_page == iPage)
			break;
		if (strncmp(cp,"====================",20)==0) {
			// JnQd
			y-=5;
			y-=fh/2; // 󎚊Jnʒu
			bDan=FALSE;
			bTTL=TRUE;
		} else if (strncmp(cp,"oǖ: ------",16)==0) {
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			y-=fh; // s
			y-=fh; // s
			// Տ PSsǂݎ̂ĂB
			for (int i=0;i<14;i++)	strtok(NULL,"\r\n");
			PrintBan(pDC,pInfo,0,&y,TRUE); 
			bDan=FALSE;
		} else if (strncmp(cp,"l: ------",18)==0) {
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			y-=fh; // s
			y-=fh; // s
			bDan=FALSE;
		} else if (strncmp(cp,"w: ------",14)==0) {
			*dnp=-1; // igJE^(w^Cĝ-1)
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			y-=fh; // s
			y-=fh; // s
			bDan=TRUE;
		} else if (strncmp(cp,"w蒍: ------",16)==0) {
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight; // tHg̍
			y-=fh; // s
			y-=fh; // s
			bDan=FALSE;
		} else {
			if (bTTL) { // ^Cg
				bTTL=FALSE;
				y-=fh; // s
				pPObj->nf12.GetObject(sizeof(LOGFONT),&lfFont);
				fh=lfFont.lfHeight; // tHg̍
			} else {
				y-=fh; // s
			}
			if (bDan) { // wo͒(ig)
				(*dnp)++;
				if (*dnp==10) {
					y-=fh;
					*dnp=0;
				}
			}
		}
		cp=strtok(NULL,"\r\n");
		int ht=(y<0)? -y:y;
		if (ht > PageHeight-100) {
			n_page++;
			y=-150; // y[W
		}
	}
	if (cp)
		ix=(int)(cp-kif);
	else
		ix=pPObj->strKif.GetLength();
	strKif.ReleaseBuffer();

	return ix;
}


//////
// PCLt@C̑IEǍ
void CWinSDJTSView::OnUpdateSelectPclfile(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}
void CWinSDJTSView::OnSelectPclfile() 
{
	if (m_bMenuLock)
		return;

	CSelectPcl SelectPcl;
	SelectPcl.SetDoc(GetDocument());
	SelectPcl.DoModal();
}

//////
// w菇̕
void CWinSDJTSView::OnUpdateMenuSeparate(CCmdUI* pCmdUI) 
{
	BOOL bEnable;
	if (m_bKifSeparate) {
		pCmdUI->SetText("͏I(&E)\tCtrl+E");
		bEnable=TRUE;
	}
	else {
		// ҏWŃ[`FbNȂ番͂B
		pCmdUI->SetText("͊Jn(&E)\tCtrl+E");
		if (IsRuleChecking())
			bEnable=TRUE;
		else
			bEnable=FALSE;

	}

	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	pCmdUI->Enable(bEnable);
}
void CWinSDJTSView::OnMenuSeparate() 
{
	if (m_bMenuLock)
		return;

	if (m_bKifSeparate) {
		m_bKifSeparate=FALSE;
	}
	else {
		m_bKifSeparate=TRUE;
		SetCursor(theApp.m_hHandCursor2); // ͎J[\̃Zbg
	}
}


////
// 菇̑I
void CWinSDJTSView::OnUpdateMenuSelseparate(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	CWinSDJTSDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	PCELL *pcl=pKBase->lastmove(); // O̎w
	PCELL *parent;
	if (pcl==pKBase->root()) {
		parent=pcl;
		pCmdUI->Enable(FALSE);
		return;
	}
	else {
		parent=pcl->pnt();
	}

	int n=parent->cldnum();  // O̎w̌Z̐

	if (n>1)
		pCmdUI->Enable(TRUE);	// \
	else
		pCmdUI->Enable(FALSE);  // s\
}
void CWinSDJTSView::OnMenuSelseparate() 
{
	int i;

	if (m_bMenuLock)
		return;

	CWinSDJTSDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	PCELL *pcl=pKBase->lastmove(); // O̎w
	PCELL *parent;
	if (pcl==pKBase->root()) {
		parent=pcl;
		return;
	}
	else {
		parent=pcl->pnt();
	}
	int n=parent->cldnum();  // O̎w̌Z̐

	if (n<=1)
		return;

	// O̎w̃CfbNXl߂
	for (i=0;i<n;i++) {
		if (parent->cld(i)==pcl)
			break;
	}
	ASSERT(i<n);

	int idx=i; // i̋L
	CDlgSelSep DlgSelSep;
	DlgSelSep.m_iSelNo=idx;
	DlgSelSep.m_pDoc=pDoc;
	if (DlgSelSep.DoModal()!=IDOK)
		return; // LZI

	if (DlgSelSep.m_iSelNo!=idx) { // ʂ̋ǖʂIꂽB 
		// ߑJĂ邾
		if (IsCommentBoxOpened()) {
			CloseCommentBox();
		}

		// ̈ړ X[Y\ɂƏ̃_CAO̎c[𔍂ĕ\
		// ̂ł̓X[Y\͂ȂB
		if (pcl!=pKBase->root())
			pKBase->backmove2();
		pKBase->ahead2(DlgSelSep.m_iSelNo);

		// JĂeXV
		if (m_pKifFrame) {
			m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
		}

		// ǖʏ̍XV
		if (GetGuideFrame()!=NULL)
			GetGuideFrame()->Invalidate();

		if (theApp.m_bKSoundEnable)
			theApp.m_KSound.Play(); // 炷
		
		// ՑJĂeXV
		if (theApp.m_bDbeUsing) {
			CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
			if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
				CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
				pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
			}
		}

		// ߕ΂ΎIɕ\B
		AutoCommentDisplay();

		Invalidate();

		SetFocus(); // tH[JX͂֒u (02.12.22 Ver5.1d)
	}
}


// lߎvlXbh[`
UINT MateThread(CWnd *pBox,CEvent *pEvent,LPARAM lParam)
{
	CKBase *pKBase=(CKBase *)lParam;
	char dispbuf[512],mes1[80],mes2[80];

	_strdate(mes1); _strtime(mes2);
	sprintf(dispbuf,"==== lvlJn %s %s ====",mes1,mes2);
	pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)dispbuf);
	time_t time1;
	time(&time1);

	STHOUGHT st(pKBase);
	PCELL *pcl=st.mate(35,pBox,pEvent);

	time_t time2;
	time(&time2);
	_strdate(mes1); _strtime(mes2);
	time_t time3=time2-time1;
	int hh=time3/3600;
	int mm=time3%3600/60;
	int ss=time3%60;
	CString str="",str2;
	if (hh) {
		str2.Format("%d ",hh); str+=str2;
	}
	if (hh!=0 || mm!=0) {
		str2.Format("%d "	,mm); str+=str2;
	}
	str2.Format("%db"	,ss); str+=str2;
	sprintf(dispbuf,"=== vlI %s %s, vlԂ %sB ===",
		mes1,mes2,str);
	pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)dispbuf);

	return 0;
}

// obt@̋lߎvl
void CWinSDJTSView::OnUpdateMenuMateBuffer(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}
void CWinSDJTSView::OnMenuMateBuffer() 
{
	if (m_bMenuLock)
		return;

	CWinSDJTSDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	if (pKBase->root()->cldnum()) { // w肪o^ĂA
		int rc=AfxMessageBox("̃obt@̎w͑SĔj܂B낵łH",MB_YESNO);
		if (rc!=IDYES)
			return;
	}

	// j[sO
	PrepareMenuMate();

	m_bMenuLock=TRUE; // Sj[bN
	// lvl
	CDocument *pMateDoc=m_pMateTemplate->OpenDocumentFile(NULL);
	POSITION pos=pMateDoc->GetFirstViewPosition(); ASSERT(pos);
	CMateView *pMateView=(CMateView*)pMateDoc->GetNextView(pos);
	pMateView->SetNotifyWnd(this);
	pMateView->BeginThread(&MateThread,(LPARAM)pKBase); // vlN
}

// lj[sO
void CWinSDJTSView::PrepareMenuMate()
{
	CWinSDJTSDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	// ߑJĂ
	if (IsCommentBoxOpened()) {
		CloseCommentBox();
	}

	// ՑJĂ
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
			pDbeFrame->SendMessage(WM_CLOSE);  // 
		}
	}

	// EI{bNXgpȂ炱IB
	if (theApp.m_pSelectBoxB && theApp.m_bSelectBoxBUsing) {
		if ((CWinSDJTSDoc *)theApp.m_pSelectBoxB->GetSDJDocument()
			==GetDocument())
			theApp.m_pSelectBoxB->SendMessage(WM_CLOSE);
	}

	// JĂ
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_CLOSE);
	}

	// ҏWȂIB
	if (m_bKifEditing) { // ݒ蒆
		m_bKifEditing=FALSE;
		if (m_bKifSeparate)
			m_bKifSeparate=FALSE;
	}

	pKBase->recstart(); // wSďĖ{菇NA
	pDoc->SetModifiedFlag(FALSE);
}

// l̏I
// lvl_CAO{bNXvlIɋNB
void CWinSDJTSView::OnMateFinished()
{
	CWinSDJTSDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->SetModifiedFlag(FALSE); 

	if (pKBase->root()->cldnum()) { // ̋lߎ菇Ԃ
		MessageBeep(MB_ICONEXCLAMATION); // Exclamation Sound.
	}
}
// l󋵕\̏
// vl_CAO{bNXN[Y鎞ɃbZ[WɂĂ΂B
void CWinSDJTSView::OnCloseMateFrame()
{
	m_bMenuLock=FALSE;
}

// R}hj[\
void CWinSDJTSView::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}
// vr[j[\
void CWinSDJTSView::OnUpdateFilePrintPreview(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}

// lca̎vl
void CWinSDJTSView::OnUpdateMenuMateDbc(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex());
}
void CWinSDJTSView::OnMenuMateDbc() 
{
	if (m_bMenuLock)
		return;

	// lcaIB[hX_CAO{bNXƂċNB
	m_bMenuLock=TRUE; // j[bN
	m_pDlgMateDbc=new CDlgMateDbc;
	m_pDlgMateDbc->Create(IDD_DLG_MATE_DBC,this);
	m_pDlgMateDbc->ShowWindow(SW_SHOWNORMAL);
}

// lvlcaI_CAȌI
void CWinSDJTSView::OnDlgMateDbcSetnull()
{
	m_pDlgMateDbc=NULL; // j[bN
	m_bMenuLock=FALSE;
}

// lvlN
void CWinSDJTSView::OnCheckMate()
{
	OnMenuMateBuffer();
}

// lvl̒f
void CWinSDJTSView::OnUpdateMenuMateBreak(CCmdUI* pCmdUI) 
{
	// lvlJĂ邩`FbN
	POSITION pos=m_pMateTemplate->GetFirstDocPosition();
	if (pos==NULL) {
		pCmdUI->Enable(FALSE);
		return;
	}
	// lߎvl`FbN
	CDocument *pMateDoc=m_pMateTemplate->GetNextDoc(pos);
	POSITION pos2=pMateDoc->GetFirstViewPosition(); ASSERT(pos2);
	CMateView *pMateView=(CMateView*)pMateDoc->GetNextView(pos2);
	if (pMateView->IsJobWorking())
		pCmdUI->Enable(TRUE);
	else	
		pCmdUI->Enable(FALSE);
}

void CWinSDJTSView::OnMenuMateBreak() 
{
	POSITION pos=m_pMateTemplate->GetFirstDocPosition();
	if (pos==NULL)
		return;
	CDocument *pMateDoc=m_pMateTemplate->GetNextDoc(pos);
	POSITION pos2=pMateDoc->GetFirstViewPosition(); ASSERT(pos2);
	CMateView *pMateView=(CMateView*)pMateDoc->GetNextView(pos2);
	if (pMateView->IsJobWorking()) // vlȂ璆f
		pMateView->SendMessage(WM_COMMAND,ID_MATE_THINK_BREAK); 
}


/*
    ujQwwwL[̃`FbN @ '02.12.21 by Ra
		Insert(VK_INSERT)	:I
 */
void CWinSDJTSView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (GetFocus()!=this) 
		return ; // ̃`FbN͕svAÖׁB

	/* I */
	if (nChar == VK_INSERT ) {
		OnMenuSelseparate();
	}
	
	CSDJView::OnKeyDown(nChar, nRepCnt, nFlags);
}
