/*********************/
/*    DbeView.cpp    */
/*********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DbeView.h"
#include "selectboxb.h"
#include "dbedoc.h"
#include "kbase.h"
#include "dbe.h"
#include <sbase.h>
#include "sdjdoc.h"
#include "sdjview.h"
#include "winsdjview.h"
#include "dbeframe.h"
#include "dlgecellbox.h"
#include "dlgevalbox.h"
#include "winsdjdoc.h"
#include "winsdjtsdoc.h"
#include "kifframe.h"
#include "winsdjtsview.h"
#include "selectboxc.h"
#include "sdjjcmntdoc.h"
#include "sdjjcmntframe.h"
#include "sdjjcmntview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CWinSDJApp theApp;
extern HANDLE g_hDblock;

/////////////////////////////////////////////////////////////////////////////
// CDbeView

IMPLEMENT_DYNCREATE(CDbeView, CTreeView)

CDbeView::CDbeView()
{
	m_bLButtonDblClkking=FALSE; 
	m_bInitRootprocessing=FALSE;
	m_bOnReturnprocessing=FALSE;
	m_bJsCommentDisp=TRUE;
	m_bDbLocking=FALSE;
	m_pDlgEcellBox=NULL;
	m_pDlgEvalBox=NULL;

	// w蒍ߑ
	m_pSDJJCmntTemplate=new CSSdjDocTemplate(
		IDR_SDJEDITFRAME,
		RUNTIME_CLASS(CSDJJCmntDoc),
		RUNTIME_CLASS(CSDJJCmntFrame),
		RUNTIME_CLASS(CSDJJCmntView));

	// ߑ\ʒu
	CString strSection=EDITOR_SECTION;
	int x1=theApp.GetProfileInt(strSection,JCMNT_POS_X1,0);
	int y1=theApp.GetProfileInt(strSection,JCMNT_POS_Y1,0);
	int x2=theApp.GetProfileInt(strSection,JCMNT_POS_X2,0);
	int y2=theApp.GetProfileInt(strSection,JCMNT_POS_Y2,0);
	CRect rc1(x1,y1,x2,y2); rc1.NormalizeRect(); // L̈
	int scW=GetSystemMetrics(SM_CXSCREEN);
	int scH=GetSystemMetrics(SM_CYSCREEN);
	CRect rc2(0,0,scW,scH); rc2.NormalizeRect(); // XN[̈
	CRect rc3;
	if (rc3.IntersectRect(&rc1,&rc2)) { // dȂ肪΋L̗p
		m_rcJCmntBoxPos.SetRect(x1,y1,x2,y2);
	}
	else {
		m_rcJCmntBoxPos.SetRectEmpty();
	}
}

CDbeView::~CDbeView()
{
}

BEGIN_MESSAGE_MAP(CDbeView, CTreeView)
	//{{AFX_MSG_MAP(CDbeView)
	ON_COMMAND(ID_MENU_SELECTBOX, OnMenuSelectbox)
	ON_NOTIFY_REFLECT(TVN_SELCHANGING, OnSelchanging)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemexpanding)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDED, OnItemexpanded)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_WM_LBUTTONDBLCLK()
	ON_NOTIFY_REFLECT(NM_RETURN, OnReturn)
	ON_COMMAND(ID_DBE_REINITROOT,OnDbeReinitRoot)
	ON_UPDATE_COMMAND_UI(ID_JSCMNTEDIT, OnUpdateJsCmntedit)
	ON_COMMAND(ID_JSCMNTEDIT, OnJsCmntedit)
	ON_COMMAND(ID_JSEXIT, OnJsExit)
	ON_UPDATE_COMMAND_UI(ID_VIEW_JSCMNT, OnUpdateViewJsCmnt)
	ON_COMMAND(ID_VIEW_JSCMNT, OnViewJsCmnt)
	ON_UPDATE_COMMAND_UI(ID_JSBCOMEDIT, OnUpdateJsBcomedit)
	ON_COMMAND(ID_JSBCOMEDIT, OnJsBcomedit)
	ON_UPDATE_COMMAND_UI(ID_MENU_SELECTBOX, OnUpdateMenuSelectbox)
	ON_WM_CHAR()
	ON_UPDATE_COMMAND_UI(ID_MENU_JPLAY_PROPERTY, OnUpdateMenuJplayProperty)
	ON_COMMAND(ID_MENU_JPLAY_PROPERTY, OnMenuJplayProperty)
	ON_UPDATE_COMMAND_UI(ID_MENU_EVAL, OnUpdateMenuEval)
	ON_COMMAND(ID_MENU_EVAL, OnMenuEval)
	ON_COMMAND(ID_DLG_ECELLBOX_SETNULL,OnEcellBoxSetnull)
	ON_COMMAND(ID_DLG_EVALBOX_SETNULL,OnEvalBoxSetnull)
	ON_COMMAND(ID_ECELLBOX_INITDATA,OnEcellBoxInitData)
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_UPDATE_COMMAND_UI(ID_MENU_DELETE_JS, OnUpdateMenuDeleteJs)
	ON_COMMAND(ID_MENU_DELETE_JS, OnMenuDeleteJs)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CTreeView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDbeView `

void CDbeView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
}

void CDbeView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	// TODO: GetTreeCtrl() o֐̌ĂяoʂĒڂ̃Xg Rg[
	// ANZX邱Ƃɂ TreeView ACeŌŒł܂B
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	/* 
	c[ Rg[̃X^C(eNjJm[gUO)
	c[ Rg[̊Oς̓X^CɂčE܂Bc[ Rg
	[̍쐬ɂ́AX^C̏lݒ肵܂BGetWindowLong 
	                                                  ~~~~~~~~~~~~~
	SetWindowLong ̊e Windows ֐gāAc[ Rg[쐬
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	łX^C擾ύXł܂B	TVS_HASLINES X^C͎q
	      ~~~~~~~~~~~~~~~~~~~~~~~~     
	ڂƑΉeڂŃN邱ƂŃc[ Rg[̃OtB
	bN\܂B̃X^Cł́AڂKw\̃[gɂ̓
	N܂Bڂ[gɃNɂ́ATVS_HASLINES X^C 
	            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	TVS_LINESATROOT X^Cgݍ킹Kv܂B
    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	[U[eڂ_uNbNƁAqڂ̃Xgg܂͏k
	܂BTVS_HASBUTTONS X^Cc[ Rg[ɂ́Aeڂ
	        ~~~~~~~~~~~~~~~~~~~~~~~~							  ~~~~~~~~
	Ƀ{^ǉ܂B[U[́Ã{^NbN邱Ƃ
	~~~~~~~~~~~~~~~~~~~~~~~~~~
	qڂ̃Xgg܂͏kł悤ɂȂ܂BTVS_HASBUTTONS 
	͊Kw\̃[gɂ̓{^ǉ܂BKw\̃[gɃ{^
												~~~~~~~~~~~~~~~~~~~~~~~~~~
	ǉɂ́ATVS_HASLINESATVS_LINESATROOTA TVS_HASBUTTONSg
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	ݍ킹Kv܂B*/
	DWORD dwStyle=GetWindowLong(TreeCtrl.m_hWnd,GWL_STYLE);
	SetWindowLong(TreeCtrl.m_hWnd,GWL_STYLE,
		dwStyle | TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS);


	// RootItem̐ݒ
	// eǖʂǖʂƂĐݒ肵ARootItemo^B
	// o^Βj̒ՎIB
	InitRoot();
}

/////////////////////////////////////////////////////////////////////////////
// CDbelView NẌ

BOOL CDbeView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CDbeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CDbeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CDbeView ff

#ifdef _DEBUG
void CDbeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CDbeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

CDbeDoc *CDbeView::GetDocument()
{
	CDbeDoc *pDoc=(CDbeDoc *)CTreeView::GetDocument();
	ASSERT(pDoc);
	ASSERT(pDoc->IsKindOf(RUNTIME_CLASS(CDbeDoc)));
	return pDoc;
}

/////////////////////////////////////////////////////////////////////////////
// CDbeView bZ[W nh

////
// ΋ǃf[^x[X̌EI
BOOL CDbeView::UpdateMenuSelectboxB()
{
	BOOL bEnable=TRUE;
	if (theApp.m_bSelectBoxBUsing)
		bEnable=FALSE;
	return bEnable;
}
void CDbeView::OnUpdateMenuSelectbox(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(UpdateMenuSelectboxB());
}
void CDbeView::OnMenuSelectbox() 
{
	CDbeDoc *pDoc=GetDocument();
	CSDJDoc *pSDJDoc0=pDoc->GetSDJDocument();
	CWaitCursor wcur; // v

	// ΋Ǌ
	if (pSDJDoc0->IsKindOf(RUNTIME_CLASS(CWinSDJDoc))) {
		CWinSDJDoc *pSDJDoc=(CWinSDJDoc *)pSDJDoc0;
		CWinSDJView *pSDJView=(CWinSDJView*)pSDJDoc->GetSDJView();
		// ΋ǂcaEI_CAO{bNX
		CSelectBoxB *pSelectBoxB;
		pSelectBoxB = new CSelectBoxB;		// [hX_CAO{bNX
		pSelectBoxB->SetSDJDocument(pSDJDoc);
		pSelectBoxB->Create(IDD_SelectBoxB,pSDJView);
		pSelectBoxB->ShowWindow(SW_SHOWNORMAL);
	}
	// l
	else if (pSDJDoc0->IsKindOf(RUNTIME_CLASS(CWinSDJTSDoc))) {
		CWinSDJTSDoc *pSDJTSDoc=(CWinSDJTSDoc *)pSDJDoc0;
		CWinSDJTSView *pSDJTSView=(CWinSDJTSView*)pSDJTSDoc->GetSDJView();
		// lcaEI_CAO{bNX
		CSelectBoxC *pSelectBoxC;
		pSelectBoxC = new CSelectBoxC;		// [hX_CAO{bNX
		pSelectBoxC->SetSDJDocument(pSDJTSDoc);
		pSelectBoxC->Create(IDD_SelectBoxC,pSDJTSView);
		pSelectBoxC->ShowWindow(SW_SHOWNORMAL);
	}
	else {
		TRACE("Program Error\n");
		ASSERT(0);
	}
}


void CDbeView::OnSelchanging(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	HTREEITEM hItem=pNMTreeView->itemNew.hItem; // VIꂽItem
	if (hItem==NULL)
		return;
	// JBbase̋ǖʂ̈ʒuɈړB
	JumpTo(hItem);
	JumpListClear(); // L͂Ȃ

	*pResult = 0;
}

void CDbeView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	// `]lJĂ\XV
	if (m_pDlgEvalBox)
		m_pDlgEvalBox->SendMessage(WM_COMMAND,ID_EVALBOX_INITDATA);
	// Վlݒ葋JĂ\XV
	if (m_pDlgEcellBox)
		m_pDlgEcellBox->SendMessage(WM_COMMAND,ID_ECELLBOX_INITDATA);

	*pResult = 0;
}

void CDbeView::OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	CDbeDoc *pDoc=GetDocument();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();

	HTREEITEM hParent=pNMTreeView->itemNew.hItem;
	if (hParent==NULL)
		return;

	if (m_bLButtonDblClkking && !m_bInitRootprocessing) {
		return ; // _uNbNKĂ΂邪InitRoot̕B
	}

	if (m_bDbLocking) {
		return; // ̃Xbh̑̕łcaANZX҂
	}

	BOOL bFirstExpand=!(TreeCtrl.GetItemState(hParent,TVIS_EXPANDEDONCE) & 
		                TVIS_EXPANDEDONCE);
	// ̍ڂ߂ĊJAZbg(qevallŃZbg)B
	if (bFirstExpand) {
		CDBE Dbe;
		if (!Dbe.Open()) // ՂcãI[v
			return;
		CDbeFrame *pFrame=(CDbeFrame *)GetParentFrame();

		// 񂾂cabNċreturnB(̂ InitRoot or )
		// DbLockModal()ĂԂƕGɂȂG[NB
		if (WaitForSingleObject(g_hDblock,0)!=WAIT_OBJECT_0) {
			Dbe.Close();
			return ;
		}
		pFrame->SetCloseLock(TRUE);
		m_bDbLocking=TRUE;

		if (m_bLButtonDblClkking && !m_bInitRootprocessing) {
			ReleaseMutex(g_hDblock); // DB unlock
			m_bDbLocking=FALSE;
			pFrame->SetCloseLock(FALSE);
			Dbe.Close();
			return ;
		}
		// 炪Expand
		HTREEITEM hChild=TreeCtrl.GetChildItem(hParent); // j
		while (hChild) {
			JumpTo(hChild);
			// ̎q̑o^B(̎q͓o^Ȃ)
			POSITION pos=(POSITION)TreeCtrl.GetItemData(hChild);
			CEcell *eclCld=pEcellList->GetAt(pos);
			// ՋǖʂJ
			InsertItem(eclCld,&Dbe,hChild);
			JumpBack();

			hChild=TreeCtrl.GetNextSiblingItem(hChild);  // jAOj...
		}
		Dbe.Close();
		ReleaseMutex(g_hDblock); // DB unlock
		m_bDbLocking=FALSE;
		pFrame->SetCloseLock(FALSE);
	}

	*pResult = 0;
}

void CDbeView::OnItemexpanded(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	*pResult = 0;
}

void CDbeView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	/*   1997.05
	̃[`OnLButtonDblClk̒Itemqbgꂽ
	Ă΂BÃ[`̒Ń_uNbN̏
	ARg[̒ŃsANZXNB
	[`̒łItem̍폜A}͑ʖڂ̂悤Ȃ̂ŁA
	OnLButtonDblClk̒ōsƂɂB*/

	*pResult = 0;
}

////
// RootItem ehLǧǖʂŏB
//  ߂l ړo^L/  TRUE/FALSE
BOOL CDbeView::InitRoot()
{
	// InitRoot͗DIɋNāAcabN҂֎Ă䂭B΁A
	// ̏̓bN҂ɏIBł͂QdN݂̂h~B
	if (m_bInitRootprocessing) {
		return FALSE; // ̃Xbh̑̕łcaANZX҂
	}

	m_bInitRootprocessing=TRUE;

	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CJBase *pJBase=pDoc->GetJBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();

	// 悸dn߂OɁA߃{bNXJĂ
	if (IsJCommentBoxOpened()) {
		CloseJCommentBox();
	}
	if (m_pDlgEcellBox)
		m_pDlgEcellBox->SendMessage(WM_CLOSE); // Վlݒ葋
	if (m_pDlgEvalBox)
		m_pDlgEvalBox->SendMessage(WM_CLOSE); // `]lݒ葋
	

	CDBE Dbe; // Ղca
	if (!Dbe.Open()) {
		m_bInitRootprocessing=FALSE;
		return FALSE; // I[vs
	}

	// ROOTo^
	// RootƂ̎qo^
	CDbeFrame *pFrame=(CDbeFrame *)GetParentFrame();
	pFrame->SetCloseLock(TRUE);
	m_bDbLocking=TRUE;

	WaitForSingleObject(g_hDblock,INFINITE); // Db lock

	CEcell eclRoot;

	// ehLǧ݂̋ǖ
	eclRoot.Bform = *pKBase->btype();
	eclRoot.side  = pKBase->turn();
	if (pKBase->lastmove()!=pKBase->root()) {
		// ǖʂłȂ΂caǂőOǖʂ̎wZbgB
		CBform Bform; int side;
		eclRoot.bplay=pKBase->LastBplay(&Bform,&side); // O̎w
		short eval,attr; B_PLAY bplay;
		int rc=Dbe.FindBplay(&Bform,side,&eval,&bplay,&attr);
		while (rc==E$OK) {
			if (bplay==eclRoot.bplay) {
				eclRoot.attr=attr;
				break;
			}
			rc=Dbe.NextBplay(&eval,&bplay,&attr);
		}
	}

	// ehLgƓǖʂɌǖʂݒ肷B
	// w͑SĔjB
	pJBase->SetAspect(&eclRoot.Bform, eclRoot.side);
	TreeCtrl.DeleteAllItems();
	pEcellList->RemoveAll();

	if (eclRoot.side!=1 && eclRoot.side!=0) {
		m_bInitRootprocessing=FALSE;
		ReleaseMutex(g_hDblock); // Db unlock
		m_bDbLocking=FALSE;
		pFrame->SetCloseLock(FALSE);
		return FALSE; // Ԃ̂Ȃǖʂ͕\łȂB
	}

	// ՋǖʂJ
	HTREEITEM hItem=InsertItem(&eclRoot,&Dbe,TVI_ROOT);

	Dbe.Close();							// ՂcaN[Y
	ReleaseMutex(g_hDblock);				// Db unlock
	m_bDbLocking=FALSE;
	pFrame->SetCloseLock(FALSE);

	if (hItem) {
		TreeCtrl.SelectItem(hItem);			// 悸RootIB
		TreeCtrl.Expand(hItem,TVE_EXPAND);  // RootJ
		HTREEITEM hChild=TreeCtrl.GetChildItem(hItem); // Root̒j
		if (hChild) {
			TreeCtrl.SelectItem(hChild);	// jIB
		}
		m_bInitRootprocessing=FALSE;
		return TRUE;
	}
	else {
		m_bInitRootprocessing=FALSE;
		return FALSE;
	}
}

////
// ڂ̑}
//  Ղca pDbe̓I[vςł邱ƁB
//  JBase̋ǖʂpeclPnt->Bform̋ǖʂɂȂĂ邱ƁB
//  ߂l  }ڂHTREEITEMB}ȂNULL
HTREEITEM  CDbeView::InsertItem(CEcell *peclPnt,CDBE *pDbe,
						  HTREEITEM hPnt,HTREEITEM hIns)
{
	CDbeDoc *pDoc=GetDocument();
	CJBase *pJBase=pDoc->GetJBase();
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	HTREEITEM hParent=NULL;
	CEcell eclHere;

	// 悸Վ(j)B
	int rc=pDbe->FindBplay(&peclPnt->Bform, peclPnt->side,
		&peclPnt->eval,&eclHere.bplay,&eclHere.attr);

	// Վ肪o^Ă
	if (rc==E$OK) {
		TV_INSERTSTRUCT tv_ins;
		POSITION pos;
		// e̓o^(Root̎)
		if (hPnt==TVI_ROOT) {
			tv_ins.hParent=hPnt;
			tv_ins.hInsertAfter=hIns;
			peclPnt->level=0;						// [level=0;
			SetStrMove(peclPnt);					// `\L̐ݒ
			pos=pEcellList->AddTail(*peclPnt);		// EcellList֒ǉ
			SetTVItem(peclPnt,pos,&tv_ins.item);	// }ڂ̐ݒ
			hParent=TreeCtrl.InsertItem(&tv_ins);	// o^
		} else {
			hParent=hPnt;							// RootȊOhPnte
		}
		do {
			// ǖʂOiĎq̋ǖʂ
			if(!pJBase->move2(eclHere.bplay))
				break; // error

			// q̋ǖʂݒ
			pJBase->GetAspect(&eclHere.Bform,&eclHere.side);

			// q̓o^
			tv_ins.hParent=hParent; 
			tv_ins.hInsertAfter=TVI_LAST;			// qLASTŒǉ
			eclHere.level=peclPnt->level+1;			// [(level)͐e+1
			SetStrMove(&eclHere);					// `\L
			pos=pEcellList->AddTail(eclHere);		// EcellListǉ
			SetTVItem(&eclHere,pos,&tv_ins.item);	// }ڐݒ
			TreeCtrl.InsertItem(&tv_ins);			// o^

			pJBase->backmove2();					// eǖʂ֖߂

			// Z̏
			eclHere.eval=0;
			short eval; // for dummy
			rc=pDbe->NextBplay(&eval,&eclHere.bplay,&eclHere.attr);

		} while (rc==E$OK);
	}

	return hParent;
}

////
// `\L̐ݒ(Root̎bplaỹZbg)
void CDbeView::SetStrMove(CEcell *ecl)
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CJBase *pJBase=pDoc->GetJBase();
	PCELL *pcl=pJBase->lastmove();

	if (pcl==pJBase->root()) {						// wȂ(RootȂ)
		// !! ecl->bplays̏ꍇ
		// ehLgǖʂƌǖʂłOB
		pcl=pKBase->lastmove();  // ehLg
		if (pcl==pKBase->root())
			ecl->strMove.Format("%s","ǖ");
		else
			ecl->strMove.Format("%s",pKBase->mvstr(pcl));
	}
	else {
		// !! ecl->bplaym̏ꍇ
		// JBaseǖʂecl->bplayōXVꂽ̋ǖʂłOB
		ecl->strMove.Format("%s",pJBase->mvstr(pcl));
	}
}

////
// }ڂ̐ݒ
void CDbeView::SetTVItem(CEcell *ecl, POSITION pos, TV_ITEM *tvi)
{
	memset(tvi,0,sizeof (TV_ITEM));

	tvi->mask = (TVIF_TEXT | TVIF_PARAM);

	tvi->cchTextMax=ecl->strMove.GetLength()+1; // 
	tvi->pszText=(char *)((LPCTSTR)(ecl->strMove));

	// lParam
	tvi->lParam=(LPARAM)pos;
}


////
// WvXg̃NA
void CDbeView::JumpListClear()
{
	FromList.RemoveAll();
	ToList.RemoveAll();
	hCommon=NULL;
}
////
// ڋǖʂւ̃Wv
//   w肳ꂽڂ̋ǖʂJBaseݒ肷
void CDbeView::JumpTo(HTREEITEM hTo)
{
	CDbeDoc *pDoc=GetDocument();
	CJBase *pJBase=pDoc->GetJBase();
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	POSITION pos;

	HTREEITEM hFrom=TreeCtrl.GetSelectedItem();		// ʒu
	if (hFrom==NULL)
		return; // ŏ̈񂾂͂ȂB
	
	JumpListClear();  // WvXg̃NA

	// 悸͐[(level)킹
	pos=(POSITION)TreeCtrl.GetItemData(hTo);
	CEcell *eclTo=pEcellList->GetAt(pos);
	pos=(POSITION)TreeCtrl.GetItemData(hFrom);
	CEcell *eclFrom=pEcellList->GetAt(pos);
	while ( (eclTo->level != eclFrom->level) &&		// [
			(hTo != hFrom) ) {						// ʂ̐ełȂ
		if (eclTo->level > eclFrom->level) {
			// _[ꍇALĈ
			ToList.AddHead(*eclTo);
			hTo=TreeCtrl.GetParentItem(hTo);
			ASSERT(hTo);
			pos=(POSITION)TreeCtrl.GetItemData(hTo);
			eclTo=pEcellList->GetAt(pos);
		} else {
			// _[ꍇALĈ
			FromList.AddHead(*eclFrom);
			hFrom=TreeCtrl.GetParentItem(hFrom);
			ASSERT(hFrom);
			pos=(POSITION)TreeCtrl.GetItemData(hFrom);
			eclFrom=pEcellList->GetAt(pos);
		}
	}

	// [(level)Aʂ̐e܂Ŗ߂
	while (hTo != hFrom) {						// ̏level͓
		// ƂLB
		ToList.AddHead(*eclTo);
		FromList.AddHead(*eclFrom);

		// Ƃ
		hTo   =TreeCtrl.GetParentItem(hTo);
		hFrom =TreeCtrl.GetParentItem(hFrom);
		pos=(POSITION)TreeCtrl.GetItemData(hTo);
		eclTo=pEcellList->GetAt(pos);
		pos=(POSITION)TreeCtrl.GetItemData(hFrom);
		eclFrom=pEcellList->GetAt(pos);
	}

	hCommon = hTo;
	ASSERT(hCommon);

	int iBack=FromList.GetCount();
	for (int i=0;i<iBack;i++) {
		pJBase->backmove2();
	}

	pos=ToList.GetHeadPosition();
	while (pos) {
		CEcell &ecl=ToList.GetNext(pos);
		pJBase->move2(ecl.bplay);
	}
}

////
// Wv֖߂
void CDbeView::JumpBack()
{
	CDbeDoc *pDoc=GetDocument();
	CJBase *pJBase=pDoc->GetJBase();

	int iBack=ToList.GetCount();
	for (int i=0;i<iBack;i++) {
		pJBase->backmove2();
	}

	POSITION pos=FromList.GetHeadPosition();
	while (pos) {
		CEcell &ecl=FromList.GetNext(pos);
		pJBase->move2(ecl.bplay);
	}

	JumpListClear();
}

//////
// _uNbNRootJ
void CDbeView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	if (m_bOnReturnprocessing | m_bLButtonDblClkking)
		return ; // ^[L[Ɣr

	CDbeDoc *pDoc=GetDocument();
	CSDJDoc *pSDJDoc=pDoc->GetSDJDocument();
	CSDJView* pSDJView=pSDJDoc->GetSDJView();
	if (pSDJView->IsAutoPlay())
		return ; // ǖʂXV͖

	m_bLButtonDblClkking=TRUE;
	BOOL bCheckOK=TRUE;

	// ߑJĂ邾(Ȃƈȉ͕̏s)
	// ReOpenRoot()ōĂђߑJƂ
	if (IsJCommentBoxOpened()) {
		CloseJCommentBox();
		bCheckOK=FALSE;
	}
	if (m_pDlgEcellBox) {
		m_pDlgEcellBox->SendMessage(WM_CLOSE);	// Վlݒ葋
		bCheckOK=FALSE;
	}
	if (m_pDlgEvalBox) {
		m_pDlgEvalBox->SendMessage(WM_CLOSE);	// `]lݒ葋
		bCheckOK=FALSE;
	}

	if (bCheckOK==FALSE) {
		m_bLButtonDblClkking=FALSE;
		return;
	}

	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	UINT flag;
	HTREEITEM hTarget=TreeCtrl.HitTest(point,&flag);
	if (hTarget) {								// qbgꂽ̂ȂΏI
		ReOpenRoot(hTarget);					// RootƂčďB
	}

	m_bLButtonDblClkking=FALSE;

	// ftHg̏ĂԂOnDblClk,OnItemexpanding΂B
	CTreeView::OnLButtonDblClk(nFlags, point);

	// ߃{bNXJĂAփtH[JXZbg
	// (̏ŃtH[JXՑɈڂĂ邩)
	if (IsJCommentBoxOpened()) {
		CFrameWnd *pFrame=m_pSDJJCmntTemplate->GetFrameWnd();
		pFrame->SetFocus();
	}
}

//////
// ^[L[RootJ
//   beep͂ǂď̂낤??(邳...)
void CDbeView::OnReturn(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if (m_bLButtonDblClkking | m_bOnReturnprocessing)
		return; // OnLButtonDblClk Ɣr

	CDbeDoc *pDoc=GetDocument();
	CSDJDoc *pSDJDoc=pDoc->GetSDJDocument();
	CSDJView* pSDJView=pSDJDoc->GetSDJView();
	if (pSDJView->IsAutoPlay())
		return ; // ǖʂXV͖

	m_bOnReturnprocessing=TRUE;

	BOOL bCheckOK=TRUE;
	// ߑJĂ邾(Ȃƈȉ͕̏s)
	// ReOpenRoot()ōĂђߑJƂ
	if (IsJCommentBoxOpened()){
		CloseJCommentBox();
		bCheckOK=FALSE;
	}
	if (m_pDlgEcellBox) {
		m_pDlgEcellBox->SendMessage(WM_CLOSE);		// Վlݒ葋
		bCheckOK=FALSE;
	}
	if (m_pDlgEvalBox) {
		m_pDlgEvalBox->SendMessage(WM_CLOSE);		// `]lݒ葋
		bCheckOK=FALSE;
	}
	if (bCheckOK==FALSE) {
		m_bOnReturnprocessing=FALSE;
		return;
	}



	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	HTREEITEM hTarget=TreeCtrl.GetSelectedItem();
	if (hTarget) {
		ReOpenRoot(hTarget); // ď 
	}
	
	*pResult = 0;
	m_bOnReturnprocessing=FALSE;
}

////////
// ŏ
// w肳ꂽڂ[gɂčēxInitRoot()Ă
void CDbeView::ReOpenRoot(HTREEITEM hTarget)
{
	CDbeDoc *pDoc=GetDocument();
	CSDJDoc *pSDJDoc=pDoc->GetSDJDocument();
	CSDJView* pSDJView=pSDJDoc->GetSDJView();
	CKBase *pKBase=pDoc->GetKBase();
	CJBase *pJBase=pDoc->GetJBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();

	// ehLg̋ǖʂJBaseRootɂ̂Ő悸JBase
	// RootIĂփWvB
	HTREEITEM hRoot=TreeCtrl.GetRootItem();
	TreeCtrl.SelectItem(hRoot); // OnSelChangingĂ΂

	// ړIʒu܂JBaseWvB
	JumpTo(hTarget); // ToListւ̎菇L^ꂽB
	// ̃Rs[(ȂƌToList͔j󂳂)
	CList <CEcell,CEcell&> TargetList;
	POSITION pos=ToList.GetHeadPosition();
	while (pos) {
		CEcell &ecl=ToList.GetNext(pos);
		TargetList.AddTail(ecl);
	}
	JumpBack(); // Rootɖ߂

	// KBaseړIʒu܂ňړBJBase͂ɍ킹
	// wIBẅړTreeViewŌB
	HTREEITEM hThis=hRoot; // JBasěʒu(ORootI)
	POSITION p=TargetList.GetHeadPosition();
	while (p) {
		CEcell &ecl=TargetList.GetNext(p);				// ŏ̎w
		// wJBaseItemhThis̎q̒T
		HTREEITEM hChild=TreeCtrl.GetChildItem(hThis);	// j
		while (hChild) {
			POSITION p2=(POSITION)TreeCtrl.GetItemData(hChild);
			CEcell &secl=pEcellList->GetAt(p2);			// ̎q̎w
			if (secl.bplay==ecl.bplay) {				// v炻̎qI
				// Ց̑Iړ
				TreeCtrl.SelectItem(hChild);			// OnSelChanging΂
				hThis=hChild;							// ̎q֍~
				break;
			}
			hChild=TreeCtrl.GetNextSiblingItem(hChild);	// j...
		}
		ASSERT(hChild); // q͐΂Ɍ锤
		// er[ɒߑJĂ炱
		pSDJView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);
		pKBase->move(ecl.bplay); // KBaseXVĉʂ
		// er[̏̕\XVB(JĂ)
		pSDJView->PostMessage(WM_COMMAND,ID_GUIDEFRAME_INVALIDATE);
	}

	// er[̊JĂ炱B
	CKifFrame *pKifFrame=pSDJView->GetKifFrame();
	if (pKifFrame) {
		pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
	}

	// KBaseړIʒu܂ňړARootɒՑJ
	// ōڂ̑}ƏIs(OnSelchanging,OnItemexpandig)
	InitRoot();

	// Վ蒍߂̕\ݒ
	if (m_bJsCommentDisp)
		PopupBcom();

	// Ջǖʒ߂̕\ݒ
	if (m_bJsCommentDisp)
		PopupKcom();
}

////
// bZ[Wɂ鏉
void CDbeView::OnDbeReinitRoot()
{
	// ͉ȂB
	if ( m_bInitRootprocessing || m_bLButtonDblClkking || m_bOnReturnprocessing)
		return;
	InitRoot();
}

////////
/// Վ蒍߂̕\ݒ
//      KBase̋ǖʂO(JBase͊֌WȂ)
//      bEdit ߖ̎̃I[v(ftHg͖ FALSE)
void CDbeView::PopupBcom(BOOL bEdit)
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	PCELL *pcl=pKBase->lastmove();
	if (pcl==pKBase->root())
		return ; // ǖ

	CBform Bform;
	int side;
	// B`̎w擾
	B_PLAY bplay=pKBase->LastBplay(&Bform,&side);

	// w̕\L擾B
	CString strMove;
	strMove.Format("%s",pKBase->mvstr(pcl));
	
	PopupBcom(&Bform,side,bplay,&strMove,bEdit);
}

////////
/// Վ蒍߂̕\ݒ
//      ǖ(bp,side)̎w(bplay,pstrMove)̎w蒍߂̕\ݒ
//      bEdit ߖ̎̃I[v(ftHg͖ FALSE)
void CDbeView::PopupBcom(CBform *bp,int side,B_PLAY bplay,CString *pstrMove,BOOL bEdit)
{
	if (IsJCommentBoxOpened())
		return;

	CDBE Dbe;
	if (!Dbe.Open())
		return; // ՂcaI[vs
	CDbeFrame *pFrame=(CDbeFrame *)GetParentFrame();
	pFrame->SetCloseLock(TRUE);
	m_bDbLocking=TRUE;
	if (WaitForSingleObject(g_hDblock,0)!=WAIT_OBJECT_0) { // Db lock
		m_bDbLocking=FALSE;
		pFrame->SetCloseLock(FALSE);
		return;
	}
	CString com;
	CString ckey;
	CWaitCursor wcur; // v([_[v̌ɒu)
	// ̏98̕ϊĂ̂Œ͎͂ԂB
	BOOL find=Dbe.GetBcomRead(bp,side,bplay,&ckey,&com);
	Dbe.Close();
	ReleaseMutex(g_hDblock); // Db unlock
	m_bDbLocking=FALSE;
	pFrame->SetCloseLock(FALSE);
	if (find==FALSE && bEdit==FALSE)
		return; // Վ蒍߂͖o^łB

	// ߕ̃_CAO{bNX\
	OpenJCommentBox(*pstrMove,2,ckey,com);
}

//////////
// Ջǖʒ߂̕\ҏW
//  KBaseǖ
void CDbeView::PopupKcom(BOOL bEdit)
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	CBform Bform=pKBase->btype();
	int side=pKBase->turn();

	// w薼̂߂
	CString strMove;
	PCELL *pcl=pKBase->lastmove();
	if (pcl==pKBase->root()) // ǖ
		strMove="ǖ";
	else {
		strMove.Format("%s",pKBase->mvstr(pcl));
	}

	PopupKcom(&Bform,side,&strMove,bEdit);
}

//////////
// Ջǖʒ߂̕\ҏW
//  wǖ(bp,side) w(pstrMove)܂ł̋ǖ
void CDbeView::PopupKcom(CBform *bp,int side,CString *pstrMove,BOOL bEdit)
{
	if (IsJCommentBoxOpened())
		return;

	CDBE Dbe;
	if (!Dbe.Open())
		return; // ՂcaI[vs
	CDbeFrame *pFrame=(CDbeFrame *)GetParentFrame();
	pFrame->SetCloseLock(TRUE);
	m_bDbLocking=TRUE;
	if (WaitForSingleObject(g_hDblock,0)!=WAIT_OBJECT_0) { // Db lock
		m_bDbLocking=FALSE;
		pFrame->SetCloseLock(FALSE);
		return;
	}
	CString com;
	CString ckey;
	CWaitCursor wcur; // v([_[v̌ɒu)
	// ̏98̕ϊĂ̂Œ͎͂ԂB
	BOOL find=Dbe.GetKcomRead(bp,side,&ckey,&com);
	Dbe.Close();
	ReleaseMutex(g_hDblock); // Db unlock
	m_bDbLocking=FALSE;
	pFrame->SetCloseLock(FALSE);
	if (find==FALSE && bEdit==FALSE)
		return; // Վ蒍߂͖o^łB

	// ߕ̃_CAO{bNX\
	OpenJCommentBox(*pstrMove,1,ckey,com);
}

//////
// Ց̏I
void CDbeView::OnJsExit() 
{
	GetParentFrame()->PostMessage(WM_CLOSE);
}

///////
// ՃRg̕\/\
BOOL CDbeView::UpdateViewJsCmnt()
{
	return m_bJsCommentDisp;
}
void CDbeView::OnUpdateViewJsCmnt(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(UpdateViewJsCmnt());
}
void CDbeView::OnViewJsCmnt() 
{
	m_bJsCommentDisp=!m_bJsCommentDisp;
}

///////
// Ջǖʂ̕ҏW
BOOL CDbeView::UpdateJsCmntedit()
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	if (IsJCommentBoxOpened())
		return FALSE;

	if (theApp.m_bSelectBoxBUsing)
		return FALSE; // EI_CAOgp

	HTREEITEM hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL)
		return FALSE; // Վ肪Ȃ

	HTREEITEM hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL) // I
		return FALSE;

	// WinSDJ5.1 by KY.00/2/20
	// [̎w̏ꍇA̎w̋ǖʂo^Ȃ̂
	// j[\Ȃ悤ɂB
	if (!TreeCtrl.ItemHasChildren(hNow))
		return FALSE;

	return TRUE;
}
void CDbeView::OnUpdateJsCmntedit(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(UpdateJsCmntedit());
}
void CDbeView::OnJsCmntedit() 
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	if (IsJCommentBoxOpened())
		return;

	if (theApp.m_bSelectBoxBUsing)
		return; // EI_CAOgp

	HTREEITEM hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL)
		return; // Վ肪Ȃ

	HTREEITEM hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL) // I
		return;


	POSITION pos=(POSITION)TreeCtrl.GetItemData(hNow);
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CEcell *eclCld=pEcellList->GetAt(pos);

	// ŐǖʂƂɎw薼̂߂ 
	CBform Bform; int side;
	CString strMove;

	Bform=eclCld->Bform;  
	side=eclCld->side;
	strMove=eclCld->strMove;

	PopupKcom(&Bform,side,&strMove,TRUE);
}

//////
// Վ蒍߂̕ҏW
//  ݑIĂՎ肪Ώ
BOOL CDbeView::UpdateJsBcomedit()
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	if (IsJCommentBoxOpened())
		return FALSE;		// ɊJĂ

	if (theApp.m_bSelectBoxBUsing)
		return FALSE;		// EI_CAOgp

	HTREEITEM hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL)
		return FALSE;		// Վ肪Ȃ

	HTREEITEM hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL)			// I
		return FALSE;

	POSITION pos=(POSITION)TreeCtrl.GetItemData(hNow);
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CEcell *eclCld=pEcellList->GetAt(pos);
	if (eclCld->bplay==(B_PLAY)(-1))
		return FALSE;		// ǖʂI

	return TRUE;
}
void CDbeView::OnUpdateJsBcomedit(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(UpdateJsBcomedit());
}
void CDbeView::OnJsBcomedit() 
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	BOOL bEnable=TRUE;

	if (IsJCommentBoxOpened())
		return;				// ɊJĂ

	if (theApp.m_bSelectBoxBUsing)
		return;				// EI_CAOgp

	HTREEITEM hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL)		// Վ肪Ȃ
		return;

	HTREEITEM hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL)			// I
		return;

	POSITION pos=(POSITION)TreeCtrl.GetItemData(hNow);
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CEcell *eclCld=pEcellList->GetAt(pos);
	if (eclCld->bplay==(B_PLAY)(-1))
		return;				// ǖʂI

	// O(e)̋ǖʂ߂B
	CBform Bform; int side;

	// RootI𒆂̏ꍇ
	if (hNow==hRoot) {
		pKBase->backmove2();
		Bform=*pKBase->btype();
		side=pKBase->turn();
		pKBase->ahead2();
	} else {
		HTREEITEM hParent=TreeCtrl.GetParentItem(hNow); // Őǖ(e)
		ASSERT(hParent);
		pos=(POSITION)TreeCtrl.GetItemData(hParent);
		CEcell *eclPnt=pEcellList->GetAt(pos);
		Bform=eclPnt->Bform;	// ̋ǖʂ
		side=eclPnt->side;
	}

	B_PLAY bplay=eclCld->bplay;	// ̎wB
	CString strMove=eclCld->strMove;

	PopupBcom(&Bform,side,bplay,&strMove,TRUE);
}

void CDbeView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// ^[L[Ƃ̉
	if (nChar=='\r')
		return;
	CTreeView::OnChar(nChar, nRepCnt, nFlags);
}

//////
// Վ̓l
BOOL CDbeView::UpdateMenuJplayProperty()
{
	CDbeDoc *pDoc=GetDocument();
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	BOOL bEnable=TRUE;
	HTREEITEM hRoot,hNow;
	POSITION pos;
	CEcell *eclCld;

	if (theApp.m_bSelectBoxBUsing) {
		bEnable=FALSE;	// EI_CAOgp
		goto exit;
	}

	if (m_pDlgEcellBox) {
		bEnable=FALSE;	// łɊJĂ
		goto exit;
	}
	
	hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL) {
		bEnable=FALSE;	// Վ肪Ȃ
		goto exit;
	}

	hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL) {
		bEnable=FALSE;	// I
		goto exit;
	}

	pos=(POSITION)TreeCtrl.GetItemData(hNow);
	eclCld=pEcellList->GetAt(pos);
	if (eclCld->bplay==(B_PLAY)(-1)) {
		bEnable=FALSE; // ǖʂI
		goto exit;
	}
exit:
	return bEnable;
}
void CDbeView::OnUpdateMenuJplayProperty(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(UpdateMenuJplayProperty());
}

void CDbeView::OnMenuJplayProperty() 
{
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	m_pDlgEcellBox = new CDlgEcellBox; // ݒ_CAO
	m_pDlgEcellBox->pTreeCtrl=&TreeCtrl;
	m_pDlgEcellBox->pDoc=GetDocument();
	m_pDlgEcellBox->pFrame		=(CDbeFrame*)GetParentFrame();
	m_pDlgEcellBox->Create(IDD_DLG_ECELLBOX,this);
	m_pDlgEcellBox->ShowWindow(SW_SHOWNORMAL);
}

////
// `]l
BOOL CDbeView::UpdateMenuEval()
{
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	HTREEITEM hRoot,hNow;
	BOOL bEnable=TRUE;

	if (theApp.m_bSelectBoxBUsing) {
		bEnable=FALSE;	// EI_CAOgp
		goto exit;
	}

	if (m_pDlgEvalBox) {
		bEnable=FALSE;	// łɊJĂ
		goto exit;
	}
	
	hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL) {
		bEnable=FALSE;	// Վ肪Ȃ
		goto exit;
	}

	hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL) {
		bEnable=FALSE;	// I
		goto exit;
	}

	// WinSDJ5.1 by KY.00/2/20
	// [̎w̏ꍇA̎w̋ǖʂo^Ȃ̂
	// j[\Ȃ悤ɂB
	if (!TreeCtrl.ItemHasChildren(hNow)) {
		bEnable=FALSE;
		goto exit;
	}
exit:
	return bEnable;
}
void CDbeView::OnUpdateMenuEval(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(UpdateMenuEval());
}
void CDbeView::OnMenuEval() 
{
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	m_pDlgEvalBox = new CDlgEvalBox;
	m_pDlgEvalBox->pTreeCtrl=&TreeCtrl;
	m_pDlgEvalBox->pDoc=GetDocument();
	m_pDlgEvalBox->pFrame=(CDbeFrame*)GetParentFrame();
	m_pDlgEvalBox->Create(IDD_DLG_EVALBOX,this);
	m_pDlgEvalBox->ShowWindow(SW_SHOWNORMAL);
}

void CDbeView::OnEcellBoxSetnull()
{
	m_pDlgEcellBox=NULL;
}

void CDbeView::OnEvalBoxSetnull()
{
	m_pDlgEvalBox=NULL;
}

/////
// Փlݒ葋̕\XV
void CDbeView::OnEcellBoxInitData()
{
	if (m_pDlgEcellBox)
		m_pDlgEcellBox->SendMessage(WM_COMMAND,ID_ECELLBOX_INITDATA);
}


////
// Et̊J
void CDbeView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// |bvAbvj[J
	CMenu Menu;
	Menu.LoadMenu(IDR_DBEPOPMENU);
	CMenu *pPopMenu=Menu.GetSubMenu(0);

	pPopMenu->EnableMenuItem(ID_JSCMNTEDIT,
		UpdateJsCmntedit()? MF_ENABLED:(MF_GRAYED|MF_DISABLED));
	pPopMenu->EnableMenuItem(ID_JSBCOMEDIT,
		UpdateJsBcomedit()? MF_ENABLED:(MF_GRAYED|MF_DISABLED));
	pPopMenu->EnableMenuItem(ID_MENU_JPLAY_PROPERTY,
		UpdateMenuJplayProperty()? MF_ENABLED:(MF_GRAYED|MF_DISABLED));
	pPopMenu->EnableMenuItem(ID_MENU_EVAL,
		UpdateMenuEval()? MF_ENABLED:(MF_GRAYED|MF_DISABLED));
	pPopMenu->EnableMenuItem(ID_MENU_DELETE_JS,
		UpdateMenuDeleteJs()? MF_ENABLED:(MF_GRAYED|MF_DISABLED));

	ClientToScreen(&point);
	pPopMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		point.x, point.y, this);

	CTreeView::OnRButtonUp(nFlags, point);
}

//////
// Et̑}(ftHg̏E)
void CDbeView::OnRButtonDown(UINT nFlags, CPoint point) 
{
//	CTreeView::OnRButtonDown(nFlags, point);
}


///////
// Ղ̍폜
BOOL CDbeView::UpdateMenuDeleteJs()
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();

	if (theApp.m_bSelectBoxBUsing)
		return FALSE; // EI_CAOgp

	HTREEITEM hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL)
		return FALSE; // Վ肪Ȃ

	HTREEITEM hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL) // I
		return FALSE;

	POSITION pos=(POSITION)TreeCtrl.GetItemData(hNow);
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CEcell *eclCld=pEcellList->GetAt(pos);
	if (eclCld->bplay==(B_PLAY)(-1))
		return FALSE; // ǖʂI

	return TRUE;
}
void CDbeView::OnUpdateMenuDeleteJs(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(UpdateMenuDeleteJs());
}
void CDbeView::OnMenuDeleteJs() 
{
	DeleteJS();
}
// ݑIĂwՂ폜B
void CDbeView::DeleteJS()
{
	CDbeDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	CTreeCtrl &TreeCtrl=GetTreeCtrl();
	BOOL bEnable=TRUE;

	if (theApp.m_bSelectBoxBUsing)
		return;			// EI_CAOgp

	HTREEITEM hRoot=TreeCtrl.GetRootItem();
	if (hRoot==NULL)	// Վ肪Ȃ
		return;

	HTREEITEM hNow =TreeCtrl.GetSelectedItem();
	if (hNow==NULL)		// I
		return;

	POSITION pos=(POSITION)TreeCtrl.GetItemData(hNow);
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	CEcell *eclCld=pEcellList->GetAt(pos);
	if (eclCld->bplay==(B_PLAY)(-1))
		return;			// ǖʂI

	// O(e)̋ǖʂ߂B
	CBform Bform; int side;

	// RootI𒆂̏ꍇ
	if (hNow==hRoot) {
		pKBase->backmove2();
		Bform=*pKBase->btype();
		side=pKBase->turn();
		pKBase->ahead2();
	} else {
		HTREEITEM hParent=TreeCtrl.GetParentItem(hNow); // Őǖ(e)
		ASSERT(hParent);
		pos=(POSITION)TreeCtrl.GetItemData(hParent);
		CEcell *eclPnt=pEcellList->GetAt(pos);
		Bform=eclPnt->Bform; // ̋ǖʂ
		side=eclPnt->side;
	}

	B_PLAY bplay=eclCld->bplay; // ̎wB
	CString mes;
	mes.Format(" %s 폜܂B낵łH",eclCld->strMove);
	if (AfxMessageBox(mes,MB_YESNO)!=IDYES)
		return;

	CDBE Dbe; // ՂcaI[v
	if (Dbe.Open()) {
		// Db lock͂̒(AAbNȂ瑦^[)
		Dbe.DeleteJS(&Bform,side,bplay);
		Dbe.Close();
	}

	InitRoot(); // r[̏
}

void CDbeView::OnDestroy() 
{
	CTreeView::OnDestroy();
	
	// ߑB
	CloseJCommentBox();
	delete m_pSDJJCmntTemplate;

	// ߑ̈ʒu
	if (!m_rcJCmntBoxPos.IsRectEmpty()) {
		CString strSection=EDITOR_SECTION;
		CPoint &tl=m_rcJCmntBoxPos.TopLeft();
		CPoint &br=m_rcJCmntBoxPos.BottomRight();
		theApp.WriteProfileInt(strSection,JCMNT_POS_X1,tl.x);
		theApp.WriteProfileInt(strSection,JCMNT_POS_Y1,tl.y);
		theApp.WriteProfileInt(strSection,JCMNT_POS_X2,br.x);
		theApp.WriteProfileInt(strSection,JCMNT_POS_Y2,br.y);
	}
}

////
// ՒߑJ
CSDJJCmntDoc *CDbeView::OpenJCommentBox
(CString &strMove,int cid,CString &ckey,CString &strComment)
{
	CSDJJCmntDoc *pSDJJCmntDoc=
		(CSDJJCmntDoc *)m_pSDJJCmntTemplate->OpenDocumentFile(NULL);
	pSDJJCmntDoc->SetInitData(strMove,cid,ckey,strComment);

	return pSDJJCmntDoc;
}
