/*******************/
/*    kbase.cpp    */
/*******************/
#include "stdafx.h"
#include "kbase.h"
#include "kmsprite.h"
#include "kmlistbox.h"
#include "kmboard.h"
#include "sdjview.h"
#include "sdjdoc.h"

//// CKBase //////////
IMPLEMENT_SERIAL(CKBase,CMBase,0)

// RXgN^
CKBase::CKBase()
{
	Za=SIDE_A;   // 
	m_pKmSprite=NULL;
	m_pKmBoard=NULL;
	m_pKmListBox=NULL;
	m_pView=NULL;
}

CKBase::~CKBase()
{
}

//////////////////////
// IuWFNg̍\z
void CKBase::Create(CKmSprite KmSprite[40],
					CKmBoard *pKmBoard,
					CKmListBox KmListBox[3])
{
	int i;

	// o[f[^
	m_pKmSprite=KmSprite;
	m_pKmBoard=pKmBoard;
	m_pKmListBox=KmListBox;

	for (i=0;i<3;i++)
		KmListBox[i].SetKBase(this); // KBase̐ݒ

	// {NX
	CMBase::Create(KmSprite,sizeof(CKmSprite),
                  pKmBoard,KmListBox,
				  sizeof(CKmListBox));


	// ̐ݒ(͕ɔzu)
	for (i=0;i<40;i++) {
		int sg=m_pKmSprite[i].getside()^GetZa();
		int km=m_pKmSprite[i].getcode();
		int nr=m_pKmSprite[i].getprom();
        m_pKmSprite[i].SetKmStatus(sg,km,nr); // ̐ݒ

		CKif Kif=m_pKmSprite[i].GetKmPos();
		Kif.pos2kif(m_pKmSprite[i].getpos(),GetZa()); // SBASËʒu擾
		m_pKmSprite[i].SetKmPosA(Kif,FALSE,FALSE);    // zu̐ݒ(\̂)

		m_pKmSprite[i].SetZ(50);
	}

	recstart(); // L^Jn
}

/////////
//  ]
//    bDisp :\邩ۂ
void CKBase::ZaRotation(void)
{
	int i;
	CKif Kif;
	int gx,gy;

	Za=!Za; // 𔽓]

	m_pKmBoard->Reset(); // ՂNA
	for (i=0;i<3;i++) {
		m_pKmListBox[i].Reset(); // ENA
		m_pKmListBox[i].ZaRotation(); // ̊_𔽓]
	}
	for (i=0;i<40;i++) {
		m_pKmSprite[i].ZaRotation(); // WƋ̔]
		// ]WɊÂAOtBbNWݒ
		Kif=m_pKmSprite[i].GetKmPos();
		Kif.grhxy(m_pKmSprite[i].GetSpoint(),&gx,&gy);
		m_pKmSprite[i].SetPosition(gx,gy);
		// ZʂZbg
		m_pKmSprite[i].SetZ(50,FALSE); 
		// ]ꂽWɂāAՁEEɋNB
		if (Kif.kt==0) { // 
			m_pKmBoard->SetSprite(Kif,&m_pKmSprite[i]);
		} else if (Kif.kt==2) { // 
			m_pKmListBox[2].Insert(&m_pKmSprite[i],FALSE); // \[g
		} else { // 
			m_pKmListBox[Kif.ky^Za].Insert(&m_pKmSprite[i],FALSE); // \[g
		}
	}

	for (i=0;i<3;i++) {	// E\[g
		m_pKmListBox[i].SortAndUpdateDirtyRegion();
	}
}

// Serialize
void CKBase::Serialize(CArchive& ar)
{
	CMBase::Serialize(ar);
}

// bLine: TRUE/FALSE {菇̂ݏo/wԑSĂo
void CKBase::Serialize(CSDJArchive& ar,BOOL bLine)
{
	if (bLine)
		CMBase::LineSerialize(ar);
	else
		CMBase::Serialize(ar);
}

/////
// ǖʂ̃Rs[(idx)
void CKBase::CopyAspect(SBASE *psrc)
{
	CMBase::CopyAspect(psrc);

	// OtBbNX\ʒũRs[
	for (int i=0;i<MAXPIECE;i++) {
		CKmSprite *pKmSprite1=(CKmSprite*)piece(i);
		CKmSprite *pKmSprite2=(CKmSprite*)psrc->piece(i);

		pKmSprite1->SetPosition(pKmSprite2->GetX(),pKmSprite2->GetY(),FALSE);
		pKmSprite1->SetZ(pKmSprite2->GetZ(),FALSE);
	}
	// \Xg̒
	CSDJDoc *pSDJDoc=(CSDJDoc*)m_pView->GetDocument();
	pSDJDoc->AdjustSpriteList();

	m_pView->Invalidate();
}
