/*****************/
/*    kif.cpp    */
/*****************/
#include "stdafx.h"
#include "kbase.h"
#include "kif.h"
#include "sdjsysp0.h"

CKif::CKif()
{
}

CKif::CKif(int ikx,int iky,int ikt)
{
	kx=ikx;
    ky=iky;
    kt=ikt;
}

CKif::CKif(int pos, int za)
{
	kt=2;ky=0;kx=0;
	pos2kif(pos,za);
}

CKif::~CKif()
{
}

/***********************************************/
/*@OtBbNWWɕϊ@         */
/*        OFWkx,kyLiPP`XXj  */
/*        PFWkx(1~9),ky(0~1)      */
/*        QF                             */
/*      |PFՁAȊO                     */
/***********************************************/
void CKif::kifxy(int x,int y,BOOL bBoxCheck)
{
    kt=-1;
	// Տ
    if (x > Banx1+1 && x < Banx1+1+40*9)    {
        if (y > Bany1+1 && y < Bany1+1+40*9)    {
            kx=9-(x-Banx1-1)/40;
            ky=(y-Bany1-1)/40+1;
            kt=0;
        }
    }
	// 
    if ( x > Sdaix1 && x < Sdaix2 )    {
        if (y > Sdaiy1 && y < Sdaiy2)   {
            kx=0;
            ky=0;
            kt=1;
        }
    }
	// 
    if (x >Gdaix1 && x < Gdaix2)    {
        if ( y > Gdaiy1 && y < Gdaiy2)    {
            kx=0;
            ky=1;
            kt=1;
        }
    }
	// 
	if (bBoxCheck) {
		if ( x > KBoxx1 && x < KBoxx2)    {
			if (y > KBoxy1 && y < KBoxy2)    {
				kx=0;
				ky=0;
				kt=2;
			}
		}
	}
}

void CKif::kifxy(CPoint point,BOOL bBoxCheck)
{
	kifxy(point.x,point.y,bBoxCheck);
}

//    WOtBbNWɕϊ
//    OtBbNW͋`f[^̍̍W
void CKif::grhxy(CPoint Spoint,        /* _ */
				 int *xp,int *yp       /* GUIW */
				 )      
{

    /*@Տ@*/
    if (kt==0)    {
            *xp=Spoint.x+1+40*(9-kx%10);
            *yp=Spoint.y+1+(ky-1)*40;
    }
	/* E */
    else {
		ASSERT(!(kx < 0 || kx > 7));
		CPoint kp;
		int dx;
		calc_xsdx(Spoint,ky,kx,0,&kp,&dx); // WvZ
		*xp=kp.x;
		*yp=kp.y;
	}
}

// \ʒǔvZ
void CKif::calc_xsdx(CPoint Spoint,   /* _*/
			  int side,	   /*  */
			  int kn,      /* ʒu */
			  int n,       /*  */
			  CPoint *pkp,int *pdx /* \ʒu */
			  ) 
{
    CPoint kp;
	int dx=0;
	int s_sin,x_off,y_off;

	if (side==0) {
		s_sin= 1; x_off=1; y_off=4;
	}
	else {
		s_sin=-1; x_off=40; y_off=45;
	}
	/* ʂƕϐ̊֌W
       Spoint +------------------+
            kp->+--------------+ |
              | | kn=0   ->dx  | |
              | +--------------+ |
              | +-----+  +-----+ |
              | |  1 +----+ 2  | |
              | +----|+7 +|----+ |
              | +----|+dx+|----+ |
              | |  3 +--|-+ 4  | |
              | +----|+ v+|----+ |
              | +----|+7 +|----+ |
              | |  5 +----+ 6  | |
              | +-----+  +-----+ |
              +------------------+
	*/
	// 炵 dx ̌vZ
	//    kn< 7Ȃ牡ւ̂炵 
	//    kn>=7Ȃcւ̂炵
	if (n!=0)  {
		if (kn < 7) {
			dx = 30/n * s_sin;
			if (kn==0) { // Piڂ̎
				if (n > 2) dx = 94/n * s_sin; // Qȏ̋̏ꍇ
				else	   dx = 40 * s_sin;   // Q̋̏ꍇ
			}
		}
		else
			dx = 40 * s_sin;
	}
	// \ʒu kp ̌vZ
 	kp=Spoint;
	kp.Offset(x_off*s_sin,y_off*s_sin);
	if (kn > 0) {
		if (kn < 7)
			kp.Offset((kn-1)%2*60*s_sin,((kn-1)/2+1)*40*s_sin);
		else
			kp.Offset(39*s_sin,60*s_sin);
	}

	*pkp=kp;
	*pdx=dx;
}

//  SBASE position posAzảł̑ΊW
//  ϊ
void CKif::pos2kif(int pos, int za)
{
	if (pos==SIDE_A || pos==SIDE_B || pos==ON_BOX) {
		switch (pos) {
		case SIDE_A:
			kt=1; ky=0; break;
		case SIDE_B:
			kt=1; ky=1; break;
		case ON_BOX:
			kt=2; break;
		default:
			kt=-1;
		}
	}
	else {
		kx=(pos-BD11) % BDWID + 1;
		ky=(pos-BD11) / BDWID + 1;
		kt=0;
	}

	cnvZa(za); // ϊ
}

// WΊWƂ݂ȂāAzaɑΉ
// ΊWɕϊ.
void CKif::cnvZa(int za)
{
	if (za==0) return ; // Ȃ牽Ȃ
	if (kt==2) return ; // Ȃ牽Ȃ
	if (kt==1) {	// Ȃς
		ky=!ky;
	}
	else {	// ՏȂW㔽]B
		kx=BDWID - kx;
		ky=BDWID - ky;
	}
}

// ݂̑ΊWƍzaSBASEWԂ
int CKif::kif2pos(int za)
{
	CKif Kif(kx,ky,kt);
	Kif.cnvZa(za); // ΍Wϊ
	int pos;
	switch (Kif.kt) {
	case 0: // Տ
		pos=BD11+(Kif.ky-1)*BDWID + Kif.kx-1; break;
	case 1: // 
		pos=Kif.ky; break;
	case 2: // 
		pos=Kif.kt; break;
	default:
		pos=OB;
	}
	return pos;
}
