/*********************/
/*    kmboard.cpp    */
/*********************/
#include "stdafx.h"
#include "kmsprite.h"
#include "kmboard.h"
#include "sdjsysp0.h"
#include <sbase.h>

///////////////////////////////////////////////////
// ՃNX

CKmBoard::CKmBoard()
{
	Reset();
}

CKmBoard::~CKmBoard()
{
}

// 
void CKmBoard::Reset()
{
	for(int i=0;i<9;i++) {
		for (int j=0;j<9;j++) {
			m_pKmSprite[i][j]=NULL;	// Ղ͋
		}
	}
	m_Spoint.x=Banx1;				// ̍W
	m_Spoint.y=Bany1;
}

// u
void CKmBoard::SetSprite(int kx,int ky,CKmSprite *pKmSprite)
{
	ASSERT(!(kx<1 || kx>9));
	ASSERT(!(ky<1 || ky>9));
	ASSERT(!(pKmSprite!=NULL && m_pKmSprite[kx-1][ky-1]!=NULL));

	m_pKmSprite[kx-1][ky-1]=pKmSprite;
}
void CKmBoard::SetSprite(CKif Kif,CKmSprite *pKmSprite)
{
	ASSERT(!(Kif.kt!=0));
	SetSprite(Kif.kx,Kif.ky,pKmSprite);
}

// m
CKmSprite *CKmBoard::GetSprite(int kx,int ky)
{
	ASSERT(!(kx<1 || kx>9));
	ASSERT(!(ky<1 || ky>9));
	
	return m_pKmSprite[kx-1][ky-1];
}
CKmSprite *CKmBoard::GetSprite(CKif Kif)
{
	ASSERT(!(Kif.kt!=0));
	return GetSprite(Kif.kx,Kif.ky);
}
