// kmsprite.h : header file
//
// CKmSprite class
//
//
#ifndef __KMSPRITE__
#define __KMSPRITE__

#include "dib.h"
#include "spriteno.h"
#include "sprite.h"
#include "sdjsysp0.h"
#include "kif.h"
#include "kbase.h"
#include "kmboard.h"

class CKmListBox;
class CSDJView;
class CKmSprite : public PIECE
{
    DECLARE_SERIAL(CKmSprite)
public:
    virtual void SetPosition(int x,int y,BOOL bChange=TRUE);
    virtual void SetZ(int z,BOOL bChange=TRUE);
	void ZaRotation(void);
	void AddRegion(void);
	void RenderAndDraw(void);
    CKmSprite();
    ~CKmSprite();
    virtual void Serialize(CArchive& ar);
	CKif GetKmPos(void) {return m_Kif;}
	void GetKmStatus(int *psg,int *pkm, int *pnr)
	{*psg=m_sg;*pkm=m_km;*pnr=m_nr;}
	int GetSg(void) { return m_sg; }
	int GetNr(void) { return m_nr; }
	// ʒuXV(\̂)
	void SetKmPosA(CKif Kif,int bSmoth,int bChange=TRUE);
	// ʒuXV(\̂)
	void SetKmPosA(int kx,int ky,int kt,int bSmoth);
	// ʒuXV(SBASEAg)
	void SetKmPos(CKif Kif,int bSmoth);
	// ʒuXV(SBASEAg)
	void SetKmPos(int kx,int ky,int kt,int bSmoth);
	void SetKmStatus(int sg, int km, int nr);   // ̐ݒ
	void SetPieceStatus(void); // PIECEݒ
	void KmListBoxRemove(BOOL bSort=TRUE,BOOL bDisp=FALSE);
	void KmListBoxInsert(CKif &Kif,BOOL bSort=TRUE,BOOL bDisp=FALSE);
	void SetBoxKx(int kx) {if (m_Kif.kt!=0) m_Kif.kx=kx; }
	CPoint GetSpoint(CKif Kif);
	CPoint GetSpoint();
	int GetZa(void){return ((CKBase *)getbase())->GetZa();}
	CSDJView *GetView(void){return ((CKBase *)getbase())->GetView();}
	CKmBoard *GetBoard(void){return ((CKBase *)getbase())->GetBoard();}
	CKmListBox *GetListBox(void){return ((CKBase *)getbase())->GetListBox();}
// PIECEz֐
	// Eto_֓āAprom=Ȃ1 Ȃ=0 ωȂ=-1
	// Eto_͔Տ̂ǂA邢SIDE_A/SIDE_B()/ON_BOX
	// EՏto_Ɋɋ΁A̋͂̃CX^X(side
	//   ̎w肪΂̑j̎Ƃċɏ
	// Eto_Ɏgꍇ͐ݒύXłƂċɂ͍sȂ
	// Eside-1Ȃ炻̋̌͌̂܂܁AύXȂSIDE_A/SIDE_B
	// @Ɩ
	// Return: 0=s\iǖʂ͂̂܂܁j1=삳
	virtual int move(int to, int prom=-1, int side=-1);
	virtual int move2(int to, int prom=-1, int side=-1);
protected:
	CKif m_Kif; // W 
	int m_sg;	// 
	int m_km;	// 
	int m_nr;	// \
};
#endif // __KMSPRITE__
