/*********************/
/*    kmstack.cpp    */
/*********************/
#include "stdafx.h"
#include "kmstack.h"
#include "kmsprite.h"
#include "kmboard.h"
#include "sdjdoc.h"
#include "sdjview.h"
#include "kbase.h"

CKmStack::CKmStack()
{
	m_iKmCtr = 0;											// ɎĂ=0
	m_pDoc = NULL;
}
CKmStack::~CKmStack()
{
}

// Ɏ
void CKmStack::HoldSprite(CPoint point,CKmSprite *pKmSprite)
{
	int sg,km,nr;

	m_KmHold[m_iKmCtr].pSprite = pKmSprite;
	m_KmHold[m_iKmCtr].Offset.x = point.x - m_KmHold[m_iKmCtr].pSprite->GetX();
	m_KmHold[m_iKmCtr].Offset.y = point.y - m_KmHold[m_iKmCtr].pSprite->GetY();
	pKmSprite->GetKmStatus(&sg,&km,&nr);					// Xe[^X̎擾
	m_KmHold[m_iKmCtr].sg = sg;								// Xe[^X̋L
	m_KmHold[m_iKmCtr].nr = nr;
	pKmSprite->SetZ(10);									// ZʕύX őO
	m_iKmCtr++;

	CKif Kif=pKmSprite->GetKmPos();
	if (Kif.kt==0)											// Տ̋AՂ̑ΉʒuNULLɃZbgB
		pKmSprite->GetBoard()->SetSprite(Kif,NULL);
	else													// ij̋A̋ij珜B
		pKmSprite->KmListBoxRemove(TRUE,TRUE);				// \Bmodified 97.12.27 Bug.Fixed.
}
//////////////
// 蒆̋u(SBASEAg)
// bSmoth: ړ\L(TRUE)/(FALSE)(Default)
// bSep  : ͂(TRUE)/Ȃ(FALSE)(Default)
//    )͂ȂꍇAǖʈȍ~̎w͑SĔjB
void CKmStack::PutSprite(CKif Kif,BOOL bSmoth)
{
	CKBase *pKBase=m_pDoc->GetKBase();
	CSDJView *pSDJView=m_pDoc->GetSDJView();

	if (pSDJView->GetKifSeparate())
		pSDJView->SetKifSeparate(FALSE);					// ͈͂LB
	else
		pKBase->FreePcell();								// ǖʈȍ~̑Sw

	if (pSDJView->IsRuleChecking())							// Րݒł͂ȂҏW͒
		pKBase->JudgeRootPreCheck();						// {菇O

	m_iKmCtr--;
	int i=m_iKmCtr;
	CKmSprite *pKmSprite=m_KmHold[i].pSprite;
	pKmSprite->SetKmPos(Kif,bSmoth);						// ǖʂ̍XV

	if (pSDJView->IsRuleChecking())							// Րݒł͂ȂҏW͒
		pKBase->JudgeRootAfterCheck();						// {菇㔻

	m_pDoc->SetModifiedFlag(TRUE);
}

////////////
// 蒆̋̈ʒu֖߂(\̂ݓf[^ɖ߂BSBASE͖֌W)
////
void CKmStack::ReturnSprite(BOOL bSmoth)
{

	m_iKmCtr--;

	int i=m_iKmCtr;
	int sg,km,nr;
	CKmSprite *pKmSprite=m_KmHold[i].pSprite;
	pKmSprite->GetKmStatus(&sg,&km,&nr);					// Xe[^X̎擾
	// Xe[^Xɕω
	if (m_KmHold[i].sg!=sg || m_KmHold[i].nr!=nr) {
		// Xe[^Xɖ߂
		pKmSprite->SetKmStatus(m_KmHold[i].sg,km,m_KmHold[i].nr);
	}

	CKif Kif;
	Kif=pKmSprite->GetKmPos();								// ̈ʒu擾
	// ̈ʒu󂢂Ă
	if (Kif.kt>0 || 
		Kif.kt==0 && pKmSprite->GetBoard()->GetSprite(Kif)==NULL)
		pKmSprite->SetKmPosA(Kif,bSmoth);					// ̈ʒuɒu
	else													// ̈ʒuՏŁA󂢂ĂȂ΁A֒uB
		pKmSprite->SetKmPosA(0,pKmSprite->GetSg(),1,bSmoth);
}
