/*
************************************************************************
        B-Tree ֐(IDX)      wb_t@C
                                            Modified by Ra  1992.11
************************************************************************
*/
#include <index.h>

/*
****************************************************************
    f[^t@C֐@wb_t@C
                                                by Ra 1992.11
****************************************************************
*/
#include <drec.h>
/*
*******************************************************************
    tf[^t@CANZX֐wb_t@C
                                                    by Ra 1992.11
*******************************************************************
*/

#define     IXPNUM      10      /* CfbNXt@C̍ől */
#define     E_IDX       100     /* IDXW[̃G[ */
#define     E_DUP       11
#define     E_LOCLT     20
#define     E_LOCEQ     21
#define     E_LOCGR     22

#ifdef OS_IS_MSDOS
#define     E$IDX       E_IDX
#define     E$DUP       E_DUP
#define     E$LOCLT     E_LOCLT
#define     E$LOCEQ     E_LOCEQ
#define     E$LOCGR     E_LOCGR
#endif

typedef struct  {
    int     dup;
    Entry   ent;
    IDX_t   ixt;
} IDX;

typedef struct  {
    char            *dbname;
    DREC            drc;
    unsigned int    leng;
    int             idxnum;
    IDX             *ixp[IXPNUM];
} DB_t;

/* }N̒` */

/* tf[^t@CDB_t *db  
   i Ԗ(0~)̍t@Cdup(int)l */
#define     IX_DUP(db,i)    (db->ixp[i]->dup)

/* tf[^t@CDB_t *db  i Ԗ(0~)
   t@CANZX\IDX_tւ̃|C^l */
#define     IX_IXT(db,i)    (&db->ixp[i]->ixt)

/* tf[^t@CDB_t *db  i Ԗ(0~)
   t@CEntryւ̃|C^l */
#define     IX_ENT(db,i)    (&db->ixp[i]->ent)

/* tf[^t@CDB_t *db  i Ԗ(0~)
   t@C̃L[ijl */
#define     IX_KEY(db,i)    (db->ixp[i]->ent.key)

/* tf[^t@CDB_t *db  i Ԗ(0~)
   t@C̃R[h(long)l */
#define     IX_REC(db,i)    (db->ixp[i]->ent.recptr)


/*
 * ֐̐錾
 */
/* tf[^t@C̍쐬 */
DB_t *DbCreate(char *dname,unsigned int leng,int idxnum,int *dup);

/* tf[^t@C̃I[v */
DB_t *DbOpen(char *dname,int idxnum,int *dup);

/* tf[^t@C̃N[Y */
int DbClose(DB_t *db);

/* t@C̃L[v */
int DbIxFind(DB_t *db,int i);

/* t@C̃L[v */
int DbIxLocate(DB_t *db,int i,char *key);

/* t@Cւ̃L[̒ǉ */
int DbIxAdd(DB_t *db,int i);

/* ̍t@CL[폜B */
int DbIxRemove(DB_t *db,int i);

/* t@C̃|C^擪ɒuB */
int DbIxFirst(DB_t *db,int i);

/* t@C̃|C^I[ɒuB */
int DbIxLast(DB_t *db,int i);

/* t@C̎̃L[ԂB */
int DbIxNext(DB_t *db,int i);

/* t@C̑ÕL[ԂB */
int DbIxPrev(DB_t *db,int i);

/* t@C̃L[lƃf[^t@CR[hԍ̗҂ňvB */
int DbIxExact(DB_t *db,int i);

/* t@C̓o^ */
int DbIxWrite(DB_t *db,long recno);

/* tf[^t@C̓ǂ݂iL[vǂ݂j */
int DbFindRead(DB_t *db,int i,char *buffer);

/* tf[^t@C̓ǂ݂iL[vǂ݂j */
int DbLocateRead(DB_t *db,int i,char *key,char *buffer);

/* tf[^t@CL[Ɏ̃R[hǂݏoB */
int DbNextRead(DB_t *db,int i,char *buffer);

/* tf[^t@CL[tɎ̃R[hǂݏoB */
int DbPrevRead(DB_t *db,int i,char *buffer);

/* tf[^t@C̍t@C̍폜 */
int DbIxDelete(DB_t *db,long recno);

/* t@C̐VKPƍ쐬 */
IDX_t *DbIdxCreate(char *name,int dup);

/* t@C̒PƃN[Y */
int DbIdxClose(IDX_t *ixt);

/* t@Cւ̒PƃL[ڒǉ */
int DbIdxAddKey(IDX_t *ixt,char *key,long recno);

/*
 * ֐}N
 */

/* f[^t@CPƓo^ */
#define DbDrWrite(db,buffer,recnp) (drec_write(&db->drc,buffer,recnp))

/* f[^t@CR[h̒Pƍ폜 */
#define DbDrDelete(db,recno) (drec_delete(&db->drc,recno))

/* f[^t@C̓ǂ݂ */
#define DbDrRead(db,recno,buffer) (drec_read(&db->drc,recno,buffer))

/* f[^t@C̏ǂ݂ */
#define DbDrNextRead(db,recno,buffer,recnp) \
    (drec_next_read(&db->drc,recno,buffer,recnp))

/* f[^t@CPƒǉo^ */
#define DbDrAppend(db,buffer,recnp) (drec_append(&db->drc,buffer,recnp))

/* f[^t@C̒PƍXV */
#define DbDrUpdate(db,buffer,recno) (drec_update(&db->drc,buffer,recno))
