/*=====================================================================
                 RSDB sqldrpix program     Version 1.0

                        Copyright (C)  1993.9
                               by Ra

-----------------------------y֐dlz----------------------------

(1)̍폜
-------------
  int SqlDropIndex(char *sqlstr);

  
  @ char *sqlstr : SQL(drop index)B
  ߂l
     E_OK:I 
     ȊO:ُI
        E_PARA:SQL@G[
        E_MEM:s@@ E_EXCEPTnn
  
  @SQL(sqlstr)Ŏw肳ꂽ\́Aw肳ꂽ폜Bw肳ꂽԍ
  @́Aɑ݂Ăł傫ԍłȂ΂ȂȂBȂ
    E_EXCEPTnnƂȂB

  SQL\
        --------------------------------------------------------
                drop index <ԍ> on <\>
        --------------------------------------------------------
        ԍ͑傫珇Ɏw肷B
                ex.
                        drop index 4 on D1

<>
    1993.9  Version 1.0  by Ra 
    1994.8  Version 1.01 by Ra
            svϐB                                       
========================================================================*/
#pragma warning(disable:4996)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rdb.h>

/* OQƊ֐ */
extern void *memalloc(unsigned int);
extern void  memfree(void *);
extern void RelTokenList(TokenList *tlp);
extern TokenList *GetTokenList(char *inbuf);

/**************
//@̍폜
//
//  
//  @ char *sqlstr : SQL(drop index)B
//  ߂l
//     E_OK:I 
//     ȊO:ُI
//        E_PARA:SQL@G[
//        E_MEM:s@@ E_EXCEPTnn
//*************************************************/
/*
  ASYTvB
  @1.TokenList쐬
  @2.TokenList𕪐͂ĕ\A폜擾
  @3.scmt@C[h (SCMHEAD,SCMITEM,SCMIDX\)
    4.폜̃`FbN
  @5.scmt@C̍XV
  @6.t@C̍폜
*/
int SqlDropIndex(char *sqlstr)
{
    int rc=E_OK;
    TokenList *tlp=NULL,*root_tlp=NULL;   /* TokenList */
    char *table=NULL;                     /* \ */
    char *scmfile=NULL;                   /* scmt@C */
    char *ixfile=NULL;                    /* t@C */
    FILE *fp;                             /* XL[}t@C\ */
    SCMHEAD sh;                           /* XL[}wb_ */
    SCMITEM *smp=NULL;                    /* XL[}ڍ\ */
    SCMIDX *sxp=NULL;                     /* XL[}ڍ\ */
    int xnum;                             /* t@Cԍ */

    /* 
     * 1.TokenList쐬
     */
    if ((root_tlp=tlp=GetTokenList(sqlstr))==NULL) {
        rc=E_MEM;goto exit;
    }

    /* 
     * 2.TokenList𕪐͂ĕ\A폜擾
     */
    /* "drop index" ̃`FbN */
    if (stricmp(tlp->token,"drop")==0)
        tlp=tlp->next;
    else {
        rc=E_PARA;goto exit;    /* "drop index" L[[hُ */
    }
    if (tlp!=NULL &&
        stricmp(tlp->token,"index")==0)
            tlp=tlp->next;      /* TokenList */
    else {
        rc=E_PARA;goto exit;    /* "drop index" L[[hُ */
    }

    /* t@Cԍ(xnum)̃`FbN */
    if (tlp!=NULL) {
        xnum=atoi(tlp->token);
        if (xnum>=0 && xnum<IXPNUM) {
            tlp=tlp->next;              /* TokenList */
        }
        else {
            rc=E_PARA;goto exit;        /* t@Cԍُ */
        }
    }
    else {
        rc=E_PARA;goto exit;    /* t@Cԍُ */
    }

    /* on \̃`FbNscmt@C̃Zbg */
    if (tlp!=NULL && stricmp(tlp->token,"on")==0)
        tlp=tlp->next;
    else {
        rc=E_PARA;goto exit;    /* \on`FbNُ */
    }
    if (tlp!=NULL) {
        /* \̃Zbg */
        table=(char *)memalloc(strlen(tlp->token)+1);
        if (table==NULL) {
            rc=E_MEM;goto exit; /* s */
        }
        strcpy(table,tlp->token);

        /* scmt@C̃Zbg */
        scmfile=(char *)memalloc(strlen(table)+5);
        if (scmfile==NULL) {
            rc=E_MEM;goto exit; /* s */
        }
        strcpy(scmfile,table);
        strcat(scmfile,".scm");

        tlp=tlp->next;          /* TokenList */
    }
    else {
        rc=E_PARA;goto exit;    /* \`FbNُ */
    }
    
    /*
     *  3.scmt@C[h
     */
    if((fp=fopen(scmfile,"rb"))==NULL) {
        rc=E_EXCEPT01;goto exit;      /* scmt@CI[vG[ */
    }
    /* SCMHEAD̓ǂݏo */
    if (1-fread(&sh,sizeof(SCMHEAD),1,fp)!=0) {
        fclose(fp);
        rc=E_EXCEPT02;goto exit;      /* XL[}t@Cُ */
    }
    /* SCMITEM̈̊m */
    smp=(SCMITEM *)memalloc(sh.inum*sizeof(SCMITEM));
    if (smp==NULL) {
        fclose(fp);
        rc=E_MEM;goto exit;     /* SCMITEM̈惁s */
    }
    /* SCMITEM̓ǂݏo */
    if (sh.inum-fread(smp,sizeof(SCMITEM),sh.inum,fp)!=0) {
        fclose(fp);
        rc=E_EXCEPT02;goto exit;      /* XL[}t@Cُ */
    }
    /* SCMIDẌ̊m */
    sxp=(SCMIDX *)memalloc(IXPNUM*sizeof(SCMIDX));
    if (sxp==NULL) {
        fclose(fp);
        rc=E_MEM;goto exit;     /* SCMIDẌ惁s */
    }
    else
        memset(sxp,'\0',IXPNUM*sizeof(SCMIDX)); /* 0NA */
    /* SCMIDX̓ǂݏo */
    if (sh.xnum!=0) {
        if (sh.xnum-fread(sxp,sizeof(SCMIDX),sh.xnum,fp)!=0) {
            fclose(fp);
            rc=E_EXCEPT02;goto exit;  /* XL[}t@Cُ */
        }
    }
    /* scmt@C̃N[Y */
    fclose(fp);

    /* 
     * 4.폜̃`FbN
     */
    if (sh.xnum<=0 || sh.xnum>0 && xnum!=sh.xnum-1) {
        rc=E_EXCEPT03;goto exit;      /* ԍُ */
    }

    /* t@C̃Zbg */
    ixfile=(char *)memalloc(strlen(table)+5);
    if (ixfile==NULL) {
        rc=E_MEM;goto exit;     /* s */
    }
    sprintf(ixfile,"%s.ix%d",table,xnum);

    /* o^炷 */
    sh.xnum--;
    
    /* 
     * 5.scmt@C̍XV
     */
    /* scmt@C̃I[v */
    if((fp=fopen(scmfile,"wb"))==NULL) {
        rc=E_EXCEPT04;goto exit;      /* scmt@CI[vG[ */
    }
    /* SCMHEAD̏ */
    if (1-fwrite(&sh,sizeof(SCMHEAD),1,fp)!=0) {
        fclose(fp);
        rc=E_EXCEPT05;goto exit;
    }
    /* SCMITEM̏ */
    if (sh.inum-fwrite(smp,sizeof(SCMITEM),sh.inum,fp)!=0) {
        fclose(fp);
        rc=E_EXCEPT05;goto exit;
    }
    /* SCMIDX̏ */
    if (sh.xnum-fwrite(sxp,sizeof(SCMIDX),sh.xnum,fp)!=0) {
        fclose(fp);
        rc=E_EXCEPT05;goto exit;
    }
    /* scmt@C̃N[Y */
    fclose(fp);

    /* 
     * 6.t@C̍폜
     */
    remove(ixfile);

  exit:
    if (sxp!=NULL)              /* SCMIDẌ̉ */
        memfree(sxp);
    if (smp!=NULL)              /* SCMITEM̈̉ */
        memfree(smp);
    if (ixfile!=NULL)           /* index filẻ */
        memfree(ixfile);
    if (scmfile!=NULL)          /* scmfilẻ */
        memfree(scmfile);
    if (table!=NULL)            /* \̉ */
        memfree(table);
    if (root_tlp!=NULL)         /* TokenList ̉ */
        RelTokenList(root_tlp);
    return rc;
}
