/*=====================================================================
                 RSDB TokenList program     Version 1.0

                        Copyright (C)  1993.9
                               by Ra

-----------------------------y֐dlz----------------------------

(1)TokenList ̎擾
-------------------
  TokenList *GetTokenList(char *inbuf);

   obt@inbuf TokenɕA
   TokenList\zB

   ߂l:擪TokenListւ̃|C^ԂB
          Xg쐬Ɏs(s)NULLԂB

(2) TokenList ̉
--------------------
  void RelTokenList(TokenList *tlp);

(3)TokenList ̃C[W
------------------------
  inbuf
  (..........first................second.............last...)
             ^                    ^                  ^
   TokenList-|------+             |                  |
   | a.ptr---+      |             |                  |
   | a.token="first"|             |                  |
   | a.next---------->TokenList---|-----+            |
   |                | | b.ptr-----+     |            |
   +----------------+ | b.token="second"|            |
                      | b.next------------>TokenList-|-----+
                      |                 |   |c.ptr---+     |
                      +-----------------+   |c.token="last"|
                                            |c.next=NULL   |
                                            +--------------+
========================================================================*/
/*
 sC
(1)1999.1.24 by Ra
  kigo,sepkigo̒`(g[N̕ɉĒPg[NƂL)
  A\\:/폜B
  ̓pX̋؂qƂȂ蓾̂ŕ\ƂătpXw肵A
  ̕\Pg[NɂȂȂȂs𐶂ׁB
*/
#pragma warning(disable:4996)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rsdbcnf.h>
#ifdef OS_IS_MSDOS
#ifdef MSC7
#include <mbstring.h>
#else
#include <jstring.h>
#define _mbscspn jstrcspn
#endif
#else
extern size_t emjstrcspn(unsigned char *,unsigned char *);
#define _mbscspn emjstrcspn
#endif

/* OQƊ֐ */
extern void *memalloc(unsigned int);
extern void  memfree(void *);

/* tokenlist\ */
typedef struct tokenlist {
    char *token;
    char *ptr;
    struct tokenlist *next;
}TokenList;

/* g[N̋؂q */
static char *sep="\t\n\r ";

/* g[NPL */
static char *kigo=
         "!\"#Q$%&'()=-`^|{}[]~@*+;?.,<>";

/* PL+؂q */
static char *sepkigo=
         "!\"#Q$%&'()=-`^|{}[]~@*+;?.,<>\t\n\r ";

/********************
//  TokenList ̉
//********************/
void RelTokenList(TokenList *tlp)
{
    TokenList *tlp1;

    while (tlp!=NULL) {
        tlp1=tlp->next;
        memfree(tlp->token);
        memfree(tlp);
        tlp=tlp1;
    }
}


/********************
//  TokenList ̎擾
//
//   obt@inbuf TokenɕA
//   TokenList\zB
//
//   ߂l:擪TokenListւ̃|C^ԂB
//          Xg쐬Ɏs(s)NULLԂB
//********************************************************/
TokenList *GetTokenList(char *inbuf)
{
    TokenList *tlp=NULL,*tlp1,*tlp2;
    char *cp=inbuf;
    int len,err=0;
    int dq=0;                   /* '"'o1 */

    do {
        if (dq==0)              /* 2dp̌łȂ */
            cp+=strspn(cp,sep); /* uNȂǋ؂qȊO̕܂ňړ */
        if (*cp!='\0') {
            /* 2dp̌łȂ */
            if (dq==0) {
                /* ̕LȂ */
                if (strchr(kigo,*cp)!=NULL) {
                    len=1;      /* LŒPƂ̃g[NƂB */
                    if (*cp==(char)'"') /* 2dp */
                        dq=1;
                }
                else    /* LłȂΎ̋LZp[^܂ */
                    len=_mbscspn((unsigned char *)cp,(unsigned char *)sepkigo);
            }
            /* 2dp̌Ȃ */
            else {
                /* ̕2dpȂ */
                if (*cp==(char)'"') {
                    len=1;dq=0;
                }
                else            /* łȂ2dp܂ */
                    len=_mbscspn((unsigned char *)cp,(unsigned char *)"\"");
            }
        }
        else
            len=0;

        /* token΃Xgɓo^B*/
        if (len!=0) {
            /* VTokenList擾 */
            tlp2=(TokenList *)memalloc(sizeof(TokenList));
            if (tlp2==NULL) {
                err=1; goto exit;
            }

            /* tokenZbg */
            tlp2->token=(char *)memalloc(len+1);
            if (tlp2->token==NULL) {
                err=1; goto exit;
            }
            strncpy(tlp2->token,cp,len);
            *(tlp2->token+len)='\0';

            /* ptrZbg */
            tlp2->ptr=cp;

            tlp2->next=NULL;    /* TokenListI[ */

            if (tlp==NULL)
                tlp=tlp1=tlp2;  /* o^̎ */
            else {
                tlp1->next=tlp2; /* 2ڈȍ~̓o^̎͑OnextƃN */
                tlp1=tlp2;
            }

            /* ̃g[N̈ʒu */
            cp+=len;
        }
    } while(len!=0);

  exit:
    if (err!=0) {
        RelTokenList(tlp);
        tlp=NULL;
    }
    return tlp;
}
