#
# RSDB Library & Commands Makefile for MSVC++ Version 4.0
#
#		                       1996.3 by Ra
#  Usage        example
#-----------------------------------------------------
#  Normal	nmake 
#  Rebuild	nmake rebuild
#  CLEAN        nmake clean
#
# ) MS/C 6.0̏ꍇ͂̃Rg͂B make MSC6=1ƋNB
# MSC6=1
#
SH=command /c
MAKE=nmake
CC=cl
LINK=link
LIBDIR=..\lib
INCDIR=..\inc
LIBRARIES=$(LIBDIR)\rsdb32.lib
#
!IFDEF DEBUG
CFLAGS = /c /Od /Zi /f /I$(INCDIR)
LINKOPTION=/NOI  /CO
!ELSE
CFLAGS = /c /Ot /Gs /I$(INCDIR)
LINKOPTION=/NOI  /EXE /FAR /PACKC
!ENDIF
#
EXES=rsdbsql.exe scm.exe dbstat.exe

TARGET=$(EXES)

ALL:$(TARGET)

$(EXES):$(LIBRARIES)
rsdbsql.obj:rsdbsql.c $(FRC)
scm.obj:scm.c $(FRC)
dbstat.obj:dbstat.c $(FRC)

tarconf:
	@$(SH) echo copy config.h
	@copy config.h $(INCDIR)\rsdbcnf.h
clean:
	@$(SH) echo Clean RSDB ...
	@$(MAKE) -f rsdb32.mak -i target_c
target_c:
	@del rsdbsql.obj
	@del scm.obj
	@del dbstat.obj
	@del rsdbsql.exe
	@del scm.exe
	@del dbstat.exe

rebuild:
	@$(SH) echo Rebuild RSDB ...
	@$(MAKE) -f rsdb32.mak all FRC=force
force:

.c.obj:
	$(CC) $(CFLAGS) $*.c
.obj.exe:
	$(CC) $*.obj $(LIBRARIES)
