#
#  Library Makefile for MSVC++ Version 4.0 NMAKE
#
#				       1996.3 by Ra
#  Usage	example
#-----------------------------------------------------
#  Normal	nmake [DEBUG=1]
#  Rebuild	nmake rebuild
#  Clean	nmake clean
#  Library      nmake libmake
#
PROJ=SDB
DEPENDHDR=sdb.h
TARGETOBJS=sdbappnd.obj\
sdbbase.obj\
sdbdel.obj\
sdbditcr.obj\
sdbfndrd.obj\
sdbidxcr.obj\
sdbitcmp.obj\
sdbitcrd.obj\
sdbitmid.obj\
sdbixdel.obj\
sdbixfnd.obj\
sdbixloc.obj\
sdbixnxt.obj\
sdbixprv.obj\
sdbixwrt.obj\
sdblocrd.obj\
sdbupdat.obj\
sdbwrite.obj
#
!IFDEF DEBUG
COPTIONS=/f /Od /Zi
!ELSE
COPTIONS=/Ox /Zl
!ENDIF
#
TARGETDIR=..\..
TARGETLIB=$(TARGETDIR)\lib\rsdb32.lib
#
CFLAGS=/c /I$(TARGETDIR)\inc
LIBOPTIONS=/nologo
SH=command /c
MAKE=nmake
CC=cl
LIBCMD=lib
LRF=nmake.lrf
TARGETHDR=$(TARGETDIR)\inc\$(DEPENDHDR)
LIBOBJS=$(TARGETOBJS)
TARGET=$(TARGETHDR) $(LIBOBJS)

ALL:$(TARGET)

$(TARGETHDR):$(DEPENDHDR)
	!copy $? $(TARGETDIR)\inc
$(TARGETOBJS):$(DEPENDHDR) $(FRC)

clean:
	@$(SH) echo Clean $(PROJ) ...
	@$(MAKE) -f sdb.mak -i target_c
target_c:
	@del *.obj
rebuild:
	@$(SH) echo Rebuild $(PROJ) ...
	@$(MAKE) -f sdb.mak all FRC=force
libmake:$(LIBOBJS)
	@$(SH) echo $(TARGETLIB) updating....
	$(LIBCMD) /out:$(TARGETLIB) $(LIBOPTIONS) $(TARGETLIB) @<<$(LRF)
$(LIBOBJS)
<<

force:

.c.obj:
	$(CC) $(CFLAGS) $(COPTIONS) $*.c

