/*
 * HBOX.cpp
 *
 * 960926: by a
 */
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#include <stdlib.h>
#include "sbase.h"
#include <assert.h>

#define MAXPNUM 18 // ނōő̋i̐j

// Pނ̎Ǘ邽߂̃e[u
// ̔ԍ 0...num()-1 ܂ło(remove())o
class MLIST {
	public:
		int num(void) {return Num;} // L
		int getid(int n) {return Idtbl[n];} // nԖڂ̋id
		int remove(int n); // nԖڂ̋đO֋l߂ Ret:1=OK 0=Error
		int put(int id); // idԂ̋ǉ  Ret:1=OK 0=Error
		void init(void){Num = 0;}
		MLIST &operator=(MLIST &);
	private:
		int Num; //@e[uNum܂ł̃f[^L
		int Idtbl[MAXPNUM];
};

MLIST &MLIST::operator=(MLIST &t)
{
	for (int i = 0; i < t.Num; i++){
		Idtbl[i] = t.Idtbl[i];
	}
	Num = t.Num;
	return *this;
}

int MLIST::remove(int n)
{
	int i;
	
	if (n >= Num || n < 0) return 0;
	for (i = n+1; i < Num; i++) Idtbl[n] = Idtbl[i];
	Num--;
	return 1;
}

int MLIST::put(int id)
{
	if (Num >= MAXPNUM) return 0;
	Idtbl[Num] = id;
	Num++;
	return 1;
}

//==============  HBOX  =================
// 󔠂ƂĐ
HBOX::HBOX(void)
{
	int i;
	
	Inpc = (MLIST*)malloc(sizeof(MLIST)*8);
	Sum = 0;
	for(i=0; i<8; i++) {
		Inpc[i].init();
		Sum += Inpc[i].num();
	}
}

HBOX::~HBOX() 
{
	free(Inpc);
}

HBOX& HBOX::operator=(HBOX& t)
{
	Sum = t.Sum;
	Pos = t.Pos;
	for(int i=0; i<8; i++) Inpc[i] = t.Inpc[i];
	return *this;
}

// 
// SIDE_A/SIDE_B/ON_BOX̂ǂꂩԂ
int HBOX::getpos(void){return Pos;}

// Ă邩
int HBOX::getnum(void) {return Sum;}

// kind͉̋邩
int HBOX::kmnum(int kind) {return Inpc[kind].num();}
	
// kind̑n(n=0c)̋|C^
PIECE* HBOX::km(int kind, int n) {return Sb->piece(Inpc[kind].getid(n));}

// 
// HBOXpc
int HBOX::put(PIECE *pc)
{
	return pput(pc);
}

int HBOX::pput(PIECE *pc)
{
	Sum++;
	return Inpc[pc->getcode()].put(pc->getid());
}

// HBOXpc
// HBOX̍\ƎoASYA납璲ׂ悢
int HBOX::remove(PIECE *pc)
{
	return rm(pc);
}

int HBOX::rm(PIECE *pc)
{
	int i, id, kind;
	
	kind = pc->getcode();
	id = pc->getid();
	Sum--;
	ASSERT(Sum >= 0);
	for (i = Inpc[kind].num() - 1; i >= 0; i--){
		if (Inpc[kind].getid(i) == id){
			return Inpc[kind].remove(i);
		}
	}
	return 0;
}

// SBASEɂݒ肳
void HBOX::setpos(int pos){Pos = pos;}

