// SBetc.cpp
// SBASE G֐
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#include <string.h>
#include "sbase.h"
#include "sbetc.h"

//============== ʒuϊ
// lԌSBASEpւ̕ϊ(11->BD11, 21->BD11+1 ...)
int mpos2spos(int mpos)
{
	int x, y, p;
	
	if (mpos > 10){
		y = mpos/10;
		x = mpos%10;
		p = BD11 + (x-1)*BDWID + y - 1;
	} else {
		p = mpos;
	}
	return p;
}

// SBASE->lԌϊ
int spos2mpos(int spos)
{
	int x, y, p;
	
	if (spos < BD11) return spos;
	spos -= BD11;
	y = spos/BDWID;
	x = spos%BDWID;
	p = (x+1)*10 + y + 1;
	
	return p;
}

// statɑΉ핶
char *namesym(int stat)
{
	static char *sym[] = {
		"", "", "p", "", "", "j", "", "",
		"n","","n","n","","j","","",
	};
	return sym[(stat & 0x0f)];
}

int xside(int side)
{
	if (side == SIDE_A) return SIDE_B;
	if (side == SIDE_B) return SIDE_A;
	return side;
}

// bit
// `I\LSBASE\(PLAY)̑ݕϊɎg
//
// E͈ȉ̐}̂ƂA猩A`H܂
//      A B C
//      D   E
//      F G H   
// Ebit̊֘At
//  bit  7 6 5 4 3 2 1 0
//   A B C D E F G H
//
// ȉA\Lbitpatten̊֌W`
#define SUGU	2
#define NAKA	0x42
#define HIDARI  0x29
#define MIGI	0x94
#define UP		0xe0
#define MID		0x18
#define BOT		0x07

#define BW BDWID

static int Vect[12] = {
	/*0*/-(2*BW+1),               /*1*/-(2*BW-1),
	/*2*/-(BW+1),  /*3*/-(BW),   /*4*/-(BW-1),
	/*5*/ -1,       /***   ړ_  ***/  /*6*/1,
	/*7*/(BW-1),   /*8*/(BW),    /*9*/(BW+1),
   /*10*/(2*BW-1),               /*11*/(2*BW+1)
};

int getvval(int vnum)
{
	ASSERT(vnum >=0 && vnum < 12);
	return Vect[vnum];
}

// xN^ԍvnum璷xN^side̎ʌQ߂
// ʌQzւ̃|C^Ԃ邪AzTCY͕sŏI-1Ŏ
int *getvpc(int vnum, int side)
{
	static int v0[] = {-1};
	static int v1[] = {HSY, -1};
	static int v2[] = {KAK, -1};
	static int v3[] = {HSY, KYO, -1};
	static int *vcode[2][12] = {
		{
			/*0*/ v0,
			/*1*/ v0,
			/*2*/ v2,
			/*3*/ v3,
			/*4*/ v2,
			/*5*/ v1,
			/*6*/ v1,
			/*7*/ v2,
			/*8*/ v1,
			/*9*/ v2,
			/*10*/ v0,
			/*11*/ v0,
		},{
			/*0*/ v0,
			/*1*/ v0,
			/*2*/ v2,
			/*3*/ v1,
			/*4*/ v2,
			/*5*/ v1,
			/*6*/ v1,
			/*7*/ v2,
			/*8*/ v3,
			/*9*/ v2,
			/*10*/ v0,
			/*11*/ v0,
		},
	};
	
	ASSERT(side >= 0 && side < 2 && vnum >= 0 && vnum < 12);
	return vcode[side][vnum];
}

// tOrbg̍쐬
// ptoɑ΂Ăǂ̕痘Ă邩
// pȂ0
unsigned char mvbit(int to, PIECE *p)
{
	unsigned char bit=0;
	int vn;
	
	if (p->getpos() < BD11) return bit;
	if (p->getside() == SIDE_A){
		vn = getvect(to, p->getpos());
	} else {
		vn = getvect(p->getpos(), to);
	}
	switch (vn){
		case -1: return 0;
		case 0: case 2:
			bit |= UP;
			bit &= MIGI;
			break;
		case 1: case 4:
			bit |= UP;
			bit &= HIDARI;
			break;
		case 3:
			bit |= UP;
			bit &= NAKA;
			break;
		case 5:
			bit |= MID;
			bit &= MIGI;
			break;
		case 6:
			bit |= MID;
			bit &= HIDARI;
			break;
		case 7: case 10:
			bit |= BOT;
			bit &=MIGI;
			break;
		case 8:
			bit |= BOT;
			bit &= SUGU;
			break;
		case 9: case 11:
			bit |= BOT;
			bit &= HIDARI;
			break;
	}
	return bit;
}

/*
 * from_𒍖ړ_Ƃto_܂ł̃xN^ԍ(Vect[]̓Y)߂
 * YxN^-1Ԃ
 */
int getvect(int from, int to)
{
	int fr, tr;
	int dr, def;
		
	fr = from/BDWID; tr = to/BDWID;
	dr = tr - fr; /* i̍̂ */
	def = to - from;
	switch(dr){
		case 8: case 7: case 6: case 5: case 4: case 3:
			if (Vect[7] * dr == def) return(7);
			if (Vect[8] * dr == def) return(8);
			if (Vect[9] * dr == def) return(9);
			break;
		case 2:
			if (Vect[10] == def) return(10);
			if (Vect[11] == def) return(11);
			if (Vect[7] * dr == def) return(7);
			if (Vect[8] * dr == def) return(8);
			if (Vect[9] * dr == def) return(9);
			break;
		case 1:
			if (Vect[7] == def) return(7);
			if (Vect[8] == def) return(8);
			if (Vect[9] == def) return(9);
			break;
		case 0:
			if (def > 0) return(6); else return(5);
		case -1:
			if (Vect[2] == def) return(2);
			if (Vect[3] == def) return(3);
			if (Vect[4] == def) return(4);
			break;
		case -2:
			if (Vect[0] == def) return(0);
			if (Vect[1] == def) return(1);
			if (Vect[2] * dr == -def) return(2);
			if (Vect[3] * dr == -def) return(3);
			if (Vect[4] * dr == -def) return(4);
			break;
		case -3: case -4: case -5: case -6: case -7: case -8:
			if (Vect[2] * dr == -def) return(2);
			if (Vect[3] * dr == -def) return(3);
			if (Vect[4] * dr == -def) return(4);
			break;
		default: break;
	}
	return -1;
}

int getvect(int vval)
{
	int i;
	
	for(i=0; i<12; i++){
		if (Vect[i] == vval) return i;
	}
	return -1;
}

/*-----------------------------------------------------------------
 * fromto֓̃xN^iPʓ̾āj
 *-----------------------------------------------------------------*/
int movect(int from, int to)
{
	int fr, tr;
	register int dr, def;
	
	fr = from/BDWID; 
	tr = to/BDWID;
	dr = tr - fr; /* i̍̂ */
	def = to - from;
	switch(dr){
		case 8: case 7: case 6: case 5: case 4: case 3:
			if ((BDWID-1)*dr == def) return BDWID -1;
			if (BDWID*dr == def) return BDWID;
			if ((BDWID+1)*dr == def) return BDWID+1;
			break;
		case 2:
			if (2*BDWID+1 == def) return 2*BDWID+1;
			if (2*BDWID-1 == def) return 2*BDWID-1;
			if ((BDWID-1)*2 == def) return BDWID - 1;
			if (BDWID*2 == def)     return BDWID;
			if ((BDWID+1)*2 == def) return BDWID + 1;
			break;
		case 1:
			if ((BDWID-1) == def) return BDWID - 1;
			if (BDWID == def)     return BDWID;
			if ((BDWID+1) == def) return BDWID + 1;
			break;
		case 0:
			if (def > 0) return 1; else return -1;
		case -1:
			if (-(BDWID-1) == def) return -(BDWID - 1);
			if (-BDWID == def)     return -BDWID;
			if (-(BDWID+1) == def) return -(BDWID + 1);
			break;
		case -2:
			if (-(2*BDWID+1) == def) return -(2*BDWID+1);
			if (-(2*BDWID-1) == def) return -(2*BDWID-1);
			if (-(BDWID-1)*2 == def) return -(BDWID - 1);
			if (-BDWID*2 == def)     return -BDWID;
			if (-(BDWID+1)*2 == def) return -(BDWID + 1);
			break;
		case -3: case -4: case -5: case -6: case -7: case -8:
			if ((BDWID-1)*dr == def) return -(BDWID - 1);
			if (BDWID*dr == def)     return -BDWID;
			if ((BDWID+1)*dr == def) return -(BDWID + 1);
			break;
		default: break;
	}
	return 0;
}

//----------------񑀍

char *spskip(char *p)
{
/*
	while(*p == ' ' || *p == '\t') p++;
	return p;
*/
	for (;;){
		if (*p == ' ' || *p == '\t') {
			p++;
			continue;
		} else if (equ(p, "@")){ // SpXy[X
			p+=2;
			continue;
		} else {
			return p;
		}
	}
	return p;
}

int str2num(char *p)
{
	int n = 0;
	
	p = spskip(p);
	while (*p >= '0' && *p <= '9'){
		n *= 10;
		n += *p - '0';
		p++;
	}
	return n;
}

int equn(char *str1, char *str2, int n)
{
	return strncmp(str1, str2, n) == 0;
}

// templateɍv邩ǂ
// ̕𔻒
int equ(char *str, char *tplate)
{
	int len;
	
	len = strlen(tplate);
	if (strncmp(str, tplate, len) == 0) {
		return len;
	}
	return 0;
}

// ----------------- ߖT -------------------
// p1p2̂WߖTȂPAłȂȂO
int is_near8(int p1, int p2)
{
	int i, d;
	
	d = p1 - p2;
	for (i=2; i<10; i++){
		if (d == Vect[i]) return 1;
	}
	return 0;
}

