/*********************/
/*    SDJView.cpp    */
/*********************/
#include "stdafx.h"
#include "dib.h"
#include "sdjsysp0.h"
#include "winsdj.h"
#include "mainfrm.h"
#include "childfrm.h"
#include "sdjview.h"
#include "sdjdoc.h"
#include "subview.h"
#include "guideview.h"
#include "kif.h"
#include "nrquery.h"
#include "shgdbdlg.h"
#include "dbeframe.h"
#include "dbedoc.h"
#include "dbeview.h"
#include "sframewnd.h"
#include "dlgeditjs.h"
#include "titlewindow.h"
#include "dlgcreatedb.h"
#include "dlgkiftojs.h"
#include "dlgcsatojs.h"
#include "dlgoutjs.h"
#include "dlgdeljs.h"
#include <WinMemFile.h>
#include "statusbox.h"
#include "winsdjsview.h"
#include "printobject.h"
#include "kifframe.h"
#include "winsdjtsdoc.h"
#include "winsdjtsview.h"
#include "lbase.h"
#include "sdjcmntdoc.h"
#include "sdjcmntframe.h"
#include "sdjcmntview.h"
#include "k2csel\k2csel.h"
#include "dlgseparatedel.h"
#include "dlgkspeed.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4244)

// O[o
extern CWinSDJApp theApp;
extern char *Ktab[];
extern char *Ksu[];

// ֐
// ʒũO[sO
static int GetGroup(CPoint point,BOOL bBoxCheck);

#include "childvsize.h"

/////////////////////////////////////////////////////////////////////////////
// CSDJView

IMPLEMENT_DYNCREATE(CSDJView, COSBView)

BEGIN_MESSAGE_MAP(CSDJView, COSBView)
	//{{AFX_MSG_MAP(CSDJView)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_BANSET_FREE, OnUpdateMenuBanset)
	ON_COMMAND(ID_MENUITEM_BANSET_FREE, OnMenuBanset)
	ON_COMMAND(ID_MENU_KBOXDIB, OnMenuKboxDIB)
	ON_COMMAND(ID_MENU_BANDIB, OnMenuBanDIB)
	ON_COMMAND(ID_MENU_KmDIB, OnMENUKmDIB)
	ON_WM_CHAR()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONDBLCLK()
	ON_COMMAND(ID_SUBWINOPN, OnSubwinopn)
	ON_UPDATE_COMMAND_UI(ID_SUBWINOPN, OnUpdateSubwinopn)
	ON_COMMAND(ID_SUBWINCLS, OnSubwincls)
	ON_UPDATE_COMMAND_UI(ID_SUBWINCLS, OnUpdateSubwincls)
	ON_COMMAND(ID_MENU_EDKIF, OnMenuEdkif)
	ON_UPDATE_COMMAND_UI(ID_MENU_EDKIF, OnUpdateMenuEdkif)
	ON_UPDATE_COMMAND_UI(ID_MENU_BANDIB, OnUpdateMenuBanDIB)
	ON_UPDATE_COMMAND_UI(ID_MENU_KBOXDIB, OnUpdateMenuKboxDIB)
	ON_UPDATE_COMMAND_UI(ID_MENU_KmDIB, OnUpdateMENUKmDIB)
	ON_COMMAND(ID_MENU_AHEAD, OnMenuAhead)
	ON_COMMAND(ID_MENU_BACKMOVE, OnMenuBackmove)
	ON_UPDATE_COMMAND_UI(ID_MENU_AHEAD, OnUpdateMenuAhead)
	ON_UPDATE_COMMAND_UI(ID_MENU_BACKMOVE, OnUpdateMenuBackmove)
	ON_COMMAND(ID_MENU_AUTOAHEAD, OnMenuAutoahead)
	ON_UPDATE_COMMAND_UI(ID_MENU_AUTOAHEAD, OnUpdateMenuAutoahead)
	ON_COMMAND(ID_MENU_AUTOBACK, OnMenuAutoback)
	ON_UPDATE_COMMAND_UI(ID_MENU_AUTOBACK, OnUpdateMenuAutoback)
	ON_COMMAND(ID_MENU_PLAYSTOP, OnMenuPlaystop)
	ON_UPDATE_COMMAND_UI(ID_MENU_PLAYSTOP, OnUpdateMenuPlaystop)
	ON_WM_TIMER()
	ON_COMMAND(ID_MENU_SHGDB, OnMenuShgdb)
	ON_COMMAND(ID_GUIDEFRAME_INVALIDATE,OnGuideFrameInvalidate)
	ON_COMMAND(ID_MENU_HEAD, OnMenuHead)
	ON_UPDATE_COMMAND_UI(ID_MENU_HEAD, OnUpdateMenuHead)
	ON_COMMAND(ID_MENU_TAIL, OnMenuTail)
	ON_UPDATE_COMMAND_UI(ID_MENU_TAIL, OnUpdateMenuTail)
	ON_UPDATE_COMMAND_UI(ID_MENU_EDKIF_TAIL, OnUpdateMenuEdkifTail)
	ON_COMMAND(ID_MENU_EDKIF_TAIL, OnMenuEdkifTail)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COMMENTBOX, OnUpdateViewCommentBox)
	ON_COMMAND(ID_VIEW_COMMENTBOX, OnViewCommentBox)
	ON_UPDATE_COMMAND_UI(ID_MENU_PLAYCMNT, OnUpdateMenuPlaycmnt)
	ON_COMMAND(ID_MENU_PLAYCMNT, OnMenuPlaycmnt)
	ON_COMMAND(ID_DLG_CMNTBOX_CLOSE,OnDlgCmntBoxClose)
	ON_UPDATE_COMMAND_UI(ID_MENU_EDITJS, OnUpdateMenuEditJS)
	ON_COMMAND(ID_MENU_EDITJS, OnMenuEditJS)
	ON_COMMAND(ID_MENU_SETJSVALUE, OnMenuSetJSValue)
	ON_UPDATE_COMMAND_UI(ID_MENU_MKTITLE, OnUpdateMenuMktitle)
	ON_COMMAND(ID_MENU_MKTITLE, OnMenuMktitle)
	ON_WM_SETCURSOR()
	ON_WM_DESTROY()
 	ON_COMMAND(ID_SETSFRAME_NULL,OnSetSFrameNull)
 	ON_COMMAND(ID_SETDBEFRAME_NULL,OnSetDbeFrameNull)
 	ON_COMMAND(ID_SETKIFFRAME_NULL,OnSetKifFrameNull)
	ON_COMMAND(ID_MENU_DBEOPEN, OnMenuDbeOpen)
	ON_UPDATE_COMMAND_UI(ID_MENU_DBEOPEN, OnUpdateMenuDbeOpen)
	ON_COMMAND(ID_MENU_CREATEDB, OnMenuCreateDB)
	ON_UPDATE_COMMAND_UI(ID_MENU_CREATEDB, OnUpdateMenuCreateDB)
	ON_UPDATE_COMMAND_UI(ID_MENU_BUFTODBE, OnUpdateMenuBufToDbe)
	ON_COMMAND(ID_MENU_BUFTODBE, OnMenuBufToDbe)
	ON_UPDATE_COMMAND_UI(ID_MENU_CSATOJS, OnUpdateMenuCsaToJS)
	ON_COMMAND(ID_MENU_CSATOJS, OnMenuCsaToJS)
	ON_UPDATE_COMMAND_UI(ID_MENU_JSTOCSA, OnUpdateMenuJSToCsa)
	ON_COMMAND(ID_MENU_JSTOCSA, OnMenuJSToCsa)
	ON_UPDATE_COMMAND_UI(ID_MENU_DELDBE, OnUpdateMenuDelDbe)
	ON_COMMAND(ID_MENU_DELDBE, OnMenuDelDbe)
	ON_UPDATE_COMMAND_UI(ID_MENU_KSOUND, OnUpdateMenuKSound)
	ON_COMMAND(ID_MENU_KSOUND, OnMenuKSound)
	ON_UPDATE_COMMAND_UI(ID_MENU_DBSTAT, OnUpdateMenuDbstat)
	ON_COMMAND(ID_MENU_DBSTAT, OnMenuDbstat)
	ON_UPDATE_COMMAND_UI(ID_KIF_WINDOW_OPEN, OnUpdateMenuKifWindowOpen)
	ON_COMMAND(ID_KIF_WINDOW_OPEN, OnMenuKifWindowOpen)
	ON_UPDATE_COMMAND_UI(ID_KIF_WINDOW_CLOSE, OnUpdateMenuKifWindowClose)
	ON_COMMAND(ID_KIF_WINDOW_CLOSE, OnMenuKifWindowClose)
	ON_UPDATE_COMMAND_UI(ID_MENU_SETJSVALUE, OnUpdateMenuSetJSValue)
	ON_UPDATE_COMMAND_UI(ID_MENU_CHECK_MATE, OnUpdateMenuCheckMate)
	ON_COMMAND(ID_MENU_CHECK_MATE, OnMenuCheckMate)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY_KF, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_COPY_KF, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_KF, OnUpdateEditPaste)
	ON_COMMAND(ID_EDIT_PASTE_KF, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_MENU_OPEN_KIFWINDOW, OnUpdateMenuOpenKifwindow)
	ON_COMMAND(ID_MENU_OPEN_KIFWINDOW, OnMenuOpenKifwindow)
	ON_COMMAND(ID_ACTIVATE_TABKEY, OnActivateTabkey)
	ON_COMMAND(ID_MENU_K2CSEL, OnMenuK2CSEL)
	ON_UPDATE_COMMAND_UI(ID_MENU_SEPARATE_DEL, OnUpdateMenuSeparateDel)
	ON_COMMAND(ID_MENU_SEPARATE_DEL, OnMenuSeparateDel)
	ON_UPDATE_COMMAND_UI(ID_MENU_KSPEED, OnUpdateMenuKspeed)
	ON_COMMAND(ID_MENU_KSPEED, OnMenuKspeed)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, COSBView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, COSBView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, COSBView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDJView NX̍\z/

CSDJView::CSDJView()
{
	SetBanSettingFlag(FALSE);
	m_pSubFrame	= NULL;
	m_pGuideFrame = NULL;
	m_pKomafont = NULL;
	if (theApp.m_bSDocTemplateUsing)
		m_bKifEditing = TRUE;
	else
		m_bKifEditing = FALSE;
	m_bKifSeparate=FALSE;
	m_iAutoPlay=0;
	m_bCommentDisp=TRUE;
	m_bJSEditing=FALSE;

	m_pSFrame=NULL;     // SDI Frame(Րݒ)
	m_pDbeFrame=NULL;   // Ց

	m_pZaFontDIB=NULL;  // \DIB

	m_pKifFrame=NULL;   // 

	m_bMenuLock=FALSE;


	// w蒍ߑ
	m_pSDJCmntTemplate=new CSSdjDocTemplate(
		IDR_SDJEDITFRAME,
		RUNTIME_CLASS(CSDJCmntDoc),
		RUNTIME_CLASS(CSDJCmntFrame),
		RUNTIME_CLASS(CSDJCmntView));

	// ߑ\ʒu
	CString strSection=EDITOR_SECTION;
	int x1=theApp.GetProfileInt(strSection,CMNT_POS_X1,0);
	int y1=theApp.GetProfileInt(strSection,CMNT_POS_Y1,0);
	int x2=theApp.GetProfileInt(strSection,CMNT_POS_X2,0);
	int y2=theApp.GetProfileInt(strSection,CMNT_POS_Y2,0);
	CRect rc1(x1,y1,x2,y2); rc1.NormalizeRect();	// L̈
	int scW=GetSystemMetrics(SM_CXSCREEN);
	int scH=GetSystemMetrics(SM_CYSCREEN);
	CRect rc2(0,0,scW,scH); rc2.NormalizeRect();	// XN[̈
	CRect rc3;
	if (rc3.IntersectRect(&rc1,&rc2)) {				// dȂ肪΋L̗p
		m_rcCmntBoxPos.SetRect(x1,y1,x2,y2);
	}
	else {
		m_rcCmntBoxPos.SetRectEmpty();
	}
}

CSDJView::~CSDJView()
{
}

void CSDJView::SetBanSettingFlag(BOOL flag)
{
	m_bBanSetting=flag;
}

/////////////////////////////////////////////////////////////////////////////
// CSDJView NX̕`

void CSDJView::OnDraw(CDC* pDC)
{
	CSDJDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// \ȂNCAg̈kB
	ResizeParentToFit(TRUE);

	Render();
	Draw(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CSDJView NẌ

BOOL CSDJView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CSDJView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CSDJView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CSDJView NX̐ff

#ifdef _DEBUG
void CSDJView::AssertValid() const
{
	COSBView::AssertValid();
}

void CSDJView::Dump(CDumpContext& dc) const
{
	COSBView::Dump(dc);
}

CSDJDoc* CSDJView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSDJDoc)));
	return (CSDJDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSDJView NX̃bZ[W nh

// Vobt@Apbg̔wiDIBɃ}b`B
BOOL CSDJView::NewBackground(CDIB* pDIB)
{
    // obt@ƃpbgVKɍ쐬B
    if (!Create(pDIB)) {
        return FALSE;
    }

	// wiDIB̐FAwî߂ɍ쐬PpbgɃpbvB
    pDIB->MapColorsToPalette(GetPalette());

	// Չ摜̑傫ɍ킹ăCt[EBhE𒲐߂B
    GetParentFrame()->RecalcLayout();
    ResizeParentToFit(FALSE); // Try shrinking first.
    ResizeParentToFit(TRUE);  // Let's be daring.

	// V[ŜItXN[obt@Ƀ_O
    Render();

	// ItXN[obt@EBhEɕ`
    Draw();

    return TRUE;
}

// Render the scene to the off-screen buffer.
// pClipRect defaults to NULL.
void CSDJView::Render(CRect* pClipRect)
{
    CSDJDoc* pDoc = GetDocument();

    // Get the background DIB and render it.
    CRect rcDraw;
    CDIB* pDIB = pDoc->GetBackground();
    if (pDIB) {
        pDIB->GetRect(&rcDraw);
        // If a clipping rectangle was supplied, use it.
        if (pClipRect) {
            rcDraw.IntersectRect(pClipRect, &rcDraw);
        }

        // Draw the image of the DIB to the off-screen buffer.
        ASSERT(m_pDIB);
        pDIB->CopyBits(m_pDIB,       
                       rcDraw.left,
                       rcDraw.top,     
                       rcDraw.right - rcDraw.left,
                       rcDraw.bottom - rcDraw.top,
                       rcDraw.left, 
                       rcDraw.top);
    }

	// ̕`
	if (m_bBanSetting) {
		CRect rcKBoxDraw;
		pDIB = &theApp.m_KBoxDIB;
		pDIB->GetRect(&rcKBoxDraw);
		rcKBoxDraw.OffsetRect(KBoxx1-1,KBoxy1-1);
        if (pClipRect) {
            rcKBoxDraw.IntersectRect(pClipRect, &rcKBoxDraw);
        }
        // Draw the image of the DIB to the off-screen buffer.
        ASSERT(m_pDIB);
        pDIB->CopyBits(m_pDIB,       
                       rcKBoxDraw.left,
                       rcKBoxDraw.top,     
                       rcKBoxDraw.right  - rcKBoxDraw.left,
                       rcKBoxDraw.bottom - rcKBoxDraw.top,
					   rcKBoxDraw.left - (KBoxx1-1),
					   rcKBoxDraw.top  - (KBoxy1-1));
	}

	// \̕`
	if (m_pZaFontDIB) {
		CRect rcZaFontDraw;
		m_pZaFontDIB->GetRect(&rcZaFontDraw);
		rcZaFontDraw.OffsetRect(Sdaix1-1,Sdaiy1-20-1);
		if (pClipRect) {
			rcZaFontDraw.IntersectRect(pClipRect, &rcZaFontDraw);
		}
		m_pZaFontDIB->CopyBits(m_pDIB,	// Dest DIB
			rcZaFontDraw.left,			// Dest Address
			rcZaFontDraw.top,
			rcZaFontDraw.right	-	rcZaFontDraw.left,	// width
			rcZaFontDraw.bottom	-	rcZaFontDraw.top,	// height
			rcZaFontDraw.left	-	(Sdaix1-1),			// Source Address
			rcZaFontDraw.top	-	(Sdaiy1-20-1));
	}

    // Render the sprite list from the bottom of the list to the top.
    // Note that we always clip to the background DIB.
    CSpriteList* pList = pDoc->GetSpriteList();
    POSITION pos = pList->GetTailPosition();
    CSprite* pSprite;
    while (pos) {
        pSprite = pList->GetPrev(pos);
        pSprite->Render(m_pDIB, &rcDraw);
    }
}

///////////////////
// Ղ̕`
//    Input :   int sg     (0) (1)
//
void CSDJView::DrawBan(CDC *pDC,int sg)
{
	theApp.m_BackDIB[sg].Draw(pDC,0,0);
}

/////////////////////////////////////////////////////////////
//  ֐
//

///////////////////
// Ղ̕`
//    Input :   int sg     (0) (1)
//
void CSDJView::DescribeBan(CDC *pDC,CRect *pRect,int sg)
{

	CBrush *poldbr;
	CPen *poldpen;

	// wiF̕`
	pDC->FillSolidRect(pRect,BACKCLR);

	// Ղ̕`
	CRect rcBan(Banx1-10,Bany1-9,Banx2+11,Bany2+9);
	DrawPanel(pDC,&rcBan,1,BANCLR,BANFCCLR,BANFDCLR);

	// ڂ`
	CPen penBanFrame(PS_SOLID,1,BANFRAME);
	poldpen=pDC->SelectObject(&penBanFrame);
	int i;
	for (i=0;i<=9;i++) {
		pDC->MoveTo(Banx1,Bany1+40*i);pDC->LineTo(Banx2+1,Bany1+40*i);
		pDC->MoveTo(Banx1+40*i,Bany1);pDC->LineTo(Banx1+40*i,Bany2+1);
	}
	pDC->SelectObject(poldpen);

	// _ł
    CBrush brBanFrame(BANFRAME);
	poldbr=pDC->SelectObject(&brBanFrame);
	poldpen=pDC->SelectObject(&penBanFrame);
	int j;
	for (i=1;i<=2;i++) {
		for (j=1;j<=2;j++)
			pDC->Ellipse(Banx1+40*3*i-2,Bany1+40*3*j-2,Banx1+40*3*i+3,Bany1+40*3*j+3);
	}
	pDC->SelectObject(poldbr);
	pDC->SelectObject(poldpen);

	// Ր
	char *ppKan[10]={"","","O","l","","Z","","","",NULL};
	char *ppSuj[10]={"1","2","3","4","5","6","7","8","9",NULL};
	CFont *pfCurr=pDC->GetCurrentFont(); // stHgIuWFNg̎擾
	LOGFONT lfFont;
	pfCurr->GetObject(sizeof(LOGFONT),&lfFont); // s̃tHg̎擾
	lfFont.lfHeight=10;
	lfFont.lfWidth=0;
	if (sg!=0)
		lfFont.lfEscapement=1800; // Ԃ̏ꍇ͋ttHg
	strcpy(lfFont.lfFaceName,"lr ");
	CFont fSuji;
	fSuji.CreateFontIndirect(&lfFont); // ՐtHgCreate.
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(SUJICLR);
	CFont *poldfont=pDC->SelectObject(&fSuji);
	int kx,ky,sx,sy;
	if (sg==0) { // Ղ̏ꍇ
		for (i=0;i<9;i++) {
			kx=Banx2+1;ky=Bany1+40*i+15;
			sx=Banx1+40*i+16;sy=Bany1-9;
			pDC->TextOut(kx,ky,ppKan[i]);
			pDC->TextOut(sx,sy,ppSuj[8-i]);
		}
	}
	else {	// Ղ̏ꍇ
		for (i=0;i<9;i++) {
			kx=Banx1;ky=Bany1+40*i+25;
			sx=Banx1+40*i+21;sy=Bany2+11;
			pDC->TextOut(kx,ky,ppKan[8-i]);
			pDC->TextOut(sx,sy,ppSuj[i]);
		}
	}
	pDC->SelectObject(poldfont);

	// ̕`
	CRect rcSdai(Sdaix1,Sdaiy1,Sdaix2,Sdaiy2);
	DrawPanel(pDC,&rcSdai,2,DAICLR,DAIFCCLR,DAIFDCLR);// 

	CRect rcGdai(Gdaix1,Gdaiy1,Gdaix2,Gdaiy2);
	DrawPanel(pDC,&rcGdai,2,DAICLR,DAIFCCLR,DAIFDCLR);// 
}

//////////////////
// pl̕`(ՁAp)
// Input :  CPoint *pBox plg int idw plOg
//          int ichr F ifcclr gF ifdclr gÐF
void CSDJView::DrawPanel(CDC *pDC,CRect *pBox,int idw,
			   COLORREF iclr,COLORREF ifcclr,COLORREF ifdclr)
{
	CBrush *poldbr;	// ۑpuV
	CPen *poldpen;  // ۑpy

	// lp`̕`
	CBrush brRect(iclr);
	CPen penRect(PS_SOLID,1,iclr);
	poldbr=pDC->SelectObject(&brRect);
	poldpen=pDC->SelectObject(&penRect);
	pDC->Rectangle(pBox);
	pDC->SelectObject(poldbr);
	pDC->SelectObject(poldpen);

	CPoint TL=pBox->TopLeft();		// lp`
	CPoint RB=pBox->BottomRight();  // lp`E

	// g̕`
	CPoint Frame1[6];
    Frame1[0]=TL;
    Frame1[1].x=RB.x;Frame1[1].y=TL.y;
    Frame1[2].x=RB.x+idw;Frame1[2].y=TL.y-idw;
    Frame1[3].x=TL.x-idw;Frame1[3].y=TL.y-idw;
    Frame1[4].x=TL.x-idw;Frame1[4].y=RB.y+idw;
    Frame1[5].x=TL.x;Frame1[5].y=RB.y;
	CBrush brFrame1(ifcclr);
	CPen penFrame1(PS_SOLID,1,ifcclr);
	poldbr=pDC->SelectObject(&brFrame1);
	poldpen=pDC->SelectObject(&penFrame1);
	pDC->Polygon(Frame1,6);
	pDC->SelectObject(poldbr);
	pDC->SelectObject(poldpen);

	// Øg̕`
	CPoint Frame2[6];
    Frame2[0]=RB;
    Frame2[1].x=TL.x;Frame2[1].y=RB.y;
    Frame2[2].x=TL.x-idw;Frame2[2].y=RB.y+idw;
    Frame2[3].x=RB.x+idw;Frame2[3].y=RB.y+idw;
    Frame2[4].x=RB.x+idw;Frame2[4].y=TL.y-idw;
    Frame2[5].x=RB.x;Frame2[5].y=TL.y;
	CBrush brFrame2(ifdclr);
	CPen penFrame2(PS_SOLID,1,ifdclr);
	poldbr=pDC->SelectObject(&brFrame2);
	poldpen=pDC->SelectObject(&penFrame2);
	pDC->Polygon(Frame2,6);
	pDC->SelectObject(poldbr);
	pDC->SelectObject(poldpen);
}

////////////////////////
// `
//  x,y ՃAhX(11~99) sg,km,nr  (0/1)A(0~7)A\(0/1)
void CSDJView::DrawKoma(CDC *pDC,int x,int y,int sg,int km,int nr)
{
	// ̕`
	int kxs=Banx1+(9-x)*40+1,kys=Bany1+(y-1)*40+1;
	theApp.m_KomaDIB[sg][km][nr].Draw(pDC,kxs,kys);
}
////////////////////////
// `
//  x,y ՃAhX(11~99) sg,km,nr  (0/1)A(0~7)A\(0/1)
void CSDJView::DescribeKoma(CDC *pDC,int x,int y,int sg,int km,int nr)
{
	// ̕`
	int kxs=Banx1+(9-x)*40+1,kys=Bany1+(y-1)*40+1;
	int iKmPalette;
	COLORREF clr;
	for (int j=0;j<Komays;j++) {
		for (int i=0;i<Komaxs;i++) {
			iKmPalette=GetKmPixel(i,j,sg,km,nr);
			switch(iKmPalette) {
			case 3 : clr=BANCLR;break;
			case 1 : clr=KOMACLR;break;
			case 12: clr=KOMAFCCLR;break;
			case 13: clr=KOMAFDCLR;break;
			case 2 : clr=KOMAPRCLR;break;
			default: clr=RGB(0,0,0);
			}
			clr=pDC->SetPixel(kxs+i,kys+j,clr);
		}
	}
}

void CSDJView::OnInitialUpdate() 
{
	COSBView::OnInitialUpdate();

	// 蒆ɃhLgݒ肷B 
	m_KmStack.SetDocument(GetDocument());

	// SDI View(ǖʐݒ)łȂΏJ
	if (IsKindOf(RUNTIME_CLASS(CWinSDJSView))!=TRUE) {
		CreateGuideFrame(); // ǖʕ\̃I[v
		CreateSubFrame();   // o\̃I[v
	}

	// TCY(łő)
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit(FALSE);
	ResizeParentToFit(TRUE);
}


static const char *pstrRuleCheck[11] = {"", // 0 OK
"ł",								  // 1
"ŝȂ͑łĂ܂",			  // 2
"܂",							  // 3
"s͋܂",					  // 4 
"łl߂ł",						  // 5
"ւ͓܂",				      // 6
"ł",								  // 7
"ԂႢ܂",						  // 8
"߂͋܂",				  // 9
"[ᔽł",						  // 10
};
static int RuleCheck0(CKmSprite *pKmSprite,CKif Kif,CKBase *pKBase)
{
	// [`FbN
	int pos=Kif.kif2pos(pKmSprite->GetZa());
	PLAY play;
	play.setmove(pKmSprite,pos,pKmSprite->GetNr());
	int result=pKBase->rulechk(&play);
	if (result==4) { // ss̏ꍇ
		int sg,km,nr;
		pKmSprite->GetKmStatus(&sg,&km,&nr);
		pKmSprite->SetKmStatus(sg,km,!nr); // IɁuv
		play.setmove(pKmSprite,pos,pKmSprite->GetNr());
		result=pKBase->rulechk(&play);
	}
	return result;
}

// [`FbN
BOOL CSDJView::RuleCheck(CKmSprite *pKmSprite,CKif Kif)
{
	CKBase *pKBase=GetDocument()->GetKBase(); // KBase

	// 悸̓[`FbN
	int result=RuleCheck0(pKmSprite,Kif,pKBase);
	if (result) { // [`FbNG[
		AfxMessageBox(pstrRuleCheck[result]);
		return FALSE; // NG
	}

	// [`FbNnjȂ琬/s₤
	// ̏
	int sg,km,nr;
	pKmSprite->GetKmStatus(&sg,&km,&nr);
	CKif Kif0=pKmSprite->GetKmPos();

	// ړՏŁAsŁAړEɓGwΐ/s₤
	int nrQuery=FALSE;
	if (Kif0.kt==0 && nr==0 && km!=0 && km!=3) { // ʂƋ͏O
		if (sg==SIDE_A && (Kif0.ky<=3 || Kif.ky<=3))
			nrQuery=TRUE;
		if (sg==SIDE_B && (Kif0.ky>=7 || Kif.ky>=7))
			nrQuery=TRUE;
	}
	if (nrQuery) {
		CNrQuery QueryBox;
		ReleaseCapture(); // }EX(Ăt[Y)
		int nrYes=QueryBox.DoModal(); // /s₤
		SetCapture(); // }EXLv`(Ăы)
		if (nrYes==IDOK) {
			pKmSprite->SetKmStatus(sg,km,!nr); // 
		}
	}

    // x[`FbN
	// Luv̏𖞑wɂāA
	// sł̃[`FbN͂njłÃ[`FbN
	// ł͂mfɂȂP[X(ȃP[X͂ȂȂ)`FbNB
	result=RuleCheck0(pKmSprite,Kif,pKBase);
	if (result) { // [`FbNG[
		AfxMessageBox(pstrRuleCheck[result]);
		return FALSE; // NG
	}
	return TRUE; // OK
}

// tVONbN
static int group1,group2;
void CSDJView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (!m_bKifEditing)
		return ; // ҏWłȂΉȂB
	
	CSDJDoc *pDoc=GetDocument();
 	CSpriteList* pList = pDoc->GetSpriteList();
	CKmSprite *pKmSprite=NULL;
	CKmSprite *pKmSprite2=NULL;
	int i;

	// _Wϊ
	CDC *pDC=GetDC();
	OnPrepareDC(pDC);
	pDC->DPtoLP(&point);
    ReleaseDC(pDC);

	// qbgꂽǂׂ
	if (m_KmStack.GetKmCtr()>0) { // ɎĂ΂̋̓qbg̑ΏۂO
		for (i=0;i<m_KmStack.GetKmCtr();i++)
			pList->Remove(m_KmStack.GetSprite(i));
		pKmSprite = (CKmSprite *)pList->HitTest(point); // qbgׂ
		for (i=0;i<m_KmStack.GetKmCtr();i++)
			pList->Insert(m_KmStack.GetSprite(i));
	}
	else {
		pKmSprite = (CKmSprite *)pList->HitTest(point);  // qbgׂ
	}

    if (m_KmStack.GetKmCtr()==0) { // }EXLv`ĂȂꍇ
		if (pKmSprite) { // qbg(߂ċqbgꂽꍇ)
			// ՑJČEI_CAO\͋͕sƂB
			// (CKBase̋ǖʂXVƒՑG[NB)
			if (!(theApp.m_bDbeUsing && theApp.m_bSelectBoxBUsing)) {
				ASSERT(!(m_KmStack.GetKmCtr()>=40));
				SetCapture();					// }EXLv`悤ɐݒ	
				m_KmStack.HoldSprite(point,pKmSprite);	// Ɏ
				group1=GetGroup(point,m_bBanSetting); // Ɏ̃O[sO

				RenderAndDrawDirtyList(); // \
			}
		}
    }
	else { // }EXLv`Ăꍇ(ȂƂ͎ɎĂ)
		ASSERT(!(m_KmStack.GetKmCtr()<=0));
		CKif Kif;
		Kif.kifxy(point,m_bBanSetting); // W̎擾
		group2=GetGroup(point,m_bBanSetting); // ړ̃O[v`FbN
		if (group2==0) // Տւ̈ړȂ珡ړqbgqbgƂɂB
			pKmSprite2=pDoc->GetBoard()->GetSprite(Kif);// Տ̋𒲂ׂ
		else
			pKmSprite2=NULL;

		if (pKmSprite!=NULL || pKmSprite2!=NULL) { // qbgꂽ
			ASSERT(!(m_KmStack.GetKmCtr()>=40));
			if (group2==group1) {   // O[v̋̏ꍇ
				int iSide; // qbgꂽ̌
				if (pKmSprite!=NULL) iSide=pKmSprite->GetSg();
				else				 iSide=pKmSprite2->GetSg();
				if (m_KmStack.TopSprite()->GetSg()==iSide) { // ̋Ȃ
					if (!IsRuleChecking()) { // [`FbNł͂ȂA
						if (pKmSprite!=NULL) { // ƋqbgĂ
							m_KmStack.TopSprite()->SetZ(20); // 蒆̌̋
							m_KmStack.HoldSprite(point,pKmSprite); // Ɏ
						}
					}	
				}
				else if (group2==0) { // Տŋt̋̏ւ̈ړ̏ꍇ
					BOOL Check=TRUE;
					if (IsRuleChecking()) { // [`FbNȂ
						Check=RuleCheck(m_KmStack.TopSprite(),Kif);
					}
					if (Check) {
						// [`FbNŋݒLȂ
						if (IsRuleChecking() && theApp.m_bKSoundEnable)
							theApp.m_KSound.Play(); // 炷B

						// ߑJĂ
						SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

						// ǖʂ̍XV
						m_KmStack.PutSprite(Kif); // ̈ʒu֎蒆̋u

						// JĂeXV
						if (m_pKifFrame) {
							m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
						}

						// ǖʏ̍XV(Ȅ)
						if (GetGuideFrame()!=NULL)
							GetGuideFrame()->Invalidate();

						// ՕҏWȂwo^
						if (m_bJSEditing) {
							CKBase *pKBase=pDoc->GetKBase();
							CBform Bform;
							int side;
							// ŐǖʂƎw𓾂(B`)
							B_PLAY bplay=pKBase->LastBplay(&Bform,&side);
							CDBE Dbe;
							if (Dbe.Open()) {
								Dbe.WriteJS(&Bform,side,bplay,pDoc->m_Eval,pDoc->m_Attr);
								Dbe.Close();
							}
						}
						// ՑJĂeXV
						if (theApp.m_bDbeUsing) {
							ASSERT(theApp.m_pDbeDocTemplate);
							CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
							if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
								CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
								pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
							}
						}
					}
				}
			}
			else if (group2>0) { // ijւ̈ړ̎
				if (!IsRuleChecking()) // [`FbNłȂ
					m_KmStack.PutSprite(Kif); // 蒆̋u
			}
		}
		else { // qbgȂ
			if (group2>=0) {  // Տォ()ւ̋ړȂ
				CKmSprite *pTopSprite=m_KmStack.TopSprite();
				CKif oldKif=pTopSprite->GetKmPos();
				if (group2==0) {	// ՏÄʒuw肳ꂽꍇ
					if (group2==group1 && 
						oldKif.kx==Kif.kx && 
						oldKif.ky==Kif.ky) { // Տ̈ړqbg
						int sg,km,nr;
						pTopSprite->GetKmStatus(&sg,&km,&nr); // 擾
						pTopSprite->SetKmStatus(sg,km,!nr); // \ϊ
						pTopSprite->AddRegion();   // \XV̈̒ǉ
					}
					else {
						BOOL Check=TRUE;
						if (IsRuleChecking()) { // [`FbNȂ
							Check=RuleCheck(m_KmStack.TopSprite(),Kif);
						}
						if (Check) {
							// [`FbNŋݒLȂ
							if (IsRuleChecking() && theApp.m_bKSoundEnable)
								theApp.m_KSound.Play(); // 炷B

							// ߑJĂ
							SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

							// ǖʂ̍XV
							m_KmStack.PutSprite(Kif); // 蒆̋u

							// JĂeXV
							if (m_pKifFrame) {
								m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
							}

							// ǖʏ̍XV(Ȅ)
							if (GetGuideFrame()!=NULL)
								GetGuideFrame()->Invalidate();

							// ՕҏWȂwo^
							if (m_bJSEditing) {
								CKBase *pKBase=pDoc->GetKBase();
								CBform Bform;
								int side;
								// ŐǖʂƎw𓾂(B`)
								B_PLAY bplay=pKBase->LastBplay(&Bform,&side);
								CDBE Dbe;
								if (Dbe.Open()) {
									Dbe.WriteJS(&Bform,side,bplay,pDoc->m_Eval,pDoc->m_Attr);
									Dbe.Close();
								}
							}
							// ՑJĂeXV
							if (theApp.m_bDbeUsing) {
								ASSERT(theApp.m_pDbeDocTemplate);
								CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
								if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
									CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
									pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
								}
							}
						}
					}
				}
				else if (group2!=group1) { // Ⴄւ̈ړȂ
					if (!IsRuleChecking()) // [`FbNłȂ
						m_KmStack.PutSprite(Kif); // 蒆̋u
				}
			}
			else  // Ȉʒuɋ𓮂ƂB
				m_KmStack.ReturnSprite(); // 蒆̋̈ʒuɖ߂
		}

		if (m_KmStack.GetKmCtr()==0) { // ɎĂȂȂ
			::ReleaseCapture();
		}
		else  // ܂ɋcĂ
			m_KmStack.TopSprite()->SetZ(10); // Z őO

		RenderAndDrawDirtyList(); // \
	} // }EXLv`Ăꍇ(ȂƂ͎ɎĂ)

}

// ʒũO[sO
static int GetGroup(CPoint point,BOOL bBoxCheck)
{
	CKif Kif;
	int group;

	Kif.kifxy(point,bBoxCheck); // W̎擾
	switch (Kif.kt) {
	case 0:
		group = 0;// Տ
		break;
	case 1:
		if (Kif.ky==0)	group = 1; // 
		else			group = 2; // 
		break;
	case 2:
		group = 3; // 
		break;
	default:
		group = -1; // ՊO
		break;
	}

	return group;
}

// }EẌړ
void CSDJView::OnMouseMove(UINT nFlags, CPoint point) 
{
	int i;

	// _Wϊ
	CDC *pDC=GetDC();
	OnPrepareDC(pDC);
	pDC->DPtoLP(&point);
    ReleaseDC(pDC);

    if (m_KmStack.GetKmCtr()>0) { // ɎĂ
		for (i=0;i<m_KmStack.GetKmCtr();i++)
			m_KmStack.SetPosition(i,point); // 蒆̋̈ʒuXV

        // Render and draw the changes.
        RenderAndDrawDirtyList();
    }
}

//  Rݒ
void CSDJView::OnUpdateMenuBanset(CCmdUI* pCmdUI) 
{
	if (m_bBanSetting)
		pCmdUI->SetText("RݒI(&E)");
	else
		pCmdUI->SetText("Rݒ(&S)");
}

// Րݒ
void CSDJView::Banset(BOOL flag)
{
	CSDJDoc *pDoc= GetDocument();
	CKmSprite *KmSprite=pDoc->GetKmSpriteArray();
	CSpriteList *pSpriteList=pDoc->GetSpriteList();
	int i;
	CKif Kif;

	if (flag) { // Banset TRUE
		SetBanSettingFlag(TRUE);// Րݒ蒆ɂ(J)
		for (i=0;i<40;i++) {
			Kif=KmSprite[i].GetKmPos();
			if (Kif.kt==2) // ̋Ȃ
				pSpriteList->Insert(&KmSprite[i]); // \Xg։
		}
	} else { // Banset FALSE
		SetBanSettingFlag(FALSE);// Րݒ蒆I()
		for (i=0;i<40;i++) {
			Kif=KmSprite[i].GetKmPos();
			if (Kif.kt==2) // ̋Ȃ
				pSpriteList->Remove(&KmSprite[i]); // \Xg珜
		}
	}
	Render();
	Draw();
}

// Ֆʐݒ
void CSDJView::OnMenuBanset() 
{
	if (m_bBanSetting) { // Րݒ蒆Ȃ
		Banset(FALSE);
	}
	else { // Րݒ蒆łȂ
		Banset(TRUE);
	}
}

// J[F̃`FbN---------------------------------------------------------
int CSDJView:: CheckColors(void)
{
	CDC *pDC=GetDC();
	ASSERT(pDC);
	int iSysColors=pDC->GetDeviceCaps(NUMCOLORS);
    ReleaseDC(pDC);
	return iSysColors;
}

// _pbg̍\z
void CSDJView::CreateSDJPalette(CPalette *pPalette)
{
	// _pbg̍\z
	LOGPALETTE *pPal=(LOGPALETTE *)malloc(sizeof(LOGPALETTE)
		                        +256*sizeof(PALETTEENTRY));
	if (pPal) {
		pPal->palVersion=0x300;	// Windows3.0
		pPal->palNumEntries=20;	// 20 F

		// F
		pPal->palPalEntry[0].peRed=theApp.m_prm.komared;
		pPal->palPalEntry[0].peGreen=theApp.m_prm.komagreen;
		pPal->palPalEntry[0].peBlue=theApp.m_prm.komablue;
		pPal->palPalEntry[0].peFlags=0;
		// F
		pPal->palPalEntry[1].peRed=theApp.m_prm.komafcred;
		pPal->palPalEntry[1].peGreen=theApp.m_prm.komafcgreen;
		pPal->palPalEntry[1].peBlue=theApp.m_prm.komafcblue;
		pPal->palPalEntry[1].peFlags=0;
		// ÐF
		pPal->palPalEntry[2].peRed=theApp.m_prm.komafdred;
		pPal->palPalEntry[2].peGreen=theApp.m_prm.komafdgreen;
		pPal->palPalEntry[2].peBlue=theApp.m_prm.komafdblue;
		pPal->palPalEntry[2].peFlags=0;
		// 蕶F
		pPal->palPalEntry[3].peRed=theApp.m_prm.komaprred;	
		pPal->palPalEntry[3].peGreen=theApp.m_prm.komaprgreen;
		pPal->palPalEntry[3].peBlue=theApp.m_prm.komaprblue;
		pPal->palPalEntry[3].peFlags=0;
		// ՐF
		pPal->palPalEntry[4].peRed=theApp.m_prm.banred;	
		pPal->palPalEntry[4].peGreen=theApp.m_prm.bangreen;
		pPal->palPalEntry[4].peBlue=theApp.m_prm.banblue;
		pPal->palPalEntry[4].peFlags=0;
		// ՉF
		pPal->palPalEntry[5].peRed=theApp.m_prm.banfcred;	
		pPal->palPalEntry[5].peGreen=theApp.m_prm.banfcgreen;
		pPal->palPalEntry[5].peBlue=theApp.m_prm.banfcblue;
		pPal->palPalEntry[5].peFlags=0;
		// ՉÐF
		pPal->palPalEntry[6].peRed=theApp.m_prm.banfdred;	
		pPal->palPalEntry[6].peGreen=theApp.m_prm.banfdgreen;
		pPal->palPalEntry[6].peBlue=theApp.m_prm.banfdblue;
		pPal->palPalEntry[6].peFlags=0;
		// F
		pPal->palPalEntry[7].peRed=theApp.m_prm.daired;	
		pPal->palPalEntry[7].peGreen=theApp.m_prm.daigreen;
		pPal->palPalEntry[7].peBlue=theApp.m_prm.daiblue;
		pPal->palPalEntry[7].peFlags=0;
		// 䉏F
		pPal->palPalEntry[8].peRed=theApp.m_prm.daifcred;	
		pPal->palPalEntry[8].peGreen=theApp.m_prm.daifcgreen;
		pPal->palPalEntry[8].peBlue=theApp.m_prm.daifcblue;
		pPal->palPalEntry[8].peFlags=0;
		// 䉏ÐF
		pPal->palPalEntry[9].peRed=theApp.m_prm.daifdred;	
		pPal->palPalEntry[9].peGreen=theApp.m_prm.daifdgreen;
		pPal->palPalEntry[9].peBlue=theApp.m_prm.daifdblue;
		pPal->palPalEntry[9].peFlags=0;
		// F
		pPal->palPalEntry[10].peRed=theApp.m_prm.kboxred;	
		pPal->palPalEntry[10].peGreen=theApp.m_prm.kboxgreen;
		pPal->palPalEntry[10].peBlue=theApp.m_prm.kboxblue;
		pPal->palPalEntry[10].peFlags=0;
		// F
		pPal->palPalEntry[11].peRed=theApp.m_prm.kboxfcred;	
		pPal->palPalEntry[11].peGreen=theApp.m_prm.kboxfcgreen;
		pPal->palPalEntry[11].peBlue=theApp.m_prm.kboxfcblue;
		pPal->palPalEntry[11].peFlags=0;
		// ÐF
		pPal->palPalEntry[12].peRed=theApp.m_prm.kboxfdred;	
		pPal->palPalEntry[12].peGreen=theApp.m_prm.kboxfdgreen;
		pPal->palPalEntry[12].peBlue=theApp.m_prm.kboxfdblue;
		pPal->palPalEntry[12].peFlags=0;
		// wiF
		pPal->palPalEntry[13].peRed=theApp.m_prm.backred;	
		pPal->palPalEntry[13].peGreen=theApp.m_prm.backgreen;
		pPal->palPalEntry[13].peBlue=theApp.m_prm.backblue;
		pPal->palPalEntry[13].peFlags=0;
		// gF
		pPal->palPalEntry[14].peRed=theApp.m_prm.winfrred;	
		pPal->palPalEntry[14].peGreen=theApp.m_prm.winfrgreen;
		pPal->palPalEntry[14].peBlue=theApp.m_prm.winfrblue;
		pPal->palPalEntry[14].peFlags=0;
		// F
		pPal->palPalEntry[15].peRed=theApp.m_prm.winbkred;	
		pPal->palPalEntry[15].peGreen=theApp.m_prm.winbkgreen;
		pPal->palPalEntry[15].peBlue=theApp.m_prm.winbkblue;
		pPal->palPalEntry[15].peFlags=0;
		// gF
		pPal->palPalEntry[16].peRed=theApp.m_prm.winfcred;	
		pPal->palPalEntry[16].peGreen=theApp.m_prm.winfcgreen;
		pPal->palPalEntry[16].peBlue=theApp.m_prm.winfcblue;
		pPal->palPalEntry[16].peFlags=0;
		// gÐF
		pPal->palPalEntry[17].peRed=theApp.m_prm.winfdred;	
		pPal->palPalEntry[17].peGreen=theApp.m_prm.winfdgreen;
		pPal->palPalEntry[17].peBlue=theApp.m_prm.winfdblue;
		pPal->palPalEntry[17].peFlags=0;

		// 
		pPal->palPalEntry[18].peRed=0;
		pPal->palPalEntry[18].peGreen=0;
		pPal->palPalEntry[18].peBlue=0;
		pPal->palPalEntry[18].peFlags=0;

		// 
		pPal->palPalEntry[19].peRed=255;
		pPal->palPalEntry[19].peGreen=255;
		pPal->palPalEntry[19].peBlue=255;
		pPal->palPalEntry[19].peFlags=0;

		pPalette->CreatePalette(pPal); // pbg̍\z
		free(pPal);
	} else {
		TRACE("Memory not enough!! for CreatePalette\n");
	}
}

// DIB쐬
void CSDJView::OnMenuKboxDIB() 
{
	if (m_bMenuLock)
		return;
	// ⏕B
	Subwincls();

	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CDC *pDC=GetDC();

	// pbg̐ݒ
	CPalette SDJPal;
	CreateSDJPalette(&SDJPal);
	CPalette *pOldPal=pDC->SelectPalette(&SDJPal,FALSE);
	pDC->RealizePalette();

	// ̕`
	CRect rcKBox(KBoxx1,KBoxy1,KBoxx2,KBoxy2);
	DrawPanel(pDC,&rcKBox,1,KBOXCLR,KBOXFCCLR,KBOXFDCLR);// 

	// ɕ(_TĈŎ~)
/*	CFont *pfCurr = pDC->GetCurrentFont(); // stHgIuWFNg̎擾
	LOGFONT lfFont;
	pfCurr->GetObject(sizeof(LOGFONT),&lfFont); // s̃tHg̎擾
	lfFont.lfHeight = 12;
	lfFont.lfWidth  = 0;
	strcpy(lfFont.lfFaceName,"lr ");
	CFont fKBox;
	pDC->SetBkMode(TRANSPARENT);
	fKBox.CreateFontIndirect(&lfFont);
	CFont *poldfont = pDC->SelectObject(&fKBox);
	pDC->SetTextColor(RGB(255,255,0));
	pDC->TextOut(KBoxx1+1,KBoxy1+1,"");
	pDC->SelectObject(poldfont); */

	// DIB̍쐬
	CRect rect;
	CDIB Dib;
	char Fname[256];
	rect.SetRect(KBoxx1-1,KBoxy1-1,KBoxx2+2,KBoxy2+2);
	Dib.MakeDib(pDC,&rect);

	int iSysColors=CheckColors(); // J[F

	//if (iSysColors!=16)
		sprintf(Fname,"%sKBox.dib",theApp.m_PgmDir);
	//else
		//sprintf(Fname,"%sKBox16.dib",theApp.m_PgmDir);

	Dib.Save(Fname);

	// pbgɖ߂
	pDC->SelectPalette(pOldPal,FALSE);

	Draw();

    ReleaseDC(pDC);

	// ⏕J
	OnSubwinopn();
}

// ՖDIB쐬
void CSDJView::OnMenuBanDIB() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CDC *pDC=GetDC();
	SendMessage(WM_COMMAND,ID_SUBWINCLS); 	// ⏕

	// pbg̐ݒ
	CPalette SDJPal;
	CreateSDJPalette(&SDJPal);
	CPalette *pOldPal=pDC->SelectPalette(&SDJPal,FALSE);
	pDC->RealizePalette();

	// NCAg̈TCY̐ݒ(COSBView{NXO)
	CSize sizeTotal(685,440);
	SetScrollSizes(MM_TEXT,sizeTotal);
	ResizeParentToFit(FALSE);
	ResizeParentToFit(TRUE);

	// NCAg̈̎擾
	CRect rect;
	GetClientRect(&rect);

	// ՔwiDIB̐
	CDIB m_dib2;
	//char Fname[256];

	// Չ摜̃I[v
	int iSysColors=CheckColors(); // J[F

	//sprintf(Fname,"%sback.dib",theApp.m_PgmDir);

	//CFile f;
	//if (!f.Open(Fname,CFile::modeReadWrite | CFile::modeCreate | CFile::shareExclusive))
	//{
		//char buffer[256];
		//sprintf(buffer,"Չ摜 %s I[vł܂B",Fname);
		//AfxMessageBox(buffer);
		//return ;
	//}

	//for (int sg=0;sg<2;sg++) {
		//DescribeBan(pDC,&rect,sg); // Ղ̕`
		//m_dib2.MakeDib(pDC,&rect);
		//m_dib2.Save(&f);
	//}
	//f.Close(); // Չ摜t@C̃N[Y

	// pbgɖ߂
	pDC->SelectPalette(pOldPal,FALSE);

	// xwiDIBǂݏoāAhLgEr[ɃZbgB--------------------


	theApp.LoadBackDIB(iSysColors);


	CSDJDoc *pDoc=GetDocument();
	pDoc->SetBackground(&theApp.m_BackDIB[pDoc->GetKBase()->GetZa()]);

    ReleaseDC(pDC);

	// r[̃TCY𕜋A
	CSize sizeViewSize(CHILD_VIEW_XSIZE,CHILD_VIEW_YSIZE);
	SetScrollSizes(MM_TEXT,sizeViewSize);
    ResizeParentToFit(FALSE); // Try shrinking first.
    ResizeParentToFit(TRUE);  // Let's be daring.

	// ⏕J
	SendMessage(WM_COMMAND,ID_SUBWINOPN);
}
// DIB쐬
void CSDJView::OnMENUKmDIB() 
{
	if (m_bMenuLock)
		return;
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if (!KmBufferAlloc()) return ; // tHgǂݍ݃obt@̊m

	if (!ReadKomafont()) { // tHg̓ǂݍ(sI)
		KmBufferFree(); // tHgǂݍ݃obt@̊J
		return ;
	}

	CDC *pDC=GetDC();

	// pbg̐ݒ
	CPalette SDJPal;
	CreateSDJPalette(&SDJPal);
	CPalette *pOldPal=pDC->SelectPalette(&SDJPal,FALSE);
	pDC->RealizePalette();

	// DIB̍쐬
	int sg,km,nr,gx,gy;
	CDIB dib2;
	CRect rect2;
	char fname[512];

	// tHgDIB̃I[v
	int iSysColors=CheckColors(); // J[F

	//if (iSysColors!=16)
		sprintf(fname,"%skmfont.dib",theApp.m_PgmDir);
	//else
		//sprintf(fname,"%skmfont16.dib",theApp.m_PgmDir);
	CFile f;
	if (!f.Open(fname,CFile::modeReadWrite | CFile::modeCreate | 
		CFile::shareExclusive)) {
		char buffer[512];
		sprintf(buffer,"摜 %s ̃I[vɎs܂B",fname);
		AfxMessageBox(buffer);
		KmBufferFree(); // tHgǂݍ݃obt@̊J
		return ;
	}
	for (sg=0;sg<2;sg++) {
		for (km=0;km<8;km++) {
			for (nr=0;nr<2;nr++) {
				DescribeKoma(pDC,5,5,sg,km,nr);	// Ղ̕`
				gx=Banx1+(9-5)*40+1;gy=Bany1+(5-1)*40+1;
				rect2.SetRect(gx,gy,gx+39,gy+39);
				dib2.MakeDib(pDC,&rect2);
				dib2.Save(&f);
			}
        }
	}
	f.Close(); // tHgDIB̃N[Y


	// pbgɖ߂
	pDC->SelectPalette(pOldPal,FALSE);

	Draw();

	KmBufferFree(); // tHgǂݍ݃obt@̊J

    ReleaseDC(pDC);
}

// tHgǂݍ݃obt@̎擾
BOOL CSDJView::KmBufferAlloc()
{
	size_t iSize=sizeof(Komafont)*2*8*2;

	if (m_pKomafont!=NULL) { // tHgobt@̊J
		free(m_pKomafont);
	}
	if ((m_pKomafont=(Komafont (*)[2][8][2])malloc(iSize))==NULL) {
		char buf[512];
		sprintf(buf,"܂B");
		MessageBox(buf,"tHgǂݍ݃G[",MB_ICONWARNING);
		return FALSE;
	}
	else
		return TRUE;
}
// tHgǂݍ݃obt@̊J
void CSDJView::KmBufferFree()
{
	if (m_pKomafont!=NULL) { // tHgobt@̊J
		free(m_pKomafont);
		m_pKomafont=NULL;
	}
}

// tHg̓ǂݍ
BOOL CSDJView::ReadKomafont(void)
{
	char strFname[512];
	sprintf(strFname,"%skomafnt.ft2",theApp.m_PgmDir);


	try {
		// t@C̃I[v
		CFile File(strFname,CFile::modeRead | CFile::shareDenyWrite);

		try {
			int i,j,k;
			long    offset,leng,lk;

			int colormode=3;  // PC98 16 F[h(0:mono 1:8/8 2:8/4096 3:16/4096)

			/* J[[ht@CItZbgƃtHgTCYvZ */
			for (leng=0,offset=0,i=0;i<=colormode%4;i++) {
				if (i==0)      lk=1;
				else if (i==3) lk=4;
				else	       lk=3;
				offset=offset+leng*32L;
				leng=(Komaxs+7)/8*Komays*lk+4;	
			}
			File.Seek(offset,CFile::begin); // ǂݏoʒuɃV[N
			for (i=0;i<8;i++)    {
				for (j=0;j<2;j++)    {
					for (k=0;k<2;k++)    {
						File.Read(&(*m_pKomafont)[k][i][j],(UINT)leng); // Pǂ
					}
				}
			}
			File.Close(); // 摜N[Y

			return TRUE;
		}
		catch(CFileException *e) {
			File.Close(); // 摜N[Y
			char buf[512];
			sprintf(buf,"摜 %s ̓ǂݍ݂Ɏs܂B",strFname);
			MessageBox(buf,"tHgǂݍ݃G[",MB_ICONWARNING);
			e->Delete();

			return FALSE;
		}
	}
	catch (CFileException *e) {
		char buf[512];
		sprintf(buf,"摜 %s ̃I[vɎs܂B",strFname);
		MessageBox(buf,"tHgǂݍ݃G[",MB_ICONWARNING);
		e->Delete();

		return FALSE;
	}
}

// tHgsNZ̎Q
//		tHg̃pbgԍԂ
int CSDJView::GetKmPixel(int x,int y, // tHgW
					   int sg,		// 
					   int km,		// 
					   int nr		// \
					   )
{
	int iXsz=(*m_pKomafont)[sg][km][nr].xsz;
	unsigned char *ucpFont=(*m_pKomafont)[sg][km][nr].font;
	int iMembytes=(iXsz+7)/8;
	int iLinbytes=iMembytes*4;
	int iPixidx=y*iLinbytes+x/8;
	unsigned char *ucpFont0=ucpFont+iPixidx;   // B plane
	unsigned char *ucpFont1=ucpFont0+iMembytes;	// R plane
	unsigned char *ucpFont2=ucpFont1+iMembytes; // G plane
	unsigned char *ucpFont3=ucpFont2+iMembytes; // I plane

	int iMsb=x % 8;
	unsigned char ucMask=0x80 >> iMsb;
	int iBit0=(*ucpFont0 & ucMask)? 1 : 0;
	int iBit1=(*ucpFont1 & ucMask)? 1 : 0;
	int iBit2=(*ucpFont2 & ucMask)? 1 : 0;
	int iBit3=(*ucpFont3 & ucMask)? 1 : 0;

	int iPaletteNo=iBit0+2*iBit1+4*iBit2+8*iBit3;

	return iPaletteNo;
}

// L[ꂽ
void CSDJView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// ꂽL[Xy[XŎ蒆ɋ
	if (nChar==' ' && m_KmStack.GetKmCtr()>0) {

		SHORT kstat=GetAsyncKeyState(VK_SHIFT);		// VtgL[̏Ԏ擾
		CKmSprite *pKmSprite=m_KmStack.TopSprite();	// 蒆̍őŐ擾

		int sg,km,nr;
		pKmSprite->GetKmStatus(&sg,&km,&nr);		// ̎擾

		if ( (kstat & 0x8000)!=0) {					// VtgL[Ă
			pKmSprite->SetKmStatus(!sg,km,nr);		// ϊ
		}
		else { // VtgL[ĂȂ
			pKmSprite->SetKmStatus(sg,km,!nr);		// \ϊ
		}

		pKmSprite->RenderAndDraw();					// \XV
	} 
}
// EtVONbN
void CSDJView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// _Wϊ
	CDC *pDC=GetDC();
	OnPrepareDC(pDC);
	pDC->DPtoLP(&point);
    ReleaseDC(pDC);

    if (m_KmStack.GetKmCtr()==0) { // }EXLv`ĂȂꍇ
		// qbgꂽǂׂ
		CSpriteList* pList = GetDocument()->GetSpriteList();
		CKmSprite *pKmSprite=NULL;
		int i;
		if (m_KmStack.GetKmCtr()>0) {
			// ɎĂ΂̋̓qbg̑ΏۂO
			for (i=0;i<m_KmStack.GetKmCtr();i++)
				pList->Remove(m_KmStack.GetSprite(i));
			pKmSprite = (CKmSprite *)pList->HitTest(point); // qbgׂ
			for (i=0;i<m_KmStack.GetKmCtr();i++)
				pList->Insert(m_KmStack.GetSprite(i));
		}
		else {
			pKmSprite = (CKmSprite *)pList->HitTest(point);  // qbgׂ
		}

		if (pKmSprite) { // qbg(߂ċqbgꂽꍇ)
			if (IsBanSetting()) { // Րݒ蒆Ȃ
				CKif Kif=pKmSprite->GetKmPos();
				if (Kif.kt==0) { // Տ̋Ȃqbgꂽꍇ
					int sg,km,nr;
					pKmSprite->GetKmStatus(&sg,&km,&nr); // ̎擾
					pKmSprite->SetKmStatus(sg,km,!nr);   // \ϊ
					GetDocument()->SetModifiedFlag();    // hLgXV
					pKmSprite->SetPieceStatus();         // PIECEݒ
					pKmSprite->RenderAndDraw();          // \XV
				}
			}
		}
    }
	else { // 蒆ɎĂꍇ
		m_KmStack.ReturnSprite(); // 蒆̋̈ʒuɖ߂B

		if (m_KmStack.GetKmCtr()==0) { // ɎĂȂȂ
			::ReleaseCapture();
		}
		else  // ܂ɋcĂ
			m_KmStack.TopSprite()->SetZ(10); // Z őO

		RenderAndDrawDirtyList(); // \
	}
}

// t_uNbN
void CSDJView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	if (!m_bKifEditing)
		return ; // ҏWłȂΉȂB
	if (IsRuleChecking()) // [`FbNȂ牽ȂB
		return;
	// _Wϊ
	CDC *pDC=GetDC();
	OnPrepareDC(pDC);
	pDC->DPtoLP(&point);
    ReleaseDC(pDC);

	if (m_KmStack.GetKmCtr()>0) { // ɎĂ
		CKif Kif;
		Kif.kifxy(point,m_bBanSetting); // W̎擾
		group2=GetGroup(point,m_bBanSetting); // ړ̃O[v`FbN

		if (group2 > 0 && group2!=group1) { // ƈႤEւ̈ړȂ
			while (m_KmStack.GetKmCtr()) {
				m_KmStack.PutSprite(Kif,TRUE); // ̈ʒu֎蒆̋SĒu
			}
			::ReleaseCapture(); // }EX[X
		}
	}
}

// Et_uNbN
void CSDJView::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	// _Wϊ
	CDC *pDC=GetDC();
	OnPrepareDC(pDC);
	pDC->DPtoLP(&point);
    ReleaseDC(pDC);

    if (m_KmStack.GetKmCtr()==0) { // }EXLv`ĂȂꍇ
		// qbgꂽǂׂ
		CSpriteList* pList = GetDocument()->GetSpriteList();
		CKmSprite *pKmSprite=NULL;
		int i;
		if (m_KmStack.GetKmCtr()>0) {
			// ɎĂ΂̋̓qbg̑ΏۂO
 			for (i=0;i<m_KmStack.GetKmCtr();i++)
				pList->Remove(m_KmStack.GetSprite(i));
			pKmSprite = (CKmSprite *)pList->HitTest(point); // qbgׂ
			for (i=0;i<m_KmStack.GetKmCtr();i++)
				pList->Insert(m_KmStack.GetSprite(i));
		}
		else {
			pKmSprite = (CKmSprite *)pList->HitTest(point);  // qbgׂ
		}

		if (pKmSprite) { // qbg(߂ċqbgꂽꍇ)
			if (IsBanSetting()) { // Րݒ蒆Ȃ
				CKif Kif=pKmSprite->GetKmPos();
				if (Kif.kt==0) { // Տ̋Ȃqbgꂽꍇ
					int sg,km,nr;
					pKmSprite->GetKmStatus(&sg,&km,&nr); // ̎擾
					// ϊ(VONbNŕ\ϊς݂Ȃ̂łŖ߂)
					pKmSprite->SetKmStatus(!sg,km,!nr);
					pKmSprite->SetPieceStatus();         // PIECEݒ
					pKmSprite->RenderAndDraw();          // \XV
				}
			}
		}
    }
	else { // 蒆ɎĂꍇ
		while (m_KmStack.GetKmCtr())
			m_KmStack.ReturnSprite(); // 蒆̋̈ʒuɖ߂B

		::ReleaseCapture();// }EXLv`[X
	}
}

//TuEBhËʒuvZ
void CSDJView::GetSubWindowRect(CRect *pRect)
{
	// ̃r[̘_W܂ZbgāA
	CSize sizeTotal=GetTotalSize();
	pRect->SetRect(0,0,sizeTotal.cx,sizeTotal.cy);
	// 
	pRect->right=pRect->left+125;
	pRect->top=pRect->bottom-200;
	// _WfoCXW֕ϊ
	CDC *pDC=GetDC();
	OnPrepareDC(pDC);
	pDC->LPtoDP(pRect);
    ReleaseDC(pDC);
}

//ē̈ʒuvZ
void CSDJView::GetGuideWindowRect(CRect *pRect)
{
	// ̃r[̘_W܂ZbgāA
	CSize sizeTotal=GetTotalSize();
	pRect->SetRect(0,0,sizeTotal.cx,sizeTotal.cy);
	// E
	pRect->left=pRect->right-128;
	pRect->bottom=pRect->top+90;
	// _WfoCXW֕ϊ
	CDC *pDC=GetDC();
	OnPrepareDC(pDC);
	pDC->LPtoDP(pRect);
	ReleaseDC(pDC);
}

// TuEBhECreateB
void CSDJView::CreateSubFrame()
{
	if (m_pSubFrame!=NULL)
		return ;
	// TuEBhECreateB
	m_pSubFrame=new CSubFrame;
	CRect rc;
	GetSubWindowRect(&rc); // TuEBhËʒuvZ
	CString cap("o");
	//  WS_CHILDCreateƐethisƂ邱Ƃł邪A
	//  POPUPEBhECreateƐeCMainFrameƂȂB
	BOOL result=m_pSubFrame->Create(NULL,(LPCTSTR)cap,
		WS_CHILD|WS_VISIBLE|WS_CAPTION|WS_SYSMENU|WS_CLIPSIBLINGS,
		rc,this,NULL,WS_EX_TOPMOST,NULL);
	ASSERT(result);

	// TuEBhE̒Ƀr[CreateB
	CRuntimeClass *pSubFrameViewClass=RUNTIME_CLASS(CSubView);
	CCreateContext context;
	context.m_pNewViewClass=pSubFrameViewClass;
	context.m_pCurrentDoc=GetDocument();
	CView *pNewView=(CView *)m_pSubFrame->CreateView(&context);
	// r[ANeBuɂB
	if (pNewView!=NULL) {
		pNewView->ShowWindow(SW_SHOW);
		pNewView->OnInitialUpdate();
		GetSubFrame()->SetActiveView(pNewView);
		GetSubFrame()->RecalcLayout();
	}
	SetFocus(); // ̃r[ɃtH[JXĂB
}

// ē\
void CSDJView::CreateGuideFrame()
{
	if (m_pGuideFrame!=NULL)
		return;
	// TuEBhECreateB
	m_pGuideFrame=new CGuideFrame;
	CRect rc;
	GetGuideWindowRect(&rc); // TuEBhËʒuvZ
	CString cap("ǖ");
	//  WS_CHILDCreateƐethisƂ邱Ƃł邪A
	//  POPUPEBhECreateƐeCMainFrameƂȂB
	BOOL result=m_pGuideFrame->Create(NULL,(LPCTSTR)cap,
		WS_CHILD|WS_VISIBLE|WS_CAPTION|WS_SYSMENU|WS_CLIPSIBLINGS,
		rc,this,NULL,WS_EX_TOPMOST,NULL);
	ASSERT(result);

	// TuEBhE̒Ƀr[CreateB
	CRuntimeClass *pGuideFrameViewClass=RUNTIME_CLASS(CGuideView);
	CCreateContext context;
	context.m_pNewViewClass=pGuideFrameViewClass;
	context.m_pCurrentDoc=GetDocument();
	CView *pNewView=(CView *)m_pGuideFrame->CreateView(&context);
	// r[ANeBuɂB
	if (pNewView!=NULL) {
		pNewView->ShowWindow(SW_SHOW);
		pNewView->OnInitialUpdate();
		m_pGuideFrame->SetActiveView(pNewView);
		m_pGuideFrame->RecalcLayout();
	}
	SetFocus(); // ̃r[ɃtH[JXĂB
}

// q̈ʒu
void CSDJView::AdjustChildFrame()
{
	// TCY(łő)
	ResizeParentToFit(FALSE);
	ResizeParentToFit(TRUE);

	// q\ĂÄʒu𒲐B
	CRect rc;
	if (GetSubFrame()) {
		GetSubWindowRect(&rc);
		GetSubFrame()->MoveWindow(&rc);
	}
	if (GetGuideFrame()) {
		GetGuideWindowRect(&rc);
		GetGuideFrame()->MoveWindow(&rc);
	}
}


// ⏕J
void CSDJView::OnSubwinopn() 
{
	if (m_bMenuLock)
		return;

	// TuEBhEĂJ
	if (!GetSubFrame()) {
		CreateSubFrame();
	}
	// ēĂJ
	if (!GetGuideFrame()) {
		CreateGuideFrame();
	}
}
// ⏕I[v \XV
void CSDJView::OnUpdateSubwinopn(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (GetSubFrame() && GetGuideFrame()) // ׂĂ̑JĂ
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
	
}

// ⏕
void CSDJView::OnSubwincls() 
{
	Subwincls();
}

// ⏕N[Y \XV
void CSDJView::OnUpdateSubwincls(CCmdUI* pCmdUI) 
{
	if (GetSubFrame() || GetGuideFrame()) // J
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
	
}

// EBhEX^C̐ݒ
BOOL CSDJView::PreCreateWindow(CREATESTRUCT& cs) 
{

	cs.style|=WS_CLIPCHILDREN;
	
	return COSBView::PreCreateWindow(cs);
}

// ҏWJn/I
void CSDJView::OnMenuEdkif() 
{
	if (m_bMenuLock)
		return;

	if (m_bKifEditing) { // ݒ蒆
		m_bKifEditing=FALSE;
		if (m_bKifSeparate)
			m_bKifSeparate=FALSE;
	}
	else {              // ݒ蒆ł͂Ȃ
		m_bKifEditing=TRUE;
		SetCursor(theApp.m_hHandCursor); // J[\̃Zbg
	}
}
// ҏWJn/I \XV
void CSDJView::OnUpdateMenuEdkif(CCmdUI* pCmdUI) 
{
	CKBase *pKBase=GetDocument()->GetKBase(); // KBase
	int side=pKBase->turn();
	BOOL bEditOK=FALSE;
	if (side==SIDE_A || side==SIDE_B)
		bEditOK=TRUE;

	if (m_bKifEditing)
		pCmdUI->SetText("ҏWI(&K)");
	else
		pCmdUI->SetText("ҏWJn(&K)");

	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (bEditOK && !m_bJSEditing)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

// ՖDIB쐬 \XV
void CSDJView::OnUpdateMenuBanDIB(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	
	// ̑݃`FbN
	if (theApp.m_bKomafontExist)
		pCmdUI->Enable(TRUE);
	else 
		pCmdUI->Enable(FALSE);
	
}
// DIB쐬 \XV
void CSDJView::OnUpdateMenuKboxDIB(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	//if (theApp.m_bKomafontExist)
		//pCmdUI->Enable(TRUE);
	//else 
		pCmdUI->Enable(FALSE);
	
}

// DIB쐬 \XV
void CSDJView::OnUpdateMENUKmDIB(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (theApp.m_bKomafontExist)
		pCmdUI->Enable(TRUE);
	else 
		pCmdUI->Enable(FALSE);
}

// ⏕
void CSDJView::Subwincls()
{
	if (GetGuideFrame())
		GetGuideFrame()->SendMessage(WM_CLOSE);
	if (GetSubFrame())
		GetSubFrame()->SendMessage(WM_CLOSE);
}

////////
// ǖʂ
static BOOL CheckMenuHead(CKBase *pKBase)
{
	BOOL bEnable;
	if (pKBase->root()!=pKBase->lastmove())
		bEnable=TRUE;
	else
		bEnable=FALSE;

	if (theApp.m_bSelectBoxBUsing && theApp.m_bDbeUsing)
			bEnable=FALSE; // I𑋂ƒՑ𗼕JĂDisable

	return bEnable;
}

void CSDJView::OnUpdateMenuHead(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pCmdUI->Enable(CheckMenuHead(pKBase));
}

void CSDJView::OnMenuHead() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	if (CheckMenuHead(pKBase)==FALSE)
		return;

	// ߑJĂ
	SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	while (pKBase->backmove2()>0); // ǖʂ̖߂(\)

	Invalidate(); // Ōɕ\

	// JĂe
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
	}

	// ǖʏ̍XV
	if (GetGuideFrame()!=NULL)
		GetGuideFrame()->Invalidate();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==this) {
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

}

//////
// ŏIǖʂ
static BOOL CheckMenuTail(CKBase *pKBase)
{
	BOOL bEnable;
	if (pKBase->playnum()>0)
		bEnable=TRUE;
	else
		bEnable=FALSE;

	if (theApp.m_bSelectBoxBUsing && theApp.m_bDbeUsing)
			bEnable=FALSE; // I𑋂ƒՑ𗼕JĂDisable
	
	return bEnable;

}

void CSDJView::OnUpdateMenuTail(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pCmdUI->Enable(CheckMenuTail(pKBase));
}

void CSDJView::OnMenuTail() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	if (CheckMenuTail(pKBase)==FALSE)
		return;

	// ߑJĂ
	SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	while (pKBase->playnum()) {
		pKBase->ahead2(); // Oi(\)
	}
	Invalidate(); // Ōɕ\

	// JĂeXV
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
	}

	// ǖʏ̍XV
	if (GetGuideFrame()!=NULL)
		GetGuideFrame()->Invalidate();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}
}

// Oij[̎{`FbN
static BOOL CheckMenuAhead(CKBase *pKBase)
{
	BOOL bEnable;
	if (pKBase->playnum()>0)
		bEnable=TRUE;
	else
		bEnable=FALSE;

	if (theApp.m_bSelectBoxBUsing && theApp.m_bDbeUsing)
			bEnable=FALSE; // I𑋂ƒՑ𗼕JĂDisable
	return bEnable;
}

// ǖʑOij[\XV
void CSDJView::OnUpdateMenuAhead(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	pCmdUI->Enable(CheckMenuAhead(pKBase));
}

// ǖʑOi					
void CSDJView::OnMenuAhead() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	if (CheckMenuAhead(pKBase)==FALSE)
		return; // AChԂ̃^C~OɂĂ͐B
	

	// ߑJĂ邾
	if (IsCommentBoxOpened()) {
		CloseCommentBox();
        // return; '02.12.08 Ver5.1d deleted by Ra
	}

	pKBase->ahead();

	// JĂeXV
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
	}

	// ǖʏ̍XV
	if (GetGuideFrame()!=NULL)
		GetGuideFrame()->Invalidate();

	if (theApp.m_bKSoundEnable)
		theApp.m_KSound.Play(); // 炷

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	// ߕ΂ΎIɕ\B
	AutoCommentDisplay();

	SetFocus(); // tH[JX͂֒u (02.12.08 Ver5.1d)
}

// ǖʌރj[\XV
static BOOL CheckMenuBackmove(CKBase *pKBase)
{
	BOOL bEnable;
	if (pKBase->root()!=pKBase->lastmove())
		bEnable=TRUE;
	else
		bEnable=FALSE;
	
	if (theApp.m_bSelectBoxBUsing && theApp.m_bDbeUsing)
			bEnable=FALSE; // I𑋂ƒՑ𗼕JĂDisable
	return bEnable;
}

void CSDJView::OnUpdateMenuBackmove(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	
	pCmdUI->Enable(CheckMenuBackmove(pKBase));
}

// ǖʌ
void CSDJView::OnMenuBackmove() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	
	if (CheckMenuBackmove(pKBase)==FALSE)
		return;

	// ߑJĂ
	SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	pKBase->backmove();

	// JĂeXV
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
	}

	// ǖʏ̍XV
	if (GetGuideFrame()!=NULL)
		GetGuideFrame()->Invalidate();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	// ߕ΂ΎIɕ\B(02.12.08 Ver5.1d)
	AutoCommentDisplay();

	SetFocus(); // tH[JX͂֒u (02.12.08 Ver5.1d)
}

BOOL CSDJView::CheckMenuAutoahead(void)
{
	BOOL bEnable;

	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	if (pKBase->playnum()>0 && m_iAutoPlay==0)
		bEnable=TRUE;
	else
		bEnable=FALSE;

	if (theApp.m_bSelectBoxBUsing && theApp.m_bDbeUsing)
			bEnable=FALSE; // I𑋂ƒՑ𗼕JĂDisable

	return bEnable;
}

// ǖʎOi\XV
void CSDJView::OnUpdateMenuAutoahead(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	pCmdUI->Enable(CheckMenuAutoahead());
}

// ǖʎOi
void CSDJView::OnMenuAutoahead() 
{
	if (m_bMenuLock)
		return;

	if (CheckMenuAutoahead()==FALSE)
		return;

	// xJĂl𔽉f
	if (theApp.m_pDlgKspeed) {
		theApp.m_KspeedCurrentA=theApp.m_pDlgKspeed->m_Slider1.GetPos();
	}
	m_iAutoPlay=1;
	int timer_a=theApp.m_KspeedTableA[9]; // ͍ō
	SetTimer(m_iAutoPlay,timer_a,NULL);
	m_iAutoFirst=TRUE; // L
}

BOOL CSDJView::CheckMenuAutoback(void)
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	BOOL bEnable;

	if (pKBase->root()!=pKBase->lastmove() && m_iAutoPlay==0)
		bEnable=TRUE;
	else
		bEnable=FALSE;

	if (theApp.m_bSelectBoxBUsing && theApp.m_bDbeUsing)
			bEnable=FALSE; // I𑋂ƒՑ𗼕JĂDisable

	return bEnable;
}

// ǖʎޕ\XV
void CSDJView::OnUpdateMenuAutoback(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	pCmdUI->Enable(CheckMenuAutoback());
}

// ǖʎ
void CSDJView::OnMenuAutoback() 
{
	if (m_bMenuLock)
		return;

	if (CheckMenuAutoback()==FALSE)
		return;

	// xJĂl𔽉f
	if (theApp.m_pDlgKspeed) {
		theApp.m_KspeedCurrentB=theApp.m_pDlgKspeed->m_Slider2.GetPos();
	}
	m_iAutoPlay=2;
	int timer_b=theApp.m_KspeedTableB[9]; // ͍ō
	SetTimer(m_iAutoPlay,timer_b,NULL);
	m_iAutoFirst=TRUE; // L
}

// ǖʂ̎XV~
void CSDJView::OnMenuPlaystop() 
{
	if (m_bMenuLock)
		return;
	if (m_iAutoPlay!=0)
		m_iAutoPlay=0;
}

// ǖʂ̎XV~̕\XV
void CSDJView::OnUpdateMenuPlaystop(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (m_iAutoPlay!=0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

// ^C}[
void CSDJView::PlayTimerProc(UINT nIDEvent)
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	BOOL ahead0=FALSE;
	BOOL backmove0=FALSE;
	BOOL endtimer=FALSE;

	int ta,tb;
	if (theApp.m_pDlgKspeed) {
		ta=theApp.m_pDlgKspeed->m_Slider1.GetPos();
		tb=theApp.m_pDlgKspeed->m_Slider2.GetPos();
	}
	else {
		ta=theApp.m_KspeedCurrentA;
		tb=theApp.m_KspeedCurrentB;
	}
	int timer_a,timer_b;
	timer_a=theApp.m_KspeedTableA[ta-1];
	timer_b=theApp.m_KspeedTableB[tb-1];


	if (m_iAutoPlay==1) { // Oȉꍇ
		if (pKBase->playnum()) {
			if (!IsCommentBoxOpened()) { 
				// ߑJĂȂɂɂB
				// (̂҂Ƃ)
				pKBase->ahead(); // Oi
				ahead0=TRUE; // wOiB

				// ēx萔𒲂ׂB
				if (pKBase->playnum()) {
					// Qڈȍ~̃^C}[lZbg
					if (m_iAutoFirst==TRUE) {
						KillTimer(nIDEvent);
						SetTimer(m_iAutoPlay,timer_a,NULL);
						theApp.m_KspeedCurrentA=ta;
						m_iAutoFirst=FALSE;
					}
					// Oi^C}[lɕύXΔf
					else if (ta!=theApp.m_KspeedCurrentA) {
						KillTimer(nIDEvent);
						SetTimer(m_iAutoPlay,timer_a,NULL);
						theApp.m_KspeedCurrentA=ta;
					}
				}
				else {
					KillTimer(nIDEvent); // ^C}[I
					endtimer=TRUE;
					m_iAutoPlay=0;
				}
			}
		}
		else {
			// ̃ubN͎OiɍŏIǖʂփWvꂽɕKv
			KillTimer(nIDEvent); // ^C}[I
			endtimer=TRUE;
			m_iAutoPlay=0;
		}
	}
	else if (m_iAutoPlay==2) { // 
		if (pKBase->lastmove()!=pKBase->root()) {
			if (IsCommentBoxOpened()) {
				// ߑJĂĂ(񂩂珈)
				CloseCommentBox();
			}
			else {
				if (pKBase->backmove()<=0) {
					KillTimer(nIDEvent); // ^C}[I
					endtimer=TRUE;
					m_iAutoPlay=0;
				}
				backmove0=TRUE; // wނB

				// ēxAǖʂɖ߂ׂB
				if (pKBase->lastmove()!=pKBase->root()) {
					if (m_iAutoFirst==TRUE) {
						KillTimer(nIDEvent);
						SetTimer(m_iAutoPlay,timer_b,NULL);
						theApp.m_KspeedCurrentB=tb;
						m_iAutoFirst=FALSE;
					}
					// ރ^C}[lɕύXΔf
					else if (tb!=theApp.m_KspeedCurrentB) {
						KillTimer(nIDEvent);
						SetTimer(m_iAutoPlay,timer_b,NULL);
						theApp.m_KspeedCurrentB=tb;
					}
				}
				else {
					KillTimer(nIDEvent); // ^C}[I
					endtimer=TRUE;
					m_iAutoPlay=0;
				}
			}
		}
		else {
			// ̃ubN͎ޒɏǖʂփWvꂽɕKv
			KillTimer(nIDEvent); // ^C}[I
			endtimer=TRUE;
			m_iAutoPlay=0;
		}
	}
	else { // ~
		KillTimer(nIDEvent); // ^C}[I
		endtimer=TRUE;
	}

	// JĂeXV
	if (m_pKifFrame) {
		if (ahead0 || backmove0) {
			m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_UPDATE);
		}
	}

	// ǖʏ̍XV(ǖʂ)
	if (GetGuideFrame()!=NULL && (ahead0 || backmove0 || endtimer))
		GetGuideFrame()->Invalidate();

	// ՑJĂeXV
	if (endtimer && theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	// wRg̃`FbN\
	if (ahead0) {
		PCELL *pcl=pKBase->lastmove(); // w肪
		if (pcl!=NULL) {
			char *cp=pKBase->getcmnt(pcl,0); 
			if (cp!=NULL && GetCommentDisp()) {                    // ߂
				KillTimer(nIDEvent);           // ^C}[~
				// ՑJĂeXV
				if (theApp.m_bDbeUsing) {
					CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
					if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
						CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
						pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
					}
				}
				CommentDisplay(pKBase);        // ߕ\B
				SetTimer(m_iAutoPlay,theApp.m_KspeedTableA[9],NULL); // ^C}[ĊJ(ō)
				m_iAutoFirst=TRUE; // Ƀ^C}[lăZbg邽߂ɃtOZbgB
				SetFocus(); // tH[JX͂֒u (02.12.08 Ver5.1d)
			}
		}
	}
}

// ^C}[
void CSDJView::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent==1 || nIDEvent==2)
		PlayTimerProc(nIDEvent);
	
	COSBView::OnTimer(nIDEvent);
}

// x
void CSDJView::OnUpdateMenuKspeed(CCmdUI* pCmdUI) 
{
	if (theApp.m_pDlgKspeed==NULL)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
	
}

void CSDJView::OnMenuKspeed() 
{
	CDlgKspeed *pDlgKspeed=new CDlgKspeed;
	pDlgKspeed->m_pParentView=this;
	pDlgKspeed->Create(IDD_DLG_KSPEED,this);
	pDlgKspeed->ShowWindow(SW_SHOWNORMAL);
}

// f[^x[X̐ݒ
void CSDJView::OnMenuShgdb() 
{
	CShgdbDlg ShgdbDlg;
	ShgdbDlg.DoModal();
}

//  ϊ⏕
void CSDJView::ZaRotation() 
{
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
    
	pKBase->ZaRotation(); // ϊ
	EmptyDirtyList();     // ϊɂXV̈NA(őS`)
	// wiՖʂύXB
	pDoc->SetBackground(&theApp.m_BackDIB[pDoc->GetKBase()->GetZa()]);
}

///////
// ߕ΂ΎIɕ\B
void CSDJView::AutoCommentDisplay()
{
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	PCELL *pcl=pKBase->lastmove(); // O̎w
	if (pcl!=NULL) {
		char *cp=pKBase->getcmnt(pcl,0); // w̒߂
		if (cp!=NULL && GetCommentDisp()) {
			CommentDisplay(pKBase);	// ߕ̕\
		}
	}
}

///////
/// w蒍ߕ̕\(ȂΉȂ)
void CSDJView::CommentDisplay(CKBase *pKBase)
{
	PCELL *pcl=pKBase->lastmove();
	if (pcl==NULL)
		return; // wȂ

	OpenCommentBox(pKBase);  // Rg\{bNX
}

/////
// GuideFrame̕\XV
void CSDJView::OnGuideFrameInvalidate()
{
	if (GetGuideFrame())
		GetGuideFrame()->Invalidate();
}

////////
// ŏIǖʂҏWJn
void CSDJView::OnUpdateMenuEdkifTail(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

 	CKBase *pKBase=GetDocument()->GetKBase(); // KBase
	int side=pKBase->turn();
	BOOL bEditOK=FALSE;
	if (side==SIDE_A || side==SIDE_B)
		bEditOK=TRUE;

	BOOL bTail=FALSE;
	if (pKBase->playnum()>0)
		bTail=TRUE;

	if (bEditOK && (!m_bKifEditing || bTail))
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

void CSDJView::OnMenuEdkifTail() 
{
	if (m_bMenuLock)
		return;
	CKBase *pKBase=GetDocument()->GetKBase(); // KBase
	BOOL bTail=FALSE;
	if (pKBase->playnum()>0)
		bTail=TRUE;

	if (bTail)
		SendMessage(WM_COMMAND,ID_MENU_TAIL); // ŏIǖʂ
	if (m_bKifEditing) // ݒ蒆Ȃ
		return;
	m_bKifEditing=TRUE; // ҏWJn
	SetCursor(theApp.m_hHandCursor); // J[\̃Zbg
}

//////
/// wRg\̗L
void CSDJView::OnUpdateViewCommentBox(CCmdUI* pCmdUI) 
{
	if (GetCommentDisp())
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CSDJView::OnViewCommentBox() 
{
	m_bCommentDisp=!m_bCommentDisp;
}

///////
// w蒍߂̕ҏW
void CSDJView::OnUpdateMenuPlaycmnt(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(UpdateMenuPlaycmnt());
}
BOOL CSDJView::UpdateMenuPlaycmnt() 
{
	BOOL bEnable=TRUE;

	if (m_bMenuLock) {
		return bEnable;
	}


	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	if (pKBase->lastmove()==pKBase->root())
		bEnable=FALSE;		// ߉\ȎwȂ
	if (IsCommentBoxOpened())
		bEnable=FALSE;		// ɊJĂ

	return bEnable;
}

void CSDJView::OnMenuPlaycmnt() 
{
	MenuPlaycmnt();
}

void CSDJView::MenuPlaycmnt() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	PCELL *pcl=pKBase->lastmove();
	PCELL *rpcl=pKBase->root();
	if (pcl==rpcl)
		return; // ߉\ȎwȂ

	OpenCommentBox(pKBase);   // Rg\{bNX
}

////
// ߃{bNX̃I[v
CSDJCmntDoc *CSDJView::OpenCommentBox(CKBase *pKBase)
{
	CSDJCmntDoc *pSDJCmntDoc=
		(CSDJCmntDoc *)m_pSDJCmntTemplate->OpenDocumentFile(NULL);
	pSDJCmntDoc->SetKBase(pKBase);

	return pSDJCmntDoc;
}

// ߃{bNX̃N[Y
void CSDJView::OnDlgCmntBoxClose()
{
	if (IsCommentBoxOpened()) {
		CloseCommentBox();
	}
}

// ՕҏWJn/I
void CSDJView::OnUpdateMenuEditJS(CCmdUI* pCmdUI) 
{
	BOOL bEnable;

	CKBase *pKBase=GetDocument()->GetKBase(); // KBase
	int side=pKBase->turn();
	BOOL bEditOK=FALSE;
	if (side==SIDE_A || side==SIDE_B)
		bEditOK=TRUE;
	
	if (m_bJSEditing) {
		pCmdUI->SetText("ՕҏWI(&J)");
		bEnable=TRUE;
	}
	else {
		pCmdUI->SetText("ՕҏWJn(&J)");
		if (bEditOK && !m_bKifEditing)
			bEnable=TRUE;
		else
			bEnable=FALSE;
	}

	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	pCmdUI->Enable(bEnable);
}

void CSDJView::OnMenuEditJS() 
{
	if (m_bMenuLock)
		return;
	if (m_bJSEditing) { // ݒ蒆
		m_bJSEditing=FALSE;
		m_bKifEditing=FALSE;
	}
	else {              // ݒ蒆ł͂Ȃ
		CString str;
		str="ꂩ̋͒ՂƂēo^܂B\r\n";
		str+="낵łH";
		if (AfxMessageBox(str,MB_YESNO)==IDYES) {
			m_bJSEditing=TRUE;
			m_bKifEditing=TRUE;
		}
	}
}

//////
// ՕҏWl̕ύX
void CSDJView::OnUpdateMenuSetJSValue(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}

void CSDJView::OnMenuSetJSValue() 
{
	if (m_bMenuLock)
		return;

	CSDJDoc *pDoc=GetDocument();
	CDlgEditJS DlgEditJS;
	DlgEditJS.m_Attr=pDoc->m_Attr;
	DlgEditJS.m_Eval=pDoc->m_Eval;
	if (DlgEditJS.DoModal()==IDOK) {
		pDoc->m_Attr=DlgEditJS.m_Attr;
		pDoc->m_Eval=DlgEditJS.m_Eval;
	}
}

/////
// ^Cgʂ̕ҏW
void CSDJView::OnUpdateMenuMktitle(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (theApp.m_bTitleExist)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
	
}

void CSDJView::OnMenuMktitle() 
{
	if (m_bMenuLock)
		return;
	CTitleWindow *ptw=theApp.CreateTitleWindow();
	//ptw->CreateTitleBmp();
	ptw->SendMessage(WM_CLOSE);
}

// J[\̐
BOOL CSDJView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// ҏW͎J[\ɂ
	if (m_bKifEditing || m_bJSEditing) {
		if (m_bKifSeparate)
			SetCursor(theApp.m_hHandCursor2);
		else
			SetCursor(theApp.m_hHandCursor);
		return TRUE;
	}
	
	return COSBView::OnSetCursor(pWnd, nHitTest, message);
}

// SDIt[EBhȄǖʐݒIbZ[W
void CSDJView::BansetCommand(CMemLump *lpMemLump)
{
	CSDJDoc *pDoc=GetDocument();
	// 󂯎t@CƂănhB
	CWinMemFile File;
	// GrowSize=0ɂƃt@CTCYm_SizeɂȂ
	File.Attach(lpMemLump->m_lpMem,lpMemLump->m_Size);
	delete lpMemLump;

	// ߃{bNXJĂ
	SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	// hLg̕ύXΕۑ̗L₢킹ĕKvΕۑ
	if (pDoc->SaveModified()) { // hLgN[YĂ悢ꍇ
		CKBase *pKBase=pDoc->GetKBase();
		BOOL bSetOK=TRUE;
		if (pKBase->root()->cld(0)) { // w肪o^ĂA
			int rc=AfxMessageBox("̃obt@̎w͑SĔj܂B낵łH",MB_YESNO);
			if (rc!=IDYES)
				bSetOK=FALSE;
		}
		if (bSetOK) {
			CSDJArchive arIn(&File,CArchive::load);
			pDoc->ReadBaninfo(arIn); // t@C̓Ǎ
			arIn.Close();
		
			pDoc->SetModifiedFlag(TRUE); // ύXtOZbg

			// ԖݒŊҏWȂҏWIB
			if (m_bKifEditing || m_bJSEditing) {
				CKBase *pKBase=pDoc->GetKBase();
				int side=pKBase->turn();
				if (side!=SIDE_A && side!=SIDE_B) {
					AfxMessageBox("Ԗݒׁ̈A̕ҏW͏I܂B");
					if (m_bKifEditing) m_bKifEditing=FALSE;
					if (m_bJSEditing) m_bJSEditing=FALSE;
				}
			}

			Render();
			Draw();
		}
	}
	// ǖʏ̍XV
	if (GetGuideFrame()!=NULL)
		GetGuideFrame()->Invalidate();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		if (m_pDbeFrame) {  // ՑJĂ
			CDbeView *pDbeView=(CDbeView *)m_pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	// JĂe
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
	}

}

BOOL CSDJView::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if (LOWORD(wParam)==ID_BANSET_COMMAND) {
		// BANSET_COMMAND
		CMemLump *lpMemLump=(CMemLump*)lParam;
		BansetCommand(lpMemLump); // BansetCommand
		return 1;
	}

	return COSBView::OnCommand(wParam, lParam);
}

void CSDJView::OnDestroy() 
{
	COSBView::OnDestroy();
	
	// ǖʐݒ蒆ȂAIB
	if (GetSFrame())
		GetSFrame()->SendMessage(WM_CLOSE);
	//  ՑgpȂ炱IB
	if (GetDbeFrame())
		GetDbeFrame()->SendMessage(WM_CLOSE);

	if (m_pKifFrame)
		m_pKifFrame->SendMessage(WM_CLOSE); // I

	// w蒍ߑB
	CloseCommentBox();
	delete m_pSDJCmntTemplate;

	// w蒍ߑ̈ʒu
	if (!m_rcCmntBoxPos.IsRectEmpty()) {
		CString strSection=EDITOR_SECTION;
		CPoint &tl=m_rcCmntBoxPos.TopLeft();
		CPoint &br=m_rcCmntBoxPos.BottomRight();
		theApp.WriteProfileInt(strSection,CMNT_POS_X1,tl.x);
		theApp.WriteProfileInt(strSection,CMNT_POS_Y1,tl.y);
		theApp.WriteProfileInt(strSection,CMNT_POS_X2,br.x);
		theApp.WriteProfileInt(strSection,CMNT_POS_Y2,br.y);
	}

	// xgpȂ炱IB
	if (theApp.m_pDlgKspeed) {
		if (theApp.m_pDlgKspeed->m_pParentView==this) 
			theApp.m_pDlgKspeed->SendMessage(WM_CLOSE);
	}
}

// SDIt[EBhE̋LNA
// ǖʐݒSDIEBhȄIR}hɂČĂ΂B
void CSDJView::OnSetSFrameNull()
{
	SetSFrame(NULL);
}

// Ցt[EBhE̋LNA
// ǖʐݒSDIEBhȄIR}hɂČĂ΂B
void CSDJView::OnSetDbeFrameNull()
{
	SetDbeFrame(NULL);
}

// ̋LNA
void CSDJView::OnSetKifFrameNull()
{
	m_pKifFrame = NULL;
}

/////
// ՂcãI[v
void CSDJView::OnMenuDbeOpen() 
{
	if (m_bMenuLock)
		return;
	// ɊJnς݂ȂȂɂȂB
	if (theApp.m_bDbeUsing)
		return ;
	theApp.m_bDbeUsing=TRUE;

	// SDIhLgt[̍쐬(eMDINCAgEBhE)
	CDbeDoc *pDoc=(CDbeDoc *)theApp.m_pDbeDocTemplate->OpenDocumentFile(NULL);

	// SDĨt[EBhE̐et[EBhẼr[ɐݒ肷B
	// SDI t[EBhE
	CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
	// ̃r[SDĨt[EBhEɃNB
	pDbeFrame->SetSdjParent(this);
	// SDIt[EBhẼr[̎qEBhEƂċLB
	SetDbeFrame(pDbeFrame);
}

void CSDJView::OnUpdateMenuDbeOpen(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (theApp.m_bDbeUsing)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

/////
// f[^x[Xj[̔rwp[
BOOL CSDJView::dbex()
{
	return !(theApp.m_bSelectBoxBUsing	|  // I_CAO(΋/l)
		     theApp.m_bDbeUsing			|  // Ց
			 theApp.m_bMateDbcUsing);	   // lcavl
}

///////
// f[^x[X̐VK쐬
void CSDJView::OnMenuCreateDB() 
{
	if (m_bMenuLock)
		return;
	CDlgCreateDB DlgCreateDB;
	DlgCreateDB.DoModal();
}

void CSDJView::OnUpdateMenuCreateDB(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex());
}

//////
// f[^x[X̃j^\
void CSDJView::OnUpdateMenuDbstat(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(dbex());
}

void CSDJView::OnMenuDbstat() 
{
	if (m_bMenuLock)
		return;
	DbStat();
}

///////////////////////////////////////////////////////////////////
/// f[^x[Xj^\ vO(̕C(܂蔲)B
///            1997.5  by Ra   dbstat.c 
#include <io.h>
#include <fcntl.h>
typedef struct {
    int dup;                    /* dtO s(0) (1) */
    int xlen;                   /* R[h */
    long xfs;                   /* t@CTCY */
} X_INFO;

typedef struct {
    long reclen;                /* R[h */
    long recnum;                /* R[h */
    long dfs;                   /* f[^TCY */
    int  xnum;                  /*  */
    X_INFO x_info[IXITEMNUM];   /*  */
    long fs_sum;                /* t@CTCYv */
} T_INFO;

/* Tu[`̌^錾 */
static void display_header(void);
static void display_footer(long l);
static int display_table(char *table);
static long disp_stable(char *pname,char *tname);
static int split_path(const char* szFullPath, char* szDir, char* szName);
static int scm_tchk(SCM_t *scm);
static SCM_t *scm_alloc(int k,int x);
static void scm_free(SCM_t *scm);
static SCM_t *get_scm(char *dname);
static int GetScmInfo(T_INFO *tip,char *pname);
static int GetFileInfo(T_INFO *tip,char *pname);
static long CountBitmap(unsigned char *bitmap,unsigned int leng);
static char *scmptr(char *cp);
static void ltoa_k(long l,char *np);

/* t@CTCYv */
static long total_sum;
static CStatusBox *s_pBox;

static void PrintMessage(char *message)
{
	if (s_pBox)
		s_pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)message);
	else
		TRACE("%s\n",message);
}

///////
// f[^x[Xԕ\Xbh
static UINT DbStatWorkerThread(CStatusBox *pBox,CEvent *pEvent,LPARAM lParam)
{
	int rc;

	s_pBox=pBox;
	total_sum=0;

    /* display header */
    display_header();

    /* display table */
	char *shgdb=GetShgdbName();
	char sdbpath[256];
	sprintf(sdbpath,"%s%s",shgdb,"*");
	
    if ((rc=display_table(sdbpath))!=0) goto exit;

    /* display footer */
    display_footer(total_sum);

	s_pBox=NULL;

exit:
	return 0;
}

void CSDJView::DbStat()
{
	CStatusBox StatusBox(&DbStatWorkerThread,(LPARAM)this);
	StatusBox.DoModal();
}

/////////// f[^x[Xj^\[` ///////
/* display header */
static void display_header(void)
{
   PrintMessage(
   "\    R[h  R[h(gp%) t@CTCY  \vTCY"
          );
}

/* display footer */
static void display_footer(long l)
{
    char dbuf[80];
	char StringBuffer[256];

    ltoa_k(l,dbuf);
    sprintf(StringBuffer,
   "                                                   v %+11s",
           dbuf
          );
	PrintMessage(StringBuffer);
}

/* display table */
static char pname[256];         /* XL[}t@CtpXi[ */
static char scm_file[256];      /* XL[}t@C */
static char tbl_name[256];      /* \ */
static int display_table(char *table)
{
    int rc=1;
    struct _finddata_t ft;
    long hFile;
    long sum;
    int fetch=0;

    strcpy(scm_file,table);
    strcat(scm_file,".scm");

    if ((hFile=_findfirst(scm_file,&ft))==-1L) rc=1; /* t@C݂͑Ȃ */
    else rc=0;

    while (rc==0) {
        split_path(scm_file,pname,NULL); /* t@CƃfBNg̕ */
        strcat(pname,ft.name);        /* pname=full path table name */
        strcpy(tbl_name,ft.name);
        *scmptr(tbl_name)='\0';       /* remove ".scm" */
        fetch=1;                      /* ȂƂP͌B*/

        /* P\̏\ */
        if ((sum=disp_stable(pname,tbl_name)) < 0L) { rc=1;goto exit;}
        total_sum+=sum;         /* t@CTCYvZ */

		rc=_findnext(hFile,&ft);
    }
    if (fetch)
        rc=0;
    else 
        PrintMessage("Y\͌܂łB");
        
  exit:
    return rc;
}

/* 
 * P\̏\
 *  \(tname)Ŏw肳ꂽ\̏\B
 *  pname̓XL[}t@CtpXB
 */
static T_INFO ti;               /* \ */
static char dbuf[4][80];        /* \pƃobt@ */
static long disp_stable(char *pname,char *tname)
{
    int rc=0;
    int i;
    unsigned long ul;
	char StringBuffer[256];

    /* XL[}̏擾 */
    if ((rc!=GetScmInfo(&ti,pname))!=0) goto exit;

    /* f[^t@C̎擾 */
    if ((rc!=GetFileInfo(&ti,pname))!=0) goto exit;

    /* \̕\ */
    ltoa_k(ti.reclen,dbuf[0]);  /* lJ}ϊ */
    ltoa_k(ti.recnum,dbuf[1]);
    ltoa_k(ti.dfs,dbuf[2]);
    ul=(unsigned long)ti.recnum*100L/8L*100L/65535L; /* % \ */
  
    /* f[^t@C̕\ */
    if (ul/100L < 100) {
		sprintf(StringBuffer,"%-8s%+7s%+14s (%2ld.%02ld%%)%+14s", 
	       tname,
	       dbuf[0],
	       dbuf[1],
	       ul/100L,
	       ul%100L,
	       dbuf[2]);
		PrintMessage(StringBuffer);
	}
    else {
		sprintf(StringBuffer,"%-8s%+7s%+14s (%3ld.%01ld%%)%+14s", 
	       tname,
	       dbuf[0],
	       dbuf[1],
	       ul/100L,
	       ul%100L,
	       dbuf[2]);
		PrintMessage(StringBuffer);
	}
    for (i=0;i<ti.xnum;i++) {                    /* t@C̕\ */
        ltoa_k((long)ti.x_info[i].xlen,dbuf[0]); /* lJ}ϊ */
        ltoa_k(ti.x_info[i].xfs,dbuf[1]);
        sprintf(StringBuffer," %d%+9s%26s%+11s",
			i,
			dbuf[0],
			" ",
			dbuf[1]);
		PrintMessage(StringBuffer);
    }
    ltoa_k(ti.fs_sum,dbuf[0]);
    sprintf(StringBuffer,"%56s%+11s"," ",dbuf[0]);
	PrintMessage(StringBuffer);

  exit:
    if (rc!=0)
        return -1L;
    else
        return ti.fs_sum;
}

/******************************************************
 * tpXAfBNgƃt@Cɕ
 *
 *      <<<߂l>>>
 * tpX̍\tO
 *
 *      <<<>>>
 * szFullPath ... ͑Ώۂ̃tpX
 * szDir      ... fBNgi[obt@
 * szName     ... t@Ci[obt@
 *
 * szDir, szName  NULL ̏ꍇ͌ʂi[Ȃ
 * szDir ͋󕶎ȊOȂA͕KpX؂Lł
 * pX؂LƂĂ \  / ̗󂯕t
 *************************************************************/
/* pX\vftOl(split_path()̖߂l) */
#define FN_DRIVE     0x80
#define FN_DIRECTORY 0x40
#define FN_FILENAME  0x20
static int split_path(const char* szFullPath, char* szDir, char* szName)
{
    char *pTailDir = strrchr((char *) szFullPath, '\\');
    char *pTmp     = strrchr((char *) szFullPath, '/');

    /**** Ă ****/
    int flag = 0;
    if (szDir)  *szDir  = 0;
    if (szName) *szName = 0;

    /**** hCu̐؂o ****/
    /* ?: ̓hCuB?͉łok */
    if (szFullPath[0] && szFullPath[1] == ':') {
        flag |= FN_DRIVE;
        if (szDir) {
            *szDir++ = *szFullPath++;
            *szDir++ = *szFullPath++;
        } else
            szFullPath += 2;
    }

    /**** fBNg̐؂o ****
     * fBNg͍Ōオ'\'  '/' ŏI镶ł
     */
    if (pTailDir < pTmp)
        pTailDir = pTmp; /* \  / ̈ԍŌ̈ʒu pTailDir ɓ */
    if (pTailDir) {
        /* fBNgszDirփRs[AszFullPatȟ֐i߂ */
        flag |= FN_DIRECTORY;
        if (szDir) {
            while (szFullPath <= pTailDir)
                *szDir++ = *szFullPath++;
        } else
            szFullPath = pTailDir + 1;
    }
    /** OƂ "."  ".." ŏIꍇAfBNgƌȂ **/
    if ( strcmp(szFullPath, ".") == 0 || strcmp(szFullPath, "..") == 0 ) {
        flag |= FN_DIRECTORY;
        if (szDir) {
            strcpy(szDir, szFullPath);
            strcat(szDir, "\\"); /* fBNg̋؂Lǉ */
        }
        return flag; /* path ̏IɒB̂łŏI */
    }
    if (szDir) *szDir = 0; /* I[̂Oݒ肷 */

        /**** t@C؂o ****/
    if (*szFullPath) {
        flag |= FN_FILENAME;
        if (szName)
            strcpy(szName, szFullPath);
    }
    return flag;
}

/*
*********************************
 SCM_t֘Å֐(sdbbase.cƋ)
*********************************
*/

/* 93.5.2ǉBSCM_ť``FbNB
   ߂lOKȂ0 NGȂ1 */
static int scm_tchk(SCM_t *scm)
{
    int i,j,rc=0;
    int mustpos;

    /* SCMHEAD̒l`FbN */
    if (SH_INUM(scm)<=0 || SH_XNUM(scm) > IXPNUM || SH_XNUM(scm) < 0) {
        rc=1;goto exit;
    }

    /* SCMITEM̃`FbN */
    for (mustpos=i=0;i<SH_INUM(scm);i++) {
        if (strlen(SIM_NAME(scm,i)) > KNAMELEN || /* ̂Kv */
            strlen(SIM_NAME(scm,i)) <=0 ||
            SIM_TYPE(scm,i) < 0 ||                /* ^0~3܂ */
            SIM_TYPE(scm,i) > 3 ||
            SIM_POS(scm,i)!=mustpos ||            /* pošvZOK */
            SIM_LEN(scm,i) <= 0 ) {               /* len͐ */

            rc=2;goto exit;
        }
        mustpos=SIM_POS(scm,i)+SIM_LEN(scm,i); /* poslvZĂ */
    }

    /* SCMIDX̃`FbN */
    for (i=0;i<SH_XNUM(scm);i++) {
        /* dup̃`FbN */
        if (scm->sxpp[i]->dup!=0 && scm->sxpp[i]->dup!=1) {
            rc=3;goto exit;
        }
        if (SIX_NUM(scm,i)<=0) {          /* ڐ͐ */
            rc=4;goto exit;
        }
        /* knõ`FbNBinumȉ̒lłǍ^eLXg(0~2) */
		// Bug fixłƓ
        for (j=0;j<SIX_NUM(scm,i);j++) {
            if (scm->sxpp[i]->kno[j] < SH_INUM(scm) &&
                scm->sxpp[i]->kno[j] >= 0 ) {
                if (SIX_TYPE(scm,i,j) < 0 ||
                    SIX_TYPE(scm,i,j) > 2 ) {
                    rc=5;goto exit;
                }
            }
            else {
                rc=6;goto exit;
            }
        }
    }
  exit:
    return rc;
}

/*
    XL[}\̂AP[gB
    ڐ(k),t@C(x)(0)B sȂNULLԂB
    {֐̓AP[ĝ݂Œl̓ZbgȂB
*/    
static SCM_t *scm_alloc(int k,int x)
{
    SCM_t *scm;
    int i,j,err=0;
    
    /* XL[}\̖{̂̃AP[g */
    scm=(SCM_t *)memalloc(sizeof(SCM_t));
    if (scm!=NULL)  {
        memset(scm,'\0',sizeof scm); /* 0NA */

        /* |C^̃AP[g */
        scm->sipp=(SCMITEM **)memalloc(k*sizeof(SCMITEM *));
        if (x!=0)
            scm->sxpp=(SCMIDX **)memalloc(x*sizeof(SCMIDX *));
        if (!(scm->sipp==NULL || (x!=0 && scm->sxpp==NULL))) {
            /* ڃf[^\̂̃AP[g */
            for (i=0;i<k;i++)   {
                scm->sipp[i]=(SCMITEM *)memalloc(sizeof(SCMITEM));
                if (scm->sipp[i]==NULL) { /* s */
                    /* ܂ŃAP[gSCMITEM̉ */
                    for (j=0;j<i;j++) memfree(scm->sipp[j]);
                    err=1;
                    break;
                }
            }
            if (err==0) {
                /* f[^\̂̃AP[g */
                for (i=0;i<x;i++)   {
                    scm->sxpp[i]=(SCMIDX *)memalloc(sizeof(SCMIDX));
                    if (scm->sxpp[i]==NULL) {   /* s */
                        /* ܂ŃAP[gSCMIDX̉ */
                        for (j=0;j<i;j++) memfree(scm->sxpp[j]);
                        err=1;
                        break;
                    }
                }
            }
        }
        else err=1;  /* |C^̃AP[gɎs */
        /* 
           |C^܂
           ڃf[^\́Af[^\̂̃AP[gɎs
         */
        if (err!=0) {
            /* ܂܂ŃAP[g */
            if (scm->sipp!=NULL) memfree(scm->sipp);
            if (scm->sxpp!=NULL) memfree(scm->sxpp);
            memfree(scm);
            scm=NULL;
        }
    }/* if (scm!=NULL) */

    return scm;
}

/*
    XL[}\̂̉
*/
static void scm_free(SCM_t *scm)
{
    int i;
    /* ڃf[^\̂̉ */
    for (i=0;i<SH_INUM(scm);i++) memfree(scm->sipp[i]);
    /* f[^\̂̉ */
    for (i=0;i<SH_XNUM(scm);i++) memfree(scm->sxpp[i]);
    /* |C^̉ */
    memfree(scm->sipp);
    if (scm->sh.xnum!=0)
        memfree(scm->sxpp);
    /* XL[}\̖{̂̉ */
    memfree(scm);
}    

/*
  XL[}t@C\̂̎擾
    XL[}t@CI[vAXL[}\̂쐬B
    DB_t *dbȊOsh,sipp,sxppZbgB
    sNULLԂBfnamescm fileB
    93.5.2 t@CTCY`FbNǉB
*/
static SCM_t *get_scm(char *fname)
{
    SCMHEAD sh;
    SCM_t *scm=NULL;
    int sfh,i,err=0;
    long fs;
    
    /* XL[}t@C̃I[v */
    sfh=open(fname,O_RDWR | O_BINARY);
    if (err==0 && sfh!=-1)    {
        /* XL[}wb_̓ǂ݂ */
        err=sizeof(SCMHEAD)-read(sfh,&sh,sizeof(SCMHEAD));

        /* SCMHEADlyуt@CTCỸ`FbN 93.5.2ǉ */
        if (err==0) {
            if (sh.inum <= 0 || sh.xnum > IXPNUM || sh.xnum < 0 )
                err=1;                /* SCMHEADlُ */
            else {
                /* t@CTCY`FbN */
                fs=_filelength(sfh);
                if (fs!=(long)sizeof(SCMHEAD)+
                        (long)sh.inum*(long)sizeof(SCMITEM)+
                        (long)sh.xnum*(long)sizeof(SCMIDX) )
                    err=1;
            }
        }
        if (err==0) {
            /* XL[}\̂̍쐬 */
            scm=scm_alloc(sh.inum,sh.xnum); /* AP[g */
            if (scm!=NULL)  {
                /* XL[}wb_̃Zbg */
                SH_INUM(scm)=sh.inum;
                SH_XNUM(scm)=sh.xnum;
                /* ڃf[^\̂̃Zbg */
                for (i=0;i<SH_INUM(scm);i++)    {
                    err=sizeof(SCMITEM)
                            -read(sfh,scm->sipp[i],sizeof(SCMITEM));
                    if (err!=0) break;        

                }
                if (err==0) {
                    /* f[^\̂̃Zbg */
                    for (i=0;i<SH_XNUM(scm);i++)    {
                        err=sizeof(SCMIDX)
                                -read(sfh,scm->sxpp[i],sizeof(SCMIDX));
                        if (err!=0) break;
                    }
                }
            }
            else err=1;/* s */
            /* XL[}\̂̍쐬s */
            if (err!=0) {
                if (scm!=NULL)  scm_free(scm);
                scm=NULL;
            }
        }
        /* XL[}t@C̃N[Y */
        close(sfh);
    } /* if (err==0 && sfh!=-1) */

    /* 93.5.2ǉBSCM_ť``FbNB*/
    if (scm!=NULL) {
        if (scm_tchk(scm)!=0) { /* `sK */
            scm_free(scm);
            scm=NULL;
        }
    }

   return scm;
}

/* 
 * SCMt@C̎擾
 *   XL[}t@C(pname)̏tipɃZbgB
 */
static int GetScmInfo(T_INFO *tip,char *pname)
{
    int rc=1;
    SCM_t *scm;
    int i,j;

    if((scm=get_scm(pname))==NULL) goto exit; /* SCM_t\̂̎擾 */
    
    /* R[h̎Zo */
    tip->reclen=0L;
    for (i=0;i<SH_INUM(scm);i++)
        tip->reclen+=SIM_LEN(scm,i);

    /*  */
    tip->xnum=SH_XNUM(scm);

    /*  */
    for (i=0;i<tip->xnum;i++) {
        tip->x_info[i].dup=SIX_DUP(scm,i); /* dtO */

        /* R[h */
        tip->x_info[i].xlen=0;
        for (j=0;j<SIX_NUM(scm,i);j++)
            tip->x_info[i].xlen+=SIX_LEN(scm,i,j);
    }
    scm_free(scm);              /* SCM_t\̂̉ */

    rc=0;
  exit:
    return rc;
}

/* 
 * f[^t@C̎擾
 *   t@C̃TCY͂OԂB
 */
static unsigned char bitmap[32000];
static int GetFileInfo(T_INFO *tip,char *pname)
{
    int rc=1;
    char *fname=NULL;
    int fh;
    int i;
    BITHEAD dh;
    long l;


    if ((fname=(char *)memalloc(strlen(pname)+1))==NULL) goto exit;

    /*  */
    tip->dfs=0L;
    tip->recnum=0;
    tip->fs_sum=0L;
    for (i=0;i<tip->xnum;i++)
        tip->x_info[i].xfs=0L;

    /* f[^t@C̃Zbg */
    strcpy(fname,pname);
    strcpy(scmptr(fname),".dat"); /* f[^t@C̃Zbg */

    /* f[^t@C̃Zbg */
    if((fh=open(fname,O_RDWR | O_BINARY))!=-1) {
        tip->dfs=_filelength(fh);
        tip->fs_sum+=tip->dfs;  /* vZ */
        close(fh);
    }
    else {
        rc=0;goto exit;
    }
        

    /* rbg}bvt@C̃Zbg */
    strcpy(fname,pname);
    strcpy(scmptr(fname),".bmp"); /* rbg}bvt@C̃Zbg */
    if ((fh=open(fname,O_RDWR | O_BINARY))==-1)
        goto exit;              /* bmpt@CȂُ͈̂ */
    if (sizeof dh-read(fh,&dh,sizeof dh)) {close(fh);goto exit;}

    /* f[^R[h̎Zo */
    tip->recnum=0L;
    for ( l=(long)dh.num; l>0L; l-=sizeof bitmap ) {
        if (l > sizeof bitmap) {
            if (sizeof bitmap - read(fh,bitmap,sizeof bitmap)) {
                close(fh);goto exit; /* bitmapt@C[hG[ */
            }
            tip->recnum+=CountBitmap(bitmap,sizeof bitmap);
        }
        else {
            if (l - read(fh,bitmap,(unsigned int)l)) {
                close(fh);goto exit; /* bitmapt@C[hG[ */
            }
            tip->recnum+=CountBitmap(bitmap,(unsigned int)l);
        }
    }
    close(fh);


    /* t@CTCỸZbg */
    for (i=0;i<tip->xnum;i++) {
        /* t@C */
        strcpy(fname,pname);
        *scmptr(fname)='\0';
        sprintf(fname,"%s.ix%d",fname,i);
        if ((fh=open(fname,O_RDWR | O_BINARY))!=-1) {
            tip->x_info[i].xfs=_filelength(fh);
            tip->fs_sum+=tip->x_info[i].xfs;    /* vZ */
                    close(fh);
        }
    }

    rc=0;
  exit:
    if (fname!=NULL)    memfree(fname);
    return rc;
}

/* bitmaplenoCg̊Ԃ1rbg𐔂 */
static long CountBitmap(unsigned char *bitmap,unsigned int len)
{
    unsigned int  ui;
    int i;
    long cnt;

    cnt=0L;
    for (ui=0;ui<len;ui++) {
        for (i=0;i<8;i++) {
            if ((bitmap[ui] & 0x80)!=0)
                cnt++;
            bitmap[ui]=bitmap[ui]<<1;
        }
    }
    return cnt;
}


/* t@Ccp̒".scm"̃|C^ԂB*/
static char *scmptr(char *cp)
{
    char *ptr;

    if ((ptr=strstr(cp,".scm"))!=NULL) goto exit;
    if ((ptr=strstr(cp,".SCM"))!=NULL) goto exit;
    ptr=cp+(strlen(cp)-4);
  exit:
    return ptr;
}

/* l(long l)LPʂŃJ}ꂽ(char *np)ɕϊ */
static void ltoa_k(long l,char *np)
{
    char work[80];
    int i,len,cnt;

    sprintf(work,"%ld",l);
    len=strlen(work);
    cnt=len % 3;
    for (i=0;i<len;i++) {
        if (cnt==0) {
            if (i!=0 && len-i>=3) {
                *np=',';
                np++;
            }
            
            cnt=3;
        }
        *np=work[i];
        np++;
        cnt--;
    }
    *np='\0';
}

/// f[^x[Xj^\ vO ܂ŁB
///////////////////////////////////////////////////////////////////

////
// obt@̒Փo^
void CSDJView::OnUpdateMenuBufToDbe(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	BOOL bEnable = FALSE;
	int side = pKBase->turn();
	if (pKBase->playnum() > 0 && 
		(side == SIDE_A || side == SIDE_B))
		bEnable = TRUE;

	bEnable &= dbex();

	pCmdUI->Enable(bEnable);
}
void CSDJView::OnMenuBufToDbe() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	int side = pKBase->turn();
	if (side!=SIDE_A && side != SIDE_B) {
		AfxMessageBox("͎ԂݒłB");
		return;
	}

	CDlgKifToJS DlgKifToJS;
	DlgKifToJS.SetKBase(pKBase);
	DlgKifToJS.DoModal();
}

/////
// t@C̒Փo^
void CSDJView::OnUpdateMenuCsaToJS(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	pCmdUI->Enable(dbex());
}
void CSDJView::OnMenuCsaToJS() 
{
	if (m_bMenuLock)
		return;
	CDlgCsaToJS DlgCsaToJS;
	DlgCsaToJS.DoModal();
}

////
// Ղ̃t@Co
void CSDJView::OnUpdateMenuJSToCsa(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	pCmdUI->Enable(dbex());
}

void CSDJView::OnMenuJSToCsa() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	int side=pKBase->turn();
	if (side!=0 && side!=1) {
		AfxMessageBox("݂̋ǖʂ͎ԂݒłB");
		return ;
	}

	CDlgOutJS DlgOutJS;
	DlgOutJS.m_Bform=*pKBase->btype();
	DlgOutJS.m_side=side;
	DlgOutJS.DoModal();
}

////
// Ղ̈ꊇ폜
void CSDJView::OnUpdateMenuDelDbe(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	pCmdUI->Enable(dbex());
}

void CSDJView::OnMenuDelDbe() 
{
	if (m_bMenuLock)
		return;
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	int side=pKBase->turn();
	if (side!=0 && side!=1) {
		AfxMessageBox("݂̋ǖʂ͎ԂݒłB");
		return ;
	}

	CDlgDelJS DlgDelJS;
	DlgDelJS.m_Bform=*pKBase->btype();
	DlgDelJS.m_side=side;
	DlgDelJS.DoModal();
}

//////
// ̐ݒ
void CSDJView::OnUpdateMenuKSound(CCmdUI* pCmdUI) 
{
	if (theApp.m_bKSoundEnable)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);

	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}

void CSDJView::OnMenuKSound() 
{
	if (m_bMenuLock)
		return;
	theApp.m_bKSoundEnable=!theApp.m_bKSoundEnable;
}

////
// ̏펞\ݒ
void CSDJView::OnUpdateMenuOpenKifwindow(CCmdUI* pCmdUI) 
{
	if (theApp.m_bKifWindowEnable)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
	
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
}

void CSDJView::OnMenuOpenKifwindow() 
{
	if (m_bMenuLock)
		return;
	theApp.m_bKifWindowEnable=!theApp.m_bKifWindowEnable;
}

/////
// Ԃ̕`
//  sg 0: /(ftHg)   !=0:U/
void CSDJView::DrawSide(CDC *pDC,BOOL sg)
{
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	int za=pKBase->GetZa();
	CString ZaFont;
	CDIB* pDIB;
	int*  pInit=NULL;

	// P[X聕`FbN
	if (sg==0) {
		if (za==0) {
			pDIB=&theApp.m_KfontDIB[0];
			if (theApp.m_bKfontInit[0]==FALSE) {
				ZaFont="";
				pInit=&theApp.m_bKfontInit[0];
			}
		} else {
			pDIB=&theApp.m_KfontDIB[1];
			if (theApp.m_bKfontInit[1]==FALSE) {
				ZaFont="";
				pInit=&theApp.m_bKfontInit[1];
			}
		}
	} else {
		if (za==0) {
			pDIB=&theApp.m_TfontDIB[0];
			if (theApp.m_bTfontInit[0]==FALSE) {
				ZaFont="U";
				pInit=&theApp.m_bTfontInit[0];
			}
		} else {
			pDIB=&theApp.m_TfontDIB[1];
			if (theApp.m_bTfontInit[1]==FALSE) {
				ZaFont="";
				pInit=&theApp.m_bTfontInit[1];
			}
		}
	}

	// \DIBς݂Ȃ牽ȂB
	if (pInit==NULL)
		return;

	// \DIB̏
	//   \ADIBɎB
	CFont *pfCurr=pDC->GetCurrentFont();		// stHgIuWFNg̎擾
	LOGFONT lfFont;
	pfCurr->GetObject(sizeof(LOGFONT),&lfFont); // s̃tHg̎擾
	lfFont.lfHeight=16;
	lfFont.lfWidth=0;
	strcpy(lfFont.lfFaceName,"lr ");
	CFont fTeban;
	fTeban.CreateFontIndirect(&lfFont);
	pDC->SetBkMode(TRANSPARENT);
	
	CFont *poldfont=pDC->SelectObject(&fTeban);
	pDC->SetTextColor(RGB(255,255,255));

	pDC->TextOut(Sdaix1,Sdaiy1-20,ZaFont);		// \
	
	// \DIB̐
	CRect rc;
	rc.SetRect(Sdaix1-1,Sdaiy1-20-1,
		Sdaix1-1+lfFont.lfHeight/2*4+2, Sdaiy1-20-1+lfFont.lfHeight+2);
	pDIB->MakeDib(pDC,&rc);

	// p^CY
	CDIBPal *pPal=GetPalette();
	pDIB->MapColorsToPalette(pPal);

	pDC->SelectObject(poldfont);

	*pInit=TRUE;

	// ̃r[̍\ZbgB
	m_pZaFontDIB=pDIB;

	// DIBfBXN֕ۑB
	// ŏ͂LsĂArŉʂ؂ւ
	// ƍ\Ȃ̂ŌǃfBXNɕۑ邱ƂɂB
	// ǂݏo͔DIBƓ^C~OōsB̃R[fBOƁA\
	// Ẵ[`Ŏ邱ƂɂȂB
	CString strFile;
	if (ZaFont=="") strFile.Format("%ssg0.dib",theApp.m_PgmDir);
	else if (ZaFont=="") strFile.Format("%ssg1.dib",theApp.m_PgmDir);
	else if (ZaFont=="U") strFile.Format("%ssu0.dib",theApp.m_PgmDir);
	else if (ZaFont=="") strFile.Format("%ssu1.dib",theApp.m_PgmDir);

	pDIB->Save((LPSTR)((LPCTSTR)strFile));
}

//////
// lzu
void CSDJView::InitMatePos()
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	CKmSprite *pKmSprite=pDoc->GetKmSpriteArray();
	CKif Kif;
	int sg,km,nr;
	int gn=0;
	int za=pKBase->GetZa(); // 
	for (int i=0;i<40;i++) {
		pKmSprite[i].GetKmStatus(&sg,&km,&nr);
		if (km!=0) { // ʈȊO
			Kif.kt=1;Kif.ky=1^za;Kif.kx=0; // 
			pKmSprite[i].SetKmPos(Kif,FALSE); // \
		}
		else {
			if (gn==0) { // ʂ̏ꍇ
				Kif.kt=2;Kif.ky=0;Kif.kx=0; // 
				pKmSprite[i].SetKmPos(Kif,FALSE); // \
				gn=1; // ꖇ
			}
			else {
				Kif.kt=0;
				Kif.kx=5; 
				Kif.ky=(za==0)?1:9; // ʂ51
				pKmSprite[i].SetKmStatus(!za,km,nr); // t
				pKmSprite[i].SetKmPos(Kif,FALSE); // \
				ASSERT(gn==1);
			}
		}
	}
	pKBase->setturn(SIDE_A); // 
	pKBase->recstart(); // L^ăX^[g
	EmptyDirtyList(); // _[eBXgNAB
}

// \DIBZbgB
//   iParentType 0:΋()   1:l(U)
void CSDJView::ResetZaFontDIB(int iParentType)
{
	m_pZaFontDIB=NULL;

	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	int za=pKBase->GetZa();

	// e΋ǂ̏ꍇ
	if (iParentType==0) {
		if (za==0 && theApp.m_bKfontInit[0]==TRUE)
			m_pZaFontDIB=&theApp.m_KfontDIB[0];
		else if (za!=0 && theApp.m_bKfontInit[1]==TRUE)
			m_pZaFontDIB=&theApp.m_KfontDIB[1];
	}
	// el̏ꍇ
	else if (iParentType==1) {
		if (za==0 && theApp.m_bTfontInit[0]==TRUE)
			m_pZaFontDIB=&theApp.m_TfontDIB[0];
		else if (za!=0 && theApp.m_bTfontInit[1]==TRUE)
			m_pZaFontDIB=&theApp.m_TfontDIB[1];
	}
}

/// (strKif)`(w̕Qig)ɕϊ
void CSDJView::GetPrintString(CString &strKif, CString &strPrt)
{
	CString str = strKif; // Ɨp
	char *kif=str.GetBuffer(str.GetLength()+1);

	// w\L܂ŒPɃRs[
	BOOL bSasite=FALSE;
	char *cp=strtok(kif,"\r\n");
	while (cp!=NULL && bSasite==FALSE) { 
		strPrt+=cp; strPrt+="\r\n";
		if (strncmp(cp,"w: ------",14)==0)
			bSasite=TRUE; // w\LL
		cp=strtok(NULL,"\r\n");
	}
	if (bSasite==FALSE)
		return;  // w\L͂Ȃ

	// w\Lo ("                          ")
	CString strSGTitle=cp;
	cp=strtok(NULL,"\r\n");

	// w\L̏
	CArray<CString,CString&> Left;
	CArray<CString,CString&> Right;
	int cnt=0;
	BOOL bLeft=TRUE;
	while (cp) {
		if (strncmp(cp,"w蒍: ------",16)==0)
			break; // w\LL
		CString buf=cp;
		if (bLeft)	Left.Add(buf);  // ig
		else   	   Right.Add(buf); // Eig
		cnt++;
		if (cnt==10) { // 20P(Qg)
			cnt=0;
			bLeft=!bLeft;
		}
		cp=strtok(NULL,"\r\n");
	}
	int ln=Left.GetSize();   // ig
	int rn=Right.GetSize();  // Eig
	// w\L̐ݒ
	CString sg;
	if (rn > 0) // EigL
		sg.Format("%s%17s %s\r\n",strSGTitle," ",strSGTitle);
	else
		sg.Format("%s\r\n",strSGTitle);
	strPrt+=sg;
	// ig
	for (int i=0;i<ln;i++) {
			// 111 W܋              112 U␬(59)  
			//  3 1    21               1 3 1    21  v51
		if (i<rn)
			sg.Format("%-51s %-51s\r\n",Left[i],Right[i]);
		else
			sg.Format("%-51s\r\n",Left[i]);
		strPrt+=sg;

		if (i%10==0)
			strPrt+="\r\n"; // ؂s
	}

	// w蒍߂̏(PRs[)
	while (cp) {
		strPrt+=cp;
		strPrt+="\r\n";
		cp=strtok(NULL,"\r\n");
	}

	str.ReleaseBuffer();
}

///////
// ǖʂ̈
//   x̍XVʂ*ypɉZB
//   bCalcOnly==TRUEȂY̍XV݂̂ŕ`͍sȂB
//   (ftHgFALSE)
void CSDJView::PrintBan(CDC *pDC,CPrintInfo *pInfo,int x,int *yp,
						   BOOL bCalcOnly)
{
	CSDJDoc* pDoc = GetDocument();
	CPrintObject *pPObj=(CPrintObject *)pInfo->m_lpUserData;
	CJBase JBase; // Ǘ
	JBase.SetAspect(&pPObj->Bform,pPObj->side); // ǖʂ̐ݒ
	CString st,gt;
	pDoc->GetSGName(&JBase,&st,&gt); // 㖼̂̎擾
	// tHg
	LOGFONT lfFont;
	CFont &nf=pPObj->nf; // tHg
	nf.GetObject(sizeof(LOGFONT),&lfFont);
	CFont &rf=pPObj->rf; // ttHg
	rf.GetObject(sizeof(LOGFONT),&lfFont);
	LONG nfh=lfFont.lfHeight; // tHg̍
	LONG nfh_qt=(nfh*10/4+9)/10; // tHg̍1/4(ľܓ)

	int i,j,n;

	CFont *pOldFont=pDC->SelectObject(&nf); // tHgI

	// 莝̕\
	BOOL bGoutput=FALSE;
	CString Gline;
	Gline.Format("%sF",gt);

	// ɋʂPꍇ͋l[hƂA
	// 莝́ucSvƕ\B
	// l[hۂׂB
	BOOL bMateMode=FALSE;
	if (JBase.hboxp(2)->kmnum(0)==1) { // ɋʂꖇB
		bMateMode=TRUE;
		for (i=1;i<=7;i++) {
			if (JBase.hboxp(2)->kmnum(i)!=0) {
				bMateMode=FALSE;
				break; // ̋ɂ΋l[hɂ͂ȂB
			}
		}
	}
	// l[hȂ
	if (bMateMode) { 
		for (i=0;i<8;i++) {
			if (JBase.hboxp(1)->kmnum(i)!=0) { // 莝̗L`FbN
				Gline+="cS";
				bGoutput=TRUE;
				break;
			}
		}
	}
	else { 
		// ʏ탂[h̕\
		for (i=0;i<8;i++) {
			n=JBase.hboxp(1)->kmnum(i); // i̎
			if (n > 0 ) {
				CString Km;
				if (n > 1) // QȏȂ
					Km.Format("%s%s ",Ktab[i*2],Ksu[n-1]);
				else
					Km.Format("%s ",Ktab[i*2]);
				Gline+=Km;
				bGoutput=TRUE;
			}
		}
	}
	if (bGoutput==FALSE)
		Gline+="Ȃ";
	if (!bCalcOnly)
		pDC->TextOut(x,*yp,Gline);
	(*yp)-=nfh; // 莝s̏I

	// Ֆʂ̕\(ӂ̏ڐ)
	CString Bline;
	Bline.Format("%s","X W V U T S R Q P");
	if (!bCalcOnly)
		pDC->TextOut(x+nfh_qt,*yp,Bline);
	(*yp)-=nfh;

	// ՘g
	int kh=nfh*3/2; // ڂ̑傫(tHg̍1.5{)
	if (!bCalcOnly) {
		for (i=0;i<10;i++) {
			// c
			pDC->MoveTo(x+kh*i,*yp); pDC->LineTo(x+i*kh,*yp-9*kh);
			// 
			pDC->MoveTo(x,*yp-i*kh); pDC->LineTo(x+9*kh,*yp-i*kh);
		}
	}
	(*yp)-=nfh_qt;

	// Ֆʂ̋
	for (j=1;j<=9;j++) { // Y
		for (i=1;i<=9;i++) { // X
			int spos=mpos2spos((10-i)*10+j);
			int id=JBase.bd(spos); // ̈ʒűID
			if (id!=NL && id!=OB) {  // 
				int prom=(JBase.pprom(id))? 1: 0; // \
				int side=JBase.pside(id);  // 
				int pcode=JBase.pcode(id); // 
				Bline.Format("%s",Ktab[pcode*2+prom]); // 
				if (side==SIDE_A) { // 
					if (!bCalcOnly)
						pDC->TextOut(x+nfh_qt+(i-1)*kh,*yp-(j-1)*kh,Bline);
				}
				else { // t
					CFont *pnf=pDC->SelectObject(&rf); // ttHgI
					if (!bCalcOnly)
						pDC->TextOut(x+nfh_qt+(i-1)*kh+nfh,*yp-(j-1)*kh-nfh,Bline);
					pDC->SelectObject(pnf);			   // tHgI
				}
			} 
		}
		Bline.Format("%s",Ksu[j-1]); // Ֆjs̏I
		if (!bCalcOnly)
			pDC->TextOut(x+nfh_qt+(i-1)*kh,*yp-(j-1)*kh,Bline);
	}
	(*yp)-=(j-1)*kh;

	// 莝̕\
	BOOL bSoutput=FALSE;
	CString Sline;
	Sline.Format("%sF",st);
	for (i=0;i<8;i++) {
		n=JBase.hboxp(0)->kmnum(i); // i̎
		if (n > 0 ) {
			CString Km;
			if (n > 1) // QȏȂ
				Km.Format("%s%s ",Ktab[i*2],Ksu[n-1]);
			else
				Km.Format("%s ",Ktab[i*2]);
			Sline += Km;
			bSoutput=TRUE;
		}
	}
	if (bSoutput==FALSE)
		Sline += "Ȃ";
	if (!bCalcOnly)
		pDC->TextOut(x,*yp,Sline);
	(*yp)-=nfh; // 莝s̏I

	pDC->SelectObject(pOldFont); // tHgɖ߂
}

// J
void CSDJView::OnUpdateMenuKifWindowOpen(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (m_pKifFrame==NULL) {
		pCmdUI->Enable(TRUE);
	}
	else {
		pCmdUI->Enable(FALSE);
	}
}

void CSDJView::OnMenuKifWindowOpen() 
{
	if (m_pKifFrame)
		return ;

	// ̃I[v
	CSDJDoc *pDoc=GetDocument();

	m_pKifFrame = new CKifFrame; // 
	m_pKifFrame->m_pParentView = this; // er[̋L

	//  ^Cg
	CString cap;
	cap.Format("%s",pDoc->GetTitle());

	// ̈ʒuvZ
	CRect rc;
	CSize sizeTotal=GetTotalSize(); // r[̃g[^̃TCY
	rc.SetRect(0,0,sizeTotal.cx, sizeTotal.cy);
	// E
	rc.left		= rc.right-128;
	rc.bottom	= rc.top+180;
	// Ȃ瑋{̕ɂB
	if (pDoc->GetKBase()->IsMulti()) {
		rc.right+=128;
	}
	// XN[W
	ClientToScreen(&rc);

	// ReLXgt@C
	CCreateContext context;
	context.m_pCurrentDoc=GetDocument();

	// t[EBhECreateB(OnCreateClient()ŕr[\z)
	BOOL result=m_pKifFrame->Create(NULL,(LPCTSTR)cap,
		WS_POPUP|WS_OVERLAPPEDWINDOW|WS_VISIBLE,
		rc,
		AfxGetMainWnd(),
		NULL, // MAKEINTRESOURCE(IDR_TESAPLTYPE) j[͏ȗ
		0,&context);
	ASSERT(result);

	// r[̏
	for (int i=0;i<2;i++) {
		CView *pView=(CView *)m_pKifFrame->m_wndSplitter.GetPane(0,i);
		pView->OnInitialUpdate();
	}
}

// 
void CSDJView::OnUpdateMenuKifWindowClose(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}

	if (m_pKifFrame) {
		pCmdUI->Enable(TRUE);
	}
	else {
		pCmdUI->Enable(FALSE);
	}
}

void CSDJView::OnMenuKifWindowClose() 
{
	if (m_bMenuLock)
		return;

	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_CLOSE);
	}
}

/////
// lvl
void CSDJView::OnUpdateMenuCheckMate(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(TRUE); // {Iɂłnj
}

void CSDJView::OnMenuCheckMate() 
{
	if (m_bMenuLock)
		return;

	// lhLg̐VK쐬
	BOOL bKifWindowEnable=theApp.m_bKifWindowEnable; // ͍Ȃ悤ɑ
	theApp.m_bKifWindowEnable=FALSE;      // ꎞIDisable
	CWinSDJTSDoc *pTSDoc=(CWinSDJTSDoc *)theApp.m_pMDocTemplate2->OpenDocumentFile(NULL);
	theApp.m_bKifWindowEnable=bKifWindowEnable; // ɖ߂
	if (!pTSDoc)
		return;
	// ̃hLg
	CSDJDoc *pSDJDoc=GetDocument();

	// t@CɌǖʂo
	CWinMemFile File;
	CSDJArchive arOut(&File,CArchive::store);
	pSDJDoc->WriteBaninfo(arOut);
	arOut.Close();
	File.Seek(0L,CFile::begin); // t@C擪Seek
	// t@ClhLgɋǖʂ[h
	CSDJArchive arIn(&File,CArchive::load);
	pTSDoc->ReadBaninfo(arIn);
	arIn.Close();

	CWinSDJTSView *pTSView=(CWinSDJTSView*)pTSDoc->GetSDJView(); // lr[
	pTSView->SendMessage(WM_COMMAND,ID_CHECK_MATE); // lvlN
}

////
// Rs[
void CSDJView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(TRUE); // {Iɂłnj
}

void CSDJView::OnEditCopy() 
{
	if (m_bMenuLock)
		return;

	CSDJDoc *pSDJDoc=GetDocument();
	CKBase *pKBase=pSDJDoc->GetKBase(); // 

	CLBase LBase; // [Nobt@
	pKBase->CopySBase(&LBase,FALSE,TRUE); // ǖʈȍ~̖{菇LBase

	// t@CLBaseSerializeo͂B
	CWinMemFile File; // t@C
	CSDJArchive ar(&File, CArchive::store);
	LBase.Serialize(ar); // t@Co
	ar.Close();
	File.Seek(0L,CFile::begin); // 擪seek
	int len=File.GetLength();	// t@C

	// O[oAP[gAɃt@C̓e𕡎
	HANDLE hMem=GlobalAlloc(GMEM_MOVEABLE,len+1);
	if (hMem==NULL)
		return;
	char *gbuf=(char *)GlobalLock(hMem);
	UINT n=File.Read(gbuf,len);
	gbuf[n]='\0'; // null terminator
	GlobalUnlock(hMem);

	// O[oNbv{[h֏o͂B
	if (!OpenClipboard()) {					// Nbv{[hJ
		GlobalFree(hMem);
		return; // Nbv{[hgp
	}
	::EmptyClipboard();  // Nbv{[h
	::SetClipboardData(theApp.m_nWinSDJFormat,hMem); // Nbv{[hɏo
	::CloseClipboard();	 // Nbv{[h
}

////
// y[Xg
void CSDJView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	BOOL bEnable=IsClipboardFormatAvailable(theApp.m_nWinSDJFormat);
	pCmdUI->Enable(bEnable); // ꂪo͂`Ȃnj
}

void CSDJView::OnEditPaste() 
{
	if (m_bMenuLock)
		return;

	// hLg̍XV`FbN
	CSDJDoc *pSDJDoc=GetDocument();
	if (pSDJDoc->IsModified()) {
		CString strMes;
		strMes.Format("obt@͕ύXĂ܂BXVĂ낵łH");
		int id=AfxMessageBox(strMes,MB_YESNO);
		if (id!=IDYES)
			return;
	}

	if (!OpenClipboard()) // Nbv{[h̃I[v
		return;
	// ̃Nbv{[htH[}bgB
	UINT nFormat=0;
	int n=CountClipboardFormats();
	for (int i=0;i<n;i++) {
		nFormat=EnumClipboardFormats(nFormat);
		if (nFormat==theApp.m_nWinSDJFormat)
			break;
	}
	if (nFormat!=theApp.m_nWinSDJFormat)
		return ; // ȂƂ͖B

	// Nbv{[hǂ(O[o擾)B
	HANDLE hMem=GetClipboardData(nFormat);
	CWinMemFile File; // t@C
	char *gbuf=(char *)GlobalLock(hMem);  // lock
	int len=strlen(gbuf);
	File.Write(gbuf,len);  // t@Cɓǂ
	GlobalUnlock(hMem);    // unlock

	::EmptyClipboard();    // Nbv{[h
	::CloseClipboard();    // Nbv{[h̃N[Y

	pSDJDoc->DeleteContents(); // hLgZbg

	// t@ChLgSerialize()B
	File.Seek(0L,CFile::begin);
	CSDJArchive ar(&File,CArchive::load);
	CKBase *pKBase=pSDJDoc->GetKBase(); // 
	pKBase->Serialize(ar);
	ar.Close();

	pSDJDoc->SetMrecTesu();		 // 萔̃Zbg
	pSDJDoc->SetModifiedFlag(TRUE);

	// \̐}
	pSDJDoc->AdjustSpriteList(); // XvCgXg̒
	EmptyDirtyList();
	if (GetGuideFrame()!=NULL) // ǖʕ\JĂ
		GetGuideFrame()->Invalidate();
	if (GetSubFrame()!=NULL) // TuEBhEJĂ
		GetSubFrame()->Invalidate(); // ͕KvȂ...B
	Invalidate();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=GetDbeFrame();
		if (pDbeFrame) { // ̃r[ՑĂ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	// JĂe
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
	}
}

///////
// ^uL[ꂽ
void CSDJView::OnActivateTabkey() 
{
	int i;
	// ̓tH[JXr[,(XgAc[jAՑ̏
	// 񂳂B
	CWnd *pFocused=GetFocus();
	if (pFocused==NULL) {
		SetFocus();  // ɃtH[JX𓖂ĂďIB
		return;
	}

	CWnd *pWnd[4];
	for (i=0;i<4;i++)
		pWnd[i]=NULL; // NULL Clear

	pWnd[0]=this; // ŏ͎(SDJView)
	if (m_pKifFrame) { // 
		pWnd[1]=m_pKifFrame->m_wndSplitter.GetPane(0,0); // ListView
		pWnd[2]=m_pKifFrame->m_wndSplitter.GetPane(0,1); // TreeView
	}
	if (m_pDbeFrame) {
		pWnd[3]=m_pDbeFrame->GetActiveView(); // Ց treeview
	}

	// tH[JX̂EBhET
	for (i=0;i<4;i++) {
		if (pWnd[i]==pFocused)
			break; // 
	}
	if (i<4) { // ̃EBhET
		for (i++;i<4;i++) {
			if (pWnd[i])
				break;
		}
	}
	if (i<4)
		pWnd[i]->SetFocus();	// ̃EBhEփtH[JXڂB
	else
		SetFocus();				// ȂΎցB
}

///////////////
// t@Cϊc[
void CSDJView::OnMenuK2CSEL() 
{
	CK2CSEL K2CSEL;
	int id=K2CSEL.DoModal();

	// ϊsB
	if (id==IDOK) {
		CString str=K2CSEL.m_ODirName + K2CSEL.m_OFileName;
		int n=str.GetLength();
		if (n>4) {
			// gqcsaȂA삵CSAt@CƂċLB
			LPCTSTR cp=(LPCTSTR)str+n-4;
			if (strnicmp(cp,".csa",4)==0) {
				WriteCsaFname(str);
			}
		}
	}
}

///////
// w폜
void CSDJView::OnUpdateMenuSeparateDel(CCmdUI* pCmdUI) 
{
	if (m_bMenuLock) {
		pCmdUI->Enable(FALSE);
		return;
	}
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	PCELL *pcl=pKBase->lastmove(); // O̎w
	PCELL *parent;
	if (pcl==pKBase->root()) {
		parent=pcl;
		pCmdUI->Enable(FALSE);
		return;
	}
	else {
		parent=pcl->pnt();
	}

	int n=parent->cldnum();  // O̎w̌Z̐

	if (n>0)
		pCmdUI->Enable(TRUE);	// w肠
	else
		pCmdUI->Enable(FALSE);  // wȂ
}

void CSDJView::OnMenuSeparateDel() 
{
	int i;

	if (m_bMenuLock)
		return;

	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	PCELL *pcl=pKBase->lastmove(); // O̎w
	PCELL *parent;
	if (pcl==pKBase->root()) {
		parent=pcl;
		return;
	}
	else {
		parent=pcl->pnt();
	}

	int n=parent->cldnum();  // O̎w̌Z̐
	// O̎w̃CfbNXl߂
	for (i=0;i<n;i++) {
		if (parent->cld(i)==pcl)
			break;
	}
	ASSERT(i<n);

	int idx=i; // i̋L
	CDlgSeparateDel DlgSeparateDel;
	DlgSeparateDel.m_iSelNo=idx;
	DlgSeparateDel.m_pDoc=pDoc;
	if (DlgSeparateDel.DoModal()!=IDOK)
		return; // LZI

	// ǖʂ폜ꂽǖʂ߂B
	if (DlgSeparateDel.m_iSelNo==i) {
		// ǖʂ߂
		pKBase->backmove2();

		// ߑJĂ
		if (IsCommentBoxOpened()) {
			CloseCommentBox();
		}
	}

	// w肳ꂽw̍폜
	PCELL *pcl2=parent->cld(DlgSeparateDel.m_iSelNo);
	pKBase->freepcl(pcl2);     // ̃XgJ
	pKBase->ResetJudgeLevel(); // {菇̌vZʂZbg
	pDoc->SetModifiedFlag(TRUE);


	// JĂeXV(Zbg)
	if (m_pKifFrame) {
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
	}

	// ǖʏ̍XV
	if (GetGuideFrame()!=NULL)
		GetGuideFrame()->Invalidate();

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=(CDbeFrame *)theApp.m_pDbeDocTemplate->GetFrameWnd();
		if (pDbeFrame->GetSdjParent()==this) { // r[Ȃ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	Invalidate();
}

/*
    ujQwwwL[̃`FbN @ '02.12.15 by Ra
	    (VK_LEFT)	,(VF_UP)		:
		(VK_RIGHT),(VF_DOWN)	:Oi
		Home(VK_HOME)				:ǖ
		End(VK_END)					:ŏIǖ
		PageUp(VK_PRIOR)			:Oi
		PageDown(VK_NEXT)			:
		Del(VK_DELETE),BS(VK_BACK)	:~
 */
void CSDJView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (GetFocus()!=this) 
		return ; // ̃`FbN͕svAÖׁB

	/* Oi */
	if (nChar == VK_RIGHT || nChar == VK_DOWN) {
		OnMenuAhead();
	}
	/*  */
	else if (nChar == VK_LEFT || nChar == VK_UP) {
		OnMenuBackmove();
	}
	/* ŏIǖʂ */
	else if (nChar == VK_END) {
		OnMenuTail();
	}
	/* ǖʂ */
	else if (nChar == VK_HOME) {
		OnMenuHead();
	}
	/* Oi */
	else if (nChar == VK_NEXT) {
		OnMenuAutoahead();
	}
	/*  */
	else if (nChar == VK_PRIOR) {
		OnMenuAutoback();
	}
	/* XV~ */
	else if (nChar == VK_DELETE || nChar == VK_BACK) {
		OnMenuPlaystop();
	}

	COSBView::OnKeyDown(nChar, nRepCnt, nFlags);
}
