/*=========================================================================
                                   
                         B `vO
                                   
                           1993.11 by Ra
                           1996.9  version 3.0 by Ra
                                   
============================================================================*/
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#include <shgdb.h>

// {擪id,}
static struct {
    int sid;
    int num;
} B_kt[8]={{0,2},{2,2},{4,2},{6,4},{10,4},{14,4},{18,4},{22,18}};
static int B_sft[8]={2,2,2,3,3,3,3,5};  /* facenum Vtgrbg */
static int B_ptt[8]={3,3,3,7,7,7,7,31}; /* facenum & Z */


//////////////////
// ukm -> BFORM ϊ
/////////////////////
void B_ImportFrom(unsigned int *ukm,B_FORM *bform)
{
    unsigned int nr,pos,side,ui;
    int i,j,k,fnum[8];

    // ukmB_FORMĐB
    for (i=0;i<8;i++) {                 // ukm̃\[g
        for (j=0;j<B_kt[i].num-1;j++) {
            for (k=j+1;k<B_kt[i].num;k++) {
                if (ukm[B_kt[i].sid+j] > ukm[B_kt[i].sid+k]) {
                    ui = ukm[B_kt[i].sid+j]; 
                    ukm[B_kt[i].sid+j] = ukm[B_kt[i].sid+k];
                    ukm[B_kt[i].sid+k] = ui;
                }
            }
        }
    }
    // km[]̍Đ
    for (i=0;i<8;i++) {                 // ̐JԂ
        fnum[i]=0;                      // ̐
        for (j=0;j<B_kt[i].num;j++) {   // ̖JԂ
            ui=ukm[B_kt[i].sid+j];
            pos=(ui >> 1) % 128;
            side=ui & 1;
            nr=(ui >> 8) & 1;
            bform->km[B_kt[i].sid+j]=(side << 7)+pos;
            if (pos!=127 && nr==0)
                fnum[i]++;              // ȊO̐
        }
    }
    // facenum̍Đ
    for (bform->facenum=0L,i=7;i>=0;i--) {
        bform->facenum += (unsigned long)fnum[i];
        if (i>=1)
            bform->facenum = bform->facenum << B_sft[i-1];
    }
}

////////////////////
// BFORM -> ukm ϊ
///////////////////
void B_ExportTo(B_FORM *bform, unsigned int *ukm)
{
    unsigned int nr,pos,side;
    int i,j,fnum[8];
    unsigned long face;

    // B_FORMukmɓWJ
    face=bform->facenum;
    for (i=0;i<8;i++) {                  // 했ɏ
        fnum[i]=face & B_ptt[i];         // fnum[i]=i̐(Տ,)
        for (j=0;j<B_kt[i].num;j++) {    // j̖͂̋JԂ
            pos=bform->km[B_kt[i].sid+j]%128;  // B`̈ʒu0~127
            side=bform->km[B_kt[i].sid+j]/128; // B`̌0/1
            if (pos!=127)  nr=(fnum[i]-j>0)? 0 : 1; // Տ,
            else           nr=0;                    // 
            ukm[B_kt[i].sid+j]=(nr<<8)+(pos<<1)+side;
        }
        face=face>>B_sft[i];
    }
}

/*****************
// Ֆʂ̏
//
//   mode  0:Sċ 1: 
//*********************************/
void B_Init(B_FORM *bform,int mode)
{
    int i;

    if (mode==0) {              /* Sċ */
        for (i=0;i<40;i++)      /* SJԂ */
            bform->km[i]=127;   /* ʒu= */
    }
    else {                      /* mode!=0͕zu */
        bform->km[0]=51+128;    /*  */
        bform->km[1]=59;        /*  */
        bform->km[2]=28;        /*  */
        bform->km[3]=82+128;    /*  */
        bform->km[4]=22+128;    /* p */
        bform->km[5]=88;        /* p */
        for (i=0;i<4;i++) {     /* ` */
            bform->km[6+i*4+0]=40-10*i+1+128;  /*  */
            bform->km[6+i*4+1]=40-10*i+9;      /*  */
            bform->km[6+i*4+2]=60+10*i+1+128;  /*  */
            bform->km[6+i*4+3]=60+10*i+9;      /*  */
        }
        for (i=0;i<9;i++) {
            bform->km[22+2*i]  =(i+1)*10+3+128; /* ̕ */
            bform->km[22+2*i+1]=(i+1)*10+7;     /* ̕ */
        }
    }
    /* facenum̐ݒ */
    bform->facenum=0L;		/* ՏE䐶=0 */
    if (mode!=0) {		/* zu̎͐Zbg */
	for (bform->facenum=0L,i=7;i>=0;i--) {
	    bform->facenum+=B_kt[i].num;
	    if (i>0)
		bform->facenum=bform->facenum<<B_sft[i-1];
	}
    }
}

//////////////////
// WJz̔Ֆʂ𔽓]
///////////////////////////
void B_ReverseUkm(unsigned int *ukm)
{
	int i;
	unsigned int nr,pos,side;

   // S(ukm[])̔]
    for (i=0;i<40;i++) {
        pos=(ukm[i]>>1) % 128;           // o
        side=ukm[i] & 1;
        nr=(ukm[i]>>8) & 1;
        if (pos>=11 && pos <=99) {       // Տ
            pos=100-pos/10*10+10-pos%10; // Wϊ
            side^=1;                     // 
        }
        else if (pos<=1) pos^=1;         // ϊ
        ukm[i]=(nr<<8)+(pos<<1)+side;    // Đ
    }
}

//////////////////
// Ֆʂ𔽓]
//////////////////////
void  B_ReverseForm(B_FORM *bform)
{
    unsigned int ukm[40];     // B`WJz

    B_ExportTo(bform, ukm);   // B`WJ

    // S(ukm[])̔]
	B_ReverseUkm(ukm);

    B_ImportFrom(ukm, bform); // B`Đ
}

///////////////////
// w𔽓]B
////////////////////
B_PLAY  B_ReversePlay(B_FORM *bform,B_PLAY bplay,B_FORM *bformr)
{
    B_PLAY bplayr,pos[2];
    int i;
    unsigned int id,idr,kmid;

    id=bplay & 0x3f;             // id=ϊŐԍ
    pos[0]=bform->km[id] & 0x7f;  // bform̈ړ
    pos[1]=(bplay>>6) & 0x7f;    // bform̈ړ

    // ړAړWϊ
    for (i=0;i<2;i++) {
        if (pos[i]>=11 && pos[i]<=99)
            pos[i]=100-pos[i]/10*10+10-pos[i]%10; // Wϊ
        else if (pos[i]<=1)
            pos[i]^=1;                            // ϊ
    }
    // kmid=
    for (kmid=0;B_kt[kmid].sid+B_kt[kmid].num<=(int)id;kmid++);

    // ϊ̋ԍidř(ňړ̈ʒuŏ̋)
    for (i=0;i<B_kt[kmid].num;i++) {
        if (bformr->km[B_kt[kmid].sid+i]%128==pos[0])
            break;
    }
    idr=B_kt[kmid].sid+i;

    // bplayr̊m
    bplayr=((bplay & 0xe000) ^ 0x4000)+(pos[1]<<6)+idr;

    return bplayr;
}

////////////
// wi߂(Ukmx[X)
/////////////////////////////
void B_ForwardUkm(unsigned int *ukm,B_PLAY bplay)
{
    unsigned int nr,pos,side,ui;
    int i,j,k,id;
	
    if ((bplay & 0x8000)!=0) return; // ̎wȂ牽Ȃ

    // ̈ړ
    id=bplay & 0x3f;            // ړ̋ԍ
    pos=(bplay>>6) & 0x7f;      // ړ
    side=((bplay & 0x4000)!=0)? 1 : 0;
    nr=((bplay & 0x2000)!=0)?  1 : 0;
    if (pos>=11 && pos<=99) {            // Տւ̈ړȂ
        for (i=0;i<40;i++) {
            if ((ukm[i]>>1)%128==pos) { // 
                ukm[i]=(side<<1);       // Ďw(0/1)̋
                break;
            }
        }
        ukm[id]&=0x101;             // ƌ̂܂܂Ɉʒu0NA
        ukm[id]=ukm[id]|(nr<<8)|(pos<<1)|side; // ̈ړ(ʒuƐXV)
    }
    else                        // ւ̈ړȂ
        ukm[id]=(pos<<1);       // ̈ړ

    // ukm̃\[g
    for (i=0;i<8;i++) {                 
        for (j=0;j<B_kt[i].num-1;j++) {
            for (k=j+1;k<B_kt[i].num;k++) {
                if (ukm[B_kt[i].sid+j] > ukm[B_kt[i].sid+k]) {
                    ui = ukm[B_kt[i].sid+j]; 
                    ukm[B_kt[i].sid+j] = ukm[B_kt[i].sid+k];
                    ukm[B_kt[i].sid+k] = ui;
                }
            }
        }
    }
}

/////////////////
// wi߂B
///////////////////
void B_Forward(B_FORM *bform,B_PLAY bplay)
{
    unsigned int ukm[40]; // B`WJz
    unsigned int nr,pos,side;
    int i,id;

    if ((bplay & 0x8000)!=0) return; // ̎wȂ牽Ȃ

    B_ExportTo(bform, ukm);     // B_FORMukmɓWJ

    // ̈ړ
    id=bplay & 0x3f;            // ړ̋ԍ
    pos=(bplay>>6) & 0x7f;      // ړ
    side=((bplay & 0x4000)!=0)? 1 : 0;
    nr=((bplay & 0x2000)!=0)?  1 : 0;
    if (pos>=11 && pos<=99) {            // Տւ̈ړȂ
        for (i=0;i<40;i++) {
            if ((ukm[i]>>1)%128==pos) { // 
                ukm[i]=(side<<1);       // Ďw(0/1)̋
                break;
            }
        }
        ukm[id]&=0x101;             // ƌ̂܂܂Ɉʒu0NA
        ukm[id]=ukm[id]|(nr<<8)|(pos<<1)|side; // ̈ړ(ʒuƐXV)
    }
    else                        // ւ̈ړȂ
        ukm[id]=(pos<<1);       // ̈ړ

    B_ImportFrom(ukm, bform);   // ukmB_FORMĐB
}




////////////////
//  w̎擾
///////////////////
B_PLAY B_GetBplay(B_FORM *bform,int from,int to,int prm,int side,int code)
{
    int i,kmid=-1;
    B_PLAY bplay=(unsigned short) -1;

    if ((to!=0 && to!=1 && to < 11) || 
    (to!=127 && to > 99 ) ||
    (code < 0 || code > 7)) goto exit;

    if (from>=11 && from <=99) {            // Տ̋
        for (i=0;i<40;i++) {
            if ((bform->km[i] & 0x7f)==from) {
                kmid=i;break;
            }
        }
    }
    else if (from==0 || from==1 || from==127) {
        for (i=B_kt[code].sid;i<B_kt[code].sid+B_kt[code].num;i++) {
            if ((bform->km[i] & 0x7f)==from) {
                kmid=i;break;
            }
        }
    }
    if (kmid >= 0) {
        prm=!!prm;
        side=!!side;
        bplay=(side<<14)+(prm<<13)+(to<<6)+kmid;
    }
  exit:
    return bplay;
}
