/*=========================================================================

                          ΋DBANZX֐

                           1993.12 by Ra

============================================================================*/
#pragma warning(disable:4996)

#include <shgdb.h>
#include <string.h>
#include <memory.h>

extern int DB_Rc;               /* OG[ϐ */
extern long CvDecL(char *,int); /* OQƊ֐ */
extern void *memalloc(unsigned int);
extern void memfree(void *);

/************************
// ΋DBւ̃R[ho^
//***********************/
long DBB_Write(
               SCM_t *Ascm,    /* ՖDB̕\XL[}\ */
               SCM_t *Bscm,    /* ΋DB̕\XL[}\ */
               B_REC *b_rec,   /* o^BR[h̃obt@ */
               B_FORM *bform,  /* ՖB` */
               int side        /* Ֆʎ 0: 1:葤 */
               )
{
    int rc;
    long hash_s,recno=(-1L);
    A_REC a_rec;
	int dba_insert=0;

    /* ՖDBɏǖʂo^Ă邩B*/
    hash_s=DBA_Find(Ascm,bform);
    if(hash_s<0) {              /* o^ȂՖDBo^B*/
        hash_s=DBA_Write(Ascm,bform,0L); /* QƐ=0œo^ */
        if (hash_s<0)
            goto exit;          /* o^s */
        dba_insert=1;
    }
    /* b_rec̍ڂ̓A{֐ŃZbg鍀 */
    sprintf(b_rec->row.hash_s,"%08ld",hash_s); /* ՖDB nbVl */
    sprintf(b_rec->row.side,"%1d",!!side);      /*  */
    memset(b_rec->row.b_recno,'9',sizeof b_rec->row.b_recno); /* recno͉l */
    memset(b_rec->row.dummy,'\0',sizeof b_rec->row.dummy);

    /* b_rec΋DBɓo^B */
    DB_Rc=rc=SdbWrite(Bscm,b_rec->buffer,&recno);
    if (rc!=E$OK) {
        recno=-1L; 
        if (dba_insert)
            DBA_Delete(Ascm,hash_s); /* DBAVKǉLZ */
        goto exit;                   /* ΋DBo^G[ */
    }

    /* R[hԍ̃ZbgEXV */
    sprintf(b_rec->row.b_recno,"%06ld",recno); /* dummy[0]'\0'B*/
    DB_Rc=rc=SdbUpdate(Bscm,b_rec->buffer,recno); /* XV */
    if (rc!=E$OK) {
        recno=-1L;
        if (dba_insert)
            DBA_Delete(Ascm,hash_s); /* DBAVKǉLZ */
        goto exit;                   /* ΋DBXVG[ */
    }
    
    /* ՖDB̎QƐ+1 */
    if ((rc=DBA_HSread(Ascm,hash_s,&a_rec))!=E$OK) {
        recno=-1L;goto exit;    /* ՖDBǂݏoG[ */
    }
    a_rec.row.refcount++; /* QƐ+1 */
    
    rc=DBA_Update(Ascm,&a_rec); /* ՖDB̍XV */
    if (rc!=E$OK) recno=-1L;    /* ՖDBXVG[ */
    
  exit:
    return recno;
}
/***********************
// ΋DB̃R[h폜
//*********************/
int DBB_Delete(
               SCM_t *Ascm,     /* ՖDB̕\XL[}\ */
               SCM_t *Bscm,     /* ΋DB̕\XL[}\ */
               long recno       /* ΋DB̑΋ǔԍ(R[hԍ) */
               )
{
    int rc;
    A_REC a_rec;                /* AR[hobt@̓X^bNɎ */
    B_REC *b_rec=NULL;          /* BR[hobt@|C^ */
    long hash_s;                /* ՖDB HSnbVl */

    b_rec=(B_REC *)memalloc(sizeof(B_REC)); /* BR[hobt@̊m */
    if (b_rec==NULL) {
        rc=E$MEM;goto exit;     /* s */
    }
    DB_Rc=rc=SdbDrRead(Bscm,recno,b_rec->buffer); /* BR[h̓ǂݏo */
    if (rc!=E$OK) goto exit;    /* ǂݏoُ܂͊ɏ */

    hash_s=CvDecL(b_rec->row.hash_s,sizeof b_rec->row.hash_s);
    rc=DBA_HSread(Ascm,hash_s,&a_rec);
    if (rc!=E$OK) goto exit;    /* ՖDBǂݏoG[ */

    /* ܂߂BR[h폜 */
    DB_Rc=rc=SdbDelete(Bscm,b_rec->buffer,recno);
    if (rc!=E$OK) goto exit;    /* BR[h폜G[ */

    /* QƐZBQƐ=0ɂȂՖDB폜B*/
    a_rec.row.refcount--;
    if (a_rec.row.refcount>0)
        rc=DBA_Update(Ascm,&a_rec); /* ՖDB̎QƐZXV */
    else
        rc=DBA_Delete(Ascm,hash_s); /* QƐ=0ȂՖDBR[h폜 */
        
  exit:
    if (b_rec!=NULL)
        memfree(b_rec);         /* BR[hobt@̉ */
    return rc;
}

