/**********************/
/*    BuftoDBB.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "BuftoDBB.h"
#include "winsdjdoc.h"
#include "statusbox.h"
#include "winsdjview.h"
#include "dbeframe.h"
#include "dbeview.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBuftoDBB _CAO

CBuftoDBB::CBuftoDBB(CWnd* pParent /*=NULL*/)
	: CDialog(CBuftoDBB::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBuftoDBB)
	m_iMode = -1;
	m_strDbbInfo = _T("");
	//}}AFX_DATA_INIT
	m_pDoc=NULL;
	m_pFile=NULL;
}

void CBuftoDBB::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBuftoDBB)
	DDX_Radio(pDX, IDC_ModeNew, m_iMode);
	DDX_Text(pDX, IDC_DBBINFO, m_strDbbInfo);
	DDV_MaxChars(pDX, m_strDbbInfo, 512);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBuftoDBB, CDialog)
	//{{AFX_MSG_MAP(CBuftoDBB)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuftoDBB bZ[W nh

BOOL CBuftoDBB::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// DoModal()̑OSetDbb()ɂCDBBݒ肳ĂO
	ASSERT(m_pDoc);

	// ΋Ǐ̐ݒ
	char StringBuffer[128];
	char DbbInfo[1024];
	BDSP *bdsp=m_pDoc->m_Dbb.GetMdsp();
	sprintf(DbbInfo,"      %s\r\n",bdsp->splayer);
	sprintf(StringBuffer,"      %s\r\n",bdsp->gplayer);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"  %s\r\n",bdsp->result);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"햼    %s\r\n",bdsp->kisen);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"    ^  %s\r\n",bdsp->senkei);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"΋Ǔ    %s\r\n",bdsp->playdate);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"      %s\r\n",bdsp->teai);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"  %s\r\n",bdsp->htime);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"o^    %s\r\n",bdsp->datetime);
	strcat(DbbInfo,StringBuffer);
	sprintf(StringBuffer,"΋ǔԍ  %s",bdsp->b_recno);
	strcat(DbbInfo,StringBuffer);

	m_strDbbInfo.Format("%s",DbbInfo);								// ΋Ǐ

	// o^[h̃ftHglb_recno̗LŌ߂
	if (strlen(bdsp->b_recno))
		m_iMode=1; // ㏑o^
	else
		m_iMode=0; // VKo^

	UpdateData(FALSE);												// f[^̔f()

	// DBRNOɏlL
	Dbrno.dbrno=atol(bdsp->b_recno);
	Dbrno.tesu=m_pDoc->GetKBase()->level();

	return TRUE;													// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
																	// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////////
/// o^Xbh
static UINT BuftoDBBWorkerThread(CStatusBox *pBox,CEvent *pEvent,LPARAM lParam)
{
	CBuftoDBB *pBuftoDBB=(CBuftoDBB *)lParam;
	CDBB Dbb;														// ΋ǂca

	Dbb.SetQuitObject((HANDLE)(*pEvent));							// fCxg

	CSDJArchive arIn(pBuftoDBB->m_pFile,CArchive::load);
	pBuftoDBB->Dbrno.dbrno=Dbb.InCsa2DB(arIn,pBox);					// DBo^ & ΋ǔԍԂ
	arIn.Close();

	return 0;
}

////////
/// ΋ǂ̓o^
void CBuftoDBB::OnOK() 
{
	BOOL bOK=TRUE;
	BDSP *bdsp=m_pDoc->m_Dbb.GetMdsp();
	B_REC *b_rec=m_pDoc->m_Dbb.GetMrec();
	char brecno[sizeof bdsp->b_recno];
	brecno[0]='\0';

	// ݒl̎擾
	UpdateData(TRUE);

	// o^[h̃`FbN
	if (m_iMode==0) { // VKo^
		if (strlen(bdsp->b_recno)!=0) {
			strcpy(brecno,bdsp->b_recno);							// b_recnoL
			b_rec->row.b_recno[0]='\0';								// hLg̑΋ǔԍꎞIɏ
		}
	}
	else { // ㏑o^
		if (strlen(bdsp->b_recno)==0) {
			AfxMessageBox("㏑o^ɂ͑΋ǔԍ̎w肪KvłB");
			bOK=FALSE;
		}
	}

	// o^
	if (bOK) {
		// ΋Ǌt@CCSAo͂B
		m_pFile=new CWinMemFile;
		CSDJArchive arOut(m_pFile, CArchive::store);
		m_pDoc->Serialize(arOut,TRUE);								// ΋Ǌ({菇)CSAt@Co
		arOut.Close();
		m_pFile->Seek(0L,CFile::begin);								// t@C̓o

		// b_recnőLɖ߂
		if (strlen(brecno)!=0) {									// L
			strncpy(b_rec->row.b_recno,brecno,strlen(brecno));
		}	

		CStatusBox StatusBox(&BuftoDBBWorkerThread,(LPARAM)this);
		StatusBox.DoModal();										// o^
		delete m_pFile;

		// o^ɐ
		if (Dbrno.dbrno >=0) {
			// DbrnȍɁA΋ǂca΋ǊǂݏoB
			// 鎖ɂAVKo^Ă΋ǔԍZbgB
			CWinSDJView *pView=(CWinSDJView *)m_pDoc->GetSDJView();

			// ߃{bNXJĂ
			pView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

			CWaitCursor wcur;										// v
			m_pDoc->ReadDbbInfo(Dbrno);								// ΋DBǂݍ

			m_pDoc->SetModifiedFlag(FALSE);

			if (pView->GetGuideFrame()!=NULL)						// ǖʕ\JĂ
				pView->GetGuideFrame()->Invalidate();
			if (pView->GetSubFrame()!=NULL)							// TuEBhEJĂ
				pView->GetSubFrame()->Invalidate();
			pView->Invalidate();									// \XV

			// JĂe
			if (pView->GetKifFrame()!=NULL) {
				pView->GetKifFrame()->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
			}

			// ՑJĂeXV(ۂ͒Ց̓I[v
			// 邱Ƃ͂ȂBj[ŃC^[bNĂ)
			if (theApp.m_bDbeUsing) {
				CDbeFrame *pDbeFrame=pView->GetDbeFrame();
				if (pDbeFrame) { // ̃r[ՑJĂ
					CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
					pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
				}
			}

		} 
		// o^ɎsAꉞADbrno̒lɖ߂ĂB
		else {
			BDSP *bdsp=m_pDoc->m_Dbb.GetMdsp();
			Dbrno.dbrno=atol(bdsp->b_recno);
		}

		CDialog::OnOK();											// OKI
	}
}
