//////////////////////
// 
// CDBC class
//                      1996.09 by Ra
//						1997.09 modified by Ra
#ifndef __DBC__
#define __DBC__

#include "bform.h"
extern "C" {
#include <shgdb.h>
}

#include "dbm.h"
#include "sdjarchive.h"

/* DB_CR[h\pobt@ */
typedef struct Cdsp {
    char author[sizeof ((C_REC *)0)->row.author + 1];	/*  */
    char movenum[sizeof ((C_REC *)0)->row.movenum + 1];	/* l萔 */
    char hint[sizeof ((C_REC *)0)->row.hint + 1];       /* qg */
    char level[sizeof ((C_REC *)0)->row.level + 1];     /* Փx */
    char title[sizeof ((C_REC *)0)->row.title + 1];     /* \ */
    char datetime[18];									/* o^ yy/mm/dd hh:mm:ss */
    char hash_s[sizeof ((C_REC *)0)->row.hash_s + 1];	/* o} */
    char c_recno[sizeof ((C_REC *)0)->row.c_recno + 1];	/* lԍ */
} CDSP;

class CDBC: public CDBM
{
	DECLARE_SERIAL(CDBC)
protected:
	CDSP *mdsp,m_mdsp;	// lcaR[h\obt@
	C_REC m_rec;		// lcaR[hobt@

private:
    void common_init();
protected:
	virtual void mrec_init();
	virtual char *get_mdsp_strrecno(){return mdsp->c_recno;}

public:
	virtual int get_mrec_side();
	virtual long get_mrec_hash_s();
	virtual long get_mrec_recno();
	void set_disp_mrec(char *dikpbuf,int w1=-1,int w2=-1);
	// CSA`DBC֓o^(nǕ)
	virtual int InCsa2DB(CSDJArchive &ar,CWnd *pWnd=NULL,BOOL bIgnoreRecno=FALSE,BOOL bTotal=TRUE );
	virtual int OutMrec2CsaHeader1(CSDJArchive &ar,int za=0);	// CSAt@Cwb_[̏o
	virtual int OutMrec2CsaHeader2(CSDJArchive &ar);			// CSARgL[[h̏o
	virtual int OutMrec2CsaHeader4(CSDJArchive &ar);			// CSA΋ǎ҂̏o
	virtual int OutDB2Csa(CSDJArchive &ar,int za=0);			// CSA`lo(1)
	CDBC();
	CDBC(char *dname);
	~CDBC();
	virtual BOOL CreateDB(void);
	virtual BOOL CreateDB(char *dname);
	virtual BOOL Open(char *dname);
	virtual BOOL Open();
public:
	virtual char *GetDbName();						  // DBC̎擾
	virtual long Write(CBform *pBform);				  // lDBւ̃R[ho^
	virtual int Delete(long recno);					  // lDB̃R[h폜
	virtual int DeleteByDbrno(long recno);            // l߁EEo̍폜
	virtual int ReadByDbrno(long dbrno);              // lԍ(Dbrno)ɂǂݏo
	virtual int Update(CBform *pBform);               // lDB̃R[hXV('03.08.02)

	// ʂ̎擾
	CDSP *GetMdsp(void){return mdsp;}
	C_REC*GetMrec(void){return &m_rec;}
	virtual void set_mdsp(void);		    // \obt@̃Zbg
	void set_mdsp(C_REC *bp, CDSP *pCdsp);  // CDSP̃Zbg

protected:
	// CSAo
	virtual void out_bplay_comment_csa(CSDJArchive &ar, long recno, int tesu); // ,ߏo

	// lca
	virtual void set_dbrno(DBRNO *pdbrno,int tesu);	// DBRNÕZbg
	virtual int ky_matches(B_FORM *bp,CDBD *pDBD,KYINFO *kyp,int *tesu);

	// CSAs̓Ǎ
	virtual int set_player(char *sente,char *gote); // ΋ǎҖ̃Zbg
	virtual int item_check(int ino,char *cp);		// L[ڒl̃`FbN

	virtual int drec_play_set(char *line,int side,long crecno); // D_REC̃R[h`FbNƊDBւ̓o^
	virtual int sasite_comment(int sasite);			// w蒍߂̓o^(sasite=萔)

	virtual int delete_DF(C_REC *crp);				// crpŎw肳ꂽl̊A߂
	// lԍrecnoɊւ钍DB Fscm̃R[hSďB Fscm,DscmQƂB
	virtual void dbf_remove(long recno);
};
#endif // __DBC__
