/////////////////////////////////
// DBD.cpp : implementation file
//                      1996.09 by Ra
//
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include "dbd.h"


CDBD::CDBD()
{
	m_Dscm=NULL;
}
CDBD::CDBD(char *dname)
{
	m_Dscm=NULL;
    Open(dname);
}
CDBD::~CDBD()
{
	if (m_Dscm!=NULL)
		DBD_Close(m_Dscm);
}

// f[^x[X̃N[Y
void CDBD::Close()
{
	if (m_Dscm!=NULL) {
		DBD_Close(m_Dscm);
		m_Dscm=NULL;
	}
}

// f[^x[X̍쐬
BOOL CDBD::CreateD() 
{
	char *dname = GetShgdbName(); // cafBNg̎擾

	return CreateD(dname);
}
// cãZbg
static void SetShgdbD(char *dbname)
{
	int len=strlen(dbname);
	if (len > 0) {
		if (dbname[len-1]!='\\' && dbname[len-1]!='/')
			strcat(dbname,"\\");
	}
	strcat(dbname,"SHGDB_D");
}
////////////////////
// f[^x[X̍쐬
//    dname ̓fBNg
BOOL CDBD::CreateD(char *dname) 
{
	char dbname[512];
	strcpy(dbname,dname);
	SetShgdbD(dbname); // cãZbg

	if (m_Dscm!=NULL) Close();
	if ((m_Dscm=SdbCreate(dbname))!=NULL) {
		DBD_Close(m_Dscm);
	    m_Dscm=NULL;
		return TRUE;
	}
	else {
		char strMes[256];
		sprintf(strMes,"f[^x[X %s ̍쐬Ɏs܂B",dbname);
		AfxMessageBox(strMes);
		return FALSE;
	}
}
// f[^x[X̃I[v
BOOL CDBD::Open()
{
	char *dname = GetShgdbName(); // cafBNg̎擾

	return Open(dname);
}
///////////////////////
// f[^x[X̃I[v
//     dname ͏cafBNg
BOOL CDBD::Open(char *dname)
{
	char dbname[512];
	strcpy(dbname,dname);
	SetShgdbD(dbname); // cãZbg

	if (m_Dscm!=NULL) Close();
	if ((m_Dscm=DBD_Open(dbname))!=NULL)
		return TRUE;
	else {
		char strMes[256];
		sprintf(strMes,"f[^x[X %s ̃I[vɎs܂B",dbname);
		AfxMessageBox(strMes);
		return FALSE;
	}
}

//////////////////////////
// DBւ̎wo^
//
//  @@
//        int recid          : R[h敪 1:΋ 2:l
//        long recno         : R[hԍ(΋ or lDB)
//        B_PLAY bplay       : o^w
//
//  @@߂l(DB_Rc)
//  @@@o^ɐ@ : E$OK(0)
//  @@@o^Ɏs@ : E$NOUTFOUND(10),E$PARA(4)ق
//
//  @@
//       R[h敪recid,R[hԍrecnoƂāADB DscmɎwǉo^
//       BR[ho^ĂȂΐVKo^B
//       f[^x[XXe[^X͊Oϐ int DB_RcɕԂB
int CDBD::WriteBplay(int recid,long recno,B_PLAY bplay)
{
	return DBD_WriteBplay(m_Dscm, recid, recno, bplay);
}

/////////////////////////
// DB̎w폜
//
//  @@
//        int recid          : R[h敪 1:΋ 2:l
//        long recno         : R[hԍ(΋ or lDB)
//        int num            : 폜w̎萔(>=1)
//
//  @@߂l(DB_Rc)
//  @@@폜ɐ@ : E$OK(0)
//  @@@폜Ɏs@ : E$NOUTFOUND(10),E$PARA(4)ق
//
//  @@
//       R[h敪recid,R[hԍrecnoA萔numŎw肳wȍ~̑S
//       ̎w폜Bnum=1w肷ƊYSẴR[h폜B
//       f[^x[XXe[^X͊Oϐ int DB_RcɕԂB
int CDBD::DeleteBplay(int recid,long recno,int num)
{
	return DBD_DeleteBplay(m_Dscm, recid, recno, num);
}

////////////////////////////
// DB̎wǂݏo
//
//      B_PLAY FindBplay(int recid,long recno,int num);
//      B_PLAY NextBplay(void);
//      B_PLAY PrevBplay(void);
//
//  @@
//        int recid          : R[h敪 1:΋ 2:l
//        long recno         : R[hԍ(΋ or lDB)
//        int num            : ǂݏow̎萔(>=1)
//
//  @@߂l(DB_Rc)
//  @@@Ǐoɐ@ : w(B_PLAY)
//  @@@ǏoɎs@ : MSB=1(0xffff)
//
//  @@
//       FindBplay̓R[h敪recid,R[hԍrecnoA萔numŎw肳w
//       ԂBNextBplay͒Oɓǂݏo̎wAPrevBplay͑O̎w
//       ԂBŏIwNextBplayĂяoꍇA邢͐擪w
//       PrevBplayĂяoꍇ0xffffԂB
//       f[^x[Ẍُ̓f[^x[XXe[^X͊Oϐ int DB_RcɕԂB
B_PLAY CDBD::FindBplay(int recid,long recno,int num){
	return DBD_FindBplay(m_Dscm, recid, recno, num);
}
B_PLAY CDBD::NextBplay(void)
{
	return DBD_NextBplay();
}
B_PLAY CDBD::PrevBplay(void)
{
	return DBD_PrevBplay();
}
