/////////////////////////////////
// DBF.cpp : implementation file
//                      1996.09 by Ra
//
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include "dbf.h"

extern void String98Convert(char*cp);

CDBF::CDBF()
{
	m_Fscm=NULL;
}
CDBF::CDBF(char *dname)
{
	m_Fscm=NULL;
    Open(dname);
}
CDBF::~CDBF()
{
	if (m_Fscm!=NULL)
		SdbClose(m_Fscm);
}

// f[^x[X̃N[Y
void CDBF::Close()
{
	if (m_Fscm!=NULL) {
		SdbClose(m_Fscm);
		m_Fscm=NULL;
	}
}

// f[^x[X̍쐬
BOOL CDBF::CreateF() 
{
	char *dname = GetShgdbName(); // cafBNg̎擾

	return CreateF(dname);
}
// cãZbg
static void SetShgdbF(char *dbname)
{
	int len=strlen(dbname);
	if (len > 0 ) {
		if (dbname[len-1]!='\\' && dbname[len-1]!='/')
			strcat(dbname,"\\");
	}
	strcat(dbname,"SHGDB_F");
}
////////////////////
// f[^x[X̍쐬
//    dname ̓fBNg
BOOL CDBF::CreateF(char *dname) 
{
	char dbname[512];
	strcpy(dbname,dname);
	SetShgdbF(dbname); // cãZbg

	if (m_Fscm!=NULL) Close();
	if ((m_Fscm=SdbCreate(dbname))!=NULL) {
		SdbClose(m_Fscm);
	    m_Fscm=NULL;
		return TRUE;
	}
	else {
		char strMes[256];
		sprintf(strMes,"f[^x[X %s ̍쐬Ɏs܂B",dbname);
		AfxMessageBox(strMes);
		return FALSE;
	}
}

// shgdb_f̎擾
char *CDBF::GetFname()
{
	char *dname = GetShgdbName(); // cafBNg̎擾
	static char dbname[512];
	strcpy(dbname,dname);
	SetShgdbF(dbname); // cãZbg

	return dbname;
}
// f[^x[X̃I[v
BOOL CDBF::Open()
{
	char *dname = GetShgdbName(); // cafBNg̎擾

	return Open(dname);
}
///////////////////////
// f[^x[X̃I[v
//     dname ͏cafBNg
BOOL CDBF::Open(char *dname)
{
	char dbname[512];
	strcpy(dbname,dname);
	SetShgdbF(dbname); // cãZbg

	if (m_Fscm!=NULL) Close();
	if ((m_Fscm=SdbOpen(dbname))!=NULL)
		return TRUE;
	else {
		char strMes[256];
		sprintf(strMes,"f[^x[X %s ̃I[vɎs܂B",dbname);
		AfxMessageBox(strMes);
		return FALSE;
	}
}

///////////////////////////
// DBւ̒ߕ̓o^
//
//		int CDBF::Write(int cid,char *ckey,char *text);
//
//  @@
//        int cid            : ߋ敪 1:ǖ 2:Վ 3:΋ 4:l
//        char *ckey         : ߃L[ 
//        char *text         : ߕ
//
//  @@߂l(DB_Rc)
//  @@@o^ɐ@ : E$OK(0)
//  @@@o^Ɏs@ : E$NOTFOUND(10),E$PARA(4)ق
//
//  @@
//       ߋ敪cid,߃L[ckeyƂĒDB DBFɒߕtextVKo^B
//       R[hɓo^ĂΏdG[ƂB
//       f[^x[XXe[^X͊Oϐ int DB_RcɕԂB
int CDBF::Write(int cid,char *ckey,char *text)
{
	return DBF_Write(m_Fscm,cid,ckey,text);
}

////////////////////////
// DB̒ߕ폜
//
//      int CDBF::Delete(int cid,char *ckey)
//
//  @@
//        int cid            : ߋ敪 1:ǖ 2:Վ 3:΋ 4:l
//        char *ckey         : ߃L[ 
//
//  @@߂l(DB_Rc)
//  @@@폜ɐ@ : E$OK(0)
//  @@@폜Ɏs@ : E$NOUTFOUND(10),E$PARA(4)ق
//
//  @@
//       ߋ敪cid,߃L[ckeyŎw肳钍ߕ̑SĂ폜B
//       f[^x[XXe[^X͊Oϐ int DB_RcɕԂB
int CDBF::Delete(int cid,char *ckey)
{
	return DBF_Delete(m_Fscm,cid,ckey);
}

////////////////////////////
// DB̒ߕǂݏo
//
//      char *CDBF::Read(int cid,char *ckey); // ǂݏo  
//      void CDBF::Free(char *text);          // ̉
//
//  @@
//        int cid            : ߋ敪 1:ǖ 2:Վ 3:΋ 4:l
//        char *ckey         : ߃L[ 
//
//  @@߂l(char *)
//  @@@Ǐoɐ@ : ߕւ̃|C^(!=NULL)
//  @@  ߕo^Ȃ@ : NULL
//
//  @@
//        DBF_Read͒ߋ敪cid,߃L[ckeyŎw肳钍ߕǂݏoA
//        ւ̕|C^ԂBo^܂̓sȂNULLԂB
//        o^sDB_RcŔʂB擾|C^͌Ăяo
//        ̐ӔCDBF_Freeŉ邱ƁB
char *CDBF::Read(int cid,char *ckey)
{
	char *cp=DBF_Read(m_Fscm,cid,ckey);
	if (cp==NULL)
		return NULL;

	String98Convert(cp); // 98̕ϊ

	return cp;
}
void CDBF::Free(char *text)
{
	DBF_Free(text);
}
