//////////////////////
// 
// CDBE class
//                      1996.09 by Ra
#ifndef __DBE__
#define __DBE__

#include "bform.h"
extern "C" {
#include <shgdb.h>
}

#include "dba.h"
#include "dbf.h"
#include "sdjarchive.h"

/* ՃXgNX */
class PNET {
public:
    CBform Bform;
    long hash_s;
    int reverse;
    short eval;
    B_PLAY bplay;
    short  attr;
    PNET *next;
};

class CJBase;
class CDBE: public CDBA
{
protected:
	CDBF DBF;
    SCM_t *m_Escm;
protected:
public:
	void CommentWriteEnable(BOOL bComment){m_bComment=bComment;}
	void DetailDispEnable(BOOL bDetail){m_bDetail=bDetail;}
	CDBF *GetDBF(){return &DBF;}
	BOOL GetBcomRead(CBform *bp,int side,B_PLAY bplay,CString *cstr,CString *str);
	BOOL GetKcomRead(CBform *bp,int side,CString *cstr,CString *str);
	int GetHsBplay(CBform *bp,int side,B_PLAY bplay,long *hash_sp,B_PLAY *bplayp);
	int GetHs(CBform *bp,int side,long *hash_sp,int *revp);
	CDBE();
	CDBE(char *dname);
	~CDBE();
	virtual BOOL CreateE(void);
	virtual BOOL CreateE(char *dname);
	virtual BOOL Open(void);
	virtual BOOL Open(char *dname);
	virtual void Close(void);
public:
	SCM_t *GetEscm(){return m_Escm;}                  // SCM_t ̎擾

	// DBւ̒Ջǖʂ̓o^
	int Write(CBform *pBform,int side,short eval,long *hash_s,int *reverse);
	// DBւ̒Վ̓o^
	int WriteBplay(CBform *pBform,B_PLAY bplay,short attr);
	// DB̒Վ폜
	int DeleteBplay(CBform *pBform,B_PLAY bplay);
	// DB̋ǖʍ폜
	int Delete(CBform *pBform,int side);

	// DB̃R[ȟ
	int FindRead (long hash_s,int side,E_REC *pErec);
	int NextRead (E_REC *pErec);

	// DB̒Վ̌
	int FindBplay(CBform *pBform,int side,short *eval,B_PLAY *bplay,short *attr);
	int NextBplay(short *eval,B_PLAY *bplay,short *attr);

	// DB̌`]l̍XV
	int UpdateEval(CBform *pBform,int side,short eval);

	// DB̒Վ̍XV
	int UpdateBplay(CBform *pBform,int side,B_PLAY bplay,short attr);

	// DB̋ǖHSnbVl̃`FbN(FindBplay-NextBplayԈȊO)
	int HSCheck(CBform *pBform,int side,long *hs,long *hsr,CBform *pBformr);

	// DB̋ǖHSnbVl̃`FbN(FindBplay-NextBplayԐp)
	int HSCheck2(CBform *pBform,long *hs,long *hsr);

	void SetQuitObject(HANDLE h){h_quit=h;}           // fIuWFNg̐ݒ
	void SetMessageWindow(CWnd *pWnd){m_pMesWnd=pWnd;} // bZ[W\Window̐ݒ
	void PrintMessage(char *StringBuffer);
	// ՂCSAt@Co^
	int InCsa2DBE(CSDJArchive &ar,int geval,int gattr,int tsn,long *nsum);
	// ՂCSAt@Co
	long OutDBE2Csa(CSDJArchive &ar,CBform *bp,int side,int depth);
	// ՂCSAj^o
	long DispDBE2Csa(CBform *bp,int side,int depth);
	// Ղ̍폜&CSAt@Co
	long DelDBE2Csa(CSDJArchive &ar,CBform *bp,int side,int depth);
	// Ղ̓o^
	BOOL WriteJS(CBform *bp,int side,B_PLAY bplay,int eval,int attr);
	// Ղ̍폜
	BOOL DeleteJS(CBform *bp,int side,B_PLAY bplay);

private:
	BOOL m_bDetail;		// Փo^󋵂̏ڍו\(ftHgTRUE)
	BOOL m_bComment;    // ߂̓o^s(ftHgFALSE)
	char *line;
	int plno,pflag;          /* csa`pԃtO */
	char *comment;
	char *comment2;
	int   rcsiz;             /* ߕ̈̃TCY */
	B_PLAY bplay2;           /* ċAIɎgpȂϐ */
	CWnd *m_pMesWnd;         // bZ[W\Window
	CJBase *m_pJBase;        // x[X
	char kif[40];            // `\L
	HANDLE h_quit;			 // fIuWFNgnh
	long	ssum;
	CBform Bform2;           /* Ɨp B` */
	CBform Bform;            /* ʗp B ` */
	int bside;               /*  //=0/1/-1 */
	int Geval;				 // `]l̃ftHgl
	int Gattr;				 // Վ葮l̃ftHgl

	char *get_line(CSDJArchive &ar); /* s */
	int P_line(CBform *pBform,char *line); /* zu */
	int PISet(char *line,CBform *pBform);
	int PsingleSet(char *line,CBform *pBform,int *flag);
	int Pall(char *line,CBform *pBform,int *flag,int *plp);
	int get_bform2(CSDJArchive &ar,CBform *pBform,int *sdp,int *eval);
	int realloc_comment(char *cp,int lf);
	int get_bplay(CSDJArchive &ar,CBform *pBform,int side,B_PLAY *bplay,short *attr);
	int get_csa(CSDJArchive &ar);
	int write_bplay(CSDJArchive &ar,CBform *pBform,int side,int depth,int tn);

	long pnetnum;
	unsigned long *amap[2];
	int nlist;
	int eval2;

	void out_bform_csa(CSDJArchive &ar, CBform *pBform,int side);
	void out_bform_comment_csa(CSDJArchive &ar,long hash_s,int side);
	int out_bplay_comment_csa(CSDJArchive &ar,long hash_s,B_PLAY bplay,int tn);
	void out_eval_csa(CSDJArchive &ar,PNET *pp);
	void relpnet(PNET *pp);
	int getpnet(CBform *bp,int side,PNET **pnp);
	void out_bplay_csa(CSDJArchive &ar,CBform *pBform, B_PLAY bplay);
	BOOL CreateAmap();
	void FreeAmap();
	int amap_check(long hash_s,int side);
	int out_list_csa(CSDJArchive &ar,CBform *bp,int side,int depth,int tn);

	void disp_bform_csa(CBform *pBform,int side);
	void disp_bform_comment_csa(long hash_s,int side);
	int disp_bplay_comment_csa(long hash_s,B_PLAY bplay,int tn);
	void disp_eval_csa(PNET *pp);
	void disp_bplay_csa(CBform *pBform, B_PLAY bplay);
	int disp_list_csa(CBform *bp,int side,int depth,int tn);

	int delete_bplay(CBform *bp,int side,long hash_s,B_PLAY bplay);
	int remove_list(CSDJArchive &ar,CBform *bp,int side,int depth,int tn);
};
#endif // __DBE__

