/////////////////////////////////
// DBM.cpp : implementation file
//                      1997.09 by Ra
//
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include "dbm.h"
#include <sbase.h>

// ID_PRINT_MESSAGE𓾂邽resource.hincludeB
#include "resource.h"

#include <mbstring.h>
extern "C" {
	long CvDecL(char *asc,int leng);
	int  CvDecI(char *asc,int leng);
}

/* ʊO֐錾 */
extern "C" {
extern int DB_Rc;
void *memalloc(unsigned int);
void memfree(void *);
}


IMPLEMENT_SERIAL(CDBM, CDBA, 0 /* Schema number */ )


////
// m_rec̏(dummy)
void CDBM::mrec_init()
{
	TRACE("mrec_init dummy_func called\n");
}

// ʏ
void CDBM::common_init()
{
	// 
	m_Mscm=NULL;
	m_dbname=NULL;
	m_pComment=NULL;
	rec_buffer=NULL;
	Mtab=NULL; // added by Ver.5.2 '03.07

	// @@ added by Ver.5.2 '03.07
	sql_text=NULL;
	select_from=NULL;

	rn=0;           // 
	resp=NULL;      // t@CQƍ\
	rfp=NULL;       // t@C
	order_by=-1;    // SQLorder byw(0/L1)̏l
    sql=NULL;	    // zBorder by w肪ȂɎgp
    rdb=NULL;		// RDB \́B  
	h_quit=NULL;    // fIuWFNg

	line=NULL;
	comment=NULL;
	rcsiz=0;
}

CDBM::CDBM()
{
	common_init();
}


CDBM::CDBM(char *dname)
{
	common_init();
    Open(dname);
}
CDBM::~CDBM()
{
	if (m_Mscm!=NULL)
		SdbClose(m_Mscm);
	if (m_dbname)
		memfree(m_dbname);
	if (comment)
		memfree(comment);
	if (m_pComment)
		DBF.Free(m_pComment);
	if (Mtab!=NULL)
		memfree(Mtab);
	// added by Ver.5.2 '03.7
	if (sql_text!=NULL)
		memfree(sql_text);
	if (select_from!=NULL)
		memfree(select_from);
}


// f[^x[X̍쐬
BOOL CDBM::CreateDB() 
{
	TRACE("CreateDB() dummy_func called\n");
	return FALSE;
}

///////////////////
// f[^x[X̍쐬(dummy)
//     dname ͏cafBNg
BOOL CDBM::CreateDB(char *dname) 
{
	TRACE("CreateDB(char *dname) dummy_func called\n");
	return FALSE;
}

// f[^x[X̃N[Y
void CDBM::Close()
{
	if (m_Mscm!=NULL) {
		SdbClose(m_Mscm);
		m_Mscm=NULL;
	}

	CDBA::Close(); // NX
}

// f[^x[X̃I[v(dummy)
BOOL CDBM::Open()
{
	TRACE("Open() dummy_func called\n");
	return FALSE;
}

// f[^x[X̃I[v(dummy)
BOOL CDBM::Open(char *dname)
{
	TRACE("Open(char *dname) dummy_func called\n");
	return FALSE;
}

// VACY
void CDBM::Serialize(CArchive& ar)
{
	if (ar.IsStoring()) { // ۑ
		m_rc=OutMrec2Csa((CSDJArchive &)ar);  // m_rec̏ۑ
	}
	else { // Ǎ
		m_rc=InCsa2Mrec((CSDJArchive &)ar);   // m_rec̏𕜌
	}
}



/////////////
// DB̎擾(dummy)
//  ϐ SHGDBA
//  m_dbnameDBBݒ肵Am_dbnameւ̃|C^ԂB
char *CDBM::GetDbName()
{
	TRACE("GetDbName dummy_func called\n");

	return NULL;
}


//////////////////
// õR[ho^(dummy)
//@@
//      CBform *pBform     : ՖB`
//      int side           : Ֆʎ 0: 1:葤
//
//@@߂l
//@@@o^ɐ@ : ΋ǔԍ(DB_Bf[^t@CR[hԍ)(>=0L)
//@@@o^Ɏs@ : ̒l(-1L)
//
long CDBM::Write(CBform *pBform,int side)
{
	TRACE("Write dummy_func called\n");
	return -1L;
}

////////////////////
// oDB̑΋Ǎ폜
//
//@@
//      long recno         : ΋DB̑΋ǔԍ(R[hԍ)
//
//@@߂l (DB_Rc)
//@@@폜ɐ@ : E$OK(0)
//@@@폜Ɏs@ : E$NOTFOUND(10)ق
//
int CDBM::Delete(long recno)
{
	TRACE("Delete dummy_func called\n");
	return 0;
}

////////////////////////
// ocǎoEE߂폜B
//    ocãR[hԍrecnoŎw肳΋Ǌ
//    (oAA)폜B
//    int recid :   1: ΋ǂca   2:lca
//
//@@߂l (DB_Rc)
//@@@폜ɐ@ : E$OK(0)
//@@@폜Ɏs@ : E$NOTFOUND(10)ق
int CDBM::DeleteByDbrno(long recno)
{
	TRACE("DeleteByDbrno dummy_func called\n");
	return 0;
}
int CDBM::DeleteByDbrno(long recno,int recid)
{
    int rc;
	char StringBuffer[256];

	// l(recid=2)̎PCLt@CB
	if (recid==2) { // l̎
		C_REC c_rec;
		// recnoɊY錩oR[hǂށB
		int rc=SdbDrRead(GetScm(),recno,(char *)c_rec.buffer);
		if (rc==E$OK) {
			CString strPclFile; // PCLt@C
			long hash_s=CvDecL(c_rec.row.hash_s,sizeof c_rec.row.hash_s);
			strPclFile.Format("%spcl\\%08ld.pcl",GetShgdbName(),hash_s);
			CFile f; CFileStatus fs;
			if (f.GetStatus(strPclFile,fs)) { // PCLt@C݂
				f.Remove(strPclFile);		  // B
			}
		}
	}

    /* b_recnoɊY钍DB̃R[hB*/
    dbf_remove(recno);

    /* DB̏ */
    rc=DBD.DeleteBplay(recid,recno,1);
    if (rc!=E$OK && rc!=E$NOTFOUND) {
        sprintf(StringBuffer,"DB폜ł܂(%d,recno=%06ld)B",rc,recno);
		AfxMessageBox(StringBuffer);
        goto exit;
    }
    /* oDB̏ */
	rc=Delete(recno);
    if (rc!=E$OK && rc!=E$NOTFOUND) {
        sprintf(StringBuffer,"oR[h폜ł܂(%d,recno=%06ld)B",rc,recno);
		AfxMessageBox(StringBuffer);
        goto exit;
    }

  exit:
    return rc;
}


/*
 * \obt@̃Zbg
 */
void CDBM::set_mdsp()
{
	TRACE("set_mdsp dummy_func called\n");
}

/*
 * ̃Zbg
 *   (strSql)ǂsql_textSQLwhere߂allocB
 *   rc=0; I !=0:ُI
 */
int CDBM::sql_cond(char *strSql, int *order_by)
{
    int rc=1;
    char *cp1,*cp2,*cp;
    long leng;
    char *cond_o=NULL;
    char *cond;

    leng=strlen(strSql);

    /* obt@ */
    if ((cond=cond_o=(char *)memalloc((unsigned int)leng+1))==NULL) {
		AfxMessageBox("NO Memory"); goto exit;
    }

	memset(cond_o,0,leng+1); // 0 Clear

    if (leng!=0) {
        /* RgȂ] */
		BOOL bCom=FALSE;
		cp1=strSql;
		for (cp2=cond_o; *cp1 != '\0';cp1++) {
			if (bCom) {
				if (*cp1 == '\n') // s܂œǂݔ΂
					bCom=FALSE;
			}
			else {
				if (*cp1 == '#') // shift jis 2oCgڂɂȂ
					bCom=TRUE;
				else {
					*cp2 = *cp1; // Lȕ
				    cp2++;
				}
			}
		}
    }


    /* 猟̕ҏW */
    cond=cond+strspn(cond," \t"); /* 擪̃uN,TAB */

    /* order by w肪 */
    if ((cp1=strstr(cond,"order by"))!=NULL || 
        (cp2=strstr(cond,"ORDER BY"))!=NULL) {
        *order_by=1;             /* ORDER BY wL */
        if (cp1!=NULL) cp=cp1;  /* order bycpɋL */
        else cp=cp2;
    }
    else {
        *order_by=0;             /* ORDER BY wȂ */
        cp=NULL;
    }

    if (sql_text!=NULL) memfree(sql_text); /* Â̈̉ */
    if ((sql_text=(char *)memalloc(strlen(cond)+7))==NULL) {
		AfxMessageBox("NO Memory");
		*order_by=-1; // lɖ߂
		goto exit;
    }

    /* where߈ȉSQLsql_textɃZbgB*/
    if (cp!=cond && strlen(cond)!=0)
        /* condɉorder by擪ɂȂwhere߂Kv */
        sprintf(sql_text,"where %s",cond);
    else
        sprintf(sql_text,"%s",cond);

    rc=0;
  exit:
    if (cond_o!=NULL)
		memfree(cond_o);
    return rc;
}

/* select_from ̐(order_by!=0Ȃwhereߕt) */
int CDBM::mk_select_from(int order_by)
{
    int len;
    int rc=1;

	// DB̂̎擾(SHGDB_B or SHGDB_C)
	// ],JgfBNgfBNgɂ邱ƂOƂȂB
	// ȂƁApXɃuN܂ނcaɃANZXłȂȂB
	// (RFselect from ̉͂ł' '؂qƂĈB)
	char *shgdb_b=GetDbName();

    if (select_from!=NULL) {
		memfree(select_from); /* ̈̉ */
		select_from=NULL;
	}

    if (order_by!=0) {
        /* select_from̐  "select * from shgdb_b where..." B */
        len=strlen(shgdb_b)+strlen(sql_text)+16;
        if ((select_from=(char *)memalloc(len))==NULL) {
			AfxMessageBox("No Memory"); goto exit; 
        }
        sprintf(select_from,"select * from %s %s",shgdb_b,sql_text);
    }
    else {
        /* select_from̐  "select * from shgdb_b" B */
        len=strlen(shgdb_b)+15;
        if ((select_from=(char *)memalloc(len))==NULL) {
			AfxMessageBox("No Memory"); goto exit; 
        }
        sprintf(select_from,"select * from %s",shgdb_b);
    }

    rc=0;
  exit:
    return rc;
}

////////////
//  Helper procedure
/////////////
////////
//  Տ̋Ֆ(ban)WJ
//    ʒu 11~99ɑΉ  side(0/1),km(0~7),nr(0/1)̏ɃrbgWJB
static struct {
    int sid;
    int num;
} KN[8]={{0,2},{2,2},{4,2},{6,4},{10,4},{14,4},{18,4},{22,18}};
static void to_ban(unsigned int ukm[40], // KꂽՖʓWJz
				   int ban[100])      // Ֆʏ
{
	int i,k;
	int nr,pos,side;

	memset(ban,-1,sizeof(int)*100); // -1 NA
	for (k=0;k<8;k++) {
		for (i=KN[k].sid;i<KN[k].sid+KN[k].num;i++) {
			pos=(ukm[i]>>1) & 0x7f;
			if (pos >= 11 && pos <= 99) { // Տɂ
				side= ukm[i] & 1;
				nr  = ukm[i] >> 8;
				ban[pos]=(side<<4)+(k<<1)+nr;
			}
		}
	}
}


/////////////////////////
// ΋ǂca
//    SQL(strSql)͂āAΏۂƂȂŏ̌R[hԂB
//    ΋ǂcãI[vƃN[Y͌Ăяoő삷Kv͂ȂB
//    <order byL̏ꍇ>
//    ϐ SHGDB̃f[^x[X FindFirst()łca̓I[vA
//    ʂtmpfileɊi[Aca̓N[YB
//    tmpfileFindNext()Not found܂œǂݏoꂽ_A܂
//    FindFirst()Ăяoꂽ_ŃN[XB
//    <order by̏ꍇ>
//    {Iɂ͏ƓlAtmpfile͎gpAFindNext()̓sx
//    sB
//
//    (f)IFindExit();
//
//	 ߂l
//		1: ɍv郌R[hǂݏo()
//		0: ɍvȂR[hǂݏo()
//	   -1: R[hNot found (Ȃ)( f)
//     -2: ǂݏoُ
//
int CDBM::FindFirst(char *strSql, KYINFO *kyinfo)
{
	int rc;
	CBform Bform;

	// ̉(where)
	if ((rc=sql_cond(strSql,&order_by))!=0) {
		rc=-2;
		goto exit;
	}
	// select from̐
	if ((rc=mk_select_from(order_by))!=0) {
		rc=-2;
		goto exit;
	}

    // ǖʈv̐ݒ`FbN
    if (kyinfo->match!=0 && order_by!=0) {
        AfxMessageBox("'order by' w肪Ɓuǖʎwv͖ł");
    }

	// ǖʎw肠Ȃ猟邽߂ɓWJǖʂB
	if (kyinfo->match!=0) {
		Bform.ImportFrom(kyinfo->uiUkm);
		Bform.ExportTo(rukm1);  // ukm\[gēWJB
		side1=kyinfo->teban;
		if (kyinfo->match==2)	// ՏvȂ
			to_ban(rukm1,ban1); // ՖʏWJĂ

		if (kyinfo->rev) { // ɔ]Ȃ
			Bform.ReverseBform(); // ]WJzpӂĂB
			Bform.ExportTo(rukm2);
			side2=side1;
			if (side2==SIDE_A || side2==SIDE_B)
				side2=side2^1;
			if (kyinfo->match==2)   // ՏvȂ
				to_ban(rukm2,ban2); // ՖʏWJĂ
		}
	}

	if (order_by) { // order_by w肠
		rc=cmd_ls_orderby_1st();
	}
	else {			// order_by wȂ
		rc=cmd_ls_1st(kyinfo);
	}

exit:
	return rc;
}
int CDBM::FindNext(KYINFO *kyinfo)
{
	int rc;
	if (order_by) {
		rc=cmd_ls_orderby_2nd();
	}
	else {
		rc=cmd_ls_2nd(kyinfo);
	}

	return rc;
}
void CDBM::FindExit(KYINFO *kyinfo)
{
	if (order_by<0)
		return;

	if (order_by)
		cmd_ls_orderby_exit();
	else
		cmd_ls_exit(kyinfo);
}

/*
 *  R}h(order by L)
 */
// BDSP̏tesuDBRNOɃZbg(G֐)(dummy)
void CDBM::set_dbrno(DBRNO *pdbrno,int tesu)
{
	TRACE("set_dbrno dummy_func called\n");
}
int CDBM::cmd_ls_orderby_1st(void)
{
    int rc=-2;

	/* t@C̃I[v */
    if (rfp!=NULL)
		fclose(rfp); /* e|t@C̃N[Y()(Öׂ) */
    if ((rfp=tmpfile())==NULL) {
		AfxMessageBox("e|t@C̃I[vɎs܂B");
        goto exit;
    }

	rn=0; // R[h

    /* ̎s */
    if (resp!=NULL)
		SqlFreeResp(resp); /* t@CQƍ\̂̉(Ö) */
    if ((resp=SqlSelectFrom(select_from,rfp))==NULL) {
		AfxMessageBox("ԈĂ܂B");
        goto exit;
    }

    /* ʂ̏o */
    fseek(rfp,0L,SEEK_SET); /* t@C̓ */

	rc=cmd_ls_orderby_2nd(); // ʂ̓ǂݏo
exit:
    return rc;
}

// ʂ̓ǂݏo
int CDBM::cmd_ls_orderby_2nd(void)
{
    int rc=-2;

	if (resp==NULL)
		goto exit;

	if (rn < REC_NUM(resp)) {
		if (fread(rec_buffer,1,REC_LEN(resp),rfp)-REC_LEN(resp)) {
			AfxMessageBox("e|t@C̓ǂݏoɎs܂B");
			goto exit;
		}
		rn++;
		rc=1;
		set_mdsp();			   // m_rec̏BDSPփZbg(񏈗̈)
        set_dbrno(&m_Dbrno,0); // BDSP̏m_DbrnoփZbg
	}
	else { // not found & end
		rc=-1;
	}
  exit:
    return rc;
}

/*
 *  R}h(order by Ȃ)
 */
int CDBM::cmd_ls_1st(KYINFO *kyinfo)
{
    int rc=-2;
	  
    if ((rdb=RdbOpen(select_from,0))==NULL) { /* RDB OPEN */
		CString strMes;
		strMes.Format("f[^x[X̃I[vɎs܂\r\n(%s)",
			select_from);
		AfxMessageBox(strMes);
        goto exit;
    }

    if ((sql=RdbGetSqlToken(rdb,sql_text))==NULL) { /* z̎擾 */
		AfxMessageBox("ԈĂ܂");
        goto exit;
    }

    /* ǖʈv̓ǂݏo */
    if (kyinfo->match!=0) {
		if (DBD.Open()==FALSE) {  /* DB̃I[v */
            goto exit;
        }
		if (CDBA::Open()==FALSE) { /* ՖDB̃I[v */
            goto exit;
        }
    }

	rn=0; // R[h
    hash_s1=-1L;    /* ՖDB HS nbVl(Ֆʂ̋L)Zbg */

    /* 擪sǂݍŔ肷B*/
    if ((rc=RdbFindRead(sql,rec_buffer))==E$OK) /* 擪s */
		rc=cmd_ls_judge(kyinfo); // ǂݏos̔
	else {
		if (rc==E$NOTFOUND)
			rc=-1; // I
		else
			rc=-2; // ُI
	}
exit:
	return rc;
}

int CDBM::cmd_ls_2nd(KYINFO *kyinfo)
{
	int rc;

    /* sǂݍŔ肷B*/
	if ((rc=RdbNextRead(rec_buffer))==E$OK) /* ̍s */
		rc=cmd_ls_judge(kyinfo); // ǂݏos̔
	else {
		if (rc==E$NOTFOUND)
			rc=-1; // I
		else
			rc=-2; // ُI
	}
	return rc;
}

////
// šʂ𔻒肷
//   CDBM̒ǑʂkyinfȍƍvĂ邩B
//   DBAǂݏoB
//  ߂l rc  -2: DBAǂݏoُ 
//             -1: f
//              0: s͏ɈvȂ 
//              1: s͏Ɉv
int CDBM::cmd_ls_judge(KYINFO *kyinfo)
{
	int rc=0; // l͍s͏ɈvȂ
	int tesu;

	// fCxg̃`FbN
	if (h_quit) {
		if (WaitForSingleObject(h_quit,0)==WAIT_OBJECT_0) {
			rc=-1;
			goto exit; // fI
		}
	}

	if (kyinfo->match==0) {  /* ǖʈvwȂ */
		set_mdsp();	   		   // m_rec̏BDSPփZbg(񏈗̈)
		set_dbrno(&m_Dbrno,0); // BDSP̏m_DbrnoփZbg
		rc=1; // ɈvB
        rn++;
	}
	else {
		/* HS nbVľvZ */
		hash_s=get_mrec_hash_s();

		/* ǖʂbform ̓ǂݏo */
		if (hash_s1!=hash_s) { // ǖʂĂ()
			if (HSread(hash_s)!=E$OK) {
				AfxMessageBox("f[^x[X(SHGDB_A)̓ǂݏoɎs܂");
				rc=-2; // ُ
				goto exit;
			}
			hash_s1=hash_s;     /* HS nbVl̋L */
		}

		/* ǖʈvƍ */
		if (ky_matches(&a_rec.row.bform,&DBD,kyinfo,&tesu)) {
			set_mdsp();				  // m_rec̏BDSPփZbg(񏈗̈)
			set_dbrno(&m_Dbrno,tesu); // BDSP̏m_DbrnoփZbg
			rc=1; // Ɉv
			rn++;
		}
	}
exit:
	return rc;
}

/////
// ǖʂ̈vƍB
//    ̋ǖʂ͐KWJςł邱ƁB
//    ߂l  !=0:v    0:sv
/////
static int cmp_kyokumen(unsigned int nukm[40],int nside, // ݂̋ǖ
						unsigned int cukm[40],int cside) // ̋ǖ
{
	int cmp;

	// 悸Ԃ`FbNB
	if (cside==SIDE_A || cside==SIDE_B) { // Ԃ̔Kv
		if (nside != cside) {
			cmp=0;
			goto exit; // ԂႤ
		}
	}
	// ǖʂ̔r
	cmp=!memcmp(nukm,cukm,sizeof(unsigned int)*40);
exit:
	return cmp;
}

/////
// Տ̈vƍ
//   ߂l  !=0: v    0:sv
// {擪id,}
static int cmp_ban(int nban[100],int nside,  // ݂̔Ֆ
				   int cban[100],int cside)  // ̔Ֆ
{
	int cmp=1; // ߂l̏l͈v
	int i;

	// 悸Ԃ`FbNB
	if (cside==SIDE_A || cside==SIDE_B) { // Ԃ̔Kv
		if (nside != cside) {
			cmp=0;
			goto exit; // ԂႤ
		}
	}
	// Ֆʂ̔r
	for (i=11;i<=99;i++) {
		if (cban[i]!=-1) { // Ֆʂɋ΁A
			if (nban[i]!=cban[i]) {
				cmp=0;  
				goto exit; // ͓̋ȂΕsv
			}
		}
	}
exit:
	return cmp;
}

///////
//  ǖʂƍB
//     v KYINFO *kyp,rUkm,rsideɁAǖCBform*pBform,sidev邩肷B
//     ߂l   0; vȂB  !=0: vB
//        Ԃ͕słȂΈv𔻒肷B
int CDBM::ky_shogo(KYINFO *kyp, unsigned int *nowUkm,int side)
{
	int nowBan[100];
	int cmp=0; // ߂l

	if (kyp->match==1) { // ǖʈvȂ
		cmp=cmp_kyokumen(nowUkm,side,rukm1,side1); // ƍ
		if (cmp==0 && kyp->rev!=0) // vA]Ȃ
			cmp=cmp_kyokumen(nowUkm,side, rukm2,side2);
	}
	else if (kyp->match==2) {  // ՏvȂ
		to_ban(nowUkm,nowBan); // ݂̋ǖʂ̔ՖʏWJ
		cmp=cmp_ban(nowBan,side,ban1,side1); // ƍ
		if (cmp==0 && kyp->rev!=0)   // vA]Ȃ
			cmp=cmp_ban(nowBan,side,ban2,side2);
	}
	return cmp;
}

/// R[h񂩂烌R[hԍƎԂ擾(dummy)
int  CDBM::get_mrec_side()
{
	TRACE("get_mrec_side dummy_func called\n");
	return -1;
}

//////////
// ǖʂ̈v`FbNB
//   KYINFO ɋǖʈvw肪΁ADB(Dscm)KYINFOɏ]ČA
//   vǖʂ邩ۂ߂lŕԂBvǖʂ鎞 *tesu
//   ɂ̎萔ڂo͂BKYINFO ɋǖʈvw肪Ȃ ߂l 1A
//   tesu=0 ԂBbp͏ǖʂw肷B
//   int recid: 1:΋ǂca  2:lca
//   
int CDBM::ky_matches(B_FORM *bp,CDBD *pDBD,KYINFO *kyp,int *tesu)
{
	TRACE("ky_matches dummy_func called\n");
	return 1;
}
int CDBM::ky_matches(B_FORM *bp,CDBD *pDBD,KYINFO *kyp,int *tesu,int recid)
{
    int matches=0;   // ƍ
    long recno;
    B_PLAY bplay;
    CBform Bform;
	unsigned int nUkm[40];
	int side;

    ///////////
	// O
	///////////
    *tesu=0;
    /* ǖʐݒȂȂI(߂ĺuvv) */
    if (kyp->match==0) {
        matches=1; goto exit;
    }

	/* oR[hԍ & Ԏ擾 */	
	recno=get_mrec_recno();
	side=get_mrec_side();

    /* ǖB`ƎԂ̐ݒ */
	memcpy(&Bform.bform,bp,sizeof(B_FORM)); /* ǖ */
	Bform.ExportTo(nUkm); // ǖʓWJ(ukm)

    /* Jnǖʂ̓ */
    bplay=pDBD->FindBplay(recid,recno,1); /* ǂݏo */
	// stesu͉ʂ̐ݒʂA1`画-1B
    while (bplay!=0xffff && *tesu < kyp->stesu-1) {
        /* ǖʂi߂ */
        Bform.ForwardUkm(nUkm,bplay);   /* B `(ukm)XV */
        side^=1;                /* Ԍ */
        (*tesu)++;
        bplay=pDBD->NextBplay();     /* ̎ǂݏo */
    }

	//////////
    // {
	//////////
    /* ǖʔJn w肪NOT FOUNDA萔͈͂܂ŌIB 
	 * )
     * Jnǖ -> 1 -> 1ǖ -> 2 -> 2ǖ... 
     * n萔͈͂Ƃnǖʂ܂łΏۂƂȂB] n+1 ǖʂB
	 */
    /* Jnǖʂ̏ƍ */
    /*  v KYINFO *kyp,rUkm,rside ɁAǖBform,sideƍB*/
    if (ky_shogo(kyp,nUkm,side)) {
		matches=1;   /* v */
		goto exit;
    }
    while (*tesu < kyp->stesu+kyp->tesu &&	bplay!=0xffff ) {
		/* vȂAǖʂi߂ */
		Bform.ForwardUkm(nUkm,bplay);   /* B `XV */
		side^=1;                /* Ԍ */
		(*tesu)++;

        /* ǖʂ̏ƍ */
        if (ky_shogo(kyp,nUkm,side)) {
            matches=1; break;   /* v */
        }
		bplay=DBD_NextBplay();     /* ̎ǂݏo */
    }

exit:
	return matches;
}


////////////////
// ̒f
//   𒆒f炱̊֐ŌnB
void CDBM::cmd_ls_orderby_exit(void)
{
	if (rfp!=NULL) {
		fclose(rfp); /* e|t@C̃N[Y() */
		rfp=NULL;
	}
	if (resp!=NULL) {
		SqlFreeResp(resp); /* t@CQƍ\̂̉ */
		resp=NULL;
	}
}
void CDBM::cmd_ls_exit(KYINFO *kyinfo)
{
	if (sql!=NULL) {
		RdbRelSqlToken(sql);    /* z̉ */
		sql=NULL;
	}
	if (rdb!=NULL) {
		RdbClose(rdb);          /* RDB̃N[Y */
		rdb=NULL;
	}
	if (kyinfo->match!=0) {
		DBD.Close();         /* DB̃N[Y */
		CDBA::Close();         /* ՖDB̃N[Y */
	}
}

// õR[hԍ擾(dummy)
char *CDBM::get_mdsp_strrecno()
{
	TRACE("get_mdsp_strrecno dummy_func called\n");
	return NULL;
}

// ΋ǔԍ(dbrno)ɂǂݏoB
//  I[vĂȂ΂ȂȂB
//  SdbDrReaďʂԂ
//  set_mdsp()Ă
//  int recid  3:΋ǂca  4:lca
int CDBM::ReadByDbrno(long dbrno)
{
	TRACE("ReadByDbrno dummy_func called\n");
    return -1;
}
int CDBM::ReadByDbrno(long dbrno,int recid)
{
	ASSERT(GetScm()); // Open Check
	// DBRNOɊY΋ǃR[hǂށB
	int rc=SdbDrRead(GetScm(),dbrno,rec_buffer);
	if (rc!=E$OK)
		return rc;
	set_mdsp();  // ΋ǃR[h\obt@̐ݒ
	set_dbrno(&m_Dbrno,0);

	BOOL bDbfopen=FALSE;
	if (DBF.GetFscm()==NULL) { // ߂caI[vĂȂ΃I[vB
		if (!DBF.Open())
			return DB_Rc; // ߂caI[vs
		else
			bDbfopen=TRUE; // ̃[`DBFI[vB
	}

	// ɑ΋ǒ߂ǂ܂ĂB
	if (m_pComment) {
		DBF.Free(m_pComment);
		m_pComment=NULL;
	}

	// o߂̓ǂݏo
    char ckey[sizeof ((F_REC*)0)->row.ckey + 1]; /* key */
	char *mrecno=get_mdsp_strrecno();
    sprintf(ckey,"%s000",mrecno);
    m_pComment=DBF.Read(recid,ckey);

	if (bDbfopen)    // ŃI[v݂̂ŃN[YB
		DBF.Close(); // (ɃI[vĂꍇ͂ł̓N[YȂB)

	return rc;
}

////////////////////////////
// DB̎wǂݏo
//
//      B_PLAY FindBplay(long recno,int num);
//      B_PLAY NextBplay(void);
//      B_PLAY PrevBplay(void);
//
//  @@
//        long recno         : R[hԍ(΋ or lDB)
//        int num            : ǂݏow̎萔(>=1)
//
//  @@߂l(DB_Rc)
//  @@@Ǐoɐ@ : w(B_PLAY)
//  @@@ǏoɎs@ : MSB=1(0xffff)
//
//  @@
//       FindBplay͑΋DB̃R[hԍrecnoA萔numŎw肳wԂB
//       NextBplay͒Oɓǂݏo̎wAPrevBplay͑O̎wԂB
//       ŏIwNextBplayĂяoꍇA邢͐擪w PrevBplay
//       Ăяoꍇ0xffffԂB
//       f[^x[Ẍُ̓f[^x[XXe[^X͊Oϐ int DB_RcɕԂB
B_PLAY CDBM::FindBplay(long recno, int num)
{
	return DBD.FindBplay(1,recno,num); // ΋DB
}
B_PLAY CDBM::NextBplay(void)
{
	return DBD.NextBplay();
}
B_PLAY CDBM::PrevBplay(void)
{
	return DBD.PrevBplay();
}
BOOL CDBM::DBDOpen(void)
{
	return DBD.Open();
}
BOOL CDBM::DBDOpen(char *dname)
{
	return DBD.Open(dname);
}
void CDBM::DBDClose(void)
{
	DBD.Close();
}
BOOL CDBM::DBFOpen(void)
{
	return DBF.Open();
}
BOOL CDBM::DBFOpen(char *dname)
{
	return DBF.Open(dname);
}
void CDBM::DBFClose(void)
{
	DBF.Close();
}

//// R[hnbVl擾(dummy)
long CDBM::get_mrec_hash_s()
{
	TRACE("get_mrec_strhash_s dummy_func called\n");
	return -1L;
}

///////
// ǖ(B`)̎擾
//   ݂̑΋DBobt@(B_REC)̏ǖʂǂݏoB`ŕԂ
//   ǂݏoɎs NULLԂ
B_FORM *CDBM::GetFirstBform(void)
{
	/* HS nbVľvZ */
	long hash = get_mrec_hash_s();

	/* ǖʂbform ̓ǂݏo */
	if (HSread(hash)!=E$OK) {
		AfxMessageBox("f[^x[X(SHGDB_A)̓ǂݏoɎs܂");
		return NULL;
	}
	return &a_rec.row.bform;
}

//======================= CSA`̂cao =============

/* CSA `̋̎ */
static struct {
  char *n1;                     /*  */
  char *n2;                     /*  */
} kmname[8] = {
  {"OU",""},                    /*  */
  {"HI","RY"},                  /*  */
  {"KA","UM"},                  /* p */
  {"KI",""},                    /*  */
  {"GI","NG"},                  /*  */
  {"KE","NK"},                  /* j */
  {"KY","NY"},                  /*  */
  {"FU","TO"}                   /*  */
};

/////
// CSA`oo(1)(dummy)
//   wb_[
//   za:1Ȃo͂BftHgza=0
int CDBM::OutMrec2CsaHeader1(CSDJArchive &ar,int za)
{
	TRACE("OutMrec2CsaHeader1 dummy_func called\n");

	return 0;
}
/////
// CSA`oo(2)
//   RgL[[h
int CDBM::OutMrec2CsaHeader2(CSDJArchive &ar)
{
	TRACE("OutMrec2CsaHeader2 dummy_func called\n");
	return 0;
}
int CDBM::OutMrec2CsaHeader2(CSDJArchive &ar,int count)
{
	int i;
	char buffer[80];
	char StringBuffer[256];

    /* CSA RgL[[hڂ̏o */
    for (i=0;i<count;i++) {
        strncpy(buffer,Mtab[i].mrp,Mtab[i].msz);
        buffer[Mtab[i].msz]='\0';
        if (strlen(buffer)!=0) {
            sprintf(StringBuffer,"'%s%s\r\n",Mtab[i].mcp,buffer);
			ar.WriteString(StringBuffer);
		}
    }
	return 0;
}

/////
// CSA`oo(3)
//  ΋ǒ
int CDBM::OutMrec2CsaHeader3(CSDJArchive &ar)
{
	int rc=1;
	int len;
    char *cp,*cp1,*cp2;
	char *pComment;
	char *pStringBuffer;

    /* ΋ǂ̒(s΂̓sxL[[ht^) */
	// ReadByDbrno()ɂđ΋ǌo񂪓ǂݍ܂ꂽ_ő΋ǒ߂
	// m_pCommentɓǂݍ܂ĂƂO񂪂B
	if (m_pComment) {
		if ((pComment=(char *)memalloc(strlen(m_pComment)+1))!=NULL) {
			strcpy(pComment,m_pComment); // Rs[
			cp1=pComment;        // cp1͌Jnʒu
			cp=strchr(cp1,'\n'); // s'\n'T
	        while(cp!=NULL) {    // s
				cp2=cp;          // cp2͍̃g[N
				if (*(cp2-1)=='\r') cp2--; // CRΈO
				*cp2='\0';       // g[N؂
				len=strlen(cp1); // g[N
				pStringBuffer=(char *)memalloc(len+10);
				if (pStringBuffer==NULL) {
					AfxMessageBox("No memory!!");
					goto exit;
				}
				sprintf(pStringBuffer,"':%s\r\n",cp1);
				ar.WriteString(pStringBuffer); // g[No
				memfree(pStringBuffer);
				cp1=cp+1; // g[NJnʒu
				cp=strchr(cp1,'\n'); // g[Ns
	        }
			// ŏIs̏(s)
			if ((len=strlen(cp1)) > 0) {
				pStringBuffer=(char *)memalloc(len+10);
				if (pStringBuffer==NULL) {
					AfxMessageBox("No memory!!");
					goto exit;
				}
				sprintf(pStringBuffer,"':%s\r\n",cp1);
				ar.WriteString(pStringBuffer); // g[No(sR[ht)
				memfree(pStringBuffer);
			}
			memfree(pComment);
		}
	}
	rc=0;
exit:
	return rc;
}

/////
// CSA`oo(4)(dummy)
//  ΋ǎ
int CDBM::OutMrec2CsaHeader4(CSDJArchive &ar)
{
	TRACE("OutMrec2CsaHeader4 dummy_func called\n");
	return 0;
}

//////////
// CSA`ȍo
//    CDBMɌݓǂݍ܂Ă錩oɁǍo
//    A[JCoarCSA`ŏo͂B
//    (\CDBMɌoǂݏoɂReadByDbrno()𗘗pO񂠂)
//     za=1Ȃo(ftHgza=0)
//  ߂l
//    I 0:   ُ:!=0
int CDBM::OutMrec2Csa(CSDJArchive &ar,int za)
{
	int rc=1;
	// ar`FbN
	ASSERT(ar.IsStoring());

	if ((rc=OutMrec2CsaHeader1(ar,za))!=0) goto exit; // wb_[
	if ((rc=OutMrec2CsaHeader2(ar))!=0) goto exit;    // RgL[[h
	if ((rc=OutMrec2CsaHeader3(ar))!=0) goto exit;    // o
	if ((rc=OutMrec2CsaHeader4(ar))!=0) goto exit;    // ΋ǎ
	rc=0;
exit:
	return rc;
}

//// R[h背R[hԍ擾(dummy)
long CDBM::get_mrec_recno()
{
	TRACE("get_mrec_recno dummy_func called\n");
	return -1L;
}
//////////////////////////////////
//  CSA`o(Ǖ)
//    CDBMɌݓǂݍ܂Ă΋ǌoɁȂ΋Ǌ
//    ΋ǂcaǂݏoAA[JCoarCSA`ŏo͂B(CDBM͊ɃI[vϑO)
//    (\CDBMɑ΋ǏǂݏoɂReadByDbrno()𗘗pO񂠂)
//    (܂ADBD,DBF͊ɃI[vĂ΂̃[`ł̓N[YȂ)
//    za=1Ȃo(ftHgza=0)
//    recid  1:΋ǂca  2:lca
//  ߂l
//    I 0:   ُ:!=0
int CDBM::OutDB2Csa(CSDJArchive &ar,int za)
{
	TRACE("OutDB2Csa dummy_func called\n");
	return -1;
}
//
// PCLt@C̃`FbN&o(98.1.5)
//     ar:݃A[JCo  hash_s:o}
//  ߂l TRUE/FALSE PCLt@Cŏo͂/ȂB
static BOOL pclfile_out(CSDJArchive &ar,long hash_s)
{
	CString strPclFile; // PCLt@C
	strPclFile.Format("%spcl\\%08ld.pcl",GetShgdbName(),hash_s);
	CFile f;
	// Open
	if (!f.Open(strPclFile,CFile::modeRead|CFile::shareDenyWrite))
		return FALSE; // Open failed.

	// o̍s߂B
	// ǖʏ̊Jns(s'P')܂ōsJEgB
	CSDJArchive loadar(&f,CArchive::load);
	CString str;
	int count=0;
	while (loadar.ReadString(str)) {
		count++;
		if (str.GetAt(0)=='P' || str.GetAt(0)=='p')
			break;
	}
	loadar.Close();
	count--; // o̍s count-1

	// oǂݎ̂Ă
	f.Seek(0L,CFile::begin); // PCLt@C𓪏o
	CSDJArchive loadar2(&f,CArchive::load);
	for (int i=0;i<count-1;i++)
		loadar2.ReadString(str); // o̓ǂݎ̂

	// ǖʏ͂̂܂܃Rs[
	while (loadar2.ReadString(str)) {
		ar.WriteString(str);
		ar.WriteString("\r\n"); // st
	}
	loadar2.Close();

	f.Close();
	return TRUE; // Normal end.
}
int CDBM::OutDB2Csa(CSDJArchive &ar,int za,int recid)
{
    int rc=1;
    B_PLAY bplay;
    long recno=get_mrec_recno();
    long hash_s=get_mrec_hash_s();
    int tesu;
	BOOL Dopen=FALSE;
	BOOL Fopen=FALSE;

	// ƃobt@
	char StringBuffer[256];
	CBform Bform;

	// ar`FbN
	ASSERT(ar.IsStoring());


	if ((rc=OutMrec2Csa(ar,za))!=0) goto exit; // ȍo

	// PCLt@C`FbNo(l̏ꍇ)
	// ǖʏPCLt@C΂ꂩo͂ďIB
	if (recid==2) {
		if (pclfile_out(ar,hash_s))
			return 0;
	}

    /* Ֆʂ̓ǂݏo */
    if ((rc=HSread(hash_s))!=E$OK) {
        sprintf(StringBuffer,"ՖDB G[(%d)\n",rc);
		AfxMessageBox(StringBuffer);
		goto exit;
    }

    /* Ֆʂ肩ǂ`FbN */
	Bform.Init(0);      /*  */

    /* Jnǖʂ̏o(ȊO̎) */
    if (memcmp(&Bform.bform,&a_rec.row.bform,sizeof(B_FORM))!=0) {
		memcpy(&Bform.bform,&a_rec.row.bform,sizeof(B_FORM));
        out_bform_csa(ar,&Bform);
	}
    else
        ar.WriteString("PI\r\n");         /* ̎ */

    /*  */
	if (recid==1) { // ΋ǂca̎
		if (get_mrec_side()==0)
			ar.WriteString("+\r\n");
		else
			ar.WriteString("-\r\n");
	}

	// DBD,DBF̃I[v`FbN
	if (DBD.GetDscm()==NULL) {
		if (!DBD.Open()) goto exit;
		Dopen=TRUE;
	}
	if (DBF.GetFscm()==NULL) {
		if (!DBF.Open()) goto exit;
		Fopen=TRUE;
	}
    /* wi߂Ȃo͂B*/
    tesu=1;
    bplay=DBD.FindBplay(recid,recno,tesu); /*  */
    while (bplay!=0xffff) {
        out_bplay_csa(ar,&Bform,bplay);       /* w̏o */
        out_bplay_comment_csa(ar,recno,tesu); /* ԁA߂̏o */

		Bform.Forward(bplay);     // ǖʂi߂
        tesu++;

        bplay=DBD.NextBplay();    /* ̎w */
    }
    rc=0;
exit:
	if (Dopen)
		DBD.Close();
	if (Fopen)
		DBF.Close();
    return rc;
}

/* zȕo(csa) */
void CDBM::out_bform_csa(CSDJArchive &ar,CBform *bp)
{
    int x,y,sg,km,nr;
	int i,n;
	SHOGIBAN SBan;
	char StringBuffer[256];

	// ՓWJ
	bp->ToShogiBan(&SBan);
	

    /* ꊇ\ */
    for (y=1;y<=9;y++) {
        sprintf(StringBuffer,"P%d",y);
		ar.WriteString(StringBuffer);
        for (x=9;x>=1;x--) {
            sg=SBan.Ban[x][y].sg;
            km=SBan.Ban[x][y].km;
            nr=SBan.Ban[x][y].nr;
            if (km!=-1) {     /*  */
                if (sg !=0) { /* ̋ */
                    sprintf(StringBuffer,"-%s",(nr)? kmname[km].n2:kmname[km].n1);
					ar.WriteString(StringBuffer);
				}
                else {             /* ̋ */
                    sprintf(StringBuffer,"+%s",(nr)? kmname[km].n2:kmname[km].n1);
					ar.WriteString(StringBuffer);
				}
            }
            else {
                ar.WriteString(" * ");  /* Ȃ */
			}
        }
        ar.WriteString("\r\n");           /* s̏o͏I */
    }
    /* ̏o */
	for (i=0;i<8;i++) {
		if (SBan.Dai[0][i]!=0) {
            ar.WriteString("P+");
            for (n=0;n < SBan.Dai[0][i];n++) { /* ނsŏo */
                sprintf(StringBuffer,"00%s",kmname[i].n1);
				ar.WriteString(StringBuffer);
			}
            ar.WriteString("\r\n");
		}
	}
    /* ̏o */
	for (i=0;i<8;i++) {
		if (SBan.Dai[1][i]!=0) {
            ar.WriteString("P-");
            for (n=0;n < SBan.Dai[1][i];n++) { /* ނsŏo */
                sprintf(StringBuffer,"00%s",kmname[i].n1);
				ar.WriteString(StringBuffer);
			}
            ar.WriteString("\r\n");
		}
	}
}

/* CSA`̎wo͂B */
void CDBM::out_bplay_csa(CSDJArchive &ar,CBform *pBform, B_PLAY bplay)
{
	int km,from,to,prom,side;
	char StringBuffer[256];

	// w̎擾
	pBform->GetMoveInfo(bplay,&km,&from,&to,&prom,&side);
	if (from<11 || from>99) from=0;
	if (to<11   || to  >99) to  =0;

    /* w̏o */
    sprintf(StringBuffer,"%c%02d%02d%s",(side)?'-':'+',from,to,
           (prom)?kmname[km].n2:kmname[km].n1);
	ar.WriteString(StringBuffer);

}

/*
 * ԁA߂̏o(csa)
 *   recid 3:΋ǂca  4:lca
 */
void CDBM::out_bplay_comment_csa(CSDJArchive &ar,long recno,int tesu)
{
	TRACE("out_bplay_comment_csa dummy_func called\n");
}
void CDBM::out_bplay_comment_csa(CSDJArchive &ar,long recno,int tesu,int recid)
{
    char ckey[sizeof ((F_REC*)0)->row.ckey + 1]; /* key */
    char *text,*cp,*cp1,*cp2;
	char *pStringBuffer;
	int len;

    /* ߃L[̃Zbg */
    sprintf(ckey,"%06ld%03d",recno,tesu);

    /* ߕ̓ǂݏo */
	// 97.3
	// sR[h\r\n̏ꍇ\n̏ꍇz肷B
	// ̃WbNł\nŏI钍߂ \r\nsR[hƂďo͂B
    if ((text=DBF.Read(recid,ckey))!=NULL) {          /* ߕ */
        if ((cp=out_T_csa(ar,text))!=NULL) {    /* Ԃo */
			cp1=cp; // cp1͌Jnʒu
            cp=strchr(cp1,'\n'); // sR[h
            while(cp!=NULL) {    // sR[h
				cp2=cp;          // cp2͍g[N̖
				if (*(cp2-1)=='\r') cp2--; // CRΈO
				*cp2='\0';       // g[N؂
				len=strlen(cp1); // g[N̕
				pStringBuffer=(char *)memalloc(len+10);
				if (pStringBuffer==NULL) {
					AfxMessageBox("No memory!!");
					return ;
				}
				sprintf(pStringBuffer,"':%s\r\n",cp1);  /* sL[[ht^ */
				ar.WriteString(pStringBuffer); // g[N̏o
				memfree(pStringBuffer);
				cp1=cp+1;              // g[N̊Jnʒu
				cp=strchr(cp1,'\n');   // g[NsR[h
            }
			// ŏIs̏(sR[ĥȂ)
			if ((len=strlen(cp1))>0) {
				pStringBuffer=(char *)memalloc(len+10);
				if (pStringBuffer==NULL) {
					AfxMessageBox("No memory!!");
					return ;
				}
				sprintf(pStringBuffer,"':%s\r\n",cp1);  /* sL[[ht^ */
				ar.WriteString(pStringBuffer); // g[N̏o(sR[ht)
				memfree(pStringBuffer);
			}
        }
        DBF.Free(text);                         /* ߕ̉ */
    }
    else
        ar.WriteString("\r\n");           /* ߕȂΉŝ */
}

/* w蒍ߕ̏Ԃo͂āAߕJnւ̃|C^Ԃ֐B
   ԂȂtextԂBߕȂNULLԂB*/
char *CDBM::out_T_csa(CSDJArchive &ar, char *text)
{
    char *cp;
    char head[12];
    int hun=0,byo=0;
	char StringBuffer[256];

    /* text 擪11(xxxB,xxxxxbB)`FbNB*/
    strncpy(head,text,11);
    head[11]='\0';
    if (_mbsbtype((unsigned char *)head,10)==1) head[10]='\0'; /* 1oCgڂ̃`FbN */
    cp=(char *)_mbsstr((unsigned char *)head,(unsigned char *)"B"); /* "B"T */
    if (cp!=NULL) {
        hun=CvDecI(head,(int)(cp-head));
        cp=text+(cp-head)+4;    /* |C^'B'̌ */
    }
    if (cp==NULL) {
        cp=(char *)_mbsstr((unsigned char *)head,(unsigned char *)"bB"); /* "bB"T */
        if (cp!=NULL) {
            byo=CvDecI(cp-2,2);
            if (strncmp(cp-4,"",2)==0) {
                hun=CvDecI(head,(int)(cp-4-head));
            }
            cp=text+(cp-head)+4;    /* |C^'B'̌ */
        }
    }
    if (cp==NULL) {
        cp=text;                /* Ԃ̏o͂Ȃ */
        ar.WriteString("\r\n");           /* ŝ */
    }
    else {
        byo=byo+hun*60;
        sprintf(StringBuffer,",T%d\r\n",byo);   /* Ԃ̏o+s */
		ar.WriteString(StringBuffer);
    }

    if (strlen(cp)==0)
        cp=NULL;

    return cp;
}

// ============  CSAo^ ================
///////////////
// ֐
//////////////
void CDBM::SetDateTime(char *datetime)
{
    time_t tim;
    struct tm *tp;

    time(&tim);
    tp=localtime(&tim);
    sprintf(datetime,"%04d%02d%02d%02d%02d%02d",
            tp->tm_year+1900,
            tp->tm_mon+1,
            tp->tm_mday,
            tp->tm_hour,
            tp->tm_min,
            tp->tm_sec);
}

/* ΋ǎҖ̃Zbg(dummy) */
int CDBM::set_player(char *sente,char *gote)
{
	TRACE("set_player dummy_func called\n");
	return 0;
}

/* L[ڒl̃`FbN */
int CDBM::item_check(int ino,char *cp)
{
	TRACE("item_check dummy_func called\n");
	return 0;
}

/* Rg̈(comment)ɃRgcpZbgB*/
// crlf!=0 ȂsR[ho͂B(ftHg)
int CDBM::realloc_comment(char *cp,int crlf)
{
    int rc=1;
	char *c2;
	char StringBuffer[256];

    /* ݂̒ߕ̗̈撷sȂ */
    while ((int)strlen(comment)+(int)strlen(cp)+3 > rcsiz) { /* ߕ̈m */
        c2=(char *)memalloc(rcsiz+1024);
        if (c2==NULL) {
            sprintf(StringBuffer,"No memory!!");
			AfxMessageBox(StringBuffer);
            goto exit;
        }
        strcpy(c2,comment);
        memfree(comment); /* Â͕̈svȂ̂ŉB*/
        comment=c2;
        rcsiz+=1024;      /* 1024oCg̈𑝂₷B*/
    }
    /* ̈撷ۏ؂ꂽߕ̈ɒli[B*/
    strcat(comment,cp);   /* ߕ̈Ɋi[ */
    if (crlf)
        strcat(comment,"\r\n"); /* s̕t^ */

    rc=0;

  exit:
    return rc;
}

/* ͍s擾 */
char *CDBM::get_line(CSDJArchive &ar)
{
	static char fbuf[1024];

    do {
        /* line CSA 1 soB(͕B) */
        /* O񌋉ʂline==NULLRgs */
        if (line==NULL || line!=NULL && (line[0]=='\'')) {
			if ((line=ar.ReadString(fbuf,sizeof fbuf -1))==NULL ) { // file read
				break;
			}
            if (line[0]!='\'')           /* RgsłȂ */
                line=strtok(fbuf,",");   /* ','؂qƂĕǏo */
        }
        else
            line=strtok(NULL,",");
    } while (line==NULL);       /* eol */
	
	if (line!=NULL)
		m_MrecCount2++;
    return line;
}

/* õRg */
// Œߕ̏ĂAInCsa2MrecInit()
// z('02/09/27 by Ra)Bǖʂ̊JnRgΉׁ̈B
int CDBM::mrec_comment_set(char *line)
{
    int i;
    char *cp;
    int rc=1;

    for (i=0;Mtab[i].mcp!=NULL;i++) {
        /* L[[hv */
        if (strncmp(&line[1],Mtab[i].mcp,strlen(Mtab[i].mcp))==0) {
            cp=line+1+strlen(Mtab[i].mcp); /* w荀ڒl */
            cp=cp+strspn(cp," \t"); /* ڒl擪' ',\t͏O */
            /* ڒl̃`FbNOKȂ */
            /* B_REC ̍ڃtB[hɒli[B*/
            if (item_check(i,cp)==0) { 
                strncpy(Mtab[i].mrp,cp,Mtab[i].msz);
            }
            break;
        }
    }
    rc=0;
    return rc;
}

/* m_rec ΋ǎ҂̐ݒ*/
int CDBM::brec_player(char *line)
{
    char *cp;
    int rc=1;
	char StringBuffer[512];

    cp=line+2;
    cp=cp+strspn(cp," \t");
    if (line[1]=='+') { /* ΋ǎҖ */
        if (flag[0]==0) {       /* ŏ̓o^ */
            /* ڗ̈擪ɒli[B */
            rc=set_player(cp,NULL);
            flag[0]=1;  /* ΋ǎ҃Zbg */
        }
    }
    else if (flag[1]==0) { /* ΋ǎҖ̏ꍇ */
        rc=set_player(NULL,cp);
        flag[1]=1;      /* ΋ǎ҃Zbg */
    }
    if (rc) {
        sprintf(StringBuffer,"΋ǎҎwG[łB(%s)",line);
		AfxMessageBox(StringBuffer);
        goto exit;
    }
    rc=0;

  exit:
    return rc;
}


/******
 loc_PI zuZbg
 (1) 菉zuƋ
 @菉zúC"PI"ƂB́C"PI"ɑCƂ̈ʒuƎނK
 vȂLqB
 F񖇗
 PI82HI22KA
 ****/
int CDBM::loc_PI(char *line)
{
    int i,j;
    int from,to,prm,side,code;  /* w */
    char work[8];
    int rc=0;
    B_PLAY bplay;

	Bform.Init(0); // zu
    to=127;           /*  */
    prm=0;
    side=0;
    work[4]='\0';
    for (i=2;line[i]!='\0';i+=4) {
        strncpy(work,&line[i],4); /* Ƃ𒊏o */
        if (strlen(work)!=4) {rc=1;break;}
        from=(work[0]-'0')*10+(work[1]-'0'); /* Տォ */
        for (code=-1,j=0;j<8;j++) {
            if (strcmp(&work[2],kmname[j].n1)==0) {
                code=j;break;     /*  */
            }
        }
        /* `FbN */
        if (from>=11 && from<=99 && code!=-1) {
            /* ֈړ */
            bplay=Bform.GetBplay(from,to,prm,side,code);
            if (bplay!=-1) {
				Bform.Forward(bplay); /* ړ */
            }
            else {rc=1;break;}
        }
        else {rc=1;break;}
    }

    return rc;
}

/********
 ʒPƕ\̏ꍇ(P+99KY,P-00FUȂ)
 (3) ʒPƕ\
	@̋Ƃ́C̋ʂɑCʒuƋ̎ނLqB
	ɌC̎ނƂ"AL"gpłCc̋ׂĂ\B"00"łB
	ʂ́Cւ͂ȂB

	F
	P-22KA
	P+99KY89KE
	P+00KI00FU
	P-00AL
 ****/
int CDBM::loc_Psingle(char *line)
{
    int i,j;
    int from,to,prm,side,code;  /* w */
    char work[8];
    int rc=0;
    B_PLAY bplay;

    if (flag[2]==0)
		Bform.Init(8); /* zu */
    
    side=(line[1]=='+')? 0:  1;
    from=127;         /*  */
    work[4]='\0';
    for (i=2;line[i]!='\0';i+=4) {
        strncpy(work,&line[i],4); /* ׂ𒊏o */
        if (strlen(work)!=4) {rc=1;break;}
        to=(work[0]-'0')*10+(work[1]-'0'); /*  */
        for (code=-1,j=0;j<8;j++) {
            if (strcmp(&work[2],kmname[j].n1)==0) {
                code=j;    /*  */
                prm=0;     /*  */
                break;
            }
            else if (strcmp(&work[2],kmname[j].n2)==0) {
                code=j;    /*  */
                prm=1;     /*  */
                break;
            }
        }
        /* `FbN */
        if (to>=11 && to<=99 || to==0) {/* Տ, */
            if (to==0 && side==1) to=1;
            if (code!=-1) {
                /* ړ */
                bplay=Bform.GetBplay(from,to,prm,side,code);
                if (bplay!=-1) {
                    Bform.Forward(bplay); /* ړ */
                    flag[2]=2; /* ʒuw蒆ƂB*/
                }
            }
            else if (strcmp(&work[2],"AL")==0) {
                /* ʒPƕ\ALwȂʒuw͏I */
                if (to==0 || to==1) {
                    for (j=2;j<40;j++) { /*ʂSĂ̋*/
                        if ((Bform.bform.km[j] & 0x7f)==127) {
                            /* c̋̋ړ */
                            bplay=(side<<14)+(to<<6)+j;
                            Bform.Forward(bplay);
                        }
                    }
                    flag[2]=1; /* ʒuw芮 */
                }
                else {rc=1;break;}
            }
            else {rc=1;break;}
        } /* if (to>=11 && to<=99) { */
        else {rc=1;break;}
    } /* for (i=2;line[i]!='\0';i+=4) { */

    return rc;
}

/* zuꊇ\ */
int CDBM::loc_Pall(char *line)
{
    int i,j;
    int from,to,prm,side,code;  /* w */
    char work[8];
    int rc=0;
    B_PLAY bplay;

    if (line[1]-'0'!=pl+1) rc=1; /* sԍ̃`FbN */
    else pl++;                  /* pl͑Ώۂ̍sԍ */

    /* ʒuwOꊇw蒆Ȃ*/
    if (rc==0 && (flag[2]==0 || flag[2]==3)) { 
        if (flag[2]==0) 
            Bform.Init(8); /* zu */
        from=127;             /*  */
        work[3]='\0';
        for (i=0;i<9;i++) {
            strncpy(work,&line[2+i*3],3); /* ̒o */
            if (strlen(work)!=3) {rc=1;break;}
            if (work[0]=='+' || work[0]=='-') {
                side=(work[0]=='+')? 0: 1;
                to=(9-i)*10+pl;         /* Տ̈ʒu */
                for (code=-1,j=0;j<8;j++) {
                    if (strcmp(&work[1],kmname[j].n1)==0) {
                        code=j;    /*  */
                        prm=0;     /*  */
                        break;
                    }
                    else if (strcmp(&work[1],kmname[j].n2)==0) {
                        code=j;    /*  */
                        prm=1;     /*  */
                        break;
                    }
                }
                /* `FbN */
                if (code!=-1) {
                    bplay=Bform.GetBplay(from,to,prm,side,code);
                    if (bplay!=-1) {
                        Bform.Forward(bplay); /* ړ */
                        flag[2]=3; /* ꊇ\w蒆ƂB*/
                    }
                    else {rc=1;break;}
                }
                else {rc=1;break;}
            } /* if (work[0]=='+' || work[0]=='-') { */
        } /* for (i=0;i<9;i++) { */

        /* ꊇ\w肪 */
        if (pl==9 && rc==0)
            flag[2]=2; /* ʒPƈʒuw蒆ƂB*/
                       /* ȍ~͋ʒPƈʒuŵݎ󂯕tB*/
    }  /* wOȂ */
    else 
        rc=1;

    return rc;
}

/* DB̃Rg */
int CDBM::drec_comment_set(char *line)
{
    char *cp;
    int rc=1;

	// ߕ̎ '02/09/27 by Ra MTABgpȂ悤ɕύX
	if (strlen(line)>6 && strncmp(line,"\':",6)==0 ) {
		cp=line+6;
		if (realloc_comment(cp,1)!=0) goto exit;
	}
    rc=0;
  exit:
    return rc;
}

/* DB̏ԏ@RgƂēo^B*/
int CDBM::drec_T_set(char *line)
{
    char jikan[20],work[20];
    unsigned int ui;
    int rc=1;

    jikan[0]='\0';

    ui=CvDecI(line+1,strlen(line)-1); /* ui͏(bP) */
    if (ui!=0) {
        if (ui/60 !=0) {
            sprintf(work,"%3d",ui/60);
            strcat(jikan,work);
            ui=ui-ui/60*60;
        }
        if (ui != 0) {
            sprintf(work,"%2db",ui);
            strcat(jikan,work);
        }
        if (strlen(jikan)!=0) {
            strcpy(&jikan[strlen(jikan)],"B"); /* _ */

            /* ߕ𒍎ߕ̈ɃZbgB */
            if (realloc_comment(jikan,0)!=0) goto exit;
        }
    }
    rc=0;

  exit:
    return rc;
}

/* D_REC̃R[h`FbNƊDBւ̓o^ */
int CDBM::drec_play_set(char *line,int side,long brecno)
{
	TRACE("drec_play_set dummy_func called\n");
	return 0;
}
int CDBM::drec_play_set(char *line,int side,long brecno,int recid)
{
    int i;
    int from,to,prm,code;       /* w */
    char work[8];
    int rc=1;
    B_PLAY bplay;
	char StringBuffer[2048];

    /* w̃`FbN */
    if (side==0 && line[0]=='-' || side==1 && line[0]=='+')  {
        sprintf(StringBuffer,"w̎ԂԈĂ܂(%s)",line);
		AfxMessageBox(StringBuffer);
        goto exit;
    }
    /* wtH[ */
    if (strlen(line)!=7) {
        sprintf(StringBuffer,"w̌`ԈĂ܂(%s)",line);
		AfxMessageBox(StringBuffer);
        goto exit;
    }
        
    from=(line[1]-'0')*10+(line[2]-'0'); /* ړ */
    if (from==0 && side==1)
        from=1;                          /* ł̎ */
    if (!((from >=11 && from <= 99) || from==0 || from==1)) {
        sprintf(StringBuffer,"ẅړԈĂ܂(%s)",line);
		AfxMessageBox(StringBuffer);
        goto exit;
    }
    to=(line[3]-'0')*10+(line[4]-'0');   /* ړ */
    if (!(to >= 11 && to <= 99)) {
        sprintf(StringBuffer,"ẅړ悪ԈĂ܂(%s)",line);
		AfxMessageBox(StringBuffer);
        goto exit;
    }
    strncpy(work,&line[5],2);            /*  */
    work[2]='\0';
    
    for (code=-1,i=0;i<8;i++) {
        if (strcmp(work,kmname[i].n1)==0) {
            code=i;     /*  */
            prm=0;
            break;
        }
        if (strcmp(work,kmname[i].n2)==0) {
            code=i;     /*  */
            prm=1;
            break;
        }
    }
    if (code==-1) {
        sprintf(StringBuffer,"w̋킪ԈĂ܂(%s)",line);
		AfxMessageBox(StringBuffer);
        goto exit;
    }

    /* ̈ړ */
    bplay=Bform.GetBplay(from,to,prm,side,code);
    if (bplay!=-1) {
        rc=DBD.WriteBplay(recid,brecno,bplay);
        if (rc!=E$OK) {
            sprintf(StringBuffer,"wo^Ɏs܂B(%d)",rc);
			AfxMessageBox(StringBuffer);
            goto exit;
        }

        Bform.Forward(bplay); /* ړ */
    }
    else {
        sprintf(StringBuffer,"w肪ԈĂ܂(%s)",line);
		AfxMessageBox(StringBuffer);
        goto exit;
    }

    rc=0;
  exit:
    return rc;
}

/* w蒍߂̓o^(sasite=萔)(dummy) */
int CDBM::sasite_comment(int sasite)
{
	TRACE("sasite_comment dummy_func called\n");
    return 0;
}

/* ΋ǔԍb_recnoɊւ钍DB Fscm̃R[hSďB */
/* Fscm,DscmQƂB(dummy)*/
void CDBM::dbf_remove(long recno)
{
	TRACE("dbf_remove dummy_func called\n");
}

//////////////////////////////
// CSA`DBB֓o^(nǕ)(dummy)

int CDBM::InCsa2DB(CSDJArchive &ar,CWnd *pWnd,BOOL bIgnoreRecno)
{
	TRACE("InCsa2DB dummy_func called\n");
	return -1;
}
// ============ ܂ CSAo^ ================

//////
// CSA`̑΋ǌoǍݏ
int CDBM::InCsa2MrecInit(CSDJArchive &ar)
{
	int rc=1;

	/* ߕ̈̊m */
    if ((comment=(char *)memalloc(1024))==NULL) {
		AfxMessageBox("No memory!!");
		return rc;
	}
	rcsiz=1024;
    comment[0]='\0';        /* ߗ̈NA */
	memset(flag,'\0',sizeof flag);

	// m_rec̏
	mrec_init();

	// ΋ǒ߂̊J
	if (m_pComment) {
		DBF.Free(m_pComment);
		m_pComment=NULL;
	}

	///////
	// os̏I`FbN
	// s'P'ɂȂO܂ł͌osƂB

	// ar̃Rs[ar2B
	CFile *pf; long fpos,seekpos; int readcount,bufsize;
	ar.GetCopyInfo(&pf,&fpos,&seekpos,&readcount,&bufsize);
	pf->Seek(seekpos,CFile::begin); // pfSeek
	CSDJArchive ar2(pf,CArchive::load,bufsize); // Ɨp CArchive ar2
	// ar2̃obt@ʒu킹B
	for (int i=0;i<readcount;i++) {
		char c[1];
		ar2.Read(c,1); // dummy reading;
	}
	/* 
	  Jnǖʂ̒ߕ΁A΋ǒ߂ɒǉ悤ɕύX
	  '02/09/27 by Ra WinSDJ Ver5.1c
	  ̓Iɂ́Aߕ͂̏ňꊇ悤ɂB
	*/
    int MrecCount3=-1; // os̏IL
	m_MrecCount2=0;               // oJEgl̃Zbg
	line=NULL; // Ăƍŏget_line()Ńt@CǂݏoB
	while ((line=get_line(ar2))!=NULL) {
		// get_line̒ŃJEglm_MrecCount2XVB
		// ߕ̏ '02/09/27 by Ra WinSDJ Ver.5.1c
		if (strlen(line) > 6) {
			if (strncmp("\':",line,6)==0) {
				// ߕ𒍎ߕ̈ɃZbgB
				realloc_comment(line+6,1);
			}
		}
		// s'P'Ȃ猩os̏I
		if (MrecCount3 == -1 && line[0] == 'P') {
			MrecCount3=m_MrecCount2; // os̏IL
		}
		// ŏ̎wǂݏoI
		if ((line[0]=='+' || line[0]=='-') && strlen(line) > 1) {
			if (strspn(line+1,"0123456789")==4) {
				break;
			}
		}
	}
	ar2.Close();	//Ɨpt@C̔j

	if (MrecCount3!=-1) {
		m_MrecCount = MrecCount3-1;  // JEglL
	}
	else {
		m_MrecCount = m_MrecCount2;  // eof(line==NULL)
	}

	m_MrecCount2=0;			  // JEglZbg

	// IWit@C̃|C^ɖ߂
	pf->Seek(fpos,CFile::begin);


	line=NULL; // Ăƍŏget_line()Ńt@CǂݏoB
	rc=0;
	return rc;
}

/////
// CSA`̑΋ǌoǍ݊`FbN(dummy)
BOOL CDBM::InCsa2MrecIsEnd()
{
	// oĨJEglrĔfB
	if (m_MrecCount2 < m_MrecCount)
		return FALSE;
	else
		return TRUE;
}

//////
// CSA`̑΋ǌoǍݏI
void CDBM::InCsa2MrecEnd()
{
	// ΋ǒ߂̃Zbg
	if (comment!=NULL) {
		if (strlen(comment)) {
			if ((m_pComment=(char *)memalloc(strlen(comment)+1))!=NULL) {
				strcpy(m_pComment,comment);
			}
		}

        memfree(comment);
		comment=NULL;
		rcsiz=0;
	}
	set_mdsp(); // \obt@̐ݒ
}


//////////////////////////////
// CSA`DBm_rec֌oǂݍށB
// ߂l I:0  ُI:!=0
// bCheck==TRUE(ftHg)ȂG[`FbN̕\L
//         FALSE Ȃ\Ȃ
int CDBM::InCsa2Mrec(CSDJArchive &ar,BOOL bCheck)
{
    int rc=1;
    char *line;
	char StringBuffer[512];

	if ((rc=InCsa2MrecInit(ar))!=0) goto exit; // Ǎݏ̏

	// ȉ̃[vCSA`ǂݍm_recZbg(΋ǎ҂܂)B
	while (!InCsa2MrecIsEnd()) { // I`FbN
		// ͍s̓Ǐo
		if ((line=get_line(ar))==NULL)
			break;          /* eof */
		// CSARgsȂ
		if (line[0]=='\'') {
		/* "'"ȉRgsL[[hƈv邩ۂׁAv
		   YC_RECtB[h̍ڂɂ̒lZbgB
		   Aߕ̏ꍇ͒ߕ̃̈mۂāAɒl
			i[B*/
			if (mrec_comment_set(line)!=0) goto exit;
		}
		// ΋ǎҎwȂ
		else if (line[0]=='N') {
			/* ΋ǎ҂̃Zbg */
			if (brec_player(line)!=0) goto exit;
		} 
		else {
			// G[\
			if (bCheck) {
				sprintf(StringBuffer,"@G[łB(%s)",line);
				AfxMessageBox(StringBuffer);
			}
			goto exit;
		}
	}

    rc=0;
  exit:
	InCsa2MrecEnd(); // CSAǍݏI
    return rc;
}

////
// ΋ǒ߂̕ύX
void CDBM::ReplaceComment(char *pComment)
{
	if (m_pComment!=NULL) {
		DBF.Free(m_pComment);
		m_pComment=NULL;
	}
	if (pComment) {
		m_pComment=(char *)memalloc(strlen(pComment)+1);
		if (m_pComment) {
			strcpy(m_pComment, pComment);
		}
	}
}

/*
 * 񕝂̃`FbNEC
 */
void CDBM::adjust_width(char *cp,int width)
{
    if (strlen(cp) > (unsigned)width) {
        *(cp+width)='\0';
        if (_mbsbtype((unsigned char *)cp,width-1)==1) /* PoCgڂ̃`FbN */
            *(cp+width-1)='\0';
    }
}

// str̕񒷂szƂȂ悤ɌɑSpuN
void CDBM::fill_zenblk(CString &str,int sz)
 {
	 // ߂B
	 int n=str.GetLength();
	 if (n>=sz)
		 return;
	 char *cp=str.GetBuffer(sz+1);
	 cp+=n;
	 int m=(sz-n)/2;
	 for (int i=0;i<m;i++) {
		 strncpy(cp,"@",2);
		 cp+=2;
	 }
	 if ((sz-n)%2) {
		 *cp=' '; // oCgȂŌ͔puN
		 cp++;
	 }
	 *cp='\0';
	 str.ReleaseBuffer();
 }




/* 
 * SHGDB_B̃R[h\ ̐(dummy)
 */
void CDBM::set_disp_mrec(char *dispbuf,int w1,int w2)
{
	TRACE("set_disp_mrec dummy_func called\n");
}
