/**********************/
/*    ChildFrm.cpp    */
/**********************/
#include "stdafx.h"
#include "ChildFrm.h"
#include "WinSDJ.h"
#include "SDJView.h"
#include "sframewnd.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_SYSCOMMAND()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame NX̍\z/

CChildFrame::CChildFrame()
{
	// TODO: oR[ḧʒuɒǉĂB
	m_iCloseLock=0;
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs ̐ݒsāAWindow NX܂
	//       X^CύXĂB

	return CMDIChildWnd::PreCreateWindow(cs);
}

////////
// EBhE^Cg߂֐
//   ̊֐CFrameWnd,CMDIFrameWnd,CMDIChildWnd ̉z֐ŁA
//   PreCreateWindow()֐ɂcs.style |= FWS_ADDTOTITLEw肷(ftHg
//   ͎w)ƃ^CgɃhLg\AԖڂ̕\EBhE
//   ":n"ŕ\AƂ̂ftHg̊֐B
//   "n" CFrameWnd̓o[m_nWindowɂĊǗĂB
//   ł Ĵ ":n"\͍sȂ悤ɕύXB
// 
//   (msdev\mfc\src\winmdi.cpp CMDIChildWnd::UpdateFrameTitle())
//                                                  1997.01 by Ra
void CChildFrame::OnUpdateFrameTitle(BOOL bAddToTitle)
{
	// update our parent window first
	GetMDIFrame()->OnUpdateFrameTitle(bAddToTitle);

	if ((GetStyle() & FWS_ADDTOTITLE) == 0)
		return;     // leave child window alone!

	CDocument* pDocument = GetActiveDocument();
	if (bAddToTitle && pDocument != NULL)
	{
		TCHAR szText[256+_MAX_PATH];
		lstrcpy(szText, pDocument->GetTitle());

		/* modified by Ra  1997.01
		if (m_nWindow > 0)
			wsprintf(szText + lstrlen(szText), _T(":%d"), m_nWindow); */

		// set title if changed, but don't remove completely
		/* modified by Ra 1997.01 ̊֐afxpriv.hŐ錾Ă邪A
		   o[WɈˑB
		AfxSetWindowText(m_hWnd, szText); */
		SetWindowText(szText);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CChildFrame NX̐ff

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame NX̃bZ[Wnh

void CChildFrame::OnSysCommand(UINT nID, LPARAM lParam)
{
	nID &= 0xfff0; // }XN
    if (nID==SC_MAXIMIZE) { // ő\
		// MFC 5.0vr[(CPreviewView)ɍőt
		// Ƃ֗悤ɂȂB
		CSDJView *pView=(CSDJView *)GetActiveView();
		if (pView->IsKindOf(RUNTIME_CLASS(CSDJView))) {
			// TCY(łő)
			if (IsIconic()) {       // ACRő\
				MDIRestore();       // ̃EBhE֖߂
			}
			pView->AdjustChildFrame();
		}
		else {
			// vr[Ȃet[̃TCY܂Ŋg傷B
			if (IsIconic())
				MDIRestore();
			CWnd *pMDIClient=GetParent(); // MDICLIENT Window
			CRect rc;
			pMDIClient->GetClientRect(&rc);
			SetWindowPos(&wndTop,rc.top,rc.left,rc.Width(),rc.Height(),
				SWP_NOZORDER | SWP_SHOWWINDOW);
		}
	}
	else {
		CMDIChildWnd::OnSysCommand(nID,lParam);
	}
}


void CChildFrame::OnClose() 
{
	if (m_iCloseLock)
		return;

	// ߑJĂ
	CSDJView *pView=(CSDJView *)GetActiveView();
	if (pView->IsKindOf(RUNTIME_CLASS(CSDJView))) {
		pView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);
	}
	
	CMDIChildWnd::OnClose();
}

///////
// EChẼN[Y
void CChildFrame::SetCloseLock(BOOL bLock)
{
	CMainFrame *pMainFrame=(CMainFrame *)GetMDIFrame();
	ASSERT(pMainFrame->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	pMainFrame->SetCloseLock(bLock);
	if (bLock)
		m_iCloseLock++;
	else if (m_iCloseLock)
		m_iCloseLock--;
}

