/**********************/
/*    DbeFrame.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DbeFrame.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDbeFrame

IMPLEMENT_DYNCREATE(CDbeFrame, CFrameWnd)

CDbeFrame::CDbeFrame()
{
	m_pSdjParent=NULL;
	m_iCloseLock=0;
}

CDbeFrame::~CDbeFrame()
{
}

BEGIN_MESSAGE_MAP(CDbeFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CDbeFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

int CDbeFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	return 0;
}

BOOL CDbeFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// ̎_ł͂܂View̐ݒ͂ȂĂȂ̂
	// CMainFramer[TB
	CMDIFrameWnd *pMDIFrame=(CMDIFrameWnd *)AfxGetMainWnd();
	ASSERT(pMDIFrame->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	CMDIChildWnd *pMDIChild=pMDIFrame->MDIGetActive();
	if (pMDIChild) { // ړĨANeBu̓r[
		CRect rect;
		pMDIChild->GetClientRect(&rect);	// r[̃NCAg̈
		rect.right=rect.left+138;			// Ց̑傫
		rect.top=rect.bottom-213;
		pMDIChild->ClientToScreen(&rect);	// Wϊ
		cs.x=rect.left;
		cs.y=rect.top;
		cs.cx=rect.Width();
		cs.cy=rect.Height();

		cs.hwndParent = pMDIFrame->m_hWnd;	// eEBhE(C)
		cs.style &=~WS_CHILD;				// POPUPEBhE
		cs.style |= WS_POPUP;
	}

	return CFrameWnd::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CDbeFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CDbeFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDbeFrame bZ[W nh

BOOL CDbeFrame::DestroyWindow() 
{
	if (theApp.m_bDbeUsing) {
		theApp.m_bDbeUsing = FALSE;
		// et[LĂ鎩̋LB
		GetSdjParent()->SendMessage(WM_COMMAND,ID_SETDBEFRAME_NULL);
	}

	return CFrameWnd::DestroyWindow();
}

void CDbeFrame::OnClose() 
{
	if (m_iCloseLock)
		return;
	CFrameWnd::OnClose();
}

///// 
// N[ỸbN/bN
void CDbeFrame::SetCloseLock(BOOL bLock)
{
	CMainFrame *pMainFrame=(CMainFrame *)AfxGetMainWnd();
	ASSERT(pMainFrame->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	pMainFrame->SetCloseLock(bLock);
	if (bLock)
		m_iCloseLock++;
	else if (m_iCloseLock)
		m_iCloseLock--;
}
