/***********************/
/*    DlgDelDbb.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgDelDbb.h"
#include "StatusBox.h"
#include "sbasedbb.h"
#include <afxtempl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgDelDbb _CAO

void CDlgDelDbb::CommonInit()
{
	//{{AFX_DATA_INIT(CDlgDelDbb)
	m_iItemNum = 0;
	m_iSelItemNum = 0;
	m_Shgdb = _T("");
	//}}AFX_DATA_INIT
}

CDlgDelDbb::CDlgDelDbb(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDelDbb::IDD, pParent)
{
	CommonInit();
}

CDlgDelDbb::CDlgDelDbb(int idd,CWnd *pParent /*=NULL*/)
    : CDialog(idd,pParent)
{
	CommonInit();
}

void CDlgDelDbb::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDelDbb)
	DDX_Control(pDX, IDC_MULTISELLIST, m_MultiSelList);
	DDX_Text(pDX, IDC_ITEMNUM, m_iItemNum);
	DDV_MinMaxInt(pDX, m_iItemNum, 0, 99999);
	DDX_Text(pDX, IDC_ITEMNUM2, m_iSelItemNum);
	DDV_MinMaxInt(pDX, m_iSelItemNum, 0, 99999);
	DDX_Text(pDX, IDC_SHGDB, m_Shgdb);
	DDV_MaxChars(pDX, m_Shgdb, 512);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgDelDbb, CDialog)
	//{{AFX_MSG_MAP(CDlgDelDbb)
	ON_BN_CLICKED(IDC_SELECTALL, OnSelectAll)
	ON_LBN_SELCHANGE(IDC_MULTISELLIST, OnSelchangeMultisellist)
	ON_BN_CLICKED(IDOK, OnDeleteDbb)
	ON_COMMAND(ID_UPDATE_DISPLAY, OnUpdateDisplay)
	ON_BN_CLICKED(IDC_DUPDEL, OnDupdel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgDelDbb bZ[W nh

BOOL CDlgDelDbb::OnInitDialog() 
{
	char *shgdb=getenv("SHGDB");
	if (shgdb)
		m_Shgdb.Format("%s",shgdb); // f[^x[X

	m_SelectBoxB.ReadPrevInfo(); // O񌟍̓ǂݏo

	CDialog::OnInitDialog();
	
	// ʃXg̓eʂɕ\B
	DispList();

	UpdateDisplay(); // \XV
	CheckDlgButton(IDC_CHECKCOPY, 1); // ߏWt`FbNB

	GotoDlgCtrl(&m_MultiSelList); // Xg\

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////
// ʃXg̓eʂɕ\B
void CDlgDelDbb::DispList()
{
	CList <DBRNO,DBRNO&> *pDbrFindList=m_SelectBoxB.GetDbrFindList();
	CList <DBRNO, DBRNO&> DbrnoList; // DBBʍƃXg
	POSITION pos;
	DBRNO Dbrno;
	CWaitCursor waitcr; // v

	CDBB Dbb; // ΋ǂca
	char dispbuf[512];
	m_MultiSelList.ResetContent(); // SelectListɂB
	if (Dbb.Open()) { // ΋ǂcãI[v
		Dbb.DBFOpen(); // ߂cãI[v
		pos=pDbrFindList->GetHeadPosition();
		while (pos) {
			Dbrno=pDbrFindList->GetNext(pos);
			// DBRNOɊY΋ǃR[hǂށB
			int rc=Dbb.ReadByDbrno(Dbrno.dbrno);
			if (rc==E$OK) { // ɓǂ߂\B
				Dbb.set_disp_mrec(dispbuf); // \̐
				m_MultiSelList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DbrnoList.AddTail(Dbrno); // ƃXgɒǉ
			}
		}
		Dbb.DBFClose(); // ߂cãN[Y
		Dbb.Close(); // ΋ǂcãN[Y
	}
	// DbrnoList̓epDbrFindList֔fB
	pDbrFindList->RemoveAll(); // XgɂB
	pos=DbrnoList.GetHeadPosition();
	while (pos) {
		// DbrnoListpDbrFindListփRs[
		Dbrno=DbrnoList.GetNext(pos);
		pDbrFindList->AddTail(Dbrno); 
	}
	DbrnoList.RemoveAll(); // DbrnoList
}

// SI(gOŉ)
void CDlgDelDbb::OnSelectAll() 
{
	int cnt=m_MultiSelList.GetCount(); // s
	if (cnt > 0) {
		if (cnt!=m_MultiSelList.GetSelCount()) { // s != I
			if (cnt>1)
				m_MultiSelList.SelItemRange(TRUE,0,cnt-1); // I
			else
				m_MultiSelList.SetSel(0,TRUE); // I
		}
		else
			m_MultiSelList.SelItemRange(FALSE,0,cnt-1); // 
	}

	UpdateDisplay(); // \XV
}

/////
// I𐔂̕\ύXꂽƂ
void CDlgDelDbb::OnSelchangeMultisellist() 
{
	UpdateDisplay();  // \XV
}

// Xe[^X{bNX̕\
static void OutputMessage(CStatusBox *pBox, char *cp)
{
	if (pBox)
		pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE, (LPARAM)cp);
	else
		TRACE("%s\n",cp);
}
////
// ΋Ǌ폜[J[Xbh
static UINT OnDeleteDbbThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgDelDbb *pDlg=(CDlgDelDbb *)lParam;
	CSelectBoxB *pSelectBoxB=pDlg->GetSelectBoxB();
	CList <DBRNO,DBRNO&> *pDbrFindList=pSelectBoxB->GetDbrFindList();
	char StringBuffer[512];
 
	// ΋ǂcãI[v
	CDBB Dbb;
	char dispbuf[512];
	DBRNO Dbrno;
	int Index,iNum;
	int iCounter=0;

    BOOL Bopen=FALSE;
    BOOL Dopen=FALSE;
    BOOL Fopen=FALSE;
	Bopen=Dbb.Open();
	if (Bopen) {
		Dopen=Dbb.DBDOpen();
		Fopen=Dbb.DBFOpen();
	}
	if (Bopen && Dopen && Fopen) { // SăI[v
		iNum=pDlg->m_MultiSelList.GetCount();
		for (Index=0;Index < iNum;Index++) {
			if (pDlg->m_MultiSelList.GetSel(Index)) { // ̃ZIĂ
				POSITION pos=pDbrFindList->FindIndex(Index);
				if (pos==NULL)
					break; // I
				Dbrno=pDbrFindList->GetAt(pos);
				// DBRNOɊY΋ǃR[hǂށB(\ׂ̈Ɉǂ)
				int rc=Dbb.ReadByDbrno(Dbrno.dbrno);
				if (rc==E$OK) { // ɓǂ߂
					// \̐
					Dbb.set_disp_mrec(dispbuf);
					rc=Dbb.DeleteByDbrno(Dbrno.dbrno);// ̑΋Ǌ폜
					if (rc!=E$NOTFOUND) {
						if (rc==E$OK) {
							// \XgAʃXg폜B
							pDlg->m_MultiSelList.DeleteString(Index);
							if (iNum>1)
								pDlg->m_MultiSelList.SetTopIndex(Index-1);
							pDlg->PostMessage(WM_COMMAND,ID_UPDATE_DISPLAY); // \XV
							pDbrFindList->RemoveAt(pos);
							sprintf(StringBuffer,"%s폜܂B",dispbuf);
							iCounter++; // o̓JE^[+1
							Index--;    // +1邩炱ňĂ
							iNum--;		// -1
						}
						else {
							sprintf(StringBuffer,
								"%s̍폜Ɏs܂(rc=%d)B", dispbuf,rc);
						}
						OutputMessage(pBox,StringBuffer);
					}
				}
			}
			// fI`FbN
			if (WaitForSingleObject(*pStopEvent, 0)==WAIT_OBJECT_0) {
				sprintf(StringBuffer,"΋Ǌ폜𒆒fI܂B");
				OutputMessage(pBox,StringBuffer);
				break;
			}
		}
		char str1[80],str2[80];
		_strdate(str1); _strtime(str2);
		sprintf(StringBuffer,"%d 폜܂(%s %s)B",iCounter,str1,str2);
		OutputMessage(pBox,StringBuffer);
	}
	if (Fopen) Dbb.DBFClose();
	if (Dopen) Dbb.DBDClose();
	if (Bopen) Dbb.Close();

	if (iCounter) { // 
		// 폜R[hʂ̃XgOB
		pSelectBoxB->SetSelNo(0);
		pSelectBoxB->WritePrevInfo(); // ʂ̃t@CXVB
	}

	return TRUE;
}

//////
// ΋Ǌ̍폜
void CDlgDelDbb::OnDeleteDbb() 
{
	UpdateData(TRUE); // ϐ̍XV

	// I𐔂̃`FbN
	if (m_iSelItemNum <=0) 
		return ; // IĂȂB

	// 폜̔O
	int MBret=IDNO;
	CString strbuf;
	strbuf.Format("%d ̊폜܂B낵łH",m_iSelItemNum);
	MBret=AfxMessageBox(strbuf,MB_YESNO);
	if (MBret!=IDYES)
		return;

	// j^\{bNX  ƊJn
	CStatusBox StatusBox(&OnDeleteDbbThread,(LPARAM)this);
	StatusBox.DoModal();

	CDialog::OnOK(); // OKI
}

// f[^̍XV\
void CDlgDelDbb::UpdateDisplay()
{
	m_iItemNum=m_MultiSelList.GetCount(); // 
	m_iSelItemNum=m_MultiSelList.GetSelCount(); // I
	UpdateData(FALSE);
}


// bZ[Wɂf[^XV\
void CDlgDelDbb::OnUpdateDisplay()
{
	UpdateDisplay();
}


////
// ̃\[gƍ폜iVO)
//   parySBaseDbb̐擪nΏۂƂB
//   parySBaseDbb擪ڂpDlg->m_MultiSelListIndex1̍ڂɑΉB
//   parySBaseDbb擪ڂ͏񂩂琔cntڂ̏łB
//   pBox, pDlg, pDbrFindList, piCounter, pIndex, piNum͌Ăяo̕ϐ̂܂ܓn
//   ApiCounter,pIndex,piNum̒lXVB
static void SortAndSingle(CStatusBox *pBox, CDlgDelDbb *pDlg,
				  CList <DBRNO,DBRNO&> *pDbrFindList,
				  CArray <CSBaseDbb*, CSBaseDbb*> &parySBaseDbb, int n, int Index1,int cnt,
				  int *piCounter, int *pIndex, int *piNum)
{
	int i, j;
	CSBaseDbb *psbdbb;
	char StringBuffer[512];
	char dispbuf[512];
	int iCopyCheck=pDlg->IsCopyChecked();
	int update=0;
	POSITION pos;

	if (n==0) return ; // 肦Ȃ

	// nrecnoi)Ƀ\[g(n<=1Ȃ牽Ȃ)
	for (i=0; i<n-1; i++) {
		for (j=i+1; j<n; j++) {
			if (parySBaseDbb[i]->GetDbb()->get_mrec_recno() >
				parySBaseDbb[j]->GetDbb()->get_mrec_recno() ) {
				psbdbb=parySBaseDbb[i];
				parySBaseDbb[i]=parySBaseDbb[j];
				parySBaseDbb[j]=psbdbb;
			}
		}
	}
	// oAߕʏ
	if (iCopyCheck) {
		for (i=1;i<n;i++)
			update+=parySBaseDbb[0]->AddInfo(parySBaseDbb[i]);
	}
	// robt@̕\
	for (i=0; i<n; i++) {
		parySBaseDbb[i]->GetDbb()->set_disp_mrec(dispbuf);
		if (i==0)
			sprintf(StringBuffer,"%d ͍XV%słB %s",cnt+i, (update)? "L":  "",dispbuf);
					
		else
			sprintf(StringBuffer,"%d d폜܂B %s",cnt+i, dispbuf);
		OutputMessage(pBox,StringBuffer);
	}
	// XV
	if (update) {
		int rc=parySBaseDbb[0]->WriteDbb(); // ǍݍςȂ̂ōXVB
		if (rc<0) {
			sprintf(StringBuffer,"(΋ǔԍ=%06d)̍XVɎs܂B",
				parySBaseDbb[0]->GetDbb()->get_mrec_recno());
			OutputMessage(pBox,StringBuffer);
		}
	}
	// d폜
	if (n>1) {
		// 폜ȂǍݍςDbbłKv͂ȂB
		// forȉZ߂1open-closeŏׂɂPDbbgpB
		CDBB Dbb; 
		BOOL Bopen=FALSE;
		BOOL Dopen=FALSE;
		BOOL Fopen=FALSE;
		Bopen=Dbb.Open();
		if (Bopen) {
			Dopen=Dbb.DBDOpen();
			Fopen=Dbb.DBFOpen();
		}
		if (Bopen && Dopen && Fopen ) {
			for (i=1;i<n;i++) {
				long recno=parySBaseDbb[i]->GetDbb()->get_mrec_recno();
				int rc=Dbb.DeleteByDbrno(recno);
				if (rc!=E_NOTFOUND) {
					if (rc==E_OK) {
						// \XgAʃXg폜B
						pDlg->m_MultiSelList.DeleteString(Index1+i);
						if (*piNum>1)
							pDlg->m_MultiSelList.SetTopIndex(Index1+i); // \XN[
						pDlg->PostMessage(WM_COMMAND,ID_UPDATE_DISPLAY); // \XV
						pos=pDbrFindList->FindIndex(Index1+i);
						ASSERT(pos!=NULL);
						pDbrFindList->RemoveAt(pos);
						Index1--;  // \EʃXg폜̂-1B
						(*piCounter)++; // 폜JE^[+1
						(*pIndex)--;    // Ăяo̒lňB
						(*piNum)--;		// -1
					}
					else {
						sprintf(StringBuffer,
							"%s̍폜Ɏs܂(rc=%d)B", dispbuf,rc);
						OutputMessage(pBox,StringBuffer);
					}
				}
			}
		}
		if (Fopen) Dbb.DBFClose();
		if (Dopen) Dbb.DBDClose();
		if (Bopen) Dbb.Close();
	}
}
////
// ΋Ǌd폜[J[Xbh
static UINT OnDupdelThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgDelDbb *pDlg=(CDlgDelDbb *)lParam;
	CSelectBoxB *pSelectBoxB=pDlg->GetSelectBoxB();
	CList <DBRNO,DBRNO&> *pDbrFindList=pSelectBoxB->GetDbrFindList();

	char StringBuffer[512];
	DBRNO Dbrno;
	int Index,iNum,Index1;
	int iCounter=0; // 폜
	int icnt=0;       // 

	char str1[80],str2[80];
	int rc;
	POSITION pos;

	CArray <CSBaseDbb*, CSBaseDbb*> parySBaseDbb;
	CSBaseDbb *psbdbb;
	int i;

	parySBaseDbb.Add(new CSBaseDbb); // Ɨpɂ܂1B
	int cn=0; // r

	iNum=pDlg->m_MultiSelList.GetCount();
	for (Index=0;Index < iNum;Index++) {
		// fI`FbN
		if (WaitForSingleObject(*pStopEvent, 0)==WAIT_OBJECT_0) {
			sprintf(StringBuffer,"΋Ǌd폜𒆒fI܂B");
			OutputMessage(pBox,StringBuffer);
			goto exit;
		}

		if (pDlg->m_MultiSelList.GetSel(Index) <=0 ) // ̃ZIĂȂ
			continue;
		//
		// ̃ZIĂȉ̏B
		//
		pos=pDbrFindList->FindIndex(Index);
		if (pos==NULL)
			goto exit; // I(肦Ȃ)
		Dbrno=pDbrFindList->GetAt(pos);

		// DBRNOɊY΋ǃR[hǂށB(\ׂ̈Ɉǂ)
		Dbrno.tesu=0; // ǖʂœǂ
		// ̏
		if (cn==0) {
			rc=parySBaseDbb[0]->ReadDbb(Dbrno);
			if (rc==0) {// Ǎ
				cn++; // Pǂݍ
				Index1=Index;
				icnt++;  // +1
			}
			continue;
		}
		// ȉ͂Qڈȍ~(cn>0)̎
		if (cn==parySBaseDbb.GetSize())
			parySBaseDbb.Add(new CSBaseDbb); // g
		rc=parySBaseDbb[cn]->ReadDbb(Dbrno);
		if (rc!=0)
			continue;
		icnt++;  // +1
		cn++; // cnǂݍ

		// vo瑱ēǂݍ
		if (*parySBaseDbb[0] == *parySBaseDbb[cn-1] )
			continue;
				
		// ȉ͈vȂ𔭌

		// cn-1ΏۂɃ\[gVOs
		// )̏iCounter,Index,iNum̒l͕ωB
		SortAndSingle(pBox, pDlg, pDbrFindList, parySBaseDbb, cn-1, Index1, icnt-cn+1,
			&iCounter, &Index, &iNum);

		// Ōɓǂݍ񂾊͎񂩂̔r(parySBaseDbb[0])ɐݒ肷B
		psbdbb=parySBaseDbb[0];
		parySBaseDbb[0]=parySBaseDbb[cn-1];
		parySBaseDbb[cn-1]=psbdbb;
		cn=1;
		Index1=Index;
	}
	// cnΏۂɃ\[gVOs
	SortAndSingle(pBox, pDlg, pDbrFindList, parySBaseDbb, cn, Index1, icnt-cn+1,
		&iCounter, &Index, &iNum);

exit:
	_strdate(str1); _strtime(str2);
	sprintf(StringBuffer,"%d 폜܂(%s %s)B",iCounter,str1,str2);
	OutputMessage(pBox,StringBuffer);

	if (iCounter) { // 
		// 폜R[hʂ̃XgOB
		pSelectBoxB->SetSelNo(0);
		pSelectBoxB->WritePrevInfo(); // ʂ̃t@CXVB
	}

	// newCSBaseDbbdeleteRemoveAll
	for (i=0; i<parySBaseDbb.GetSize(); i++)
		delete parySBaseDbb[i];
	parySBaseDbb.RemoveAll();

	return TRUE;
}

/////////////
// d̍폜
void CDlgDelDbb::OnDupdel() 
{
	UpdateData(TRUE); // ϐ̍XV

	// I𐔂̃`FbN
	if (m_iSelItemNum <=1) 
		return ; // Pȉł͉IȂB

	// 폜̔O
	int MBret=IDNO;
	CString strbuf;
	strbuf.Format("%d ̊̒d폜܂B낵łH",m_iSelItemNum);
	MBret=AfxMessageBox(strbuf,MB_YESNO);
	if (MBret!=IDYES)
		return;

	// j^\{bNX  ƊJn
	CStatusBox StatusBox(&OnDupdelThread,(LPARAM)this);
	StatusBox.DoModal(); 
}
