/**********************/
/*    DlgDelJS.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgDelJS.h"
#include "StatusBox.h"
#include <dbe.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgDelJS _CAO


CDlgDelJS::CDlgDelJS(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDelJS::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgDelJS)
	m_Depth = 1;
	m_strFileName = _T("");
	//}}AFX_DATA_INIT
}


void CDlgDelJS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDelJS)
	DDX_Text(pDX, IDC_EDIT_NUM, m_Depth);
	DDV_MinMaxInt(pDX, m_Depth, 1, 300);
	DDX_Text(pDX, IDC_CSA_FILENAME, m_strFileName);
	DDV_MaxChars(pDX, m_strFileName, 256);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgDelJS, CDialog)
	//{{AFX_MSG_MAP(CDlgDelJS)
	ON_BN_CLICKED(IDC_DISPLAY, OnDisplay)
	ON_BN_CLICKED(IDC_FILE_SELECT, OnFileSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgDelJS bZ[W nh

////////////////////////
// Ճt@Co [J[Xbh
//   t@CI[vāAՂt@Cɏo͂B
static UINT RemoveThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgDelJS *pDlgDelJS=(CDlgDelJS *)lParam;
	CString *pstrFile	=&pDlgDelJS->m_strFileName;
	CString strFile	=*pstrFile;
	CBform Bform(&pDlgDelJS->m_Bform);
	int side		=pDlgDelJS->m_side;
	int Depth		=pDlgDelJS->m_Depth;
	long total;
	char StringBuffer[256];

	BOOL bQuit=FALSE;

	CDBE Dbe;
	if (!Dbe.Open()) { // DB I[vs
		return 1;
	}
	
	Dbe.SetQuitObject((HANDLE)(*pStopEvent)); // fCxg̐ݒ
	Dbe.CommentWriteEnable(TRUE);		      // ߍ폜̗L

	if (strFile.IsEmpty()) {
		// obNAbvt@C̓G[
		CString str;
		str.Format("obNAbvt@C͂ĂB");
		AfxMessageBox(str);
		bQuit=TRUE;
	}

	if (!bQuit) {
		CFile f;
		// t@C̃I[v
		if (f.Open(strFile,
			CFile::modeReadWrite | CFile::modeCreate | CFile::shareDenyWrite
			)) { 
			CSDJArchive ar(&f,CArchive::store);
			Dbe.SetMessageWindow(pBox);
			// Ղca폜AeobNAbvt@C֏o͂B
			total=Dbe.DelDBE2Csa(ar,&Bform,side,Depth);
			ar.Close();
			f.Close();
			if (total > 0L) {
				sprintf(StringBuffer,"%ld  폜܂B",total);
			} else {
				sprintf(StringBuffer,"w̍폜͂܂B");
			}
			pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)StringBuffer);
		}
		else { // CSAt@CI[vG[
			CString str;
			str.Format("t@C(%s)I[vł܂B",strFile);
			AfxMessageBox(str);
			bQuit=TRUE;
		}
	}

	Dbe.Close();
	return (UINT)(!bQuit);
}

//////
// 폜
void CDlgDelJS::OnOK() 
{
	if (!UpdateData(TRUE))
		return;

	// CSA t@C̃I[v`FbN
	CFile fcsa;
	int MBret=IDYES;

	CString strbuf;
	CString strMes;
	strbuf.Format("݂̋ǖʂ %d̐[܂ŒՂ폜܂B\r\n",m_Depth);
	strMes=strbuf;
	strbuf.Format("폜ꂽe̓obNAbvt@C(%s)ɏ㏑܂B\r\n",
		m_strFileName);
	strMes += strbuf;
	strMes += "낵łH";

	MBret=AfxMessageBox(strMes,MB_YESNO);

	if (MBret!=IDYES)
		return;

	// t@C̋L
	theApp.WriteProfileString(JS_SECTION,JS_BAKFILENAME,m_strFileName);

	// Ս폜
	CStatusBox StatusBox(&RemoveThread,(LPARAM)this); // t@C̏o
	StatusBox.DoModal();
	
	CDialog::OnOK();
}

////////////////////////
// Ճj^o [J[Xbh
//   PCLt@Cej^֏o͂B
static UINT DispThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgDelJS *pDlgDelJS=(CDlgDelJS *)lParam;
	CBform Bform(&pDlgDelJS->m_Bform);
	int side		=pDlgDelJS->m_side;
	int Depth		=pDlgDelJS->m_Depth;
	long total;
	char StringBuffer[256];

	CDBE Dbe;
	if (!Dbe.Open()) { // DB I[vs
		return 1;
	}
	
	Dbe.SetQuitObject((HANDLE)(*pStopEvent)); // fCxg̐ݒ
	Dbe.CommentWriteEnable(TRUE);		      // ߂̏o̗͂L
	Dbe.SetMessageWindow(pBox);

	// ՂCSA`Ńj^o͂B
	total=Dbe.DispDBE2Csa(&Bform,side,Depth);
	if (total > 0L) {
		sprintf(StringBuffer,"%ld  o͂܂B",total);
	} else {
		sprintf(StringBuffer,"w̏o͂͂܂B");
	}
	pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)StringBuffer);

	Dbe.Close();
	return 0;
}

///////////
// \mF
void CDlgDelJS::OnDisplay() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if (!UpdateData(TRUE))
		return;

	// Օ\
	CStatusBox StatusBox(&DispThread,(LPARAM)this); // t@C̏o
	StatusBox.DoModal();
}

///////
// t@C̑I
void CDlgDelJS::OnFileSelect() 
{
	if (!UpdateData(TRUE))
		return;

	CString strFile=m_strFileName;
	if (strFile.IsEmpty())
		// CSAt@C(fBNĝ)
		strFile.Format("%s*.pcl",GetShgdbName()); 

	CFileDialog dlgJS(TRUE,	// Ǎ݃_CAO
			"pcl",				// ftHggq
			strFile,	    // ftHgPCLt@C
			(DWORD)(OFN_HIDEREADONLY), // t@C̑
			"CSAt@C (*.pcl)|*.pcl| CSAt@C (*.csa)|*.csa||");
	BOOL bResult = dlgJS.DoModal();

	if (bResult == IDOK) { // I
		m_strFileName = dlgJS.GetPathName();
		UpdateData(FALSE);
	}
}

BOOL CDlgDelJS::OnInitDialog() 
{
	// ftHg̃t@C
	CString defFileName;
	defFileName.Format("%sJsBackup.pcl",GetShgdbName());
	m_strFileName=theApp.GetProfileString(JS_SECTION,JS_BAKFILENAME,defFileName);

	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
