/************************/
/*    DlgEvalBox.cpp    */
/************************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgEvalBox.h"
#include "dbeframe.h"
#include <dbe.h>
#include "ecell.h"
#include "dbedoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/// O[o
extern CWinSDJApp theApp;
extern HANDLE g_hDblock;

/////////////////////////////////////////////////////////////////////////////
// CDlgEvalBox _CAO

CDlgEvalBox::CDlgEvalBox(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgEvalBox::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgEvalBox)
	m_Eval = 0;
	m_strMove = _T("");
	//}}AFX_DATA_INIT
	m_bInitOK=FALSE;
}

void CDlgEvalBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgEvalBox)
	DDX_Text(pDX, IDC_EVAL, m_Eval);
	DDV_MinMaxInt(pDX, m_Eval, 0, 256);
	DDX_Text(pDX, IDC_STRMOVE, m_strMove);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgEvalBox, CDialog)
	//{{AFX_MSG_MAP(CDlgEvalBox)
	ON_WM_DESTROY()
	ON_COMMAND(ID_EVALBOX_INITDATA,OnEvalBoxInitData)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgEvalBox bZ[W nh

////
// `]lݒI
void CDlgEvalBox::OnOK() 
{
	if (!UpdateData(TRUE)) // f[^̎荞
		return;
	if (!m_bInitOK)  // f[^̏܂ĂȂB
		return ; 

	if (m_Eval != eclCld->eval) {
		// Վ葮l̍XV
		// f[^x[XP񂾂bNĎsreturnB
		if (WaitForSingleObject(g_hDblock,0)!=WAIT_OBJECT_0) {
			AfxMessageBox("f[^x[X͎gpł");
			return;
		}
		pFrame->SetCloseLock(TRUE);
		
		CDBE Dbe;
		int rc;
		if (Dbe.Open()) {
			//  Ղca̍XV
			rc=Dbe.UpdateEval(&eclCld->Bform,eclCld->side,(short)m_Eval);
			Dbe.Close();
		}
		ReleaseMutex(g_hDblock); // DB unlock
		pFrame->SetCloseLock(FALSE);

		if (rc==E$OK)  {
			// w̌`]lXVB
			eclCld->eval=m_Eval;

			// Վl̑JĂ\XVB
			CWnd *pWnd=GetParent(); // DbeFrame
			pWnd->SendMessage(WM_COMMAND,ID_ECELLBOX_INITDATA);
		} else {
			CString mes;
			mes.Format("`]l̍XVɎs܂(%d)",rc);
			AfxMessageBox(mes);
		}
	}

	DestroyWindow();
}

////
// LZI
void CDlgEvalBox::OnCancel() 
{
	DestroyWindow();
}

////
// IuWFNg̔j
void CDlgEvalBox::PostNcDestroy() 
{
	delete this;
}

////
// e̋L
void CDlgEvalBox::OnDestroy() 
{
	CDialog::OnDestroy();
	
	CWnd *pWnd=GetParent(); // CDbeFrame
	pWnd->SendMessage(WM_COMMAND,ID_DLG_EVALBOX_SETNULL);
}

////
// 
BOOL CDlgEvalBox::OnInitDialog() 
{
	InitData(); // f[^̏

	CDialog::OnInitDialog();
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////
// f[^̏
void CDlgEvalBox::InitData()
{
	m_bInitOK=FALSE;

	m_strMove.Empty();
	m_Eval=0;
	SList.RemoveAll();

	if (theApp.m_bSelectBoxBUsing)
		return ; // EI_CAOgp
	
	HTREEITEM hRoot=pTreeCtrl->GetRootItem();
	if (hRoot==NULL)
		return ; // Վ肪Ȃ

	HTREEITEM hNow =pTreeCtrl->GetSelectedItem();
	if (hNow==NULL)
		return ; // I

	POSITION pos=(POSITION)pTreeCtrl->GetItemData(hNow);
	CList <CEcell,CEcell&> *pEcellList=pDoc->GetEcellList();
	eclCld=pEcellList->GetAt(pos);

	m_strMove =eclCld->strMove;
	m_Eval	  =eclCld->eval;

	// Zׂċ߂Ă
	// ܂͒j߂
	HTREEITEM hChild1; // j
	HTREEITEM hParent=pTreeCtrl->GetParentItem(hNow);
	if (hParent)
		hChild1=pTreeCtrl->GetChildItem(hParent);
	else
		hChild1=hNow;
	HTREEITEM hInsItem=hChild1;
	//  Zׂm_pDlgEvalBox->SList LB
	while (hInsItem) {
		POSITION p=(POSITION)pTreeCtrl->GetItemData(hInsItem);
		CEcell *eclItem=pEcellList->GetAt(p);
		SList.AddTail(eclItem);
		hInsItem=pTreeCtrl->GetNextSiblingItem(hInsItem);
	}

	m_bInitOK=TRUE;
}

//////
// \XV
void CDlgEvalBox::OnEvalBoxInitData()
{
	InitData();
	UpdateData(FALSE);
}
