/**********************/
/*    DlgInPcl.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgInPcl.h"
#include "StatusBox.h"
#include <dbc.h>
#include "winmemfile.h"
#include "winsdjtsdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

/////////////////////////////////////////////////////////////////////////////
// CDlgInPcl _CAO


CDlgInPcl::CDlgInPcl(CWnd* pParent /*=NULL*/)
	: CDlgInCsa(CDlgInPcl::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgInPcl)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}

void CDlgInPcl::DoDataExchange(CDataExchange* pDX)
{
	CDlgInCsa::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgInPcl)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgInPcl, CDlgInCsa)
	//{{AFX_MSG_MAP(CDlgInPcl)
	ON_BN_CLICKED(IDC_FILE_SELECT, OnFileSelect)
	ON_BN_CLICKED(IDOK, OnTouroku)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgInPcl bZ[W nh

//////
// PCLt@C̑I
void CDlgInPcl::OnFileSelect() 
{
	CString PclFile=m_strCsaFile;
	if (PclFile.IsEmpty())
		// CSAt@C(fBNĝ)
		PclFile.Format("%s*.pcl",GetShgdbName()); 

	CFileDialog dlgInCsa(TRUE,	// Ǎ݃_CAO
			"pcl",				// ftHggq
			PclFile,		    // ftHgCSAt@C
			(DWORD)(OFN_HIDEREADONLY | OFN_FILEMUSTEXIST), // t@C̑
			"PCLt@C (*.pcl)|*.pcl||");
	BOOL bResult = dlgInCsa.DoModal();

	if (bResult == IDOK) { // I
		m_strCsaFile = dlgInCsa.GetPathName();
		UpdateData(FALSE);

		// t@C̎w肪΂m_edContents֓ǂݏo
		SetEditCsaContents();

		// Iꂽt@Cvt@CփZ[uB
		// OnInitDialogŎQƂB
		WritePclFname(m_strCsaFile);
	}
}

////
/// _CAȌ
BOOL CDlgInPcl::OnInitDialog() 
{
	CWaitCursor waitcr; // v
	m_iMode=0; // ɐVKo^(ftHg)
	
	// It@C̋L(vt@C)ΓǂݏoB
	GetPclFname(m_strCsaFile,FALSE);

	CDialog::OnInitDialog();

	// t@C̎w肪΂m_edContents֓ǂݏo
	SetEditCsaContents(FALSE); // ͌x\ȂB


	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

///////////////
// PCLt@CeGfBbg{bNXɕ\B
//  bMessageTRUE(ftHg)ȂxbZ[WL
void CDlgInPcl::SetEditCsaContents(BOOL bMessage)
{
	if (m_strCsaFile.IsEmpty())
		return ;

	FILE *fp;

	// String buffer  Ɨp
	char buffer[CSALINE_MAX]; // PCLt@CsǍ݃obt@(CSA MAXs)
	char *buf,*buf1;
	int bufsize,buflen,len;
	
	bufsize=sizeof buffer; // String Buffer̃TCY8KPʂɂ
	if ((buf=(char *)memalloc(bufsize))==NULL) {
		AfxMessageBox("No memory!!");
		return;
	}
	// String Buffeȑ
	buf[0]='\0';
	buflen=0; // Buffer Length = 0

	fp=fopen(m_strCsaFile,"rt");
	if (fp!=NULL) {
		m_edCsaContents.SetReadOnly(FALSE); // obt@ҏW\ƂB
		// eLXgt@C"rt"ŃI[vfgets()œǂނƂɂB
		// eLXgt@C"\n"̍s"\r\n"̍sL蓾B
		// fgets()͂ǂ̃P[Xł"\n"ƂēǂݏoB
		for (int nLine=0;fgets(buffer,sizeof buffer -3,fp)!=NULL; nLine++) { // 
			// String Buffer Max 3000s܂
			// (5000ɂSetWindowTextĂȂ)
			if (nLine == 3000) {
				if (bMessage)
					AfxMessageBox(
 "PCLt@C͑傫̂ŕҏW͏o܂B\nAÂ܂ܓo^邱Ƃ͉\łB");
				m_edCsaContents.SetReadOnly(TRUE); // obt@[hI[ɂB
				break;
			}
			char *cp=strchr(buffer,'\n'); // fgetsœǂނ"\n"tēǂ܂
			if (cp!=NULL)
				strcpy(cp,"\r\n"); // WindowText͉sR[hKv

			// String Buffer̃TCY`FbN
			// ǂ񂾍sǉłȂ΃obt@gB
			len=strlen(buffer);
			if (buflen+len+1 > bufsize) {
				// obt@̊g
				bufsize+=sizeof buffer; // gTCY
				if ((buf1=(char *)memalloc(bufsize))==NULL) {
					AfxMessageBox("No memory!!");
					break;
				}
				strcpy(buf1,buf); // obt@̓eVobt@փRs[B
				memfree(buf);     // obt@͊JB
				buf=buf1; // obt@̊g
			}
			strcat(buf,buffer); // String Buffer֍sǍ݃obt@̓eǉB
			buflen+=len; // Buffer Length
		}
		fclose(fp);
	}
	m_edCsaContents.SetWindowText(buf);
	m_edCsaContents.SetModify(FALSE); // CtOZbg

	if (buf)
		memfree(buf);
}
///
// PǕ̓o^
static BOOL inpcl2db(CWinSDJTSDoc &WorkDocument,CStatusBox *pBox,BOOL bIgnoreRecno)
{
	// WorkDocument̖{菇t@Cɏo͂B
	CWinMemFile Mfile;		   // t@C(PǕ)
	CSDJArchive arOut(&Mfile,CArchive::store);
	WorkDocument.Serialize(arOut,TRUE); // {菇o
	arOut.Close();

	// t@C̖{菇caɓo^B
	Mfile.Seek(0L,CFile::begin); // t@Co
	CSDJArchive arIn(&Mfile,CArchive::load);
	DBRNO Dbrno;
	// {菇cao^(g[^̕\͂Ȃ悤ɂ)
	Dbrno.dbrno=WorkDocument.m_Dbc.InCsa2DB(arIn,pBox,bIgnoreRecno,FALSE); 
	arIn.Close();
	if (Dbrno.dbrno<0)
		return FALSE; // ُI

	// {菇̂cao^IwPCLt@CXV(o^/)B
	// wԂ̎擾
	CList <B_PLAY,B_PLAY&> Blist; // _~[ϐ
	CKBase *pKBase=WorkDocument.GetKBase();  // CKBase
	int iMulti=pKBase->GetBplayList(&Blist); // wԂ̎擾
	// \obt@̎擾
	WorkDocument.m_Dbc.set_mdsp();
	CDSP *cdsp=WorkDocument.m_Dbc.GetMdsp();
	// PCLt@CXV
	// ca PCLt@CXV(hash_ss)B
	BOOL result=WorkDocument.PclUpdate(iMulti,TRUE,cdsp->hash_s);
	Dbrno.tesu=0;
	WorkDocument.ReadDbcInfo(Dbrno); // ēxcaǂݍށB
	if (result)
		WorkDocument.PclUpdate(iMulti);  // ca PCLt@CXV(hash_sm)B

	return TRUE; // I
}
////////////////////////
// PCL o^ [J[Xbh
//   vt@C(KF_SECTION,KF_PCLFILE_NAME)Ɋi[ĂPCLt@
//   CǂݏoCSAt@CI[vāAelca
//   o^BVKEXVo^̎wPCLt@C̋lԍw̗L
//   ōsB
static UINT Csa2DBCWorkerThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam )
{
	BOOL bQuit=FALSE;
	CDlgInCsa *pDlg=(CDlgInCsa*)lParam;
	BOOL bIgnoreRecno=!(pDlg->m_iMode); // ɐVKo^(TRUE)ۂ

	
	CString strPclFile; // PCLt@C
	GetPclFname(strPclFile,FALSE); // PCLt@C̓ǂݏo
	if (strPclFile.IsEmpty()) {
		// PCLt@Ci[t@CI[vG[
		CString str;
		str.Format("PCLt@C͂ĂB");
		AfxMessageBox(str);
		bQuit=TRUE;
	}

	if (!bQuit) {
		CFile fCsa;
		// PCLt@C̃I[v
		if (fCsa.Open(strPclFile,CFile::modeReadWrite)) { 
			CSDJArchive ar(&fCsa,CArchive::load);
			// PCLt@C̓elca֓o^B
			CWinSDJTSDoc WorkDocument;  // lhLg
			// fCxg̐ݒ
			WorkDocument.m_Dbc.SetQuitObject((HANDLE)(*pStopEvent));

			// WorkDocumentɈǕǂݏoĂcaɓo^B
			WorkDocument.Serialize(ar); // ǕǂݏoB
			int count=0;
			while (WorkDocument.IsActualRead()) {
				if(!inpcl2db(WorkDocument,pBox,bIgnoreRecno)) // PǕo^
					break; // o^s
				count++;
				WorkDocument.Serialize(ar); // Ǖǂݏo
			}
			ar.Close();
			fCsa.Close();
			if (count) {
				char mes[2][80];
				_strdate(mes[0]); _strtime(mes[1]);
				char StringBuffer[512];
				sprintf(StringBuffer,"%d o^܂(%s %s)B",count,mes[0],mes[1]);
				if (pBox)
					pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)StringBuffer);
				else
					TRACE("%s\n",StringBuffer);
			}
		}
		else { // PCLt@CI[vG[
			CString str;
			str.Format("CSAt@C(%s)I[vł܂B",strPclFile);
			AfxMessageBox(str);
			bQuit=TRUE;
		}
	}
	return (UINT)(!bQuit);
}


// obt@̓et@C֍XV
BOOL CDlgInPcl::UpdateCsaFile()
{
	CFile f;
	if (!f.Open(m_strCsaFile,
		CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyWrite)) {
		char StringBuffer[512];
		if (m_strCsaFile!="")
			sprintf(StringBuffer,"PCLt@C(%s)̃I[vG[łB",m_strCsaFile);
		else
			sprintf(StringBuffer,"PCLt@Cw肵ĂB");

		AfxMessageBox(StringBuffer);
		return FALSE;
	}
	char buffer[CSALINE_MAX]; // CSAt@CsǍ݃obt@
	// ɂƁAGetLineCount()'\n'̐+1Ԃ̗lB
	// ]čŏIs'\n'ƂƂȂƂŒӂKvB(Ldl)
	int nLine=m_edCsaContents.GetLineCount();
	int i,len;
	for (i=0;i<nLine;i++) {
		// ɂƁAGetLine()\r\nOčsԂB
		len=m_edCsaContents.GetLine(i,buffer,sizeof buffer);
		strcpy(&buffer[len],"\r\n"); // ގ͉sď
		if (i < nLine-1 || len > 0) // ŏIs'\n'Ȃ len>0̔
			f.Write(buffer,len+2); // notepadłJ悤 "\n\r"ŏ
	}
	f.Close();
	m_edCsaContents.SetModify(FALSE); // eLXg͖C(=FILE)ƂB

	return TRUE;
}

//////
// PCLt@C̓o^
void CDlgInPcl::OnTouroku() 
{
	int iWriteOK=IDYES;

	// obt@ҏWĂ邩ׂ
	if (m_edCsaContents.GetModify()) {
		iWriteOK=AfxMessageBox(
			"obt@ύXĂ܂B̓eœo^܂H",MB_YESNO);
		if (iWriteOK==IDYES) {
			if (!UpdateCsaFile()) // obt@̓eCSAt@C֍XV
				iWriteOK=IDNO;    // XVs
		}
	}
	if (iWriteOK != IDYES)
		return ;

	UpdateData(TRUE); // f[^̎擾

	// lDBo^
	CStatusBox StatusBox(&Csa2DBCWorkerThread,(LPARAM)this); // PCLt@C̓o^
	StatusBox.DoModal();

	CDialog::OnOK(); // OKI
}
