/************************/
/*    DlgMidasiC.cpp    */
/************************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgMidasiC.h"
#include "winsdjtsdoc.h"
#include "kbase.h"
#include "sdjview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgMidasiC _CAO

CDlgMidasiC::CDlgMidasiC(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgMidasiC::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMidasiC)
	m_Author = _T("");
	m_Comment = _T("");
	m_Crecno = _T("");
	m_Datetime = _T("");
	m_Hint = _T("");
	m_Level = _T("");
	m_Title = _T("");
	m_Movenum = _T("");
	m_Hash_s = _T("");
	//}}AFX_DATA_INIT
	m_pDoc=NULL;
	m_pComment=NULL;
	m_pDbc=NULL;
	memset(&m_Crec,0,sizeof(C_REC));
	memset(&m_Cdsp,0,sizeof(CDSP));
}

void CDlgMidasiC::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMidasiC)
	DDX_Text(pDX, IDC_AUTHOR, m_Author);
	DDV_MaxChars(pDX, m_Author, 18);
	DDX_Text(pDX, IDC_COMMENT, m_Comment);
	DDV_MaxChars(pDX, m_Comment, 4096);
	DDX_Text(pDX, IDC_CRECNO, m_Crecno);
	DDV_MaxChars(pDX, m_Crecno, 6);
	DDX_Text(pDX, IDC_DATETIME, m_Datetime);
	DDV_MaxChars(pDX, m_Datetime, 20);
	DDX_Text(pDX, IDC_HINT, m_Hint);
	DDV_MaxChars(pDX, m_Hint, 40);
	DDX_Text(pDX, IDC_LEVEL, m_Level);
	DDV_MaxChars(pDX, m_Level, 14);
	DDX_Text(pDX, IDC_TITLE, m_Title);
	DDV_MaxChars(pDX, m_Title, 50);
	DDX_Text(pDX, IDC_MOVENUM, m_Movenum);
	DDV_MaxChars(pDX, m_Movenum, 4);
	DDX_Text(pDX, IDC_HASH_S, m_Hash_s);
	DDV_MaxChars(pDX, m_Hash_s, 8);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgMidasiC, CDialog)
	//{{AFX_MSG_MAP(CDlgMidasiC)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgMidasiC bZ[W nh

// hLg̐ݒ
void CDlgMidasiC::SetDoc(CWinSDJTSDoc *pDoc)
{
	m_pDoc=pDoc;
	m_pDbc=&pDoc->m_Dbc;
}

//////////
// obt@ʃf[^փZbg
void CDlgMidasiC::UpdateDisplayInfo()
{
	m_pDoc->SetMrecTesu();  // 萔̌vZhLglXV

	m_pComment=m_pDbc->GetComment();     // ΋ǒ
	// l
	if (m_pComment!=NULL)
		m_Comment.Format("%s",m_pComment);

	C_REC *pCrec=m_pDbc->GetMrec();      // lcaR[h
	memcpy(&m_Crec,pCrec,sizeof(C_REC));
	m_pDbc->set_mdsp(&m_Crec,&m_Cdsp);   // lca\obt@̃Zbg

	// \
	m_Title.Format("%s",m_Cdsp.title);
	// 
	m_Author.Format("%s",m_Cdsp.author);
	// Փx
	m_Level.Format("%s",m_Cdsp.level);
	// qg
	m_Hint.Format("%s",m_Cdsp.hint);
	// l萔
	m_Movenum.Format("%s",m_Cdsp.movenum);
	// o^
	m_Datetime.Format("%s",m_Cdsp.datetime);
	// lԍ
	m_Crecno.Format("%s",m_Cdsp.c_recno);
	// o}
	m_Hash_s.Format("%s",m_Cdsp.hash_s);

	// obt@lʂ֔f
	UpdateData(FALSE);
}

////////////////////
// ʏobt@փZbgB
void CDlgMidasiC::UpdateBufferInfo()
{
	int len,i;

	// l
	const char *cp;
	len=m_Comment.GetLength();
	cp=m_Comment;
	for (i=0;i<len;i++) {
		if (cp[i]!='\r' && cp[i]!='\n') // sR[hȊO邩
			break;
	}
	// LȕΒߕƂĐݒ肷B
	if (len > 0 && i < len)
		m_pDbc->ReplaceComment((char *)cp); // l߂̐ݒ
	else
		m_pDbc->ReplaceComment(NULL);       // l߂̐ݒ
	m_pComment=m_pDbc->GetComment();

	// lԍAo^Al萔̓[hI[ݒ肵ȂB

	// \
	memset(m_Crec.row.title,0,sizeof m_Crec.row.title);
	if ((len=m_Title.GetLength())>0)
		memcpy(m_Crec.row.title,m_Title,len);
	// 
	memset(m_Crec.row.author,0,sizeof m_Crec.row.author);
	if ((len=m_Author.GetLength())>0)
		memcpy(m_Crec.row.author,m_Author,len);
	// Փx
	memset(m_Crec.row.level,0,sizeof m_Crec.row.level);
	if ((len=m_Level.GetLength())>0)
		memcpy(m_Crec.row.level,m_Level,len);
	// qg
	memset(m_Crec.row.hint,0,sizeof m_Crec.row.hint);
	if ((len=m_Hint.GetLength())>0)
		memcpy(m_Crec.row.hint,m_Hint,len);

	// obt@(m_Crec)̓ehLgɃRs[B
	C_REC *pCrec=m_pDbc->GetMrec();
	memcpy(pCrec,&m_Crec,sizeof(C_REC));
	// hLg̕\obt@XVB
	m_pDbc->set_mdsp();

	// r[̏̕\XV
	CWnd *pWnd=m_pDoc->GetSDJView()->GetSubFrame();
	if (pWnd)
		pWnd->Invalidate();

	// _CAO̕\obt@XVB
	m_pDbc->set_mdsp(&m_Crec,&m_Cdsp);

	// XVobt@lʂ֔f
	UpdateDisplayInfo();
}

BOOL CDlgMidasiC::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// ɂȑO m_pDocݒ肳ĂȂ΂ȂȂB
	ASSERT(m_pDoc);

	UpdateDisplayInfo(); // hLgʃf[^

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgMidasiC::OnOK() 
{
	if (!UpdateData(TRUE))
		return;

	// `FbNOKȂlhLg֔f
	UpdateBufferInfo();
	
	CDialog::OnOK();
}
