/***********************/
/*    DlgOutCsa.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "DlgOutCsa.h"
#include "StatusBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDlgOutCsa _CAO

void CDlgOutCsa::CommonInit()
{
	//{{AFX_DATA_INIT(CDlgOutCsa)
	m_strCsaFile = _T("");
	m_iItemNum = 0;
	m_iSelItemNum = 0;
	//}}AFX_DATA_INIT
}
CDlgOutCsa::CDlgOutCsa(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOutCsa::IDD, pParent)
{
	CommonInit();
}
CDlgOutCsa::CDlgOutCsa(int idd,CWnd* pParent)
	: CDialog(idd, pParent)
{
	CommonInit();
}

void CDlgOutCsa::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOutCsa)
	DDX_Control(pDX, IDC_MULTISELLIST, m_MultiSelList);
	DDX_Text(pDX, IDC_CSA_FILENAME, m_strCsaFile);
	DDV_MaxChars(pDX, m_strCsaFile, 128);
	DDX_Text(pDX, IDC_ITEMNUM, m_iItemNum);
	DDV_MinMaxInt(pDX, m_iItemNum, 0, 99999);
	DDX_Text(pDX, IDC_ITEMNUM2, m_iSelItemNum);
	DDV_MinMaxInt(pDX, m_iSelItemNum, 0, 99999);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgOutCsa, CDialog)
	//{{AFX_MSG_MAP(CDlgOutCsa)
	ON_BN_CLICKED(IDC_FILE_SELECT, OnFileSelect)
	ON_BN_CLICKED(IDC_SELECTALL, OnSelectAll)
	ON_BN_CLICKED(IDOK, OnOutCsaFile)
	ON_LBN_SELCHANGE(IDC_MULTISELLIST, OnSelchangeMultisellist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOutCsa bZ[W nh
extern char *GetShgdbName();

BOOL CDlgOutCsa::OnInitDialog() 
{
	CWaitCursor waitcr; // v

	m_SelectBoxB.ReadPrevInfo(); // O񌟍̓ǂݏo

	// CSAt@C̎擾
	GetCsaFname(m_strCsaFile);

	CDialog::OnInitDialog();
	
	CList <DBRNO,DBRNO&> *pDbrFindList=m_SelectBoxB.GetDbrFindList();
	CList <DBRNO, DBRNO&> DbrnoList; // DBBʍƃXg
	POSITION pos;
	DBRNO Dbrno;

	CDBB Dbb; // ΋ǂca
	char dispbuf[512];
	m_MultiSelList.ResetContent(); // SelectListɂB
	if (Dbb.Open()) { // ΋ǂcãI[v
		Dbb.DBFOpen(); // ߂cãI[v
		pos=pDbrFindList->GetHeadPosition();
		while (pos) {
			Dbrno=pDbrFindList->GetNext(pos);
			// DBRNOɊY΋ǃR[hǂށB
			int rc=Dbb.ReadByDbrno(Dbrno.dbrno);
			if (rc==E$OK) { // ɓǂ߂\B
				Dbb.set_disp_mrec(dispbuf); // \̐
				m_MultiSelList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DbrnoList.AddTail(Dbrno); // ƃXgɒǉ
			}
		}
		Dbb.DBFClose(); // ߂cãN[Y
		Dbb.Close(); // ΋ǂcãN[Y
		// Xg{bNX̃J[\ݒ
		if (m_MultiSelList.GetCount()) {
			m_MultiSelList.SetSel(0,TRUE);  // 擪ɐݒ
		}
	}
	// DbrnoList̓epDbrFindList֔fB
	pDbrFindList->RemoveAll(); // XgɂB
	pos=DbrnoList.GetHeadPosition();
	while (pos) {
		// DbrnoListpDbrFindListփRs[
		Dbrno=DbrnoList.GetNext(pos);
		pDbrFindList->AddTail(Dbrno); 
	}
	DbrnoList.RemoveAll(); // DbrnoList

	// \̍XV
	m_iItemNum=m_MultiSelList.GetCount(); // 
	m_iSelItemNum=m_MultiSelList.GetSelCount(); // I
	UpdateData(FALSE); // \XV	UpdateData(FALSE);

	GotoDlgCtrl(&m_MultiSelList); // 

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

////
// CSAt@C̑I
void CDlgOutCsa::OnFileSelect() 
{
	if (m_strCsaFile.IsEmpty())
		GetCsaFname(m_strCsaFile); // CSAt@C̎擾

	CFileDialog dlgOutCsa(TRUE, // ǂݍ݃_CAO
		"csa",					// ftHggq
		m_strCsaFile,			// ftHgCSAt@C
		(DWORD)(OFN_HIDEREADONLY), //  t@C̑
		"CSAt@C (*.csa)|*.csa||"); // tB^[
	BOOL bResult = dlgOutCsa.DoModal();

	if (bResult == IDOK) { // Iꂽ
		m_strCsaFile = dlgOutCsa.GetPathName(); // pX擾
		UpdateData(FALSE); // \XV

		WriteCsaFname(m_strCsaFile); // vt@C֋L
	}
}

////
// SI(gOŉ)
void CDlgOutCsa::OnSelectAll() 
{
	int cnt=m_MultiSelList.GetCount(); // s
	if (cnt > 0) {
		if (cnt!=m_MultiSelList.GetSelCount()) { // s != I
			if (cnt>1)
				m_MultiSelList.SelItemRange(TRUE,0,cnt-1); // I
			else
				m_MultiSelList.SetSel(0,TRUE); // I
		}
		else
			m_MultiSelList.SelItemRange(FALSE,0,cnt-1); // 
	}
	m_iSelItemNum=m_MultiSelList.GetSelCount(); // I
	UpdateData(FALSE); // \XV
}

////
// LZt
void CDlgOutCsa::OnCancel() 
{
	CDialog::OnCancel();
}

////
// CSAt@Co̓[J[Xbh
static UINT OnOutCsaFileThread(CStatusBox *pBox,CEvent *pStopEvent,LPARAM lParam)
{
	CDlgOutCsa *pDlg=(CDlgOutCsa *)lParam;
	CSelectBoxB *pSelectBoxB=pDlg->GetSelectBoxB();
	CList <DBRNO,DBRNO&> *pDbrFindList=pSelectBoxB->GetDbrFindList();
	char StringBuffer[512];
 
	// CSA t@C̃I[v
	CFile fcsa;
	if (!fcsa.Open(pDlg->m_strCsaFile,CFile::modeCreate | CFile::modeReadWrite | CFile::shareDenyWrite))
		return FALSE; // I[vs
	CSDJArchive ar(&fcsa,CArchive::store);

	// ΋ǂcãI[v
	CDBB Dbb;
	char dispbuf[512];
	DBRNO Dbrno;
	int Index=-1;
	BOOL bInitOutFlag = FALSE;
	int iCounter=0;

    BOOL Bopen=FALSE;
    BOOL Dopen=FALSE;
    BOOL Fopen=FALSE;
	Bopen=Dbb.Open();
	if (Bopen) {
		Dopen=Dbb.DBDOpen();
		Fopen=Dbb.DBFOpen();
	}
	if (Bopen && Dopen && Fopen) { // SăI[v
		POSITION pos=pDbrFindList->GetHeadPosition();
		while (pos) {
			Dbrno=pDbrFindList->GetNext(pos);
			Index++;
			if (pDlg->m_MultiSelList.GetSel(Index)) { // ̃ZIĂ
				// DBRNOɊY΋ǃR[hǂށB
				int rc=Dbb.ReadByDbrno(Dbrno.dbrno);
				if (rc==E$OK) { // ɓǂ߂
					if (bInitOutFlag) {
						CString crlf("/\r\n"); // ΋ǋ؂̏o
						ar.WriteString(crlf);
					}
					else
						bInitOutFlag=TRUE;

					rc=Dbb.OutDB2Csa(ar);// ̑΋ǂCSAo
					// \̐
					Dbb.set_disp_mrec(dispbuf);
					if (rc==0) {
						sprintf(StringBuffer,"%so͂܂B",dispbuf);
						iCounter++; // o̓JE^[+1
					}
					else
						sprintf(StringBuffer,
						"%s̏o͂Ɏs܂(rc=%d)B", dispbuf,rc);
					if (pBox)
						pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,
						(LPARAM)StringBuffer);
					else
						TRACE("%s\n",StringBuffer);
				}
			}
			// fI`FbN
			if (WaitForSingleObject(*pStopEvent, 0)==WAIT_OBJECT_0) {
				sprintf(StringBuffer,"CSAt@Co͂𒆒fI܂B");
				if (pBox)
					pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,
					(LPARAM)StringBuffer);
				else
					TRACE("%s\n",StringBuffer);
				break;
			}
		}
		char str1[80],str2[80];
		_strdate(str1); _strtime(str2);
		sprintf(StringBuffer,"%d o͂܂(%s %s)B",iCounter,str1,str2);
		if (pBox)
		    pBox->SendMessage(WM_COMMAND,ID_PRINT_MESSAGE,(LPARAM)StringBuffer);
	    else
			TRACE("%s\n",StringBuffer);
	}
	if (Fopen) Dbb.DBFClose();
	if (Dopen) Dbb.DBDClose();
	if (Bopen) Dbb.Close();

	ar.Close();
	fcsa.Close();

	return TRUE;
}

////
// CSAt@Co
void CDlgOutCsa::OnOutCsaFile() 
{
	UpdateData(TRUE); // ϐ̍XV

	// I𐔂̃`FbN
	if (m_iSelItemNum <=0) 
		return ; // IĂȂB

	// CSAt@C̃`FbN
	if (m_strCsaFile.IsEmpty()) {
		AfxMessageBox("CSA t@C(*.csa)w肵ĂB");
		return ;
	}
	if (strcmp((LPCTSTR)m_strCsaFile+strlen(m_strCsaFile)-4,".csa")!=0)
		TRACE("Csa file does not terminiate with \".csa\"\n");

	// CSA t@C̃I[v`FbN
	CFile fcsa;
	int MBret=IDYES;
	if (fcsa.Open(m_strCsaFile,CFile::modeReadWrite | CFile::shareDenyWrite)) {
		CString strbuf;
		strbuf.Format("CSAt@C(%s)ɏ㏑Ă낵łH",m_strCsaFile);
		MBret=AfxMessageBox(strbuf,MB_YESNO);
		fcsa.Close();
	}
	if (MBret!=IDYES)
		return;

	// j^\{bNX  ƊJn
	CStatusBox StatusBox(&OnOutCsaFileThread,(LPARAM)this);
	StatusBox.DoModal();

	CDialog::OnOK(); // OKI
}

/////
// I𐔂̕\ύXꂽƂ
void CDlgOutCsa::OnSelchangeMultisellist() 
{
	m_iSelItemNum=m_MultiSelList.GetSelCount(); // I
	UpdateData(FALSE); // \XV
}
