/************************/
/*    GuideView.cpp    */
/************************/
#include "stdafx.h"
#include "WinSDJ.h"
#include "GuideView.h"
#include "kbase.h"
#include "winsdjdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CGuideView

IMPLEMENT_DYNCREATE(CGuideView, CView)

CGuideView::CGuideView()
{
}

CGuideView::~CGuideView()
{
}

BEGIN_MESSAGE_MAP(CGuideView, CView)
	//{{AFX_MSG_MAP(CGuideView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGuideView `

void CGuideView::OnDraw(CDC* pDC)
{
	CSDJDoc* pDoc = (CSDJDoc *)GetDocument();
	CKBase *pKBase=pDoc->GetKBase();

	// obNOEhJ[
	CRect rc;
	GetClientRect(&rc);
	pDC->FillSolidRect(&rc,WINBKCLR);

	// tHg̏
	CFont *pfCurr=pDC->GetCurrentFont();			// s̃tHg
	LOGFONT lfFont;
	pfCurr->GetObject(sizeof(LOGFONT),&lfFont);		// s̃tHg
	lfFont.lfHeight=14;								// tHg̐ݒ
	lfFont.lfWidth=0;								// tHg͎ݒ
	strcpy(lfFont.lfFaceName,"lr ");			// MS
	CFont fNewFont;
	fNewFont.CreateFontIndirect(&lfFont);			// `tHg̍쐬

	// tHg̑I
	CFont *pOldFont=pDC->SelectObject(&fNewFont);	// tHgI
	pDC->SetTextColor(WINMJCLR);					// ꑋF
	pDC->SetBkMode(TRANSPARENT);					// obN͓߂ɐݒ


	CString Sname,Gname;
	if (pDoc->IsKindOf(RUNTIME_CLASS(CWinSDJDoc))) {
		Sname.Format("  "); Gname.Format("  ");
	} else {
		Sname.Format("U  "); Gname.Format("  ");
	}
	
	CString str;									// obt@(default 128)
	CPoint loc(1,1);								// `ʒu
	//
	// Ԃ̕\
	//
	// \̍쐬
	switch (pKBase->turn()) {
	case SIDE_A:
		str.Format("  : %s",Sname); break;
	case SIDE_B:
		str.Format("  : %s",Gname); break;
	default:
		str.Format("  : %s","  "); break;
	}
	pDC->TextOut(loc.x,loc.y,str);					// ̕\
	loc.Offset(0,lfFont.lfHeight+1);				// ̕`ʒu
	//
	// w\
	//
	if (pKBase->root()==pKBase->lastmove())
		str.Format("w: %s", "");
	else
		str.Format("w: %3d ",pKBase->level());	// ڂ̎w肩
	pDC->TextOut(loc.x,loc.y,str);					// ̕\
	loc.Offset(0,lfFont.lfHeight+1);				// ̕`ʒu
	//
	// `I\L̕\
	//
	if (pKBase->root()!=pKBase->lastmove()) {		// łȂ΁A
		PCELL *pcl=pKBase->lastmove();
		str.Format("%s",pKBase->mvstr(pcl));
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+1);			// ̕`ʒu
		
		if (pKBase->playnum()==0)					// ꂪŌ̎wȂB
			pDC->TextOut(loc.x,loc.y,"܂");		// ̕\
	}

	// tHgɖ߂
	pDC->SelectObject(pOldFont);
}

/////////////////////////////////////////////////////////////////////////////
// CGuideView ff

#ifdef _DEBUG
void CGuideView::AssertValid() const
{
	CView::AssertValid();
}

void CGuideView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGuideView bZ[W nh
