/********************/
/*    K2CSEL.cpp    */
/********************/
#include "stdafx.h"
#include "winsdj.h"
#include "K2CSEL.h"
#include <stdlib.h>
#include <string.h>
#include "osversion.h"
#include "dlgdir.h"
#include "dlgselectdir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CK2CSEL _CAO

CK2CSEL::CK2CSEL(CWnd* pParent /*=NULL*/)
	: CDialog(CK2CSEL::IDD, pParent)
{
	//{{AFX_DATA_INIT(CK2CSEL)
	m_RadioSelNum = 0; // ꊇ
	m_Date = _T("");
	m_Kisen = _T("");
	m_RadioAdd = 0; // ǉ
	m_OFileName = _T("");
	m_ODirName = _T("");
	m_ConvChar = TRUE;
	//}}AFX_DATA_INIT

	indir[0] = outdir[0] = outfile[0] = '\0';
	wmode = 0;

	// ftHglinit@Cǂ
	CWinApp *app = AfxGetApp();
	CString work;
	
	work = app->GetProfileString(K2C_SECTION, INDIR_ITEM);
	strcpy(indir, (LPCTSTR)work);
	work = app->GetProfileString(K2C_SECTION, OUTDIR_ITEM);
	strcpy(outdir, (LPCTSTR)work);
	m_ODirName = work;
	work = app->GetProfileString(K2C_SECTION, OUTFILE_ITEM);
	m_OFileName = work;
	wmode = m_RadioAdd = app->GetProfileInt(K2C_SECTION, WMODE_ITEM, 0);
//	UpdateData(FALSE);	// DDXϐɕ\𓯊
}

CK2CSEL::~CK2CSEL()
{
	// ftHglinit@C֏
	CWinApp *app = AfxGetApp();
	
	app->WriteProfileString(K2C_SECTION, INDIR_ITEM, indir);
	app->WriteProfileString(K2C_SECTION, OUTDIR_ITEM, outdir);
	app->WriteProfileString(K2C_SECTION, OUTFILE_ITEM, (LPCTSTR)m_OFileName);
	app->WriteProfileInt(K2C_SECTION, WMODE_ITEM, m_RadioAdd);
}

void CK2CSEL::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CK2CSEL)
	DDX_Control(pDX, IDC_LIST1, m_InfileList);
	DDX_Radio(pDX, IDC_RADIO_INDI, m_RadioSelNum);
	DDX_Text(pDX, IDC_EDIT_DATE, m_Date);
	DDX_Text(pDX, IDC_EDIT_KISEN, m_Kisen);
	DDX_Radio(pDX, IDC_RADIO_ADD, m_RadioAdd);
	DDX_Text(pDX, IDC_EDIT1, m_OFileName);
	DDX_Text(pDX, IDC_EDIT2, m_ODirName);
	DDX_Check(pDX, IDC_CHECK1, m_ConvChar);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CK2CSEL, CDialog)
	//{{AFX_MSG_MAP(CK2CSEL)
	ON_BN_CLICKED(IDC_RADIO_INDI, OnRadioIndi)
	ON_BN_CLICKED(IDC_RADIO_LUMP, OnRadioLump)
	ON_BN_CLICKED(IDC_BUTTON_REF, OnButtonRef)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_RADIO_ADD, OnRadioAdd)
	ON_BN_CLICKED(IDC_RADIO_OW, OnRadioOw)
	ON_BN_CLICKED(IDC_BUTTON_DEL, OnButtonDel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CK2CSEL bZ[W nh

// o̓t@C\̗L/
void CK2CSEL::chgedit()
{
	if (m_RadioSelNum == 1){ // 
		// filename
		GetDlgItem(IDC_EDIT1)->EnableWindow(FALSE); // ʂȂ̂Ŗ
		// openmode
		GetDlgItem(IDC_RADIO_ADD)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO_OW)->EnableWindow(FALSE);
	} else { // ꊇ
		// filename
		GetDlgItem(IDC_EDIT1)->EnableWindow(TRUE); // ꊇȂ̂ŗL
		// openmode
		GetDlgItem(IDC_RADIO_ADD)->EnableWindow(TRUE);
		GetDlgItem(IDC_RADIO_OW)->EnableWindow(TRUE);
	}
}

// ꊇ{^
void CK2CSEL::OnRadioIndi() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_OFileName = outfile;
	m_RadioSelNum = 0;
	m_RadioAdd = wmode;
	UpdateData(FALSE);
	chgedit();
}

// ʃ{^
void CK2CSEL::OnRadioLump() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_RadioSelNum = 1;
	strcpy(outfile, (LPCTSTR)m_OFileName);
	m_OFileName = "";
	wmode = m_RadioAdd;
	m_RadioAdd = 1; // ʎ͏㏑
	UpdateData(FALSE);
	chgedit();
}

// ̓t@C̎Qƃ{^ꂽƂ
//  t@CIsInfileListXV
void CK2CSEL::OnButtonRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char drive[10], dir[256], fname[256], ext[256];
	POSITION pp, p0;

	CString strFile="*.kif"; // ftHg̃t@C
	strcpy(m_dbuf,strFile);  // added by Ra

	CFileDialog fsdlg(TRUE,  // Ǎ݃_CAO
    	"kif",              // ftHggq
    	strFile,            
		(DWORD)(OFN_HIDEREADONLY | OFN_FILEMUSTEXIST),  // t@C̑
		"KIFt@C (*.kif)|*.kif|KI2t@C (*.ki2)|*.ki2|St@C(*.*)|*.*||"); //tB^w

//	CFileDialog fsdlg(TRUE); // t@CI_CAO{bNX
	fsdlg.m_ofn.Flags |= OFN_ALLOWMULTISELECT; // t@CI\ɂ
	fsdlg.m_ofn.lpstrFile = m_dbuf; // t@C󂯂obt@
	fsdlg.m_ofn.nMaxFile = DBUFSIZ; // Ƃ̃TCY̎w
	fsdlg.m_ofn.lpstrTitle = "̓t@C̑I"; // ^Cg
	fsdlg.m_ofn.lpstrInitialDir = indir; // ftHgfBNg

	if (fsdlg.DoModal() == IDOK){ // s
	//	filename = fsdlg.GetPathName();
		p0 = pp = fsdlg.GetStartPosition();
		while (pp != NULL){
			p0 = pp;
			m_InfileList.AddString(fsdlg.GetNextPathName(pp));
		}
		UpdateData(FALSE);
		if (p0 != NULL){
			_splitpath((LPCTSTR)fsdlg.GetNextPathName(p0), drive,
				dir, fname, ext);
			strcpy(indir, drive);
			strcat(indir, dir);
		}
	}
}

// o̓t@CQƃ{^
void CK2CSEL::OnButton1() 
{
	char filename[256];
	char drive[20], dir[256], fname[256], ext[256];
	COsVersion OsVersion; // OS Version 

	filename[0] = '\0';

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if (m_RadioSelNum == 0){ // ꊇ
		CString strFile="*.CSA"; // ftHg̃t@C

		CFileDialog fsdlg (FALSE,  // 
    	"CSA",              // ftHggq
    	strFile,            
		(DWORD)(OFN_HIDEREADONLY | OFN_FILEMUSTEXIST),  // t@C̑
		"CSAt@C (*.CSA)|*.CSA|St@C (*.*)|*.*||"); //tB^w
		
		fsdlg.m_ofn.lpstrTitle = "o̓t@CEfBNg̑I";
		fsdlg.m_ofn.lpstrInitialDir = outdir;
		if (fsdlg.DoModal() == IDOK){ // s
			strcpy(filename, (LPCTSTR)fsdlg.GetPathName());
			_splitpath(filename, drive, dir, fname, ext);
			m_ODirName = drive;
			m_ODirName += dir;
			m_OFileName = fname;
			m_OFileName += ext;
			UpdateData(FALSE);	// DDXϐɕ\𓯊
			strcpy(outdir, drive);
			strcat(outdir, dir);
		}
	} else { // 
		if (OsVersion.m_OsVersionType >=2 ) { // Win95,NT4.0 ȏ
			CDlgSelectDir DlgSelectDir; // fBNgI_CAO
			DlgSelectDir.m_strSelectDir = outdir; // l
		
			if (DlgSelectDir.DoModal() == IDOK) {
				m_ODirName = DlgSelectDir.m_strSelectDir;
				UpdateData(FALSE);	// DDXϐɕ\𓯊
				strcpy(outdir, (LPCTSTR)m_ODirName);
			}
		} else { // NT3.51
			CDlgDir DlgDir;
	
			if (DlgDir.DoModal()==IDOK) {
				strcpy(filename, (LPCTSTR)(DlgDir.strSelPathName));
				m_ODirName = filename;
				UpdateData(FALSE);	// DDXϐɕ\𓯊
				strcpy(outdir, filename);
			}
		}
	}
}

// ̊֐ɂϊ̎sJn
void CK2CSEL::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	
	UpdateData(TRUE); // TRUE:f[^DDXϐɎ擾 FALSE:DDXϐ\ɔf
	
	// ϊt@C̊mF
	if (m_InfileList.GetCount() == 0){
		AfxMessageBox("̓t@Cݒ");
		goto end;
	}
	// ϊt@C̊mF
	//   m_RadioSelNum; // 1: 0:ꊇ
	//   ꊇȂm_RadioAdd=0:ǉ[h 1:㏑
	//   ʂȂ珑
	//   ꊇȂm_OFileNameo̓t@C
	if (m_ODirName.IsEmpty()){
		AfxMessageBox("o̓fBNgݒ");
		goto end;
	} 
	if (m_RadioSelNum == 0){	// ꊇ
		if (m_OFileName.IsEmpty()){
			AfxMessageBox("o̓t@Cݒ");
			goto end;
		}
		// added by Ra. 98.7.9
		// t@Cgq.csaɂB(csałȂ)
		else {
			BOOL add_csa=FALSE;
			int n=m_OFileName.GetLength();
			if (n<4) {
				add_csa=TRUE;
			}
			else {
				LPCTSTR cp=(LPCTSTR)m_OFileName + n-4;
				if (strnicmp(cp,".csa",4)!=0) {
					add_csa=TRUE;
				}
			}
			if (add_csa) {
				m_OFileName+=".csa";
				UpdateData(FALSE);
			}
		}
	}
	// ϊs
	convert(&m_InfileList, m_RadioSelNum, m_RadioAdd,
	 &m_ODirName, &m_OFileName, &m_Kisen, &m_Date);
	
	// ŌFrameWorkIWȉĂ
	CDialog::OnOK();
	return; // 삵Ƃɂ̓_CAO
	
	end:; //G[Ȃ_CAO͊J܂
}

BOOL CK2CSEL::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	chgedit();
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CK2CSEL::OnRadioAdd() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_RadioAdd = 0;
}

void CK2CSEL::OnRadioOw() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_RadioAdd = 1;	
}

// 폜{^
void CK2CSEL::OnButtonDel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// Xg{bNXőIĂ̂
	int n, i;
	int buf;

	n = m_InfileList.GetSelCount(); // IĂ鐔
	for (i=0; i<n; i++){
		m_InfileList.GetSelItems(1, &buf);
		m_InfileList.DeleteString(buf);
	}
	UpdateData(FALSE);
}

////////////////////////////////////////////////////////////////////
/// ȍ~convert.cppzB
/// ȂC1010vRpCς݂....ƂG[ɂȂB
///
/*
 * convert.cpp ( kf2csa.cpp)
 *
 * 970925: ver1.0 by a
 *         Ȃ̃XpQeB
 *         ꉞ kif`AKI2`Aт(萔 s(쌳))
 *         Ƃ`T|[g
 *
 * FSHOGIɃAbvĂ鏇ʐ̊CSA`ɕϊc[B
 * CSA`ɂ́AœǂݍŊcãf[^Ƃ
 * ӏ܂蕪͂邱ƂړIƂĂB
 *
 * 980604: WKF2CSAƂwindowsłɑgݍ݂}
 * 980617: v}[NAfxMessageBox()Ȃǂwinɉς
 */
/*
#include <afx.h>
#include "..\stdafx.h"
#include "..\winsdj.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
*/
#include <sbase.h>
#include <sbetc.h>

#define BUFLEN (1024) // sobt@

struct KEYWD{
	char *kw;	// ϊÕL[[h
	char *cmv;	// ϊ
	int num;	// ϊl
};

// c 0-9 ȂTRUE
static BOOL isnum(char c)
{
	if (c >= '0' && c <='9') return TRUE;
	return FALSE;
}

static int readnum(char *str, int *n)
{
	int i, t;
	
	t = 0;
	i = 0;
	str = spskip(str);
	while (*str >= '0' && *str <= '9'){
		t *= 10;
		t += *str - '0';
		i++;
		str++;
	}
	*n = t;
	return i;
}

// nꂽ񂩂Ɏb`(hh:mm:ss)
// ̐擪AhXԂAȂNULL
static char *searchtime(char *str)
{
	for( ; *str != '\0' && *str != 0x0a; str++){
		if (isnum(*str)){
			if (isnum(str[1]) && str[2]==':'
			 && isnum(str[3]) && isnum(str[4])
			 && str[5]==':' && isnum(str[6]) && isnum(str[7])){
			 	return str;
			 }
		}
	}
	return NULL;
}

// ȇ΋Ǔt`
// yy/mm/dd ........(1)
// yyyy/mm/dd .........(2)
// yyyyNm(m)d(d) .....(3)
// ܂e`̌ hh:mm:ss ΎbƂĕϊ
// strϊcpɓ
static void datechange(char *str, char *cp)
{
	int yy, mm, dd, num, zo, len;
	int hr, min, sec;
	char *pp;
	char *zone[] = {"N","",""};
	
	len = strlen(str);
	if (len < 8) return;
	hr = -1; // 0ȉȂ玞ɈӖƂ
	if (str[2] == '/' && str[5] == '/'){ // type(1)
		yy = (str[0]-'0')*10 + (str[1]-'0');
		mm = (str[3]-'0')*10 + (str[4]-'0');
		dd = (str[6]-'0')*10 + (str[7]-'0');
		if ((pp = searchtime(&str[8])) != NULL){
			hr = (pp[0]-'0')*10 +( pp[1]-'0');
			min = (pp[3]-'0')*10 +( pp[4]-'0');
			sec = (pp[6]-'0')*10 +( pp[7]-'0');
		}
	} else if (str[4] == '/' && str[7] == '/'){ // type(2)
		yy = (str[0]-'0')*1000+(str[1]-'0')*100+(str[2]-'0')*10+(str[3]-'0');
		mm = (str[5]-'0')*10 + (str[6]-'0');
		dd = (str[8]-'0')*10 + (str[9]-'0');
		if ((pp = searchtime(&str[10])) != NULL){
			hr = (pp[0]-'0')*10 +( pp[1]-'0');
			min = (pp[3]-'0')*10 +( pp[4]-'0');
			sec = (pp[6]-'0')*10 +( pp[7]-'0');
		}
	} else {
		pp = str;
		zo = 0;
		num = 0;
		while (*pp != 0x0a && *pp != '\0'){
			while (*pp >= '0' && *pp <= '9'){
				num = num*10 + (*pp - '0');
				pp++;
			}
			if (equ(pp, zone[zo])){
				if (zo == 0) yy = num;
				if (zo == 1) mm = num;
				if (zo == 2) {dd = num; break;}
				pp += 2;
				zo++;
				num = 0;
			} else {
				strcpy(cp, str);
				return;
			}
		}
		if ((pp = searchtime(&str[12])) != NULL){
			hr = (pp[0]-'0')*10 +( pp[1]-'0');
			min = (pp[3]-'0')*10 +( pp[4]-'0');
			sec = (pp[6]-'0')*10 +( pp[7]-'0');
		}
		
	}
	if (yy < 100){
		if (yy < 50) {
			yy += 2000;
		} else {
			yy += 1900;
		}
	}
	if (hr < 0){
		sprintf(cp, "%4d%02d%02d", yy, mm, dd);
	} else {
		sprintf(cp, "%4d%02d%02d%02d%02d%02d", yy, mm, dd, hr, min, sec);
	}
}

// strϊcpɓ
// ̂ƂꕶΑSpϊ
static void namechange(char *str, char *cp)
{
	static char sc[] = ".,!\"#$%&'()=^`|~@[]{}<>-+*/?_\\";
	static char sc2[] = "DCIhfijOMb`mnop|{^HQ";
	int scnum;
	BOOL inkanji;
	int j;

	scnum = sizeof(sc)/sizeof(char);
	inkanji = FALSE;
	while (*str != '\0' && *str != 0x0a){
		if (inkanji){
			*cp++ = *str++;
			inkanji = FALSE;
		} else {
			if (_ismbblead(*str)){ // *str͊PoCg
				inkanji = TRUE;
				*cp++ = *str++;
			} else {
				for (j=0; j<scnum; j++){
					if (sc[j] == *str){
						str++;
						*cp++ = sc2[2*j];
						*cp++ = sc2[2*j+1];
						goto next;
					}
				}
				*cp++ = *str++; // ꕶ͂Ȃ
				next:;
			}
		}
	}
	*cp = '\0';
}

/*
wb_ԍ

0 
1 ^
2 
3 萔
4 荇
5 \
6 ΋Ǔ
7 
8 
9 
10 ΋ǃRg
*/

// wb_Ƃstr𒲂ׂ
// Return: ߕs\Ȃ0 Ȃ1Ԃ
int CK2CSEL::convheader(char *str, char *head[])
{
	KEYWD headkw[] = {
		{"F", "N+", 8}, {"F", "N-", 9},
		{"", "N+", 8}, {"", "N-", 9}, // ꕶ͒̂
		{"F", "N-", 9}, {"F", "N+", 8},
		{"F", "'햼F", 0}, { "^F", "'^:", 1},
		{"荇F", "'荇", 4}, {"\F", "'", 5},
		{"΋ǓF", "'΋Ǔ", 6},
		{"JnF", "'΋Ǔ", 6}, {"萔---", "'", 3},
		{"IF", "", -1},{"RgF","",10}, {"āF","",10}, {"Ֆʉ]","",-1},
		{"ΐ푊hcF", "ΐ푊hcF",10},
		{"*","",10}/* Rg */,
	};
	int headkwnum = sizeof(headkw)/sizeof(KEYWD);
	int i, n, t;
	char *cp;
	char strbuf[1024];
	
	str = spskip(str);
	for (i=0; i<headkwnum; i++){
		if (n = equ(str, headkw[i].kw)){ // vL[[h
			str = spskip(str+n);
			if (headkw[i].num < 0){
				// Ȃ
				return 1;
			}
			cp = head[headkw[i].num];
			t = headkw[i].num;
			if (t == 6){ // ΋Ǔ
				datechange(str, cp);
			} else if ((t == 8 || t == 9) && m_ConvChar){ // ΋ǎҖőSpϊ
				namechange(str, cp);
			} else if (t == 10){
				if (strlen(str) > 0){
					sprintf(strbuf, "':%s", headkw[i].cmv);
					strcat(strbuf, str);
					m_Comment += strbuf;
				}
			} else {
				while (*str != 0x0a && *str != '\0'){
					*cp++ = *str++;
				}
				*cp = '\0';
			}
			return 1;
		}
	}
	// L[[hꗗɂ͂ȂuiL[[hjFXXXv̌`͂
	if (_mbschr((const unsigned char*)str, 'F') != NULL){
		if (strlen(str) > 0){
			sprintf(strbuf, "':%s", str);
			m_Comment += strbuf;
		}
		return 1;
	}
	return 0;
}

// 荇̏
// ԂSBASE::setup()̔ԍƓA9,10g
static char *handistr(int n)
{
	char *hstr[] = {
		"PI\n+\n",		// 0. 
		"PI91KY\n-\n",	// 1. E
		"PI11KY\n-\n",	// 2. 
		"PI82HI\n-\n",	// 3. 
		"PI22KA\n-\n",	// 4. p
		"PI82HI22KA\n-\n",	// 5. 
		"PI82HI22KA11KY91KY\n-\n",	// 6. l
		"PI82HI22KA11KY91KY21KE81KE\n-\n",	// 7. Z
		"", // 8. S
		"PI82HI11KY\n-\n",	//  9. 
		"PI22KA11KY\n-\n",	// 10. p
	};
	
	if (n < 0 || n > sizeof(hstr)/sizeof(char*)) return NULL;
	return hstr[n];
}

static int handicap(char *str)
{
/*
	SBASE̋w萔l
		void setup(int n);// 0= 1=E 2= 3= 4=p 
		                  // 5=񖇗 6=l 7=Z 8=S
*/
	KEYWD handikw[] = {
		{"","",0}, {"ԍ","",9},
		{"","",3}, {"p","",10}, // ꕶ͒̂
		{"p","",4},
		{"","",2}, 
		{"E","",1},{"","",2},
		{"","",5}, { "l","",6},
		{"Z","",7}, {"", "", 9},
	};
	int handikwnum = sizeof(handikw)/sizeof(KEYWD);
	int i, n;
	
	str = spskip(str);
	for (i=0; i<handikwnum; i++){
		if (n = equ(str, handikw[i].kw)){ // vL[[h
			return handikw[i].num;
		}
	}
	return 0;
}

// ǖʐ}Ƃstr𒲂ׂ
// Return: ߕs\Ȃ0 Ȃ1Ԃ
static int convfbd(char *str, SBASE *sb)
{
	return 0;
}

// sƂstr𒲂ׂ
// Return: ߕs\Ȃ0 쐬Ȃ1ȏԂ
//         ̂r炨ȂĂ-1Ԃ
//         앶=1
//         菟=2 菟=3 =4 =5 f=6Ԃ
//         Rg=7Ԃ
// Call: sente=SIDE_A/SIDE_B 葤
//       pstat=sO̓쌋 7ȂRg
static int convmov(char *str, SBASE *sb, int sente, int pstat)
{
	KEYWD sidekw[] = {
		{"","+",SIDE_A}, {"", "-",SIDE_B}, {"", "-",SIDE_B},
	};
	int sidekwnum = sizeof(sidekw)/sizeof(KEYWD);
	KEYWD rankkw[] = {
		{"P","",1}, {"Q", "",2}, {"R", "",3},
		{"S","",4}, {"T", "",5}, {"U", "",6},
		{"V","",7}, {"W", "",8}, {"X", "",9},
	};
	int rankkwnum = sizeof(rankkw)/sizeof(KEYWD);
	KEYWD colkw[] = {
		{"","",1}, {"", "",2}, {"O", "",3},
		{"l","",4}, {"", "",5}, {"Z", "",6},
		{"","",7}, {"", "",8}, {"", "",9},
	};
	int colkwnum = sizeof(colkw)/sizeof(KEYWD);
	KEYWD kindkw[] = {
		{"","OU",GYK}, {"","OU",GYK}, {"", "HI",HSY}, {"p", "KA",KAK},
		{"","KI",KIN}, {"", "GI",GIN}, {"j", "KE",KEI},
		{"","KY",KYO}, {"","FU",FU},
		{"","",0}, 
		{"", "RY",(HSY | PROMBIT)},{"", "RY",(HSY | PROMBIT)},
		{"n","UM",(KAK | PROMBIT)}, 
		{"","",0},
		{"", "NG",(GIN | PROMBIT)}, 
		{"j", "NK",(KEI | PROMBIT)}, 
		{"","NY",(KYO | PROMBIT)}, 
		{"", "TO",(FU | PROMBIT)}, 
	};
	int kindkwnum = sizeof(kindkw)/sizeof(KEYWD);
	KEYWD dextkw[] = {
		{"E","",MIGI}, {"", "",HIDARI}, {"", "",SUGU},
		{"","",MID}, {"", "",UP}, {"", "",BOT},
		{"s","",BOT}, {"","",-1}, 
	};
	int dextkwnum = sizeof(dextkw)/sizeof(KEYWD);
	KEYWD pextkw[] = {
		{"","N",1}, {"s","",0}, 
	};
	int pextkwnum = sizeof(pextkw)/sizeof(KEYWD);
	int i, n, dirbit, rc, num, len;
	int side, pos, kind, prom, topos;
	PIECE *tp;
	PLAY ply;
	char *sid, *str2, *endstr;
	char cbuf[BUFLEN];
	int prevmove = SIDE_B;
	int gote;
	
	rc = 0; // gCJEg

	gote = (sente == SIDE_A) ? SIDE_B:SIDE_A;
	for (;;){ // Psɕ̎w̋Lq
		// Rg
		if (*str == '*'){
			i = 0;
			str++;
			while (*str != 0x0a && *str != '\0' && i < BUFLEN-1){
				cbuf[i] = *str++;
				i++;
			}
			cbuf[i] = '\0';
			sb->addcmnt(sb->lastmove(), cbuf);
			return 7; // ߐƂĖ߂
//			return 1; // ߐƂĖ߂ '02/09/26 by Ra for Winsdj Ver5.1c
		}
		// 
		n = 0;
		for (i=0; i<sidekwnum; i++){
			str = spskip(str);
			if (n = equ(str, sidekw[i].kw)){ // vL[[h
				side = sidekw[i].num;
				sid = sidekw[i].cmv;
				if (sb->turn() != side){ // Qw
					return -1;
				}
				prevmove = side;
				goto zahyou;
			}
		} // \ĂȂ
		// ł͎萔̐邩
		if ((n = readnum(str, &num)) > 0){ // n͕
			if (num%2 == 0) {
				// side = sidekw[1].num; // 
				side = gote;
				sid = sidekw[1].cmv;
			} else {
				// side = sidekw[0].num; // 
				side = sente;
				sid = sidekw[0].cmv;
			}
			prevmove = side;
			goto zahyou;
		}
		
		// ł̓^Cv~XȂ̂ŗ\zԂݒ肵đsĂ݂
		if (prevmove == SIDE_A){
				// side = sidekw[1].num; // 
				side = gote;
				sid = sidekw[1].cmv;
				prevmove = SIDE_B;
		} else {
				// side = sidekw[0].num; // 
				side = sente;
				sid = sidekw[0].cmv;
				prevmove = SIDE_A;
		}
		str ++; // ^Cv~X1byte
		// return 0; 
		
		zahyou:
		// W
		str += n;
		str = spskip(str);
		if (n = equ(str, "")){ // Ȍ`ւ̑Ή
			str += n;
			return 1; // ̍s͖Ĕ΂
		}
		if (n = equ(str, "")){
			str += n;
			return 1; // ̍s͖Ĕ΂
		}
		// kif̏Iǌ`
		if (equ(str, "")){
			if (prevmove == SIDE_A) return 3; // 菟
			if (prevmove == SIDE_B) return 2; // 菟
		}
		if (equ(str, "f"))return 6;
		if (equ(str, "")) return 4;
		if (equ(str, "")) return 5;
		// ki2̏Iǌ`
		len = strlen(str);
		endstr = str + len - 5; // /f 4byte\(ki2)
		if (equ(endstr, "")){
			if (prevmove == SIDE_A) return 3; // 菟
			if (prevmove == SIDE_B) return 2; // 菟
		}
		if (equ(endstr, "f"))return 6;
		endstr = str + len - 7; // ''6byte\(ki2)
		if (equ(endstr, "")) return 4;
		if (equ(endstr, "")) return 5;
		pos = -1; // ʓIȍW̊Jn
		if (n = equ(str, "")){
			pos = sb->lastmove()->to(); // ̑O̒n_
			str += n;
			if (n = equ(str, "@")) str += n; // SpXy[X
			str = spskip(str); // ''ƎʂƂ̊ԂɑS/pspaceΎ
		} else {
			for (i=0; i<rankkwnum; i++){
				if (n = equ(str, rankkw[i].kw)){
					pos = rankkw[i].num;
					str += n;
					break;
				}
			}
			for (i=0; i<colkwnum; i++){
				if (n = equ(str, colkw[i].kw)){
					pos = pos*10 + colkw[i].num;
					str += n;
					break;
				}
			}
			if (pos != -1){
				topos = pos;
				pos = mpos2spos(pos);
			}
		}
		if (pos == -1) {
			// if (pstat == 2){
			if (pstat == 7){ // OsRgȂ
				i = 0;
				str++;
				while (*str != 0x0a && *str != '\0' && i < BUFLEN-1){
					cbuf[i] = *str++;
					i++;
				}
				cbuf[i] = '\0';
				sb->addcmnt(sb->lastmove(), cbuf);
				return 7; // ߐƂĖ߂
			}
			return 0; // W\ĂȂ
		}
			
		
		// 
		if (n = equ(str,"")) str += n; // Wľ''΃XLbv
		for (i=0; i<kindkwnum; i++){
			if (n = equ(str, kindkw[i].kw)){
				kind = kindkw[i].num; // keywordcode+prom bit𓾂
				str += n;
				if (kind & PROMBIT) prom = 1; else prom = 0; // promBIT
				kind &= CODEBITS; // ɃR[hɂ
			//	printf("%s", kindkw[i].cmv);
			//	name = kindkw[i].cmv; // ł͐Ԃs
				break;
			}
		}
		if (i == kindkwnum) return -1;
	
		// Cq
		tp = NULL;
		if (n = equ(str, "")){
			str += n;
			tp = sb->piece(sb->handid(side, kind));
			// łkif`ׂ
			str2 = spskip(str);
			if (*str2 == '('){ //kif`Ɣfčs܂Ŗ
				while (*str != 0x0a) str++;
			} else if (*str2 == 0x0a){
				str = str2;
			}
		} else {
			// Cq
			dirbit = 0xff;
			while (1){
				for (i=0; i<dextkwnum; i++){
					if (n = equ(str, dextkw[i].kw)) {
						str += n;
						dirbit &= dextkw[i].num; // rbg}XN
						goto next; // ̕Cq
					}
				}
				// KCqȂȂ
				break;
				// ̕Cq
				next:;
			}
			// `I\L̏ꍇƂĒׂ
			// rbgɓKT
			for (i=0; i<sb->getefnum(side, pos); i++){
				tp = sb->piece(sb->getefid(side, pos, i));
				if (tp->getcode() != kind || tp->getprom() != prom)
					continue; // Ɛ肪vȂƂ
				if (mvbit(pos, tp) & dirbit){ // rbgv
					goto find; // tpv
				}
			}
			// ƉE͒AȀꍇ
			if ((dirbit & MIGI) || (dirbit & HIDARI)){
				dirbit |= NAKA; // ^Ɛ^t 
				for (i=0; i<sb->getefnum(side, pos); i++){
					tp = sb->piece(sb->getefid(side, pos, i));
					if (tp->getcode() != kind || tp->getprom() != prom)
						continue; // Ɛ肪vȂƂ
					if (mvbit(pos, tp) & dirbit){ // rbgv
						goto find; // tpv
					}
				}
			}
			tp = NULL; // vʂ͂Ȃ
			if (prom) return -1;
			// Տɂ͂Ȃ̂ŎT
			if (sb->hand(side, kind) != 0){
				tp = sb->piece(sb->handid(side, kind));
				goto find;
			}
			return -1; // YȂ
		}
		find: // YƂ̒Eo
		if (tp == NULL) return -1;
		
		// Cq
		for (i=0; i<pextkwnum; i++){
			if (n = equ(str, pextkw[i].kw)) {
				str += n;
				prom = pextkw[i].num;
				break;
			}
		}
		
		// VZ(77)Ȃǂ̕\L̏ꍇ
		// ()́AkifȂړki2Ə
		// kif`́uVZ(77)vAki2́uVZ ( 0)vXy[XႤ
		if (*str == '('){ // kif`
			str++;
			str = spskip(str);
			n = readnum(str, &num);
			tp = sb->bdp(mpos2spos(num)); // ki2`Ƃ͂܂
			str += n+1; // ')'̕
			
			// łkif`ׂ
			str2 = spskip(str);
			if (*str2 == '('){ //kif`Ɣfčs܂Ŗ
				while (*str != 0x0a) str++;
			} else if (*str2 == 0x0a){
				str = str2;
			}
		} else if (*str == ' ' && *(str+1) == '('){ // ki2
			str+=2;
			str = spskip(str);
			n = readnum(str, &num);
			// tp = sb->bdp(mpos2spos(num)); // ki2`Ƃ͂܂
			str += n+1; // ')'̕
			
			// łkif`ׂ
			str2 = spskip(str);
			if (*str2 == '('){ //kif`Ɣfčs܂Ŗ
				while (*str != 0x0a) str++;
			} else if (*str2 == 0x0a){
				str = str2;
			}
		}
		
		if (tp == NULL)	return -1; // YȂA
	
	
		// SBASE𓮂
		// frompos = tp->getpos();
		ply.setmove(tp, pos, prom);
		if ((n = sb->rulechk(&ply)) != 0 /*&& n != 8*/){ // n==8:Qw
			return -1;
		}
		sb->move(&ply);
		
		// s
		if (*str == 0x0a) break;
		if (*str == '\0') break;
		if (*str == ' ') {
			while (*str == ' '){
				str++;
			}
			if (*str == 0x0a || *str == '\0') break;
			rc = 0;
			continue;
		}
		if (n = equ(str, "@")){ // SpXy[X
			str += 2;
			rc = 0;
			continue;
		}
		rc++;
		if (rc == 2){
//			fprintf(stderr, "\nϊs\(): [%s]", str);
			return 0; // \łȂ
		} else {
			continue;
		}
	}
	
	return 1;
}

// ϊs
// Return:ϊǐ
int CK2CSEL::conv(FILE *fp, FILE *op, SBASE *sb, const char *kisen, const char *datestr, int n, const char *fname)
{
	char *headstr[10] = {
		"'햼:", "'^:", "", "'萔:", "'荇:",
		"'\:", "'΋Ǔ:", "':", "N+", "N-",
	};
	char *head[10];
	char hbuf[10][1000];
	char buf[BUFLEN];
	char *str;
	char *t;
	int i, r1, r2, r3, newkifu, retry, tesu, kifucount, teai, sente;
	PCELL *pcl;
	
	CWaitCursor cw; // v}[N̕\A{֐̏Iŏ

	if (n != 0) fprintf(op, "/\n");
	
	for (i=0; i<10; i++) {
		hbuf[i][0] = '\0';
		head[i] = &(hbuf[i][0]);
	};
	kifucount = 0; // Ǐ
	retry = 0; // ꕶ񒲂ׂ
	newkifu = 1; // 1=VJn҂ 0=Jn
	sb->setup(0); // ɍď
	sb->setturn(SIDE_A); // setup()ł͎ԏłȂ
	m_Comment.Empty();
	sente = SIDE_A;
	teai = 0; // 
	str = buf;
	t = fgets(str, BUFLEN, fp);
	while (t != NULL){// st@C̏I܂œǂ
		// ݂̃tF[Ywb_Ɖ肷
		// wb_I܂
		while ((r1 = convheader(str, head)) != 0){//L[[h
			// YȂΎ̃tF[Y
			// ̊ꍇɂ'/'o
			if (newkifu == 1 && kifucount != 0){
				fprintf(op, "/\n");
			}
			newkifu = 0; // ̊Jnł邱ƂmFꂽ
			retry = 0; // nꂽstr͓ǂ߂̂retry̓NA
			tesu = 0;
			do {
				str = buf;
				t = fgets(str, BUFLEN, fp); // sǂ
				if (t == NULL) goto findeof;
				str = spskip(str);
			} while(*str == 0x0a);
		}
		
		// 荇ŏ
		if (newkifu == 0){
			teai = handicap(head[4]);
			sb->setup(teai);
			if (teai != 0) {
				sente = SIDE_B;
				sb->setturn(SIDE_B); // łȂȂSIDE_B
			} else {
				sente = SIDE_A;
				sb->setturn(SIDE_A);
			}
		}
		// ǖʂ̃tF[Y
		// ǖʎw肪I܂
		if (newkifu == 0){
			while ((r2 = convfbd(str, sb)) != 0){ // s̉
				// ߂łȂΎ̃tF[Y
				do {
					str = buf;
					t = fgets(str, BUFLEN, fp); // sǂ
					if (t == NULL) goto findeof;
					str = spskip(str);
				} while(*str == 0x0a);
			}
		}
		
		// ̃tF[Y
		// IsȂ甲
		if (newkifu == 0 /*|| newkifu == 1*/){
			r3 = 0;
			while ((r3 = convmov(str, sb, sente, r3)) > 0){ // 
				// if (newkifu == 1) newkifu = 0; // Ƃēǂ߂
				do {
					str = buf;
					t = fgets(str, BUFLEN, fp); // sǂ
					if (t == NULL) goto findeof;
					str = spskip(str);
				} while(*str == 0x0a); // sȂǂݔ΂
				if (r3 == 4 || r3 == 5 || r3 == 6) goto findeof;
			}
		}
		
		// ŏItF[YŏłȂ̂łPǏIƂ݂Ȃ
		findeof:
		if (newkifu == 0) {
			if (kisen != NULL && head[0][0] == '\0') {
				sprintf(head[0], "%s", kisen);
			}
			if (datestr != NULL && head[6][0] == '\0'){
				sprintf(head[6], "%s", datestr);
			}
			sprintf(head[3], "%d", sb->level());
			if (r3 == 0){
				if (teai == 0){
					sprintf(head[7], "%s", 
						(sb->level()%2 == 0) ? "菟" : "菟");
				} else {
					sprintf(head[7], "%s", 
						(sb->level()%2 == 0) ? "菟" : "菟");
				}
			} else if (r3 == 2) {
				if (teai == 0){
					sprintf(head[7], "菟");
				} else {
					sprintf(head[7], "菟");
				}
			} else if (r3 == 3){
				if (teai == 0){
					sprintf(head[7], "菟");
				} else {
					sprintf(head[7], "菟");
				}
			} else if (r3 == 4){
				sprintf(head[7], "");
			} else if (r3 == 5){
				sprintf(head[7], "");
			} else if (r3 == 6){
				sprintf(head[7], "f");
			}
			for (i=0; i<10; i++) { // wb_o͎s
				if (*(head[i]) != '\0') {
					fprintf(op, "%s%s\n", headstr[i], head[i]);
				}
			}
			if (m_Comment != ""){
				fprintf(op, (LPCTSTR)m_Comment); // ΋ǒ
			}
			fprintf(op, "': ϊt@C[%s]\n", fname);
//			fprintf(stderr, " %d.[%s - %s] ϊ\n",
//					 kifucount+1, head[8], head[9]);
			
			fprintf(op, handistr(teai));
//			if (teai == 0) fprintf(op, "PI\n+\n"); // A

			pcl = (sb->root())->cld(0);
			while (pcl != NULL){	// o
				fprintf(op, "%s\n", sb->csastr(pcl));
				i = 0;
				while (sb->getcmnt(pcl, i) != NULL){
					fprintf(op, "':%s\n", sb->getcmnt(pcl, i));
					i++;
				}
				pcl = pcl->cld(0);
			}
			if (r3 == -1){ // 
				fprintf(op, 
				"': {͂ȍ~͐ɕϊ܂łB\n");
				fprintf(op,
				"': ɕs̉\܂B\n");
//				fprintf(stderr, 
//				"  ----Ǐ]s\ɂ{ϊ𒆒f܂\n");
				fprintf(op, "%%ERROR\n");
			} else if (r3 == 4){
				fprintf(op, "%%SENNICHITE\n");
			} else if (r3 == 5){
				fprintf(op, "%%JISHOGI\n");
			} else if (r3 == 6){
				fprintf(op, "%%CHUDAN\n");
			} else {
				fprintf(op, "%%TORYO\n");
			}
			kifucount++;
			if (t == NULL) return 1;
			
			sb->setup(0); // ɍď
			teai = 0;
			sb->setturn(SIDE_A); // setup()ł͎ԏłȂ
			for (i=0; i<10; i++) {
				hbuf[i][0] = '\0';
			};
			newkifu = 1; // ̊̊Jn
			if (retry == 0){
				retry++;
				continue;
			}
		}
		retry = 0;
		str = buf;
		t = fgets(str, BUFLEN, fp); // Vɍsǂ
		str = spskip(str);
	}
	return kifucount;
}

/*
int main(int argc, char *argv[])
{
	FILE *fp;
	PIECE pc[40];
	BOARD bd;
	HBOX hb[3];
	SBASE sb;
	int i, n;
	char *kisen, *datestr;
	
	kisen = NULL;
	n = 0;
	sb.Create(pc, sizeof(PIECE), &bd, hb, sizeof(HBOX));
	if (argc == 1){
		usage();
		return 0;
	}
		
	for (i = 1; i< argc; i++){
		if (equ(argv[i], "-t")){
			kisen = argv[i]+2;
		} else if (equ(argv[i], "-d")){
			datestr = argv[i]+2;
		} else {
			fp = fopen(argv[i], "r");
			if (fp == NULL){
				fprintf(stderr, "can't open [%s]\n", argv[i]);
				exit(1);
			}
			fprintf(stderr, "==== ̓t@Cu%sv====\n", argv[i]);
			if (n != 0) printf("/\n"); // t@C̋؂
			n = conv(fp, &sb, kisen, datestr);
			fclose(fp);
		}
	}
	return 0;
}
*/

// orgpath(tpX)t@C߁Agqcsaɂ
// hCuƃfBNgdstpathɂorgpathXgOɊi[
static void csafile(CString *orgpath, CString *dstdir)
{
	char drive[10], dir[256], fname[256], ext[256];

	_splitpath((LPCTSTR)(*orgpath), drive, dir, fname, ext);
	*orgpath = *dstdir;
	if (orgpath->Right(1) != _T("\\")){
			*orgpath += "\\";
	}
	*orgpath += fname;
	*orgpath += ".csa";
}

int CK2CSEL::convert(CListBox *list,		// ϊt@CitpXj
			int pack,			// 0= 1=ꊇ
			int wmode,			// ꊇ 0=ǉ 1=㏑
			CString *outdir,	// o̓hCu&fBNg(C:\..\..\)
			CString *outfname,	// ꊇ̏ꍇ̃t@C(abc.csa)
			CString *kisen,		// 햼
			CString *datestr)	// t(yyyymmdd)
{
	FILE *fp, *outfp;
	PIECE pc[40];
	BOARD bd;
	HBOX hb[3];
	SBASE sb;
	int i, n, filenum;
	CString readfname;
	CString writefname;
	char buf[256];
	
	n = 0;
	sb.Create(pc, sizeof(PIECE), &bd, hb, sizeof(HBOX));
	
	filenum = list->GetCount(); // t@C
	
	if (pack == 0){ // ꊇ
		writefname = *outdir;
		if (writefname.Right(1) != _T("\\")){
			writefname += "\\";
		}
		writefname += *outfname;
		// t@Cłɑ݂ĂȂ擪/̂Œׂ
		outfp = fopen((LPCTSTR)writefname, "r");
		if (outfp != NULL && wmode == 0){ // ǉ
			n = 1; // n!=0Ȃconv()̍ŏ'/\n'o͂
		}
		if (outfp != NULL) fclose(outfp);
		if (wmode == 0){
			outfp = fopen((LPCTSTR)writefname, "a+"); // o̓t@CJ
		} else {
			outfp = fopen((LPCTSTR)writefname, "w"); // o̓t@CJ
		}
		if (outfp == NULL){
			sprintf(buf, "o[%s]J܂", (LPCTSTR)writefname);
			AfxMessageBox(buf);
			return 1; // ꊇŏo̓t@CJȂΑI
		}
		for (i = 0; i< filenum; i++){
			list->GetText(i, readfname); // t@C擾
			fp = fopen((LPCTSTR)readfname, "r"); // ̓t@CJ
			if (fp == NULL){
				sprintf(buf, "[%s]J܂", (LPCTSTR)readfname);
				AfxMessageBox(buf);
				continue;
			}
			n = conv(fp, outfp, &sb, (LPCTSTR)(*kisen), (LPCTSTR)(*datestr),
				n, (LPCTSTR)readfname);
			fclose(fp); // ̓t@C
		}
		fclose(outfp); // o̓t@C
		sprintf(buf, "t@C %s Ɉꊇo͂܂", (LPCTSTR)writefname);
		AfxMessageBox(buf);
	} else { // 
		for (i = 0; i< filenum; i++){
			list->GetText(i, readfname); // t@C擾
			fp = fopen((LPCTSTR)readfname, "r"); // ̓t@CJ
			if (fp == NULL){
				sprintf(buf, "[%s]J܂", (LPCTSTR)readfname);
				AfxMessageBox(buf);
				continue;
			}
			writefname = readfname;
			csafile(&writefname, outdir); // fnamêύX
			outfp = fopen((LPCTSTR)writefname, "w"); // o̓t@CJ
			if (outfp == NULL){
				sprintf(buf, "o[%s]J܂", (LPCTSTR)writefname);
				AfxMessageBox(buf);
				fclose(fp); // outfpNULLfp͐Ă̂ŕ
				continue;
			}
			conv(fp, outfp, &sb, (LPCTSTR)(*kisen), (LPCTSTR)(*datestr),
				0, (LPCTSTR)readfname);
			fclose(outfp); // o̓t@C
			fclose(fp); // ̓t@C
		}
		// modified by Ra outdir -> (*outdir)
		sprintf(buf, "fBNg %s Ɍʏo͂܂", (LPCTSTR)(*outdir));
		AfxMessageBox(buf);
	}
	return 1;
}
