/**********************/
/*    KifFrame.cpp    */
/**********************/
#include "stdafx.h"
#include "winsdj.h"
#include "KifFrame.h"
#include "kiflistview.h"
#include "kiftreeview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKifFrame

IMPLEMENT_DYNCREATE(CKifFrame, CFrameWnd)

CKifFrame::CKifFrame()
{
	m_pParentView = NULL;
}

CKifFrame::~CKifFrame()
{
}

BEGIN_MESSAGE_MAP(CKifFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CKifFrame)
		ON_COMMAND(ID_KIFFRAME_INIT, OnKifFrameInit)
		ON_COMMAND(ID_KIFFRAME_UPDATE, OnKifFrameUpdate)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKifFrame bZ[W nh

BOOL CKifFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// EBhE̐
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;
	// Xgr[̐
	CRect rc;
	GetClientRect(&rc);
	CSize sz(128,rc.Height()); // 128Xg\̈
	if (!m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CKifListView),sz,pContext))
		return FALSE;
	// c[r[̐
	CSize sz2(rc.Width()-128,rc.Height()); // 128̎cXg\̈
	if (!m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CKifTreeView),sz2,pContext))
		return FALSE;
	
	return CFrameWnd::OnCreateClient(lpcs, pContext);
}

BOOL CKifFrame::DestroyWindow() 
{

	m_pParentView->SendMessage(WM_COMMAND,ID_SETKIFFRAME_NULL);
	
	return CFrameWnd::DestroyWindow();
}

// ̍XV
void CKifFrame::OnKifFrameUpdate()
{
	// Xgr[̍XV
	CKifListView *pKifListView = (CKifListView *)m_wndSplitter.GetPane(0,0);
	pKifListView->KifUpdate();

	CKifTreeView *pKifTreeView = (CKifTreeView *)m_wndSplitter.GetPane(0,1);
	pKifTreeView->KifUpdate();
}

// ̏
void CKifFrame::OnKifFrameInit()
{
	// Xgr[̏
	CKifListView *pKifListView = (CKifListView *)m_wndSplitter.GetPane(0,0);
	pKifListView->KifInit();

	CKifTreeView *pKifTreeView = (CKifTreeView *)m_wndSplitter.GetPane(0,1);
	pKifTreeView->KifInit();
}

// 鎞
void CKifFrame::OnClose() 
{
	// DefaultOnClose()̓hLg̕ύX`FbN̂ŌĂ΂ȂB
	
	DestroyWindow();
}
