/*******************/
/*    MBase.cpp    */
/*******************/
#include "stdafx.h"
#include "mbase.h"

// O[o֐
extern "C" {
	void *memalloc(unsigned int);
	void memfree(void *);
}

// pid alloc size 50肸
#define PID_SIZE 50

// wp[֐
static void check_mpid(CArray <int,int>*pid,int sz)
{
	int n=pid->GetSize();
	if (sz<=n)
		return ;	 // ݂̗eʂőB
	for (int i=0;i<sz-n;i++)
		pid->Add(0); // eʂsz܂ŊgB 
}

///////////////////////////////////////////
// CMBase

IMPLEMENT_SERIAL(CMBase, SBASE,0)

CMBase::CMBase()
{
	m_judgelevel=-1; // ݒ

	m_pid.SetSize(PID_SIZE);
	m_pid2.SetSize(PID_SIZE);

	memset(&m_jban,0,sizeof m_jban);
	m_maxlevel=-1;  // ݒ
	m_bAlistUsing=FALSE;
}

CMBase::~CMBase()
{
	m_pid.RemoveAll();
	m_pid2.RemoveAll();
}

///////////////////////////////////////////
// VACY
void CMBase::Serialize(CArchive& ar)
{
	// SBASE::Serialize()setbtype()move2()Ă΂A
	// ̒ō̎Q(GetZa())sB
	// ̂ɐZaVAĂKv
	// (DocSerializeQƂ)B
	SBASE::Serialize(ar);
}

// {菇݂̂̃VACY
void CMBase::LineSerialize(CSDJArchive& ar)
{
	PIECE Piece[40];	// 
	BOARD Board;		// 
	HBOX  Hbox[3];		// E
	CMBase mb;			// ƗpCMBase
	mb.Create(Piece,sizeof(PIECE),&Board,Hbox,sizeof(HBOX));

	if (ar.IsStoring()) {
		CopySBase(&mb,TRUE); // S{菇Rs[
		mb.Serialize(ar);    // o
	}
	else {
		mb.Serialize(ar);		 // Swǂݍ
		mb.CopySBase(this,TRUE); // S{菇Rs[
	}
}

///////
// ǖʂB`̎wbplayœ
// bSep͕򂵂ē͂邩ۂ TRUEŕ DefaultFALSE
int CMBase::move(B_PLAY bplay,BOOL bSep /*=FALSE */)
{
	if (!bSep)
		FreePcell();		// 򂵂w̏
	JudgeRootPreCheck(bplay);	// {菇̑O
	int ret = SBASE::move(bplay);
	JudgeRootAfterCheck();	// {菇̌㔻

	return ret;
}
int CMBase::move2(B_PLAY bplay,BOOL bSep /*=FALSE*/)
{
	if (!bSep)
		FreePcell();		// 򂵂w̏
	JudgeRootPreCheck(bplay);	// {菇̑O
	int ret = SBASE::move2(bplay);
	JudgeRootAfterCheck();	// {菇̌㔻
	
	return ret;
}
int CMBase::move(PCELL *pcl,BOOL bSep /*=FALSE*/)
{
	if (!bSep)
		FreePcell();		// 򂵂w̏
	JudgeRootPreCheck(pcl);	// {菇̑O
	int ret = SBASE::move(pcl);
	JudgeRootAfterCheck();	// {菇̌㔻
	
	return ret;
}
int CMBase::move2(PCELL *pcl,BOOL bSep /*=FALSE*/)
{
	if (!bSep)
		FreePcell();		// 򂵂w̏
	JudgeRootPreCheck(pcl);	// {菇̑O
	int ret = SBASE::move2(pcl);
	JudgeRootAfterCheck();	// {菇̌㔻
	
	return ret;
}

//////////
// O̎w(ƕKvȂ璼O̔Ֆ)𓾂
// bp==NULL(ftHg)ȂՖʂ͕ԂȂB
// pside==NULL(ftHg)ȂԂ͕ԂȂB
B_PLAY CMBase::LastBplay(CBform *bp,int *pside)
{
	PCELL *pcl=lastmove();
	if (pcl==root())
		return 0x8000; // ǖʂ̎͋̎wԂ

	backmove2();
	CBform *pBform=btype();// Őǖ
	int side =pcl->newside();     // ̌==
	int from =spos2mpos(pcl->from());
	int to	 =spos2mpos(pcl->to());
	int prom =pcl->prom();
	int id	 =pcl->getid();
	int code =pcode(id);
	// B`̎w擾
	B_PLAY bplay=pBform->GetBplay(from,to,prom,side,code);
	// ǖʂ~΃Rs[B
	if (bp)
		*bp=*pBform;
	if (pside)
		*pside=side;

	// pcl̃CfNXlT
	PCELL *pcl2=lastmove();
	int n=pcl2->cldnum();
	int i;
	for (i=0;i<n;i++) {
		if (pcl2->cld(i)==pcl)
			break;
	}
	ASSERT(i!=n);
	SBASE::ahead2(i); // Ŗ{菇̔͂Ȃ̂SBASEĂԁB
	return bplay;
}

///////
// ǖʂ̎擾
void CMBase::GetAspect(CBform *pBform, int *side)
{
	CBform *bp=btype();
	*pBform = *bp;  // Rs[
	*side=turn();   // 
}

/////
// ǖʂ̐ݒ
//  w̋L^͔jB
void CMBase::SetAspect(CBform *pBform, int side)
{
	setbtype(pBform);
	setturn(side);
}

//// 
// ǖʂł̎w̎̕擾
//   ̊֐bplayŋǖʂXVŐǖʂŎw蕶
//   擾ꍇɗpB(ŋǖʂi߂Ė߂)
// ߂l  OK/NG 1/0
BOOL CMBase::GetMvstr(B_PLAY bplay,CString &strMove)
{
	// ǖʂ𓮂(w͋L^)
	int rc=SBASE::move2(bplay); // {菇̕KvȂB
	if (rc==0) {
		TRACE("CMBase::GetMvstr move2 error\n");
		return 0; // error;
	}
	PCELL *pcl=lastmove();
	strMove.Format("%s",mvstr(pcl));
	backmove2(); // ǖʂɖ߂

	return 1;
}

//////
// wԂ̊J
void CMBase::FreePcell()
{
	// }ʂꂵwc[Ώ
	PCELL *pcl=lastmove();
	if (pcl->cldnum()) {
		while(pcl->cldnum()) {   // w胊XgȂȂ܂ŌJԂB
			if (pcl->cldnum()) { // w胊Xg΁A
				PCELL *pcl2=pcl->cld(0); // ̐擪̎w胊Xg擾
				freepcl(pcl2);   // ̃XgJ
			}
		} 
		m_judgelevel=-1;
	}
}

////////////////////////////////////////////////////
// {菇̏


///////////////////////////
// {菇̔
//  ݂̋ǖʂƋLĂ{菇ŏIǖʂrA
//  {菇XVBŏIǖʂLĂȂ(m_maxlevel<0)
//  Ɍ݂̋ǖʂ{菇̍ŏIǖʂƂB
//  {菇̔f́A
//    1. 萔̐[
//    2. ̎̏Ȃ
//    3. ̎̑
//  ߂l  
//    FALSE:{菇͂܂ł̂܂
//    TRUE :{菇͌ǖʂɍXVꂽ

BOOL CMBase::JudgeAspect()
{
	BOOL ret=FALSE;
	int c_level=level(); // ݂̎萔
	CBform *bp=btype();  // ݂̋ǖ

	// ŏIǖʂLĂȂ΁Aǖʂݒ
	if (m_maxlevel<0) {
		ret=TRUE;
	}
	// 萔΁Aǖʂݒ
	else if (c_level > m_maxlevel) {
		ret=TRUE;
	}
	// 萔΋ǖʂᖡB
	else if (c_level==m_maxlevel){
		SHOGIBAN ban;
		bp->ToShogiBan(&ban);
		// ̃JEg
		int i,j,n;
		int score[8]={0,5,5,1,1,1,1,1}; // ̓_(5_Aq1_)
		int sg[2]={0,0};  // ǖ   sg[]
		int sg1[2]={0,0}; // Lǖ sg1[]
		for (i=0;i<2;i++) {
			for (j=0;j<8;j++) {
				// Dai[][]()_֊ZB
				if ((n=ban.Dai[i][j])!=0)
					sg[i]=sg[i]+score[j]*n;
				if ((n=m_jban.Dai[i][j])!=0)
					sg1[i]=sg1[i]+score[j]*n;
			}
		}
		// ̎Ȃ {菇ɍ̗p
		if (sg[0] < sg1[0]) {
			ret=TRUE;
		}
		// ̎ȂA̎{菇ɍ̗p
		else if (sg[0]==sg1[0]) {
			if (sg[1] > sg1[1])
				ret=TRUE;
		}
	}

	// {菇̍XV
	if (ret) {
		bp->ToShogiBan(&m_jban);
		m_maxlevel=c_level;
		check_mpid(&m_pid,m_maxlevel);
		for (int i=0;i<m_maxlevel;i++)
			m_pid[i]=m_pid2[i];
	}
	return ret;
}

///////////
// wԂ̒T(ċA֐)
//   ݂̋ǖʈȉŖ{菇TAm_pidփZbgB
//   {菇TŏIǖʂŏIB
void CMBase::SearchPcell()
{
	int cnum=lastmove()->cldnum(); // q̐
	if (cnum==0) {			// [Ȃ
		JudgeAspect();		// {菇̔
		return;
	}
	int n=level();
	for (int i=0;i<cnum;i++) {
		// q(j)̋ǖʂ֍~ĒTB
		check_mpid(&m_pid2,n+1);
		m_pid2[n]=i;		// 菇L
		SBASE::ahead2(i);	// ǖʑOi
		SearchPcell();		// ċAďo !!!!
		backmove2();		// ǖʌ
	}
}

///////////
// {菇̔
//   ǖʈȍ~̎wԂ̒Ŗ{菇vZB
//   {菇m_pidzɊi[Bahead() or ahead(m_pid[level()])
//   ƂėpB
//   {֐ɂĔ肳ꂽ萔ڂm_judgelevelɋLB
void CMBase::JudgeRoot()
{
	m_judgelevel=level();	// {菇萔ڂ̋L

	// 㗬̖{菇m_pid2փRs[B
	check_mpid(&m_pid2,m_judgelevel);
	for (int i=0;i<m_judgelevel;i++)
		m_pid2[i]=m_pid[i];

	m_maxlevel=m_judgelevel;
	// ȍ~̍Œ菇m_maxlevel֕Ԃ
	SearchPcell();	// wԂ̒T
}

//////
// wO̖{菇
// ǖʂOiƂ{菇̔肪Kvۂ
// `FbNAKvȂ{菇̔sB
void CMBase::JudgeRootPreCheck()
{
	// wOɖ{菇f̕Kv`FbN
	BOOL judge=FALSE;
	int m=level();
	// ܂͏㗬n_܂͕
	if	(m_judgelevel < 0)		judge=TRUE;
	else if (m < m_judgelevel)	judge=TRUE;

	if (judge)
		JudgeRoot(); // {菇̔
}
void CMBase::JudgeRootPreCheck(PCELL *pcl)
{
	// wOɖ{菇f̕Kv`FbN
	BOOL judge=FALSE;
	int m=level();
	// ܂͏㗬n_܂͕
	if	(m_judgelevel < 0)		judge=TRUE;
	else if (m < m_judgelevel)	{
		judge=TRUE;
		// w肪{菇Ȃjudge=FALSEƂB
		if (m < m_maxlevel) {
			if (lastmove()->cld(m_pid[m])==pcl)
				judge=FALSE;
		}
	}

	if (judge)
		JudgeRoot(); // {菇̔
}
void CMBase::JudgeRootPreCheck(int n)
{
	// wOɖ{菇f̕Kv`FbN
	BOOL judge=FALSE;
	int m=level();
	// ܂͏㗬n_܂͕
	if	(m_judgelevel < 0)		judge=TRUE;
	else if (m < m_judgelevel)	{
		judge=TRUE;
		// w肪{菇Ȃjudge=FALSEƂB
		if (m < m_maxlevel) {
			if (m_pid[m]==n)
				judge=FALSE;
		}
	}

	if (judge)
		JudgeRoot(); // {菇̔
}
void CMBase::JudgeRootPreCheck(B_PLAY bplay)
{
	// wOɖ{菇f̕Kv`FbN
	BOOL judge=FALSE;
	int m=level();
	// ܂͏㗬n_܂͕
	if	(m_judgelevel < 0)		judge=TRUE;
	else if (m < m_judgelevel)	{
		judge=TRUE;
		// w肪{菇Ȃjudge=FALSEƂB
		if (m < m_maxlevel) {
			PCELL *pcl=lastmove()->cld(m_pid[m]);
			PLAY ply1=*pcl;
			PLAY ply2;
			BOOL ok=BplayToPlay(bplay,&ply2);
			ASSERT(ok);
			if (ply1==ply2)
				judge=FALSE;
		}
	}

	if (judge)
		JudgeRoot(); // {菇̔
}

//////
// w̖{菇
// ǖʂw蒼ƂāAwOɐݒ肳Ă
// {菇ɑ΂򂵂ǖʂɓۂ`FbNA
// KvȂ{菇̔sB
void CMBase::JudgeRootAfterCheck()
{
	PCELL *pcl=lastmove();		// O̎w
	PCELL *pntpcl=pcl->pnt();	// ̑O̎w
	// O̎wIndex߂
	int cnum=pntpcl->cldnum();
	int n;
	for (n=0;n<cnum;n++) {
		if (pntpcl->cld(n)==pcl)
			break;
	}
	ASSERT(n!=cnum);
	int m=level();		    // ݂̎w萔
	int sz=m_pid.GetSize(); // m_pid̗e
	if (m>sz)				// m_pidTCY`FbNeʊm
		check_mpid(&m_pid,m);
	if (m_pid[m-1]!=n) {	// ֓ꍇ͍ēx{菇𔻒B
		m_pid[m-1]=n;
		JudgeRoot(); // {菇̔
	}
	else {
		if (m_maxlevel<m) {
			// check_mpid0ǉĂꂪ{菇̎
			// (ҏW͂̂悤ɂȂ)A{菇̎萔XVB
			m_maxlevel=m;
		}
	}
}

///////////
// ǖʑOi
int CMBase::ahead(void)
{
	JudgeRootPreCheck();	// {菇̑O

	return SBASE::ahead(m_pid[level()]); // ǖʑOi
}

int CMBase::ahead2(void)
{
	JudgeRootPreCheck();	// {菇̑O

	return SBASE::ahead2(m_pid[level()]); // ǖʑOi
}

int CMBase::ahead(int n)
{
	JudgeRootPreCheck(n);	// {菇̑O

	int ret=SBASE::ahead(n); // ǖʑOi

	JudgeRootAfterCheck();   // {菇̌㔻

	return ret;
}

int CMBase::ahead2(int n)
{
	JudgeRootPreCheck(n);	// {菇̑O

	int ret=SBASE::ahead2(n); // ǖʑOi

	JudgeRootAfterCheck();   // {菇̌㔻

	return ret;
}

// {菇Ȃahead2()ĂԂ̂ŁAgp͕K̋ǖʂ֖߂ƁB
int CMBase::ahead3(int n)
{
	int ret=SBASE::ahead2(n); // ǖʑOi

	return ret;
}

// ݋ǖʂǖʂƂĊL^Jn
void CMBase::recstart(void)
{
	SBASE::recstart();

	m_judgelevel=-1; // {菇NA
}

// ǖʂ̋L
// bReturn: TRUE/FALSE ̋ǖʂ܂Ŗ߂(Default)/ǖʂŕԂ
// bp,side: w(!=NULL)ΏǖʂԂBDefault:NULL
// pList:   OCListgpBDefault(NULL)Ȃm_AlistgpB
void CMBase::PushAspect(BOOL bReturn,
						CBform *bp,int *side,
						CList <int,int> *pList)
{
	int i;

	if (pList==NULL)
		pList=&m_Alist;

	// `FbN(lXg͋Ȃ)
	if (pList==&m_Alist) {
		if (m_bAlistUsing) {
			TRACE("Caution!. m_Alist is using.\n");
			m_Alist.RemoveAll();
		}
		m_bAlistUsing=TRUE;
	}

	// ǖʂ܂Ŗ߂ȂwLB
	PCELL *rootpcl=root();
	PCELL *pcl=lastmove();
	while (pcl!=rootpcl) {
		PCELL *pntpcl=pcl->pnt();
		int n=pntpcl->cldnum();
		for (i=0;i<n;i++) {
			if (pntpcl->cld(i)==pcl)
				break;
		}
		ASSERT(i!=n);
		pList->AddHead(i);
		backmove2();
		pcl=lastmove();
	}
	// ǖʂ̎擾
	if (bp)
		*bp = *btype();
	if (side)
		*side = turn();

	// ǖʂ猳̋ǖʂ܂Ŗ߂B
	if (bReturn)  {
		POSITION pos=pList->GetHeadPosition();
		while(pos) {
			int n=pList->GetNext(pos);
			SBASE::ahead2(n);
		}
	}
}

// ǖʂ̕
void CMBase::PopAspect(CList <int,int> *pList)
{
	if (pList==NULL)
		pList=&m_Alist;

	if (pList==&m_Alist) {
		// ȂďoƂ͋Ȃ
		if (m_bAlistUsing==FALSE) {
			TRACE("Caution!. m_Alist is not available.\n");
			return;
		}
	}
	// ǖʂ܂Ŗ߂B
	while (lastmove()!=root())
		backmove2();
	// ǖʂ猳̋ǖʂ܂Ŗ߂B
	POSITION pos=pList->GetHeadPosition();
	while(pos) {
		int n=pList->GetNext(pos);
		int ret=ahead2(n);
		ASSERT(ret==1);
	}
	// L폜B
	pList->RemoveAll();

	if (pList==&m_Alist)
		m_bAlistUsing=FALSE;
}

//////////////
// CopySBase Bug. 97.12.27 Fix
//   CMBase̖{菇SBASEɃRs[ꍇA܂ŏCKBase̋ǖʂbtype()
//   Ŏ擾ACJBasesetbtype()ŃRs[Ăid̊֌W܂œȂƂ
//   ȂB]āAw̃Rs[͋idCMBasePCELLőp鎖͏o
//   ȂBSBASEPLAY𐶐čsȂ΂ȂȂB
/////////
// CMBase̖{菇̃Rs[
//   pjCMBase̖{菇Rs[B
//   bAll=TRUE Ȃ珉ǖʂ̎wRs[B
//   bAll=FALSEȂ猻ǖʈȍ~̎wRs[B(ftHg)
//   bLine=TRUE Ȃ{菇̂݃Rs[B(ftHg)
//   bLine=FALSEȂ瑽̎wԂRs[B
void CMBase::CopySBase(SBASE *pj,BOOL bAll,BOOL bLine)
{
	CList <int,int> nlist;

	if (bAll) {
		// ǖʂցBǖʂ߂菇nlist֕ۑB
		PushAspect(FALSE,NULL,NULL,&nlist);
	}

	// ǖʂ̃Rs[
	pj->setbtype(btype());
	pj->setturn(turn());

	// Lǖʈȍ~̎w̃Rs[
	if (bLine)
		CopySBasePlay(pj);		// {菇̂
	else
		CopySBasePlayWhole(pj); // 莟̎w

	// ǖʂ֖߂
	if (bAll) {
		POSITION pos=nlist.GetHeadPosition();
		while (pos) {
			int n=nlist.GetNext(pos);
			ahead2(n);
			if (bLine) { // P
				if (pj->playnum())
					pj->ahead2(0);		
			}
			else {		 // 
				PCELL *pcl=lastmove();
				PLAY ply;
				if (PclToPly(pcl,pj,&ply)) // PLAYvZ
					pj->move2(&ply);
				else
					ASSERT(0); // Ȃ
			}
		}
	}
}

void CMBase::CopySBasePlay(SBASE *pj)
{
	if (playnum() <= 0) 
		return ;

	// {菇őOi
	ahead2();
	PCELL *pcl=lastmove();

	//  L pclSBASE̎wRs[ɂ͎gȂBSBASEpPLAY𐶐B
	PLAY ply;
	if (PclToPly(pcl,pj,&ply)==FALSE) {
		TRACE("PcltoPly failed\n");	return ; // ϊs(Ȃ);
	}
	pj->move2(&ply); // pj𓮂

	PCELL *pcl2=pj->lastmove(); // pj𓮂PCELL

	CopyPclCmnt(pcl,pj,pcl2); // ߕ̃Rs[

	CopySBasePlay(pj); // ċAĂяo

	backmove2();
	pj->backmove2();
}

void CMBase::CopySBasePlayWhole(SBASE *pj)
{
	int n=playnum();

	if (n <= 0) 
		return ;

	// SĂ̎wԂɑOi
	for (int i=0;i<n;i++) {
		SBASE::ahead2(i);
		PCELL *pcl=lastmove();

		//  L pclSBASE̎wRs[ɂ͎gȂBSBASEpPLAY𐶐B
		PLAY ply;
		if (PclToPly(pcl,pj,&ply)==FALSE) {
			TRACE("PcltoPly failed\n");	return ; // ϊs(Ȃ);
		}
		pj->move2(&ply); // pj𓮂

		PCELL *pcl2=pj->lastmove(); // pj𓮂PCELL

		CopyPclCmnt(pcl,pj,pcl2); // ߕ̃Rs[

		CopySBasePlayWhole(pj); // ċAĂяo

		backmove2();
		pj->backmove2();
	}
}

/////
/// PCELL plySBASE *pjœPLAY *pplyɕϊB
//  ߂l  TRUE/FALSE   /s
BOOL CMBase::PclToPly(PCELL *pcl,SBASE *pj,PLAY *pply)
{
	int id;
	int sfrom	=pcl->from();
	int sto		=pcl->to();
	int side	=pcl->newside();
	int prom	=pcl->prom();
	int kid		=pcl->getid();
	int code	=pcode(kid);

	PLAY ply;	// pjpPLAY

	// w̏񂩂PLAY\z(SBASE::setpcelldataQl)
	if (sfrom <= 2){ // 
		// YID
		ASSERT(code >=0 && code <= 7);
		int sid[] = {0, 2, 4, 6, 10, 14, 18, 22}; // start id
		for (id=sid[code];id < MAXPIECE && pj->ppos(id) != sfrom;id++);
		ASSERT(id!=MAXPIECE);
			// ID̎ʊmFAŏꏊ̋󏊊mF
		ply.setmove(pj->piece(id), sto, 0, side);
	} else { // 
		PIECE *ppc;
		if ((ppc = pj->bdp(sfrom)) == NULL) {
			TRACE("SBase::BplayToPlay error, bdp(%d)==NULL\n",sfrom);
			return FALSE; // Error
		}
		ply.setmove(ppc, sto, prom, side);
	}

	*pply=ply;

	return TRUE;
}

// PCELL *pcl̃RgSBASE *pjPCELL *pcl2̃RgփRs[
void CMBase::CopyPclCmnt(PCELL *pcl,SBASE *pj,PCELL *pcl2)
{
	// ߕ̃Rs[
	int n=getcmntnum(pcl);
	for (int i=0;i<n;i++) {
		char *cmnt=getcmnt(pcl,i);
		if (cmnt)
			pj->addcmnt(pcl2,cmnt);
		else 
			ASSERT(0); // ȂƂ͂Ȃ
	}
}

///////
// {菇BPLAYXg̎擾
//  pBlist B_PLAYXgi[CList^ւ̃|C^
//  bp,side:  !=NULLłȂΏǖʂԂB
//  ߂l 0:wԂ͂P  1:wԂ͑
int CMBase::GetBplayList(CList <B_PLAY,B_PLAY&> *pBlist,
						 CBform *bp,int *side)
{
	int ret=0;

	CList <int,int> Back; // ֖߂邽߂̃Xg

	PushAspect(FALSE,bp,side,&Back); // ǖʂ

	pBlist->RemoveAll();
	// {菇HčŏIǖʂ܂
	int n=lastmove()->cldnum();
	while (n) {
		if (ret==0 && n > 1)
			ret=1; // Xg͑ł
		ahead2();
		B_PLAY bplay=LastBplay();
		pBlist->AddTail(bplay);

		n=lastmove()->cldnum();
	}

	PopAspect(&Back); // ǖʂɖ߂

	return ret;
}

////
// wԂۂ𒲂ׂ
//  TRUE:   FALSE:ꎟ
BOOL CMBase::IsMulti()
{
	BOOL ret=FALSE;

	CList <int,int> Back; // ֖߂邽߂̃Xg

	PushAspect(FALSE,NULL,NULL,&Back); // ǖʂ

	// {菇HčŏIǖʂ܂
	int n;
	while ((n=playnum())!=0) {
		if (n > 1) {
			ret=TRUE; // Xg͑ł
			break;
		}
		ahead2();
	}

	PopAspect(&Back); // ǖʂɖ߂

	return ret;
}

/////////
// ǖʂ̃Rs[
//    idxłv悤ɋǖʂRs[B
//    SBASE *psrc: Rs[SBASE
void CMBase::CopyAspect(SBASE *psrc)
{
	setup(8); // Sċ֓B

	for (int i=0;i < MAXPIECE;i++) {
		int to		= psrc->ppos(i);
		int prom	= psrc->pprom(i);
		int side	= psrc->pside(i);
		if (to!=ON_BOX) {
			piece(i)->move2(to,prom,side); // 𓮂
		}
	}

	setturn(psrc->turn()); // 

	recstart();
}
