/***********************/
/*    MateFrame.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "MateFrame.h"
#include "mainfrm.h"
#include "mateview.h"
#include "winsdjtsview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMateFrame

IMPLEMENT_DYNCREATE(CMateFrame, CFrameWnd)

CMateFrame::CMateFrame()
{
}

CMateFrame::~CMateFrame()
{
}

BEGIN_MESSAGE_MAP(CMateFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMateFrame)
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMateFrame bZ[W nh

BOOL CMateFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	// CMainFramer[TB
	CMDIFrameWnd *pMDIFrame=(CMDIFrameWnd *)AfxGetMainWnd();
	ASSERT(pMDIFrame->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	CMDIChildWnd *pChild=pMDIFrame->MDIGetActive();
	CView *pSDJView=pChild->GetActiveView();

	// EBhE̕\ʒu
	CRect rect;
	pSDJView->GetClientRect(&rect);
	// E
	rect.left	= rect.right -128;
	rect.bottom	= rect.top	 +180;

	cs.hwndParent = pSDJView->m_hWnd; // eEBhE(SDJView)
	cs.x=rect.left;
	cs.y=rect.top;
	cs.cx=rect.Width();
	cs.cy=rect.Height();
	cs.style &=~WS_POPUP;
	cs.style |= (WS_CHILD | WS_CLIPSIBLINGS);

	return CFrameWnd::PreCreateWindow(cs);
}

// [_[vI`FbN
// RunMOdalLoop()I`FbNׂɌĂ΂B
// TRUEContinue,FALSEŃ[vI
BOOL CMateFrame::ContinueModal()
{
	CMateView *pView=(CMateView*)GetActiveView();
	if (pView->IsJobWorking())
		return TRUE;  // vl
	else
		return FALSE; // vlI
}

BOOL CMateFrame::DestroyWindow() 
{
	CMateView *pView=(CMateView*)GetActiveView();
	// vlȂ悸𒆒fB
	if (pView->IsJobWorking()) {
		pView->GetStopEvent()->SetEvent(); // fCxg̃Zbg
		// [_[vŎvlXbh𓮂ȂA
		// Î҂BI`FbN͉ContinueModal()B
		// ̊ԂɎ󂯂bZ[Ŵ͖ŗvӁB
		RunModalLoop(MLF_NOIDLEMSG);
	}
	CWnd *pNotifyWnd=pView->GetNotifyWnd();
	if (pNotifyWnd) {
		// er[֕\̏Iʒm
		pNotifyWnd->SendMessage(WM_COMMAND,ID_ON_CLOSE_MATE_FRAME);
	}

	return CFrameWnd::DestroyWindow();
}

// VXej[R}h(ő\ResoreɕύX)
void CMateFrame::OnSysCommand(UINT nID, LPARAM lParam)
{
	nID &= 0xfff0; // }XN
	switch (nID) {
	case SC_CLOSE: // Ij[
		OnScClose(); // ftHgOnClose()Ă΂̂ŕύXB
		break;
	default:
		CFrameWnd::OnSysCommand(nID,lParam);
	}
}

// SYSj[(~)AɂI
void CMateFrame::OnScClose()
{
	CMateView *pMateView=(CMateView*)GetActiveView();
	CWnd *pNotifyWnd=pMateView->GetNotifyWnd();
	// elca̎vl(CDlgMateDbc)̎͐e߂WM_CLOSEႤ
	if (!pNotifyWnd->IsKindOf(RUNTIME_CLASS(CWinSDJTSView))) {
		// TSViewłȂ΋lca̎vlBƋꂵ肾A
		// RUNTIME_CLASSCDlgMateDbcɂ͎gȂB
		pNotifyWnd->PostMessage(WM_CLOSE);
	}
	else {
		// eTSView̏ꍇOnClose()ďoĎŏIB
		DestroyWindow();
	}
}
