/**************************/
/*    SDJCmntFrame.cpp    */
/**************************/
#include "stdafx.h"
#include "winsdj.h"
#include "SDJCmntFrame.h"
#include "mainfrm.h"
#include "sdjview.h"
#include "kbase.h"
#include "sdjcmntdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSDJCmntFrame

IMPLEMENT_DYNCREATE(CSDJCmntFrame, CSDJEditFrame)

CSDJCmntFrame::CSDJCmntFrame()
{
}

CSDJCmntFrame::~CSDJCmntFrame()
{
}

BEGIN_MESSAGE_MAP(CSDJCmntFrame, CSDJEditFrame)
	//{{AFX_MSG_MAP(CSDJCmntFrame)
	ON_WM_MOVE()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CSDJCmntFrame bZ[W nh

BOOL CSDJCmntFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	// CMainFramer[TB
	CMDIFrameWnd *pMDIFrame=(CMDIFrameWnd *)AfxGetMainWnd();
	ASSERT(pMDIFrame->IsKindOf(RUNTIME_CLASS(CMainFrame)));
	CMDIChildWnd *pMDIChild=pMDIFrame->MDIGetActive();
	if (pMDIChild) { 
		// ړĨANeBuȃr[
		CSDJView *pSDJView=(CSDJView *)pMDIChild->GetActiveView();
		ASSERT(pSDJView->IsKindOf(RUNTIME_CLASS(CSDJView)));
		CRect *prcCmntBoxPos=pSDJView->GetCmntBoxPos();
		// _CAOJnʒuȑO̐ݒ肪΂
		CRect rect;
		if (!prcCmntBoxPos->IsRectEmpty()) {
			rect.CopyRect(prcCmntBoxPos);
		}
		else {
			pMDIChild->GetClientRect(&rect);	// r[̃NCAg̈
			int mx=rect.Width()/2;				// S
			int my=rect.Height()/2;
			// Ց̑傫(180*600)
			rect.right	= mx+300;
			rect.left	= mx-300;
			rect.top	= my-90;
			rect.bottom = my+90;
			// Wϊ
			pMDIChild->ClientToScreen(&rect);
		}

		cs.x=rect.left;
		cs.y=rect.top;
		cs.cx=rect.Width();
		cs.cy=rect.Height();

		cs.hwndParent = pMDIFrame->m_hWnd; // eEBhE(C)
		cs.style &=~WS_CHILD;			   // POPUPEBhE
		cs.style |= WS_POPUP;
	}
	
	return CFrameWnd::PreCreateWindow(cs); // CSDJEditFrame͌Ă΂Ȃ
}

////
// EBhE
void CSDJCmntFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y); // CSDJEditFrame͌Ă΂Ȃ

	// r[NULL̏HƃACRAőTCYԂ
	// EBhËʒuLB
	CView *pView=GetActiveView();
	if (pView && !IsIconic() && !IsZoomed()) {
		CSDJCmntDoc *pSDJCmntDoc=(CSDJCmntDoc*)GetActiveDocument();
		CKBase *pKBase=pSDJCmntDoc->GetKBase();
		CSDJView *pSDJView=pKBase->GetView();
		CRect *pRect=pSDJView->GetCmntBoxPos();
		GetWindowRect(pRect);
	}
}

//////
// EBhẼTCYς
void CSDJCmntFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy); // CSDJEditFrame͌Ă΂Ȃ
	
	// r[NULL̏HƃACRAőTCYԂ
	// EBhËʒuLB
	CView *pView=GetActiveView();
	if (pView && !IsIconic() && !IsZoomed()) {
		CSDJCmntDoc *pSDJCmntDoc=(CSDJCmntDoc*)GetActiveDocument();
		CKBase *pKBase=pSDJCmntDoc->GetKBase();
		CSDJView *pSDJView=pKBase->GetView();
		CRect *pRect=pSDJView->GetCmntBoxPos();
		GetWindowRect(pRect);
	}
}

int CSDJCmntFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_SDJEDITFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.SetWindowText("W");
	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	
	// init@C`FbN
	CString strSection=EDITOR_SECTION;
	BOOL bVisible;
	// Xe[^Xo[
	bVisible=theApp.GetProfileInt(strSection,VISIBLE_CEDITOR_STATUS_BAR,1);
	if (!bVisible) {
		ShowControlBar(&m_wndStatusBar,FALSE,FALSE);
	}
	// c[o[
	bVisible=theApp.GetProfileInt(strSection,VISIBLE_CEDITOR_TOOL_BAR,1);
	if (!bVisible) {
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
	}

	return 0;
}

void CSDJCmntFrame::OnDestroy() 
{
	// init@Cւ̃Z[u
	CString strSection=EDITOR_SECTION;

	BOOL bVisible;
	// Xe[^Xo[̋L
	bVisible=(m_wndStatusBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	theApp.WriteProfileInt(strSection,VISIBLE_CEDITOR_STATUS_BAR,bVisible);
	// c[o[̋L
	bVisible=(m_wndToolBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	theApp.WriteProfileInt(strSection,VISIBLE_CEDITOR_TOOL_BAR,bVisible);

	CFrameWnd::OnDestroy();
}
