/***************************/
/*    SDJJCmntFrame.cpp    */
/***************************/
#include "stdafx.h"
#include "winsdj.h"
#include "SDJJCmntFrame.h"
#include "dbeframe.h"
#include "dbeview.h"
#include "ssdjdoctemplate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSDJJCmntFrame

IMPLEMENT_DYNCREATE(CSDJJCmntFrame, CSDJEditFrame)

CSDJJCmntFrame::CSDJJCmntFrame()
{
}

CSDJJCmntFrame::~CSDJJCmntFrame()
{
}

BEGIN_MESSAGE_MAP(CSDJJCmntFrame, CSDJEditFrame)
	//{{AFX_MSG_MAP(CSDJJCmntFrame)
	ON_WM_MOVE()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CSDJJCmntFrame bZ[W nh

BOOL CSDJJCmntFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	// DbeFrame̎擾
	ASSERT(theApp.m_bDbeUsing);
	CDbeFrame *pDbeFrame=(CDbeFrame*)theApp.m_pDbeDocTemplate->GetFrameWnd();
	CDbeView *pDbeView=(CDbeView*)pDbeFrame->GetActiveView();
	ASSERT(pDbeView->IsKindOf(RUNTIME_CLASS(CDbeView)));
	CRect *prcJCmntBoxPos=pDbeView->GetJCmntBoxPos();

	// _CAOJnʒuȑO̐ݒ肪΂
	CRect rect;
	if (!prcJCmntBoxPos->IsRectEmpty()) {
		rect.CopyRect(prcJCmntBoxPos);
	}
	else {
		pDbeView->GetClientRect(&rect); // r[̃NCAg̈
		// Wϊ
		pDbeView->ClientToScreen(&rect);
		// Ց̑傫(180*600)
		rect.right	= rect.left+600;
		rect.bottom = rect.top+180;
	}

	cs.x=rect.left;
	cs.y=rect.top;
	cs.cx=rect.Width();
	cs.cy=rect.Height();

	cs.hwndParent = pDbeFrame->m_hWnd; // eEBhE(Ց)
	cs.style &=~WS_CHILD;			   // POPUPEBhE
	cs.style |= WS_POPUP;
	
	return CFrameWnd::PreCreateWindow(cs); // CSDJEditFrame͌Ă΂Ȃ
}

void CSDJJCmntFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y); // CSDJEditFrame͌Ă΂Ȃ

	// r[NULL̏HƃACRAőTCYԂ
	// EBhËʒuLB
	CView *pSDJJCmntView=GetActiveView();
	if (pSDJJCmntView && !IsIconic() && !IsZoomed()) {
		CDbeFrame *pDbeFrame=(CDbeFrame*)GetParentFrame();
		ASSERT(pDbeFrame->IsKindOf(RUNTIME_CLASS(CDbeFrame)));
		CDbeView *pDbeView=(CDbeView*)pDbeFrame->GetActiveView();
		CRect *pRect=pDbeView->GetJCmntBoxPos();
		GetWindowRect(pRect);
	}
}

void CSDJJCmntFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy); // CSDJEditFrame͌Ă΂Ȃ

	// r[NULL̏HƃACRAőTCYԂ
	// EBhËʒuLB
	CView *pSDJJCmntView=GetActiveView();
	if (pSDJJCmntView && !IsIconic() && !IsZoomed()) {
		CDbeFrame *pDbeFrame=(CDbeFrame*)GetParentFrame();
		ASSERT(pDbeFrame->IsKindOf(RUNTIME_CLASS(CDbeFrame)));
		CDbeView *pDbeView=(CDbeView*)pDbeFrame->GetActiveView();
		CRect *pRect=pDbeView->GetJCmntBoxPos();
		GetWindowRect(pRect);
	}
}

int CSDJJCmntFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_SDJEDITFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.SetWindowText("W");
	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	
	// init@C`FbN
	CString strSection=EDITOR_SECTION;
	BOOL bVisible;
	// Xe[^Xo[
	bVisible=theApp.GetProfileInt(strSection,VISIBLE_JEDITOR_STATUS_BAR,1);
	if (!bVisible) {
		ShowControlBar(&m_wndStatusBar,FALSE,FALSE);
	}
	// c[o[
	bVisible=theApp.GetProfileInt(strSection,VISIBLE_JEDITOR_TOOL_BAR,1);
	if (!bVisible) {
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
	}

	return 0;
}

void CSDJJCmntFrame::OnDestroy() 
{
	// init@Cւ̃Z[u
	CString strSection=EDITOR_SECTION;

	BOOL bVisible;
	// Xe[^Xo[̋L
	bVisible=(m_wndStatusBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	theApp.WriteProfileInt(strSection,VISIBLE_JEDITOR_STATUS_BAR,bVisible);
	// c[o[̋L
	bVisible=(m_wndToolBar.GetStyle() & WS_VISIBLE)? TRUE:FALSE;
	theApp.WriteProfileInt(strSection,VISIBLE_JEDITOR_TOOL_BAR,bVisible);

	CFrameWnd::OnDestroy();
}
