/************************/
/*    SelectBoxC.cpp    */
/************************/
#include "stdafx.h"
#include "winsdj.h"
#include "SelectBoxC.h"
#include <mbstring.h>
#include "winsdjtsview.h"
#include "winsdjtsdoc.h"
#include "sframewnd.h"
#include "ssdjdoctemplate.h"
#include <winmemfile.h>
#include "dbeframe.h"
#include "dbeview.h"
#include "childfrm.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;
extern HANDLE g_hDblock;

/////////////////////////////////////////////////////////////////////////////
// CSelectBoxC _CAO

IMPLEMENT_SERIAL(CSelectBoxC, CSelectBoxB,0)

// RXgN^
CSelectBoxC::CSelectBoxC()
{
	//{{AFX_DATA_INIT(CSelectBoxC)

	//}}AFX_DATA_INIT
}

void CSelectBoxC::DoDataExchange(CDataExchange* pDX)
{
	CSelectBoxB::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectBoxC)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectBoxC, CSelectBoxB)
	//{{AFX_MSG_MAP(CSelectBoxC)
	ON_BN_CLICKED(IDC_SELWRT, OnSelwrt)
	ON_BN_CLICKED(IDC_SELRED, OnSelred)
	ON_BN_CLICKED(IDC_SEARCH, OnSearch)	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////
//  \bh

// DBCʂ\Xg(m_SelectList)ɔf
void CSelectBoxC::set_SelectList(void)
{
	CDBC Dbc; // lca
	char dispbuf[512];
	CList <DBRNO, DBRNO&> DbrnoList; // DBCʍƃXg
	POSITION pos;
	DBRNO Dbrno;
	CWaitCursor waitcr;  // v

	m_SelectList.ResetContent(); // SelectListɂB
	// INFINITEő҂B
	// 猏̌ʂǂݍł鎞DbLockModal()WM_CLOSE
	// 󂯂MFCASSERTĂ܂B(InitDialogłModalLoop͑ʖ)
	WaitForSingleObject(g_hDblock,INFINITE); // DB lock

	if (Dbc.Open()) { // lcãI[v
		Dbc.DBFOpen(); // ߂caI[vB
		pos=m_DbrFindList.GetHeadPosition();
		while (pos) {
			Dbrno=m_DbrFindList.GetNext(pos);
			// DBRNOɊYlR[hǂށB
			int rc=Dbc.ReadByDbrno(Dbrno.dbrno);
			if (rc==E$OK) { // ɓǂ߂
				Dbc.set_disp_mrec(dispbuf); // \̐
				m_SelectList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DbrnoList.AddTail(Dbrno); // ƃXgɒǉ
			}
		}
		Dbc.DBFClose(); // ߂cãN[Y
		Dbc.Close(); // lcãN[Y
		// Xg{bNX̃J[\ݒ
		if (m_SelectList.GetCount()) {
			m_SelectList.SetCurSel(m_iSelNo);  // 擪ɐݒ
		}
	}
	ReleaseMutex(g_hDblock); // DB unlock

	// DbrnoList̓em_DbrFindList֔fB
	m_DbrFindList.RemoveAll(); // XgɂB
	pos=DbrnoList.GetHeadPosition();
	while (pos) {
		// DbrnoListm_DbrFindListփRs[
		Dbrno=DbrnoList.GetNext(pos);
		m_DbrFindList.AddTail(Dbrno); 
	}
	DbrnoList.RemoveAll(); // DbrnoList

	UpdateItemNum();			// ڐ\XV
	GotoDlgCtrl(&m_SelectList); // 
}

/////
// O񌟍̓ǂݏo
//   ߂l:I[v
BOOL CSelectBoxC::ReadPrevInfo(void)
{
	CFile file;
	BOOL success=FALSE;

	char *shgdb=GetShgdbName(); // f[^x[X
	m_strFindFile.Format("%s%s",shgdb,SDJFIND_FILE2);
	if (file.Open(m_strFindFile,CFile::modeRead)) {
		CSDJArchive ar(&file,CArchive::load);
		Serialize(ar);
		ar.Close();
		file.Close();
		success=TRUE;
	}
	return success;
}

///////
// O񌟍Ƃĕۑ
void CSelectBoxC::WritePrevInfo()
{
	char *shgdb=GetShgdbName(); // f[^x[X
	m_strFindFile.Format("%s%s",shgdb,SDJFIND_FILE2);
	CFile file;
	// t@C̃I[v
	if (file.Open(m_strFindFile,CFile::modeReadWrite|CFile::modeCreate)) {
		CSDJArchive ar(&file,CArchive::store);
		Serialize(ar); // VA
		ar.Close();
		file.Close();
	}
}

///
// Rg[ɐݒ肷B
void CSelectBoxC::SetEdSqlText()
{
	// ̃ftHg
	if (m_strSqlText.IsEmpty()) {
		m_strSqlText.Format("%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n",
			"#",
			"#擪'#'̓Rg",
			"#\ matches \"ߑ㏫\" and ",
			"#l萔 = \"5\" and ",
			"#order by o^ desc");
	}
	m_edSqlText.SetWindowText(m_strSqlText); // EditBOXɒl𔽉f
}

/////////////////////////////////////////////////////////////////////////////
// CSelectBoxC bZ[W nh

// lI
void CSelectBoxC::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	
	int idx=m_SelectList.GetCurSel(); // ݑIĂ镶̃CfbNXl
	if (idx==LB_ERR)
		return ; // IꂽR[hȂΉɏI

	// Iꂽl̔ԍʃXg狁߂B
	DBRNO Dbrno;
	POSITION pos=m_DbrFindList.GetHeadPosition();
	for (int i=0;i<=idx;i++) Dbrno=m_DbrFindList.GetNext(pos);

	// lԍ̃R[hhLgɓǍ
	CWinSDJTSDoc *pDoc=GetSDJDocument();
	if (pDoc->SaveModified()) { // Modified`FbNۑ
		CWaitCursor wait; // v
		CWinSDJTSView *pView=(CWinSDJTSView *)pDoc->GetSDJView();

		// ߃{bNXJĂ
		pView->SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);
 
		CWaitCursor wcur; // v
		// ŃhLgƃ}YĈŃ[_[v͎gȂ
		WaitForSingleObject(g_hDblock,INFINITE); // Dblock
		pDoc->ReadDbcInfo(Dbrno); // lDB烌R[hǂݍ
		ReleaseMutex(g_hDblock);  // DB unlock

		pDoc->SetModifiedFlag(FALSE);

		if (pView->GetGuideFrame()!=NULL) // ǖʕ\JĂ
			pView->GetGuideFrame()->Invalidate();
		if (pView->GetSubFrame()!=NULL) // TuEBhEJĂ
			pView->GetSubFrame()->Invalidate();
		pView->Invalidate(); // \XV

		m_iSelNo=idx;	 // ǂݏoꂽIԍ
		WritePrevInfo(); // Ƃ̋L

		// ՑJĂeXV
		if (theApp.m_bDbeUsing) {
			CDbeFrame *pDbeFrame=pView->GetDbeFrame();
			if (pDbeFrame) { // ̃r[ՑJĂ
				CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
				pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
			}
		}

		// JĂe
		CKifFrame *pKifFrame=pView->GetKifFrame();
		if (pKifFrame!=NULL) {
			pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
		}
	}


	// [hX_CAO{bNX̏ꍇEndDialog()(CDialog::OnOK())
	// Ă΂ȂŒDestroyWindow()ĂԁB
	DestroyWindow();
}

// ۑ
void CSelectBoxC::OnSelwrt() 
{
	if (UpdateData(TRUE)) { // ̓f[^̎荞(]OK)
		CFileDialog fileDialog(FALSE, // 
			"dj2",			// ftHg̊gq
			m_strFindFile,	// ftHg̃t@C
			// ǂݏopt@C͑ΏۊOA㏑mFL
			(DWORD)(OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT),
			" (*.dj2)|*.dj2||"); // tB^[

		BOOL bRet=fileDialog.DoModal(); // Dialog̎s
		if (bRet==IDOK) {				// IDOKȂA
			m_strFindFile=fileDialog.GetPathName(); // t@C̎擾
			CFile file;
			// t@C̃I[v
			if (file.Open(m_strFindFile,CFile::modeReadWrite|CFile::modeCreate)) {
				m_edSqlText.GetWindowText(m_strSqlText); // o
				CSDJArchive ar(&file,CArchive::store);
				Serialize(ar); // VA
				ar.Close();
				file.Close();
			}
		}
	}
}

// ǂݏo
void CSelectBoxC::OnSelred() 
{
	CFileDialog fileDialog(TRUE, // ǂݏo
		"dj2",			// ftHg̊gq
		m_strFindFile,	// ftHg̃t@C
		// ǂݏopt@C͑ΏۊOA㏑mFL
		(DWORD)(OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT),
		" (*.dj2)|*.dj2||"); // tB^[

	BOOL bRet=fileDialog.DoModal(); // Dialog̎s
	if (bRet==IDOK) {				// IDOKȂA
		m_strFindFile=fileDialog.GetPathName(); // t@C̎擾
		CFile file;
		// t@C̃I[v
		if (file.Open(m_strFindFile,CFile::modeRead)) {
			CSDJArchive ar(&file,CArchive::load);
			Serialize(ar); // VA
			ar.Close();
			file.Close();
			UpdateData(FALSE); // ǂݏolDialogɔf
			SetEdSqlText();  // EditBoxɂf
			set_SelectList(); // ǂݏoʂR[h̕\XgɔfB

			// ǂݏoO񌟍Ƃĕۑ
			WritePrevInfo();
		}
	}
}

// sXbh֐
static UINT DbcFindThread(LPVOID pParam)
{
	CSelectBoxC  *pBoxC=(CSelectBoxC *)pParam;
	CDBC Dbc;

	Dbc.SetQuitObject((HANDLE)pBoxC->m_QuitEvent); // fCxg̐ݒ

	int counter=0; // \XVJE^
	char dispbuf[512];
	char *strSql=(char *)(LPCTSTR)pBoxC->m_strSqlText;
	// ̓CDoModal()ő҂Ă̂WM_CLOSE̓ubNB
	// ă[_[vő҂B
	if (DbLockModal()) { // Db lock
		int found=Dbc.FindFirst(strSql,&pBoxC->m_kyinfo); // ŏ̃R[h{
		// R[hȂȂ邩ACxg(m_QuitEvent)܂Ń[vB
		while (found>=0) {
			if (found) {
				Dbc.set_disp_mrec(dispbuf); // \̐
				pBoxC->m_SelectList.InsertString(-1,dispbuf); // ɃXg{bNXɓ
				DBRNO Dbrno=Dbc.GetDbrno(); // DBRNO̎擾
				pBoxC->m_DbrFindList.AddTail(Dbrno); // Xg֕ۑ
				// ڐ\XV (Xbh璼ڊ֐ĂԂƃfobO
				// [hASSERTƂȂ̂łނȂbZ[Wgp)
				if ((++counter % 10)==0) // 101\(͒x)B
					pBoxC->PostMessage(WM_COMMAND,ID_SELBOX_UPDATENUM);
			}
			found=Dbc.FindNext(&pBoxC->m_kyinfo); // ̃R[h{
		}
		Dbc.FindExit(&pBoxC->m_kyinfo); // I
		pBoxC->SetSelNo(0);             // IʒũZbg
		pBoxC->WritePrevInfo();			// ʂ"O񌟍"Ƃĕۑ
		ReleaseMutex(g_hDblock);		// Db unlock
	}
	pBoxC->PostMessage(WM_COMMAND,ID_SELBOX_UPDATENUM); // \

	pBoxC->m_FindStop.PostMessage(WM_CLOSE); // f_CAO{bNX̏
	return 0;
}

// s
void CSelectBoxC::OnSearch() 
{
	if (!UpdateData(TRUE))
		return ;

	set_kyinfo(); // KYINFOɐݒ肷
	m_edSqlText.GetWindowText(m_strSqlText); // o

	m_SelectList.ResetContent(); // Xg{bNXɂB
	m_DbrFindList.RemoveAll();   // DBʂɂB
	UpdateItemNum();			// ڐ\XV

	// ɂ͏fBNgChange DirectoryB
	char szCurrDir[MAX_PATH];
	GetCurrentDirectory(sizeof szCurrDir,szCurrDir); // JgDir̎擾
	char *shgdb=GetShgdbName();
	if (SetCurrentDirectory(shgdb)==FALSE) {
		CString strMes;
		strMes.Format("f[^x[X(%s)Ił܂B",shgdb);
		AfxMessageBox(strMes);
		return;
	}

	CSDJView *pView=GetSDJDocument()->GetSDJView();
	CChildFrame *pChildFrame=(CChildFrame *)pView->GetParentFrame();
	ASSERT(pChildFrame->IsKindOf(RUNTIME_CLASS(CChildFrame)));
	pChildFrame->SetCloseLock(TRUE); // et[N[YbN
	m_QuitEvent.ResetEvent();   // fCxg̃Zbg
	// Jn(D揇ʂ͂Pi)
	CWinThread *pFindThread=AfxBeginThread(DbcFindThread,this,
		THREAD_PRIORITY_BELOW_NORMAL);
	m_FindStop.DoModal(); // f_CAO{bNX
	pChildFrame->SetCloseLock(FALSE); // et[̃bN

	// Xg{bNX̃J[\ݒ
	if (m_SelectList.GetCount()) {
		m_SelectList.SetCurSel(m_iSelNo); // 擪ɐݒ
	}
	GotoDlgCtrl(&m_SelectList); // 

	// fBNgɖ߂B
	SetCurrentDirectory(szCurrDir); 
}
