// StatusBox.h : wb_[ t@C
//
#ifndef __STATUSBOX__
#define __STATUSBOX__
#include <afxmt.h>

/////////////////////////////////////////////////////////////////////////////
// CStatusBox _CAO
class CStatusBox : public CDialog
{
// RXgNV
public:
	void DisableStatusStop(void);
	void EnableStatusStop(void);
	void PrintMessage(LPTSTR pMessage);
	CStatusBox(CWnd* pParent = NULL);   // W̃RXgN^
	CStatusBox(UINT (*pWorkerThread)(CStatusBox *,CEvent*,LPARAM),
		LPARAM lParam=0L,CWnd* pParent = NULL);
	CEvent *GetStopEvent(){return &m_StopEvent;};
	LPARAM GetThreadParam(){return m_lThreadParam;};
	void SetWorkerThread(UINT (*pThread)(CStatusBox *,CEvent*,LPARAM)){m_pWorkerThread=pThread;};

// _CAO f[^
	//{{AFX_DATA(CStatusBox)
	enum { IDD = IDD_STATUSBOX };
	CListBox	m_StatusList;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CStatusBox)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Cve[V
protected:
	int m_lfWidth; // Xg{bNX̃tHg
	int m_Width;       // Xg{bNX̕
	LPARAM m_lThreadParam;
	UINT (*m_pWorkerThread)(CStatusBox *,CEvent*,LPARAM lParam);
	CEvent m_StopEvent;
	BOOL  m_bJobWorking;
private:
	void common_init(void);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CStatusBox)
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	afx_msg void OnJobStop();
	//}}AFX_MSG
friend UINT StatusBoxWorkerThread(LPVOID);
	DECLARE_MESSAGE_MAP()
};
#endif // __STATUSBOX_
