/*********************/
/*    SubView.cpp    */
/*********************/
#include "stdafx.h"
#include "WinSDJ.h"
#include "SubView.h"
#include "kbase.h"
#include "winsdjdoc.h"
#include "winsdjtsdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSubView

IMPLEMENT_DYNCREATE(CSubView, CScrollView)

CSubView::CSubView()
{
}

CSubView::~CSubView()
{
}

BEGIN_MESSAGE_MAP(CSubView, CScrollView)
	//{{AFX_MSG_MAP(CSubView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSubView `

void CSubView::OnDraw(CDC* pDC)
{
	// obNOEhJ[
	CRect rc;
	GetClientRect(&rc);
    pDC->DPtoLP(&rc);
	pDC->FillSolidRect(&rc,WINBKCLR);

	// tHg̏
	CFont *pfCurr=pDC->GetCurrentFont();			// s̃tHg
	LOGFONT lfFont;
	pfCurr->GetObject(sizeof(LOGFONT),&lfFont);		// s̃tHg
	lfFont.lfHeight=14;								// tHg̐ݒ
	lfFont.lfWidth=0;								// tHg͎ݒ
	strcpy(lfFont.lfFaceName,"lr ");			// MS
	CFont fNewFont;
	fNewFont.CreateFontIndirect(&lfFont);			// `tHg̍쐬

	// tHg̑I
	CFont *pOldFont=pDC->SelectObject(&fNewFont);	// tHgI
	pDC->SetTextColor(WINMJCLR);					// ꑋF
	pDC->SetBkMode(TRANSPARENT);					// obN͓߂ɐݒ

	int mjnum=0;									// \(̌)
	CSDJDoc* pDoc0 = (CSDJDoc *)GetDocument();
	// ΋Ǌ̏ꍇ
	if (pDoc0->IsKindOf(RUNTIME_CLASS(CWinSDJDoc))) {
		CWinSDJDoc *pDoc=(CWinSDJDoc *)pDoc0;
	
		BDSP *pBdsp=pDoc->m_Dbb.GetMdsp();			// \obt@
		CString str;								// obt@(default 128)
		CPoint loc(1,1);							// `ʒu

		// ̕\
		str.Format(": %s",pBdsp->splayer);
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+4);			// ̕`ʒu
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// ̕\
		str.Format(": %s",pBdsp->gplayer);
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+4);			// ̕`ʒu
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// ΋Ǔ
		str.Format("΋Ǔ: %s",pBdsp->playdate);
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+4);			// ̕`ʒu
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// 햼
		str.Format("햼:");
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+1);			// ̕`ʒu
		str.Format(" %s",pBdsp->kisen);
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+4);			// ̕`ʒu
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ	

		// ^
		str.Format("^:");
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+1);			// ̕`ʒu
		str.Format(" %s", pBdsp->senkei);
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+4);			// ̕`ʒu
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// ΋ǔԍ
		str.Format("΋ǔԍ: %s",pBdsp->b_recno);
		pDC->TextOut(loc.x,loc.y,str);				// ̕\
		loc.Offset(0,lfFont.lfHeight+1);			// ̕`ʒu
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ
	} // ΋Ǌ̏ꍇ

	// l̏ꍇ
	if (pDoc0->IsKindOf(RUNTIME_CLASS(CWinSDJTSDoc))) {
		CWinSDJTSDoc *pDoc=(CWinSDJTSDoc *)pDoc0;

		CDSP *pCdsp=pDoc->m_Dbc.GetMdsp();			// \obt@
		CString str;								// obt@(default 128)
		CPoint loc(1,1);							// `ʒu

		// \̕\
		str.Format("\:");
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+1);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ
		str.Format(" %s",pCdsp->title);
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+4);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// ҂̕\
		str.Format(": %s",pCdsp->author);
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+4);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// Փx
		str.Format("Փx:");
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+1);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ
		str.Format(" %s",pCdsp->level);
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+4);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// qg
		str.Format("qg:");
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+1);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ
		str.Format(" %s",pCdsp->hint);
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+4);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// o}
		str.Format("o}: %s",pCdsp->hash_s);
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+1);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

		// lԍ
		str.Format("lԍ: %s",pCdsp->c_recno);
		pDC->TextOut(loc.x,loc.y,str);				// \
		loc.Offset(0,lfFont.lfHeight+1);			// s
		if (str.GetLength() > mjnum)
			mjnum=str.GetLength();					// vZ

	} // l̏ꍇ

	// \̌vZ(͕̔ƂĎ蔲vZ)
	GetClientRect(&rc);
	if (mjnum*(lfFont.lfHeight/2) > rc.right) {
		CSize sizeTotal(mjnum*(lfFont.lfHeight/2)+1,rc.bottom);
		SetScrollSizes(MM_TEXT,sizeTotal);
	}
	else {
		CSize sizeTotal(rc.right,rc.bottom);
		SetScrollSizes(MM_TEXT,sizeTotal);
	}

	// tHgɖ߂
	pDC->SelectObject(pOldFont);
}

/////////////////////////////////////////////////////////////////////////////
// CSubView ff

#ifdef _DEBUG
void CSubView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CSubView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSubView bZ[W nh

void CSubView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	
	CRect rc;
	GetClientRect(&rc);
	CSize sizeTotal(rc.right,rc.bottom);
	SetScrollSizes(MM_TEXT,sizeTotal);
}
