/***********************/
/*    WinSDJDoc.cpp    */
/***********************/
#include "stdafx.h"
#include "winsdj.h"
#include "sdjview.h"
#include "winsdjview.h"
#include "winsdjdoc.h"
#include <winmemfile.h>
#include "jbase.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)
#pragma warning(disable:4244)

// O[o
extern CWinSDJApp theApp;

extern "C" {
	void *memalloc(unsigned int);
	void memfree(void *);
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJDoc

IMPLEMENT_DYNCREATE(CWinSDJDoc, CSDJDoc)

BEGIN_MESSAGE_MAP(CWinSDJDoc, CSDJDoc)
	//{{AFX_MSG_MAP(CWinSDJDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSDJDoc NX̍\z/

CWinSDJDoc::CWinSDJDoc()
{
	// TODO: ̈ʒuɂP񂾂\zp̃R[hǉĂB
}

CWinSDJDoc::~CWinSDJDoc()
{
}


BOOL CWinSDJDoc::OnNewDocument()
{

	// DeleteContentsĂ΂AՁE()񂪃NA
	if (!CSDJDoc::OnNewDocument())
		return FALSE;
	
	// (SDI hLg͂̃hLgėp܂B)
	m_KBase.setup(0); // zu(𕽎zuAՏ񂪃Zbg)
	m_KBase.setturn(SIDE_A); // 

	// ̕\
	CSDJView *pSDJView=GetSDJView();
	if (theApp.m_bKifWindowEnable)
		pSDJView->SendMessage(WM_COMMAND,ID_KIF_WINDOW_OPEN);

	return TRUE;
}

BOOL CWinSDJDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CSDJDoc::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// ̕\
	CSDJView *pSDJView=GetSDJView();
	if (theApp.m_bKifWindowEnable)
		pSDJView->SendMessage(WM_COMMAND,ID_KIF_WINDOW_OPEN);
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJDoc VAC[[V

void CWinSDJDoc::Serialize(CArchive& ar)
{
	Serialize((CSDJArchive &)ar,FALSE);
}
// bLine: TRUE/FALSE(Default)  {菇̂ݏo/wԑSĂo
void CWinSDJDoc::Serialize(CSDJArchive& ar,BOOL bLine)
{
	int za=m_KBase.GetZa(); // ݂̍

	if (ar.IsStoring()) { // o͏
		SetMrecTesu();    // ΋ǌo̎萔ݒ肷
		WriteToCsa(ar);   // ΋ǌoCSA`ŏo
	}
	else { // ͏
		ReadFromCsa(ar);  // CSA`΋ǌo
	}

	// KBase ̃VACY(̓o)
	CSDJDoc::Serialize(ar,bLine);

	if (!ar.IsStoring()) { // ͂̏ꍇ
		SetMrecTesu();     // ΋ǌo̎萔ݒ肷
	}

	if (za!=m_KBase.GetZa()) { // ύXɂȂ
		// Ղ̔wiĐݒ
		SetBackground(&theApp.m_BackDIB[m_KBase.GetZa()]);
	}
}

/////
// CSAt@Cւ̏o
int CWinSDJDoc::WriteToCsa(CSDJArchive &ar)
{
	int rc=1;
	// ar`FbN
	ASSERT(ar.IsStoring());

	int za=m_KBase.GetZa();
	if ((rc=m_Dbb.OutMrec2CsaHeader1(ar,za))!=0) goto exit; // wb_[
	if ((rc=m_Dbb.OutMrec2CsaHeader2(ar))!=0) goto exit; // RgL[[h
	if ((rc=m_Dbb.OutMrec2CsaHeader3(ar))!=0) goto exit; // ΋ǒ
	if ((rc=m_Dbb.OutMrec2CsaHeader4(ar))!=0) goto exit; // ΋ǎ
	rc=0;
exit:
	return rc;
}

/////
// CSAt@C̓
int CWinSDJDoc::ReadFromCsa(CSDJArchive &ar)
{
    int rc=1;
    char *line;
	char StringBuffer[512];
	CKmListBox *pListBox=m_KBase.GetListBox();
	int i;
	
	if ((rc=m_Dbb.InCsa2MrecInit(ar))!=0) goto exit; // Ǎݏ̏

	// lɐݒ肷B
	if (m_KBase.GetZa()!=SIDE_A) { // ύXɂȂ
		m_KBase.SetZa(SIDE_A);
		for (i=0;i<3;i++)
			pListBox[i].ZaRotation(); // _̔]
	}

	// ȉ̃[vCSA`ǂݍb_recZbg(΋ǎ҂܂)B
	while (!m_Dbb.InCsa2MrecIsEnd()) { // I`FbN
		// ͍s̓Ǐo
		if ((line=m_Dbb.get_line(ar))==NULL)
			break;          /* eof */
		// CSARgsȂ
		if (line[0]=='\'') {
		/* "'"ȉRgsL[[hƈv邩ۂׁAv
		   YB_RECtB[h̍ڂɂ̒lZbgB
		 */
			if (m_Dbb.mrec_comment_set(line)!=0) goto exit;

			// ̃`FbN
			if (strcmp(line,"'")==0) {
				// ̐ݒ(ꂪ肽̂ł킴킴̏
				// CDBBzĂB
				if (m_KBase.GetZa()!=SIDE_B) { // ύXɂȂ
					m_KBase.SetZa(SIDE_B);
					for (i=0;i<3;i++)
						pListBox[i].ZaRotation(); // _̔]
				}
			}
		}
		// ΋ǎҎwȂ
		else if (line[0]=='N') {
			/* ΋ǎ҂̃Zbg */
			if (m_Dbb.brec_player(line)!=0) goto exit;
		} 
		else {
			sprintf(StringBuffer,"@G[łB(%s)",line);
			if (line[0]=='P')
				strcat(StringBuffer,"\r\n΋ǎҎw(N+N-)͏ȗł܂B");
			AfxMessageBox(StringBuffer);
			goto exit;
		}
	}

    rc=0;
  exit:
	m_Dbb.InCsa2MrecEnd(); // CSAǍݏI
    return rc;
}


/////////////////////////////////////////////////////////////////////////////
// CWinSDJDoc NX̐ff

#ifdef _DEBUG
void CWinSDJDoc::AssertValid() const
{
	CSDJDoc::AssertValid();
}

void CWinSDJDoc::Dump(CDumpContext& dc) const
{
	CSDJDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinSDJDoc R}h

/////
// ΋(Dbrno) ΋ǔԍ=Dbrno.dbrno 萔=Dbrno.tesu Ŏw肳΋Ǌ
// DBCKBase֓ǂݍ
void CWinSDJDoc::ReadDbbInfo(DBRNO &Dbrno)
{
	if (!m_Dbb.Open()) { // ΋ǂcaI[v
		return ; // I[vɎs牽ȂB
	}

	// ΋ǔԍ(Dbrno)̑΋ǂcaR[hǂ
	int rc=m_Dbb.ReadByDbrno(Dbrno.dbrno);
	
	// ΋ǂcaR[hɑ΋ǊCSA`œǂݏo
	int za=GetKBase()->GetZa();
	CWinMemFile File; // t@C
	CSDJArchive storear(&File,CArchive::store);
	// CSA`ŏo
	if ((rc=m_Dbb.OutDB2Csa(storear,za))!=0) {m_Dbb.Close(); return;} 
	storear.Close();
	
	File.Seek(0L,CFile::begin); // CSAt@C擪ʒuSeek

	DeleteContents(); // hLgZbg

	// CSA`̃t@Cobt@֓ǂݍށB
	CSDJArchive loadar(&File,CArchive::load);
	Serialize(loadar);
	loadar.Close();

	m_Dbb.Close();  // ΋ǂcaN[Y

	// hLg̃^CgxxxxxxƂB
	CString strTitle;
	strTitle.Format("%s",m_Dbb.GetMdsp()->b_recno);
	SetTitle(strTitle);
	SetDiskPathName("");  // ܂ł̃fBXNpX𖳌ɂB

	// r[
	CSDJView *pSDJView=GetSDJView();
	if (pSDJView) {
		AdjustSpriteList(); // XvCgXg̒
		// JĂ^CgXV
		CKifFrame *pKifFrame=pSDJView->GetKifFrame();
		if (pKifFrame) {
			pKifFrame->SetWindowText(strTitle);
		}
	}

	// ǖʂǖʂɂB
	while (m_KBase.backmove2()>0); // 悸͏ǖʂ
	// ǖʂ܂Ői߂
	for (int i=0;i<(int)Dbrno.tesu;i++)
		m_KBase.ahead2();
}

//////
// ΋ǂcǎo̎萔ݒ肷B
// BDSP̃obt@XVB萔0̂Ƃ̓obt@NÂ݁B
void CWinSDJDoc::SetMrecTesu()
{
	int iTesu=GetTesu(); // ݂̊̎萔擾
	CString strTesu;
	strTesu.Format("%04d",iTesu); // 萔𕶎
	int len=strTesu.GetLength();// 萔̕

	// B_REC̍XV
	B_REC *pBrec=m_Dbb.GetMrec();
	memset(pBrec->row.tesu,0,sizeof pBrec->row.tesu); // 萔 0 NA
	if (iTesu > 0 && len <= sizeof pBrec->row.tesu) {  // 񒷂̃`FbN
		strncpy(pBrec->row.tesu,strTesu,len);
	}
	// BDSP̍XV
	BDSP *pBdsp=m_Dbb.GetMdsp();
    strncpy(pBdsp->tesu,pBrec->row.tesu,sizeof pBrec->row.tesu);
    pBdsp->tesu[sizeof pBrec->row.tesu]='\0';
}

/////
// 㖼̂̎擾
//  ߂l 0: 1:  2:lߏ
int CWinSDJDoc::GetSGName(SBASE *sb,CString *s,CString *g)
{
	int pattern;
	HBOX *phb=sb->hboxp(2);
	if (phb->getnum() > 0) { // ɋ
		if (m_KmListBox[2].kmnum(0) > 0) { // ʂɂ΋lߏ
			g->Format("%s","");
			s->Format("%s","");
			pattern=2; // l
		} else {
			g->Format("%s","");
			s->Format("%s","");
			pattern=1; // 
		}
	} else {
		g->Format("%s","");
		s->Format("%s","");
		pattern=0; // ΋
	}
	return pattern;
}

// ݂̋ǖʂW`ŃA[JCo[֏o͂(\A΋ǎҖ)B
void CWinSDJDoc::OutputAspectStd(CSDJArchive &ar,BOOL bTitle)
{
	CString crlf("\r\n"); // s
	PCELL *pcl=m_KBase.lastmove();
	PCELL *rpcl=m_KBase.root();
	int tesu=m_KBase.level(); // 萔
	CString str;
	if (pcl!=rpcl) // w肪LȂ
		str.Format("%s",m_KBase.mvstr(pcl)); // w̕\L

	// 薼
	CString Gote;
	CString Sente;
	int pattern=GetSGName(&m_KBase,&Sente,&Gote);

	// 薼 (ftHgł͂Ȃ)
	if (bTitle) {
		CString Tline;
		CString str1=str; // ̎w
		int len1=str1.GetLength();
		CString Sym1; //̃V{
		if (str1.Left(4)=="" || str1.Left(4)=="U" || str1.Left(4)=="")
			Sym1="";
		else
			Sym1="";
		str1.Format("%s%s",Sym1,str1.Right(len1-4));

		CString str2;     // O̎w
		if (tesu > 1) {
			PCELL *pcl1=pcl->pnt(); // ̑O̎w
			str2.Format("%s",m_KBase.mvstr(pcl1)); // ̎w̕\L
			int len2=str2.GetLength();
			CString Sym2; //̃V{
			if (str2.Left(4)=="" || str2.Left(4)=="U" || str2.Left(4)=="") 
				Sym2="";
			else
				Sym2="";
			str2.Format("%s%s",Sym2,str2.Right(len2-4));
		}

		if (pcl==rpcl) { // Jnǖ
			if (pattern!=2)  // lłȂ
				Tline.Format("薼F낵肢܂B%s",crlf);
		} else if (tesu == 1) { // wǖ
			Tline.Format("薼FA%s łB%s", str1,crlf);
		} else  { // Qڈȍ~̋ǖ
			Tline.Format("薼F%dA%s%słB%s",tesu,str2,str1,crlf);
		}
		ar.WriteString(Tline);
	}

	// ΋ǎ
	CString Gline;
	if (pattern!=2) { // lłȂ
		Gline.Format("%sF%s%s",Gote,m_Dbb.GetMdsp()->gplayer,crlf);
		ar.WriteString(Gline);
	}

	// W`ǖʏo
	OutputAspectFormStd(ar,&m_KBase,&Sente,&Gote);

	// ΋ǎ
	CString Sline;
	if (pattern!=2) { // lłȂ
		Sline.Format("%sF%s%s",Sente,m_Dbb.GetMdsp()->splayer,crlf);
		ar.WriteString(Sline);
	}

	// ŏIw̕\
	CString Pline;
	if (pcl==rpcl) {
		if (pattern!=2) // lłȂ
			Pline.Format("Jnǖ ܂%s",crlf);
	} else if (tesu==1) {
		Pline.Format(" %s ܂%s",str,crlf);
	} else {
		Pline.Format("%d %s ܂%s",tesu,str,crlf);
	}
	ar.WriteString(Pline);
}
/////
// ݂̋ǖʂW`CString֏o͂
void CWinSDJDoc::OutputAspectStd(CString &strAspect,BOOL bTitle)
{
	CWinMemFile File;
	CSDJArchive ar(&File,CArchive::store);
	OutputAspectStd(ar,bTitle); // t@C֏o
	ar.Close();
	File.Seek(0L,CFile::begin); // 擪Seek
	long leng=File.GetLength(); // t@C
	char *cp=strAspect.GetBuffer(leng+1); // t@C+1̃obt@m
	UINT nBytes=File.Read(cp,leng); // obt@փt@Cǂ
	cp[nBytes]='\0'; // ǂݏoŌNULLZbg
	strAspect.ReleaseBuffer(); // obt@J(NULLȍ~J)
}


//////
// (W`)A[JCo֏o͂B
// width=ŕ(72ftHg) line=Œ(9999ftHg) 
// bFF FORMFEEDo(ftHg͖FALSE)
void CWinSDJDoc::OutputKifStd(CSDJArchive &ar,int width,int line,BOOL bFF)
{
	CDBB *pDbb=&m_Dbb;          // ΋DB
	CString str;				// Ɨp


    /* sJEg=0 */
    lfc=0;
    lf_line=line;

	BOOL blfEnable=m_blfEnable; // FFo
	m_blfEnable=bFF;

	//////// KBaseJBaseփRs[ ////
	CJBase JBase;				// Ɨp
	CKBase *pKBase=GetKBase();  // Ǘ({)
	// ƗpǗ̐ݒ
	pKBase->CopySBase(&JBase,TRUE); // JBase֑S{菇Rs[

	pKBase->PushAspect(FALSE);	// ǖʂۑďǖʂ
	CBform Ibf=pKBase->btype(); // ǖʂ͌ŎĝŎcĂ
	int Iside=pKBase->turn();
	pKBase->PopAspect(); // ǖʂ߂

	// JBaseǖʂ֖߂
	while(JBase.lastmove()!=JBase.root())
		JBase.backmove2();

    BDSP bds;                   /* \pobt@ */
	SetMrecTesu(); // ΋ǌo̎萔BDSP̍XV
	B_REC *pBrec=pDbb->GetMrec(); // DBB ΋ǃR[h
	B_REC b_rec;
	B_REC *bp=&b_rec;
	memcpy(bp,pBrec,sizeof(B_REC)); // ΋ǃR[hRs[
    /* BR[h\pobt@(bds)Zbg */
    pDbb->set_mdsp(bp,&bds);

	// 㖼
	CString Sn,Gn;
	int sg_pattern=GetSGName(&JBase,&Sn,&Gn);
	
    /* ------- ΋ǃR[h̕\ --------- */
	ar.WriteString("========================================\r\n"); lf(ar);
    str.Format("y ΋ǔԍ: %s   o^: %17s z\r\n",bds.b_recno,bds.datetime);
	ar.WriteString(str); lf(ar);
    str.Format("΋Ǔ: %8s   햼: %s\r\n",bds.playdate,bds.kisen);
	ar.WriteString(str);lf(ar);
    str.Format("%s: %s %s\r\n",Sn,bds.splayer,bds.sdan);ar.WriteString(str); lf(ar);
    str.Format("%s: %s %s\r\n",Gn,bds.gplayer,bds.gdan);ar.WriteString(str); lf(ar);
    str.Format("荇: %-6s   : %8s   b: %2s\r\n",bds.teai,bds.htime,bds.timecount);
	ar.WriteString(str); lf(ar);
    str.Format("萔: %s  %s\r\n",(bds.tesu[0]!='\0')? bds.tesu:"?",bds.result);
	ar.WriteString(str); lf(ar);
    str.Format("%sc: %8s   %sc: %8s\r\n",Sn,bds.srhtime,Gn,bds.grhtime);
	ar.WriteString(str); lf(ar);
    str.Format("^: %s\r\n",bds.senkei);	 ar.WriteString(str); lf(ar);
    str.Format("΋Ǐꏊ: %s\r\n",bds.place);ar.WriteString(str); lf(ar);

    /* Ֆʂ肩ǂ`FbN */
    CBform Bform;               /* Ɨp */
	Bform.Init(0);				/*  */

    /* ǖʂ̕\(荇="w"̎܂͏ǖʂłȂƂ̂)*/
    if (strncmp(bp->row.teai,"w",4)==0 || Bform != Ibf ) {
        ar.WriteString("Jnǖ: ------------\r\n");lf(ar);
		// ǖʂ̏o
		OutputAspectFormStd(ar,&JBase,&Sn,&Gn,TRUE); // FORMFEEDo͕t
        ar.WriteString("\r\n");lf(ar);
    }

    /* ΋ǂ̒ */
	char *pComment=pDbb->GetComment();
	if (pComment) {
        ar.WriteString("΋ǒ: ------------\r\n");lf(ar);
		char *text=(char*)memalloc(strlen(pComment)+1);
		if (text) {
			strcpy(text,pComment);
			fputs_width(text,width,"",ar);
			memfree(text);
			ar.WriteString("\r\n");lf(ar);
		}
	}

	// w肪Ύw\L̃^Cgo͂B
	if (JBase.playnum()) {
		str.Format("w: ------------\r\n");
		ar.WriteString(str); lf(ar);
		if (Iside==SIDE_A) // ǖʂԂȂ
			str.Format("%4s%-15s %-5s %4s%s\r\n"," ",Sn," "," ",Gn);
		else
            str.Format("%4s%-15s %-5s %4s%s\r\n"," ",Gn," "," ",Sn);
		ar.WriteString(str); lf(ar);
	}
    /* wi߂Ȃ\B*/
	CString strMove;
	int level=1;
	while (JBase.playnum()) {
		JBase.ahead2(); // i߂
		PCELL *pcl=JBase.lastmove();
		strMove.Format("%s",JBase.mvstr(pcl)); // w\L
		char s_time[6];
        get_bplay_time(&JBase,pcl,s_time); // Ԃs_timeɃZbg(P)B
		char *kif=strMove.GetBuffer(strMove.GetLength()+1);
		char buf[128];
        set_buf(&kif[4],s_time,buf); // w蕶(㖳)+ԂbufɃZbgB
		strMove.ReleaseBuffer();
		level=JBase.level();
        if (level%2==1) {             /* () */
            str.Format("%3d %-21s ",level,buf);    /* \ */
			ar.WriteString(str);
		}
        else {                       /* ()(s) */ 
            str.Format("%3d %s\r\n",level,buf);      /* \ */
			ar.WriteString(str); lf(ar);
        }
        if (level%20==0) {
            ar.WriteString("\r\n");           /* 20ŉs */
            lf(ar);
        }
	}
    if (level%2!=0) {
        ar.WriteString("\r\n");lf(ar); /* ()ԂȂŌ2s */
	}
    ar.WriteString("\r\n");lf(ar); /* Ōŉs */

	// JBaseǖʂ֖߂
	while(JBase.lastmove()!=JBase.root())
		JBase.backmove2();

    /* wi߂Ȃ璍߂\ */

    level=1;
	m_bfirst=TRUE; // }[NBoutput_bplay_commentɂČoóB
	while (JBase.playnum()) {
		JBase.ahead2();
		output_bplay_comment(&JBase,JBase.lastmove(),width,ar);
	}

	// FFo
	if (bFF) {
		if (lfc>0) {
			BYTE ff = FORMFEED;
			ar << ff;
			lfc=0;
		}
	}

	m_blfEnable=blfEnable;
}

////
// t@C̃I[v
void CWinSDJDoc::OnFileOpen() 
{
	theApp.OnFileOpenKF();
}
