/************************/
/*    WinSDJSDoc.cpp    */
/************************/
#include "stdafx.h"
#include "winsdj.h"
#include "WinSDJSDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp; 

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSDoc

IMPLEMENT_DYNCREATE(CWinSDJSDoc, CSDJDoc)

CWinSDJSDoc::CWinSDJSDoc()
{
}

BOOL CWinSDJSDoc::OnNewDocument()
{
	if (!CSDJDoc::OnNewDocument())
		return FALSE;

	m_KBase.setup(0); // zu(𕽎zuAՏ񂪃Zbg)
	m_KBase.setturn(SIDE_A); // 

	m_KBase.turnsw(0); // ԍXVƂ

	return TRUE;
}

BOOL CWinSDJSDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CSDJDoc::OnOpenDocument(lpszPathName))
		return FALSE;
	
	m_KBase.turnsw(0); // ԍXVƂ

	return TRUE;
}

CWinSDJSDoc::~CWinSDJSDoc()
{
}

BEGIN_MESSAGE_MAP(CWinSDJSDoc, CSDJDoc)
	//{{AFX_MSG_MAP(CWinSDJSDoc)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSDoc ff

#ifdef _DEBUG
void CWinSDJSDoc::AssertValid() const
{
	CSDJDoc::AssertValid();
}

void CWinSDJSDoc::Dump(CDumpContext& dc) const
{
	CSDJDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSDoc VACY

void CWinSDJSDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		WriteBaninfo((CSDJArchive &)ar);
	}
	else
	{
		ReadBaninfo((CSDJArchive &)ar);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSDoc R}h

// msdev\mfc\source\doccore.cpp 
// SelectBoxBǖʎw肵Ă鎞At@CZ[u_CAO
// ǖʎw̃t[IꍇɑΉ邽߁B
BOOL CWinSDJSDoc::DoSave(LPCTSTR lpszPathName, BOOL bReplace)
	// Save the document data to a file
	// lpszPathName = path name where to save document file
	// if lpszPathName is NULL then the user will be prompted (SaveAs)
	// note: lpszPathName can be different than 'm_strPathName'
	// if 'bReplace' is TRUE will change file name if successful (SaveAs)
	// if 'bReplace' is FALSE will not change path name (SaveCopyAs)
{
	CString newName = lpszPathName;
	if (newName.IsEmpty())
	{
		CDocTemplate* pTemplate = GetDocTemplate();
		ASSERT(pTemplate != NULL);

		newName = m_strPathName;
		if (bReplace && newName.IsEmpty())
		{
			newName = m_strTitle;
#ifndef _MAC
			// check for dubious filename
			int iBad = newName.FindOneOf(_T(" #%;/\\"));
#else
			int iBad = newName.FindOneOf(_T(":"));
#endif
			if (iBad != -1)
				newName.ReleaseBuffer(iBad);

#ifndef _MAC
			// append the default suffix if there is one
			CString strExt;
			if (pTemplate->GetDocString(strExt, CDocTemplate::filterExt) &&
			  !strExt.IsEmpty())
			{
				ASSERT(strExt[0] == '.');
				newName += strExt;
			}
#endif
		}

		if (!AfxGetApp()->DoPromptFileName(newName,
		  bReplace ? AFX_IDS_SAVEFILE : AFX_IDS_SAVEFILECOPY,
		  OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, FALSE, pTemplate))
			return FALSE;       // don't even attempt to save
	}

	CWaitCursor wait;

	if (!theApp.m_bSDocTemplateUsing) // ǖʎw肪IĂꍇ
		return FALSE;  // by Ra (ȂƂ͐悸ȂƂ͎v)

	if (!OnSaveDocument(newName))
	{
		if (lpszPathName == NULL)
		{
			// be sure to delete the file
			TRY
			{
				CFile::Remove(newName);
			}
			CATCH_ALL(e)
			{
				TRACE0("Warning: failed to delete file after failed SaveAs.\n");
//				DELETE_EXCEPTION(e);
				e->Delete();
			}
			END_CATCH_ALL
		}
		return FALSE;
	}

	// reset the title and change the document name
	if (bReplace)
		SetPathName(newName);

	return TRUE;        // success
}
