/*************************/
/*    WinSDJTSDoc.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include "sdjview.h"
#include "WinSDJTSDoc.h"
#include <winmemfile.h>
#include "jbase.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSDoc

IMPLEMENT_DYNCREATE(CWinSDJTSDoc, CSDJDoc)

CWinSDJTSDoc::CWinSDJTSDoc()
{
}

CWinSDJTSDoc::~CWinSDJTSDoc()
{
}


BEGIN_MESSAGE_MAP(CWinSDJTSDoc, CSDJDoc)
	//{{AFX_MSG_MAP(CWinSDJTSDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSDoc ff

#ifdef _DEBUG
void CWinSDJTSDoc::AssertValid() const
{
	CSDJDoc::AssertValid();
}

void CWinSDJTSDoc::Dump(CDumpContext& dc) const
{
	CSDJDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSDoc VACY

void CWinSDJTSDoc::Serialize(CArchive& ar)
{
	Serialize((CSDJArchive &)ar,FALSE);
}
// bLine: TRUE/FALSE(Default)  {菇̂ݏo/wԑSĂo
void CWinSDJTSDoc::Serialize(CSDJArchive& ar,BOOL bLine)
{
	int za=m_KBase.GetZa(); // ݂̍

	if (ar.IsStoring())
	{
		SetMrecTesu();    // lo̎萔ݒ肷
		WriteToCsa(ar);   // loCSA`ŏo
		CSDJDoc::Serialize(ar,bLine); // KBase ̃VACY(̓o)
	}
	else
	{
		m_bActualRead=ReadFromCsa(ar);  // CSA`lo
		if (m_bActualRead) {
			CSDJDoc::Serialize(ar,bLine); // KBase ̃VACY(̓o)
			SetMrecTesu();     // lo̎萔ݒ肷
		}
	}

	if (za!=m_KBase.GetZa()) { // ύXɂȂ
		// Ղ̔wiĐݒ
		SetBackground(&theApp.m_BackDIB[m_KBase.GetZa()]);
	}
}

BOOL CWinSDJTSDoc::OnNewDocument() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	// DeleteContentsĂ΂AՁE()񂪃NA
	if (!CSDJDoc::OnNewDocument())
		return FALSE;
	
	// (SDI hLg͂̃hLgėp܂B)
	CSDJView *pSDJView=GetSDJView();
	if (pSDJView) {
		pSDJView->InitMatePos(); // lzu
		AdjustSpriteList();      // \
	}
	// ̕\
	if (theApp.m_bKifWindowEnable)
		pSDJView->SendMessage(WM_COMMAND,ID_KIF_WINDOW_OPEN);
	return TRUE;
}

BOOL CWinSDJTSDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CSDJDoc::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// ̕\
	CSDJView *pSDJView=GetSDJView();
	if (theApp.m_bKifWindowEnable)
		pSDJView->SendMessage(WM_COMMAND,ID_KIF_WINDOW_OPEN);
	
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSDoc R}h

//////
// lo̎萔ݒ肷B
// CDSP̃obt@XVB萔0̂Ƃ̓obt@NÂ݁B
void CWinSDJTSDoc::SetMrecTesu()
{
	int iTesu=GetTesu(); // ݂̊̎萔擾
	CString strTesu;
	strTesu.Format("%04d",iTesu); // 萔𕶎
	int len=strTesu.GetLength();  // 萔̕

	// C_REC̍XV
	C_REC *pCrec=m_Dbc.GetMrec();
	memset(pCrec->row.movenum,0,sizeof pCrec->row.movenum); // l萔 0 NA
	if (iTesu > 0 && len <= sizeof pCrec->row.movenum) {  // 񒷂̃`FbN
		strncpy(pCrec->row.movenum,strTesu,len);
	}
	// CDSP̍XV
	CDSP *pCdsp=m_Dbc.GetMdsp();
    strncpy(pCdsp->movenum,pCrec->row.movenum,sizeof pCrec->row.movenum);
    pCdsp->movenum[sizeof pCrec->row.movenum]='\0';
}


/////
// CSAt@Cւ̏o
int CWinSDJTSDoc::WriteToCsa(CSDJArchive &ar)
{
	int rc=1;
	// ar`FbN
	ASSERT(ar.IsStoring());

	int za=m_KBase.GetZa();
	if ((rc=m_Dbc.OutMrec2CsaHeader1(ar,za))!=0) goto exit; // wb_[
	if ((rc=m_Dbc.OutMrec2CsaHeader2(ar))!=0) goto exit; // RgL[[h
	if ((rc=m_Dbc.OutMrec2CsaHeader3(ar))!=0) goto exit; // l
	if ((rc=m_Dbc.OutMrec2CsaHeader4(ar))!=0) goto exit; // ΋ǎ
	rc=0;
exit:
	return rc;
}

/////
// CSAt@C̓
BOOL CWinSDJTSDoc::ReadFromCsa(CSDJArchive &ar)
{
    int rc=1;
    char *line;
	char StringBuffer[512];
	CKmListBox *pListBox=m_KBase.GetListBox();
	int i;
	BOOL ret=FALSE;
	
	// lł̓t@Ĉcao^AUhLgɓǂݍށB
	// EOFɂȂt@ChLgɓǂݍ܂Ȃ悤ɂ̔
	// B̔肪ȂƏԂ̃hLgo^ɍsB
	// ŏ̃t@CuJvƂƂ́At@CTCY==0Ȃ
	// Serialize()Ă΂ȂB(MFC̃R[hȂĂ)
	// ΋ǂł͒ڃt@Cǂœo^Ă̂EOFm玩R
	// IB]đ΋ǂł͕͂̔svB(ĂQ)
	if (ar.IsEOF()) goto exit; // EOFȂ瑦I

	if ((rc=m_Dbc.InCsa2MrecInit(ar))!=0) goto exit; // Ǎݏ̏

	// lɐݒ肷B
	if (m_KBase.GetZa()!=SIDE_A) { // ύXɂȂ
		m_KBase.SetZa(SIDE_A);
		for (i=0;i<3;i++)
			pListBox[i].ZaRotation(); // _̔]
	}

	// ȉ̃[vCSA`ǂݍb_recZbg(΋ǎ҂܂)B
	while (!m_Dbc.InCsa2MrecIsEnd()) { // I`FbN
		// ͍s̓Ǐo
		if ((line=m_Dbc.get_line(ar))==NULL)
			break;          /* eof */
		// CSARgsȂ
		if (line[0]=='\'') {
		/* "'"ȉRgsL[[hƈv邩ۂׁAv
		   YB_RECtB[h̍ڂɂ̒lZbgB
		 */
			if (m_Dbc.mrec_comment_set(line)!=0) goto exit;

			// ̃`FbN
			if (strcmp(line,"'")==0) {
				if (m_KBase.GetZa()!=SIDE_B) { // ύXɂȂ
					m_KBase.SetZa(SIDE_B);
					for (i=0;i<3;i++)
						pListBox[i].ZaRotation(); // _̔]
				}
			}
		}
		// ΋ǎҎwȂ
		else if (line[0]=='N') {
			/* ΋ǎ҂̃Zbg */
			if (m_Dbc.brec_player(line)!=0) goto exit;
		} 
		else {
			sprintf(StringBuffer,"@G[łB(%s)",line);
			if (line[0]=='P')
				strcat(StringBuffer,"\r\n o̍s\"'\"܂\"N\"܂B");
			AfxMessageBox(StringBuffer);
			goto exit;
		}
	}

	ret=TRUE;
    rc=0;
  exit:
	m_Dbc.InCsa2MrecEnd(); // CSAǍݏI
    return ret;
}

/////
// l(Dbrno) ԍ=Dbrno.dbrno 萔=Dbrno.tesu Ŏw肳l
// DBCKBase֓ǂݍށB
// pBlist: ǖʂDbrno.tesu̎w܂ŋǖʂi߂ׂ̎w(B_PLAY)Xg
//         ==NULL(ftHg)Ȃ{菇Ői߂B
void CWinSDJTSDoc::ReadDbcInfo(DBRNO &Dbrno,CList <B_PLAY,B_PLAY&> *pBlist)
{
	if (!m_Dbc.Open()) { // ΋ǂcaI[v
		return ; // I[vɎs牽ȂB
	}

	// lԍ(Dbrno)DBR[hǂ
	int rc=m_Dbc.ReadByDbrno(Dbrno.dbrno);
	if (rc!=E$OK)
		return;

	// caR[hɋlCSA`œǂݏo
	int za=GetKBase()->GetZa();
	CWinMemFile File; // t@C
	CSDJArchive storear(&File,CArchive::store);
	// CSA`ŏo
	if ((rc=m_Dbc.OutDB2Csa(storear,za))!=0) {m_Dbc.Close(); return;} 
	storear.Close();
	// ŁAo}(hash_s)SerializeȂ̂ŋLB
	// (set_mdsp()ReadByDbrno̒łĂ)
	C_REC *cp=m_Dbc.GetMrec();
	char hash_s[sizeof cp->row.hash_s];
	memcpy(hash_s,cp->row.hash_s,sizeof hash_s);
		
	File.Seek(0L,CFile::begin); // CSAt@C擪ʒuSeek
		
	DeleteContents(); // hLgZbg

	// CSA`̃t@Cobt@֓ǂݍށB
	CSDJArchive loadar(&File,CArchive::load);
	Serialize(loadar); // ӁI ŏo}(hash_s)͏B
	loadar.Close();

	m_Dbc.Close();  // lcaN[Y

	// ŋLĂo}(hash_s)𕜊B
	memcpy(cp->row.hash_s,hash_s,sizeof hash_s);
	m_Dbc.set_mdsp(); // \obt@ZbgB

	// hLg̃^CgxxxxxxƂB
	CString strTitle;
	strTitle.Format("l%s",m_Dbc.GetMdsp()->c_recno);
	SetTitle(strTitle);
	SetDiskPathName("");  // ܂ł̃fBXNpX𖳌ɂB

	// r[
	CSDJView *pSDJView=GetSDJView();
	if (pSDJView) {
		AdjustSpriteList(); // XvCgXg̒
		CKifFrame *pKifFrame=pSDJView->GetKifFrame();
		if (pKifFrame) {
			// hLgƓ^Cg
			pKifFrame->SetWindowText(strTitle); 
		}
	}

	// ǖʂwǖʂɂB
	while (m_KBase.root()!=m_KBase.lastmove())
		m_KBase.backmove2();  // 悸͏ǖʂ

	if (pBlist==NULL) { // w胊Xg̎w肪ȂꍇB
		for (int i=0;i<(int)Dbrno.tesu;i++)
			m_KBase.ahead2(); 	// {菇i߂B
	}
	else { // w胊Xg̎w肪ꍇB
		POSITION pos=pBlist->GetHeadPosition();
		int i=0;
		while (i<(int)Dbrno.tesu && pos) {
			B_PLAY &bplay=pBlist->GetNext(pos);
			// w肳ꂽwi߂B(w͏move)
			int rc=m_KBase.move2(bplay,TRUE);
			ASSERT(rc!=0); // 퓮mF
			i++;
		}
		ASSERT(i==(int)Dbrno.tesu); // Xgeʂ̊mF
	}
}

/////////
// PCL t@C̍XV
//  Multi: w  0/1 P/
//  bMessage: EH[jOoۂ  TRUE/FALSE  o(DEFAULT)/oȂ
//  pPclFile :PCLt@CpXB==NULL(ftHg)Ȃ玩vZ
//  ߂lF TRUE/FALSE  /s
BOOL CWinSDJTSDoc::PclUpdate(int Multi,BOOL bMessage,char *hash_s)
{
	BOOL ret=TRUE;

	// PCLfBNg̃`FbN
	CString strPclDir;
	strPclDir.Format("%spcl",GetShgdbName());
	CFile f; CFileStatus fs;
	if (!f.GetStatus(strPclDir,fs)) { // PCL fBNgȂCreateB
		if (!CreateDirectory(strPclDir,NULL)) { // fBNg쐬Ɏs
			if (bMessage) {
				CString strMes;
				strMes.Format("PCLtH_ %s 쐬ł܂BwԂ͖܂B",
					strPclDir);
				AfxMessageBox(strMes);
			}
			return FALSE; // fBNgoȂ̂łŏIB
		}
	}

	// PCLt@C
	CString strPclFile;
	if (hash_s==NULL) {   // Ow肪ȂΎ(hLg)ɐB
		m_Dbc.set_mdsp();
		CDSP *cdsp=m_Dbc.GetMdsp();
		hash_s=cdsp->hash_s;
	}
	strPclFile.Format("%s\\%s.pcl",strPclDir,hash_s);

	// wԂ̏ꍇBhLgSerialize()B
	if (Multi) { 
		if (f.Open(strPclFile,
			CFile::modeReadWrite|CFile::modeCreate|CFile::shareExclusive)) {
			CSDJArchive arOut(&f,CArchive::store); // ݃A[JCo
			Serialize(arOut); // wԂPCLo
			arOut.Close();
			f.Close();
		}
		else {
			ret=FALSE;
			if (bMessage) {
				CString strMes;
				strMes.Format(
					"wԃt@C %s ݂̏Ɏs܂B\r\n%s",	strPclFile,
					"łɂ̃t@C݂Ăꍇ͎蓮ō폜ĂB");
				AfxMessageBox(strMes);
			}
		}
	}
	// P̎wԂȂɂPCLt@C͏
	else { 
		CFileStatus status;
		if (f.GetStatus(strPclFile,status)) { // PCLt@C̑݊mF()
			TRY {
				f.Remove(strPclFile);  // 
			}
			CATCH (CFileException,e) { // oȂ
				ret=FALSE;
				if (bMessage) {
					char strErr[256];
					e->GetErrorMessage(strErr,sizeof strErr);
					CString strMes;
					strMes.Format(
						"wԃt@C %s 폜ł܂B:\r\n(Error message:%s)",
						strPclFile,strErr);
					AfxMessageBox(strMes);
				}
			}
			END_CATCH
		}
	}

	return ret;
}


/////
// 㖼̂̎擾
//  ߂l 0: 1:  2:lߏ
int CWinSDJTSDoc::GetSGName(SBASE *sb,CString *s,CString *g)
{
	int pattern;
	HBOX *phb=sb->hboxp(2);
	if (phb->getnum() > 0) { // ɋ
		if (m_KmListBox[2].kmnum(0) > 0) { // ʂɂ΋lߏ
			g->Format("%s","");
			s->Format("%s","U");
			pattern=2; // l
		} else {
			g->Format("%s","");
			s->Format("%s","U");
			pattern=1; // 
		}
	} else {
		g->Format("%s","");
		s->Format("%s","U");
		pattern=0; // ΋
	}
	return pattern;
}

//////
// (W`)A[JCo֏o͂B
// width=ŕ(72ftHg) line=Œ(9999ftHg) 
// bFF FORMFEEDo(ftHg͖FALSE)
void CWinSDJTSDoc::OutputKifStd(CSDJArchive &ar,int width,int line,BOOL bFF)
{
	CDBC *pDbc=&m_Dbc;          // lDB
	CString str;				// Ɨp


    /* sJEg=0 */
    lfc=0;
    lf_line=line;

	BOOL blfEnable=m_blfEnable; // FFo
	m_blfEnable=bFF;

	//////// KBaseJBaseփRs[ ////
	CJBase JBase;				// Ɨp
	CKBase *pKBase=GetKBase();  // Ǘ({)
	// ƗpǗ̐ݒ
	pKBase->CopySBase(&JBase,TRUE); // JBase֑S{菇Rs[

	pKBase->PushAspect(FALSE);	// ǖʂۑďǖʂ
	CBform Ibf=pKBase->btype(); // ǖʂ͌ŎĝŎcĂ
	int Iside=pKBase->turn();
	pKBase->PopAspect(); // ǖʂ߂

	// JBaseǖʂ֖߂
	while(JBase.lastmove()!=JBase.root())
		JBase.backmove2();

    CDSP cds;                   /* \pobt@ */
	SetMrecTesu(); // lo̎萔CDSP̍XV
	C_REC *pCrec=pDbc->GetMrec(); // DBC lR[h
	C_REC c_rec;
	C_REC *crp=&c_rec;
	memcpy(crp,pCrec,sizeof(C_REC)); // lR[hRs[
    /* CR[h\pobt@(bds)Zbg */
    pDbc->set_mdsp(crp,&cds);

	// 㖼
	CString Sn,Gn;
	int sg_pattern=GetSGName(&JBase,&Sn,&Gn);
	
    /* ------- lR[h̕\ --------- */
	ar.WriteString("========================================\r\n"); lf(ar);
    str.Format("y lԍ: %s   o^: %17s z\r\n",cds.c_recno,cds.datetime);
	ar.WriteString(str); lf(ar);
    str.Format("\: %s\r\n",cds.title);
	ar.WriteString(str);lf(ar);
    str.Format(": %s\r\n",cds.author);
	ar.WriteString(str);lf(ar);
    str.Format("Փx: %s\r\n",cds.level);
	ar.WriteString(str);lf(ar);
    str.Format("qg: %s\r\n",cds.hint);
	ar.WriteString(str);lf(ar);
    str.Format("l萔: %s\r\n",cds.movenum);
	ar.WriteString(str); lf(ar);
    str.Format("o}: %s\r\n",cds.hash_s);
	ar.WriteString(str); lf(ar);

    ar.WriteString("oǖ: ------------\r\n");lf(ar);
    // ǖʂ̏o
	OutputAspectFormStd(ar,&JBase,&Sn,&Gn,TRUE); // FORMFEEDo͕t
    ar.WriteString("\r\n");lf(ar);

    /* l̒ */
	char *pComment=pDbc->GetComment();
	if (pComment) {
        ar.WriteString("l: ------------\r\n");lf(ar);
		char *text=(char*)memalloc(strlen(pComment)+1);
		if (text) {
			strcpy(text,pComment);
			fputs_width(text,width,"",ar);
			memfree(text);
			ar.WriteString("\r\n");lf(ar);
		}
	}

	// w肪Ύw\L̃^Cgo͂B
	if (JBase.playnum()) {
		str.Format("w: ------------\r\n");
		ar.WriteString(str); lf(ar);
		if (Iside==SIDE_A) // ǖʂԂȂ
			str.Format("%4s%-15s %-5s %4s%s\r\n"," ",Sn," "," ",Gn);
		else
            str.Format("%4s%-15s %-5s %4s%s\r\n"," ",Gn," "," ",Sn);
		ar.WriteString(str); lf(ar);
	}
    /* wi߂Ȃ\B*/
	CString strMove;
	int level=1;
	while (JBase.playnum()) {
		JBase.ahead2(); // i߂
		PCELL *pcl=JBase.lastmove();
		strMove.Format("%s",JBase.mvstr(pcl)); // w\L
		char s_time[6];
        get_bplay_time(&JBase,pcl,s_time); // Ԃs_timeɃZbg(P)B
		char *kif=strMove.GetBuffer(strMove.GetLength()+1);
		char buf[128];
        set_buf(&kif[4],s_time,buf); // w蕶(㖳)+ԂbufɃZbgB
		strMove.ReleaseBuffer();
		level=JBase.level();
        if (level%2==1) {             /* () */
            str.Format("%3d %-21s ",level,buf);    /* \ */
			ar.WriteString(str);
		}
        else {                       /* ()(s) */ 
            str.Format("%3d %s\r\n",level,buf);      /* \ */
			ar.WriteString(str); lf(ar);
        }
        if (level%20==0) {
            ar.WriteString("\r\n");           /* 20ŉs */
            lf(ar);
        }
	}
    if (level%2!=0) {
        ar.WriteString("\r\n");lf(ar); /* ()ԂȂŌ2s */
	}
    ar.WriteString("\r\n");lf(ar); /* Ōŉs */

	// JBaseǖʂ֖߂
	while(JBase.lastmove()!=JBase.root())
		JBase.backmove2();

    /* wi߂Ȃ璍߂\ */

    level=1;
	m_bfirst=TRUE; // }[NBoutput_bplay_commentɂČoóB
	while (JBase.playnum()) {
		JBase.ahead2();
		output_bplay_comment(&JBase,JBase.lastmove(),width,ar);
	}

	// FFo
	if (bFF) {
		if (lfc>0) {
			BYTE ff = FORMFEED;
			ar << ff;
			lfc=0;
		}
	}

	m_blfEnable=blfEnable;
}

////
// t@C̃I[v
void CWinSDJTSDoc::OnFileOpen() 
{
	theApp.OnFileOpenTS();
}
