// WinSDJTSDoc.h : wb_[ t@C
//
#ifndef __WINSDJTSDOC__
#define __WINSDJTSDOC__
#include <afxtempl.h>
#include "sdjdoc.h"
#include "dbc.h"
#include "sdjarchive.h"

/////////////////////////////////////////////////////////////////////////////
// CWinSDJTSDoc hLg
class CWinSDJTSDoc : public CSDJDoc
{
protected:
	DECLARE_DYNCREATE(CWinSDJTSDoc)

// Agr[g
public:
	CDBC m_Dbc;      // lf[^x[X

// Iy[V
public:
	virtual int GetSGName(SBASE *sb,CString *s,CString *g);
	virtual void OutputKifStd(CSDJArchive &ar,int width=72,int line=9999,
		BOOL bFF=FALSE);
	virtual void OutputKifStd(CString &strKif,int width=72,int line=9999,
		BOOL bFF=FALSE){CSDJDoc::OutputKifStd(strKif,width,line,bFF);}
	virtual void OutputKifCsa(CString &strKif){CSDJDoc::OutputKifCsa(strKif);}
	BOOL PclUpdate(int Multi,BOOL bMessage=TRUE,char *hash_s=NULL);
	virtual void SetMrecTesu();
	void ReadDbcInfo(DBRNO &Dbrno,CList <B_PLAY,B_PLAY&> *pBlist=NULL);
	int WriteToCsa(CSDJArchive &ar);    // CSAt@Cւ̏o
	BOOL ReadFromCsa(CSDJArchive &ar);   // CSAt@C̓
	BOOL IsActualRead(){return m_bActualRead;}
	CWinSDJTSDoc();           // IɎgpveNg RXgN^B

	virtual void Serialize(CSDJArchive& ar,BOOL bLine);
	virtual void Serialize(CSDJArchive &ar){Serialize((CArchive &)ar);}

// I[o[Ch
	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CWinSDJTSDoc)
	public:
	virtual void Serialize(CArchive& ar); // hLg I/O ɑ΂ăI[o[Ch܂B
	virtual BOOL OnNewDocument();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CWinSDJTSDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// bZ[W }bv֐̐
protected:
	//{{AFX_MSG(CWinSDJTSDoc)
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL m_bActualRead;
};

#endif // __WINSDJTSDOC__
