/************************/
/*    WinSDJView.cpp    */
/************************/
#include "stdafx.h"
#include "winsdj.h"
#include "childfrm.h"
#include "winsdjview.h"
#include "winsdjdoc.h"
#include "ssdjdoctemplate.h"
#include "sframewnd.h"
#include "SelectBoxB.h"
#include "DlgInCsa.h"
#include "DlgOutCsa.h"
#include <WinMemFile.h>
#include "buftodbb.h"
#include "DlgMidasi.h"
#include "DlgDelDbb.h"
#include "selectcsa.h"
#include "dbeframe.h"
#include "dbeview.h"
#include "k2csa.h"
#include "jbase.h"
#include "printobject.h"
#include "winsdjsdoc.h"
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4996)

// O[o
extern CWinSDJApp theApp;

extern "C" {
	void *memalloc(unsigned int);
	void memfree(void *);
}


/////////////////////////////////////////////////////////////////////////////
// CWinSDJView

IMPLEMENT_DYNCREATE(CWinSDJView, CSDJView)

BEGIN_MESSAGE_MAP(CWinSDJView, CSDJView)
	//{{AFX_MSG_MAP(CWinSDJView)
	ON_UPDATE_COMMAND_UI(ID_MENU_INITFORM, OnUpdateMenuInitForm)
	ON_COMMAND(ID_MENU_INITFORM, OnMenuInitForm)
	ON_COMMAND(ID_MENU_SELECTBOX, OnMenuSelectbox)
	ON_UPDATE_COMMAND_UI(ID_MENU_SELECTBOX, OnUpdateMenuSelectbox)
	ON_WM_DESTROY()
	ON_COMMAND(ID_MENU_OUTCSA, OnMenuOutCSA)
	ON_COMMAND(ID_MENU_BUFTODBB, OnMenuBuftoDBB)
	ON_UPDATE_COMMAND_UI(ID_MENU_BUFTODBB, OnUpdateMenuBuftoDbb)
	ON_UPDATE_COMMAND_UI(ID_MENU_OUTCSA, OnUpdateMenuOutCsa)
	ON_COMMAND(ID_MENU_MIDASI, OnMenuMidasi)
	ON_COMMAND(ID_MENU_DELDBB, OnMenuDelDbb)
	ON_UPDATE_COMMAND_UI(ID_MENU_DELDBB, OnUpdateMenuDelDbb)
	ON_COMMAND(ID_SELECT_CSAFILE, OnSelectCsafile)
	ON_COMMAND(ID_MENU_CLIPOUT1, OnMenuClipout1)
	ON_UPDATE_COMMAND_UI(ID_MENU_INCSA, OnUpdateMenuInCsa)
	ON_COMMAND(ID_MENU_INCSA, OnMenuInCsa)
	ON_COMMAND(ID_MENU_CLIPOUT2, OnMenuClipout2)
	ON_COMMAND(ID_MENU_CLIPOUT3, OnMenuClipout3)
	ON_COMMAND(ID_READ_KKF, OnReadKKF)
	ON_COMMAND(ID_ZA_ROTATION, OnZaRotation)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSDJView NX̍\z/

CWinSDJView::CWinSDJView()
{
}

CWinSDJView::~CWinSDJView()
{
}


/////////////////////////////////////////////////////////////////////////////
// CWinSDJView NX̕`

void CWinSDJView::OnDraw(CDC* pDC)
{
	ResetZaFontDIB(0);		// \̃Zbg
	CSDJView::OnDraw(pDC);
	DrawSide(pDC,0);		// ΋ǎԕ\(\DIB̏)
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJView NẌ

BOOL CWinSDJView::OnPreparePrinting(CPrintInfo* pInfo)
{
	CWinSDJDoc *pDoc=GetDocument();
	CPrintObject *pPObj = new CPrintObject;
	CString str;
	pDoc->OutputKifStd(str,100);		// W`(100)
	GetPrintString(str,pPObj->strKif);	// `(Qig)
	pPObj->kif=pPObj->strKif.GetBuffer(pPObj->strKif.GetLength()+1);

	// ǖʂ̎擾
	CKBase *pKBase=pDoc->GetKBase();
	pKBase->PushAspect(FALSE);			// ݂̋ǖʂۑďǖʂ
	pPObj->Bform=*pKBase->btype();		// ǖʂ擾
	pPObj->side=pKBase->turn();
	pKBase->PopAspect();				// ǖʂ߂

	// ǖʂ͕肩
	CBform Bform; Bform.Init(0);		// 
	if (Bform == pPObj->Bform)	pPObj->bPI=TRUE;
	else					    pPObj->bPI=FALSE;

	pInfo->m_lpUserData=(LPVOID)pPObj;
	return CSDJView::DoPreparePrinting(pInfo);
}

void CWinSDJView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	CPrintObject *pPObj=(CPrintObject *)pInfo->m_lpUserData;

	// s̃tHg̎擾
	// tHg̏
	pDC->SetMapMode(MM_LOMETRIC);

	CFont Font;									// `̃tHg
	Font.CreatePointFont(100,"lr ",pDC);	// `tHg10pt̍쐬()
	LOGFONT lfFont;
	Font.GetObject(sizeof(LOGFONT),&lfFont);	// tHg̎擾
	// 
	// CreatePointFontŃ|Cgw肵ătHg쐬ƃvr[ƈ
	// ŃtHgTCYقȂBł
	//             12pt    10pt 
	//  vr[  25	    17   (_P)
	//          42      35   (_P)
	//  ̂ɁAł͒ڃTCYw肷B
	lfFont.lfHeight=42;	pPObj->nf12.CreateFontIndirect(&lfFont);	// 12pt
	lfFont.lfHeight=35;	pPObj->nf.CreateFontIndirect(&lfFont);		// 10pt
	lfFont.lfEscapement = 1800;
	pPObj->rf.CreateFontIndirect(&lfFont);							// `tHg10pt(t)̍쐬
	
	// MAXy[W̌vZ
	int i,ix,dn;
	for (ix=0,i=0;ix < pPObj->strKif.GetLength();) {
		// OłpInfo->m_rectDraw͖BA4cŌvZB
		ix=PageCalc(++i,pDC,pInfo,&dn,2883); 
	}
	pInfo->SetMaxPage(i-1);
}

void CWinSDJView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	CPrintObject *pPObj=(CPrintObject*)pInfo->m_lpUserData;
	pPObj->strKif.ReleaseBuffer();
	delete pPObj;
}

void CWinSDJView::OnEndPrintPreview(CDC* pDC, CPrintInfo* pInfo, POINT point, CPreviewView* pView) 
{
	CChildFrame *pParent=(CChildFrame*)GetParentFrame();
	// ő\(vr[̂݋Ă)Ȃ猳ɂɖ߂B
	if (pParent->IsZoomed()) {
		pParent->MDIRestore();
	}

	// ACR\Ȃ猳ɂɖ߂BȂOnEndPrintPreview()ASSERT.
	// MFC̃oOB
	if (pParent->IsIconic()) {
		pParent->MDIRestore();
	}

	// ̒ŏOnEndPrintingĂ΂B
	CSDJView::OnEndPrintPreview(pDC, pInfo, point, pView);
}

void CWinSDJView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CPrintObject *pPObj=(CPrintObject*)pInfo->m_lpUserData;

	PagePrint(pDC,pInfo);

	// tb^[(y[Wԍ)̈
	CString str;
	str.Format("- %d -",pInfo->m_nCurPage);
	LOGFONT lfFont; // tHg
	pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);	// tHg̎擾
	if (lfFont.lfHeight<0) lfFont.lfHeight=-lfFont.lfHeight;
	lfFont.lfWidth=0;
	CFont Font;
	Font.CreateFontIndirect(&lfFont);
	CFont *pOldFont=pDC->SelectObject(&Font);		// tHgI
	int h=pInfo->m_rectDraw.Height();				// ʒu
	int w=pInfo->m_rectDraw.Width();
	pDC->TextOut(w/2-lfFont.lfHeight/2*2,h+50,str);
	pDC->SelectObject(pOldFont);					// tHgɖ߂
}

void CWinSDJView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	if (pInfo==NULL) 
		CSDJView::OnPrepareDC(pDC, pInfo);
	else {
		int OldMode = pDC->SetMapMode(MM_LOMETRIC);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CWinSDJView NX̐ff

#ifdef _DEBUG
void CWinSDJView::AssertValid() const
{
	CSDJView::AssertValid();
}

void CWinSDJView::Dump(CDumpContext& dc) const
{
	CSDJView::Dump(dc);
}

CWinSDJDoc* CWinSDJView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWinSDJDoc)));
	return (CWinSDJDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinSDJView NX̃bZ[W nh


// ǖʂ̐ݒJn
void CWinSDJView::OnUpdateMenuInitForm(CCmdUI* pCmdUI) 
{
	// ɔՖʕҏWȂ烁j[Disable
	if (theApp.m_bSDocTemplateUsing)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}
void CWinSDJView::OnMenuInitForm() 
{
	// ɊJnς݂ȂȂɂȂB
	if (theApp.m_bSDocTemplateUsing)
		return ;
	theApp.m_bSDocTemplateUsing=TRUE;

	// ǖʂ̃t@Co(t@C)
	CWinSDJDoc *pDocument=GetDocument();
	CWinMemFile File;
	CSDJArchive arOut(&File,CArchive::store);
	pDocument->WriteBaninfo(arOut);
	arOut.Close();

	/*************************************
	 * SDIt[̐eMDINCAgEBhEɂƁAPLUSgpāuWindow
	 * \ăhbOvIĂꍇAWindow̕\ʒuɃItZbg
	 * AȂBނȂAeCEBhEɂBƃt@
	 * CǍ݂Ȃǂ̃_CAOJƂACEBhĚ։B悤
	 * ɂȂB̓_CAOɏo߂ɂ̂悤ɃR[fBOB

	// MDINCAgEBhE̎擾
	CFrameWnd *pFrame=GetParentFrame(); // ̃r[̐et[
	ASSERT(pFrame->IsKindOf(RUNTIME_CLASS(CChildFrame))); // CChildFrame̔
	CWnd *pClientWnd=pFrame->GetParent(); // MDICLIENT Window
	// SDIhLgt[̍쐬
	CWinSDJDoc *pDoc=theApp.m_pSDocTemplate->OpenDocumentFile(NULL,TRUE,pClientWnd);
	***********************************/

	// SDIhLgt[̍쐬
	CWinSDJSDoc *pDoc = (CWinSDJSDoc *)theApp.m_pSDocTemplate->OpenDocumentFile(NULL);

	File.Seek(0L,CFile::begin);				// t@C擪Seek
	CSDJArchive arIn(&File,CArchive::load);
	pDoc->ReadBaninfo(arIn);				// SDI hLgɏǖʂ[h
	arIn.Close();
	pDoc->SetTitle(pDocument->GetTitle());	// ^Cg

	// SDĨt[EBhE̐et[EBhẼr[ɐݒ肷B
	// SDI t[EBhE
	CSFrameWnd *pSFrameWnd=(CSFrameWnd *)theApp.m_pSDocTemplate->GetFrameWnd();
	// ̃r[SDĨt[EBhEɃNB
	pSFrameWnd->SetSdjParent(this);
	pSFrameWnd->SetParentType(0);			// e͑΋ǃhLg

	// SDIt[EBhẼr[̎qEBhEƂċLB
	SetSFrame(pSFrameWnd);
}

// ΋ǂcaEI
void CWinSDJView::OnUpdateMenuSelectbox(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(dbex()||theApp.m_bMateDbcUsing);
}

// ΋ǂcǎEI
void CWinSDJView::OnMenuSelectbox() 
{
	// ΋ǂcaEI_CAO{bNX
	// m_pSelectBoxBւSelectBoxB InitDialogœo^ɍs
	// ȂDbeView쐬ƃoX
	CWaitCursor waitcr;								// v
	CSelectBoxB *pSelectBoxB = new CSelectBoxB;		// [hX_CAO{bNX
	pSelectBoxB->SetSDJDocument(GetDocument());		// Kꂪ
	pSelectBoxB->Create(IDD_SelectBoxB,this);
	pSelectBoxB->ShowWindow(SW_SHOWNORMAL);
}

// ̃r[jƂɁA_CAOJĂ炱jB
void CWinSDJView::OnDestroy() 
{
	CSDJView::OnDestroy();

	// EI{bNXgpȂ炱IB
	if (theApp.m_pSelectBoxB && theApp.m_bSelectBoxBUsing) {
		if (theApp.m_pSelectBoxB->GetSDJDocument()==GetDocument())
			theApp.m_pSelectBoxB->SendMessage(WM_CLOSE);
	}
}

/////
// CSAt@Ĉcao^j[
void CWinSDJView::OnUpdateMenuInCsa(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(dbex());
}
void CWinSDJView::OnMenuInCsa() 
{
	CDlgInCsa DlgInCsa; // t@CIj[_CAO
	DlgInCsa.DoModal();
}


/////
// ΋ǊCSAt@Cւ̏o̓j[
void CWinSDJView::OnUpdateMenuOutCsa(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(dbex());
}
void CWinSDJView::OnMenuOutCSA() 
{
	CDlgOutCsa DlgOutCsa;
	DlgOutCsa.DoModal();
}



//////
/// ΋ǂ̓o^
void CWinSDJView::OnUpdateMenuBuftoDbb(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(dbex());
}
void CWinSDJView::OnMenuBuftoDBB() 
{
	CWinSDJDoc *pDoc=GetDocument();

	CBuftoDBB BuftoDBB;   // ΋ǂ̓o^_CAO{bNX
	BuftoDBB.m_pDoc=pDoc; // ΋DB̐ݒ

	BuftoDBB.DoModal();
}


///////
// ΋ǌo̕ҏW
void CWinSDJView::OnMenuMidasi() 
{
	CWinSDJDoc *pDoc=GetDocument();
	CDlgMidasi DlgMidasi;
	DlgMidasi.SetDoc(pDoc);
	DlgMidasi.DoModal();
}


/////////
// ΋Ǌ폜
void CWinSDJView::OnUpdateMenuDelDbb(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(dbex());
}
void CWinSDJView::OnMenuDelDbb() 
{
	CDlgDelDbb DlgDelDbb;
	DlgDelDbb.DoModal();
}



//////
// CSAt@C̑IEǍ
void CWinSDJView::OnSelectCsafile() 
{
	CSelectCsa SelectCsa;
	SelectCsa.SetDoc(GetDocument());
	SelectCsa.DoModal();
}

//////
// ǖʂ̃Nbv{[ho
void CWinSDJView::OnMenuClipout1() 
{
	CWinSDJDoc *pDoc=GetDocument();
	// ݂̋ǖʂ𕶎Ŏ擾B
	CString Aspect;
	pDoc->OutputAspectStd(Aspect,TRUE);		// 薼t

	// O[oAP[gĂփRs[B
	int len=Aspect.GetLength();
	HANDLE hMem=GlobalAlloc(GMEM_MOVEABLE,len+1);
	if (hMem==NULL)
		return;
	char *cp=(char *)GlobalLock(hMem);
	strcpy(cp,Aspect);
	GlobalUnlock(hMem);
	// O[oNbv{[h֏o͂B
	if (!OpenClipboard()) {
		GlobalFree(hMem);
		return ;							// Nbv{[hI[vs
	}
	::EmptyClipboard();						// Nbv{[h󂷂B
	::SetClipboardData(CF_OEMTEXT,hMem);	// Nbv{[hɏo
	::CloseClipboard();						// Nbv{[hB
}

///////
// ΋ǂ̃Nbv{[ho
void CWinSDJView::OnMenuClipout2() 
{
	CWinSDJDoc *pDoc=GetDocument();
	// ݂̋ǖʂ𕶎Ŏ擾B
	CString str;
	pDoc->OutputKifStd(str);
	// O[oAP[gĂփRs[B
	int len=str.GetLength();
	HANDLE hMem=GlobalAlloc(GMEM_MOVEABLE,len+1);
	if (hMem==NULL)
		return;
	char *cp=(char *)GlobalLock(hMem);
	strcpy(cp,str);
	GlobalUnlock(hMem);
	// O[oNbv{[h֏o͂B
	if (!OpenClipboard()) {
		GlobalFree(hMem);
		return ;							// Nbv{[hI[vs
	}
	::EmptyClipboard();						// Nbv{[h󂷂B
	::SetClipboardData(CF_OEMTEXT,hMem);	// Nbv{[hɏo
	::CloseClipboard();						// Nbv{[hB
}

/////////
// ΋ǂ̃Nbv{[ho(CSA`)
void CWinSDJView::OnMenuClipout3() 
{
	CWinSDJDoc *pDoc=GetDocument();

	// ݂̋ǖʂ𕶎Ŏ擾B
	CString str;
	pDoc->OutputKifCsa(str);

	// O[oAP[gĂփRs[B
	int len=str.GetLength();
	HANDLE hMem=GlobalAlloc(GMEM_MOVEABLE,len+1);
	if (hMem==NULL)
		return;
	char *cp=(char *)GlobalLock(hMem);
	strcpy(cp,str);
	GlobalUnlock(hMem);

	// O[oNbv{[h֏o͂B
	if (!OpenClipboard()) {
		GlobalFree(hMem);
		return ;							// Nbv{[hI[vs
	}
	::EmptyClipboard();						// Nbv{[h󂷂B
	::SetClipboardData(CF_OEMTEXT,hMem);	// Nbv{[hɏo
	::CloseClipboard();						// Nbv{[hB
}


//////
/// y[Ẅ
void CWinSDJView::PagePrint(CDC *pDC,CPrintInfo *pInfo)
{
	CPrintObject *pPObj=(CPrintObject *)pInfo->m_lpUserData;
	int dn;
	int ix=PageCalc(pInfo->m_nCurPage,pDC,pInfo,&dn);
	CString strKif=&pPObj->kif[ix];						// 舵(Ɨp)
	char *kif=strKif.GetBuffer(strKif.GetLength()+1);	// ̓WJ
	int PageHeight=pInfo->m_rectDraw.Height();			// y[W(_P)
	if (PageHeight<0) PageHeight=-PageHeight;
	// 󎚊Jnʒu
	int y=-150;
	int x=150;
	// wo͒ۂ
	BOOL bDan=FALSE;
	// ^Cg\ۂ
	BOOL bTTL=FALSE;

	// õtHg
	LOGFONT lfFont;
	int fh;
	CFont *pOldFont=pDC->SelectObject(&pPObj->nf);				// tHgI(10pt)
	pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);				// tHg
	fh=lfFont.lfHeight;											// tHg̍
	char *cp=strtok(kif,"\r\n");
	while (cp) {
		CString str;
		if (strncmp(cp,"====================",20)==0) {
			// JnQd
			pDC->MoveTo(x,y); pDC->LineTo(x+1700,y); y-=5;
			pDC->MoveTo(x,y); pDC->LineTo(x+1700,y);
			y-=fh/2;											// 󎚊Jnʒu
			bDan=FALSE;
			bTTL=TRUE;
		} else if (strncmp(cp,"Jnǖ: ------",16)==0) {
			pDC->SelectObject(&pPObj->nf);						// tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			str="Jnǖ:";
			y-=fh; // s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*11,y-fh/2);
			pDC->LineTo(x+fh/2*11+700,y-fh/2);
			y-=fh;
			// Տ PSsǂݎ̂ĂB
			for (int i=0;i<14;i++)	strtok(NULL,"\r\n");
			PrintBan(pDC,pInfo,x,&y);							// Ֆʂ̈
			bDan=FALSE;
		} else if (strncmp(cp,"΋ǒ: ------",16)==0) {
			pDC->SelectObject(&pPObj->nf);						// tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			str="΋ǒ:";
			y-=fh;												// s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*11,y-fh/2);
			pDC->LineTo(x+fh/2*11+700,y-fh/2);
			y-=fh;												// s
			bDan=FALSE;
		} else if (strncmp(cp,"w: ------",14)==0) {
			dn=-1;												// igJE^(w^Cĝ-1)
			pDC->SelectObject(&pPObj->nf);						// tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			str="w:";
			y-=fh;												// s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*9,y-fh/2);
			pDC->LineTo(x+fh/2*9+700,y-fh/2);
			y-=fh;												// s
			bDan=TRUE;
		} else if (strncmp(cp,"w蒍: ------",16)==0) {
			pDC->SelectObject(&pPObj->nf);						// tHgI
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			str="w蒍:";
			y-=fh;												// s
			pDC->TextOut(x,y,str);
			pDC->MoveTo(x+fh/2*11,y-fh/2);
			pDC->LineTo(x+fh/2*11+700,y-fh/2);
			y-=fh;												// s
			bDan=FALSE;
		} else {
			str=cp;
			if (bTTL) {											// ^Cg(΋ǔԍ,o^)
				bTTL=FALSE;
				pDC->TextOut(x+800,y,str);
				y-=fh;											// s
				pDC->SelectObject(&pPObj->nf12);				// tHgI
				pPObj->nf12.GetObject(sizeof(LOGFONT),&lfFont);
				fh=lfFont.lfHeight;								// tHg̍
			} else {
				pDC->TextOut(x,y,str);
				y-=fh;											// s
			}
			if (bDan) {											// wo͒(ig)
				dn++;
				if (dn==10) {
					y-=fh;
					dn=0;
				}
			}
		}
		cp=strtok(NULL,"\r\n");
		int ht=(y<0)? -y:y;
		if (ht > PageHeight-100)
			break;
	}
	pDC->SelectObject(pOldFont);								// tHgɖ߂
	strKif.ReleaseBuffer();
}

///////
/// y[WvZ
///   iPagey[WƂ obt@Jnʒu(ix)߂lɕԂB
//    ̎̒igJE^ldnpɕԂB
//    I[o[y[Ww肵
//    ߂lɂ̓obt@̕(strKif.GetLength())ԂB
//    y[W(PageHeight)=0(ftHg)wȂŒpInfovZB
//    (ӁIĨASYPagePrint()Ƒ΂ɂȂĂB)
int CWinSDJView::PageCalc(int iPage,CDC *pDC,CPrintInfo *pInfo,int *dnp,int PageHeight)
{
	CPrintObject *pPObj=(CPrintObject *)pInfo->m_lpUserData;
	*dnp=0;
	int ix=0;
	int n_page=1;
	CString strKif=pPObj->strKif;								// 舵(Ɨp)
	char *kif=strKif.GetBuffer(strKif.GetLength()+1);			// ̓WJ
	if (PageHeight==0) {
		PageHeight=pInfo->m_rectDraw.Height();					// y[W(_P)
		if (PageHeight<0) PageHeight=-PageHeight;
	}

	// 󎚊Jnʒu
	int y=-150;
	// wo͒ۂ
	BOOL bDan=FALSE;
	// ^Cg\ۂ
	BOOL bTTL=FALSE;

	// õtHg
	LOGFONT lfFont;
	int fh;
	pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
	fh=lfFont.lfHeight;											// tHg̍
	char *cp=strtok(kif,"\r\n");
	while (cp) {
		if (n_page == iPage)
			break;
		if (strncmp(cp,"====================",20)==0) {
			// JnQd
			y-=5;
			y-=fh/2;											// 󎚊Jnʒu
			bDan=FALSE;
			bTTL=TRUE;
		} else if (strncmp(cp,"Jnǖ: ------",16)==0) {
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			y-=fh;												// s
			y-=fh;												// s
			// Տ PSsǂݎ̂ĂB
			for (int i=0;i<14;i++)	strtok(NULL,"\r\n");
			PrintBan(pDC,pInfo,0,&y,TRUE); 
			bDan=FALSE;
		} else if (strncmp(cp,"΋ǒ: ------",16)==0) {
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			y-=fh;												// s
			y-=fh;												// s
			bDan=FALSE;
		} else if (strncmp(cp,"w: ------",14)==0) {
			*dnp=-1;											// igJE^(w^Cĝ-1)
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			y-=fh;												// s
			y-=fh;												// s
			bDan=TRUE;
		} else if (strncmp(cp,"w蒍: ------",16)==0) {
			pPObj->nf.GetObject(sizeof(LOGFONT),&lfFont);
			fh=lfFont.lfHeight;									// tHg̍
			y-=fh;												// s
			y-=fh;												// s
			bDan=FALSE;
		} else {
			if (bTTL) {											// ^Cg
				bTTL=FALSE;
				y-=fh;											// s
				pPObj->nf12.GetObject(sizeof(LOGFONT),&lfFont);
				fh=lfFont.lfHeight;								// tHg̍
			} else {
				y-=fh;											// s
			}
			if (bDan) {											// wo͒(ig)
				(*dnp)++;
				if (*dnp==10) {
					y-=fh;
					*dnp=0;
				}
			}
		}
		cp=strtok(NULL,"\r\n");
		int ht=(y<0)? -y:y;
		if (ht > PageHeight-100) {
			n_page++;
			y=-150;												// y[W
		}
	}
	if (cp)
		ix=(int)(cp-kif);
	else
		ix=pPObj->strKif.GetLength();
	strKif.ReleaseBuffer();

	return ix;
}


/////////
// `؊̓Ǎ
void CWinSDJView::OnReadKKF() 
{
	CWinSDJDoc* pDoc = GetDocument();

	// hLg̕ύXΕۑ̗L₢킹ĕKvΕۑ
	if (!pDoc->SaveModified()) 
		return ;												// hLgۑ~

	// ȉ̓hLgN[YĂ悢ꍇ

	CString strKKF="*.kif";										// ftHg̃t@C(tB^̖ڂ)
	CFileDialog dlgKKF(TRUE,									// Ǎ
		"kif",													// ftHggq
		strKKF,													// ftHgKKFt@C
		(DWORD)(OFN_HIDEREADONLY | OFN_FILEMUSTEXIST),			// 
		"KIFt@C (*.kif)|*.kif||");

	BOOL bResult = dlgKKF.DoModal();							// _CAOI[v

	if (bResult != IDOK)
		return;													// I𒆎~

	strKKF = dlgKKF.GetPathName();								// `؃t@C

	// `؊t@C̃I[v
	CFile KKFile;
	if (!KKFile.Open(strKKF,CFile::modeRead | CFile::shareDenyWrite)) {
		CString mes;
		mes.Format("t@C %s I[vł܂B",strKKF);
		AfxMessageBox(mes);
		return ;
	}
	CSDJArchive arkkf(&KKFile,CArchive::load);					// `؃A[JCo

	// CSAt@C
	CWinMemFile MFile;
	CSDJArchive arcsa(&MFile,CArchive::store);					// CSAA[JCo

	// `؊ǂݍCSA`ɕϊB
	CK2Csa K2Csa;
	K2Csa.KtoCsa(arkkf,arcsa);

	// FileName  XXXX.kif
	CString strKKFname=KKFile.GetFileName();

	// t@C,A[JCõN[Y
	arkkf.Close();
	KKFile.Close();
	arcsa.Close();

	// CSAt@C̓o
	MFile.Seek(0L,CFile::begin);								// CSAt@C擪ʒuSeek

	// CSAǍ݃A[JCo
	CSDJArchive inar(&MFile,CArchive::load);

	// ߃{bNXJĂ
	SendMessage(WM_COMMAND,ID_DLG_CMNTBOX_CLOSE);

	// hLgɃR[hǂݍ
	pDoc->DeleteContents();										// hLgZbg
	// R[hǍ(\obt@BDSPŃZbg)
	pDoc->Serialize(inar); 
	pDoc->SetModifiedFlag(FALSE);

	// hLg^CgXXXXX.kifXXXXXɂB
	CString strTitle=strKKFname;
	int n=strTitle.GetLength();
	char *cp=strTitle.GetBuffer(n+1);
	*(cp+n-4)='\0'; // gq".kif"
	strTitle.ReleaseBuffer();
	pDoc->SetTitle(strTitle);
	pDoc->SetDiskPathName("");									// fBXNpXZbg
	

	// r[̕\XV
	pDoc->AdjustSpriteList();
	if (GetGuideFrame()!=NULL)									// ǖʕ\JĂ
		GetGuideFrame()->Invalidate();
	if (GetSubFrame()!=NULL)									// TuEBhEJĂ
		GetSubFrame()->Invalidate();
	Invalidate();												// \XV

	// ՑJĂeXV
	if (theApp.m_bDbeUsing) {
		CDbeFrame *pDbeFrame=GetDbeFrame();
		if (pDbeFrame) {										// ̃r[ՑĂ
			CDbeView *pDbeView=(CDbeView *)pDbeFrame->GetActiveView();
			pDbeView->SendMessage(WM_COMMAND,ID_DBE_REINITROOT);
		}
	}

	// JĂe
	if (m_pKifFrame) {
		m_pKifFrame->SetWindowText(strTitle);					// ̃^Cg
		m_pKifFrame->SendMessage(WM_COMMAND,ID_KIFFRAME_INIT);
	}

	// CSAǍ݃A[JCõN[Y
	inar.Close();
}

// ϊ
void CWinSDJView::OnZaRotation() 
{
	CSDJView::ZaRotation();
	Invalidate();												// ĕ\
}
