// KBase.h header file
//
// CKBase class

#ifndef __CKBASE__
#define __CKBASE__

#include "mbase.h"
#include "sdjarchive.h"

class CKmSprite;
class CKmBoard;
class CKmListBox;
class CSDJView;
class CKBase : public CMBase
{
	DECLARE_SERIAL(CKBase)
public:
	virtual void CopyAspect(SBASE *psrc);
	// RXgN^
	CKBase();
	~CKBase();
	// IuWFNg̍\z
	void Create(CKmSprite KmSprite[40], CKmBoard *pBoard, CKmListBox KmListBox[3]);
	// ϊ
	void ZaRotation(void);
	// ̎擾
	int GetZa(void){ return Za;}
	// ̐ݒ(ʏ͎gȂ:ZaRotation()p)
	void SetZa(int za){Za=za;};
	// AՁA̎擾
	CKmSprite *GetKmSprite(void){return m_pKmSprite;}
	CKmBoard *GetBoard(void){return m_pKmBoard;}
	CKmListBox *GetListBox(void){return m_pKmListBox;}
	// View̎擾
	CSDJView *GetView(void){return m_pView;}
	// View̐ݒ
	void SetView(CSDJView *pView){ m_pView=pView;}

	void Serialize(CSDJArchive& ar,BOOL bLine);
	virtual void Serialize(CArchive& ar);
protected:
	int Za;
	CKmSprite  *m_pKmSprite;
	CKmBoard   *m_pKmBoard;
	CKmListBox *m_pKmListBox;
	CSDJView   *m_pView;
};
#endif // __CKBASE__
