/**********************/
/*    kmsprite.cpp    */
/**********************/
#include "stdafx.h"
#include "kmsprite.h"
#include "winsdj.h"
#include "sdjview.h"
#include "kmlistbox.h"
#include <sbase.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

// O[o
extern CWinSDJApp theApp;

// EXghc̎擾
static int LBoxID(int ky, int kt, int za) { return (kt==2)? kt: ky^za;}

/////////////////////////////////////////////////////////////////////////////
// CKmSprite

IMPLEMENT_SERIAL(CKmSprite, PIECE, 0 /* Schema number */ )

CKmSprite::CKmSprite()
{
	// 0ƂĂƂ肠BSBASEɓo^ƂɍĐݒB
    // l͋
    m_Kif.pos2kif(getpos(),0);
	m_km = getcode();
	m_nr = getprom();
	m_sg = getside();
}

CKmSprite::~CKmSprite()
{
}

/////////////////////////////////////////////////////////////////////////////
// CKmSprite serialization
void CKmSprite::Serialize(CArchive& ar)
{
    if (ar.IsStoring()) {
        ar << (DWORD) m_Kif.kx;
        ar << (DWORD) m_Kif.ky;
        ar << (DWORD) m_Kif.kt;
        ar << (DWORD) m_sg;
        ar << (DWORD) m_km;
        ar << (DWORD) m_nr;
    } else {
        DWORD dw;
        ar >> dw; m_Kif.kx = (int) dw;
        ar >> dw; m_Kif.ky = (int) dw;
        ar >> dw; m_Kif.kt = (int) dw;
        ar >> dw; m_sg = (int) dw;
        ar >> dw; m_km = (int) dw;
        ar >> dw; m_nr = (int) dw;
    }
}

/////////////////////////////////////////////////////////////////////////////
// CKmSprite commands

// W̐ݒ
//   XvCg̊W(kx,ky,kt)w肳ꂽlɐݒ肷B
//   bSmothTRUEȂ猻݂̈ʒuAjړB
//   bChangeTRUEȂ\XV̒ʒms
#define SMOTH_CTR	5	/* ړ */
void CKmSprite::SetKmPosA(CKif Kif,int bSmoth,int bChange)
{
	int gx1,gy1,gx2,gy2,dx,dy;
	int i;

	ASSERT(m_Kif.kt>=0);
	if (m_Kif.kt>0) { // ̈ړ̎ E폜
		ASSERT(GetListBox());
		// 䂩폜B쎞͕\Bmodifeid 97.12.27.
		// ʒuXV͂{B98.1.24
		KmListBoxRemove(TRUE,bChange); 
		if (bSmoth) {
			GetView()->RenderAndDrawDirtyList();
		}
	}
	else if (m_Kif.kt==0) {  // Տォړ̎
		ASSERT(GetBoard());
		if (GetBoard()->GetSprite(m_Kif)==this) // ȊŐȂȂ
			GetBoard()->SetSprite(m_Kif,NULL); // ړNULLZbg
	}


	// ړÏʒu(gx2,gy2)vZB
	Kif.grhxy(GetSpoint(Kif),&gx2,&gy2);
	if (bSmoth) {
		// ݂̈ʒu(gx1,gy1)擾B
		gx1=GetX(); gy1=GetY();
		// (gx1,gx1)(gx2,gy2)܂ŃAjړ
		SetZ(10); // Z
		dx=(gx2-gx1)/SMOTH_CTR;if (dx==0) dx=1;
		dy=(gy2-gy1)/SMOTH_CTR;if (dy==0) dy=1;
		for (i=0;i<SMOTH_CTR-1;i++) {
			if (((gx1-gx2)*(gx1-gx2) <= 1600) &&
				((gy1-gy2)*(gy1-gy2) <= 1600)) { // Pȉ̋ߖTŏI
				break;
			}
			gx1+=dx;gy1+=dy;
			SetPosition(gx1,gy1); // ړ̕\
			GetView()->RenderAndDrawDirtyList();
			Sleep(20); // ړԊԊu 20msec
		}
		SetPosition(gx2,gy2); // GUIʒu̐ݒ
		SetZ(50); // Z
		GetView()->RenderAndDrawDirtyList(); // `
	}
	else {
		SetPosition(gx2,gy2,bChange); // ړ\ (RenderAndDrawDirtyList()͕ʓrKv)
		if (GetZ()!=50)
			SetZ(50,bChange); // Z
	}

	// ړ̕\XVB
	ASSERT(Kif.kt>=0);
	if (Kif.kt > 0) { // Eւ̈ړ̎ EɒǉB
		KmListBoxInsert(Kif,TRUE,bChange); // \(AddDirtyRegion)
		if (bSmoth) {
			GetView()->RenderAndDrawDirtyList();
		}
	}
	else if (Kif.kt==0) { // Տւ̋ړ̎
		ASSERT(GetBoard());
		CKmSprite *pKmSprite=GetBoard()->GetSprite(Kif);
		if (pKmSprite!=NULL && pKmSprite->GetSg()!=GetSg()) { // Տɋt̋
			CKif Kif2(0,(int)!pKmSprite->GetSg(),1);
			pKmSprite->SetKmPosA(Kif2,bSmoth,bChange); // (\̂)
		}
		GetBoard()->SetSprite(Kif,this); // Տ̂̈ʒuɎu
	}
	m_Kif=Kif;
}

void CKmSprite::SetKmPosA(int kx,int ky,int kt,int bSmoth)
{
	CKif Kif(kx,ky,kt);
	SetKmPosA(Kif,bSmoth);
}

void CKmSprite::SetKmPos(CKif Kif,int bSmoth)
{
	int pos1=m_Kif.kif2pos(GetZa()); // W
	int pos2=Kif.kif2pos(GetZa());   // VW

	SetKmPosA(Kif,bSmoth); // ړ\(\W͍XV)

	// VW̐ݒ
	if (pos1!=pos2) // ʒu̍XV
		PIECE::move(pos2,m_nr,(GetZa()==0) ? m_sg: !m_sg);
}

void CKmSprite::SetKmPos(int kx,int ky,int kt,int bSmoth)
{
	CKif Kif(kx,ky,kt);
	SetKmPos(Kif,bSmoth);
}

/////
//  SBASEʋ֐
// Eto_֓āAprom=Ȃ1 Ȃ=0 ωȂ=-1
// Eto_͔Տ̂ǂA邢SIDE_A/SIDE_B()/ON_BOX
// EՏto_Ɋɋ΁A̋͂̃CX^X(side
//   ̎w肪΂̑j̎Ƃċɏ
// Eto_Ɏgꍇ͐ݒύXłƂċɂ͍sȂ
// Eside-1Ȃ炻̋̌͌̂܂܁AύXȂSIDE_A/SIDE_B
// @Ɩ
// Return: 0=s\iǖʂ͂̂܂܁j1=삳
// P) to,sideSBASEW(΍W)\
// Qjmove(),move2()PIECEŐ錾鉼z֐łBSBASEmove(),
//       move2()ďoBCKmSprite::move(),move2()͒ڎgpȂB
//       ̏ꍇ͑CKmSprite::SetKmPos()gpB
int CKmSprite::move(int to, int prom, int side)
{
	CKif Kif(to,GetZa());	// Wϊ
	SetKmPosA(Kif,TRUE);	// ړ\(\ʒu͍XV)
	
	if (Kif.kt==0) { // Տ̂
		int nr,sg;
		(prom==-1)? nr=m_nr:nr=prom;
		(side==-1)? sg=m_sg:sg=side^GetZa();
		if (nr!=m_nr || sg!=m_sg) // \Eɕω
			SetKmStatus(sg,m_km,nr);
	}

	RenderAndDraw(); // ʕ\

	return PIECE::move(to,prom,side);
}
int CKmSprite::move2(int to, int prom, int side)
{
	CKif Kif(to,GetZa());	// Wϊ
	SetKmPosA(Kif,FALSE,FALSE);	// ړ\(\ʒu͍XV)
	
	if (Kif.kt==0) { // Տ̂
		int nr,sg;
		(prom==-1)? nr=m_nr:nr=prom;
		(side==-1)? sg=m_sg:sg=side^GetZa();
		if (nr!=m_nr || sg!=m_sg) // \Eɕω
			SetKmStatus(sg,m_km,nr);
	}

	return PIECE::move2(to,prom,side);
}

// ̐ݒ
//    sg:(0/1)
//    km:(:0 :1 p:2 :3 :4 j:5 :6 :7)
//    nr:\(0/1)
void CKmSprite::SetKmStatus(int sg, int km, int nr)
{
	CDIB *pDIB;

	pDIB=&theApp.m_KomaDIB[sg][km][nr];	// tHgDIB
	// tHgDIBCDIBƂĎw肷B
	Create((BITMAPINFO *)pDIB->GetBitmapInfoAddress(),
		(BYTE*)pDIB->GetBitsAddress());
	Initialize(); // XvCg̓F̐ݒ蓙

	// ̐ݒ
	m_sg=sg;
	m_km=km;
	m_nr=nr;
}
// PIECE ̐ݒ
void CKmSprite::SetPieceStatus(void)
{
	int pos=m_Kif.kif2pos(GetZa()); // ̍W
	
	// VW̐ݒ
	PIECE::move(pos,m_nr,(GetZa()==0) ? m_sg: !m_sg);
}

// EXg̍폜
void CKmSprite::KmListBoxRemove(BOOL bSort,BOOL bDisp)
{
	ASSERT(GetListBox());
	if (m_Kif.kt > 0)
		(GetListBox()+LBoxID(m_Kif.ky,m_Kif.kt,GetZa()))->Remove(this,bSort,bDisp);
}
// EXgւ̑}
void CKmSprite::KmListBoxInsert(CKif &Kif,BOOL bSort,BOOL bDisp)
{
	ASSERT(GetListBox());
	if (Kif.kt > 0)
		(GetListBox()+LBoxID(Kif.ky,Kif.kt,GetZa()))->Insert(this,bSort,bDisp);
}

// _(Spoint)Ԃ
CPoint CKmSprite::GetSpoint(CKif Kif)
{
	ASSERT(GetListBox());
	CPoint Spoint(Banx1,Bany1);
	if (Kif.kt==0)
		return Spoint;
	else
		return (GetListBox()+LBoxID(Kif.ky,Kif.kt,GetZa()))->GetSpoint();
}
// _(Spoint)Ԃ
CPoint CKmSprite::GetSpoint()
{
	return GetSpoint(m_Kif);
}

// ̕\XV
void CKmSprite::RenderAndDraw(void)
{
	AddRegion();
	GetView()->RenderAndDrawDirtyList();	// r[̕\XV
}
//̕\XVXgւ̒ǉ
void CKmSprite::AddRegion(void)
{
	CRect rect;
	GetRect(&rect);						// ̕\̈
	GetView()->AddDirtyRegion(&rect);	// r[̍XV̈惊Xgɒǉ
}

//  ]
//   KBaseĂ΂
void CKmSprite::ZaRotation(void)
{
	m_Kif.cnvZa(1); // Wϊ
	if (m_Kif.kt!=2) { // łȂ΋𔽓]
		SetKmStatus(!m_sg,m_km,m_nr);
	}
}


// Set a new x,y position.
void CKmSprite::SetPosition(int x, int y,BOOL bChange)
{
    // Save the current position.
    CRect rcOld;
    GetRect(&rcOld);
    // Move to new position.
    m_x = x;
    m_y = y;

	if (bChange) {
		CRect rcNew;
		GetRect(&rcNew);
		// Notify that we have moved from our old position to
		// our new position.
		if (m_pNotifyObj) {
			m_pNotifyObj->Change(this, 
				CSpriteNotifyObj::POSITION,
				&rcOld,
				&rcNew);
		}
	}
}

// Set a new Z-order.
void CKmSprite::SetZ(int z,BOOL bChange)
{
    if (m_z != z) {
        m_z = z;
        // See if we have to notify anyone.
		if (bChange) {
			if (m_pNotifyObj) {
				CRect rc;
				GetRect(&rc);
				m_pNotifyObj->Change(this,
					CSpriteNotifyObj::ZORDER,
					&rc);
			}
		}
		else {
			if (m_pNotifyObj) {
				m_pNotifyObj->Reorder(this);
			}
		}
    }
}
