/*=====================================================================
    <f[^x[X(RSDB) [eBeBvO>

         f[^x[X̏󋵕\vO   Version 1.0

                        Copyright (C)  1994.6
                               by Ra

     p@: dbstat [table_name1,table_name2,...]

     @\: RSDBf[^x[X̕\̏󋵂\B

     table_name:
         pX܂߂ĕ\w肷BChJ[hw\B
         ȗ̓JgfBNgɂSĂ̕\ΏۂƂȂB
     o
      @ ʂ͕Wo͂ɏo͂B
     s
      @ IȂ 0AُIȂ@0ȊOŏIB
<>
  Version 1.0   1994.6   by Ra  
  Version 1.1   1995.8   by Ra  %\̏C
  Version 1.2   1996.3   by Ra  MSVC++4.0ΉBwild card etc.
  Version 1.3   1997.5   by Ra  SCM`FbN̕sC(scm_tchk)
  Version 1.31   1997.5            Bug fixed & For UNIX 
========================================================================*/
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <sdb.h>
#include <fcntl.h>
#ifdef OS_IS_MSDOS
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>
#include <dos.h>
#else
#include <sys/types.h>
#include <sys/stat.h>
#endif

#ifndef MSC7
#define _filelength filelength
#define _find_t find_t
#endif
extern void *memalloc(unsigned int);
extern void memfree(void *);


typedef struct {
    int dup;                    /* dtO s(0) (1) */
    int xlen;                   /* R[h */
    long xfs;                   /* t@CTCY */
} X_INFO;

typedef struct {
    long reclen;                /* R[h */
    long recnum;                /* R[h */
    long dfs;                   /* f[^TCY */
    int  xnum;                  /*  */
    X_INFO x_info[IXITEMNUM];   /*  */
    long fs_sum;                /* t@CTCYv */
} T_INFO;

/* Tu[`̌^錾 */
static void Usage(void);
static void display_header(void);
static void display_footer(long l);
static int display_table(char *table);
static long disp_stable(char *pname,char *tname);
static int split_path(const char* szFullPath, char* szDir, char* szName);
static int scm_tchk(SCM_t *scm);
static SCM_t *scm_alloc(int k,int x);
static void scm_free(SCM_t *scm);
static SCM_t *get_scm(char *dname);
static int GetScmInfo(T_INFO *tip,char *pname);
static int GetFileInfo(T_INFO *tip,char *pname);
static long CountBitmap(unsigned char *bitmap,unsigned int leng);
static char *scmptr(char *cp);
static void ltoa_k(long l,char *np);



/* vO */
static char *program="DBSTAT";

/* t@CTCYv */
static long total_sum;

/* MAIN ֐ */
void main(int ac,char **av)
{
    int rc,i;

    if (ac > 1 && strcmp(av[1],"-h")==0) {
        Usage();
        rc=0;goto exit;
    }

    /* display header */
    display_header();

    /* display table */
    if (ac > 1) {
        for (i=1;i<ac;i++)
            if ((rc=display_table(av[i]))!=0) goto exit;
    }
    else {
        if ((rc=display_table("*"))!=0) goto exit;
    }

    /* display footer */
    display_footer(total_sum);

  exit:
    exit(rc);
}

/* Display Usage */
static void Usage()
{
#ifdef MSVC32
printf("DBSTAT32 Version 1.31 for RSDB Version 1.32\n\n");
#else
printf("DBSTAT Version 1.31 for RSDB Version 1.32\n\n");
#endif
printf("  DBSTAT [table_name1,table_name2,...]\n\n");
printf("  table_name̓pX܂ށBChJ[hw\B\n");
}



/* display header */
static void display_header(void)
{
   printf(
   "\     R[h  R[h(gp%)  t@CTCY   \vTCY\n"
          );
}
/* display footer */
static void display_footer(long l)
{
    char dbuf[80];

    ltoa_k(l,dbuf);
    printf(
   "                                                      v %+11s\n",
           dbuf
          );
}
/* display table */
static char pname[256];         /* XL[}t@CtpXi[ */
static char scm_file[256];      /* XL[}t@C */
static char tbl_name[256];      /* \ */
static int display_table(char *table)
{
    int rc=1;
#ifdef OS_IS_MSDOS
#ifdef MSVC32
    struct _finddata_t ft;
    long hFile;
#else
    struct _find_t ft;
#endif
#else
    char fname[512];
    char cmdline[512];
    char *tmpf;
    FILE *fp;
    char *sl,*cp;
#endif
    long sum;
    int fetch=0;

    strcpy(scm_file,table);
#ifndef OS_IS_MSDOS
    if ((cp=strstr(scm_file,".scm"))!=NULL)
        *cp='\0';
#endif
    strcat(scm_file,".scm");
#ifdef OS_IS_MSDOS
#ifdef MSVC32
    if ((hFile=_findfirst(scm_file,&ft))==-1L) rc=1; /* t@C݂͑Ȃ */
    else rc=0;
#else
    rc=_dos_findfirst(scm_file,_A_NORMAL,&ft);
#endif
#else
    tmpf=tmpnam(NULL);
    sprintf(cmdline,"find . -name '%s' -print > %s",scm_file,tmpf);
    rc=system(cmdline);
    fp=fopen(tmpf,"r");
    if (fp) {
        if (fgets(pname,sizeof pname,fp)) {
            strtok(pname,"\r\n");
            rc=0;
        }
        else
            rc=1;
    }
#endif
    while (rc==0) {
#ifdef OS_IS_MSDOS
        split_path(scm_file,pname,NULL); /* t@CƃfBNg̕ */
        strcat(pname,ft.name);        /* pname=full path table name */
        strcpy(tbl_name,ft.name);
#else
        sl=strrchr(pname,'/');
        if (sl)
            strcpy(tbl_name,sl+1);
        else
            strcpy(tbl_name,pname);
#endif
        *scmptr(tbl_name)='\0';       /* remove ".scm" */
        fetch=1;                      /* ȂƂP͌B*/

        /* P\̏\ */
        if ((sum=disp_stable(pname,tbl_name)) < 0L) { rc=1;goto exit;}
        total_sum+=sum;         /* t@CTCYvZ */
#ifdef OS_IS_MSDOS
#ifdef MSVC32
        rc=_findnext(hFile,&ft);
#else        
        rc=_dos_findnext(&ft);
#endif
#else
        if (fgets(pname,sizeof pname,fp)) {
            strtok(pname,"\r\n");
            rc=0;
        }
        else
            rc=1;
#endif
    }
    if (fetch)
        rc=0;
    else
        fprintf(stderr,"Y\(%s)͌܂łB\n",scm_file);

#ifndef OS_IS_MSDOS
    unlink (tmpf);
#endif

  exit:
    return rc;
}

/* 
 * P\̏\
 *  \(tname)Ŏw肳ꂽ\̏\B
 *  pname̓XL[}t@CtpXB
 */
static T_INFO ti;               /* \ */
static char dbuf[4][80];        /* \pƃobt@ */
static long disp_stable(char *pname,char *tname)
{
    int rc=0;
    int i;
    unsigned long ul;

    /* XL[}̏擾 */
    if ((rc!=GetScmInfo(&ti,pname))!=0) goto exit;

    /* f[^t@C̎擾 */
    if ((rc!=GetFileInfo(&ti,pname))!=0) goto exit;

    /* \̕\ */
    ltoa_k(ti.reclen,dbuf[0]);  /* lJ}ϊ */
    ltoa_k(ti.recnum,dbuf[1]);
    ltoa_k(ti.dfs,dbuf[2]);
    ul=(unsigned long)ti.recnum*100L/8L*100L/65535L; /* % \ */
  
    /* f[^t@C̕\ */
    if (ul/100L < 100) 
      printf("%-8s%+9s%+14s (%2ld.%02ld%%)%+16s\n", 
	     tname,
	     dbuf[0],
	     dbuf[1],
	     ul/100L,
	     ul%100L,
	     dbuf[2]);
    else 
      printf("%-8s%+9s%+14s (%3ld.%01ld%%)%+16s\n", 
	     tname,
	     dbuf[0],
	     dbuf[1],
	     ul/100L,
	     ul%100L,
	     dbuf[2]);
    for (i=0;i<ti.xnum;i++) {                    /* t@C̕\ */
        ltoa_k((long)ti.x_info[i].xlen,dbuf[0]); /* lJ}ϊ */
        ltoa_k(ti.x_info[i].xfs,dbuf[1]);
        printf(" %d%+11s%28s%+11s\n",
               i,
               dbuf[0],
               " ",
               dbuf[1]);
    }
    ltoa_k(ti.fs_sum,dbuf[0]);
    printf("%59s%+11s\n"," ",dbuf[0]);

  exit:
    if (rc!=0)
        return -1L;
    else
        return ti.fs_sum;
}


/******************************************************
 * tpXAfBNgƃt@Cɕ
 *
 *      <<<߂l>>>
 * tpX̍\tO
 *
 *      <<<>>>
 * szFullPath ... ͑Ώۂ̃tpX
 * szDir      ... fBNgi[obt@
 * szName     ... t@Ci[obt@
 *
 * szDir, szName  NULL ̏ꍇ͌ʂi[Ȃ
 * szDir ͋󕶎ȊOȂA͕KpX؂Lł
 * pX؂LƂĂ \  / ̗󂯕t
 *************************************************************/
/* pX\vftOl(split_path()̖߂l) */
#define FN_DRIVE     0x80
#define FN_DIRECTORY 0x40
#define FN_FILENAME  0x20
static int split_path(const char* szFullPath, char* szDir, char* szName)
{
    char *pTailDir = strrchr((char *) szFullPath, '\\');
    char *pTmp     = strrchr((char *) szFullPath, '/');

    /**** Ă ****/
    int flag = 0;
    if (szDir)  *szDir  = 0;
    if (szName) *szName = 0;

    /**** hCu̐؂o ****/
    /* ?: ̓hCuB?͉łok */
    if (szFullPath[0] && szFullPath[1] == ':') {
        flag |= FN_DRIVE;
        if (szDir) {
            *szDir++ = *szFullPath++;
            *szDir++ = *szFullPath++;
        } else
            szFullPath += 2;
    }

    /**** fBNg̐؂o ****
     * fBNg͍Ōオ'\'  '/' ŏI镶ł
     */
    if (pTailDir < pTmp)
        pTailDir = pTmp; /* \  / ̈ԍŌ̈ʒu pTailDir ɓ */
    if (pTailDir) {
        /* fBNgszDirփRs[AszFullPatȟ֐i߂ */
        flag |= FN_DIRECTORY;
        if (szDir) {
            while (szFullPath <= pTailDir)
                *szDir++ = *szFullPath++;
        } else
            szFullPath = pTailDir + 1;
    }
    /** OƂ "."  ".." ŏIꍇAfBNgƌȂ **/
    if ( strcmp(szFullPath, ".") == 0 || strcmp(szFullPath, "..") == 0 ) {
        flag |= FN_DIRECTORY;
        if (szDir) {
            strcpy(szDir, szFullPath);
            strcat(szDir, "\\"); /* fBNg̋؂Lǉ */
        }
        return flag; /* path ̏IɒB̂łŏI */
    }
    if (szDir) *szDir = 0; /* I[̂Oݒ肷 */

        /**** t@C؂o ****/
    if (*szFullPath) {
        flag |= FN_FILENAME;
        if (szName)
            strcpy(szName, szFullPath);
    }
    return flag;
}

/*
*********************************
 SCM_t֘Å֐(sdbbase.cƋ)
*********************************
*/

/* 93.5.2ǉBSCM_ť``FbNB
   ߂lOKȂ0 NGȂ1 */
/* 97.5 Bug fix */
static int scm_tchk(SCM_t *scm)
{
    int i,j,rc=0;
    int mustpos;

    /* SCMHEAD̒l`FbN */
    if (SH_INUM(scm)<=0 || SH_XNUM(scm) > IXPNUM || SH_XNUM(scm) < 0) {
        rc=1;goto exit;
    }

    /* SCMITEM̃`FbN */
    for (mustpos=i=0;i<SH_INUM(scm);i++) {
        if (strlen(SIM_NAME(scm,i)) > KNAMELEN || /* ̂Kv */
            strlen(SIM_NAME(scm,i)) <=0 ||
            SIM_TYPE(scm,i) < 0 ||                /* ^0~3܂ */
            SIM_TYPE(scm,i) > 3 ||
            SIM_POS(scm,i)!=mustpos ||            /* pošvZOK */
            SIM_LEN(scm,i) <= 0 ) {               /* len͐ */

            rc=2;goto exit;
        }
        mustpos=SIM_POS(scm,i)+SIM_LEN(scm,i); /* poslvZĂ */
    }

    /* SCMIDX̃`FbN */
    for (i=0;i<SH_XNUM(scm);i++) {
        /* dup̃`FbN */
        if (scm->sxpp[i]->dup!=0 && scm->sxpp[i]->dup!=1) {
            rc=3;goto exit;
        }
        if (SIX_NUM(scm,i)<=0) {          /* ڐ͐ */
            rc=4;goto exit;
        }
        /* knõ`FbNBinumȉ̒lłǍ^eLXg(0~2) */
        /* Bug fix( SH_XNUM(scm)->SIX_NUM(scm,i) ) 1997.05 by Ra */
        for (j=0;j<SIX_NUM(scm,i);j++) {
            if (scm->sxpp[i]->kno[j] < SH_INUM(scm) &&
                scm->sxpp[i]->kno[j] >= 0 ) {
                if (SIX_TYPE(scm,i,j) < 0 ||
                    SIX_TYPE(scm,i,j) > 2 ) {
                    rc=5;goto exit;
                }
            }
            else {
                rc=6;goto exit;
            }
        }
    }
  exit:
    return rc;
}

/*
    XL[}\̂AP[gB
    ڐ(k),t@C(x)(0)B sȂNULLԂB
    {֐̓AP[ĝ݂Œl̓ZbgȂB
*/    
static SCM_t *scm_alloc(int k,int x)
{
    SCM_t *scm;
    int i,j,err=0;
    
    /* XL[}\̖{̂̃AP[g */
    scm=(SCM_t *)memalloc(sizeof(SCM_t));
    if (scm!=NULL)  {
        memset(scm,'\0',sizeof scm); /* 0NA */

        /* |C^̃AP[g */
        scm->sipp=(SCMITEM **)memalloc(k*sizeof(SCMITEM *));
        if (x!=0)
            scm->sxpp=(SCMIDX **)memalloc(x*sizeof(SCMIDX *));
        if (!(scm->sipp==NULL || (x!=0 && scm->sxpp==NULL))) {
            /* ڃf[^\̂̃AP[g */
            for (i=0;i<k;i++)   {
                scm->sipp[i]=(SCMITEM *)memalloc(sizeof(SCMITEM));
                if (scm->sipp[i]==NULL) { /* s */
                    /* ܂ŃAP[gSCMITEM̉ */
                    for (j=0;j<i;j++) memfree(scm->sipp[j]);
                    err=1;
                    break;
                }
            }
            if (err==0) {
                /* f[^\̂̃AP[g */
                for (i=0;i<x;i++)   {
                    scm->sxpp[i]=(SCMIDX *)memalloc(sizeof(SCMIDX));
                    if (scm->sxpp[i]==NULL) {   /* s */
                        /* ܂ŃAP[gSCMIDX̉ */
                        for (j=0;j<i;j++) memfree(scm->sxpp[j]);
                        err=1;
                        break;
                    }
                }
            }
        }
        else err=1;  /* |C^̃AP[gɎs */
        /* 
           |C^܂
           ڃf[^\́Af[^\̂̃AP[gɎs
         */
        if (err!=0) {
            /* ܂܂ŃAP[g */
            if (scm->sipp!=NULL) memfree(scm->sipp);
            if (scm->sxpp!=NULL) memfree(scm->sxpp);
            memfree(scm);
            scm=NULL;
        }
    }/* if (scm!=NULL) */

    return scm;
}

/*
    XL[}\̂̉
*/
static void scm_free(SCM_t *scm)
{
    int i;
    /* ڃf[^\̂̉ */
    for (i=0;i<SH_INUM(scm);i++) memfree(scm->sipp[i]);
    /* f[^\̂̉ */
    for (i=0;i<SH_XNUM(scm);i++) memfree(scm->sxpp[i]);
    /* |C^̉ */
    memfree(scm->sipp);
    if (scm->sh.xnum!=0)
        memfree(scm->sxpp);
    /* XL[}\̖{̂̉ */
    memfree(scm);
}    

/*
  XL[}t@C\̂̎擾
    XL[}t@CI[vAXL[}\̂쐬B
    DB_t *dbȊOsh,sipp,sxppZbgB
    sNULLԂBfnamescm fileB
    93.5.2 t@CTCY`FbNǉB
*/
static SCM_t *get_scm(char *fname)
{
    SCMHEAD sh;
    SCM_t *scm=NULL;
    int sfh,i,err=0;
    long fs;
    
    /* XL[}t@C̃I[v */
#ifdef OS_IS_MSDOS
    sfh=open(fname,O_RDWR | O_BINARY);
#else
    sfh=open(fname,O_RDWR);
#endif
    if (err==0 && sfh!=-1)    {
        /* XL[}wb_̓ǂ݂ */
        err=sizeof(SCMHEAD)-read(sfh,&sh,sizeof(SCMHEAD));

        /* SCMHEADlyуt@CTCỸ`FbN 93.5.2ǉ */
        if (err==0) {
            if (sh.inum <= 0 || sh.xnum > IXPNUM || sh.xnum < 0 )
                err=1;                /* SCMHEADlُ */
            else {
                /* t@CTCY`FbN */
#ifdef OS_IS_MSDOS
                fs=_filelength(sfh);
#else
                fs=lseek(sfh,0L,SEEK_END);
                lseek(sfh,(long)(sizeof(SCMHEAD)),SEEK_SET);
#endif
                if (fs!=(long)sizeof(SCMHEAD)+
                        (long)sh.inum*(long)sizeof(SCMITEM)+
                        (long)sh.xnum*(long)sizeof(SCMIDX) )
                    err=1;
            }
        }
        if (err==0) {
            /* XL[}\̂̍쐬 */
            scm=scm_alloc(sh.inum,sh.xnum); /* AP[g */
            if (scm!=NULL)  {
                /* XL[}wb_̃Zbg */
                SH_INUM(scm)=sh.inum;
                SH_XNUM(scm)=sh.xnum;
                /* ڃf[^\̂̃Zbg */
                for (i=0;i<SH_INUM(scm);i++)    {
                    err=sizeof(SCMITEM)
                            -read(sfh,scm->sipp[i],sizeof(SCMITEM));
                    if (err!=0) break;        

                }
                if (err==0) {
                    /* f[^\̂̃Zbg */
                    for (i=0;i<SH_XNUM(scm);i++)    {
                        err=sizeof(SCMIDX)
                                -read(sfh,scm->sxpp[i],sizeof(SCMIDX));
                        if (err!=0) break;
                    }
                }
            }
            else err=1;/* s */
            /* XL[}\̂̍쐬s */
            if (err!=0) {
                if (scm!=NULL)  scm_free(scm);
                scm=NULL;
            }
        }
        /* XL[}t@C̃N[Y */
        close(sfh);
    } /* if (err==0 && sfh!=-1) */

    /* 93.5.2ǉBSCM_ť``FbNB*/
    if (scm!=NULL) {
        if (scm_tchk(scm)!=0) { /* `sK */
            scm_free(scm);
            scm=NULL;
        }
    }

   return scm;
}

/****************************
 * sdbbase.c Ƃ܂ŋ 
 ****************************/



/* 
 * SCMt@C̎擾
 *   XL[}t@C(pname)̏tipɃZbgB
 */
static int GetScmInfo(T_INFO *tip,char *pname)
{
    int rc=1;
    SCM_t *scm;
    int i,j;

    if((scm=get_scm(pname))==NULL) goto exit; /* SCM_t\̂̎擾 */
    
    /* R[h̎Zo */
    tip->reclen=0L;
    for (i=0;i<SH_INUM(scm);i++)
        tip->reclen+=SIM_LEN(scm,i);

    /*  */
    tip->xnum=SH_XNUM(scm);

    /*  */
    for (i=0;i<tip->xnum;i++) {
        tip->x_info[i].dup=SIX_DUP(scm,i); /* dtO */

        /* R[h */
        tip->x_info[i].xlen=0;
        for (j=0;j<SIX_NUM(scm,i);j++)
            tip->x_info[i].xlen+=SIX_LEN(scm,i,j);
    }
    scm_free(scm);              /* SCM_t\̂̉ */

    rc=0;
  exit:
    return rc;
}


/* 
 * f[^t@C̎擾
 *   t@C̃TCY͂OԂB
 */
static unsigned char bitmap[32000];
static int GetFileInfo(T_INFO *tip,char *pname)
{
    int rc=1;
    char *fname=NULL;
    int fh;
    int i;
    BITHEAD dh;
    long l;


    if ((fname=(char *)memalloc(strlen(pname)+1))==NULL) goto exit;

    /*  */
    tip->dfs=0L;
    tip->recnum=0;
    tip->fs_sum=0L;
    for (i=0;i<tip->xnum;i++)
        tip->x_info[i].xfs=0L;

    /* f[^t@C̃Zbg */
    strcpy(fname,pname);
    strcpy(scmptr(fname),".dat"); /* f[^t@C̃Zbg */

    /* f[^t@C̃Zbg */
#ifdef OS_IS_MSDOS
    if((fh=open(fname,O_RDWR | O_BINARY))!=-1) {
#else
    if((fh=open(fname,O_RDWR))!=-1) {
#endif
#ifdef OS_IS_MSDOS
        tip->dfs=_filelength(fh);
#else
        tip->dfs=lseek(fh,0L,SEEK_END);
#endif
        tip->fs_sum+=tip->dfs;  /* vZ */
        close(fh);
    }
    else {
        rc=0;goto exit;
    }
        

    /* rbg}bvt@C̃Zbg */
    strcpy(fname,pname);
    strcpy(scmptr(fname),".bmp"); /* rbg}bvt@C̃Zbg */
#ifdef OS_IS_MSDOS
    if ((fh=open(fname,O_RDWR | O_BINARY))==-1)
#else
    if ((fh=open(fname,O_RDWR))==-1)
#endif
        goto exit;              /* bmpt@CȂُ͈̂ */
    if (sizeof dh-read(fh,&dh,sizeof dh)) {close(fh);goto exit;}

    /* f[^R[h̎Zo */
    tip->recnum=0L;
    for ( l=(long)dh.num; l>0L; l-=sizeof bitmap ) {
        if (l > sizeof bitmap) {
            if (sizeof bitmap - read(fh,bitmap,sizeof bitmap)) {
                close(fh);goto exit; /* bitmapt@C[hG[ */
            }
            tip->recnum+=CountBitmap(bitmap,sizeof bitmap);
        }
        else {
            if (l - read(fh,bitmap,(unsigned int)l)) {
                close(fh);goto exit; /* bitmapt@C[hG[ */
            }
            tip->recnum+=CountBitmap(bitmap,(unsigned int)l);
        }
    }
    close(fh);


    /* t@CTCỸZbg */
    for (i=0;i<tip->xnum;i++) {
        /* t@C */
        strcpy(fname,pname);
        *scmptr(fname)='\0';
        sprintf(fname,"%s.ix%d",fname,i);
#ifdef OS_IS_MSDOS
        if ((fh=open(fname,O_RDWR | O_BINARY))!=-1) {
#else
        if ((fh=open(fname,O_RDWR))!=-1) {
#endif
#ifdef OS_IS_MSDOS
            tip->x_info[i].xfs=_filelength(fh);
#else
            tip->x_info[i].xfs=lseek(fh,0L,SEEK_END);
#endif
            tip->fs_sum+=tip->x_info[i].xfs;    /* vZ */
                    close(fh);
        }
    }

    rc=0;
  exit:
    if (fname!=NULL)    memfree(fname);
    return rc;
}


/* bitmaplenoCg̊Ԃ1rbg𐔂 */
static long CountBitmap(unsigned char *bitmap,unsigned int len)
{
    unsigned int  ui;
    int i;
    long cnt;

    cnt=0L;
    for (ui=0;ui<len;ui++) {
        for (i=0;i<8;i++) {
            if ((bitmap[ui] & 0x80)!=0)
                cnt++;
            bitmap[ui]=bitmap[ui]<<1;
        }
    }
    return cnt;
}


/* t@Ccp̒".scm"̃|C^ԂB*/
static char *scmptr(char *cp)
{
    char *ptr;

    if ((ptr=strstr(cp,".scm"))!=NULL) goto exit;
    if ((ptr=strstr(cp,".SCM"))!=NULL) goto exit;
    ptr=cp+(strlen(cp)-4);
  exit:
    return ptr;
}


/* l(long l)LPʂŃJ}ꂽ(char *np)ɕϊ */
static void ltoa_k(long l,char *np)
{
    char work[80];
    int i,len,cnt;

    sprintf(work,"%ld",l);
    len=strlen(work);
    cnt=len % 3;
    for (i=0;i<len;i++) {
        if (cnt==0) {
            if (i!=0 && len-i>=3) {
                *np=',';
                np++;
            }
            
            cnt=3;
        }
        *np=work[i];
        np++;
        cnt--;
    }
    *np='\0';
}
