#pragma warning(disable:4996)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#include <fcntl.h>
#include <db.h>
#ifdef OS_IS_MSDOS
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>
#else
#include <sys/types.h>
#include <sys/stat.h>
#endif

extern void *memalloc(unsigned int);
extern void memfree(void *);

/* O[oϐ */
extern int db_status;
extern jmp_buf DB_Jmp;

/* ʕϐ */
static Entry *pe;

/*
************************************************************************
t@C̐VKPƍ쐬
    IDX_t *DbIdxCreate(char *name,int dup);


@@name:t@Cւ̃pX
    dup: dtO s(0),(1)
߂l(t@Cϐ:IDX_t *)
    !=NULL:I
    NULL: G[R[h(db_statusZbg)B

@@̓_CNgIdxCreateĂсAG[nhOĖ߂B
    {֐ō쐬t@C͕KDbIdxCloseŃN[Y
    ƁB
                                            1993.8 ǉ Ra
************************************************************************
*/
IDX_t *DbIdxCreate(char *name,int dup)
{
    int rc=E_OK;
    IDX_t *ixt=NULL;

    db_status=rc;
    remove(name);               /* ɂ铯̍t@C͏ */

    /* IDX_t (*ixt)̊m */
    if ((ixt=(IDX_t *)memalloc(sizeof(IDX_t)))==NULL) {
        db_status=rc=E_MEM;goto exit;
    }
    /* Entry (*pe)̊m({֐ł͒ڎgpȂ) */
    if (pe==NULL) {
        if ((pe=(Entry *)memalloc(sizeof(Entry)))==NULL) {
            db_status=rc=E_MEM;goto exit;
        }
    }
    if ((rc=setjmp(DB_Jmp))!=0)    /* IDX error */
        rc=db_status=E_IDX+rc;     /* t@C쐬s */
    else
        IdxCreate(name,ixt,dup);   /* t@C̍쐬 */
  exit:
    if (rc!=E_OK) {                /* ُIȂ狤ʃ */
        if (ixt!=NULL) {
            memfree(ixt);ixt=NULL;
        }
        if (pe!=NULL) {
            memfree(pe);pe=NULL;
        }
    }

    return ixt;
}

/*
************************************************************************
t@C̒PƃN[Y
    int DbIdxClose(IDX_t *ixt);


    t@Cϐ:IDX_t *ixt;
߂l
    E_OK(0):I
    ̑̒l̓G[R[h(db_statusZbg)B

@@̓_CNgIdxCloseĂсAG[nhOĖ߂B
                                            1993.8 ǉ Ra
************************************************************************
*/
int DbIdxClose(IDX_t *ixt)
{
    int rc=E_OK;

    db_status=rc;
    if ((rc=setjmp(DB_Jmp))!=0)    /* IDX error */
        rc=db_status=E_IDX+rc;     /* t@CN[Ys */
    else
        IdxClose(ixt);             /* t@C̃N[Y */

    /* ʃ̉ */
    if (ixt!=NULL)
        memfree(ixt);
    if (pe!=NULL) {
        memfree(pe);pe=NULL;
    }

    return rc;
}

/*
************************************************************************
t@Cւ̒PƃL[ڒǉ
    int DbIdxAddKey(IDX_t *ixt,char *key,long recno);


    L[ڃf[^:key
    f[^t@CR[hԍ:recno
    t@Cϐ:IDX_t *ixt;
߂l
    E_OK(0):I
    ̑̒l̓G[R[h(db_statusZbg)B

@@̓_CNgIdxAddĂсAG[nhOĖ߂B
                                            1993.8 ǉ Ra
************************************************************************
*/
int DbIdxAddKey(IDX_t *ixt,char *key,long recno)
{
    int rc=E_OK;

    db_status=rc;
    if (strlen(key)>MAXKEY-1) {
        db_status=rc=E_IDX;goto exit;/* L[ڒُ */
    }
    strcpy(pe->key,key);         /* o^f[^̃Zbg */
    pe->recptr=recno;            /* o^f[^t@CR[hԍ̃Zbg */
    if ((rc=setjmp(DB_Jmp))!=0) /* IDX error */
        rc=db_status=E_IDX+rc;  /* t@Co^s */
    else {
        if (IdxAdd(pe,ixt)!=IX_TRUE) /* t@C̓o^ */
            db_status=rc=E_DUP;
    }

  exit:
    return rc;
}
