#
#  Library Makefile for MSVC++ Version 4.0 NMAKE
#
#				       1996.3 by Ra
#  Usage	example
#-----------------------------------------------------
#  Normal	nmake [DEBUG=1]
#  Rebuild	nmake rebuild
#  Clean	nmake clean
#  Library      nmake libmake
#
PROJ=DREC
DEPENDHDR=drec.h
TARGETOBJS=drec.obj
#
!IFDEF DEBUG
COPTIONS=/f /Od /Zi
!ELSE
COPTIONS=/Ox /Zl
!ENDIF
#
TARGETDIR=..\..
TARGETLIB=$(TARGETDIR)\lib\rsdb32.lib
#
CFLAGS=/c /I$(TARGETDIR)\inc
LIBOPTIONS=/nologo
SH=command /c
MAKE=nmake
CC=cl
LIBCMD=lib
LRF=nmake.lrf
LIBOBJS=$(TARGETOBJS)
TARGETHDR=$(TARGETDIR)\inc\$(DEPENDHDR)
TARGET=$(TARGETHDR) $(LIBOBJS)

ALL:$(TARGET)

$(TARGETHDR):$(DEPENDHDR)
	!copy $? $(TARGETDIR)\inc
$(TARGETOBJS):$(DEPENDHDR) $(FRC)

clean:
	@$(SH) echo Clean $(PROJ) ...
	@$(MAKE) -f drec.mak -i target_c
target_c:
	@del *.obj
rebuild:
	@$(SH) echo Rebuild $(PROJ) ...
	@$(MAKE) -f drec.mak all FRC=force
libmake:$(LIBOBJS)
	@$(SH) echo $(TARGETLIB) updating....
	$(LIBCMD) /out:$(TARGETLIB) $(LIBOPTIONS) @<<$(LRF)
$(LIBOBJS: =&^
)
<<

force:

.c.obj:
	$(CC) $(CFLAGS) $(COPTIONS) $*.c
