/*=========================================================================
//                  RSDB  program     Version 1.0
//
//                          wb_t@C
//
//                        Copyright (C)  1993.9
//                               by Ra
//   Ver 1.1 1997.01 by Ra f@\̒ǉ
//========================================================================*/

/* 
 *  VÕf[^x[Xwb_CN[hB
 */
#include <sdb.h>

/* 
 * ֐߂l̒`
 */
#define E_NG 99
#define E_EXCEPT01 201
#define E_EXCEPT02 202
#define E_EXCEPT03 203
#define E_EXCEPT04 204
#define E_EXCEPT05 205
#define E_EXCEPT06 206
#define E_EXCEPT07 207
#define E_EXCEPT08 208
#define E_EXCEPT09 209
#define E_EXCEPT10 210
#define E_EXCEPT11 211
#define E_EXCEPT12 212

#ifdef OS_IS_MSDOS
#define E$NG E_NG 
#define E$EXCEPT01 E_EXCEPT01
#define E$EXCEPT02 E_EXCEPT02
#define E$EXCEPT03 E_EXCEPT03 
#define E$EXCEPT04 E_EXCEPT04
#define E$EXCEPT05 E_EXCEPT05
#define E$EXCEPT06 E_EXCEPT06
#define E$EXCEPT07 E_EXCEPT07
#define E$EXCEPT08 E_EXCEPT08
#define E$EXCEPT09 E_EXCEPT09
#define E$EXCEPT10 E_EXCEPT10
#define E$EXCEPT11 E_EXCEPT11
#define E$EXCEPT12 E_EXCEPT12
#endif

/* 
 * f[^\̒`
 */
typedef struct table {          /* \ */
    char *tname;                /* \(f[^x[X) */
    SCM_t *scm;                 /* f[^x[X */
    char *recp;                 /* PR[hǂݏoobt@ */
}Table;

typedef struct tables{          /* \DB */
    int tnum;                   /* \ */
    Table *tbl;                 /* \z */
}Tdb;
typedef struct row {            /*  */
    int    tix;                 /* \DBCfbNX */
    int    iix;                 /* \̗iځjCfbNX */
}Row;

typedef struct rows {           /* s */
    int rnum;                   /*  */
    Row *rw;                    /*  */
}Line;


typedef struct rdb_t {          /* RDB */
    Tdb tdb;                    /* \DB */
    Line ln;                    /* s */
}RDB_t;
    

typedef struct condition {      /*  */
    int ope;                    /* 艉Zq */
    Row rw;                     /* ӂ̗ */
    char *vdata;                /* l */
    Row rw2;                    /* Eӂ̗Bvdata퉉Zl̎
                                 @rw2.tix,rw2.iix͗Ƃ-1ƂB*/
}Condition;

typedef struct cdlnk {
    Condition cd;				/*  */
    int lnk;					/* Ƃ̊֌W(and,or..) */
}Cdlnk;
    

typedef struct conds {          /* z */
    RDB_t *rdb;                 /* ΏRDB */
    int cnum;                   /*  */
    Cdlnk *cond;                /*  */
    int onum;                   /* ʂ̃\[g */
    int *rix;                   /* ʂ̃\[gCfbNXz
                                   (RDB̗CfbNXl)*/
    int *desc;                  /* \[g(0: 1:~ rixɊeXΉ) */
}SQL_t;


/*
 * RDBt@CQƂɊւ\
 */
typedef struct rdbitem {        /* ڋLq\ */
    char *tname;                /* \ */
    char *kname;                /* ږ */
    int type;                   /* ڌ^(0: 1~\) */
    int len;                    /* ڒ */
}RDBITEM;

typedef struct rdbrec {         /* R[hLq\ */
    unsigned int reclen;        /* R[h(oCg) */
    int itemnum;                /* ڐ */
    RDBITEM *item;              /* ڍ\̔z */
}RDBREC;

typedef struct sqlresp {        /* t@CQƍ\ */
    long recnum;                /* R[h */
    RDBREC rec;                 /* R[hLq\ */
}SQLRESP;


/*------------------------------
 CuŎgp\ 
 ------------------------------*/
/*
 *   SQL̉͌ʂi[obt@(SQLBUF)
 */
typedef struct sbuf {
    int tnum;                   /* \ */
    char **tname;               /* \z */
    int rnum;                   /*  */
    char **rname;               /* 񖼔z */
    int cnum;                   /* Lqڔz */
    char **cname;               /* Lqڔz */
    int onum;                   /* ʂ̃\[g */
    char **oname;               /* ʂ̃\[gz */
    int *desc;                  /* \[g 0: 1:~ eonameɑΉ */
}SQLBUF;

/*
 * tokenlist\
 */
typedef struct tokenlist {
    char *token;
    char *ptr;
    struct tokenlist *next;
}TokenList;


/* 
 * }N
 */
/* =====RDB_t Ɋւ}N===== */

/* RDB rdb̎\DB(Tdb *) */
#define R_TDB(rdb) (rdb->tdb)

/* RDB rdb̍s(Line *) */
#define R_LN(rdb) (rdb->ln)


/* =====RDB_t̎\Ɋւ}N===== */

/* RDB rdb̎\DB tdb̎\(Tdb *) */
#define R_TDB_TNUM(rdb) (rdb->tdb.tnum)

/* RDB rdb̎\DB tdb̎\z(Table *) */
#define R_TDB_TBL(rdb) (rdb->tdb.tbl)

/* RDB rdb̎\DB tdbiԖڂ̎\(char *) */
#define R_TDB_TNAME(rdb,i) (rdb->tdb.tbl[i].tname)

/* RDB rdb̎\DB tdbiԖڂ̎\f[^x[X(scm)(SCM_t *) */
#define R_TDB_SCM(rdb,i) (rdb->tdb.tbl[i].scm)

/* RDB rdb̎\DB tdbiԖڂ̎\̓ǂݏoobt@(char *) */
#define R_TDB_RECP(rdb,i) (rdb->tdb.tbl[i].recp)


/* =====RDB_t̍sɊւ}N===== */

/* RDB rdb̍s ln̗(int) */
#define R_LN_RNUM(rdb) (rdb->ln.rnum)

/* RDB rdb̍s ln̐擪̗z(Row *) */
#define R_LN_RW(rdb) (rdb->ln.rw)

/* RDB rdb̍s lniԖڂ̗z(Row *) */
#define R_LN_RWi(rdb,i) (&rdb->ln.rw[i])

/* RDB rdb̍s lniԖڂ̗̎\zCfbNXtix(int) */
#define R_RW_TIX(rdb,i) (rdb->ln.rw[i].tix)

/* RDB rdb̍s lniԖڂ̗̎\CfbNXiix(int) */
#define R_RW_IIX(rdb,i) (rdb->ln.rw[i].iix)

/* RDB rdb̍s lniԖڂ̗̎\f[^x[Xscm(SCM_t *) */
#define R_RW_SCM(rdb,i) R_TDB_SCM(rdb,R_RW_TIX(rdb,i))

/* RDB rdb̍s lniԖڂ̗̗(char *) */
#define R_RW_NAME(rdb,i) SIM_NAME(R_RW_SCM(rdb,i),R_RW_IIX(rdb,i))

/* RDB rdb̍s lniԖڂ̗̌(short) */
#define R_RW_POS(rdb,i) SIM_POS(R_RW_SCM(rdb,i),R_RW_IIX(rdb,i))

/* RDB rdb̍s lniԖڂ̗̌(short) */
#define R_RW_LEN(rdb,i) SIM_LEN(R_RW_SCM(rdb,i),R_RW_IIX(rdb,i))

/* RDB rdb̍s lniԖڂ̗̌^(short) */
#define R_RW_TYPE(rdb,i) SIM_TYPE(R_RW_SCM(rdb,i),R_RW_IIX(rdb,i))

/* RDB rdb̍s lniԖڂ̗̃R[h(recp)ʒu(char *) */
#define R_RW_ITEM(rdb,i) \
    SIM_ITEM(R_RW_SCM(rdb,i),R_RW_IIX(rdb,i),\
             R_TDB_RECP(rdb,R_RW_TIX(rdb,i)))



/* =====SQL_tɊւ}N===== */

/* z sqľΏRDB */
#define SQL_RDB(sql) (sql->rdb)

/* z sql̔z(int) */
#define SQL_CNUM(sql) (sql->cnum)

/* z sql̐擪̏zcond (Cdlnk *) */
#define SQL_COND(sql) (sql->cond)

/* z sqliԖڂ̏zcond (Cdlnk *) */
#define SQL_CONDi(sql,i) (&sql->cond[i])

/* z sqliԖڂ̏z̒̏(Condition *) */
#define SQL_CD(sql,i) (&sql->cond[i].cd)

/* z sqliԖڂ̏z̒̌(int) */
#define SQL_LNK(sql,i) (sql->cond[i].lnk)



/* =====SQL_t̏Ɋւ}N===== */

/* z sqliԖڂ̏̉Zqope(int) */
#define SQL_OPE(sql,i) (sql->cond[i].cd.ope)

/* z sqliԖڂ̏̔퉉Zl(char *) */
#define SQL_VDATA(sql,i) (sql->cond[i].cd.vdata)


/* =====SQL_t̏̍ӂ̗Ɋւ}N===== */

/* z sqliԖڂ̏̍ӂ̗rw(Row) */
#define SQL_ROW(sql,i) (sql->cond[i].cd.rw)

/* z sqliԖڂ̏̍ӂ̗rw̎\CfbNX(int) */
#define SQL_TIX(sql,i) (sql->cond[i].cd.rw.tix)

/* z sqliԖڂ̏̍ӂ̗rw̎\CfbNX(int) */
#define SQL_IIX(sql,i) (sql->cond[i].cd.rw.iix)


/* z sqliԖڂ̏̍ӗ̎\DB scm(SCM_t *) */
#define SQL_SCM(sql,i) R_TDB_SCM(SQL_RDB(sql),SQL_TIX(sql,i))

/* z sqliԖڂ̏̍ӗ̗(char *) */
#define SQL_NAME(sql,i) SIM_NAME(SQL_SCM(sql,i),SQL_IIX(sql,i))
     
/* z sqliԖڂ̏̍ӗ̌(int) */
#define SQL_LEN(sql,i) SIM_LEN(SQL_SCM(sql,i),SQL_IIX(sql,i))

/* z sqliԖڂ̏̍ӗ̌^(int) */
#define SQL_TYPE(sql,i) SIM_TYPE(SQL_SCM(sql,i),SQL_IIX(sql,i))




/* =====SQL_t̏̉Eӂ̗Ɋւ}N===== */

/* z sqliԖڂ̏̉Eӂ̗rw2(Row) */
#define SQL_ROW2(sql,i) (sql->cond[i].cd.rw2)

/* z sqliԖڂ̏̉Eӂ̗rw2̎\CfbNX(int) */
#define SQL_TIX2(sql,i) (sql->cond[i].cd.rw2.tix)

/* z sqliԖڂ̏̉Eӂ̗rw2̎\CfbNX(int) */
#define SQL_IIX2(sql,i) (sql->cond[i].cd.rw2.iix)


/* z sqliԖڂ̏̉Eӗ̎\DB scm(SCM_t *) */
#define SQL_SCM2(sql,i) R_TDB_SCM(SQL_RDB(sql),SQL_TIX2(sql,i))

/* z sqliԖڂ̏̉Eӗ̗(char *) */
#define SQL_NAME2(sql,i) SIM_NAME(SQL_SCM2(sql,i),SQL_IIX2(sql,i))
     
/* z sqliԖڂ̏̉Eӗ̌(int) */
#define SQL_LEN2(sql,i) SIM_LEN(SQL_SCM2(sql,i),SQL_IIX2(sql,i))

/* z sqliԖڂ̏̉Eӗ̌^(int) */
#define SQL_TYPE2(sql,i) SIM_TYPE(SQL_SCM2(sql,i),SQL_IIX2(sql,i))



/* =====SQL_ťʃ\[gɊւ}N===== */

/* z sqľʃ\[g(int) */
#define SQL_ONUM(sql) (sql->onum)

/* z sqľʃ\[gz(int *) */
#define SQL_ORIX(sql) (sql->rix)

/* z sqliԖڂ̌ʃ\[gRDBCfbNXl(int) */
#define SQL_ORIXi(sql,i) (sql->rix[i])

/* z sqľʃ\[gwz(int *) */
#define SQL_ODESC(sql) (sql->desc)

/* z sqliԖڂ̌ʃ\[g̃\[g(int) */
#define SQL_ODESCi(sql,i) (sql->desc[i])

/* z sqliԖڂ̌ʃ\[g̎\CfbNXl(int) */
#define SQL_OTIX(sql,i) R_RW_TIX(SQL_RDB(sql),sql->rix[i])

/* z sqliԖڂ̌ʃ\[g̎\̗CfbNXl(int) */
#define SQL_OIIX(sql,i) R_RW_IIX(SQL_RDB(sql),sql->rix[i])

/* z sqliԖڂ̌ʃ\[ǧ(int) */
#define SQL_OLEN(sql,i) R_RW_LEN(SQL_RDB(sql),sql->rix[i])


/* ===== t@CQƍ\(SQLRESP *resp)Ɋւ}N ===== */

/* R[h(long) */
#define REC_NUM(resp) (resp->recnum)

/* R[h(unsigned int) */
#define REC_LEN(resp) (resp->rec.reclen)

/* ڐ(int) */
#define REC_INUM(resp) (resp->rec.itemnum)

/* iԖڂ̍ڂ̕\(char *) */
#define REC_TNAME(resp,i) (resp->rec.item[i].tname)

/* iԖڂ̍ڂ̍ږ(char *) */
#define REC_KNAME(resp,i) (resp->rec.item[i].kname)

/* iԖڂ̍ڂ̍ڌ^(int) */
#define REC_TYPE(resp,i) (resp->rec.item[i].type)

/* iԖڂ̍ڂ̍ڒ(int) */
#define REC_ILEN(resp,i) (resp->rec.item[i].len)

/* 
 * ֐̐錾
 */

/*   RDB̃I[v */
RDB_t *RdbOpen(char *sqlstr,int create_flag);

/*   RDB̃N[Y */
void RdbClose(RDB_t *rdb);

/*  zSQL_t̎擾 */
SQL_t *RdbGetSqlToken(RDB_t *rdb,char *sqlstr);

/*   zSQL_t̉ */
void RdbRelSqlToken(SQL_t *sql);

/*   RDB̏񌟍 */
int RdbFindRead(SQL_t *sql,char *buf);

/*   RDB̎񌟍 */
int RdbNextRead(char *buf);

/* RdbFind/NextRead̍p̐ */
void RdbReadIndexEnable(void);  /* pB*/
void RdbReadIndexDisable(void); /* pȂB*/

/*  R[h̃R[hԍQƂB */
long RdbGetSqlReadRecno(int fix);

/*
 * Sql֐
 */
/* \̍쐬  */
int SqlCreateTable(char *sqlstr);

/* ̍쐬  */
int SqlCreateIndex(char *sqlstr);

/* ̍폜 */
int SqlDropIndex(char *sqlstr);

/* s̒ǉ */
int SqlInsertInto(char *sqlstr);

/* s̍XV */
int SqlUpdate(char *sqlstr,long *count);

/* s̍폜 */
int SqlDelete(char *sqlstr,long *count);

/* \̍폜 */
int SqlDropTable(char *sqlstr);

/* \̖₢킹 */
SQLRESP *SqlSelectFrom(char *sqlstr,FILE *fp);

/* t@CQƍ\̂̉ */
void SqlFreeResp(SQLRESP *resp);

/* SQL\̌^`FbNB */
int SqlType(char *sqlstr);

/* Ver1.1 1997.01 by Ra */
/* ftO 1/0 1Œf */
void SqlSetQuit(int quit);
