/*=====================================================================
                 RSDB rdbbase program     Version 1.1

                        Copyright (C)  1993.9
                               by Ra

-----------------------------y֐dlz----------------------------

(1)RDB̃I[v
----------------

  RDB_t *RdbOpen(char *sqlstr,int create_flag);

  
    char *sqlstr: SQL(select~from~)ŗ񖼃XgE\Xgw肷B
  @int create_flag: 0:I[v@1:VK쐬
  o
    ߂l(RDB_t *)

@
    SQL(sqlstr)ɏ]RDBI[vE\zARDB_tԂB
    create_flag==1ȂRDBVK쐬B
    create_flag!=1ȂRDBŎgpf[^x[X͂łɑ݂Ă
    Ȃ΂ȂȂB

  ߂l
  @NULLȊO:I@@@NULL:ُI

(2)RDB̃N[Y
-----------------
  void RdbClose(RDB_t *rdb);

  RdbOpenŃI[vꂽRDBN[YB


<>
    1993.9  Version 1.0  by Ra 
    1994.8  Version 1.1  by Ra
	 1.RdbCloseŃN[YORdbCloseCheck֐Ăяo悤ɕύXB
         2.svϐ̐B
========================================================================*/
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rdb.h>

/* OQƊ֐ */
extern void *memalloc(unsigned int);
extern void  memfree(void *);
extern SQLBUF *_SqlBufAlloc(char *);
extern void _SqlBufFree(SQLBUF *);
extern int RdbCloseCheck(RDB_t *);
extern int _RdbRwSet(RDB_t *rdb,Row *rw,char *rstr);

/*******************************************
//  RDB_tTdbtbltnameallocateB
//
//  
//       RDB_t *rdbtnum
//       char **tname:\DB(f[^x[X)
//  o
//      R_TDB_TBL,R_TDB_TNAME
//  ߂l
//      E_OK:I E_OKȊO:ُI
//*******************************************/
static int tbl_alloc(RDB_t *rdb,char **tname)
{
    int i=0,j,rc=E_OK;

    /* tbl̃AP[g */
    if ((R_TDB_TBL(rdb)=
         (Table *)memalloc(R_TDB_TNUM(rdb)*sizeof(Table)))==NULL) {
        rc=E_MEM;goto exit;
    }
    else {
        for (i=0;i<R_TDB_TNUM(rdb);i++)
            R_TDB_TNAME(rdb,i)=NULL; /* TNAMEGANULLNA */
    }
    /* \񒷂̃`FbN&AP[g */
    for (i=0;i<R_TDB_TNUM(rdb);i++) {
        if (strlen(tname[i])==0) {
            rc=E_NG;goto exit;
        }
        else {
            if ((R_TDB_TNAME(rdb,i)=
                 (char *)memalloc(strlen(tname[i])+1))!=NULL) {
                strcpy(R_TDB_TNAME(rdb,i),tname[i]); /* ̃Zbg */
            }
            else {
                rc=E_MEM;goto exit;
            }
        }
    }

  exit:
    /* ZbgɎs炻܂łɊmۂB */
    if (rc!=E_OK) {
        if (R_TDB_TBL(rdb)!=NULL) {
            for (j=0;j<i;j++) {
                if (R_TDB_TNAME(rdb,j)!=NULL)
                    memfree(R_TDB_TNAME(rdb,j));
            }
            memfree(R_TDB_TBL(rdb));
        }
    }

    return rc;
}

/******************************************
//  RDB_t TdbtbltnameB
//  tbl_allocꂽ\tbl,tnameB
//*****************************************/
static void tbl_free(RDB_t *rdb)
{
    int i;

    for (i=0;i<R_TDB_TNUM(rdb);i++) {
        memfree(R_TDB_TNAME(rdb,i)); /* \̃̉ */
    }
    memfree(R_TDB_TBL(rdb));    /* tbl̉ */
}


/*************************
//  \DBI[vB
//
//  
//    int    R_TDB_TNUM(rdb)     \
//    Table  R_TDB_TNAME(rdb,i)  \(f[^x[X)
//    int    create_flag         ==1 ȂcreateB
//  o
//    Table  R_TDB_SCM(rdb,i)    \DB
//           R_TDB_RECP(rdb,i)   obt@
//  ߂l
//    E_OK:@E_OKȊO:ُI
//*******************************************************/
static int tdb_open(RDB_t *rdb,int create_flag)
{
    int i,j,rc=E_OK;

    /* tnumscmI[viNGCgjB*/
    for (i=0;i<R_TDB_TNUM(rdb);i++) {
        if (create_flag==1)
	{
            R_TDB_SCM(rdb,i)=SdbCreate(R_TDB_TNAME(rdb,i));
	}
        else {
            R_TDB_SCM(rdb,i)=SdbOpen(R_TDB_TNAME(rdb,i));
	}

        if (R_TDB_SCM(rdb,i)==NULL) {
            rc=E_NG; break;     /* I[vs */
        }
        else {
            /* f[^t@CR[h̊m */
            R_TDB_RECP(rdb,i)=(char *)memalloc(SdbDrGetLen(R_TDB_SCM(rdb,i)));
            if (R_TDB_RECP(rdb,i)==NULL) {
                rc=E_MEM;
                SdbClose(R_TDB_SCM(rdb,i)); /* ̃f[^x[XN[Y */
                break;
            }
        }
    }
    if (rc!=E_OK) {
        /* I[vɎsA܂łɐN[Y */
        for (j=0;j<i;j++) {
            SdbClose(R_TDB_SCM(rdb,j));
            memfree(R_TDB_RECP(rdb,j));
        }
    }
        
    return rc;
}                               /* End tdb_open */


/*********************
//  \DBN[YA
//  tdb_openŊmۂꂽ̈B
//**************************************/
static void tdb_close(RDB_t *rdb)
{
    int i;
    
    for (i=0;i<R_TDB_TNUM(rdb);i++) {
        if (R_TDB_SCM(rdb,i)!=NULL) {   /* ̃`FbN͕sv... */
            SdbClose(R_TDB_SCM(rdb,i));
            memfree(R_TDB_RECP(rdb,i));
        }
    }
}                               /* End TdbClose */


/***********************************************************
//  RDB_t *rdbLinerwallocateAtix,iix\zB
//
//  ߂l E_OK:I E_OKȊO:ُI
//
//  `rnamě`
//     "\.row_name"̃|C^z
//  "\."͏ȗ\ŁAȗꍇ͎\z擪̎\
//  ̗pB
///
//  R_LN_RNUM(rdb)<=0łꍇ́A\zR_TDB(rdb)ɓo^
//  Ă鏇ɁAׂĂ̕\ׂ̂Ă̗tB
//  (̂Ƃrname͎QƂȂB)
//**************************************************************/
static int rw_alloc(RDB_t *rdb,char **rname)
{
    int i,j,k,rc=E_OK;

    /* rnum>0̎ */
    if (R_LN_RNUM(rdb)>0) {
        /* Row\̂AP[gB */
        if((R_LN_RW(rdb)=(Row *)memalloc(R_LN_RNUM(rdb)*sizeof(Row)))==NULL) {
            rc=E_MEM;goto exit;
        }
        /* 񐔉JԂ */
        for (i=0;i<R_LN_RNUM(rdb);i++) {
            /* ̃ubNł́A`rname[i]͂A
               R_RW_TIX(rdb,i)R_RW_IIX(rdb,i)߂B */
            if ((rc=_RdbRwSet(rdb,R_LN_RWi(rdb,i),rname[i]))!=E_OK)
                goto exit;
        }
    }
    /* R_LN_RNUM(rdb)<=0̎ */
    else {
        for (R_LN_RNUM(rdb)=i=0;i<R_TDB_TNUM(rdb);i++)
            R_LN_RNUM(rdb)+=SH_INUM(R_TDB_SCM(rdb,i)); /* rnum̌vZ */

        /* Row\̂AP[gB */
        if((R_LN_RW(rdb)=(Row *)memalloc(R_LN_RNUM(rdb)*sizeof(Row)))==NULL) {
            rc=E_MEM;goto exit;
        }

        /* TIXIIXZbgB*/
        for (k=i=0;i<R_TDB_TNUM(rdb);i++) {
            for (j=0;j<SH_INUM(R_TDB_SCM(rdb,i));j++) {
                R_RW_TIX(rdb,k)=i;
                R_RW_IIX(rdb,k)=j;
                k++;
            }
        }
    }

  exit:
    if (rc!=E_OK && R_LN_RW(rdb)!=NULL)
        memfree(R_LN_RW(rdb));  /* ُI͊mۂB*/

    return rc;
}

/***************************
// RDB_tLinerw̉
//*************************/
#define rw_free(rdb) (memfree(R_LN_RW(rdb)))


/***************
//  RDB̃I[v
//
//  
//    char *sqlstr: SQL(select~from~)ŗ񖼃XgE\Xgw肷B
//  @int create_flag: 0:I[v@1:VK쐬
//  o
//    ߂l(RDB_t *)
//
//  ߂l
//  @NULLȊO:I@@@NULL:ُI
//*************************************************************/
RDB_t *RdbOpen(char *sqlstr,int create_flag)
{
    RDB_t *rdb=NULL;
    SQLBUF *sb=NULL;

    /* SQLBUFAP[gB*/
    if ((sb=_SqlBufAlloc(sqlstr))==NULL) {
        goto exit;
    }
    /* select~from~̃`FbN */
    if (sb->tnum==0) {          /* from߂OKƂB*/
        goto exit;
    }
    /* 悸RDB_tAP[gB*/
    if ((rdb=(RDB_t *)memalloc(sizeof(RDB_t)))==NULL) {
        goto exit;
    }
    /* tnum,rnum̃Zbg */
    R_TDB_TNUM(rdb)=sb->tnum;
    R_LN_RNUM(rdb)=sb->rnum;

    /* RDB_tTdbtbl,tnameallocateB*/
    if (tbl_alloc(rdb,sb->tname)!=E_OK) {
        memfree(rdb);   /* s炻܂łɊmۂ͉B*/
        rdb=NULL;
        goto exit;
    }

    /* \DBI[vAǂݏoobt@mۂB*/
    if (tdb_open(rdb,create_flag)!=E_OK) {
        tbl_free(rdb);   /* s炻܂łɊmۂ͉B*/
        memfree(rdb);
        rdb=NULL;
        goto exit;
    }

    /* RDB_t *rdbLinerwallocateAtix,iix\zB
       rnum<=0ȂS\̑S񂪃Zbg */
    if (rw_alloc(rdb,(sb->rnum>0)? sb->rname : (char **)NULL)!=E_OK) {
        tdb_close(rdb);   /* s炻܂łɊmۂ͉B*/
        tbl_free(rdb);
        memfree(rdb);
        rdb=NULL;
        goto exit;
    }

  exit:
    if (sb!=NULL) 
        _SqlBufFree(sb);
    return rdb;
}

/*******************
//  RDB̃N[Y
//***********************/
void RdbClose(RDB_t *rdb)
{
    RdbCloseCheck(rdb); /* RdbFindRead,RdbNextRead֐̓L`FbN */
    rw_free(rdb);
    tdb_close(rdb);
    tbl_free(rdb);
    memfree(rdb);
}
