/*=====================================================================
                 RSDB sqlcrtbl program     Version 1.0

                        Copyright (C)  1993.9
                               by Ra

-----------------------------y֐dlz----------------------------

(1)\̍쐬 
------------
  int SqlCreateTable(char *sqlstr);

  
  @ char *sqlstr : SQL(create table)B
  ߂l
     E_OK:I 
     ȊO:ُI
        E_PARA:SQL@G[
        E_MEM:s@@
  
  @SQL(sqlstr)Ŏw肳ꂽ\VK쐬B܂ő݂Ă̕\
    B\͐VK쐬N[YꂽԂɂȂ̂Ŏgpɂ̓I[v
    KvB

  SQL\
        --------------------------------------------------
                create table  <\> (
                        <> <f[^^>,
                        <> <f[^^>,
                             ...
                        <> <f[^^>
                )
        --------------------------------------------------
                f[^^
                        char    ^
                        time    Ԍ^(\)
                        date    t^(\)
                        bin@@ oCi^
                ex.
                        create table D1 (
                                D1nam00 char(8),
                                D1nam01 char(8),
                                    ...
                                D1nam09 char(8)
                        )
============================================================================*/
#pragma warning(disable:4996)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rdb.h>

/* OQƊ֐ */
extern void *memalloc(unsigned int);
extern void  memfree(void *);
extern void RelTokenList(TokenList *tlp);
extern TokenList *GetTokenList(char *inbuf);

/* SCMITEM̃N\ */
typedef struct itemlist {
    SCMITEM item;
    struct itemlist *next;
} ItemList;

/**********
//  \̍쐬 
//
//  
//  @ char *sqlstr : SQL(create table)B
//  ߂l
//     E_OK:I 
//     ȊO:ُI
//        E_PARA:SQL@G[
//        E_MEM:s@@
//****************************************************/
/* 
 * ASYTvB
 *   1.scmt@CVK쐬B(t@CŐVK쐬)
 *      1.1.TokenList 쐬
 *      1.2.TokenList `FbNȂA
 *          \(table),
 *          SCMHEAD sh,
 *          SCMITEMList(ItemList),
 *          쐬
 *      1.3.scmt@CVK쐬
 *   2.scmt@CSdbCreateŕ\VK쐬B
 */
int SqlCreateTable(char *sqlstr)
{
    int rc=E_OK,i;
    SCMHEAD sh={0,0};                  /* XL[}wb_\ */
    ItemList *root_item=NULL,          /* ItemList [gE[ */
             *current_item=NULL,
             *ip,*ip2;
    TokenList *tlp=NULL,*root_tlp=NULL;
    char *table=NULL;                  /* \ */
    FILE *fp=NULL;
    SCM_t *scm;


    /* TokenList ̊m */
    if ((root_tlp=tlp=GetTokenList(sqlstr))==NULL) {
        rc=E_MEM;goto exit;
    }
    /* "create table"̃`FbN */
    if (tlp!=NULL && 
        stricmp(tlp->token,"create")==0 && 
        tlp->next!=NULL &&
        stricmp(tlp->next->token,"table")==0) {
        tlp=tlp->next->next;                    /* OK Ȃ玟 token  */
    }
    else {
        rc=E_PARA;goto exit;    /* "create table" L[[hُ */
    }

    /* \̎擾ƃ`FbN */
    if (tlp!=NULL ) {
        /* \͓̕Ƀ`FbNȂƂɂB */
        table=(char *)memalloc(strlen(tlp->token)+5);
        if (table!=NULL) {
            strcpy(table,tlp->token);
            strcat(table,".scm"); /* gqtB */
            tlp=tlp->next;        /*  token  */
        }
        else {
            rc=E_MEM;goto exit;   /* \mۃs */
        }
    }
    else {
        rc=E_PARA;goto exit;    /* \ُ */
    }
        
    /* 
     * ڒ`̉: (D1nam00 char(8),D1nam01 char(8),....)̉
     */
    /* 擪'('̃`FbN */
    if (tlp!=NULL && strcmp(tlp->token,"(")!=0) {
        rc=E_PARA;goto exit;
    }
    /* Ō')'܂Ń[v */
    while (tlp!=NULL && strcmp(tlp->token,")")!=0) {
        if ((tlp=tlp->next)==NULL)              /* ڒ`token */
            break;

        /* V ItemList ̊m */
        if ((ip=(ItemList *)memalloc(sizeof(ItemList)))==NULL) {
            rc=E_MEM;goto exit;
        }
        ip->next=NULL; /* ̃Xg͖ */

        /* ږ̒`̃`FbN */
        if (strlen(tlp->token)>=KNAMELEN) {
            rc=E_PARA;goto exit; /* ڒB*/
        }
        /* ږ̂ɓo^ς݂łȂ`FbN */
        for (ip2=root_item;ip2!=NULL;ip2=ip2->next) {
            if (strcmp(ip2->item.kname,tlp->token)==0)
                break;          /* o^ςݔ */
        }
        if (ip2!=NULL) {
            rc=E_PARA;goto exit; /* ږ̏dG[ */
        }
        
        strcpy(ip->item.kname,tlp->token); /* ږ̃Zbg */
        if ((tlp=tlp->next)==NULL) /*  token  */
            break;

        /* ڌ^̃`FbN */
        if (strcmp(tlp->token,"char")==0)
            ip->item.type=0;
        else if (strcmp(tlp->token,"time")==0)
            ip->item.type=1;
        else if (strcmp(tlp->token,"date")==0)
            ip->item.type=2;
        else if (strcmp(tlp->token,"bin")==0)
            ip->item.type=3;
        else {
            rc=E_PARA;goto exit;
        }
        if ((tlp=tlp->next)==NULL) /*  token  */
            break;

        /* ڒ̃`FbN */
        if (strcmp(tlp->token,"(")==0) { /* '('̃`FbN */
            if ((tlp=tlp->next)==NULL) /*  token  */
                break;
        }
        else {
            rc=E_PARA;goto exit;
        }
        /* ڒ̌ */
        if (ip->item.type==1 || ip->item.type==2)
            ip->item.len=6;     /* time,date ^͖ 6 */
        else
            ip->item.len=atoi(tlp->token);
        if (ip->item.len>0) { /* l`FbN */
            if ((tlp=tlp->next)==NULL) /*  token  */
                break;
        }
        else {
            rc=E_PARA;goto exit; /* ڒُ */
        }
        if (strcmp(tlp->token,")")==0) { /* ')'̃`FbN */
            if ((tlp=tlp->next)==NULL) /*  token  */
                break;
        }
        else {
            rc=E_PARA;goto exit;
        }

        /* ڂ̃ZbgAipItemList֓o^B*/
        if (root_item==NULL) {  /* o^̏ꍇ */
            ip->item.pos=0;
            root_item=current_item=ip;
        }
        else {
            /* Vڂ͂̑ǑځE̘a */
            ip->item.pos=current_item->item.pos+current_item->item.len;
            current_item->next=ip; /* VItemListǉ */
            current_item=ip;       /* current ̈ʒu𖖒[ɃZbg */
        }
        sh.inum++;              /* ItemList o^ +1 */

        /* ڒ`Ō','܂')'łȂ΂ȂȂ */
        if (tlp!=NULL) {
            if (strcmp(tlp->token,",")!=0 &&
                strcmp(tlp->token,")")!=0) {
                rc=E_PARA;goto exit;
            }
        }
    }                           /* ڒ`̉͏I */

    /* ڒ`͂tlp==NULLŔĂG[ */
    if (tlp==NULL) {
        rc=E_PARA;goto exit;
    }

    /* ȂƂItemListɗLȓo^ȂƃG[ */
    if (sh.inum==0) {
        rc=E_PARA;goto exit;
    }

    /* 
     scmt@C̐VK쐬B
     ܂ł SCMHEAD sh,ItemList *root_item,ɗLȒl
     ZbgBscmt@Ctableɏo͂B
     */
    fp=fopen(table,"wb");
    if (fp==NULL) {
        rc=E_EXCEPT01;goto exit;
    }
    /* SCMHEAD̏ */
    if (sizeof(SCMHEAD)-fwrite(&sh,1,sizeof(SCMHEAD),fp)!=0) {
        fclose(fp);
        rc=E_EXCEPT02;goto exit;
    }
    /* SCMITEM̏ */
    for (i=0,ip=root_item;i<sh.inum;i++,ip=ip->next) {
        if (sizeof(SCMITEM)-fwrite(&ip->item,1,sizeof(SCMITEM),fp)!=0) {
            fclose(fp);
            rc=E_EXCEPT02;goto exit;
        }
    }
    /* t@C(SCMIDX)͂Ȃ̂łscmt@C݂̏͏I */
    fclose(fp);

    /* scmt@CɊÂĕ\VK쐬B*/
    *strrchr(table,'.')='\0';   /* \.scmƂ */
    if ((scm=SdbCreate(table))==NULL) {
        rc=E_EXCEPT03;goto exit;        /* \̍쐬s */
    }
    /* \̍쐬ɐA\N[YB*/
    SdbClose(scm);
    
  exit:
    if (root_tlp!=NULL)               /* TokenList ̉ */
        RelTokenList(root_tlp);
    if (table!=NULL)                  /* \̉ */
        memfree(table);
    while (root_item!=NULL) {
        ip=root_item->next; /* ItemList ̉*/
        memfree(root_item);
        root_item=ip;
    }
    return rc;
}
