#
#  Library Makefile for MSVC++ Version 4.0 NMAKE
#
#				       1996.3 by Ra
#  Usage	example
#-----------------------------------------------------
#  Normal	nmake [DEBUG=1]
#  Rebuild	nmake rebuild
#  Clean	nmake clean
#  Library      nmake libmake
#
PROJ=TOOLS
TARGETOBJS=reexp.obj memory.obj emjstr.obj
#
!IFDEF DEBUG
COPTIONS1=/f /Od /Zi
COPTIONS2=/f /Od /Zi
!ELSE
COPTIONS1=/Gs /Zl
COPTIONS2=/Ox /Zl
!ENDIF
#
TARGETDIR=..\..
TARGETLIB=$(TARGETDIR)\lib\rsdb32.lib
#
CFLAGS=/c /I. /I$(TARGETDIR)\inc
LIBOPTIONS=/nologo
SH=command /c
MAKE=nmake
CC=cl
LIBCMD=lib
LRF=nmake.lrf
LIBOBJS=$(TARGETOBJS)
TARGET=$(LIBOBJS)

ALL:$(TARGET)

reexp.obj:reexp.c reexp.h $(FRC)
	$(CC) $(CFLAGS) $(COPTIONS1) $*.c
memory.obj:memory.c $(FRC)
	$(CC) $(CFLAGS) $(COPTIONS2) $*.c
emjstr.obj:emjstr.c $(FRC)
	$(CC) $(CFLAGS) $(COPTIONS2) $*.c

clean:
	@$(SH) echo Clean $(PROJ) ...
	@$(MAKE) -f tools.mak -i target_c
target_c:
	@del *.obj
rebuild:
	@$(SH) echo Rebuild $(PROJ) ...
	@$(MAKE) -f tools.mak all FRC=force
libmake:$(LIBOBJS)
	@$(SH) echo $(TARGETLIB) updating....
	$(LIBCMD) /out:$(TARGETLIB) $(LIBOPTIONS) $(TARGETLIB) @<<$(LRF)
$(LIBOBJS)
<<

force:








