/*
 * BOARD class
 *
 * 960926: by a
 * 980618: pput()o͈͂BD11..BD100ɐ
 */
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#include "sbase.h"

//==============  BOARD  ================
BOARD::BOARD(void)
{
	int i;
	
	for (i = BD11; i < BD100; i++) Bd[i] = NL;
	for (i = 0; i < BD11; i++) Bd[i] = OB;
	for (i = BD100; i < BDSIZ; i++) Bd[i] = OB;
	for (i = BD11 - 1; i < BDSIZ; i += BDWID) Bd[i] = OB;
}

BOARD::~BOARD()
{
}


BOARD& BOARD::operator=(const BOARD &t)
{
	for (int i=0; i<BDSIZ; i++){
		Bd[i] = t.Bd[i];
	}
	Sb = t.Sb;
	return *this;
}


void BOARD::setbase(SBASE *p)
{
	Sb = p;
}

PIECE *BOARD::what(int pos)
{
	// BOARD class͎ł͐eSBASEɓo^ĂPIECEmȂ
	return Sb->bdp(pos);
}

/*
int BOARD::whatid(int pos)
{
	return Bd[pos];
}
*/

int BOARD::put(int pos, PIECE *pc)
{
	return pput(pos, pc);
}

int BOARD::pput(int pos, PIECE *pc)
{
	if (pos < BD11 || pos >= BD100) return -1;
	if (Bd[pos] == OB) return -1;
	Bd[pos] = pc->getid();
	return 1;
}

int BOARD::remove(int pos)
{
	return rm(pos);
}

int BOARD::rm(int pos)
{
	if (pos < BD11 || pos >= BD100) return -1;
	if (Bd[pos] == OB) return -1;
	Bd[pos] = NL;
	return 1;
}