/********************/
/*    SDJDoc.cpp    */
/********************/
#include "stdafx.h"
#include "winsdj.h"
#include "sdjview.h"
#include "SDJDoc.h"
#include <mbstring.h>
#include <winmemfile.h>
#include "kifframe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4244)
#pragma warning(disable:4996)

// SKBt@Č``FbN
#define SKBMARK "WINSDJ.SKB"
#define SKBMARK_LENGTH  10

// O[o
extern CWinSDJApp theApp;
extern char *Ktab[];
extern char *Ksu[];

extern "C" {
	void *memalloc(unsigned int);
	void memfree(void *);
}

/////////////////////////////////////////////////////////////////////////////
// CSDJDoc

IMPLEMENT_DYNCREATE(CSDJDoc, CDocument)

BEGIN_MESSAGE_MAP(CSDJDoc, CDocument)
	//{{AFX_MSG_MAP(CSDJDoc)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDJDoc NX̍\z/

CSDJDoc::CSDJDoc()
{
	// TODO: ̈ʒuɂP񂾂\zp̃R[hǉĂB
	m_pBkgndDIB=NULL;
	m_bInitFlag=FALSE;
	m_KBase.SetView(NULL);
	m_KBase.Create(m_KmSprite,&m_KmBoard,m_KmListBox);
	m_Eval=100;
	m_Attr=100;
	m_blfEnable=FALSE;
}

CSDJDoc::~CSDJDoc()
{
	m_pBkgndDIB=NULL;
}

// hLgʏ
//   񂵂ȂBłRXgN^ł͂łȂB(ViewȂ)
BOOL CSDJDoc::CommonInitDocument()
{
	if (m_bInitFlag)
		return TRUE;
	m_bInitFlag=TRUE;

	// XvCgXg̒ʒmIuWFNgɃr[ǂɂ邩
	// āAXvCgǉƂɃ_[eBXgI
	// Ǘł悤ɂB
	CSDJView *pView = GetSDJView();
	m_SpriteList.m_NotifyObj.SetView(pView);

	if (!theApp.m_bLoadDIB) {
		theApp.m_bLoadDIB=TRUE;

		// foCX̃J[F
		int iSysColors=pView->CheckColors();

		// VXep[^̐ݒ(e̓J[F)
		theApp.InitSysprm(iSysColors);

		// tHg̓ǂݍ
		theApp.LoadBackDIB(iSysColors);		// Քwi
		theApp.LoadKomaDIB(iSysColors);		// 
		theApp.LoadKBoxDIB(iSysColors);		// 
		theApp.LoadFontDIB();				// \
	}

	// wiDIB̐ݒ
	SetBackground(&theApp.m_BackDIB[0]);

	// A,\DIB̃pbg̃}bv
	// (pView==NULL̎if͋Uł)
	if ( !theApp.m_bMapColorsToPalette) {
		// pbg̎擾
		CDIBPal *pPal=pView->GetPalette();

		// 
		int sg,km,nr;
		for (sg=0;sg<2;sg++) {
			for (km=0;km<8;km++) {
				for (nr=0;nr<2;nr++) {
					theApp.m_KomaDIB[sg][km][nr].MapColorsToPalette(pPal);
				}
			}
		}

		// 
		theApp.m_KBoxDIB.MapColorsToPalette(pPal);

		// \
		for (int i=0;i<2;i++) {
			if (theApp.m_bKfontInit[i]==TRUE)
				theApp.m_KfontDIB[i].MapColorsToPalette(pPal);
			if (theApp.m_bTfontInit[i]==TRUE)
				theApp.m_TfontDIB[i].MapColorsToPalette(pPal);
		}

		theApp.m_bMapColorsToPalette = TRUE;
	}

    // KBase̕\ׂ̈̏
	m_KBase.SetView(pView);
	CSpriteList *pList=GetSpriteList();// \Xg
	// CSpriteList Reset;
	for (int i=0;i<40;i++) {
		int sg,km,nr;
		m_KmSprite[i].GetKmStatus(&sg,&km,&nr);		// ̎擾
        m_KmSprite[i].SetKmStatus(sg,km,nr);		// ̐ݒ(p^CY)
		pList->Remove(&m_KmSprite[i]);
		pList->Insert(&m_KmSprite[i]);
	}

	return TRUE;
}

BOOL CSDJDoc::OnNewDocument()
{
	CommonInitDocument(); // (hLg\z̏̂)

	// DeleteContentsĂ΂AՁE()񂪃NA
	if (!CDocument::OnNewDocument())
		return FALSE;
	
	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)
	return TRUE;
}

BOOL CSDJDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	CommonInitDocument();							// (hLg\z̏̂)

	// DeleteContents()Ă΂AՁE()񂪃NAB
	// āASerialize()Ă΂Asetbtype()->move2()̏ŁAEՁE񂪃ZbgB
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;

	// XvCgXg̒(r[)
	if (GetSDJView())
		AdjustSpriteList();							// XvCgXg̒

	return TRUE;
}

// XvCgXg̒
void CSDJDoc::AdjustSpriteList()
{
	CKmSprite *KmSprite=GetKmSpriteArray();
	CSpriteList *pSpriteList=GetSpriteList();
	CSDJView *pView=GetSDJView();
	for (int i=0;i<40;i++) {
		pSpriteList->Remove(&KmSprite[i]);			// XgO
		if (pView->IsBanSetting()) {				// JĂ
			pSpriteList->Insert(&KmSprite[i]);		// Xgɉ
		} else {									// Ă
			CKif Kif=KmSprite[i].GetKmPos();
			if (Kif.kt!=2)							// ȊO
				pSpriteList->Insert(&KmSprite[i]);	// Xgɉ
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSDJDoc VAC[[V

// Sw
void CSDJDoc::Serialize(CArchive& ar)
{
	// KBase ̃VACY(̓o)
	Serialize((CSDJArchive &)ar,FALSE);
}
// bLine: TRUE/FALSE(Default)  {菇̂ݏo/wԑSĂo
void CSDJDoc::Serialize(CSDJArchive& ar,BOOL bLine)
{
	// KBase ̃VACY(̓o)
	m_KBase.Serialize(ar,bLine);
}


// ǖʃt@CǍ
// (܂߂ċǖʂǂݍ܂)
void CSDJDoc::ReadBaninfo(CSDJArchive &ar)
{
	ASSERT(!ar.IsStoring());

	// FILE CHECK
	char buf[SKBMARK_LENGTH];
	UINT n=ar.Read(buf,SKBMARK_LENGTH);
	if (n==SKBMARK_LENGTH && 
		strncmp(buf,SKBMARK,SKBMARK_LENGTH)!=0) {
		AfxMessageBox("t@C`Ⴂ܂");
		return;
	}

	DeleteContents();

	CBform Bform;
	Bform.Serialize(ar); // ŔՖʂǍ܂
	DWORD dw;
	ar >> dw; int teban=(int)dw; // 
	ar >> dw; int za=(int)dw;    // 
	m_KBase.setbtype(&Bform); // ǂݍB`̔Ֆʂݒ肷B
	m_KBase.setturn(teban);   // ǂݍ񂾎Ԃݒ肷B

	CSDJView *pView=GetSDJView(); // ViewBȂNULL
	
	int za0=m_KBase.GetZa();  // ݂̍
	if (za!=za0) { // ĂA
		m_KBase.ZaRotation();  // 𔽓]B
		if (pView)
			pView->EmptyDirtyList();
		// wiՖʂύXB
		SetBackground(&theApp.m_BackDIB[GetKBase()->GetZa()]);
	}
	
	// XvCgXg̒(r[)
	if (pView) {
		AdjustSpriteList();
		pView->EmptyDirtyList();
		pView->ZaFontDIBSetNULL(); //ƔhViewœK؂ȒlăZbgB
		pView->Invalidate();
	}

	// L^X^[g
	GetKBase()->recstart();
}
void CSDJDoc::ReadBaninfo(LPCTSTR fname)
{
	CFile file;
	file.Open(fname,CFile::modeRead | CFile::shareDenyWrite);
	CSDJArchive ar(&file,CArchive::load | CArchive::bNoFlushOnDelete);

	ReadBaninfo(ar); // A[JCo

	ar.Close();
	file.Close();
}

// ǖʃt@Co
// (܂߂ċǖʂo͂)
void CSDJDoc::WriteBaninfo(CSDJArchive &ar)
{
	ASSERT(ar.IsStoring());

	ar.Write(SKBMARK,SKBMARK_LENGTH); // SKB}[N
	CBform *pBform=m_KBase.btype();
	pBform->Serialize(ar); // ŔՖʂo͂B
	int teban=m_KBase.turn();
	ar << (DWORD)teban;  // Ԃ̏o
	int za=m_KBase.GetZa();
	ar << (DWORD)za;     // ̏o
}
void CSDJDoc::WriteBaninfo(LPCTSTR fname)
{
	CFile file;
	file.Open(fname,CFile::modeCreate|CFile::modeWrite);
	CSDJArchive ar(&file,CArchive::store);

	WriteBaninfo(ar); // A[JCoo

	ar.Close();
	file.Close();
}

/////////////////////////////////////////////////////////////////////////////
// CSDJDoc NX̐ff

#ifdef _DEBUG
void CSDJDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSDJDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSDJDoc R}h

// View ̎擾
CSDJView *CSDJDoc::GetSDJView()
{
	POSITION pos;
	pos = GetFirstViewPosition();
	if (!pos)
		return NULL; // I
	CSDJView *pView = (CSDJView *)GetNextView(pos);
	ASSERT(pView);
	ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSDJView)));
	return pView;
}

// wiDIB̐ݒ
BOOL CSDJDoc::SetBackground(CDIB *pDIB)
{
	m_pBkgndDIB=pDIB; // wi̐ݒ

	// ViewɁAVobt@ƃpbg̍쐬Kvł邱Ƃ`B
	CSDJView *pView = GetSDJView();

	// r[Δwi`悷B
	if (pView)
		return pView->NewBackground(m_pBkgndDIB);
	else
		return FALSE;
}

// hLg̓eďB
void CSDJDoc::DeleteContents() 
{
	CDocument::DeleteContents();

	// ς݂̏ꍇ̂ݍď
	//     OnOpenDocumentĂ΂ꍇA
	//     DeleteContents();
	//     Doc::Serialize()->SBASE::setbtype()->CKmSprite::move2()
	//     ->CKmSprite::SetKmPosA()->CKmBoard::SetSprite()̏ɌĂ΂āA
	//     fBXNǂݏoVzu̐ݒ肪sB
	//     ̂ɁAŔՁAA̋NAĂB

	// ՁȄ
	// m_bInitFlag==TRUE̎s悤ɂĂAWorkDocument
	// gpꍇ̓RXgN^݂̂̏ŁACommonInitDocument()
	// ʂ炸m_bInitFlagFALSÊ܂܂ƂȂB̂ɂ̏OB
	m_KmBoard.Reset();			// ՂNA
	m_KmListBox[0].Reset();     // ENA
	m_KmListBox[1].Reset();
	m_KmListBox[2].Reset();
}

// OnFileSave()
// Msdev\Mfc\src\Doccore.cpp
void CSDJDoc::OnFileSave() 
{
	CSDJView *pView=GetSDJView();
	if (pView && pView->IsMenuLock()) {
			return;
	}
	DoFileSave();

	// JĂ瓯^Cg
	CSDJView *pSDJView=GetSDJView();
	if (pSDJView) {
		CKifFrame *pKifFrame=pSDJView->GetKifFrame();
		if (pKifFrame) {
			CString strTitle=GetTitle();
			pKifFrame->SetWindowText(strTitle);
		}
	}
}
void CSDJDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	CSDJView *pView=GetSDJView();
	if (pView) {
		if (pView->IsMenuLock()) {
			pCmdUI->Enable(FALSE);
			return;
		}
	}
}

// OnFileSaveAs()
// Msdev\Mfc\src\Doccore.cpp
void CSDJDoc::OnFileSaveAs() 
{
	CSDJView *pView=GetSDJView();
	if (pView && pView->IsMenuLock()) {
			return;
	}
	if (!DoSave(NULL)) {
		TRACE0("Warning: File save-as failed.\n");
	}
	else {
		// JĂ瓯^Cg
		CSDJView *pSDJView=GetSDJView();
		if (pSDJView) {
			CKifFrame *pKifFrame=pSDJView->GetKifFrame();
			if (pKifFrame) {
				CString strTitle=GetTitle();
				pKifFrame->SetWindowText(strTitle);
			}
		}
	}
}
void CSDJDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	CSDJView *pView=GetSDJView();
	if (pView) {
		if (pView->IsMenuLock()) {
			pCmdUI->Enable(FALSE);
			return;
		}
	}
}

// InfoViewB
// hLg\Ăt[ EBhEN[YOɁA
// t[[NĂяo܂BftHg̃Cvgł́A
// hLg\Ăʂ̃t[ EBhE邩ǂ
// `FbN܂Bw肳ꂽt[ EBhEhLg\
// ĂŌ̂̂łƂAhLgύXĂƁAhL
// gۑ邩ǂ₢킹܂Bt[ EBhEN
// [YƂɁAʂȏƂɂ́Å֐I[o[
// Ch܂B́AxȃI[o[Ch\Ȋ֐łB
//
// ⏕ƕۑ₢킹ɍsȂ̂ŁAI[o[ChB
// IWidoccore.cpp
BOOL CSDJDoc::CanCloseFrame(CFrameWnd* pFrame) 
{
	// otherwise only one frame that we know about
	return SaveModified();
}

////
// ̎萔Ԃ
int CSDJDoc::GetTesu()
{
	CKBase *pKBase=GetKBase();

	pKBase->PushAspect(FALSE); // ݂̋ǖʂۑďǖʂցB

	// ŏIw܂Ői߂
	while(pKBase->playnum()) 
		pKBase->ahead2();

	int tesu=pKBase->level(); // 萔̎擾
	
	pKBase->PopAspect(); // ̋ǖʂ܂Ŗ߂

	return tesu;
}

/////
// 㖼̂̎擾
//  ߂l 0: 1:  2:lߏ
int CSDJDoc::GetSGName(SBASE *sb,CString *s,CString *g)
{
	int pattern;
	HBOX *phb=sb->hboxp(2);
	if (phb->getnum() > 0) { // ɋ
		if (m_KmListBox[2].kmnum(0) > 0) { // ʂɂ΋lߏ
			g->Format("%s","");
			s->Format("%s","U");
			pattern=2; // l
		} else {
			g->Format("%s","");
			s->Format("%s","");
			pattern=1; // 
		}
	} else {
		g->Format("%s","");
		s->Format("%s","");
		pattern=0; // ΋
	}
	return pattern;
}

///////
// ݂̋ǖʂW`ŃA[JCo[֏o͂(ǖʂ̂)B
// s,g͐E薼
// bFF FORMFEED̏o(ftHg͖(FALSE))
void CSDJDoc::OutputAspectFormStd(CSDJArchive &ar,SBASE *sb,CString *s,CString *g,
									 BOOL bFF)
{
	int i,j,n;
	CString crlf("\r\n"); // s

	BOOL blfEnable=m_blfEnable;
	m_blfEnable=bFF;

	// 莝̕\
	BOOL bGoutput=FALSE;
	CString Gline;
	Gline.Format("%sF",*g);
	ar.WriteString(Gline);

	// ɋʂPꍇ͋l[hƂA
	// 莝́ucSvƕ\B
	// l[hۂׂB
	BOOL bMateMode=FALSE;
	if (sb->hboxp(2)->kmnum(0)==1) { // ɋʂꖇB
		bMateMode=TRUE;
		for (i=1;i<=7;i++) {
			if (sb->hboxp(2)->kmnum(i)!=0) {
				bMateMode=FALSE;
				break; // ̋ɂ΋l[hɂ͂ȂB
			}
		}
	}
	// l[hȂ
	if (bMateMode) { 
		for (i=0;i<8;i++) {
			if (sb->hboxp(1)->kmnum(i)!=0) { // 莝̗L`FbN
				ar.WriteString("cS");
				bGoutput=TRUE;
				break;
			}
		}
	}
	else { 
		// ʏ탂[h̕\
		for (i=0;i<8;i++) {
			n=sb->hboxp(1)->kmnum(i); // i̎
			if (n > 0 ) {
				CString Km;
				if (n > 1) // QȏȂ
					Km.Format("%s%s ",Ktab[i*2],Ksu[n-1]);
				else
					Km.Format("%s ",Ktab[i*2]);
				ar.WriteString(Km);
				bGoutput=TRUE;
			}
		}
	}
	if (bGoutput==FALSE)
		ar.WriteString("Ȃ");
	ar.WriteString(crlf); // 莝s̏I
	lf(ar);

	// Ֆʂ̕\
	CString Bline;
	Bline.Format("%s%s","  X W V U T S R Q P",crlf);
	ar.WriteString(Bline); lf(ar);
	Bline.Format("%s%s","+---------------------------+",crlf); // Ֆʏ
	ar.WriteString(Bline); lf(ar);
	for (j=1;j<=9;j++) { // Y
		ar.WriteString("|"); // Ֆjs̎n܂
		for (i=1;i<=9;i++) { // X
			int spos=mpos2spos((10-i)*10+j);
			int id=sb->bd(spos); // ̈ʒűID
			if (id!=NL && id!=OB) {  // 
				int prom=(sb->pprom(id))? 1: 0; // \
				int side=sb->pside(id);  // 
				int pcode=sb->pcode(id); // 
				if (side==SIDE_A)
					Bline.Format(" %s",Ktab[pcode*2+prom]);
				else
					Bline.Format("v%s",Ktab[pcode*2+prom]);
			} else { // Ȃ
				Bline.Format("%s"," E");
			}
			ar.WriteString(Bline);
		}
		Bline.Format("|%s%s",Ksu[j-1],crlf); // Ֆjs̏I
		ar.WriteString(Bline); lf(ar);
	}
	Bline.Format("%s%s","+---------------------------+",crlf); // Ֆʉ
	ar.WriteString(Bline); lf(ar);
	// 莝̕\
	BOOL bSoutput=FALSE;
	CString Sline;
	Sline.Format("%sF",*s);
	ar.WriteString(Sline);
	for (i=0;i<8;i++) {
		n=sb->hboxp(0)->kmnum(i); // i̎
		if (n > 0 ) {
			CString Km;
			if (n > 1) // QȏȂ
				Km.Format("%s%s ",Ktab[i*2],Ksu[n-1]);
			else
				Km.Format("%s ",Ktab[i*2]);
			ar.WriteString(Km);
			bSoutput=TRUE;
		}
	}
	if (bSoutput==FALSE)
		ar.WriteString("Ȃ");
	ar.WriteString(crlf); // 莝s̏I
	lf(ar);

	m_blfEnable=blfEnable;
}

/////////////////// o͎G֐ /////////////////
//
/* w蒍text̏Ԃ""̎̕ւ
   text̃CfbNXԂ֐BȂ -1 */
int CSDJDoc::get_hunp(char *text)
{
	int rc=-1;
    char *cp;
    char head[12];

    /* text 擪11(xxxB,xxxxxbB)`FbNB*/
    strncpy(head,text,11);
    head[11]='\0';
    if (_mbsbtype((unsigned char*)head,10)==1) head[10]='\0'; /* 1oCgڂ̃`FbN */
    cp=(char *)_mbsstr((unsigned char*)head,(unsigned char*)"B"); /* "B"T */
    if (cp==NULL) {
        cp=(char*)_mbsstr((unsigned char*)head,(unsigned char*)""); /* "xxbB"T */
        if (cp!=NULL) {
            if (strncmp(cp+4,"bB",4)!=0)
				cp=NULL; // bBłȂΖƂB
        }
    }
    if (cp!=NULL) // LŗLȕ
		rc=(cp-head)+2; // cp-head͕܂ł̃ItZbg

    return rc;
}

// helper ֐
/* Ԃ̊l(tp֕Ԃ) */
// pcl:w
void CSDJDoc::get_bplay_time(SBASE *sb,PCELL *pcl, char *tp)
{
    int flag=0;
	int idx;

	char *text=NULL;
	if (sb->getcmntnum(pcl)) // Rg
		text=sb->getcmnt(pcl,0); // ŏ̈s

    if (text) { /* ߕ */
        if ((idx=get_hunp(text))!=-1) {  /* Ԃ */
            strncpy(tp,text,idx);
			tp[idx]='\0';
            flag=1;
        }
    }
    if (flag==0)
        tp[0]='\0';
}
/* \w̃Zbg */
/* \obt@̃C[W  "T  120"
                           "      120"
                            < 8 >   2   5=15
      ő(21)         "T⍶s  120"
 */
void CSDJDoc::set_buf(char *kf,char *s_time,char *buf)
{
    int len=strlen(kf);

    strcpy(buf,kf);
    if (len<8) {
        memset(buf+len,' ',8-len);
        buf[8]='\0';
    }
    strcat(buf,"  ");
    strcat(buf,s_time);
}

/* w蒍ߕ̏Ԃ̌̕ւ̃|C^Ԃ֐BԂ
 @Ȃΐ擪̕ւ̃|C^ԂB*/
char *CSDJDoc::get_comp(char *text)
{
    char *cp;
    char head[12];

    /* text 擪11(xxxB,xxxxxbB)`FbNB*/
    strncpy(head,text,11);
    head[11]='\0';
    if (_mbsbtype((unsigned char*)head,10)==1) head[10]='\0'; /* 1oCgڂ̃`FbN */
    cp=(char*)_mbsstr((unsigned char*)head,(unsigned char*)"B"); /* "B"T */
    if (cp==NULL)
        cp=(char*)_mbsstr((unsigned char*)head,(unsigned char*)"bB"); /* "b"T */
    if (cp!=NULL)
        cp=text+(cp-head)+4;    /* |C^'B'̌ */
    else
        cp=text;

    if (strlen(cp)==0)
        cp=NULL;

    return cp;
}


/*
 * sJEg & s
 *   W[ϐ lfc,lf_line𑀍삷B
 */
void CSDJDoc::lf(CSDJArchive &ar)
{
	if (lfc >=0) {
		lfc++;
		if (m_blfEnable) {
			if (lfc==lf_line) {
				BYTE cFF = FORMFEED;
				ar << cFF;  // y[WR[h
				lfc=0;
			}
		}
	}
}

/*
 * (buf)ŕ(wid)ɋ؂ďo͂B
 * Qsڈȍ~̎offŎw肷B
 */
void CSDJDoc::fputs_width(char *buf,int wid,char *off,CSDJArchive &ar)
{
    char *cp=NULL;
    int len;
    int first=1;
    int wid1;
	CString str;
	char *tp,*buffer;
    
	wid1=wid-strlen(off); // off񕝂ZB
	if (wid1<=1) wid1=2;

	/* ƃobt@ */
    if ((buffer=(char *)memalloc(strlen(buf)+1))==NULL) goto exit;
	
	strcpy(buffer,buf);
	tp=strtok(buffer,"\r\n");
	while (tp) {
		/* ƃobt@ */
	    if ((cp=(char *)memalloc(strlen(tp)+1))==NULL) goto exit;
		while ((len=strlen(tp))>0) {
			if (len > wid1) {       /* ŕ傫 */
				if (_mbsbtype((unsigned char*)tp,wid1-1)==1) /* 1oCgڂȂ炻̑O܂ */
					wid1--;
				strncpy(cp,tp,wid1);
				cp[wid1]='\0';
				tp+=wid1; // ͈s̓r܂ŏo͂̂Ŏc͎̃[vŁB
			}
			else {                  /* ŕȉ̎ */
				strcpy(cp,tp);
				tp+=len;  // ňsSďo͂B
			}
			if (first) {  // ŏ̍s
				str.Format("%s\r\n",cp); /* t@Cɏo */
				ar.WriteString(str); lf(ar);
				first=0;
			}
			else {                  /* second~ && off!=0 */
				str.Format("%s%s\r\n",off,cp);
				ar.WriteString(str); lf(ar); /* t@Cɏo */
			}
		}
		memfree(cp);
		tp=strtok(NULL,"\r\n");
    }

  exit:
    if (buffer!=NULL) memfree(buffer);
}



/* w̃Rg\B(std)*/
// ߂l͒߂̗L
void CSDJDoc::output_bplay_comment(SBASE *sb,PCELL *pcl,int wid,CSDJArchive &ar)
{
    char *text,*comp;
    char *sp9="         ";
	CString str;
	int level=sb->level();

	CString strText; // w̒ߕ̎擾
	int n=sb->getcmntnum(pcl);
	for (int i=0;i<n;i++) {
		str.Format("%s\r\n",sb->getcmnt(pcl,i));
		strText+=str;
	}
	if (strText.IsEmpty())
		return;
	text=strText.GetBuffer(strText.GetLength()+1);
	if ((comp=get_comp(text))!=NULL) {  /* LȒ߂ */
		if (m_bfirst) {
			m_bfirst=FALSE;
			ar.WriteString("w蒍: ------------\r\n");lf(ar);
		}
		str.Format("%3d: ",level);
		ar.WriteString(str);
		fputs_width(comp,wid,sp9,ar);
	}
	strText.ReleaseBuffer();
}

//////
// (W`)A[JCo֏o͂B
// width=ŕ(72ftHg) line=Œ(9999ftHg) 
// bFF FORMFEEDo(ftHg͖FALSE)
void CSDJDoc::OutputKifStd(CSDJArchive &ar,int width,int line,BOOL bFF)
{
	TRACE("This is virtual routine, so that not called.\n");
}

//////
// (W`)CString֏o͂B
// width=ŕ(72ftHg) line=Œ(9999ftHg) 
// bFF FORMFEEDo(ftHg͖FALSE)
void CSDJDoc::OutputKifStd(CString &strKif,int width,int line,BOOL bFF)
{
	CWinMemFile File;
	CSDJArchive ar(&File,CArchive::store);
	OutputKifStd(ar,width,line,bFF);	// t@C֏o
	ar.Close();
	File.Seek(0L,CFile::begin);			// 擪Seek
	long leng=File.GetLength();			// t@C
	char *cp=strKif.GetBuffer(leng+1);	// t@C+1̃obt@m
	UINT nBytes=File.Read(cp,leng);		// obt@փt@Cǂ
	cp[nBytes]='\0';					// ǂݏoŌNULLZbg
	strKif.ReleaseBuffer();				// obt@J(NULLȍ~J)
}

//////
// (CSA`)CString֏o͂B
// Serialize()CStringo
void CSDJDoc::OutputKifCsa(CString &strKif)
{
	CWinMemFile File;
	CSDJArchive ar(&File,CArchive::store);
	Serialize(ar);						// t@C֏o
	ar.Close();
	File.Seek(0L,CFile::begin);			// 擪Seek
	long leng=File.GetLength();			// t@C
	char *cp=strKif.GetBuffer(leng+1);	// t@C+1̃obt@m
	UINT nBytes=File.Read(cp,leng);		// obt@փt@Cǂ
	cp[nBytes]='\0';					// ǂݏoŌNULLZbg
	strKif.ReleaseBuffer();				// obt@J(NULLȍ~J)
}
