// SDJDoc.h : CSDJDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////
#ifndef __SDJDOC__
#define __SDJDOC__

#include "dib.h"
#include "spritlst.h"
#include "kmsprite.h"
#include "kmlistbox.h"
#include "kmboard.h"
#include "sdjarchive.h"

// o
#define FORMFEED (0xc)

class CSDJView;
class CSDJDoc : public CDocument
{
// Agr[g
public:
	int m_Eval;
	int m_Attr;

protected:
	CDIB *m_pBkgndDIB;			// wiDIBւ̃|C^
	CSpriteList m_SpriteList;	// ̃XvCgXg
	CKmSprite m_KmSprite[40];   // ̃XvCg
	CKmListBox m_KmListBox[3];  // E
	CKmBoard   m_KmBoard;       // 
	CKBase	m_KBase;			// ǗNX

	// OutputKifStdpϐ
	int lfc;                 /* sJE^ */
	int lf_line;             /* Œ */
	int m_blfEnable;
	BOOL m_bfirst;
private:
	BOOL m_bInitFlag;           // Init

// Iy[V
public:
	void SetDiskPathName(LPCTSTR cp){m_strPathName=cp;}
	virtual int GetSGName(SBASE *sb,CString *s,CString *g);
	virtual void OutputKifStd(CSDJArchive &ar,int width=72,int line=9999,
		BOOL bFF=FALSE);
	virtual void OutputKifStd(CString &strKif,int width=72,int line=9999,
		BOOL bFF=FALSE);
	virtual void OutputKifCsa(CString &strKif);
	void OutputAspectFormStd(CSDJArchive &ar,SBASE *sb,CString *s,CString *g,
		BOOL bFF=FALSE);
	int GetTesu();
	CSDJDoc();
	CDIB *GetBackground(){return m_pBkgndDIB;}
	CSpriteList *GetSpriteList() {return &m_SpriteList;}
	CKmListBox *GetKmListBox(int i) {return &m_KmListBox[i];}
	CKmBoard   *GetBoard(){return &m_KmBoard;}
	CKmSprite  *GetKmSpriteArray(){return &m_KmSprite[0];}
	CKBase *GetKBase(){return &m_KBase;}
	CSDJView *GetSDJView();
	void WriteBaninfo(LPCTSTR fname); // ݂̋ǖʂt@Co
	void WriteBaninfo(CSDJArchive &ar);  // ݂̋ǖʂt@Co
	void ReadBaninfo(LPCTSTR fname);  // t@CǖʂǍ
	void ReadBaninfo(CSDJArchive &ar);   // t@CǖʂǍ
	void AdjustSpriteList(void);
	BOOL SetBackground(CDIB *pDIB);
	virtual void SetMrecTesu(){TRACE("This is virtual SetMrecTesu\n");}

    virtual void Serialize(CSDJArchive& ar,BOOL bLine);
	virtual void Serialize(CSDJArchive &ar){Serialize((CArchive &)ar);}

protected:
	void lf(CSDJArchive &ar);
	void fputs_width(char *buf,int wid,char *off,CSDJArchive &ar);
    void output_bplay_comment(SBASE *sb,PCELL *pcl,int wid,CSDJArchive &ar);
	int get_hunp(char *text);
	void get_bplay_time(SBASE *sb,PCELL *pcl, char *tp);
	void set_buf(char *kf,char *s_time,char *buf);
	char *get_comp(char *text);


	DECLARE_DYNCREATE(CSDJDoc)

private:
	BOOL CommonInitDocument();  // hLgʏ


//I[o[Ch
	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CSDJDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void DeleteContents();
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CSDJDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CSDJDoc)
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif // __SDJDOC__
