// SDJView.h : CSDJView NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////
#ifndef __SDJVIEW__
#define __SDJVIEW__

#include "osbview.h"
#include "kmsprite.h"
#include "kmstack.h"
#include "sdjdoc.h"
#include "subframe.h"
#include "guideframe.h"
#include "ssdjdoctemplate.h"
class CTitleWindow;
class CSFrameWnd;
class CDbeFrame;
class CMemLump;
class CKifFrame;
class CSDJCmntDoc;
class CSDJView : public COSBView
{
protected: // VACY@\݂̂쐬܂B
	CSSdjDocTemplate *m_pSDJCmntTemplate;
	BOOL m_bCommentDisp;
	CSDJView();
	DECLARE_DYNCREATE(CSDJView)

	CSFrameWnd *m_pSFrame;
	CDbeFrame  *m_pDbeFrame;
	CKifFrame  *m_pKifFrame;
	CRect m_rcCmntBoxPos;

// Iy[V
public:
	BOOL UpdateMenuPlaycmnt();
	void MenuPlaycmnt();
	CRect *GetCmntBoxPos(){return &m_rcCmntBoxPos;}
	CSDJCmntDoc *OpenCommentBox(CKBase *pKBase);
	BOOL IsCommentBoxOpened()
	{return (BOOL)m_pSDJCmntTemplate->GetFirstDocPosition();}
	void CloseCommentBox()
	{m_pSDJCmntTemplate->CloseAllDocuments(TRUE);}
	BOOL IsMenuLock(){return m_bMenuLock;}
	BOOL IsAutoPlay(){return (m_iAutoPlay!=0)? TRUE: FALSE;}
	CKifFrame *GetKifFrame(){return m_pKifFrame;}
	void BansetCommand(CMemLump *lpMemlump);
	void SetSFrame(CSFrameWnd *pSFrame){m_pSFrame=pSFrame;}
	CSFrameWnd *GetSFrame(void){return m_pSFrame;}
	void SetDbeFrame(CDbeFrame *pFrame){m_pDbeFrame=pFrame;}
	CDbeFrame *GetDbeFrame(void){return m_pDbeFrame;}
	BOOL GetCommentDisp(){return m_bCommentDisp;}
	void AutoCommentDisplay();
	void CommentDisplay(CKBase *pKBase);
	void Subwincls();
	void SetBanSettingFlag(BOOL flag);
	void Banset(BOOL flag);
	CSDJDoc* GetDocument();
	BOOL NewBackground(CDIB *pDIB);
	void Render(CRect *pClipRect=NULL);
	void AdjustChildFrame();
	void SubFrameCloseSet(){m_pSubFrame=NULL;}
	void GuideFrameCloseSet(){m_pGuideFrame=NULL;}
	CGuideFrame *GetGuideFrame(){return m_pGuideFrame;}
	CSubFrame *GetSubFrame(){return m_pSubFrame;}
	BOOL IsKifEditing(void){return m_bKifEditing;}
	BOOL IsBanSetting(void){return m_bBanSetting;}
	BOOL IsRuleChecking(void)
	{return (m_bKifEditing && !m_bBanSetting)? TRUE: FALSE;}
	BOOL RuleCheck(CKmSprite *pSprite,CKif Kif);
	void PlayTimerProc(UINT nIDEvent);
	void CreateSubFrame();		// ⏕ʂ̃I[v
	void CreateGuideFrame();	// ē̃I[v
	int CheckColors();			// J[F̃`FbN
	void DrawSide(CDC *pDC,BOOL sg=0);
	void InitMatePos();			// lzu
	void ZaFontDIBSetNULL(){m_pZaFontDIB=NULL;}
	void SetKifSeparate(BOOL bSep){m_bKifSeparate=bSep;}
	BOOL GetKifSeparate(){return m_bKifSeparate;}

protected:
	BOOL m_bBanSetting;			// ՃZbg
	BOOL m_bKifEditing;			// ҏW
	BOOL m_bJSEditing;			// ՕҏW
	BOOL m_bKifSeparate;		// ͎w(P)
	CDIB* m_pZaFontDIB;			// \tHg
protected:
	BOOL dbex();
	void DbStat();
	void ZaRotation();
	void ResetZaFontDIB(int iParentType);
	void GetPrintString(CString &strKif, CString &strPrt);
	void PrintBan(CDC *pDC,CPrintInfo *pInfo,int x,int *yp,
		BOOL bCalcOnly=FALSE);

private:
	void GetSubWindowRect(CRect *pRect);
	void GetGuideWindowRect(CRect *pRect);
	BOOL CheckMenuAutoahead(void);
	BOOL CheckMenuAutoback(void);

	CSubFrame *m_pSubFrame;     // ⏕
	CGuideFrame *m_pGuideFrame; // ē

	void DrawBan(CDC *pDC,int sg);// Ղ̕`
	CKmStack m_KmStack;   // 
	int  m_iAutoPlay;     // ǖʎXV(0:Stop 1:Oi 2:)
	int  m_iAutoFirst;    // ǖʎXVL
    
	/* 98tHgi[GA
	    komaft[][][\]
		 0@1
		@pj=01234567
		\@\0@1  */
	Komafont (*m_pKomafont)[2][8][2];
	BOOL KmBufferAlloc(); // tHgǂݍ݃obt@̎擾
	void KmBufferFree();  // tHgǂݍ݃obt@̊J
	BOOL ReadKomafont(void);// tHg̓ǂݍ
	int GetKmPixel(int x,int y,int sg,int km,int nr); // tHgsNZ̎Q

	// `
	void DescribeKoma(CDC *pDC,int x,int y,int sg,int km,int nr);
	// Ղ̕`
	void DescribeBan(CDC *pDC,CRect *pRect,int sg);
	// pl̕`
	void DrawPanel(CDC *pDC,CRect *pBox,int idw,
					  COLORREF iclr,COLORREF ifcclr,COLORREF ifdclr);
	// ̕`
	void DrawKoma(CDC *pDC,int x,int y,int sg,int km,int nr);
    // pbg\̂̍\z
	void CreateSDJPalette(CPalette *pPalette);


// I[o[Ch
	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CSDJView)
	public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷ۂɃI[o[Ch܂B
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CSDJView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽbZ[W }bv֐
protected:
	BOOL m_bMenuLock;
	//{{AFX_MSG(CSDJView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnUpdateMenuBanset(CCmdUI* pCmdUI);
	afx_msg void OnMenuBanset();
	afx_msg void OnMenuKboxDIB();
	afx_msg void OnMenuBanDIB();
	afx_msg void OnMENUKmDIB();
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnSubwinopn();
	afx_msg void OnUpdateSubwinopn(CCmdUI* pCmdUI);
	afx_msg void OnSubwincls();
	afx_msg void OnUpdateSubwincls(CCmdUI* pCmdUI);
	afx_msg void OnMenuEdkif();
	afx_msg void OnUpdateMenuEdkif(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMenuBanDIB(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMenuKboxDIB(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMENUKmDIB(CCmdUI* pCmdUI);
	afx_msg void OnMenuAhead();
	afx_msg void OnMenuBackmove();
	afx_msg void OnUpdateMenuAhead(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMenuBackmove(CCmdUI* pCmdUI);
	afx_msg void OnMenuAutoahead();
	afx_msg void OnUpdateMenuAutoahead(CCmdUI* pCmdUI);
	afx_msg void OnMenuAutoback();
	afx_msg void OnUpdateMenuAutoback(CCmdUI* pCmdUI);
	afx_msg void OnMenuPlaystop();
	afx_msg void OnUpdateMenuPlaystop(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMenuShgdb();
	afx_msg void OnGuideFrameInvalidate();
	afx_msg void OnMenuHead();
	afx_msg void OnUpdateMenuHead(CCmdUI* pCmdUI);
	afx_msg void OnMenuTail();
	afx_msg void OnUpdateMenuTail(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMenuEdkifTail(CCmdUI* pCmdUI);
	afx_msg void OnMenuEdkifTail();
	afx_msg void OnUpdateViewCommentBox(CCmdUI* pCmdUI);
	afx_msg void OnViewCommentBox();
	afx_msg void OnUpdateMenuPlaycmnt(CCmdUI* pCmdUI);
	afx_msg void OnMenuPlaycmnt();
	afx_msg void OnDlgCmntBoxClose();
	afx_msg void OnUpdateMenuEditJS(CCmdUI* pCmdUI);
	afx_msg void OnMenuEditJS();
	afx_msg void OnMenuSetJSValue();
	afx_msg void OnUpdateMenuMktitle(CCmdUI* pCmdUI);
	afx_msg void OnMenuMktitle();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnDestroy();
	afx_msg void OnSetSFrameNull();
	afx_msg void OnSetDbeFrameNull();
	afx_msg void OnSetKifFrameNull();
	afx_msg void OnMenuDbeOpen();
	afx_msg void OnUpdateMenuDbeOpen(CCmdUI* pCmdUI);
	afx_msg void OnMenuCreateDB();
	afx_msg void OnUpdateMenuCreateDB(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMenuBufToDbe(CCmdUI* pCmdUI);
	afx_msg void OnMenuBufToDbe();
	afx_msg void OnUpdateMenuCsaToJS(CCmdUI* pCmdUI);
	afx_msg void OnMenuCsaToJS();
	afx_msg void OnUpdateMenuJSToCsa(CCmdUI* pCmdUI);
	afx_msg void OnMenuJSToCsa();
	afx_msg void OnUpdateMenuDelDbe(CCmdUI* pCmdUI);
	afx_msg void OnMenuDelDbe();
	afx_msg void OnUpdateMenuKSound(CCmdUI* pCmdUI);
	afx_msg void OnMenuKSound();
	afx_msg void OnUpdateMenuDbstat(CCmdUI* pCmdUI);
	afx_msg void OnMenuDbstat();
	afx_msg void OnUpdateMenuKifWindowOpen(CCmdUI* pCmdUI);
	afx_msg void OnMenuKifWindowOpen();
	afx_msg void OnUpdateMenuKifWindowClose(CCmdUI* pCmdUI);
	afx_msg void OnMenuKifWindowClose();
	afx_msg void OnUpdateMenuSetJSValue(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMenuCheckMate(CCmdUI* pCmdUI);
	afx_msg void OnMenuCheckMate();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateMenuOpenKifwindow(CCmdUI* pCmdUI);
	afx_msg void OnMenuOpenKifwindow();
	afx_msg void OnActivateTabkey();
	afx_msg void OnMenuK2CSEL();
	afx_msg void OnUpdateMenuSeparateDel(CCmdUI* pCmdUI);
	afx_msg void OnMenuSeparateDel();
	afx_msg void OnUpdateMenuKspeed(CCmdUI* pCmdUI);
	afx_msg void OnMenuKspeed();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#ifndef _DEBUG  // CSDJView.cpp t@CfobO̎gp܂B
inline CSDJDoc* CSDJView::GetDocument()
   { return (CSDJDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

#endif  // __SDJVIEW__
