/*=========================================================================

                          DBANZX֐

                           1994.3 by Ra

============================================================================*/
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include <shgdb.h>
#include <string.h>
#include <memory.h>

extern int DB_Rc;               /* OG[ϐ */
extern void *memalloc(unsigned int);
extern void memfree(void *);

/* W[ÓIϐ */
static F_REC F_rec;     /* DB_F R[hobt@ */

/*************************
// DBւ̒ߕ̓o^
//***********************/
int DBF_Write(
              SCM_t *Fscm,      /* DB̕\XL[}\ */
              int cid,          /* ߋ敪 1:ǖ 2:Վ 3:΋ 4:l */
              char *ckey,       /* ߃L[  */
              char *text        /* ߕ */
              )
{
    int rc,sno,remain,counts;
    long recno;

    /* łɓo^ĂdG[ƂB */
    F_rec.row.cid[0]='0'+cid;                /* cid ̃Zbg */
    strcpy(F_rec.row.ckey,ckey);             /* ckey ̃Zbg */
    strcpy(F_rec.row.sno,"00");              /* sno ̃Zbg */
    DB_Rc=rc=SdbIxFind(Fscm,0,F_rec.buffer); /* o^L̊mF */

    if (rc!=E$NOTFOUND) {       /* o^łȂΏdG[ */
        if (rc==E$OK) rc=E$DUP;
        goto exit;
    }

    /* o^ */
    remain=strlen(text);sno=0;
    while (remain>0) {
        F_rec.row.cid[0]='0'+cid;               /* cid ̃Zbg */
        strcpy(F_rec.row.ckey,ckey);            /* ckeỹZbg */
        sprintf(F_rec.row.sno,"%02d",sno);      /* snõZbg */
        /* text̃Zbg */
        if (remain<=sizeof(F_rec.row.text))   counts=remain;
        else                                  counts=sizeof(F_rec.row.text);
        strncpy(F_rec.row.text,&text[sno*sizeof(F_rec.row.text)],counts);
        if (counts<sizeof(F_rec.row.text)) F_rec.row.text[counts]='\0';
        DB_Rc=rc=SdbWrite(Fscm,F_rec.buffer,&recno); /* o^ */

        if (rc==E$OK) {         /* o^ */
            remain-=counts;sno++;
        }
        else break;             /* o^s */
    }
    if (rc!=E$OK)     /* o^Ɏs炻܂œo^ɐ */
        DBF_Delete(Fscm,cid,ckey);

  exit:
    return rc;
}
/*********************
// DB̒ߕ폜
//*******************/
int DBF_Delete(
               SCM_t *Fscm,     /* DB̕\XL[}\ */
               int cid,         /* ߋ敪 1:ǖ 2:Վ 3:΋ 4:l */
               char *ckey       /* ߃L[  */
               )
{
    int sno,rc;

    sno=0;
    do {
        F_rec.row.cid[0]='0'+cid;                   /* cid ̃Zbg */
        strcpy(F_rec.row.ckey,ckey);                /* ckeỹZbg */
        sprintf(F_rec.row.sno,"%02d",sno);          /* snõZbg  */
        DB_Rc=SdbFindRead(Fscm,0,F_rec.buffer);     /* YR[hǏo */
        if (sno==0) rc=DB_Rc;                       /* rc͏̌ */
        if (DB_Rc==E$OK) {
            DB_Rc=SdbDelete(Fscm,F_rec.buffer,SIX_REC(Fscm,0)); /*  */
            if (DB_Rc==E$OK)        sno++;
        }
    } while (DB_Rc==E$OK);
    
    if (DB_Rc!=E$NOTFOUND) rc=DB_Rc;

    return rc;
}

/************************
// DB̒ߕǂݏo
//***********************/
void DBF_Free(char *text)       /*  ̉ */
{
    if (text!=NULL) memfree(text);
}

/* ǂݏo */
char *DBF_Read(
               SCM_t *Fscm,     /* DB̕\XL[}\ */
               int cid,         /* ߋ敪 1:ǖ 2:Վ 3:΋ 4:l */
               char *ckey       /* ߃L[  */
               )
{
    char *cp=NULL;
    int len,sno;

    /* eLXg߂ */
    sno=0;
    F_rec.row.cid[0]='0'+cid;   /* cidckeyZbg */
    strcpy(F_rec.row.ckey,ckey);
    do {
        sprintf(F_rec.row.sno,"%02d",sno); /* snoZbg */
        DB_Rc=SdbIxFind(Fscm,0,F_rec.buffer); /* mF */
        if (DB_Rc==E$OK) sno++; /* R[hsno++ */
    } while(DB_Rc==E$OK);       /* R[hȂ܂ŌJԂB */
    if (DB_Rc!=E$NOTFOUND) goto exit; /* f[^x[XG[ */
    if (sno==0) goto exit;      /* YR[hȂ */
    len=sno*sizeof(F_rec.row.text)+1; /* őeLXg{P̑傫 */

    /* eLXg+1̃m */
    cp=memalloc(len);           /* AP[g */
    if (cp==NULL) { 
        DB_Rc=E$MEM;goto exit;  /* s */
    }
    memset(cp,'\0',len);        /* 0NA */

    /* ߕ̓ǂݏo */
    sno=0;
    F_rec.row.cid[0]='0'+cid;   /* cidckeyZbg */
    strcpy(F_rec.row.ckey,ckey);
    do {
        sprintf(F_rec.row.sno,"%02d",sno); /* snoZbg */
        DB_Rc=SdbFindRead(Fscm,0,F_rec.buffer); /* ǂݏo */
        if (DB_Rc==E$OK) {      /* ǂ߂ */
            strncpy(cp+sno*sizeof(F_rec.row.text),
                    F_rec.row.text,
                    sizeof(F_rec.row.text)); /* Rs[ */
            sno++;
        }
    } while(DB_Rc==E$OK);

  exit:
    return cp;
}
