/*==================================================================

          DB@wb_t@C       1993.11  by Ra
                                           1996.09  by Ra
                                           1997.7   by Ra
 ===================================================================*/
#include <stdio.h>

#ifndef __SHGDB__
#define __SHGDB__
#include <rdb.h>

#pragma pack(1)                 /* \̃oCgACgpbN */

/*
 * B `
 */
#ifndef __B_FORM__
#define __B_FORM__
typedef struct {                /* B`̃tH[}bg */
    unsigned char km[40];
    unsigned long facenum;
} B_FORM;

typedef unsigned short B_PLAY;  /* B`̎w̃tH[}bg */
#endif

/* DB_A R[hobt@ */
typedef union {                 /* ՖDB(SHGDB_A) */
    struct A_ROW {
        char hash[6];           /* nbVl */
        char synonym[2];        /* Vmjԍ */
        B_FORM bform;           /* B ` */
        unsigned long refcount; /* QƐ */
    } row;
    unsigned char buffer[sizeof(struct A_ROW)];
} A_REC;

/* DB_B R[hobt@ */
typedef union {                 /* ΋DB(SHGDB_B) */
    struct B_ROW {
        char player[29];        /* ΋ǎ 薼O-薼O */
        char playdate[8];       /* ΋ǊJn yyyymmdd */
        char sdan[10];          /* i */
        char gdan[10];          /* i */
        char teai[6];           /* 荇 U,S,Q,...etc */
        char htime[6];          /*  hhmmss */
        char timecount[2];      /* b ss or 00(ؕ) */
        char result[6];         /* ʁ@菟,菟,,... */
        char tesu[4];           /* 萔,10i4l */
        char srhtime[6];        /* c hhmmss */
        char grhtime[6];        /* c hhmmss */
        char senkei[40];        /* ^ */
        char kisen[40];         /* 햼 */
        char place[40];         /* ΋Ǐꏊ */
        char datetime[14];      /* o^ yymmddhhmmss */
        char hash_s[8];         /* ՖʃL[ */
        char side[1];           /*  '0': '1': */
        char b_recno[6];        /* f[^t@CR[hԍ */
        char dummy[8];          /* \ */
    } row;
    unsigned char buffer[sizeof(struct B_ROW)];
} B_REC;

/* DB_C R[hobt@ */
typedef union {                 /* lDB(SHGDB_C) */
    struct C_ROW {
        char author[18];        /*  */
        char movenum[4];        /* l萔 l */
        char hint[40];          /* qg */
        char level[14];         /* Փx */
        char title[50];         /* \ */
        char datetime[14];      /* o^@yyyymmddhhmmss */
        char hash_s[8];         /* o}ՖʃL[ */
        char c_recno[6];        /* f[^t@CR[hԍ */
        char dummy[6];          /* \ */
    } row;
    unsigned char buffer[sizeof(struct C_ROW)];
} C_REC;

/* DB_D R[hobt@ */
#define D_BPLAYMAX  20
typedef union {                   /* DB(SHGDB_D) */
    struct D_ROW {
        char recid[1];            /* R[h敪 '1':΋ '2':l */
        char recno[6];            /* R[hԍ(΋orlDB) */
        char sno[2];              /* V[gԍ "00"~"99" */
        B_PLAY bplay[D_BPLAYMAX]; /* w B_PLAY MSB=1Ȃ'' */
        char dummy[11];           /* \ */
    } row;
    unsigned char buffer[sizeof(struct D_ROW)];
} D_REC;

/* DB_E R[hobt@ */
typedef union {                 /* DB(SHGDB_E) */
    struct E_ROW {
        char hash_s[8];         /* HSnbVl */
        char side[1];           /*  '0': '1': */
        short eval;             /* `]l */
        struct {
            short attr;         /* (-1:o^ >=0:Վ葮) */
            B_PLAY bplay;       /* Վ(B `) */
        } move[10];             /* Վ 10 蕪̔z */
        char dummy[1];          /* \ */
    } row;
    unsigned char buffer[sizeof(struct E_ROW)];
} E_REC;

/* DB_F R[hobt@ */
typedef union {                 /* DB(SHGDB_F) */
    struct F_ROW {
        char cid[1];            /* ߋ敪 */
        char ckey[12];          /* ߃L[ */
        char sno[2];            /* V[gԍ */
        char text[45];          /* ߕ */
    } row;
    unsigned char buffer[sizeof(struct F_ROW)];
} F_REC;

#pragma pack()                  /* \̃pbNLZ */

/* 
 *  DB֐vg^Cv錾
 */

/* ukm -> BFORM ϊ */
void B_ImportFrom(unsigned int *ukm,B_FORM *bform);

/* BFORM -> ukm ϊ */
void B_ExportTo(B_FORM *bform, unsigned int *ukm);

/* B`̏ */
void B_Init(B_FORM *bform,int mode);

/* WJzՖʂ𔽓] */
void  B_ReverseUkm(unsigned int *ukm);

/* Ֆʂ𔽓] */
void  B_ReverseForm(B_FORM *bform);

/* w𔽓] */
B_PLAY  B_ReversePlay(B_FORM *bform,B_PLAY bplay,B_FORM *bformr);


/* wi߂(ukmx[X) */
void B_ForwardUkm(unsigned int *ukm, B_PLAY bplay);

/* wi߂ */
void B_Forward(B_FORM *bform,B_PLAY bplay);

/* w̎擾 */
B_PLAY B_GetBplay(B_FORM *bform,int from,int to,int prm,int side,int code);

/* nbVlԂB*/
long B_Hash(B_FORM *bform);

/* ՖDBB`Ō */
long DBA_Find(SCM_t *scm,B_FORM *bform);

/* ՖDBHSnbVlŌB*/
int DBA_HSfind(SCM_t *scm,long hash_s);

/* ՖDBB`œǂݏo */
long DBA_Read(SCM_t *scm,B_FORM *bform,A_REC *recp);

/* ՖDBHSnbVlœǂݏo */
int DBA_HSread(SCM_t *scm,long hash_s,A_REC *recp);

/* ՖDBւ̓o^ */
long DBA_Write(SCM_t *scm,B_FORM *bform,unsigned long refcount);

/* ՖDB̍XV */
int DBA_Update(SCM_t *scm,A_REC *recp);

/* ՖDB̃R[h폜 */
int DBA_Delete(SCM_t *scm,long hash_s);

/* ΋DBւ̃R[ho^ */
long DBB_Write(SCM_t *Ascm,SCM_t *Bscm,B_REC *b_rec,B_FORM *bform,int side);

/* ΋DB̃R[h폜 */
int DBB_Delete(SCM_t *Ascm,SCM_t *Bscm,long recno);

/* lDBւ̐VKo^ */
long DBC_Write (SCM_t *Ascm,SCM_t *Cscm,C_REC *c_rec,B_FORM *bform);

/* lDB̑΋Ǎ폜 */
int DBC_Delete(SCM_t *Ascm,SCM_t *Cscm,long recno);


/* DBւ̎wo^ */
int DBD_WriteBplay(SCM_t *Dscm,int recid,long recno,B_PLAY bplay);

/* DB̎w폜 */
int DBD_DeleteBplay(SCM_t *Dscm,int recid,long recno,int num);

/* DB̎wǂݏo */
B_PLAY DBD_FindBplay(SCM_t *Dscm,int recid,long recno,int num);
B_PLAY DBD_NextBplay(void);
B_PLAY DBD_PrevBplay(void);

/* DBANZX֐ϐ */
void DBD_Init();

/* DB̃I[v */
SCM_t *DBD_Open(char *dname);

/* DB̃N[Y */
void DBD_Close(SCM_t *Dscm);

/* DBւ̒Ջǖʂ̓o^ */
int DBE_Write(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,int side,short eval,
              long *hash_s,int *reverse);

/* DBւ̒Վ̓o^ */
int DBE_WriteBplay(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,
                   B_PLAY bplay,short attr);

/* DB̒Վ폜 */
int DBE_DeleteBplay(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,B_PLAY bplay);

/* DB̋ǖʍ폜 */
int DBE_Delete(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,int side);

/* DB̃R[ȟ */
int DBE_FindRead (SCM_t *Escm,long hash_s,int side,E_REC *e_rec);
int DBE_NextRead (E_REC *e_rec);

/* DB̒Վ̌ */
int DBE_FindBplay(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,int side,
                  short *eval,B_PLAY *bplay,short *attr);
int DBE_NextBplay(short *eval,B_PLAY *bplay,short *attr);

/* DB̌`]l̍XV */
int DBE_UpdateEval(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,
                   int side,short eval);

/* DB̒Վ̍XV */
int DBE_UpdateBplay(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,int side,
                    B_PLAY bplay,short attr);

/* DB̋ǖHSnbVl̃`FbN(FindBplay-NextBplayԈȊO) */
int DBE_HSCheck(SCM_t *Ascm,SCM_t *Escm,B_FORM *bform,int side,
                long *hs,long *hsr,B_FORM *bformr);

/* DB̋ǖHSnbVl̃`FbN(FindBplay-NextBplayԐp) */
int DBE_HSCheck2(SCM_t *Ascm,B_FORM *bform,long *hs,long *hsr);


/* DBւ̒ߕ̓o^ */
int DBF_Write(SCM_t *Fscm,int cid,char *ckey,char *text);

/* DB̒ߕ폜 */
int DBF_Delete(SCM_t *Fscm,int cid,char *ckey);

/* DB̒ߕǂݏo */
char *DBF_Read(SCM_t *Fscm,int cid,char *ckey);
void DBF_Free(char *text);

#endif // __SHGDB__
