/*
 * mate.cpp
 *
 * 980320:ver0.1 mate()̊x͒Ⴂꉞ삷B
 *        StatusBox()gēroߕ\ȂǂsB
 * 980428: killer move ǉBʂ́HH
 * 010830: nbVe[uǉ
 * 010916: ꉞJ(010916)
 * 030723: defense()ŁAmarktblNA˂ĂBugFix
 */
#ifndef WINVER
#define WINVER 0x0501 // WindowsXP
#endif

#pragma warning(disable:4996)

#include <time.h>
#include "sthought.h"
#ifndef WINSDJ_SBASE
	#include "..\statusbox.h"
#endif

#ifdef WINTYPE
#include <afxwin.h> //ASSERT
#endif

#define MARKSIZ 	8

// ǖʕ]lMATE`FAIL̊Ԃŕϓ
#define MATE		120
#define FAIL		10
#define QUIT		8

// nbVe[uɂ͋ǖʃf[^̑
// E]l(m_val)@MATE`FILE, OPEN
// Eǂ݂̐[(m_depth)
// L^B
#define OPEN		-1	// nbVe[uł鎖l

/*------------------------------------------------
 * BSDATA
 * ǖʔ̂߂̃f[^BBSTACKB
 *
 * ǖʃf[^͌nIȌ`ŕۑĂBl
 * WPbyteƂƂHash֐̐\ቺăRtNg
 * 債BՊOFFKɍĂǂH
 *------------------------------------------------*/

// xƎ̃f[^rAxƓ=1, x=2, ʋǖ=0Ԃ
int BSDATA::comp(const BSDATA& x)
{
	int i;
	int inc; // tO

	if (memcmp(x.Bd, Bd, BD100-BD11) != 0) return 0;
	inc = 1; // ǖʂƂ
	for (i=0; i<MAXCODE; i++){
		if (x.Hn[i] > Hn[i]) return 0; // not equ
		if (x.Hn[i] < Hn[i]) inc = 2; // 
	}
	return inc;

}

void BSDATA::setdata(SBASE *sb, int turn)
{
	int i, j, t;
	
	for (i=0, j=BD11; j < BD100; i++,j++){
		if ((t = sb->bd(j)) == NL || t == OB) {
			Bd[i] = 0xff;
		} else {
			Bd[i] = (sb->piece(t))->getstat();
		}
	}
	for (i=0; i<MAXCODE; i++){
		ASSERT(turn == SIDE_A || turn == SIDE_B);
		Hn[i] = sb->hand(turn, i);
	}
}

void BSDATA::cpy(BSDATA *bs)
{
	memcpy(Bd, bs->Bd, BD100-BD11);
	memcpy(Hn, bs->Hn, MAXCODE);
}

void BSDATA::cpy_hand(BSDATA *bs)
{
	memcpy(Hn, bs->Hn, MAXCODE);
}

// nbV֐
int BSDATA::gethash(void)
{
	unsigned long buf, t;
	int i;
	
	t = 0;
	for(i=0; i < (BD100-BD11)/4; i++){
		buf = (Bd[i*4+3] << 24) + (Bd[i*4+2] << 16)
			+ (Bd[i*4+1] << 8) + Bd[i*4];
		t = t ^ buf; // xor
	}
	return t % HASHSIZE;
}


/*------------------------------------------------
 * BSTACK
 *------------------------------------------------*/
BSTACK::~BSTACK()
{
	BSTACK *d, *dn;
	
	d = next();
	if (d != NULL){
		dn = d->next();
		delete d;
		d = dn;
	}
	Next = NULL;
}

// STACK̃[gɑ΂čs
// STACKlevel܂Œǉ
// return: 1=ok 0=NoMem
int BSTACK::addstack(int level)
{
	int n;
	BSTACK *bsp, *t;
	
	bsp = this;
	for (n = 0; n <= level; n++){
		if (bsp->next() == NULL){
			t = new BSTACK;
			bsp->setnext(t);
			if (t == NULL) return 0;
		}
		bsp = bsp->next();
	}
	return 1;
}

// Ylevel̋ǖʃf[^L^
// RootBSTACKɑ΂čs
int BSTACK::regist(BSDATA *bs, unsigned long hash, int level)
{
	BSTACK *data, *t;
	int n;
	
	data = this;
	for (n = 0; n < level; n++){
		if (data->next() == NULL){
			t = new BSTACK;
			data->setnext(t);
			if (t == NULL) return 0;
		}
		data = data->next();
	}
	(data->Bdata).cpy(bs);
	data->HashVal = hash;
	return 1;
}

// sblebel̃f[^rAxƓ=1, x=2, ʋǖ=0Ԃ
int BSTACK::comp(BSDATA *bs, unsigned long hash, int level)
{
	BSTACK *t;
	int n;
	
	t = this;
	for (n = 0; n < level; n++){
		t = t->next();
		ASSERT(t != NULL);
		// if (t == NULL) return 0; // Error
	}
	if (hash != t->HashVal) return 0; // ƂhashlŔr
	return (t->Bdata).comp(*bs); // vĂ\Ƃ
}

/*----------------------------------------------------------------------
 * p
 *----------------------------------------------------------------------*/
/*
 * }[Ne[u0NA
 */
void mark_init(int *tbl)
{
	int i;
	
	for (i=0; i<MARKSIZ; i++) *tbl++ = 0;
}

/*
 * }[Ne[uɒς݈ʒuL^
 */
int markset(int p, int *tbl)
{
	int i = 0;
	
	while (*tbl != 0) {
		tbl++;
		i++;
	}
	*tbl = p;
	return i;
}

/*
 * }[Ne[uɒς݂Ƃēo^Ă邩ׂ
 * ς݂Ȃ炻̃e[üʒuԂBo^Ȃ-1ԂB
 */
int is_mark(int p, int *tbl)
{
	register int i;
	
	for (i = 0; *tbl != 0 && i < MARKSIZ; i++, tbl++){
		if (*tbl == p) return i;
	}
	return -1;
}

/*-----------------------------------------------------------------------
 * TGW
 *-----------------------------------------------------------------------*/
STHOUGHT::STHOUGHT(SBASE *sb)
{
	Sb = sb; 
	Atkside=SIDE_A;
	// PCELLv[
	Pool = new PCELLPOOL(20000, 5000, 50000);
#ifdef HASHVER
	Hashtbl = new HASHMEMB[HASHSIZE];
	ASSERT(Hashtbl != NULL);
#endif
}

STHOUGHT::~STHOUGHT()
{
	if (Pool != NULL){
		delete Pool;
	}
	Pool = NULL;
#ifdef HASHVER
	if (Hashtbl != NULL) delete [] Hashtbl;
#endif
}

int STHOUGHT::settarget(void)
{
	int i, k;
	
	/* ϐ̏ */
	Atkside = Sb->turn();
	k = xside(Atkside);
	Tid = -1; // ݒ肳ĂȂȂ-1
	Gmode = 0;
	for (i=0; i<Sb->maxid(); i++){
		if (Sb->pcode(i) == GYK 
		 && Sb->pside(i) == k 
		 && Sb->ppos(i) >= BD11){
			Tid = i; // Target ID
		}
		if (Sb->pcode(i) == GYK 
		 && Sb->pside(i) == Atkside 
		 && Sb->ppos(i) >= BD11){
			Gmode = 1;
			Mid = i;
		}
	}
	if (Tid == -1) return 0;
	return 1;
}


/*
 * OC^[tF[X֐ T̊Jn  
 *
 *   oʎΉ -- ڋǖʂ̔Տɂӂʂ΁AoʂƂ
 *  
 *  Call     : Eڋǖ = ݒijǖ
 *             Elimit_depth = E[(MAXLȉ)
 *  Return   : l݋؂PCELLroot(sl݂ȂNULL)
 */
#ifdef WINSDJ_SBASE
PCELL *STHOUGHT::mate(int limit_depth, CWnd *sbox, CEvent *pe) 
#else
PCELL *STHOUGHT::mate(int limit_depth, CStatusBox *sbox, CEvent *pe)
#endif
{
	int k, i;
	PCELL root;
	time_t start, finish;
	long hcount;
	
	// f̃T|[g
	Pevent = pe;
	Stop = 0;

	/* ϐ̏ */
	Maxlevel = limit_depth;
	
	// Atkside, Tid, Mid, Gmode̐ݒBłȂNULLŖ߂B
	if (! settarget()) return NULL;
	
	Nowlev = 0;
	Bcount = 0;
	
	// WindowsɑΉď󋵂\
	Sbox = sbox;
	
#ifdef WINTYPE
	sprintf(DispBuf, "ET[xF %d܂ŒT", limit_depth);
	Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
#endif

	/* [lLimitQȂJԂT */
	time(&start); // Jn擾
#ifdef HASHVER
		// nbVe[uNA
		for(i=0; i<HASHSIZE; i++) Hashtbl[i].m_val = OPEN;
		Hmode = TRUE; // }[h
#endif
	for (Limit = 1; Limit <= limit_depth; Limit += 2){
		// Ts
		k = attack(&root, NULL, 0);
		time(&finish); // I擾
		if (k == MATE) {
			sprintf(DispBuf, " -----(^_^)v l݂܂(%ldǖʒT/%ldsec)",
			 Bcount, finish-start);
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
#ifdef HASHVER
			hcount = 0;
			for(i=0; i<HASHSIZE; i++) {
				if (Hashtbl[i].m_val != OPEN) hcount++;
			}
			sprintf(DispBuf, " Hashgp %ld/%ld", hcount, HASHSIZE);
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
			// 
			Hmode = FALSE;
			k = FAIL;
			sprintf(DispBuf, "菇␳܂");
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
			while (k != MATE){
				k = attack(&root, NULL, 0);
				Limit += 2;
				if (k == FAIL || k == QUIT) break;
			}
			time(&finish); // I擾
			if (k == MATE){
				sprintf(DispBuf, " -----(^_^)v ␳I(%ldǖʒT/%ldsec)",
				 Bcount, finish-start);
				Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
			} else if (k == QUIT){
				sprintf(DispBuf, " ----- ␳f(%ldǖʒT/%ldsec)",
				 Bcount, finish-start);
				Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
			}

#endif //HASHVER
			if (k != FAIL) copytree(&root, Sb, NULL); // K=MATE/QUIT Sbɉ𓚋ԂRs[
			delete Pool;
			Pool = NULL;
			return Sb->root()->cld(0);
		}
		if (k == FAIL) {
			sprintf(DispBuf, " -----(;_;) l݂܂ł(%ldǖʒT/%ldsec)"
			 , Bcount, finish-start);
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
			delete Pool;
			Pool = NULL;
			return NULL;
		}
/*
		if (k == QUIT){
			if (k != FAIL) copytree(&root, Sb, NULL); // Sbɉ𓚋ԂRs[
			delete Pool;
			Pool = NULL;
			return Sb->root()->cld(0);
		}
*/
		root.setevv(k); // ʂL
	}
	Pool->freelist(root.cld(0));
	return NULL; // vOE[x
}


/*--------------------------------------------------------------------------
 * U
 *
 *  Call     : Eڋǖ = U(̂ĂȂ)ǖ
 *             Emcp = e̎wZւ̃|C^
 *             Ekiller = L͂ȎAȂNULL
 *             Ep   = skipՏ̈ʒuiɂǂݒn_j
 *  Return   : l=MATE, sl=FAIL, s([ł؂)=]l(max)
 *
 * XVmcp̃ocld. {Imcp͐ê
 *--------------------------------------------------------------------------*/
int STHOUGHT::attack(PCELL *mcp, PLAY *killer, int p)
{
	PCELL *pp, *bp;
	PCELL dmy, *tmp;
	PLAY *nextkiller;
	int ufu, max, rsn;
	int nlevel;
	long k;
	BSDATA bs;
	int hashkey;
	int tmpval;
	BOOL cf; // ̃xŐVɎ}Ă邩

	ASSERT(Sb->ppos(Tid) >= BD11);
//	settarget();
	
	// f󂯕t
	if (Stop) return Stop;
	if (WaitForSingleObject((HANDLE)(*Pevent), 0) == WAIT_OBJECT_0){
		sprintf(DispBuf, "f܂");
		Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
#ifdef HASHVER
		if (Hmode) {
			Stop = FAIL;
			return FAIL;
/*
			Stop = QUIT;
			return QUIT;
*/
		} else {
			Stop = QUIT;
			return QUIT;
		}
#else
		Stop = 1;
		return FAIL;
#endif
	}

	Nowlev++; /* ݐ[x */
	Bcount++; /* ǖʐJEg */
	
//	ASSERT(Nowlev < 9);

	/* ̃xŉ\ȋl݂؂̔ */	
	/* |肪ꉞ悤ɏł̔͂Ȃ */
	if (Nowlev != 1 && eval_cut()){ 
		Nowlev--; 
		return FAIL;// l܂Ȃ
	}

	// ǖʁEǖʔ
	bs.setdata(Sb, Atkside); // ݋ǖʂBSDATA`ɂ
	hashkey = bs.gethash();
	for (nlevel = Nowlev-4; nlevel >= 0; nlevel -= 2){// 2OƓȂ邱Ƃ͂蓾Ȃ
		if (Bstack.comp(&bs, hashkey, nlevel)) {
			Nowlev--;
			return FAIL; // ꂠ邢͓ǖʂŋl܂Ȃ
		}
	}
	Bstack.regist(&bs, hashkey, Nowlev);// Ֆʂ𓯈ǖʃX^bNɕۑ
	
#ifdef HASHVER
	if (Hmode){
		// nbVe[uɂ`FbN
//		hashkey = bs.gethash();
		ASSERT(hashkey >= 0);
		if (Hashtbl[hashkey].m_val != OPEN){// e[uT
		// o^ς݂Ȃ炻̌ʂďI
			int cval;
			if ((cval = bs.comp(Hashtbl[hashkey].m_bsd)) != 0){ // ǖʂ͓o^ς݋ǖʂɓ
				tmpval = Hashtbl[hashkey].m_val;
				if (tmpval == MATE || (cval == 1 && Hashtbl[hashkey].m_depth >= Limit - Nowlev)){
					// l݁A邢́AǖʂAAǂł[[ɂ́A̒lg
					Nowlev--;
					return tmpval;
					// łȂāAo^ǖʂiǖʂ̕''jȂAǂݒKv
				}
				// tɁA݋ǖʂo^ǖʂɓĂāAo^ǂݐ[x[΂̒lgH
			}
		}
	}
#endif // HASHVER

	// ̃e[u쐬
	Sb->make_eftab();
	
	/* ̏ */
	cf = FALSE;
	if (mcp->cld(0) == NULL){ /* VKɒƂ */
		if ((pp = list_ef(Atkside, Sb->ppos(Tid))) == NULL){ 
			/* ̃Xg쐬󂾂 */
			Nowlev--; 
			return FAIL;/* l܂Ȃ */
		}
		mcp->setcld(pp);
		// ]ă\[g. mcp->cld()͕ύX

		if (Nowlev < Limit || Limit < 5) {// T̍Ő[ł͂Ȃ
			// D
			pp = sort_catch(pp); // pp->brs()Ƀ\[g
			mcp->setcld(pp);
			sort_atk(mcp); // ÓI]l߂ă\[g
			// ȏ̑ŕт͕]lA]lȂ肪DɂȂ
		}
		cf = TRUE;
	} else {
		/* obNAbvꂽ]lɂ\[g */
		mcp->sort_max();
	}
	
	// killer move
	if (killer != NULL){
		for(pp = mcp->cld(0); pp != NULL; pp = pp->brs()){
			if (killer->getid() == pp->getid() 
			 && killer->to() == pp->to()
			 && killer->prom() == pp->prom()){
				Pool->listtop(pp);
				break;
			}
		}
	}

	// WindowsΉ̏󋵕\
#ifdef WINSDJ_SBASE
	if (Nowlev == 1){
		if (Hmode){ // T
			sprintf(DispBuf, "%d܂ŒT(Tǖʐ=%ld free=%d/%dcell)",
				Limit, Bcount, Pool->restcell(), Pool->total());
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
		} else { // 
			sprintf(DispBuf, ". . %d . .", Limit);
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
		}
	}
#else
#ifdef WINTYPE
	if (Nowlev == 1){
		sprintf(DispBuf, "%d܂ŒT(T/PoolSiz=%ld/%ld)",
			Limit, Bcount, Pool->total());
		Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
	}
#endif
#endif

	/************ ̃x̒T ************/
	nextkiller = NULL;
	max = FAIL; /* ]l̏lŒɂĂ */
	for (pp = mcp->cld(0); pp != NULL; pp = pp->brs()){/* ZH */
	//	if (Stop) {Nowlev--; return Stop;}
		/*  */
		if (pp->to() == p){ 
		/* ꂽꍇŁA̐ǂ݂̌ʂLimit܂łɂ͕s */
			k = mcp->getevv();  /* ǂ݂̌ʂ̕]lnĂ */
			pp->setevv(k);   /* ׂ̐͒Ȃ */
			if (max < k) max = k;
			continue; /* ɒׂꂽƂĈȉ̒TXLbv */
		}
		/* ŕtOݒ */
		if (Sb->pcode(pp->getid()) == FU && pp->from() < BD11){
			ufu = TRUE;
		} else {
			ufu = FALSE;
		}

#ifdef WINSDJ_SBASE
		if (Nowlev == 1 && Hmode) {
/*			sprintf(DispBuf, " %s (free %d/%d cell)", 
				Sb->mvstr(pp), Pool->restcell(), Pool->total());
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
*/
			sprintf(DispBuf, " %s ", Sb->mvstr(pp));
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
		}
#else
#ifdef WINTYPE
		/* oߕ\ : Ɍ]lƓ\ */
		if (Nowlev == 1) {
//		if (Nowlev <= 5) {
//			sprintf(DispBuf, " (%d)%s ]=%ld",
//			 Nowlev, Sb->mvstr(pp), pp->getevv()); // 萔\܂
			sprintf(DispBuf, " %s ]=%ld", Sb->mvstr(pp), pp->getevv());
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
		}
#endif
#endif

		/* ǂ */
		Sb->mv(pp, 0);
		k = defense(pp, NULL, ufu, &rsn); // rsn͋l܂Ȃ
		Sb->rm();
		
		/* ǂ݂̌ʂɊÂ𐧌䂷 */
		if (k == QUIT){
			if (cf == TRUE){
				Pool->freecld(mcp);
			}
			Nowlev--;
			return QUIT;
		}
		if (k == MATE){ /* l -- ̌₾c */
			Pool->freebrs(pp); /* ZĎl̎qƂȂ */
			pp->setevv(MATE);
#ifdef HASHVER
			if (Hmode){
				// nbVe[uɓo^
				tmpval = Hashtbl[hashkey].m_val;
				if (tmpval == OPEN || Hashtbl[hashkey].m_depth <= Limit-Nowlev){// e[uT. 󂢂Ă΋L^
					Hashtbl[hashkey].m_bsd.cpy(&bs);
					Hashtbl[hashkey].m_val = MATE;
					Hashtbl[hashkey].m_depth = Limit-Nowlev;
				/*
				} else if (tmpval != MATE && Hashtbl[hashkey].m_depth == Limit-Nowlev){ // [ȂMATED
					Hashtbl[hashkey].m_bsd.cpy(&bs);
					Hashtbl[hashkey].m_val = MATE;
					Hashtbl[hashkey].m_depth = Limit-Nowlev;
				*/
				} else if (tmpval == MATE && Hashtbl[hashkey].m_bsd.comp(bs) == 2){ // ǖʂo^ǖʂɓĂ
					Hashtbl[hashkey].m_bsd.cpy_hand(&bs);
					Hashtbl[hashkey].m_val = MATE; // ǖʂŌʂĂȂꍇ蓾
					// Hashtbl[hashkey].m_depth = Limit-Nowlev; // ͊ɐ藧Ă
				}
			}
#endif // HASHVER
			Nowlev--;
			return MATE;
		} else if (k == FAIL){ /* sl -- ̌폜 */
			nextkiller = pp->cld(0);
			if (rsn == pp->to()){ /* Ɏċl܂ȂȂ */
				/* Đ/sقȂ邾̎lɋl܂Ȃ */
				for (bp = pp->brs(); bp != NULL; bp = bp->brs()){
					if (bp->getid() == pp->getid() && bp->to() == pp->to()){
						Pool->freeself(bp); /* ͍폜 */
						break;
					}
				}
			}
			dmy.setbrs(Pool->freeself(pp));
			pp = &dmy;//gČZăNZԂ
		} else { /* k ͔]l */
			pp->setevv(k);  /* ]l͋L^ */
			if (Pool->lackcell()){ /* ZsĂ */
				Pool->freecld(pp); /* q */
			}
			if (max < k) max = k; /* ]Maxl߂ */
			if (rsn == pp->to() // Ɏċl܂ȂȂ
			  && pp->orgprom() == 0){ //ƂƐł͂̃`FbN͋NȂ
				/* Đ/sقȂ邾̎lɋl܂Ȃ */
				for(bp=pp->brs(),tmp=pp;bp!=NULL;bp=bp->brs(),tmp=tmp->brs()){
					/* 킩瓯T */
					if (bp->getid() == pp->getid() && bp->to() == pp->to()){
						break;
					}
				}
				if (bp != NULL){ // ̎oCpX
					tmp->setbrs(bp->brs()); // XgbpO
					bp->setbrs(pp->brs());
					pp->setbrs(bp); // pp̒֓
					bp->setevv(k);  // ]l͐ݒ肵
					Pool->freecld(bp);
					pp = bp; // ̎]ɂ
				}
			}
		}
	}
#ifdef HASHVER
	// nbVe[uɓo^
	if (Hmode){
		if (max != FAIL){ // ȂǂŕslƔ肵\͏
			tmpval = Hashtbl[hashkey].m_val;
		//	if (tmpval != MATE && tmpval != FAIL){// e[uT
				if (tmpval == OPEN || Hashtbl[hashkey].m_depth <= Limit - Nowlev){
					Hashtbl[hashkey].m_bsd.cpy(&bs);
					Hashtbl[hashkey].m_val = max;
					Hashtbl[hashkey].m_depth = Limit-Nowlev;
				}
		//	}
		}
	}
#endif //HASHVER
	Nowlev--;
	return max; /* FAIL̏ꍇ */
}

/*-----------------------------------------------------------------------
 * 
 *
 *  Call     : Eڋǖ = (̂)ǖ
 *             Emcp = e̎wZւ̃|C^
 *             Eufu = łtO   ON=ł΂/OFF=łȊO
 *             Ersn = Ԃ߂̃obt@
 *  Return   : El=MATE, sl=FAIL, [ł؂=]l(min?)
 *             EMATEȊOԂƂ *rsnɂ̓삪LĂ
 *               *rsn = 󂯂̓(ǂ֓Ŏ󂯂)
 *                    = ŕlȂ -1
 *                    = [ɂJbgȂ -2
 *                    = oʎ̋t -3
 *
 * XVmcp̃ocld. {Imcp͐ê
 *----------------------------------------------------------------------*/
int STHOUGHT::defense(PCELL *mcp, PLAY *killer, int ufu, int *rsn)
{
	PCELL *pp;
	PLAY *nextkiller;
	PCELL dmy;
	int t, ps, k, irval, latk;
	int marktbl[MARKSIZ];/* sՏ̈ʒuo^e[u */
	int oldskip[MARKSIZ];/* marktblɓo^ꂽʒuɑΉĕ]lL^*/
	BOOL cf;

/*	CBform *pcb, tcb;
//	HASHMEMB hm;
*/
	int hashkey;
	BSDATA bs;
	int tmpval;

	if (Stop) return Stop;
	Bcount++; /* ǖʐJEg */
	Nowlev++;
	ASSERT(Sb->ppos(Tid) >= BD11);
	Sb->make_eftab();
	
	/* oʃ[hɍUʂ̉𔻒 */
	if (Gmode == 1){
		if (Sb->getefnum(xside(Atkside), Sb->ppos(Mid)) != 0){
			*rsn = -3;
			Nowlev--;
			return(FAIL);
		}
	}
	
	/* T̏Ƌl݂̔ */
	cf = FALSE;
	if (mcp->cld(0) == NULL){ // 肪ۑĂȂ
		if ((pp = list_dif(Sb->ppos(Tid))) == NULL){
			/* 肪Ȃ */
			Nowlev--; 
			if (ufu != TRUE){
				return MATE;    /* l */
			} else { 
				*rsn = -1;
				return FAIL;	 /* ŕl */
			}
		}
		mcp->setcld(pp);
		cf = TRUE;
	} /* Ɍ₪Ă鎞́Aő̕]\[gsĂA
	   * l܂ȂɃXg擪ɎĂĂ邽ߌ͌サȂ 
	   * ȂAlist_difł (1) (2) (3) ̏ɐ
	   */
	
	/* [ɂł؂ */
	if (Nowlev > Limit){ /* ݂̐[xĂĂ */
		for (pp = mcp->cld(0); pp != NULL; pp = pp->brs()){
			// Ȃ炳ɐ[܂œǂ	
			if (pp->from() >= BD11) { // ȊOiՏj
				*rsn = -2;
				Nowlev--;
				return eval_fin(mcp);// [ɂł؂(])
				// ]l attak()ł̏tɉe
			}
		}
	}


#ifdef HASHVER
	if (Hmode){
		bs.setdata(Sb, xside(Atkside)); // ݋ǖʂBSDATA`ɂ
		// nbVɂ`FbN
		hashkey = bs.gethash(); // nbVl𓾂
		ASSERT(hashkey >= 0);
		if (Hashtbl[hashkey].m_val != OPEN){// e[uT
		// o^ς݂Ȃ炻̌ʂďI
			int cval;
			if ((cval = bs.comp(Hashtbl[hashkey].m_bsd)) != 0){ // ݋ǖʂ͓o^ǖʂ邢͓
				tmpval = Hashtbl[hashkey].m_val;
				if (tmpval == FAIL){
					Nowlev--;
					return tmpval;
				} else if (cval == 1 && Hashtbl[hashkey].m_depth >= Limit - Nowlev){
					// ǖʂAAǂł[[ɂ́A̒lg
					Nowlev--;
					return tmpval;
					// łȂāAo^ǖʂiǖʂ̕''jȂAǂݒKv
				}
				// tɁA݋ǖʂo^ǖʂɓĂāAo^ǂݐ[x[΂̒lg
			}
		}
	}
#endif // HASHVER
	
	// killer move
	if (killer != NULL){
		for(pp = mcp->cld(0); pp != NULL; pp = pp->brs()){
			if (killer->getid() == pp->getid() 
			 && killer->to() == pp->to()
			 && killer->prom() == pp->prom()){
				Pool->listtop(pp);
				break;
			}
		}
	}
	
	/************* ̃x̒T ************/
	nextkiller = NULL;
	// ɂUԂȂ latk=1 Ȃ latk = 0;
	// ӁII@͕smŁADiscoveȑꍇȂǂ
	if (!is_near8(mcp->to(), Sb->ppos(Tid))
		/* && Sb->pcode(mcp->getid()) != KEI */){
		latk = 1;
	} else {
		latk = 0;
	}
	
	// ̏
	EFTAB et;
	et.set(Sb); // ̃e[ũRs[
	mark_init(marktbl); /* }[JNA */
	
	// 󂯂ׂ̂ĂɂĒׂ
	for (pp = mcp->cld(0); pp != NULL; pp = pp->brs()){ // 󂯂̑Sɂ
#ifdef HASHVER
//		if (Stop) {Nowlev--; return Stop;}
		if (Hmode){ // ł͂Ȃ
			if (pp->getevv() == MATE) continue;/* ɋl݂Ă */
		}
#else
		if (pp->getevv() == MATE) continue;/* ɋl݂Ă */
#endif
		/* ́Aɋl񂾎}XLbv鏈Ō듮삵Ȃ悤
		 * get_cell()ŎoZevv͏Kv
		 * (get_cell()clsďĂj
		 */
		
		/*  */
		// ppƂ肪̏ꍇAdmy_attack()̏sAʍ
		// ǂׂBdmy_attack()͍ʒuNULLuĂ
		// lނǂ𒲂ׂĂBl񂾏ꍇ͖ʍȂ̂ł̈ʒu
		// 肷ׂĂ̂Ăāi₩āj܂Bl܂Ȃꍇ
		//iLimit܂łɕsȏꍇj͋lމ\̂Ŏ又ɉ񂷁B
		// @ȂA\[Xŏɂ̃`FbNsĂ悤Ɍ邪
		// ۂ̌胊Xgł͍͖ɂ̂ŁA̎̕]
		// ɏB
		irval = FAIL; // irval(>=0)FAIL/MATE/Ő؂莞̕]l̂ꂩ
		if (pp->cld(0) == NULL && pp->from() < BD11){ // ۑőōȂ
			if ((t = is_mark(pp->to(), marktbl)) >= 0){
				/* oldskipł̈ʒu߂ */
				irval = oldskip[t]; /* ̒n_̍͊ɒς */
			} else {
				/*  ȉ dmy_attak FAIL/MATE/Ő؂莞̕]l Ԃ
				 *  move()dmy_attak()ĂԂ̂́AōNUL
				 *  Ӗ
				 *  FAILԂꂽANULł͕sl݂m肵B
				 */
				/* ʍǂׂ̂́A̎
				 *   1)ʕ̗̂Ȃn_ւ̋Łij
				 *   2)ʋߖTŗʂ݂̂UQȏ̏ꍇ̋
				 * łB
				 *   3)ړ
				 * ɂĂׂ͒ASǂށB
				 */
				if ((ps = et.getefnum(xside(Atkside), pp->to())) == 0){
					// ps͋ʕ̗
					// ʕ̗Ȃꏊւ̑ōȂ
					t = markset(pp->to(), marktbl);
					oldskip[t] = irval = dmy_attack(pp->to());
				} else if (ps == 1
					 && et.getefnum(Atkside, pp->to()) > 1
					 && is_near8(pp->to(), Sb->ppos(Tid))){
					// ʋߖTōU̗2ȏ, ʕ̗͋ʎ̂
					t = markset(pp->to(), marktbl);
					oldskip[t] = irval = dmy_attack(pp->to());
				}
			}
			if (irval == MATE) {/* ͎ċl(ʍ) */
				dmy.setbrs(Pool->freeself(pp)); /* ͍̎폜 */
				pp = &dmy;
				continue; /* 又͏ȗł */
			} else if (irval == QUIT){
				Nowlev--;
				return QUIT;
			}
		}
		
		/* 又 */
		Sb->mv(pp, 0);
/* 
#ifdef WINTYPE
		// oߕ\ : ]lƓ\
		if (Nowlev <= 5) {
			sprintf(DispBuf, " (%d)%s ]=%ld",
			 Nowlev, Sb->mvstr(pp), pp->getevv());
			Sbox->SendMessage(WM_COMMAND, ID_PRINT_MESSAGE, (LPARAM)DispBuf);
		}
#endif
*/
		if (irval == FAIL){ // ł͂Ȃ/̎ނɂĂ͋lȂ
			k = attack(pp, nextkiller, 0);
		} else { // ĂLimit܂łɂ͕s
			pp->setevv(irval);// ]l attakŎQƂ
			// ǂ݂̓ǂ݋؂͕ۊǂĂȂ
			k = attack(pp, nextkiller, pp->to());
					 // U'pp->p.to'֓̓pX
		}
		Sb->rm();
		
		
		/*
		 * irval̒lɂ̓앪ނ́A͕smł
 		 *  1. irval=MATEȂ ʍ
		 *      -----Ȃ̂͐
		 *  2. irval=FAIL
		 *      (1)łȂ
		 *	    (2)ɑ΂dmy_attakł͕sl݂Ƃʂo
		 *     ̂ǂ炩ł
		 *      -----ɑ΂attak()ĂԂ̂͐
		 *         i̎ނɂċlނȂj
		 *  3. irval=???  dmy_attakȉŐ[ɂƂƂł
		 *	   炭 ɂȂĂ [܂łɂ͋l݂Ȃ낤
		 *	   fĂ
		 *      -----smAċlނȂ
		 */
		
		if (k == QUIT){
			if (cf == TRUE){
				Pool->freecld(mcp);
			}
			Nowlev--;
			return QUIT;
		}
		if (k == FAIL){/* ̎}ŋl܂Ȃ */
		//	pool->listtop(pp); // killer move ƂĎgȂlisttop()邪...
			*rsn = pp->to();
#ifdef HASHVER
			if (Hmode){
				// nbVe[uɓo^
				tmpval = Hashtbl[hashkey].m_val;
				if (tmpval == OPEN || Hashtbl[hashkey].m_depth <= Limit-Nowlev){ // 󂢂Ă邩󂢂Ȃ珑
					Hashtbl[hashkey].m_bsd.cpy(&bs);
					Hashtbl[hashkey].m_val = FAIL;
					Hashtbl[hashkey].m_depth = Limit-Nowlev;
				/*
				} else if (tmpval != MATE && tmpval != FAIL && Hashtbl[hashkey].m_depth == Limit-Nowlev){ 
					// o^f[^󂢂Ȃ㏑
					Hashtbl[hashkey].m_bsd.cpy(&bs);
					Hashtbl[hashkey].m_val = FAIL;
					Hashtbl[hashkey].m_depth = Limit-Nowlev;
				*/
				} else if (tmpval == FAIL && Hashtbl[hashkey].m_bsd.comp(bs) == 2){ // ǖʂo^ǖʂɓĂ
					Hashtbl[hashkey].m_bsd.cpy_hand(&bs);
					Hashtbl[hashkey].m_val = FAIL; // ǖʂrʂĂȂ\
				}
			}
#endif //HASHVER
			Nowlev--; 
			return FAIL; /* ̎}ׂ͂attak()ō폜 */
		} else if (k == MATE){
			pp->setevv(MATE); /* l݋؂͕ۑ */
			if (latk) nextkiller = pp->cld(0);
		} else { /* [܂łɂ͂̎ŋl܂Ȃ */
			pp->setevv(k); /* Ƃ]l͋L^ */
			Pool->listtop(pp); /* ɔ̎擪ɂĂ */
			*rsn = pp->to();
			/* sȂ̈ */
			if (Pool->lackcell()){ // rootɋ߂}͊JȂ
				Pool->freecld(pp); /* q */
			}
			/* l݂̕ωɂ]֐l̕␳ */
			for (pp = mcp->cld(0); pp != NULL; pp = pp->brs()){
				if (pp->getevv() == MATE) {
					k += 3;/* l݂ւ̕ω*3 */
				}
				/* ̓_]֐̐ɑ傫Ă悤 */
			}
			if (k >= MATE) k = MATE-1;
			if (k <= FAIL) k = FAIL+1;
#ifdef HASHVER
/*
			// nbVe[uɓo^
			if (Hmode){
				tmpval = Hashtbl[hashkey].m_val;
			//	if (tmpval != MATE && tmpval != FAIL){// e[uT
					if (tmpval == OPEN || Hashtbl[hashkey].m_depth < Limit - Nowlev){
						Hashtbl[hashkey].m_bsd.cpy(&bs);
						Hashtbl[hashkey].m_val = k;
						Hashtbl[hashkey].m_depth = Limit-Nowlev;
					}
			//	}
			}
*/	
#endif //HASHVER

			Nowlev--;
			return k; /* ݂̐[ł͕s */
			/* {minlԂׂƂ낾EE */
		}
	}
	Nowlev--;
	return MATE;/* l݂ł */
}

/*
 * pattak
 *
 * 肪p1֍ꍇɂ̋čU}TB
 * 		̓_~[łĐ̎͑ȂB
 * 		̏ł͏[xxNowLev͑ȂB
 *      ʂ̂ɂ炸Aǂ݋؂͕ۑȂ
 * ƂĂ͍UAċ𓮂ƂɂȂ
 *
 * ڋǖ : ŉ肪ĂԂłB{p1n_Ɏ
 *            ̍ǖʂ̂͂A̋NULɂ邽߂̏ԂŌ
 *            ΂B
 * Call     : p1 --- _~[̍ʒu
 * Return   : FAIL, MATE, ]l(max)
 */
int STHOUGHT::dmy_attack(int p1)
{
	PCELL *pp, *bp;
	PCELL mcp, dmy;
	int  k, max, rsn;
/*
	int hashkey;
	BSDATA bs;
	int tmpval;
*/
	if (Stop) return Stop;
	
	Bcount++; /* ǖʐJEg */
	Nowlev--;/* Ȃ */
	ASSERT(Sb->ppos(Tid) >= BD11);
	
	mcp.setcld(list_mvef2(p1, Sb->ppos(Tid), Atkside)); /* mcp͉̐e */
	/* 铮 */
	/* ͎ĕKɂȂ邩Acld==NULL͂肦Ȃ */
/*	if (mcp.cld() == NULL) {
		printf("dmy_attak s\n");
		exit(1);
	}
*/

/*
#ifdef HASHVER
	if (Hmode){
		// nbVe[uɂ`FbN
		hashkey = bs.gethash();
		ASSERT(hashkey >= 0);
		if (Hashtbl[hashkey].m_val != OPEN){// e[uT
		// o^ς݂Ȃ炻̌ʂďI
			int cval;
			if ((cval = bs.comp(Hashtbl[hashkey].m_bsd)) != 0){ // ǖʂ͓o^ς݋ǖʂɓ
				tmpval = Hashtbl[hashkey].m_val;
				if (tmpval == MATE || (cval == 1 && Hashtbl[hashkey].m_depth >= Limit - Nowlev)){
					// l݁A邢́AǖʂAAǂł[[ɂ́A̒lg
				//	Nowlev--;
					Nowlev++;
					return tmpval;
					// łȂāAo^ǖʂiǖʂ̕''jȂAǂݒKv
				}
				// tɁA݋ǖʂo^ǖʂɓĂāAo^ǂݐ[x[΂̒lgH
			}
		}
	}
#endif // HASHVER
*/
	Sb->make_eftab();
	max = FAIL; /* maxl̏l͍Œɂ */
	
	for (pp = mcp.cld(0); pp != NULL; pp = pp->brs()){
		Sb->mv(pp, 1); // dummy move 1
		k = defense(pp, NULL, 0, &rsn);
		Sb->rm();
		if (k == QUIT){
			Pool->freecld(&mcp);/* ̈S */
			Nowlev++;
			return QUIT;
		}
		if (k == MATE){ /* l */
			Pool->freecld(&mcp);
/*
#ifdef HASHVER
			if (Hmode){
				// nbVe[uɓo^
				tmpval = Hashtbl[hashkey].m_val;
				if (tmpval == OPEN || Hashtbl[hashkey].m_depth <= Limit-Nowlev){// e[uT. 󂢂Ă΋L^
					Hashtbl[hashkey].m_bsd.cpy(&bs);
					Hashtbl[hashkey].m_val = MATE;
					Hashtbl[hashkey].m_depth = Limit-Nowlev;
				} else if (tmpval == MATE && Hashtbl[hashkey].m_bsd.comp(bs) == 2){ // ǖʂo^ǖʂɓĂ
					Hashtbl[hashkey].m_bsd.cpy(&bs);
					Hashtbl[hashkey].m_val = MATE; // ǖʂŌʂĂȂꍇ蓾
					// Hashtbl[hashkey].m_depth = Limit-Nowlev; // ͊ɐ藧Ă
				}
			}
#endif // HASHVER
*/
			Nowlev++;
			return MATE;
		} else { /* k == FAIL || k == ? : l݈ȊOȂ */
			if (max < k) max = k; /* ]Maxl߂ */
			if (rsn == pp->to() /* Ɏċl܂ȂȂ */
			  && pp->orgprom() == 0){ // ƂƐł͈ӖȂ
				/* Đ/sقȂ邾̎lɋl܂Ȃ */
				for (bp = pp->brs(); bp != NULL; bp = bp->brs()){
					if (bp->getid() == pp->getid() && bp->to() == pp->to()){
						Pool->freeself(bp); /* ͍폜 */
						break;
					}
				}
			}
			dmy.setbrs(Pool->freeself(pp));
					//gČZăNԂ
			pp = &dmy;
		}
	}
	Nowlev++; /* ߂鏀 */
	Pool->freecld(&mcp);/* ̈S */
	return max;
}

/*------------------------------------------------------------------
 * ]
 *------------------------------------------------------------------*/
/*
 * I[ǖʔF݂̋ǖʂl܂ȂǖʂAlOɔ
 *
 * Return : TRUE=l܂Ȃ / FALSE=s
 */
int STHOUGHT::eval_cut(void)
{
	int id;
	int k, /* Ȗi܁Aj*/
		p, /* U̔Տ̋ */
		statbuf[2][MAXCODE], /* ՏU̎ʁi܂ށj\ */
		t;
	
	for (id=0; id<MAXCODE; id++) statbuf[0][id] = statbuf[1][id] = 0;
	for (id=1, k=0, p=0; id < Sb->maxid(); id++){
		if (Sb->pside(id) == Atkside) { /* UȂ */
			k++;
			if (Sb->ppos(id) >= BD11){
				t = (Sb->pprom(id)) ? 1:0;
				(statbuf[t][Sb->pcode(id)])++;
				p++;
			}
		}
	}
	/* 
	 * l܂ȂƔf 
	 */
	// USłP
	if (k <= 1) return TRUE;
	// |
	if (p == 0) return TRUE;
	// ՏɍUAɌjȂ
	/*if (p == 0 && Sb->hand(Atkside,KEI) == 0) return TRUE;*/
	// ՏPȊOŎ
	if (p == 1 && statbuf[1][HSY] == 0 && Sb->hand(Atkside,FU) == k-1) 
		return TRUE;
	// ՏŎƌj
	if (p == statbuf[0][FU] 
	 && Sb->hand(Atkside,FU) + Sb->hand(Atkside,KEI) == k-p) 
		return TRUE;
	// ʂ̂WߖTɍU̗Ȃj()ȂāAU͕
	//   ̃`FbNmake_eftab()ĂԁBʂ͂̂ƍXlistupŌ
	//   make_eftab()ŝŌ͉Ȃ͂.
	if (Sb->hand(Atkside,FU) == k-p 
		&& statbuf[0][HSY] == 0 && statbuf[1][HSY] == 0
		&& statbuf[0][KAK] == 0 && statbuf[1][KAK] == 0
		&& statbuf[0][KYO] == 0 && statbuf[0][KEI] == 0
		&& neigbef(Sb->ppos(Tid), Atkside) == 0)
		return TRUE;

	return FALSE;
}

// lɂ̉l
int pval(int prom, int code)
{
	static int p_val[2][MAXCODE] = {
	//	   p   j  
		 {0, 3, 3, 3, 3, 2, 1, 0}, 	// 
		 {0, 5, 5, 3, 3, 3, 3, 3}	// 
	};
	if (prom > 1 || prom < 0) return 0;
	return p_val[prom][code];
}

/*
 * heaďZ̎wŋD悳悤Ƀ\[g
 * ܂l̍鏇ɂ
 * ȊO̕я͕ςȂ (Ⴆ΍Ȃ)
 *
 * --- {Iɂ͎ǖʂł邾؂ɗU邽߂Ɏg
 * Call : head=Xg擪Ahead̂PLAYoL
 * Return : \[gXg̐擪|C^
 */
PCELL *STHOUGHT::sort_catch(PCELL *head)
{
	PCELL dmy;
	register PCELL *kp, *ip;
	PCELL *next, *mp, *tail;
	int mpv;
	
	tail = &dmy;
	// mp = head->brs();
	mp = head;
	while (mp != NULL){
		if (mp->getpid() == NL){ /* Ȃ */
			/* Xgmp擪Ɋ܂Ƃ߂ĊO */
			ip = mp;
			kp = ip->brs();
			while (kp != NULL && kp->getpid() == NL){/* mp`ip܂ŊO */
				ip = kp;
				kp = kp->brs();
			}
			next = kp;     /* O */
			ip->setbrs(NULL);   /* tail->brs; */
			tail->setbrs(mp);   /* taiľmp`ip} */
			tail = ip;        /* tail͍Ȃ̍Ō */
		} else {
			/* ̓\[g */
			next = mp->brs(); /* XgmpЂƂO */
			mpv = pval(Sb->pprom(mp->getpid()), Sb->pcode(mp->getpid()));
														 /* ̉l */
			ip = &dmy;
			kp = ip->brs();
			while (kp != NULL && kp->getpid() != NL){/* }_ipɋ߂ */
				if (mpv >=
				 pval(Sb->pprom(kp->getpid()), Sb->pcode(kp->getpid()))) break;
				ip = kp;
				kp = kp->brs();
			}
			mp->setbrs(kp); /* ip̌mpȂ */
			ip->setbrs(mp);
			if (kp == NULL) tail = mp;
		}
		mp = next;
	}
	return dmy.brs();
}

/*
 * mother̎qiZǰQ\]ă\[g
 *
 * \]͌Q̊eXɏ]ĒڋǖʂisAgčsB
 * ɁÃe[ueڋǖʖɍ쐬邽߁Aׂ傫B
 *
 * Call   : ڋǖ=Uߕǖ(̂ĂȂǖ)
 *          mother=ŉ̃Xg̐e(qɃXg)
 * Return : ȂAmother->cldZ͍UߕLȏɃ\[g
 */
void STHOUGHT::sort_atk(PCELL *mother)
{
	PCELL *tp;
	
	/*--- \] : ]levfɋ߂ ---*/
	for (tp = mother->cld(0); tp != NULL; tp = tp->brs()){
		Sb->mv(tp, 0); /* s */
		tp->setevv(eval_atk(tp->to())); /* ] */
		Sb->rm();
	}
	/*--- evfL[Ƀ\[gs ---*/
	mother->sort_max();
}

/* 
 * \]֐ 
 *
 *   ڋǖʂ̐ÓI]l߂. ]lقǋl݂ɋ߂.
 * Call   : ڋǖʂ͉̋ǖʂł邱.
 *          pos=̉邽ߓU̍siƂ͌Ȃj
 * Return : value=]lAUߕLȂقǕ]l
 *
 */
int STHOUGHT::eval_atk(int pos) 
{
	int count, id;
	
	/* countɋʂ̎Rx(mobility)߂ */
	count = 8 - neigbef(Sb->ppos(Tid), Atkside);
	count *= 4; /* mobility̏d = 4 */
	if (Sb->getefnum(Atkside, pos) != 0) count--;
						// ɕRtĂ]
	if ((id = Sb->bd(pos)) != NL) {
		count -= pval(Sb->pprom(id), Sb->pcode(id)); // ]
	}
	return MATE - 40 - count; // count]lɕϊ
}

/*
int STHOUGHT::neighb(int cen, int side)
{
	int i, pos, count;
	
	Sb->make_eftab();
	if (cen < BD11) return 0;
	for (count = 0, i = 2; i < 10; i++){
		pos = getvval(i)+cen;
		if (Sb->getefnum(side, pos)) count++;
	}
	return count;
}
*/

/*
 * ]֐ 
 *
 * ]lႢقǋʂ͈SƂ݂Ȃ
 * Call : mcp => 󂯂̎̃Xg̐eA󂯂̎̃Xg͂cldZɂ
 *        ڋǖ = ̊|ǖ
 * Return : ]lAقǍUL
 */
int STHOUGHT::eval_fin(PCELL *mcp)
{
	static int dwtbl[2][BD100] = { /* Έʒu]e[u */
	{
		/*    0  1  2  3  4  5  6  7  8  9 */
	    	 OB,OB,OB,OB,OB,OB,OB,OB,OB,OB,
			 OB,OB,OB,OB,OB,OB,OB,OB,OB,OB,
	  /*9*/  OB, 1, 2, 2, 2, 2, 2, 2, 2, 1,
	  /*8*/  OB, 1, 2, 2, 2, 2, 2, 2, 2, 1,
	  /*7*/  OB, 1, 2, 2, 2, 2, 2, 2, 2, 1,
	  /*6*/  OB, 0, 0, 1, 1, 1, 1, 1, 0, 0,
	  /*5*/  OB,-1, 0, 1, 1, 1, 1, 1, 0,-1,
	  /*4*/  OB,-1, 0, 1, 1, 1, 1, 1, 0,-1,
	  /*3*/  OB,-1, 0, 0, 0, 0, 0, 0, 0,-1,
	  /*2*/  OB,-2,-2, 0, 0, 0, 0, 0,-2,-2,
	  /*1*/  OB,-3,-3,-2,-1,-1,-1,-2,-3,-3,
    	     /* OB = FF, NL = 0 */
	},
	{
		/*    0  1  2  3  4  5  6  7  8  9 */
	    	 OB,OB,OB,OB,OB,OB,OB,OB,OB,OB,
			 OB,OB,OB,OB,OB,OB,OB,OB,OB,OB,
	  /*1*/  OB,-3,-3,-2,-1,-1,-1,-2,-3,-3,
	  /*2*/  OB,-2,-2, 0, 0, 0, 0, 0,-2,-2,
	  /*3*/  OB,-1, 0, 0, 0, 0, 0, 0, 0,-1,
	  /*4*/  OB,-1, 0, 1, 1, 1, 1, 1, 0,-1,
	  /*5*/  OB,-1, 0, 1, 1, 1, 1, 1, 0,-1,
	  /*6*/  OB, 0, 0, 1, 1, 1, 1, 1, 0, 0,
	  /*7*/  OB, 1, 2, 2, 2, 2, 2, 2, 2, 1,
	  /*8*/  OB, 1, 2, 2, 2, 2, 2, 2, 2, 1,
	  /*9*/  OB, 1, 2, 2, 2, 2, 2, 2, 2, 1,
    	     /* OB = FF, NL = 0 */
	}
	};
	register PCELL *pp;
	int k, v;
	
	/* 󂯎̕] : XgŜ : kقǋʂ͈S */
	for (pp = mcp->cld(0), k = 0; pp != NULL; pp = pp->brs()){
		if (pp->getid() == Tid) {
			k += 4;		/* ʂ̎Rxɑ΂d */
			if (pp->getpid() != NL) {
				k += pval(Sb->pprom(pp->getpid()), Sb->pcode(pp->getpid()));
															/* ̉l_ */
			}
		} else if (pp->from() < BD11){
			k += 1; 	/* ̎ސɑ΂d */
		} else if (pp->getpid() != NL){
			k += 3;		/* 邱Ƃɑ΂] */
			k += pval(Sb->pprom(pp->getpid()), Sb->pcode(pp->getpid()));
															/* ̉l_ */
		}
	}
	k += dwtbl[xside(Atkside)][Sb->ppos(Tid)];	/* ʂ̈ʒuɂ] */
	v = MATE - 40 - k;
	if (v >= MATE) v = MATE - 1;
	if (v <= FAIL) v = FAIL + 1;
	return v;
}
