/*************************/
/*    WinSDJSView.cpp    */
/*************************/
#include "stdafx.h"
#include "winsdj.h"
#include "mainfrm.h"
#include "WinSDJSView.h"
#include "sdjdoc.h"
#include "sframewnd.h"
#include  <WinMemFile.h>
#include "ssdjdoctemplate.h"
#include "childfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4244)

// O[o
extern CWinSDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSView

IMPLEMENT_DYNCREATE(CWinSDJSView, CSDJView)

BEGIN_MESSAGE_MAP(CWinSDJSView, CSDJView)
	//{{AFX_MSG_MAP(CWinSDJSView)
	ON_COMMAND(ID_MENU_2M_SET, OnMenu2mSet)
	ON_COMMAND(ID_MENU_4M_SET, OnMenu4mSet)
	ON_COMMAND(ID_MENU_6M_SET, OnMenu6mSet)
	ON_COMMAND(ID_MENU_BOX_SET, OnMenuBoxSet)
	ON_COMMAND(ID_MENU_HIRA_SET, OnMenuHiraSet)
	ON_COMMAND(ID_MENU_HSHA_SET, OnMenuHshaSet)
	ON_COMMAND(ID_MENU_KAK_SET, OnMenuKakSet)
	ON_COMMAND(ID_MENU_LKYO_SET, OnMenuLkyoSet)
	ON_COMMAND(ID_MENU_RKYO_SET, OnMenuRkyoSet)
	ON_COMMAND(ID_BANSET_OK, OnBansetOk)
	ON_COMMAND(ID_SET_SIDE_A, OnSetSideA)
	ON_UPDATE_COMMAND_UI(ID_SET_SIDE_A, OnUpdateSetSideA)
	ON_COMMAND(ID_SET_SIDE_B, OnSetSideB)
	ON_UPDATE_COMMAND_UI(ID_SET_SIDE_B, OnUpdateSetSideB)
	ON_COMMAND(ID_SET_NOSIDE, OnSetNoside)
	ON_UPDATE_COMMAND_UI(ID_SET_NOSIDE, OnUpdateSetNoside)
	ON_COMMAND(ID_MENU_TUME_SET, OnMenuTumeSet)
	ON_COMMAND(ID_ZA_ROTATION, OnZaRotation)
	ON_COMMAND(ID_MENU_KKYO_SET, OnMenuKkyoSet)
	ON_COMMAND(ID_MENU_HIKYO_SET, OnMenuHikyoSet)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CSDJView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CSDJView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CSDJView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSView NX̍\z/

CWinSDJSView::CWinSDJSView()
{
}

CWinSDJSView::~CWinSDJSView()
{
}

void CWinSDJSView::OnInitialUpdate() 
{
	CSDJView::OnInitialUpdate();

	Banset(TRUE); // Jă[`FbNJB/
}


/////////////////////////////////////////////////////////////////////////////
// CWinSDJSView NX̕`

void CWinSDJSView::OnDraw(CDC* pDC)
{
	CSFrameWnd *pParent=(CSFrameWnd *)GetParentFrame();
	int iParentType=pParent->GetParentType(); // ehLg̃^Cv擾
	ResetZaFontDIB(iParentType);	// \̃Zbg
	CSDJView::OnDraw(pDC);
	DrawSide(pDC,iParentType);		// ԕ\
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSView NẌ

BOOL CWinSDJSView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CWinSDJSView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CWinSDJSView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSView NX̐ff

#ifdef _DEBUG
void CWinSDJSView::AssertValid() const
{
	CSDJView::AssertValid();
}

void CWinSDJSView::Dump(CDumpContext& dc) const
{
	CSDJView::Dump(dc);
}

CSDJDoc* CWinSDJSView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSDJDoc)));
	return (CSDJDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinSDJSView NX̃bZ[W nh

// Qzu
void CWinSDJSView::OnMenu2mSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(5);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// Szu
void CWinSDJSView::OnMenu4mSet() 
{
	CSDJDoc* pDoc = GetDocument();
	pDoc->DeleteContents();
	CKBase *pKBase=pDoc->GetKBase();
	pKBase->setup(6);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// Uzu
void CWinSDJSView::OnMenu6mSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(7);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// zu
void CWinSDJSView::OnMenuBoxSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(8);
	pKBase->setturn(ON_BOX);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// zu
void CWinSDJSView::OnMenuHiraSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(0);
	pKBase->setturn(SIDE_A);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// ԗzu
void CWinSDJSView::OnMenuHshaSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(3);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// pzu
void CWinSDJSView::OnMenuKakSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(4);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// zu
void CWinSDJSView::OnMenuLkyoSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(2);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// Ezu
void CWinSDJSView::OnMenuRkyoSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(1);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// pzu
void CWinSDJSView::OnMenuKkyoSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(10);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// 򍁗zu
void CWinSDJSView::OnMenuHikyoSet() 
{
	CSDJDoc* pDoc = GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pDoc->DeleteContents();
	pKBase->setup(9);
	pKBase->setturn(SIDE_B);
	pDoc->SetModifiedFlag();
	Render();
	Draw();
}

// lߏ zu
void CWinSDJSView::OnMenuTumeSet() 
{
	InitMatePos();
	GetDocument()->SetModifiedFlag();
	Render();
	Draw();
}

// ǖʂ̐ݒ(SDI̎)
// ǖʂt@Cɏo͂ĐeɃR}h𑗂A͏IB
void CWinSDJSView::OnBansetOk() 
{
	CSDJDoc* pDoc = GetDocument();
	// SDIFrameWindow(CSFrameWnd)擾
	CSFrameWnd *pParent=(CSFrameWnd *)GetParentFrame();

	// 
	Banset(FALSE);

	// ݒɕύX邩Aǖʎw蒆̏ꍇ͐ݒIR}h𑗂
	if (pDoc->IsModified() || theApp.m_bSelectBoxBUsing) {
		// ݂̋ǖʂt@Cɏo͂B
		CWinMemFile File;
		CSDJArchive arOut(&File,CArchive::store);
		pDoc->WriteBaninfo(arOut);
		arOut.Close();
		UINT Size=File.GetLength();
		BYTE *lpMem=File.Detach();
        CMemLump *pMemlump=new CMemLump(Size,lpMem);

		pDoc->SetModifiedFlag(FALSE); // ύXtOZbg

		// SDICSFrameWnd̃o[֐GetSdjParentA
		// ełƂ̃EBhE擾
		CWnd *pWnd=pParent->GetSdjParent();
		ASSERT(pWnd);
		// ̃t[EBhẼr[ɃR}h𑗂
		pWnd->SendMessage(WM_COMMAND,ID_BANSET_COMMAND,(LPARAM)pMemlump);
	}

	// I
	pParent->PostMessage(WM_CLOSE);
}

// Ԑݒ()
void CWinSDJSView::OnSetSideA() 
{
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	if (pKBase->turn()!=SIDE_A) {
		pKBase->setturn(SIDE_A);
		pDoc->SetModifiedFlag();
	}
}
void CWinSDJSView::OnUpdateSetSideA(CCmdUI* pCmdUI) 
{
	CSFrameWnd *pParent=(CSFrameWnd *)GetParentFrame();
	int iParentType=pParent->GetParentType(); // ehLg̃^Cv擾
	if (iParentType) // lhLgȂ
		pCmdUI->SetText("U  (&S)");
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pCmdUI->Enable();
	if (pKBase->turn()==SIDE_A)
		pCmdUI->SetCheck(1); // `FbN}[NL
	else
		pCmdUI->SetCheck(0); // `FbN}[N
}
// Ԑݒ()
void CWinSDJSView::OnSetSideB() 
{
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	if (pKBase->turn()!=SIDE_B) {
		pKBase->setturn(SIDE_B);
		pDoc->SetModifiedFlag();
	}
}

void CWinSDJSView::OnUpdateSetSideB(CCmdUI* pCmdUI) 
{
	CSFrameWnd *pParent=(CSFrameWnd *)GetParentFrame();
	int iParentType=pParent->GetParentType(); // ehLg̃^Cv擾
	if (iParentType) // lhLgȂ
		pCmdUI->SetText("  (&G)");
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pCmdUI->Enable();
	if (pKBase->turn()==SIDE_B)
		pCmdUI->SetCheck(1); // `FbN}[NL
	else
		pCmdUI->SetCheck(0); // `FbN}[N
}

// Ԑݒ(ݒ)
void CWinSDJSView::OnSetNoside() 
{
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	if (pKBase->turn()!=ON_BOX) {
		pKBase->setturn(ON_BOX);
		pDoc->SetModifiedFlag();
	}
}
void CWinSDJSView::OnUpdateSetNoside(CCmdUI* pCmdUI) 
{
	CSDJDoc *pDoc=GetDocument();
	CKBase *pKBase=pDoc->GetKBase();
	pCmdUI->Enable();
	if (pKBase->turn()==ON_BOX)
		pCmdUI->SetCheck(1); // `FbN}[NL
	else
		pCmdUI->SetCheck(0); // `FbN}[N
}

// ϊ
void CWinSDJSView::OnZaRotation() 
{
	CSDJView::ZaRotation();
	Invalidate(); // ĕ\
}
